/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#ifndef WDFMAIN_MUSICEDITOR_HPP
#define WDFMAIN_MUSICEDITOR_HPP

#include "smr/smrmain.hpp"
#include "smr/smr.hpp"
#include "drw/scorefrm.hpp"

class MyScoreEditor : public wxMEScoreFrame
{
public:
	MyScoreEditor(wxWindow* parent,const wxString& tit,const wxPoint& pos, const wxSize& siz);
	
	void OnNew(wxCommandEvent&);
	void OnLoad(wxCommandEvent&);
	void OnSave(wxCommandEvent&);
	void OnSaveAs(wxCommandEvent&);
	void OnSettings(wxCommandEvent&);
	void OnEncodeSMXF(wxCommandEvent&);
	void OnDecodeBITS(wxCommandEvent&);	
	void OnView(wxCommandEvent&);
	void OnSaveAsMP4(wxCommandEvent&);
	void OnLoadFromMP4(wxCommandEvent&);

	void OnBatchSaveAsMP4(wxCommandEvent&);

	void OnAddSMFL(wxCommandEvent&);
	void OnAddFont(wxCommandEvent&);
	void OnAddMIDI(wxCommandEvent&);

	wxMenu* CreatePartsMenu();
	
	DECLARE_EVENT_TABLE()
};

class MySMRFile : public SMRFile
{
public:
	wxMEScoreFrame* NewWxMEScoreFrame(wxWindow* parent,const wxString& tit,const wxPoint& pos, const wxSize& siz)
	{ 
		return new MyScoreEditor(parent,tit,pos,siz); 
	};
	
};

class SMREditorApp : public SMRApp
{
public:
    MySMRFile smrf; 
	
	void OpenTopWindow(const char* fileToLoad=NULL);
};

DECLARE_APP(SMREditorApp)

#endif 
