#ifndef _SMRCURSOR_H
#define _SMRCURSOR_H

class Partitura;
class Spartito;
class Battuta;
class Layer;
class Figura;
class Nota;
class DrawObject;
class Colore;

typedef enum depth{
	D_EMPTY,
	D_PART,
	D_MEASURE,
	D_VOICE,
	D_FIGURE,
	D_NOTE,
}curDepth;


class SMRcursor {
private:
	Partitura* pScore;

	Spartito * pPart;

	Battuta * pMeasure;

	Layer * pVoice;

	Figura * pFigure;

	Nota * pNote;

public:
	SMRcursor(Partitura* const & s);

	//~SMRcursor(void );

	void Reset();

	void Reset(const curDepth &level);

	void Deselect();

	void Select(const curDepth &level);

	const curDepth GetDepth();

	Partitura* const & GetScore();

	Spartito* const & GetPart();

	Battuta* const & GetMeasure();

	Layer* const & GetVoice();

	Figura* const & GetFigure();

	Nota* const & GetNote();

	void SetScore(Partitura* const & s);

	void SetPart(Spartito* const & p);

	void SetMeasure(Battuta* const & m);

	void SetVoice(Layer* const & v);

	void SetFigure(Figura* const & f);

	void SetNote(Nota* const & n);

	void GoFirst(const curDepth &level);

	void GoLast(const curDepth &level);

	void GoNext(const curDepth &level);

	void GoPrev(const curDepth &level);

	void GoLeft(const curDepth &level);

	void GoRight(const curDepth &level);

	void GoUp(const curDepth &level);

	void GoDown(const curDepth &level);

	//void GoIn(curDepth &level);

	//void GoOut(curDepth &level);

	unsigned int GetPosition(const curDepth &level);

	const int SetPosition(const curDepth &level, const unsigned int & pos);

	const int GetCount(const curDepth &level);

//-----------------------------------------------------//

//	void Highlight(bool val = true);

	void SetColor(const Colore & color, const curDepth &level);

private:

//	bool highlighted;

	unsigned int GetVoiceGraphicPosition();

	const int SetVoiceGraphicPosition(const unsigned int & pos);

};
#endif
