/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: def_abb.hpp,v 1.1 2005/07/25 10:09:01 bellinpo Exp $ */


class Scr;   

#ifndef DEF_ABB_HPP
#define DEF_ABB_HPP

// turn
#define CODE_GINFERIORE 82
#define DELTAXGINFERIORE Scr->Get_VU2DX(CODE_GINFERIORE)       
#define DELTAYGINFERIORE Scr->Get_VU2DY(CODE_GINFERIORE)       
#define GINFERIORE2UP Scr->Get_VU2UP(CODE_GINFERIORE)          
#define GINFERIORE2DWN Scr->Get_VU2DWN(CODE_GINFERIORE)        
#define GINFERIORE2RGT Scr->Get_VU2RG(CODE_GINFERIORE)         
#define GINFERIORE2LFT Scr->Get_VU2LF(CODE_GINFERIORE)         

// turn back
#define CODE_GSUPERIORE 84
#define DELTAXGSUPERIORE Scr->Get_VU2DX(CODE_GSUPERIORE)       
#define DELTAYGSUPERIORE Scr->Get_VU2DY(CODE_GSUPERIORE)      
#define GSUPERIORE2UP Scr->Get_VU2UP(CODE_GSUPERIORE)          
#define GSUPERIORE2DWN Scr->Get_VU2DWN(CODE_GSUPERIORE)        
#define GSUPERIORE2RGT Scr->Get_VU2RG(CODE_GSUPERIORE)         
#define GSUPERIORE2LFT Scr->Get_VU2LF(CODE_GSUPERIORE)         

// turn slash
#define CODE_GSLASH 122
#define DELTAXGSLASH Scr->Get_VU2DX(CODE_GSLASH, MUSICFONT2_ID)       
#define DELTAYGSLASH Scr->Get_VU2DY(CODE_GSLASH, MUSICFONT2_ID)       
#define GSLASH2UP Scr->Get_VU2UP(CODE_GSLASH, MUSICFONT2_ID)          
#define GSLASH2DWN Scr->Get_VU2DWN(CODE_GSLASH, MUSICFONT2_ID)        
#define GSLASH2RGT Scr->Get_VU2RG(CODE_GSLASH, MUSICFONT2_ID)         
#define GSLASH2LFT Scr->Get_VU2LF(CODE_GSLASH, MUSICFONT2_ID)         

// turn up
#define CODE_GUP 121
#define DELTAXGUP Scr->Get_VU2DX(CODE_GUP, MUSICFONT2_ID)        
#define DELTAYGUP Scr->Get_VU2DY(CODE_GUP, MUSICFONT2_ID)        
#define GUP2UP Scr->Get_VU2UP(CODE_GUP, MUSICFONT2_ID)           
#define GUP2DWN Scr->Get_VU2DWN(CODE_GUP, MUSICFONT2_ID)       
#define GUP2RGT Scr->Get_VU2RG(CODE_GUP, MUSICFONT2_ID)      
#define GUP2LFT Scr->Get_VU2LF(CODE_GUP, MUSICFONT2_ID)      

// mordente inferiore
#define CODE_MINFERIORE 77
#define DELTAXMINFERIORE Scr->Get_VU2DX(CODE_MINFERIORE)       
#define DELTAYMINFERIORE Scr->Get_VU2DY(CODE_MINFERIORE)       
#define MINFERIORE2UP Scr->Get_VU2UP(CODE_MINFERIORE)          
#define MINFERIORE2DWN Scr->Get_VU2DWN(CODE_MINFERIORE)        
#define MINFERIORE2RGT Scr->Get_VU2RG(CODE_MINFERIORE)         
#define MINFERIORE2LFT Scr->Get_VU2LF(CODE_MINFERIORE)         

// mordente inferiore doppio
#define CODE_M2INFERIORE 202
#define DELTAXM2INFERIORE Scr->Get_VU2DX(CODE_M2INFERIORE)       
#define DELTAYM2INFERIORE Scr->Get_VU2DY(CODE_M2INFERIORE)       
#define M2INFERIORE2UP Scr->Get_VU2UP(CODE_M2INFERIORE)          
#define M2INFERIORE2DWN Scr->Get_VU2DWN(CODE_M2INFERIORE)        
#define M2INFERIORE2RGT Scr->Get_VU2RG(CODE_M2INFERIORE)         
#define M2INFERIORE2LFT Scr->Get_VU2LF(CODE_M2INFERIORE)         

// mordente superiore 
#define CODE_MSUPERIORE 109
#define DELTAXMSUPERIORE Scr->Get_VU2DX(CODE_MSUPERIORE)       
#define DELTAYMSUPERIORE Scr->Get_VU2DY(CODE_MSUPERIORE)       
#define MSUPERIORE2UP Scr->Get_VU2UP(CODE_MSUPERIORE)          
#define MSUPERIORE2DWN Scr->Get_VU2DWN(CODE_MSUPERIORE)        
#define MSUPERIORE2RGT Scr->Get_VU2RG(CODE_MSUPERIORE)         
#define MSUPERIORE2LFT Scr->Get_VU2LF(CODE_MSUPERIORE)         

// mordente superiore doppio
#define CODE_M2SUPERIORE 196
#define DELTAXM2SUPERIORE Scr->Get_VU2DX(CODE_M2SUPERIORE)       
#define DELTAYM2SUPERIORE Scr->Get_VU2DY(CODE_M2SUPERIORE)       
#define M2SUPERIORE2UP Scr->Get_VU2UP(CODE_M2SUPERIORE)          
#define M2SUPERIORE2DWN Scr->Get_VU2DWN(CODE_M2SUPERIORE)        
#define M2SUPERIORE2RGT Scr->Get_VU2RG(CODE_M2SUPERIORE)         
#define M2SUPERIORE2LFT Scr->Get_VU2LF(CODE_M2SUPERIORE)         

// trillo semplice, solo tr senza onda, per quello con l'onda vedi trillonda in /IND/
#define CODE_TRILLO 235   // that is 235 del musica il tr
#define DELTAXTRILLO Scr->Get_VU2DX(CODE_TRILLO)       
#define DELTAYTRILLO Scr->Get_VU2DY(CODE_TRILLO)       
#define TRILLO2UP Scr->Get_VU2UP(CODE_TRILLO)          
#define TRILLO2DWN Scr->Get_VU2DWN(CODE_TRILLO)        
#define TRILLO2RGT Scr->Get_VU2RG(CODE_TRILLO)         
#define TRILLO2LFT Scr->Get_VU2LF(CODE_TRILLO)         

#define CODE_ONDA2 230  // that is l'onda che segue il tr
#define DELTAXONDA2 Scr->Get_VU2DX(CODE_ONDA2)       
#define DELTAYONDA2 Scr->Get_VU2DY(CODE_ONDA2)       
#define ONDA22UP Scr->Get_VU2UP(CODE_ONDA2)          
#define ONDA22DWN Scr->Get_VU2DWN(CODE_ONDA2)        
#define ONDA22RGT Scr->Get_VU2RG(CODE_ONDA2)         
#define ONDA22LFT Scr->Get_VU2LF(CODE_ONDA2)         
#define NEWTRILLO 21  
#define NUMTRILLIMAX 12


#define CODE_FITTIZIO_GLISSATO 25 
#define DELTAXGLISSATO Scr->Get_VU2DX(CODE_FITTIZIO_GLISSATO)
#define DELTAYGLISSATO Scr->Get_VU2DY(CODE_FITTIZIO_GLISSATO)

#define CODE_FITTIZIO_GLISSATOONDA 24 
#define DELTAXGLISSATOONDA Scr->Get_VU2DX(CODE_FITTIZIO_GLISSATOONDA)
#define DELTAYGLISSATOONDA Scr->Get_VU2DY(CODE_FITTIZIO_GLISSATOONDA)


#define CODE_FITTIZIO_TREMOLO 16 
#define DELTAXTREMOLO Scr->Get_VU2DX(CODE_FITTIZIO_TREMOLO)
#define DELTAYTREMOLO Scr->Get_VU2DY(CODE_FITTIZIO_TREMOLO)

#endif //DEF_ABB_HPP
