/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: gsuperio.cpp,v 1.1 2005/07/25 10:09:03 bellinpo Exp $ */


#include "abb/gsuperio.hpp"
#include "drw/gscreen.hpp"

GSuperiore::GSuperiore()
{ ID=CL_GSUPERIORE; }

VUnit GSuperiore::GetVU2Up()
{return GSUPERIORE2UP;};

VUnit GSuperiore::GetVU2Dwn()
{return GSUPERIORE2DWN;};

VUnit GSuperiore::GetVU2Lft()
{return GSUPERIORE2LFT;};

VUnit GSuperiore::GetVU2Rgt()
{return GSUPERIORE2RGT;};

void GSuperiore::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	if(PAltSotto!=NULL)
		PAltSotto->Draw();
	
	char code[2]={0,0};
	code[0]=CODE_GSUPERIORE; 
                                  
	Scr->TextTo(GetAbsPos()+Point(DELTAXGSUPERIORE,DELTAYGSUPERIORE)+Point( GetDx(),GetDy() ));
	Scr->OutText((unsigned char *)code);
	
	if(PAltSopra!=NULL)
		PAltSopra->Draw();

	Scr->SetColor(oldcol);
};  
