/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: minferio.cpp,v 1.1 2005/07/25 10:09:03 bellinpo Exp $ */


#include "abb/minferio.hpp"
#include "drw/gscreen.hpp"

MInferiore::MInferiore()
{                                        
	ID=CL_MINFERIORE;                  
};

VUnit MInferiore::GetVU2Up()
{
	if(Doppio) return M2INFERIORE2UP;
	else return MINFERIORE2UP;
};

VUnit MInferiore::GetVU2Dwn()
{
	if(Doppio) return M2INFERIORE2DWN;
	else return MINFERIORE2DWN;
};

VUnit MInferiore::GetVU2Lft()
{
	if(Doppio) return M2INFERIORE2LFT;
	else return MINFERIORE2LFT;
};

VUnit MInferiore::GetVU2Rgt()
{
	if(Doppio) return M2INFERIORE2RGT;
	else return MINFERIORE2RGT;
};

void MInferiore::Draw()
{                                      
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	if(PAltSotto!=NULL)
		PAltSotto->Draw();
    
	char code[2]={0,0};
	if(Doppio) code[0]=CODE_M2INFERIORE;
	else code[0]=CODE_MINFERIORE;
	                                    
	if(Doppio)
		Scr->TextTo(GetAbsPos()+Point(DELTAXM2INFERIORE,DELTAYM2INFERIORE)+Point( GetDx(),GetDy() ));
	else
		Scr->TextTo(GetAbsPos()+Point(DELTAXMINFERIORE,DELTAYMINFERIORE)+Point( GetDx(),GetDy() ));
	Scr->OutText((unsigned char *)code);
	
	if(PAltSopra!=NULL)
		PAltSopra->Draw();

	Scr->SetColor(oldcol);
};  
