/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: altecomp.hpp,v 1.1 2005/07/25 10:43:12 bellinpo Exp $ */


#ifndef ALTERAZCOMPOSTA_HPP
#define ALTERAZCOMPOSTA_HPP

#include "drw/drawobje.hpp"
#include "alt/alterazi.hpp"
#include "alt/def_alt.hpp"


class AlterazComposta : public DrawObject
{ 
	int n_alterazioni;  //Numero di alterazioni presenti in alterazione composta.
	Alterazione *alterazioni[N_ALT_MAX];
	
public:              
	
    AlterazComposta();
    ~AlterazComposta();
    
    int Getn_alterazioni();
	//Restituisce il numero di alterazioni presenti nell'alterazione composta
    Bool InserisciAlt(ClassID CL_ALT, int parentesi=-1); 	
	//Inserisce una nuova alterazione nell'alterazione composta.
	//Restituisce TRUE se la nuova alterazione viene inserita 
	//o FALSE altrimenti.
    Alterazione *GetPAlterazione(int i);
	//Restituisce l'i-esima alterazione dell'alterazione composta.	
	Alterazione *GetPAlterazione(CmdID MyId);
	Alterazione *GetPAlterazione(ClassID MyAlt);
    
    Bool DeleteSym(DrawObject *sym);
    Bool Hit(const Point&, SelObj, DrawObject*&, SymPath&);
    Bool SymbolicHit(SymPath&, SelObj, DrawObject*&);
    void Draw();
    
    VUnit GetVU2Up();
    VUnit GetVU2Dwn();
    VUnit GetVU2Lft();
    VUnit GetVU2Rgt();
	
	// Restituisce il numero dell'alterazione corrente
	void SetPAlterazione(int i,Alterazione* alt);
	
	int SaveXML(FILE *);
};


#endif //ALTERAZCOMPOSTA_HPP
