/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: alterazi.hpp,v 1.1 2005/07/25 10:43:13 bellinpo Exp $ */


#ifndef ALTERAZIONE_HPP
#define ALTERAZIONE_HPP  

#include "drw/drawobje.hpp"

class Alterazione: public DrawObject
{
protected:
    int Altezza;
	// Altezza musicale dell'alterazione rispetto alla nota che occupa la
	// riga pi bassa del pentagramma (Mi nella chiave di violino).
    Bool Notina;
	// E' TRUE se l'alterazione e' riferita a una notina. 
	//Viene inizializzato a FALSE.
	Bool Parentesi;
	// E' TRUE se l'alterazione viene scritta fra parentesi. 
	//Viene inizializzato a FALSE.
	
public:
    Alterazione() { Notina=FALSE; Altezza=0; Parentesi=FALSE;};
    // Costruttore standard. 
	
    void SetAltezza(int alt);  
	// Imposta l'altezza musicale della figura.
    void SetNotina(Bool b);
	// Seleziona la grandezza dell'alterazione.
    Bool GetNotina() ;
	// Dice se l'alterazione  riferita a una notina.
    void SetParentesi(Bool b);
	// Setta le parentesi.
    Bool GetParentesi() ;
	// Dice se l'alterazione  parentesizzata.
	
    void SetPos(DrawObject *d,const Point& p);
    // Imposta la posizione dell'alterazione.
    void Draw(){};                           
	
	virtual int SaveXML(FILE *)=0;
	virtual char* GetXMLDesc()=0;
};

#endif //ALTERAZIONE_HPP
