/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: bemoll1q.cpp,v 1.1 2005/07/25 10:43:13 bellinpo Exp $ */


#include "alt/bemoll1q.hpp"

VUnit Bemolle1Q::GetVU2Up() 
{	if (GetParentesi())
return (GetNotina())? (BRABEMOLLE1Q2UP_NOTINA):(BRABEMOLLE1Q2UP);
else
return (GetNotina())? BEMOLLE1Q2UP_NOTINA:BEMOLLE1Q2UP;
};

VUnit Bemolle1Q::GetVU2Dwn() 
{	if (GetParentesi())
return (GetNotina())? (BRABEMOLLE1Q2DWN_NOTINA):(BRABEMOLLE1Q2DWN);
else
return (GetNotina())? BEMOLLE1Q2DWN_NOTINA:BEMOLLE1Q2DWN;
};

VUnit Bemolle1Q::GetVU2Lft() 
{
	if (GetParentesi())
		return (GetNotina())? (BRABEMOLLE1Q2LFT_NOTINA):(BRABEMOLLE1Q2LFT);
	else
		return (GetNotina())? BEMOLLE1Q2LFT_NOTINA:BEMOLLE1Q2LFT;
};

VUnit Bemolle1Q::GetVU2Rgt() 
{
	if (GetParentesi())
		return (GetNotina())? (BRABEMOLLE1Q2RGT_NOTINA):(BRABEMOLLE1Q2RGT);
	else
		return (GetNotina())? BEMOLLE1Q2RGT_NOTINA:BEMOLLE1Q2RGT;
}


void Bemolle1Q::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	int oldFont;
	char code[2] = {0, 0};
	
	if (GetParentesi())
	{
		oldFont=Scr->SetFont(nMusicFont2);
		if (GetNotina())
		{
			code[0] = CODE_BRABEMOLLE1Q_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRABEMOLLE1Q_NOTINA,DELTAYBRABEMOLLE1Q_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_BRABEMOLLE1Q;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRABEMOLLE1Q,DELTAYBRABEMOLLE1Q)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
	}
	else 
	{
		oldFont=Scr->SetFont(nMusicFont);
		if (GetNotina())
		{
			code[0] = CODE_BEMOLLE1Q_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBEMOLLE1Q_NOTINA,DELTAYBEMOLLE1Q_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_BEMOLLE1Q;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBEMOLLE1Q,DELTAYBEMOLLE1Q)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		
	}
	Scr->SetFont(oldFont);	

	Scr->SetColor(oldcol);
	
};  
