/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: bemolle.cpp,v 1.1 2005/07/25 10:43:14 bellinpo Exp $ */


#include "alt/bemolle.hpp"

VUnit Bemolle::GetVU2Up() 
{	if (GetParentesi())
return (GetNotina())? (BRABEMOLLE2UP_NOTINA):(BRABEMOLLE2UP);
else
return (GetNotina())? BEMOLLE2UP_NOTINA:BEMOLLE2UP;
};

VUnit Bemolle::GetVU2Dwn() 
{	if (GetParentesi())
return (GetNotina())? (BRABEMOLLE2DWN_NOTINA):(BRABEMOLLE2DWN);
else
return (GetNotina())? BEMOLLE2DWN_NOTINA:BEMOLLE2DWN;
};

VUnit Bemolle::GetVU2Lft() 
{
	if (GetParentesi())
		return (GetNotina())? (BRABEMOLLE2LFT_NOTINA):(BRABEMOLLE2LFT);
	else
		return (GetNotina())? BEMOLLE2LFT_NOTINA:BEMOLLE2LFT;
};

VUnit Bemolle::GetVU2Rgt() 
{
	if (GetParentesi())
		return (GetNotina())? (BRABEMOLLE2RGT_NOTINA):(BRABEMOLLE2RGT);
	else
		return (GetNotina())? BEMOLLE2RGT_NOTINA:BEMOLLE2RGT;
}


void Bemolle::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	int oldFont;
	char code[2] = {0, 0};
	
	if (GetParentesi())
	{
		oldFont=Scr->SetFont(nMusicFont2);
		if (GetNotina())
		{
			code[0] = CODE_BRABEMOLLE_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRABEMOLLE_NOTINA,DELTAYBRABEMOLLE_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_BRABEMOLLE;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRABEMOLLE,DELTAYBRABEMOLLE)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
	}
	else 
	{
		oldFont=Scr->SetFont(nMusicFont);
		if (GetNotina())
		{
			code[0] = CODE_BEMOLLE_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBEMOLLE_NOTINA,DELTAYBEMOLLE_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_BEMOLLE;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBEMOLLE,DELTAYBEMOLLE)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		
	}
		
	Scr->SetFont(oldFont);

	Scr->SetColor(oldcol);

};  
