/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: bequadro.cpp,v 1.1 2005/07/25 10:43:14 bellinpo Exp $ */


#include "alt/bequadro.hpp"

VUnit Bequadro::GetVU2Up() 
{	if (GetParentesi())
return (GetNotina())? (BRABEQUADRO2UP_NOTINA):(BRABEQUADRO2UP);
else
return (GetNotina())? BEQUADRO2UP_NOTINA:BEQUADRO2UP;
};

VUnit Bequadro::GetVU2Dwn() 
{	if (GetParentesi())
return (GetNotina())? (BRABEQUADRO2DWN_NOTINA):(BRABEQUADRO2DWN);
else
return (GetNotina())? BEQUADRO2DWN_NOTINA:BEQUADRO2DWN;
};

VUnit Bequadro::GetVU2Lft() 
{
	if (GetParentesi())
		return (GetNotina())? (BRABEQUADRO2LFT_NOTINA):(BRABEQUADRO2LFT);
	else
		return (GetNotina())? BEQUADRO2LFT_NOTINA:BEQUADRO2LFT;
};

VUnit Bequadro::GetVU2Rgt() 
{
	if (GetParentesi())
		return (GetNotina())? (BRABEQUADRO2RGT_NOTINA):(BRABEQUADRO2RGT);
	else
		return (GetNotina())? BEQUADRO2RGT_NOTINA:BEQUADRO2RGT;
}


void Bequadro::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	int oldFont;
	char code[2] = {0, 0};
	
	if (GetParentesi())
	{
		oldFont=Scr->SetFont(nMusicFont2);
		if (GetNotina())
		{
			code[0] = CODE_BRABEQUADRO_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRABEQUADRO_NOTINA,DELTAYBRABEQUADRO_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_BRABEQUADRO;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRABEQUADRO,DELTAYBRABEQUADRO)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
	}
	else 
	{
		oldFont=Scr->SetFont(nMusicFont);
		if (GetNotina())
		{
			code[0] = CODE_BEQUADRO_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBEQUADRO_NOTINA,DELTAYBEQUADRO_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_BEQUADRO;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBEQUADRO,DELTAYBEQUADRO)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		
	}
		
	Scr->SetFont(oldFont);

	Scr->SetColor(oldcol);

};  
