/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: bequadro3q.cpp,v 1.1 2005/07/25 10:43:15 bellinpo Exp $ */


#include "alt/bequadro3q.hpp"

VUnit Bequadro3Q::GetVU2Up() 
{	if (GetParentesi())
return (GetNotina())? (BRABEQUADRO3Q2UP_NOTINA):(BRABEQUADRO3Q2UP);
else
return (GetNotina())? BEQUADRO3Q2UP_NOTINA:BEQUADRO3Q2UP;
};

VUnit Bequadro3Q::GetVU2Dwn() 
{	if (GetParentesi())
return (GetNotina())? (BRABEQUADRO3Q2DWN_NOTINA):(BRABEQUADRO3Q2DWN);
else
return (GetNotina())? BEQUADRO3Q2DWN_NOTINA:BEQUADRO3Q2DWN;
};

VUnit Bequadro3Q::GetVU2Lft() 
{
	if (GetParentesi())
		return (GetNotina())? (BRABEQUADRO3Q2LFT_NOTINA):(BRABEQUADRO3Q2LFT);
	else
		return (GetNotina())? BEQUADRO3Q2LFT_NOTINA:BEQUADRO3Q2LFT;
};

VUnit Bequadro3Q::GetVU2Rgt() 
{
	if (GetParentesi())
		return (GetNotina())? (BRABEQUADRO3Q2RGT_NOTINA):(BRABEQUADRO3Q2RGT);
	else
		return (GetNotina())? BEQUADRO3Q2RGT_NOTINA:BEQUADRO3Q2RGT;
}


void Bequadro3Q::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	int oldFont;
	char code[2] = {0, 0};
	
	if (GetParentesi())
	{
		oldFont=Scr->SetFont(nMusicFont2);
		if (GetNotina())
		{
			code[0] = CODE_BRABEQUADRO3Q_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRABEQUADRO3Q_NOTINA,DELTAYBRABEQUADRO3Q_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_BRABEQUADRO3Q;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRABEQUADRO3Q,DELTAYBRABEQUADRO3Q)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
	}
	else 
	{
		oldFont=Scr->SetFont(nMusicFont);
		if (GetNotina())
		{
			code[0] = CODE_BEQUADRO3Q_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBEQUADRO3Q_NOTINA,DELTAYBEQUADRO3Q_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_BEQUADRO3Q;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBEQUADRO3Q,DELTAYBEQUADRO3Q)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		
	}
	
	Scr->SetFont(oldFont);

	Scr->SetColor(oldcol);
	
};  
