/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: def_alt.hpp,v 1.1 2005/07/25 10:43:15 bellinpo Exp $ */


class Scr;

#ifndef DEF_ALT_HPP
#define DEF_ALT_HPP

#define N_ALT_MAX 2  //Numero massimo di alterazioni in alterazione composta.

#define CODE_DOPPIODIESIS 154-256
#define DELTAXDOPPIODIESIS Scr->Get_VU2DX(154)       
#define DELTAYDOPPIODIESIS Scr->Get_VU2DY(154)       
#define DOPPIODIESIS2UP   Scr->Get_VU2UP(154)        
#define DOPPIODIESIS2DWN  Scr->Get_VU2DWN(154)       
#define DOPPIODIESIS2LFT  Scr->Get_VU2LF(154)        
#define DOPPIODIESIS2RGT  Scr->Get_VU2RG(154)        

#define CODE_DIESIS 35
#define DELTAXDIESIS Scr->Get_VU2DX(35)       
#define DELTAYDIESIS Scr->Get_VU2DY(35)       
#define DIESIS2UP   Scr->Get_VU2UP(35)        
#define DIESIS2DWN  Scr->Get_VU2DWN(35)       
#define DIESIS2LFT  Scr->Get_VU2LF(35)        
#define DIESIS2RGT  Scr->Get_VU2RG(35)        

#define CODE_DIESIS1Q 176
#define DELTAXDIESIS1Q Scr->Get_VU2DX(176)       
#define DELTAYDIESIS1Q Scr->Get_VU2DY(176)       
#define DIESIS1Q2UP   Scr->Get_VU2UP(176)        
#define DIESIS1Q2DWN  Scr->Get_VU2DWN(176)        
#define DIESIS1Q2LFT  Scr->Get_VU2LF(176)        
#define DIESIS1Q2RGT  Scr->Get_VU2RG(176)        

#define CODE_DIESIS3Q 177
#define DELTAXDIESIS3Q Scr->Get_VU2DX(177)      
#define DELTAYDIESIS3Q Scr->Get_VU2DY(177)      
#define DIESIS3Q2UP   Scr->Get_VU2UP(177)       
#define DIESIS3Q2DWN  Scr->Get_VU2DWN(177)      
#define DIESIS3Q2LFT  Scr->Get_VU2LF(177)       
#define DIESIS3Q2RGT  Scr->Get_VU2RG(177)       

#define CODE_DOPPIOBEMOLLE 167-256
#define DELTAXDOPPIOBEMOLLE Scr->Get_VU2DX(167)       
#define DELTAYDOPPIOBEMOLLE Scr->Get_VU2DY(167)       
#define DOPPIOBEMOLLE2UP   Scr->Get_VU2UP(167)        
#define DOPPIOBEMOLLE2DWN  Scr->Get_VU2DWN(167)       
#define DOPPIOBEMOLLE2LFT  Scr->Get_VU2LF(167)        
#define DOPPIOBEMOLLE2RGT  Scr->Get_VU2RG(167)        

#define CODE_BEMOLLE 98
#define DELTAXBEMOLLE Scr->Get_VU2DX(98)       
#define DELTAYBEMOLLE Scr->Get_VU2DY(98)       
#define BEMOLLE2UP   Scr->Get_VU2UP(98)        
#define BEMOLLE2DWN  Scr->Get_VU2DWN(98)       
#define BEMOLLE2LFT  Scr->Get_VU2LF(98)        
#define BEMOLLE2RGT  Scr->Get_VU2RG(98)        

#define CODE_BEMOLLE1Q 178
#define DELTAXBEMOLLE1Q Scr->Get_VU2DX(178)       
#define DELTAYBEMOLLE1Q Scr->Get_VU2DY(178)       
#define BEMOLLE1Q2UP   Scr->Get_VU2UP(178)        
#define BEMOLLE1Q2DWN  Scr->Get_VU2DWN(178)       
#define BEMOLLE1Q2LFT  Scr->Get_VU2LF(178)        
#define BEMOLLE1Q2RGT  Scr->Get_VU2RG(178)        

#define CODE_BEMOLLE3Q 180
#define DELTAXBEMOLLE3Q Scr->Get_VU2DX(180)       
#define DELTAYBEMOLLE3Q Scr->Get_VU2DY(180)       
#define BEMOLLE3Q2UP   Scr->Get_VU2UP(180)        
#define BEMOLLE3Q2DWN  Scr->Get_VU2DWN(180)       
#define BEMOLLE3Q2LFT  Scr->Get_VU2LF(180)        
#define BEMOLLE3Q2RGT  Scr->Get_VU2RG(180)        

#define CODE_BEQUADRO 110
#define DELTAXBEQUADRO Scr->Get_VU2DX(110)       
#define DELTAYBEQUADRO Scr->Get_VU2DY(110)       
#define BEQUADRO2UP   Scr->Get_VU2UP(110)        
#define BEQUADRO2DWN  Scr->Get_VU2DWN(110)       
#define BEQUADRO2LFT  Scr->Get_VU2LF(110)        
#define BEQUADRO2RGT  Scr->Get_VU2RG(110)        

#define CODE_BEQUADRO1Q 218 - 256
#define DELTAXBEQUADRO1Q Scr->Get_VU2DX(218)       
#define DELTAYBEQUADRO1Q Scr->Get_VU2DY(218)       
#define BEQUADRO1Q2UP   Scr->Get_VU2UP(218)        
#define BEQUADRO1Q2DWN  Scr->Get_VU2DWN(218)       
#define BEQUADRO1Q2LFT  Scr->Get_VU2LF(218)        
#define BEQUADRO1Q2RGT  Scr->Get_VU2RG(218)        

#define CODE_BEQUADRO3Q 219 - 256
#define DELTAXBEQUADRO3Q Scr->Get_VU2DX(219)       
#define DELTAYBEQUADRO3Q Scr->Get_VU2DY(219)       
#define BEQUADRO3Q2UP   Scr->Get_VU2UP(219)        
#define BEQUADRO3Q2DWN  Scr->Get_VU2DWN(219)       
#define BEQUADRO3Q2LFT  Scr->Get_VU2LF(219)        
#define BEQUADRO3Q2RGT  Scr->Get_VU2RG(219)        

#define CODE_DOPPIODIESIS_NOTINA 93 
#define DELTAXDOPPIODIESIS_NOTINA Scr->Get_VU2DX(93)       
#define DELTAYDOPPIODIESIS_NOTINA Scr->Get_VU2DY(93)       
#define DOPPIODIESIS2UP_NOTINA   Scr->Get_VU2UP(93)        
#define DOPPIODIESIS2DWN_NOTINA  Scr->Get_VU2DWN(93)       
#define DOPPIODIESIS2LFT_NOTINA  Scr->Get_VU2LF(93)        
#define DOPPIODIESIS2RGT_NOTINA  Scr->Get_VU2RG(93)        

#define CODE_DIESIS_NOTINA 73  
#define DELTAXDIESIS_NOTINA Scr->Get_VU2DX(73)       
#define DELTAYDIESIS_NOTINA Scr->Get_VU2DY(73)       
#define DIESIS2UP_NOTINA   Scr->Get_VU2UP(73)             
#define DIESIS2DWN_NOTINA  Scr->Get_VU2DWN(73)        
#define DIESIS2LFT_NOTINA  Scr->Get_VU2LF(73)        
#define DIESIS2RGT_NOTINA  Scr->Get_VU2RG(73)        

#define CODE_DIESIS1Q_NOTINA 186
#define DELTAXDIESIS1Q_NOTINA Scr->Get_VU2DX(186)       
#define DELTAYDIESIS1Q_NOTINA Scr->Get_VU2DY(186)       
#define DIESIS1Q2UP_NOTINA   Scr->Get_VU2UP(186)            
#define DIESIS1Q2DWN_NOTINA  Scr->Get_VU2DWN(186)      
#define DIESIS1Q2LFT_NOTINA  Scr->Get_VU2LF(186)       
#define DIESIS1Q2RGT_NOTINA  Scr->Get_VU2RG(186)       

#define CODE_DIESIS3Q_NOTINA 187
#define DELTAXDIESIS3Q_NOTINA Scr->Get_VU2DX(187)       
#define DELTAYDIESIS3Q_NOTINA Scr->Get_VU2DY(187)       
#define DIESIS3Q2UP_NOTINA   Scr->Get_VU2UP(187)            
#define DIESIS3Q2DWN_NOTINA  Scr->Get_VU2DWN(187)       
#define DIESIS3Q2LFT_NOTINA  Scr->Get_VU2LF(187)       
#define DIESIS3Q2RGT_NOTINA  Scr->Get_VU2RG(187)       

#define CODE_DOPPIOBEMOLLE_NOTINA 96       
#define DELTAXDOPPIOBEMOLLE_NOTINA Scr->Get_VU2DX(96)       
#define DELTAYDOPPIOBEMOLLE_NOTINA Scr->Get_VU2DY(96)       
#define DOPPIOBEMOLLE2UP_NOTINA  Scr->Get_VU2UP(96)          
#define DOPPIOBEMOLLE2DWN_NOTINA  Scr->Get_VU2DWN(96)      
#define DOPPIOBEMOLLE2LFT_NOTINA  Scr->Get_VU2LF(96)       
#define DOPPIOBEMOLLE2RGT_NOTINA  Scr->Get_VU2RG(96)       

#define CODE_BEMOLLE_NOTINA 105  
#define DELTAXBEMOLLE_NOTINA Scr->Get_VU2DX(105)       
#define DELTAYBEMOLLE_NOTINA Scr->Get_VU2DY(105)       
#define BEMOLLE2UP_NOTINA   Scr->Get_VU2UP(105)               
#define BEMOLLE2DWN_NOTINA  Scr->Get_VU2DWN(105)              
#define BEMOLLE2LFT_NOTINA  Scr->Get_VU2LF(105)              
#define BEMOLLE2RGT_NOTINA  Scr->Get_VU2RG(105)       

#define CODE_BEMOLLE1Q_NOTINA 188
#define DELTAXBEMOLLE1Q_NOTINA Scr->Get_VU2DX(188)       
#define DELTAYBEMOLLE1Q_NOTINA Scr->Get_VU2DY(188)       
#define BEMOLLE1Q2UP_NOTINA   Scr->Get_VU2UP(188)               
#define BEMOLLE1Q2DWN_NOTINA  Scr->Get_VU2DWN(188)               
#define BEMOLLE1Q2LFT_NOTINA  Scr->Get_VU2LF(188)               
#define BEMOLLE1Q2RGT_NOTINA  Scr->Get_VU2RG(188)        

#define CODE_BEMOLLE3Q_NOTINA 191
#define DELTAXBEMOLLE3Q_NOTINA Scr->Get_VU2DX(191)       
#define DELTAYBEMOLLE3Q_NOTINA Scr->Get_VU2DY(191)       
#define BEMOLLE3Q2UP_NOTINA   Scr->Get_VU2UP(191)               
#define BEMOLLE3Q2DWN_NOTINA  Scr->Get_VU2DWN(191)              
#define BEMOLLE3Q2LFT_NOTINA  Scr->Get_VU2LF(191)              
#define BEMOLLE3Q2RGT_NOTINA  Scr->Get_VU2RG(191)       

#define CODE_BEQUADRO_NOTINA 222-256        
#define DELTAXBEQUADRO_NOTINA Scr->Get_VU2DX(222)       
#define DELTAYBEQUADRO_NOTINA Scr->Get_VU2DY(222)       
#define BEQUADRO2UP_NOTINA   Scr->Get_VU2UP(222)             
#define BEQUADRO2DWN_NOTINA  Scr->Get_VU2DWN(222)              
#define BEQUADRO2LFT_NOTINA  Scr->Get_VU2LF(222)              
#define BEQUADRO2RGT_NOTINA  Scr->Get_VU2RG(222)             

#define CODE_BEQUADRO1Q_NOTINA 220 - 256
#define DELTAXBEQUADRO1Q_NOTINA Scr->Get_VU2DX(220)       
#define DELTAYBEQUADRO1Q_NOTINA Scr->Get_VU2DY(220)       
#define BEQUADRO1Q2UP_NOTINA   Scr->Get_VU2UP(220)        
#define BEQUADRO1Q2DWN_NOTINA  Scr->Get_VU2DWN(220)       
#define BEQUADRO1Q2LFT_NOTINA  Scr->Get_VU2LF(220)        
#define BEQUADRO1Q2RGT_NOTINA  Scr->Get_VU2RG(220)        

#define CODE_BEQUADRO3Q_NOTINA 221 - 256
#define DELTAXBEQUADRO3Q_NOTINA Scr->Get_VU2DX(221)       
#define DELTAYBEQUADRO3Q_NOTINA Scr->Get_VU2DY(221)       
#define BEQUADRO3Q2UP_NOTINA   Scr->Get_VU2UP(221)        
#define BEQUADRO3Q2DWN_NOTINA  Scr->Get_VU2DWN(221)       
#define BEQUADRO3Q2LFT_NOTINA  Scr->Get_VU2LF(221)        
#define BEQUADRO3Q2RGT_NOTINA  Scr->Get_VU2RG(221)        

#define CODE_BIG_OPENBRA 40
#define DELTAXBIG_OPENBRA Scr->Get_VU2DX(40)       
#define DELTAYBIG_OPENBRA Scr->Get_VU2DY(40)       
#define BIG_OPENBRA_2UP        Scr->Get_VU2UP(40)
#define BIG_OPENBRA_2DWN       Scr->Get_VU2DWN(40)
#define BIG_OPENBRA_2LFT       Scr->Get_VU2LF(40)
#define BIG_OPENBRA_2RGT       Scr->Get_VU2RG(40)

#define CODE_BIG_CLOSEBRA 41
#define DELTAXBIG_CLOSEBRA Scr->Get_VU2DX(41)       
#define DELTAYBIG_CLOSEBRA Scr->Get_VU2DY(41)       
#define BIG_CLOSEBRA_2UP        Scr->Get_VU2UP(41)
#define BIG_CLOSEBRA_2DWN       Scr->Get_VU2DWN(41)
#define BIG_CLOSEBRA_2LFT       Scr->Get_VU2LF(41)
#define BIG_CLOSEBRA_2RGT       Scr->Get_VU2RG(41)

#define CODE_SMALL_OPENBRA 232 - 256
#define DELTAXSMALL_OPENBRA Scr->Get_VU2DX(232)       
#define DELTAYSMALL_OPENBRA Scr->Get_VU2DY(232)       
#define SMALL_OPENBRA_2UP        Scr->Get_VU2UP(232)
#define SMALL_OPENBRA_2DWN       Scr->Get_VU2DWN(232)
#define SMALL_OPENBRA_2LFT       Scr->Get_VU2LF(232)
#define SMALL_OPENBRA_2RGT       Scr->Get_VU2RG(232)

#define CODE_SMALL_CLOSEBRA 233 - 256
#define DELTAXSMALL_CLOSEBRA Scr->Get_VU2DX(233)       
#define DELTAYSMALL_CLOSEBRA Scr->Get_VU2DY(233)       
#define SMALL_CLOSEBRA_2UP        Scr->Get_VU2UP(233)
#define SMALL_CLOSEBRA_2DWN       Scr->Get_VU2DWN(233)
#define SMALL_CLOSEBRA_2LFT       Scr->Get_VU2LF(233)
#define SMALL_CLOSEBRA_2RGT       Scr->Get_VU2RG(233)

// Tutti le alterazioni con parentesi sono state implementate nel
// secondo font
#define CODE_BRADOPPIODIESIS 137-256
#define DELTAXBRADOPPIODIESIS Scr->Get_VU2DX(137, MUSICFONT2_ID)       
#define DELTAYBRADOPPIODIESIS Scr->Get_VU2DY(137, MUSICFONT2_ID)       
#define BRADOPPIODIESIS2UP   Scr->Get_VU2UP(137, MUSICFONT2_ID)        
#define BRADOPPIODIESIS2DWN  Scr->Get_VU2DWN(137, MUSICFONT2_ID)       
#define BRADOPPIODIESIS2LFT  Scr->Get_VU2LF(137, MUSICFONT2_ID)        
#define BRADOPPIODIESIS2RGT  Scr->Get_VU2RG(137, MUSICFONT2_ID)        

#define CODE_BRADIESIS 131 - 256
#define DELTAXBRADIESIS Scr->Get_VU2DX(131, MUSICFONT2_ID)       
#define DELTAYBRADIESIS Scr->Get_VU2DY(131, MUSICFONT2_ID)       
#define BRADIESIS2UP   Scr->Get_VU2UP(131, MUSICFONT2_ID)        
#define BRADIESIS2DWN  Scr->Get_VU2DWN(131, MUSICFONT2_ID)       
#define BRADIESIS2LFT  Scr->Get_VU2LF(131, MUSICFONT2_ID)        
#define BRADIESIS2RGT  Scr->Get_VU2RG(131, MUSICFONT2_ID)        

#define CODE_BRADIESIS1Q 130 - 256
#define DELTAXBRADIESIS1Q Scr->Get_VU2DX(130, MUSICFONT2_ID)       
#define DELTAYBRADIESIS1Q Scr->Get_VU2DY(130, MUSICFONT2_ID)       
#define BRADIESIS1Q2UP   Scr->Get_VU2UP(130, MUSICFONT2_ID)        
#define BRADIESIS1Q2DWN  Scr->Get_VU2DWN(130, MUSICFONT2_ID)        
#define BRADIESIS1Q2LFT  Scr->Get_VU2LF(130, MUSICFONT2_ID)        
#define BRADIESIS1Q2RGT  Scr->Get_VU2RG(130, MUSICFONT2_ID)        

#define CODE_BRADIESIS3Q 132 - 256
#define DELTAXBRADIESIS3Q Scr->Get_VU2DX(132, MUSICFONT2_ID)      
#define DELTAYBRADIESIS3Q Scr->Get_VU2DY(132, MUSICFONT2_ID)      
#define BRADIESIS3Q2UP   Scr->Get_VU2UP(132, MUSICFONT2_ID)       
#define BRADIESIS3Q2DWN  Scr->Get_VU2DWN(132, MUSICFONT2_ID)      
#define BRADIESIS3Q2LFT  Scr->Get_VU2LF(132, MUSICFONT2_ID)       
#define BRADIESIS3Q2RGT  Scr->Get_VU2RG(132, MUSICFONT2_ID)       

#define CODE_BRADOPPIOBEMOLLE 138-256
#define DELTAXBRADOPPIOBEMOLLE Scr->Get_VU2DX(138, MUSICFONT2_ID)       
#define DELTAYBRADOPPIOBEMOLLE Scr->Get_VU2DY(138, MUSICFONT2_ID)       
#define BRADOPPIOBEMOLLE2UP   Scr->Get_VU2UP(138, MUSICFONT2_ID)        
#define BRADOPPIOBEMOLLE2DWN  Scr->Get_VU2DWN(138, MUSICFONT2_ID)       
#define BRADOPPIOBEMOLLE2LFT  Scr->Get_VU2LF(138, MUSICFONT2_ID)        
#define BRADOPPIOBEMOLLE2RGT  Scr->Get_VU2RG(138, MUSICFONT2_ID)        

#define CODE_BRABEMOLLE 134 - 256
#define DELTAXBRABEMOLLE Scr->Get_VU2DX(134, MUSICFONT2_ID)       
#define DELTAYBRABEMOLLE Scr->Get_VU2DY(134, MUSICFONT2_ID)       
#define BRABEMOLLE2UP   Scr->Get_VU2UP(134, MUSICFONT2_ID)        
#define BRABEMOLLE2DWN  Scr->Get_VU2DWN(134, MUSICFONT2_ID)       
#define BRABEMOLLE2LFT  Scr->Get_VU2LF(134, MUSICFONT2_ID)        
#define BRABEMOLLE2RGT  Scr->Get_VU2RG(134, MUSICFONT2_ID)        

#define CODE_BRABEMOLLE1Q 133 - 256
#define DELTAXBRABEMOLLE1Q Scr->Get_VU2DX(133, MUSICFONT2_ID)       
#define DELTAYBRABEMOLLE1Q Scr->Get_VU2DY(133, MUSICFONT2_ID)       
#define BRABEMOLLE1Q2UP   Scr->Get_VU2UP(133, MUSICFONT2_ID)        
#define BRABEMOLLE1Q2DWN  Scr->Get_VU2DWN(133, MUSICFONT2_ID)       
#define BRABEMOLLE1Q2LFT  Scr->Get_VU2LF(133, MUSICFONT2_ID)        
#define BRABEMOLLE1Q2RGT  Scr->Get_VU2RG(133, MUSICFONT2_ID)        

#define CODE_BRABEMOLLE3Q 135 - 256
#define DELTAXBRABEMOLLE3Q Scr->Get_VU2DX(135, MUSICFONT2_ID)       
#define DELTAYBRABEMOLLE3Q Scr->Get_VU2DY(135, MUSICFONT2_ID)       
#define BRABEMOLLE3Q2UP   Scr->Get_VU2UP(135, MUSICFONT2_ID)        
#define BRABEMOLLE3Q2DWN  Scr->Get_VU2DWN(135, MUSICFONT2_ID)       
#define BRABEMOLLE3Q2LFT  Scr->Get_VU2LF(135, MUSICFONT2_ID)        
#define BRABEMOLLE3Q2RGT  Scr->Get_VU2RG(135, MUSICFONT2_ID)        

#define CODE_BRABEQUADRO 136 - 256
#define DELTAXBRABEQUADRO Scr->Get_VU2DX(136, MUSICFONT2_ID)       
#define DELTAYBRABEQUADRO Scr->Get_VU2DY(136, MUSICFONT2_ID)       
#define BRABEQUADRO2UP   Scr->Get_VU2UP(136, MUSICFONT2_ID)        
#define BRABEQUADRO2DWN  Scr->Get_VU2DWN(136, MUSICFONT2_ID)       
#define BRABEQUADRO2LFT  Scr->Get_VU2LF(136, MUSICFONT2_ID)        
#define BRABEQUADRO2RGT  Scr->Get_VU2RG(136, MUSICFONT2_ID)        

#define CODE_BRABEQUADRO1Q 139 - 256
#define DELTAXBRABEQUADRO1Q Scr->Get_VU2DX(139, MUSICFONT2_ID)       
#define DELTAYBRABEQUADRO1Q Scr->Get_VU2DY(139, MUSICFONT2_ID)       
#define BRABEQUADRO1Q2UP   Scr->Get_VU2UP(139, MUSICFONT2_ID)        
#define BRABEQUADRO1Q2DWN  Scr->Get_VU2DWN(139, MUSICFONT2_ID)       
#define BRABEQUADRO1Q2LFT  Scr->Get_VU2LF(139, MUSICFONT2_ID)        
#define BRABEQUADRO1Q2RGT  Scr->Get_VU2RG(139, MUSICFONT2_ID)        

#define CODE_BRABEQUADRO3Q 140 - 256
#define DELTAXBRABEQUADRO3Q Scr->Get_VU2DX(140, MUSICFONT2_ID)       
#define DELTAYBRABEQUADRO3Q Scr->Get_VU2DY(140, MUSICFONT2_ID)       
#define BRABEQUADRO3Q2UP   Scr->Get_VU2UP(140, MUSICFONT2_ID)        
#define BRABEQUADRO3Q2DWN  Scr->Get_VU2DWN(140, MUSICFONT2_ID)       
#define BRABEQUADRO3Q2LFT  Scr->Get_VU2LF(140, MUSICFONT2_ID)        
#define BRABEQUADRO3Q2RGT  Scr->Get_VU2RG(140, MUSICFONT2_ID)        

#define CODE_BRADOPPIODIESIS_NOTINA 194 - 256 
#define DELTAXBRADOPPIODIESIS_NOTINA Scr->Get_VU2DX(194, MUSICFONT2_ID)       
#define DELTAYBRADOPPIODIESIS_NOTINA Scr->Get_VU2DY(194, MUSICFONT2_ID)       
#define BRADOPPIODIESIS2UP_NOTINA   Scr->Get_VU2UP(194, MUSICFONT2_ID)        
#define BRADOPPIODIESIS2DWN_NOTINA  Scr->Get_VU2DWN(194, MUSICFONT2_ID)       
#define BRADOPPIODIESIS2LFT_NOTINA  Scr->Get_VU2LF(194, MUSICFONT2_ID)        
#define BRADOPPIODIESIS2RGT_NOTINA  Scr->Get_VU2RG(194, MUSICFONT2_ID)        

#define CODE_BRADIESIS_NOTINA 188 - 256  
#define DELTAXBRADIESIS_NOTINA Scr->Get_VU2DX(188, MUSICFONT2_ID)       
#define DELTAYBRADIESIS_NOTINA Scr->Get_VU2DY(188, MUSICFONT2_ID)       
#define BRADIESIS2UP_NOTINA   Scr->Get_VU2UP(188, MUSICFONT2_ID)             
#define BRADIESIS2DWN_NOTINA  Scr->Get_VU2DWN(188, MUSICFONT2_ID)        
#define BRADIESIS2LFT_NOTINA  Scr->Get_VU2LF(188, MUSICFONT2_ID)        
#define BRADIESIS2RGT_NOTINA  Scr->Get_VU2RG(188, MUSICFONT2_ID)        

#define CODE_BRADIESIS1Q_NOTINA 187 - 256
#define DELTAXBRADIESIS1Q_NOTINA Scr->Get_VU2DX(187, MUSICFONT2_ID)       
#define DELTAYBRADIESIS1Q_NOTINA Scr->Get_VU2DY(187, MUSICFONT2_ID)       
#define BRADIESIS1Q2UP_NOTINA   Scr->Get_VU2UP(187, MUSICFONT2_ID)            
#define BRADIESIS1Q2DWN_NOTINA  Scr->Get_VU2DWN(187, MUSICFONT2_ID)      
#define BRADIESIS1Q2LFT_NOTINA  Scr->Get_VU2LF(187, MUSICFONT2_ID)       
#define BRADIESIS1Q2RGT_NOTINA  Scr->Get_VU2RG(187, MUSICFONT2_ID)       

#define CODE_BRADIESIS3Q_NOTINA 189 - 256
#define DELTAXBRADIESIS3Q_NOTINA Scr->Get_VU2DX(189, MUSICFONT2_ID)       
#define DELTAYBRADIESIS3Q_NOTINA Scr->Get_VU2DY(189, MUSICFONT2_ID)       
#define BRADIESIS3Q2UP_NOTINA   Scr->Get_VU2UP(189, MUSICFONT2_ID)            
#define BRADIESIS3Q2DWN_NOTINA  Scr->Get_VU2DWN(189, MUSICFONT2_ID)       
#define BRADIESIS3Q2LFT_NOTINA  Scr->Get_VU2LF(189, MUSICFONT2_ID)       
#define BRADIESIS3Q2RGT_NOTINA  Scr->Get_VU2RG(189, MUSICFONT2_ID)       

#define CODE_BRADOPPIOBEMOLLE_NOTINA 195 - 256       
#define DELTAXBRADOPPIOBEMOLLE_NOTINA Scr->Get_VU2DX(195, MUSICFONT2_ID)       
#define DELTAYBRADOPPIOBEMOLLE_NOTINA Scr->Get_VU2DY(195, MUSICFONT2_ID)       
#define BRADOPPIOBEMOLLE2UP_NOTINA  Scr->Get_VU2UP(195, MUSICFONT2_ID)          
#define BRADOPPIOBEMOLLE2DWN_NOTINA  Scr->Get_VU2DWN(195, MUSICFONT2_ID)      
#define BRADOPPIOBEMOLLE2LFT_NOTINA  Scr->Get_VU2LF(195, MUSICFONT2_ID)       
#define BRADOPPIOBEMOLLE2RGT_NOTINA  Scr->Get_VU2RG(195, MUSICFONT2_ID)       

#define CODE_BRABEMOLLE_NOTINA 191 - 256  
#define DELTAXBRABEMOLLE_NOTINA Scr->Get_VU2DX(191, MUSICFONT2_ID)       
#define DELTAYBRABEMOLLE_NOTINA Scr->Get_VU2DY(191, MUSICFONT2_ID)       
#define BRABEMOLLE2UP_NOTINA   Scr->Get_VU2UP(191, MUSICFONT2_ID)               
#define BRABEMOLLE2DWN_NOTINA  Scr->Get_VU2DWN(191, MUSICFONT2_ID)              
#define BRABEMOLLE2LFT_NOTINA  Scr->Get_VU2LF(191, MUSICFONT2_ID)              
#define BRABEMOLLE2RGT_NOTINA  Scr->Get_VU2RG(191, MUSICFONT2_ID)       

#define CODE_BRABEMOLLE1Q_NOTINA 190 - 256
#define DELTAXBRABEMOLLE1Q_NOTINA Scr->Get_VU2DX(190, MUSICFONT2_ID)       
#define DELTAYBRABEMOLLE1Q_NOTINA Scr->Get_VU2DY(190, MUSICFONT2_ID)       
#define BRABEMOLLE1Q2UP_NOTINA   Scr->Get_VU2UP(190, MUSICFONT2_ID)               
#define BRABEMOLLE1Q2DWN_NOTINA  Scr->Get_VU2DWN(190, MUSICFONT2_ID)               
#define BRABEMOLLE1Q2LFT_NOTINA  Scr->Get_VU2LF(190, MUSICFONT2_ID)               
#define BRABEMOLLE1Q2RGT_NOTINA  Scr->Get_VU2RG(190, MUSICFONT2_ID)        

#define CODE_BRABEMOLLE3Q_NOTINA 192 - 256
#define DELTAXBRABEMOLLE3Q_NOTINA Scr->Get_VU2DX(192, MUSICFONT2_ID)       
#define DELTAYBRABEMOLLE3Q_NOTINA Scr->Get_VU2DY(192, MUSICFONT2_ID)       
#define BRABEMOLLE3Q2UP_NOTINA   Scr->Get_VU2UP(192, MUSICFONT2_ID)               
#define BRABEMOLLE3Q2DWN_NOTINA  Scr->Get_VU2DWN(192, MUSICFONT2_ID)              
#define BRABEMOLLE3Q2LFT_NOTINA  Scr->Get_VU2LF(192, MUSICFONT2_ID)              
#define BRABEMOLLE3Q2RGT_NOTINA  Scr->Get_VU2RG(192, MUSICFONT2_ID)       

#define CODE_BRABEQUADRO_NOTINA 193-256        
#define DELTAXBRABEQUADRO_NOTINA Scr->Get_VU2DX(193, MUSICFONT2_ID)       
#define DELTAYBRABEQUADRO_NOTINA Scr->Get_VU2DY(193, MUSICFONT2_ID)       
#define BRABEQUADRO2UP_NOTINA   Scr->Get_VU2UP(193, MUSICFONT2_ID)             
#define BRABEQUADRO2DWN_NOTINA  Scr->Get_VU2DWN(193, MUSICFONT2_ID)              
#define BRABEQUADRO2LFT_NOTINA  Scr->Get_VU2LF(193, MUSICFONT2_ID)              
#define BRABEQUADRO2RGT_NOTINA  Scr->Get_VU2RG(193, MUSICFONT2_ID)             

#define CODE_BRABEQUADRO1Q_NOTINA 196 - 256
#define DELTAXBRABEQUADRO1Q_NOTINA Scr->Get_VU2DX(196, MUSICFONT2_ID)       
#define DELTAYBRABEQUADRO1Q_NOTINA Scr->Get_VU2DY(196, MUSICFONT2_ID)       
#define BRABEQUADRO1Q2UP_NOTINA   Scr->Get_VU2UP(196, MUSICFONT2_ID)        
#define BRABEQUADRO1Q2DWN_NOTINA  Scr->Get_VU2DWN(196, MUSICFONT2_ID)       
#define BRABEQUADRO1Q2LFT_NOTINA  Scr->Get_VU2LF(196, MUSICFONT2_ID)        
#define BRABEQUADRO1Q2RGT_NOTINA  Scr->Get_VU2RG(196, MUSICFONT2_ID)        

#define CODE_BRABEQUADRO3Q_NOTINA 197 - 256
#define DELTAXBRABEQUADRO3Q_NOTINA Scr->Get_VU2DX(197, MUSICFONT2_ID)       
#define DELTAYBRABEQUADRO3Q_NOTINA Scr->Get_VU2DY(197, MUSICFONT2_ID)       
#define BRABEQUADRO3Q2UP_NOTINA   Scr->Get_VU2UP(197, MUSICFONT2_ID)        
#define BRABEQUADRO3Q2DWN_NOTINA  Scr->Get_VU2DWN(197, MUSICFONT2_ID)       
#define BRABEQUADRO3Q2LFT_NOTINA  Scr->Get_VU2LF(197, MUSICFONT2_ID)        
#define BRABEQUADRO3Q2RGT_NOTINA  Scr->Get_VU2RG(197, MUSICFONT2_ID)        



//

#endif //DEF_ALT_HPP
