/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: diesis1q.cpp,v 1.1 2005/07/25 10:43:16 bellinpo Exp $ */


#include "alt/diesis1q.hpp" 

VUnit Diesis1Q::GetVU2Up() 
{	if (GetParentesi())
return (GetNotina())? (BRADIESIS1Q2UP_NOTINA):(BRADIESIS1Q2UP);
else
return (GetNotina())? DIESIS1Q2UP_NOTINA:DIESIS1Q2UP;
};

VUnit Diesis1Q::GetVU2Dwn() 
{	if (GetParentesi())
return (GetNotina())? (BRADIESIS1Q2DWN_NOTINA):(BRADIESIS1Q2DWN);
else
return (GetNotina())? DIESIS1Q2DWN_NOTINA:DIESIS1Q2DWN;
};

VUnit Diesis1Q::GetVU2Lft() 
{
	if (GetParentesi())
		return (GetNotina())? (BRADIESIS1Q2LFT_NOTINA):(BRADIESIS1Q2LFT);
	else
		return (GetNotina())? DIESIS1Q2LFT_NOTINA:DIESIS1Q2LFT;
};

VUnit Diesis1Q::GetVU2Rgt() 
{
	if (GetParentesi())
		return (GetNotina())? (BRADIESIS1Q2RGT_NOTINA):(BRADIESIS1Q2RGT);
	else
		return (GetNotina())? DIESIS1Q2RGT_NOTINA:DIESIS1Q2RGT;
}


void Diesis1Q::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	int oldFont;
	char code[2] = {0, 0};
	
	if (GetParentesi())
	{
		oldFont=Scr->SetFont(nMusicFont2);
		if (GetNotina())
		{
			code[0] = CODE_BRADIESIS1Q_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRADIESIS1Q_NOTINA,DELTAYBRADIESIS1Q_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_BRADIESIS1Q;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRADIESIS1Q,DELTAYBRADIESIS1Q)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
	}
	else 
	{
		oldFont=Scr->SetFont(nMusicFont);
		if (GetNotina())
		{
			code[0] = CODE_DIESIS1Q_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXDIESIS1Q_NOTINA,DELTAYDIESIS1Q_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_DIESIS1Q;
			Scr->TextTo(GetAbsPos()+Point(DELTAXDIESIS1Q,DELTAYDIESIS1Q)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		
	}
	
	Scr->SetFont(oldFont);
	
	Scr->SetColor(oldcol);
};  
