/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: doppiobe.cpp,v 1.1 2005/07/25 10:43:16 bellinpo Exp $ */


#include "alt/doppiobe.hpp"

VUnit DoppioBemolle::GetVU2Up() 
{	if (GetParentesi())
return (GetNotina())? (BRADOPPIOBEMOLLE2UP_NOTINA):(BRADOPPIOBEMOLLE2UP);
else
return (GetNotina())? DOPPIOBEMOLLE2UP_NOTINA:DOPPIOBEMOLLE2UP;
};

VUnit DoppioBemolle::GetVU2Dwn() 
{	if (GetParentesi())
return (GetNotina())? (BRADOPPIOBEMOLLE2DWN_NOTINA):(BRADOPPIOBEMOLLE2DWN);
else
return (GetNotina())? DOPPIOBEMOLLE2DWN_NOTINA:DOPPIOBEMOLLE2DWN;
};

VUnit DoppioBemolle::GetVU2Lft() 
{
	if (GetParentesi())
		return (GetNotina())? (BRADOPPIOBEMOLLE2LFT_NOTINA):(BRADOPPIOBEMOLLE2LFT);
	else
		return (GetNotina())? DOPPIOBEMOLLE2LFT_NOTINA:DOPPIOBEMOLLE2LFT;
};

VUnit DoppioBemolle::GetVU2Rgt() 
{
	if (GetParentesi())
		return (GetNotina())? (BRADOPPIOBEMOLLE2RGT_NOTINA):(BRADOPPIOBEMOLLE2RGT);
	else
		return (GetNotina())? DOPPIOBEMOLLE2RGT_NOTINA:DOPPIOBEMOLLE2RGT;
}


void DoppioBemolle::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	int oldFont;
	char code[2] = {0, 0};
	
	if (GetParentesi())
	{
		oldFont=Scr->SetFont(nMusicFont2);
		if (GetNotina())
		{
			code[0] = CODE_BRADOPPIOBEMOLLE_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRADOPPIOBEMOLLE_NOTINA,DELTAYBRADOPPIOBEMOLLE_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_BRADOPPIOBEMOLLE;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRADOPPIOBEMOLLE,DELTAYBRADOPPIOBEMOLLE)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
	}
	else 
	{
		oldFont=Scr->SetFont(nMusicFont);
		if (GetNotina())
		{
			code[0] = CODE_DOPPIOBEMOLLE_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXDOPPIOBEMOLLE_NOTINA,DELTAYDOPPIOBEMOLLE_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_DOPPIOBEMOLLE;
			Scr->TextTo(GetAbsPos()+Point(DELTAXDOPPIOBEMOLLE,DELTAYDOPPIOBEMOLLE)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		
	}
	
	Scr->SetFont(oldFont);

	Scr->SetColor(oldcol);

};  
