/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: doppiodi.cpp,v 1.1 2005/07/25 10:43:17 bellinpo Exp $ */


#include "alt/doppiodi.hpp"

VUnit DoppioDiesis::GetVU2Up() 
{	if (GetParentesi())
return (GetNotina())? (BRADOPPIODIESIS2UP_NOTINA):(BRADOPPIODIESIS2UP);
else
return (GetNotina())? DOPPIODIESIS2UP_NOTINA:DOPPIODIESIS2UP;
};

VUnit DoppioDiesis::GetVU2Dwn() 
{	if (GetParentesi())
return (GetNotina())? (BRADOPPIODIESIS2DWN_NOTINA):(BRADOPPIODIESIS2DWN);
else
return (GetNotina())? DOPPIODIESIS2DWN_NOTINA:DOPPIODIESIS2DWN;
};

VUnit DoppioDiesis::GetVU2Lft() 
{
	if (GetParentesi())
		return (GetNotina())? (BRADOPPIODIESIS2LFT_NOTINA):(BRADOPPIODIESIS2LFT);
	else
		return (GetNotina())? DOPPIODIESIS2LFT_NOTINA:DOPPIODIESIS2LFT;
};

VUnit DoppioDiesis::GetVU2Rgt() 
{
	if (GetParentesi())
		return (GetNotina())? (BRADOPPIODIESIS2RGT_NOTINA):(BRADOPPIODIESIS2RGT);
	else
		return (GetNotina())? DOPPIODIESIS2RGT_NOTINA:DOPPIODIESIS2RGT;
}


void DoppioDiesis::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	int oldFont;
	char code[2] = {0, 0};
	
	if (GetParentesi())
	{
		oldFont=Scr->SetFont(nMusicFont2);
		if (GetNotina())
		{
			code[0] = CODE_BRADOPPIODIESIS_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRADOPPIODIESIS_NOTINA,DELTAYBRADOPPIODIESIS_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_BRADOPPIODIESIS;
			Scr->TextTo(GetAbsPos()+Point(DELTAXBRADOPPIODIESIS,DELTAYBRADOPPIODIESIS)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
	}
	else 
	{
		oldFont=Scr->SetFont(nMusicFont);
		if (GetNotina())
		{
			code[0] = CODE_DOPPIODIESIS_NOTINA;
			Scr->TextTo(GetAbsPos()+Point(DELTAXDOPPIODIESIS_NOTINA,DELTAYDOPPIODIESIS_NOTINA)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		else
		{
			code[0] = CODE_DOPPIODIESIS;
			Scr->TextTo(GetAbsPos()+Point(DELTAXDOPPIODIESIS,DELTAYDOPPIODIESIS)+Point( GetDx(),GetDy() ));
			Scr->OutText((unsigned char *)code);
		}
		
	}
	
	Scr->SetFont(oldFont);

	Scr->SetColor(oldcol);

};  
