/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: barra.cpp,v 1.1 2005/07/25 10:50:59 bellinpo Exp $ */


#include "bat/barra.hpp"
#include "gui/dialogs.hpp"

Barra::Barra()
{ 
	NStaffLine=5;
	for(int i=0; i<MAX_VIEW; i++)
		ProlUp[i] = ProlDwn[i] = ProlDwnMultiStaff[i] = 0; 
	lineType=SOLID_LINE;
}

VUnit Barra::GetVU2Up()
{
	int gap;
	switch( NStaffLine )
	{
	case 1: gap=4;
		break;
	case 2: 
	case 3: gap=NStaffLine;
		break;
	case 4: gap=3;
		break;
	default:
		gap=4+(NStaffLine-5)/2;
		break;
	}
	
	return gap*VU_PER_ROW+ProlUp[currentView];	
}

VUnit Barra::GetVU2Dwn()
{
	int gap;
	switch( NStaffLine )
	{
		  case 1: gap=0;
			  break;
		  case 2: gap=1;
			  break;
		  case 3: gap=1;
			  break;
		  case 4: gap=0;
			  break;
		  default: 
			  gap=-(NStaffLine-4)/2;
			  break;
	}
	
	return -gap*VU_PER_ROW+ProlDwn[currentView]+ProlDwnMultiStaff[currentView];;
	
}


VUnit Barra::GetVU2Lft()
{ return 0;}; 

VUnit Barra::GetVU2Rgt()
{ return 0;};


tipoBarra Barra::GetTipoBarra()
{ return SINGOLA; }

void Barra::Setup(VUnit prUp, VUnit prDwn)
{
	ProlUp[currentView] = prUp;
	ProlDwn[currentView] = prDwn;
}

void Barra::SetProlDwnMultiStaff(VUnit ProlDwnMS)
{
	ProlDwnMultiStaff[currentView] = ProlDwnMS;
}

void Barra::SetPos(DrawObject *d,const Point& p)
{
	DrawObject::SetPos(d,p);
} 


void Barra::Draw(){}


