/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */



#include "bat/bdashed.hpp"
#include "drw/gscreen.hpp"

BDashed::BDashed(Bool lineetta)
{
	SetColor((ColorIcon)NORMAL_COLOR);
	Dashed=lineetta;
};

VUnit BDashed::GetVU2Up()
{return 0;};

VUnit BDashed::GetVU2Dwn()
{return 0;};

VUnit BDashed::GetVU2Lft()
{return 0;};

VUnit BDashed::GetVU2Rgt()
{return 0;};


void BDashed::Draw()
{
};  


void BDashed::Select()
{
	DrawObject::Select();
	return;
}

void BDashed::Deselect()
{
	DrawObject::Deselect();
	return;
}

UL BDashed::GetSp2NextFig()
{
	UL d=Figura::GetSp2NextFig();
	
	if(d==0)
	{
		d=VU2UL(GetWidth())*1.4;
		if ((tipoLeggio==LEGGIO_MASAE) || (tipoLeggio==LEGGIO_MASE))
			SetSpG(d); //attenzione al leggio!!!
		if ((tipoLeggio==LEGGIO_DLIOO) || (tipoLeggio==LEGGIO_PDLOO)) 
			SetSpOr(d);
	}
	return d;
}

