/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: bfinale.cpp,v 1.1 2005/07/25 10:51:00 bellinpo Exp $ */


#include "bat/bfinale.hpp"
#include "drw/gscreen.hpp"

BFinale::BFinale()
{
	ID = CL_BFINALE;
}


VUnit BFinale::GetVU2Rgt() 
{return BFINALE2RGT;};

tipoBarra BFinale::GetTipoBarra()
{ return FINALE; }

void BFinale::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	Scr->Line(GetAbsPos()+Point(0,-GetVU2Dwn()),
		GetAbsPos()+Point(0,GetVU2Up()));
	Scr->Rect(class Rectangle(GetAbsPos()+Point(BDOPPIA2RGT,-GetVU2Dwn()),
		GetAbsPos()+Point(BFINALE2RGT,GetVU2Up())),TRUE);
	
	Scr->SetColor(oldcol);

};  

