/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: binifine.cpp,v 1.1 2005/07/25 10:51:01 bellinpo Exp $ */


#include "bat/binifine.hpp"
#include "drw/gscreen.hpp"

BInizioFine::BInizioFine()
{
	ID = CL_BINIZIOFINERIT;
}


VUnit BInizioFine::GetVU2Rgt() 
{ return bi.GetVU2Rgt() + bf.GetVU2Rgt(); }

tipoBarra BInizioFine::GetTipoBarra()
{ return INIZIOFINERIT; }




void BInizioFine::SetPos(DrawObject *d,const Point& p)
{
	DrawObject::SetPos(d,p);
	
	bi.SetNStaffLine(GetNStaffLine());
	bf.SetNStaffLine(GetNStaffLine());
	
	bf.SetPos(d,p);
	bi.SetPos(d,p + Point(bf.GetVU2Rgt(),0));
    
} 

void BInizioFine::SetColor(int col)
{
	bf.SetColor((ColorIcon)col);
	bi.SetColor((ColorIcon)col);
	DrawObject::SetColor((ColorIcon)col);
	return;
}

void BInizioFine::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());
	
	bf.Draw();
	bi.Draw();
	
	Scr->Line(GetAbsPos()+Point(DELTAXBFINERIT,-GetVU2Dwn()),
		GetAbsPos()+Point(DELTAXBFINERIT,GetVU2Up()));
	Scr->Rect(class Rectangle(GetAbsPos()+Point(DELTAXBFINERIT+BDOPPIA2RGT,-GetVU2Dwn()),
		      GetAbsPos()+Point(BFINERIT2RGT,GetVU2Up())),TRUE);
	
	Scr->Rect(class Rectangle(GetAbsPos()+Point(BFINERIT2RGT, -GetVU2Dwn()),
		      GetAbsPos()+Point(BFINERIT2RGT + WDTBIGLINE, GetVU2Up())), TRUE);
	Scr->Line(GetAbsPos()+Point(BFINERIT2RGT + BFINALE2RGT, -GetVU2Dwn()),
		GetAbsPos()+Point(BFINERIT2RGT + BFINALE2RGT, GetVU2Up()));
	

	Scr->SetColor(oldcol);
};  


