/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: bsingola.cpp,v 1.1 2005/07/25 10:51:02 bellinpo Exp $ */


#include "bat/bsingola.hpp"
#include "drw/gscreen.hpp"

BSingola::BSingola()
{
	ID = CL_BSINGOLA;
	RepeatDoubleMeasure = false;
	lineType=SOLID_LINE;
}

BSingola::BSingola(bool ripeti_doppia_battuta)
{
	ID = CL_BSINGOLA;
	RepeatDoubleMeasure = ripeti_doppia_battuta;
}

VUnit BSingola::GetVU2Rgt() 
{return 0;};

tipoBarra BSingola::GetTipoBarra()
{ return SINGOLA; }

bool BSingola::IsRepeatDoublemeasure()
{
	return RepeatDoubleMeasure;
}

void BSingola::SetLineType(LineType tp)
{ lineType = tp; }

LineType BSingola::GetLineType()
{ return lineType; }

void BSingola::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	if (RepeatDoubleMeasure)
	{  
		char code[2]={0,0};
		code[0]=CODE_RIPDOPPIABATTUTA;
		Scr->TextTo(GetAbsPos() + Point (DELTAXRIPDOPPIABATTUTA,DELTAYRIPDOPPIABATTUTA));
		Scr->OutText((unsigned char *)code);
	}
	
	Scr->Line(GetAbsPos()+Point(0,-GetVU2Dwn()),GetAbsPos()+Point(0,GetVU2Up()), lineType);
	
	Scr->SetColor(oldcol);
}  


