/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: cbasso8sopra.cpp,v 1.1 2005/07/25 10:51:03 bellinpo Exp $ */



#include "bat/cbasso8sopra.hpp" 

VUnit CBasso8Sopra::GetVU2Up()  
{return ((GetChiavina())? CBASSO8SOPRA2UP_CHIAVINA: CBASSO8SOPRA2UP);};

VUnit CBasso8Sopra::GetVU2Dwn() 
{return ((GetChiavina())? CBASSO8SOPRA2DWN_CHIAVINA: CBASSO8SOPRA2DWN);};

VUnit CBasso8Sopra::GetVU2Lft() 
{return ((GetChiavina())? CBASSO8SOPRA2LFT_CHIAVINA: CBASSO8SOPRA2LFT);};

VUnit CBasso8Sopra::GetVU2Rgt() 
{return ((GetChiavina())? CBASSO8SOPRA2RGT_CHIAVINA: CBASSO8SOPRA2RGT);};

int CBasso8Sopra::GetShift() 
{return CBASSO8SOPRASHIFT; };

int CBasso8Sopra::GetAltezza() 
{
	if (GetChiavina())
		return ALTEZZA_CBASSO8SOPRA_INA;
	else 
		return ALTEZZA_CBASSO8SOPRA;  
};


void CBasso8Sopra::SetPos(DrawObject *d,const Point& p)
{
	DrawObject::SetPos(d,p);
	if (GetChiavina())
		GetAbsPos().y+=ALTEZZA_CBASSO8SOPRA_INA*VU_PER_ROW/2;
	else 
		GetAbsPos().y+=ALTEZZA_CBASSO8SOPRA*VU_PER_ROW/2; 
}; 


void CBasso8Sopra::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	char code[2]={0,0};
	code[0]=((GetChiavina())? CODE_CBASSO8SOPRA_CHIAVINA: CODE_CBASSO8SOPRA);
	
	if (GetChiavina())
	{
		Scr->TextTo(GetAbsPos()+Point(DELTAXCBASSO8SOPRA_CHIAVINA,DELTAYCBASSO8SOPRA_CHIAVINA));
	}
	else
	{
		Scr->TextTo(GetAbsPos()+Point(DELTAXCBASSO8SOPRA,DELTAYCBASSO8SOPRA));
	}
	
	Scr->OutText((unsigned char *)code);
	
	Chiave::Draw();

	Scr->SetColor(oldcol);
};  

void CBasso8Sopra::Adjust(Bool primaleg, Battuta *pBattuta, short current_layer, short current_staff) 
{
	if(GetChiavina())
	{
		SetVU2UpF(CBASSO8SOPRA2UP_CHIAVINA);
		SetVU2DwnF(CBASSO8SOPRA2DWN_CHIAVINA);
		SetVU2LftF(CBASSO8SOPRA2LFT_CHIAVINA);
		SetVU2RgtF(CBASSO8SOPRA2RGT_CHIAVINA);
	}
	else
	{
		SetVU2DwnF(CBASSO8SOPRA2UP);
		SetVU2DwnF(CBASSO8SOPRA2DWN);
		SetVU2LftF(CBASSO8SOPRA2LFT);
		SetVU2RgtF(CBASSO8SOPRA2RGT);
	}
	
	Figura::Adjust(primaleg, pBattuta, current_layer, current_staff);
}