/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: cpercus2lines.cpp,v 1.1 2005/07/25 10:51:05 bellinpo Exp $ */


#include "bat/cpercus2lines.hpp"

VUnit CPercus2Lines::GetVU2Up()  
{return ((GetChiavina())? CPERCUS2LINES2UP_CHIAVINA: CPERCUS2LINES2UP);};

VUnit CPercus2Lines::GetVU2Dwn() 
{return ((GetChiavina())? CPERCUS2LINES2DWN_CHIAVINA: CPERCUS2LINES2DWN);};

VUnit CPercus2Lines::GetVU2Lft() 
{return ((GetChiavina())? CPERCUS2LINES2LFT_CHIAVINA: CPERCUS2LINES2LFT);};

VUnit CPercus2Lines::GetVU2Rgt() 
{return ((GetChiavina())? CPERCUS2LINES2RGT_CHIAVINA: CPERCUS2LINES2RGT);};

int CPercus2Lines::GetShift() 
{return CPERCUS2LINESSHIFT; };

int CPercus2Lines::GetAltezza() 
{
	if (GetChiavina())
		return ALTEZZA_CPERCUS2LINES_INA;
	else 
		return ALTEZZA_CPERCUS2LINES;
};


void CPercus2Lines::SetPos(DrawObject *d,const Point& p)
{
	DrawObject::SetPos(d,p);
	if (GetChiavina())
		GetAbsPos().y+=ALTEZZA_CPERCUS2LINES_INA*VU_PER_ROW/2; 
	else 
		GetAbsPos().y+=ALTEZZA_CPERCUS2LINES*VU_PER_ROW/2; 
}; 


void CPercus2Lines::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	char code[2]={0,0};
	code[0]=((GetChiavina())? CODE_CPERCUS2LINES_CHIAVINA: CODE_CPERCUS2LINES);

	if (GetChiavina())
		Scr->TextTo(GetAbsPos()+Point(DELTAXCPERCUS2LINES_CHIAVINA,DELTAYCPERCUS2LINES_CHIAVINA));
	else
		Scr->TextTo(GetAbsPos()+Point(DELTAXCPERCUS2LINES,DELTAYCPERCUS2LINES));
	Scr->OutText((unsigned char *)code);
	
	Chiave::Draw();

	Scr->SetColor(oldcol);
};  

void CPercus2Lines::Adjust(Bool primaleg, Battuta *pBattuta, short current_layer, short current_staff) 
{
	if(GetChiavina())
	{
		SetVU2UpF(CPERCUS2LINES2UP_CHIAVINA);
		SetVU2DwnF(CPERCUS2LINES2DWN_CHIAVINA);
		SetVU2LftF(CPERCUS2LINES2LFT_CHIAVINA);
		SetVU2RgtF(CPERCUS2LINES2RGT_CHIAVINA);
	}
	else
	{
		SetVU2DwnF(CPERCUS2LINES2UP);
		SetVU2DwnF(CPERCUS2LINES2DWN);
		SetVU2LftF(CPERCUS2LINES2LFT);
		SetVU2RgtF(CPERCUS2LINES2RGT);
	}
	
	Figura::Adjust(primaleg, pBattuta, current_layer, current_staff);
}

