/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: cpercusbox.cpp,v 1.1 2005/07/25 10:51:05 bellinpo Exp $ */


#include "bat/cpercusbox.hpp"

VUnit CPercusBox::GetVU2Up()  
{return ((GetChiavina())? CPERCUSBOX2UP_CHIAVINA: CPERCUSBOX2UP);};

VUnit CPercusBox::GetVU2Dwn() 
{return ((GetChiavina())? CPERCUSBOX2DWN_CHIAVINA: CPERCUSBOX2DWN);};

VUnit CPercusBox::GetVU2Lft() 
{return ((GetChiavina())? CPERCUSBOX2LFT_CHIAVINA: CPERCUSBOX2LFT);};

VUnit CPercusBox::GetVU2Rgt() 
{return ((GetChiavina())? CPERCUSBOX2RGT_CHIAVINA: CPERCUSBOX2RGT);};

int CPercusBox::GetShift() 
{return CPERCUSBOXSHIFT; };

int CPercusBox::GetAltezza() 
{
	if (GetChiavina())
		return ALTEZZA_CPERCUSBOX_INA;
	else 
		return ALTEZZA_CPERCUSBOX;
};


void CPercusBox::SetPos(DrawObject *d,const Point& p)
{
	DrawObject::SetPos(d,p);
	if (GetChiavina())
		GetAbsPos().y+=ALTEZZA_CPERCUSBOX_INA*VU_PER_ROW/2; 
	else 
		GetAbsPos().y+=ALTEZZA_CPERCUSBOX*VU_PER_ROW/2; 
}; 


void CPercusBox::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	char code[2]={0,0};
	code[0]=((GetChiavina())? CODE_CPERCUSBOX_CHIAVINA: CODE_CPERCUSBOX);

	if (GetChiavina())
		Scr->TextTo(GetAbsPos()+Point(DELTAXCPERCUSBOX_CHIAVINA,DELTAYCPERCUSBOX_CHIAVINA));
	else
		Scr->TextTo(GetAbsPos()+Point(DELTAXCPERCUSBOX,DELTAYCPERCUSBOX));
	Scr->OutText((unsigned char *)code);
	
	Chiave::Draw();

	Scr->SetColor(oldcol);
};  

void CPercusBox::Adjust(Bool primaleg, Battuta *pBattuta, short current_layer, short current_staff) 
{
	if(GetChiavina())
	{
		SetVU2UpF(CPERCUSBOX2UP_CHIAVINA);
		SetVU2DwnF(CPERCUSBOX2DWN_CHIAVINA);
		SetVU2LftF(CPERCUSBOX2LFT_CHIAVINA);
		SetVU2RgtF(CPERCUSBOX2RGT_CHIAVINA);
	}
	else
	{
		SetVU2DwnF(CPERCUSBOX2UP);
		SetVU2DwnF(CPERCUSBOX2DWN);
		SetVU2LftF(CPERCUSBOX2LFT);
		SetVU2RgtF(CPERCUSBOX2RGT);
	}
	
	Figura::Adjust(primaleg, pBattuta, current_layer, current_staff);
}
