/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: cviolino.cpp,v 1.1 2005/07/25 10:51:07 bellinpo Exp $ */


#include "bat/cviolino.hpp"

VUnit CViolino::GetVU2Up()  
{return ((GetChiavina())? CVIOLINO2UP_CHIAVINA: CVIOLINO2UP);};

VUnit CViolino::GetVU2Dwn() 
{return ((GetChiavina())? CVIOLINO2DWN_CHIAVINA: CVIOLINO2DWN);};

VUnit CViolino::GetVU2Lft() 
{return ((GetChiavina())? CVIOLINO2LFT_CHIAVINA: CVIOLINO2LFT);};

VUnit CViolino::GetVU2Rgt() 
{return ((GetChiavina())? CVIOLINO2RGT_CHIAVINA: CVIOLINO2RGT);};

int CViolino::GetShift() 
{return CVIOLINOSHIFT; };

int CViolino::GetAltezza() 
{
	if (GetChiavina())
		return ALTEZZA_CVIOLINO_INA;
	else 
		return ALTEZZA_CVIOLINO;
};


void CViolino::SetPos(DrawObject *d,const Point& p)
{
	DrawObject::SetPos(d,p);
	if (GetChiavina())
		GetAbsPos().y+=ALTEZZA_CVIOLINO_INA*VU_PER_ROW/2; 
	else 
		GetAbsPos().y+=ALTEZZA_CVIOLINO*VU_PER_ROW/2; 
}; 


void CViolino::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	char code[2]={0,0};
	code[0]=((GetChiavina())? CODE_CVIOLINO_CHIAVINA: CODE_CVIOLINO);

	if (GetChiavina())
		Scr->TextTo(GetAbsPos()+Point(DELTAXCVIOLINO_CHIAVINA,DELTAYCVIOLINO_CHIAVINA));
	else
		Scr->TextTo(GetAbsPos()+Point(DELTAXCVIOLINO,DELTAYCVIOLINO));
	Scr->OutText((unsigned char *)code);
	
	Chiave::Draw();

	Scr->SetColor(oldcol);
};  

void CViolino::Adjust(Bool primaleg, Battuta *pBattuta, short current_layer, short current_staff) 
{
	if(GetChiavina())
	{
		SetVU2UpF(CVIOLINO2UP_CHIAVINA);
		SetVU2DwnF(CVIOLINO2DWN_CHIAVINA);
		SetVU2LftF(CVIOLINO2LFT_CHIAVINA);
		SetVU2RgtF(CVIOLINO2RGT_CHIAVINA);
	}
	else
	{
		SetVU2DwnF(CVIOLINO2UP);
		SetVU2DwnF(CVIOLINO2DWN);
		SetVU2LftF(CVIOLINO2LFT);
		SetVU2RgtF(CVIOLINO2RGT);
	}
	
	Figura::Adjust(primaleg, pBattuta, current_layer, current_staff);
}