/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: cvuota.cpp,v 1.1 2005/07/25 10:51:08 bellinpo Exp $ */


#include "bat/cvuota.hpp"

VUnit CVuota::GetVU2Up()  
{return ((GetChiavina())? CVUOTA2UP_CHIAVINA: CVUOTA2UP);};

VUnit CVuota::GetVU2Dwn() 
{return ((GetChiavina())? CVUOTA2DWN_CHIAVINA: CVUOTA2DWN);};

VUnit CVuota::GetVU2Lft() 
{return ((GetChiavina())? CVUOTA2LFT_CHIAVINA: CVUOTA2LFT);};

VUnit CVuota::GetVU2Rgt() 
{return ((GetChiavina())? CVUOTA2RGT_CHIAVINA: CVUOTA2RGT);};

int CVuota::GetShift() 
{return CVUOTASHIFT; };

int CVuota::GetAltezza() 
{
	if (GetChiavina())
		return ALTEZZA_CVUOTA_INA;
	else 
		return ALTEZZA_CVUOTA;
};


void CVuota::SetPos(DrawObject *d,const Point& p)
{
	DrawObject::SetPos(d,p);
	if (GetChiavina())
		GetAbsPos().y+=ALTEZZA_CVUOTA_INA*VU_PER_ROW/2; 
	else 
		GetAbsPos().y+=ALTEZZA_CVUOTA*VU_PER_ROW/2; 
}; 


void CVuota::Draw()
{
};  

void CVuota::Adjust(Bool primaleg, Battuta *pBattuta, short current_layer, short current_staff) 
{
	if(GetChiavina())
	{
		SetVU2UpF(CVUOTA2UP_CHIAVINA);
		SetVU2DwnF(CVUOTA2DWN_CHIAVINA);
		SetVU2LftF(CVUOTA2LFT_CHIAVINA);
		SetVU2RgtF(CVUOTA2RGT_CHIAVINA);
	}
	else
	{
		SetVU2DwnF(CVUOTA2UP);
		SetVU2DwnF(CVUOTA2DWN);
		SetVU2LftF(CVUOTA2LFT);
		SetVU2RgtF(CVUOTA2RGT);
	}
	
	Figura::Adjust(primaleg, pBattuta, current_layer, current_staff);
}
