/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: def_bat.hpp,v 1.1 2005/07/25 10:51:08 bellinpo Exp $ */

class Scr;


#ifndef DEF_BAT_HPP
#define DEF_BAT_HPP


#define CODE_CVIOLINO 38
#define CODE_CVIOLINO_CHIAVINA 194-256
#define CODE_CVIOLINO8 86
#define CODE_CVIOLINO8_CHIAVINA 195-256
#define CODE_CVIOLINO8SOPRA 69
#define CODE_CVIOLINO8SOPRA_CHIAVINA 159-256
#define CODE_CBASSO 63
#define CODE_CBASSO_CHIAVINA 193-256
#define CODE_CBASSO8 203-256
#define CODE_CBASSO8_CHIAVINA 204-256
#define CODE_CBARITONO 63
#define CODE_CBARITONO_CHIAVINA 193-256
#define CODE_CTENORE 66
#define CODE_CTENORE_CHIAVINA 192-256
#define CODE_CTENORE8 81
#define CODE_CTENORE8_CHIAVINA 33
#define CODE_CCONTRALTO 66
#define CODE_CCONTRALTO_CHIAVINA 192-256
#define CODE_CMEZZOSOPRANO 66
#define CODE_CMEZZOSOPRANO_CHIAVINA 192-256
#define CODE_CSOPRANO 66
#define CODE_CSOPRANO_CHIAVINA 192-256
#define CODE_CBASSO8SOPRA 140-256
#define CODE_CBASSO8SOPRA_CHIAVINA 168-256 
#define CODE_CTAB 139-256
#define CODE_CTAB_CHIAVINA 212 - 256 
#define CODE_CPERCUSBOX 135-256
#define CODE_CPERCUSBOX_CHIAVINA 34 
#define CODE_CPERCUS2LINES 131-256
#define CODE_CPERCUS2LINES_CHIAVINA 161 - 256 
#define CODE_CVUOTA 32
#define CODE_CVUOTA_CHIAVINA 78 
#define CODE_CBASSOOLD 130-256
#define CODE_CBASSOOLD_CHIAVINA 160-256 



#define MAX_GRUPPI 10
// numero massimo di gruppi che riesce a gestire per inserimento.
#define MAX_FIGURE 64
// numero massimo di figure in un pentagramma


#define DIST_BATT_INTEST 0
#define DIST_INTEST_CHIAVE 10
#define DIST_CHIAVE_ARMCHIAVE 5 //10
#define DIST_ARMCHIAVE_TEMPO 10
#define DIST_INTEST_TEMPO (DIST_INTEST_CHIAVE+DIST_CHIAVE_ARMCHIAVE+DIST_ARMCHIAVE_TEMPO)
#define DIST_FIGURE_BARRA 0

#define DIST_ALTERAZIONI_ARMAT 8 //10
#define DELTAX_ARM_DIESIS7 (6 * DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_DIESIS7 4
#define DELTAX_ARM_DIESIS6 (DELTAX_ARM_DIESIS7 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_DIESIS6 7
#define DELTAX_ARM_DIESIS5 (DELTAX_ARM_DIESIS6 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_DIESIS5 3
#define DELTAX_ARM_DIESIS4 (DELTAX_ARM_DIESIS5 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_DIESIS4 6
#define DELTAX_ARM_DIESIS3 (DELTAX_ARM_DIESIS4 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_DIESIS3 9
#define DELTAX_ARM_DIESIS2 (DELTAX_ARM_DIESIS3 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_DIESIS2 5
#define DELTAX_ARM_DIESIS1 (DELTAX_ARM_DIESIS2 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_DIESIS1 8

#define DELTAX_ARM_BEMOLLE7 (6 * DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_BEMOLLE7 1
#define DELTAX_ARM_BEMOLLE6 (DELTAX_ARM_BEMOLLE7 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_BEMOLLE6 5
#define DELTAX_ARM_BEMOLLE5 (DELTAX_ARM_BEMOLLE6 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_BEMOLLE5 2
#define DELTAX_ARM_BEMOLLE4 (DELTAX_ARM_BEMOLLE5 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_BEMOLLE4 6
#define DELTAX_ARM_BEMOLLE3 (DELTAX_ARM_BEMOLLE4 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_BEMOLLE3 3
#define DELTAX_ARM_BEMOLLE2 (DELTAX_ARM_BEMOLLE3 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_BEMOLLE2 7
#define DELTAX_ARM_BEMOLLE1 (DELTAX_ARM_BEMOLLE2 - DIST_ALTERAZIONI_ARMAT)
#define ALTEZZA_ARM_BEMOLLE1 4

#define CBASSO2UP   Scr->Get_VU2UP(63)       
#define CBASSO2DWN  Scr->Get_VU2DWN(63)-5    
// il 5 dipende dalla distanza tra 2 righe del pentagramma
#define CBASSO2LFT  Scr->Get_VU2LF(63)       
#define CBASSO2RGT  Scr->Get_VU2RG(63)       
#define CBASSO2UP_CHIAVINA   Scr->Get_VU2UP(193)       
#define CBASSO2DWN_CHIAVINA  Scr->Get_VU2DWN(193)      
#define CBASSO2LFT_CHIAVINA  Scr->Get_VU2LF(193)       
#define CBASSO2RGT_CHIAVINA  Scr->Get_VU2RG(193)       
#define DELTAXCBASSO Scr->Get_VU2DX(63)       
#define DELTAYCBASSO Scr->Get_VU2DY(63)       
#define DELTAXCBASSO_CHIAVINA Scr->Get_VU2DX(193)       
#define DELTAYCBASSO_CHIAVINA Scr->Get_VU2DY(193)       

#define CBASSO82UP   Scr->Get_VU2UP(203)       
#define CBASSO82DWN  Scr->Get_VU2DWN(203)       
#define CBASSO82LFT  Scr->Get_VU2LF(203)       
#define CBASSO82RGT  Scr->Get_VU2RG(203)       
#define CBASSO82UP_CHIAVINA   Scr->Get_VU2UP(204)       
#define CBASSO82DWN_CHIAVINA  Scr->Get_VU2DWN(204)      
#define CBASSO82LFT_CHIAVINA  Scr->Get_VU2LF(204)       
#define CBASSO82RGT_CHIAVINA  Scr->Get_VU2RG(204)       
#define DELTAXCBASSO8 Scr->Get_VU2DX(203)       
#define DELTAYCBASSO8 Scr->Get_VU2DY(203)       
#define DELTAXCBASSO8_CHIAVINA Scr->Get_VU2DX(204)       
#define DELTAYCBASSO8_CHIAVINA Scr->Get_VU2DY(204)       

#define CBASSO8SOPRA2UP   Scr->Get_VU2UP(140)       
#define CBASSO8SOPRA2DWN  Scr->Get_VU2DWN(140)       
#define CBASSO8SOPRA2LFT  Scr->Get_VU2LF(140)       
#define CBASSO8SOPRA2RGT  Scr->Get_VU2RG(140)       
#define CBASSO8SOPRA2UP_CHIAVINA   Scr->Get_VU2UP(168)       
#define CBASSO8SOPRA2DWN_CHIAVINA  Scr->Get_VU2DWN(168)      
#define CBASSO8SOPRA2LFT_CHIAVINA  Scr->Get_VU2LF(168)       
#define CBASSO8SOPRA2RGT_CHIAVINA  Scr->Get_VU2RG(168)       
#define DELTAXCBASSO8SOPRA Scr->Get_VU2DX(140)       
#define DELTAYCBASSO8SOPRA Scr->Get_VU2DY(140)       
#define DELTAXCBASSO8SOPRA_CHIAVINA Scr->Get_VU2DX(168)       
#define DELTAYCBASSO8SOPRA_CHIAVINA Scr->Get_VU2DY(168)       

#define CBARITONO2UP   Scr->Get_VU2UP(63)       
#define CBARITONO2DWN  Scr->Get_VU2DWN(63)      
#define CBARITONO2LFT  Scr->Get_VU2LF(63)       
#define CBARITONO2RGT  Scr->Get_VU2RG(63)       
#define CBARITONO2UP_CHIAVINA   Scr->Get_VU2UP(193)       
#define CBARITONO2DWN_CHIAVINA  Scr->Get_VU2DWN(193)      
#define CBARITONO2LFT_CHIAVINA  Scr->Get_VU2LF(193)       
#define CBARITONO2RGT_CHIAVINA  Scr->Get_VU2RG(193)       
#define DELTAXCBARITONO Scr->Get_VU2DX(63)       
#define DELTAYCBARITONO Scr->Get_VU2DY(63)       
#define DELTAXCBARITONO_CHIAVINA Scr->Get_VU2DX(193)       
#define DELTAYCBARITONO_CHIAVINA Scr->Get_VU2DY(193)       

#define CTENORE2UP   Scr->Get_VU2UP(66)       
#define CTENORE2DWN  Scr->Get_VU2DWN(66)      
#define CTENORE2LFT  Scr->Get_VU2LF(66)       
#define CTENORE2RGT  Scr->Get_VU2RG(66)       
#define CTENORE2UP_CHIAVINA   Scr->Get_VU2UP(192)       
#define CTENORE2DWN_CHIAVINA  Scr->Get_VU2DWN(192)      
#define CTENORE2LFT_CHIAVINA  Scr->Get_VU2LF(192)       
#define CTENORE2RGT_CHIAVINA  Scr->Get_VU2RG(192)       
#define DELTAXCTENORE Scr->Get_VU2DX(66)       
#define DELTAYCTENORE Scr->Get_VU2DY(66)       
#define DELTAXCTENORE_CHIAVINA Scr->Get_VU2DX(192)       
#define DELTAYCTENORE_CHIAVINA Scr->Get_VU2DY(192)       

#define CTENORE82UP   Scr->Get_VU2UP(81)       
#define CTENORE82DWN  Scr->Get_VU2DWN(81)      
#define CTENORE82LFT  Scr->Get_VU2LF(81)       
#define CTENORE82RGT  Scr->Get_VU2RG(81)       
#define CTENORE82UP_CHIAVINA   Scr->Get_VU2UP(33)       
#define CTENORE82DWN_CHIAVINA  Scr->Get_VU2DWN(33)      
#define CTENORE82LFT_CHIAVINA  Scr->Get_VU2LF(33)       
#define CTENORE82RGT_CHIAVINA  Scr->Get_VU2RG(33)       
#define DELTAXCTENORE8 Scr->Get_VU2DX(81)       
#define DELTAYCTENORE8 Scr->Get_VU2DY(81)       
#define DELTAXCTENORE8_CHIAVINA Scr->Get_VU2DX(33)       
#define DELTAYCTENORE8_CHIAVINA Scr->Get_VU2DY(33)       


#define CCONTRALTO2UP   Scr->Get_VU2UP(66)       
#define CCONTRALTO2DWN  Scr->Get_VU2DWN(66)      
#define CCONTRALTO2LFT  Scr->Get_VU2LF(66)       
#define CCONTRALTO2RGT  Scr->Get_VU2RG(66)       
#define CCONTRALTO2UP_CHIAVINA   Scr->Get_VU2UP(192)       
#define CCONTRALTO2DWN_CHIAVINA  Scr->Get_VU2DWN(192)      
#define CCONTRALTO2LFT_CHIAVINA  Scr->Get_VU2LF(192)       
#define CCONTRALTO2RGT_CHIAVINA  Scr->Get_VU2RG(192)       
#define DELTAXCCONTRALTO Scr->Get_VU2DX(66)       
#define DELTAYCCONTRALTO Scr->Get_VU2DY(66)       
#define DELTAXCCONTRALTO_CHIAVINA Scr->Get_VU2DX(192)       
#define DELTAYCCONTRALTO_CHIAVINA Scr->Get_VU2DY(192)       

#define CMEZZOSOPRANO2UP   Scr->Get_VU2UP(66)       
#define CMEZZOSOPRANO2DWN  Scr->Get_VU2DWN(66)      
#define CMEZZOSOPRANO2LFT  Scr->Get_VU2LF(66)       
#define CMEZZOSOPRANO2RGT  Scr->Get_VU2RG(66)       
#define CMEZZOSOPRANO2UP_CHIAVINA   Scr->Get_VU2UP(192)       
#define CMEZZOSOPRANO2DWN_CHIAVINA  Scr->Get_VU2DWN(192)      
#define CMEZZOSOPRANO2LFT_CHIAVINA  Scr->Get_VU2LF(192)       
#define CMEZZOSOPRANO2RGT_CHIAVINA  Scr->Get_VU2RG(192)       
#define DELTAXCMEZZOSOPRANO Scr->Get_VU2DX(66)       
#define DELTAYCMEZZOSOPRANO Scr->Get_VU2DY(66)       
#define DELTAXCMEZZOSOPRANO_CHIAVINA Scr->Get_VU2DX(192)       
#define DELTAYCMEZZOSOPRANO_CHIAVINA Scr->Get_VU2DY(192)       

#define CSOPRANO2UP   Scr->Get_VU2UP(66)       
#define CSOPRANO2DWN  Scr->Get_VU2DWN(66)      
#define CSOPRANO2LFT  Scr->Get_VU2LF(66)       
#define CSOPRANO2RGT  Scr->Get_VU2RG(66)       
#define CSOPRANO2UP_CHIAVINA   Scr->Get_VU2UP(192)       
#define CSOPRANO2DWN_CHIAVINA  Scr->Get_VU2DWN(192)      
#define CSOPRANO2LFT_CHIAVINA  Scr->Get_VU2LF(192)       
#define CSOPRANO2RGT_CHIAVINA  Scr->Get_VU2RG(192)       
#define DELTAXCSOPRANO Scr->Get_VU2DX(66)       
#define DELTAYCSOPRANO Scr->Get_VU2DY(66)       
#define DELTAXCSOPRANO_CHIAVINA Scr->Get_VU2DX(192)       
#define DELTAYCSOPRANO_CHIAVINA Scr->Get_VU2DY(192)       

#define CVIOLINO2UP   Scr->Get_VU2UP(38)       
#define CVIOLINO2DWN  Scr->Get_VU2DWN(38)      
#define CVIOLINO2LFT  Scr->Get_VU2LF(38)       
#define CVIOLINO2RGT  Scr->Get_VU2RG(38)       
#define CVIOLINO2UP_CHIAVINA   Scr->Get_VU2UP(194)       
#define CVIOLINO2DWN_CHIAVINA  Scr->Get_VU2DWN(194)      
#define CVIOLINO2LFT_CHIAVINA  Scr->Get_VU2LF(194)       
#define CVIOLINO2RGT_CHIAVINA  Scr->Get_VU2RG(194)       
#define DELTAXCVIOLINO Scr->Get_VU2DX(38)       
#define DELTAYCVIOLINO Scr->Get_VU2DY(38)       
#define DELTAXCVIOLINO_CHIAVINA Scr->Get_VU2DX(194)       
#define DELTAYCVIOLINO_CHIAVINA Scr->Get_VU2DY(194)       

#define CVIOLINO82UP   Scr->Get_VU2UP(86)       
#define CVIOLINO82DWN  Scr->Get_VU2DWN(86)      
#define CVIOLINO82LFT  Scr->Get_VU2LF(86)       
#define CVIOLINO82RGT  Scr->Get_VU2RG(86)       
#define CVIOLINO82UP_CHIAVINA   Scr->Get_VU2UP(195)       
#define CVIOLINO82DWN_CHIAVINA  Scr->Get_VU2DWN(195)      
#define CVIOLINO82LFT_CHIAVINA  Scr->Get_VU2LF(195)       
#define CVIOLINO82RGT_CHIAVINA  Scr->Get_VU2RG(195)       
#define DELTAXCVIOLINO8 Scr->Get_VU2DX(86)       
#define DELTAYCVIOLINO8 Scr->Get_VU2DY(86)       
#define DELTAXCVIOLINO8_CHIAVINA Scr->Get_VU2DX(195)       
#define DELTAYCVIOLINO8_CHIAVINA Scr->Get_VU2DY(195)       

#define CVIOLINO8SOPRA2UP   Scr->Get_VU2UP(69)       
#define CVIOLINO8SOPRA2DWN  Scr->Get_VU2DWN(69)      
#define CVIOLINO8SOPRA2LFT  Scr->Get_VU2LF(69)       
#define CVIOLINO8SOPRA2RGT  Scr->Get_VU2RG(69)       
#define CVIOLINO8SOPRA2UP_CHIAVINA   Scr->Get_VU2UP(159)       
#define CVIOLINO8SOPRA2DWN_CHIAVINA  Scr->Get_VU2DWN(159)      
#define CVIOLINO8SOPRA2LFT_CHIAVINA  Scr->Get_VU2LF(159)       
#define CVIOLINO8SOPRA2RGT_CHIAVINA  Scr->Get_VU2RG(159)       
#define DELTAXCVIOLINO8SOPRA Scr->Get_VU2DX(69)       
#define DELTAYCVIOLINO8SOPRA Scr->Get_VU2DY(69)       
#define DELTAXCVIOLINO8SOPRA_CHIAVINA Scr->Get_VU2DX(159)       
#define DELTAYCVIOLINO8SOPRA_CHIAVINA Scr->Get_VU2DY(159)       

#define CTAB2UP   Scr->Get_VU2UP(139)       
#define CTAB2DWN  Scr->Get_VU2DWN(139)      
#define CTAB2LFT  Scr->Get_VU2LF(139)       
#define CTAB2RGT  Scr->Get_VU2RG(139)       
#define CTAB2UP_CHIAVINA   Scr->Get_VU2UP(212)       
#define CTAB2DWN_CHIAVINA  Scr->Get_VU2DWN(212)      
#define CTAB2LFT_CHIAVINA  Scr->Get_VU2LF(212)       
#define CTAB2RGT_CHIAVINA  Scr->Get_VU2RG(212)       
#define DELTAXCTAB Scr->Get_VU2DX(139)       
#define DELTAYCTAB Scr->Get_VU2DY(139)       
#define DELTAXCTAB_CHIAVINA Scr->Get_VU2DX(212)       
#define DELTAYCTAB_CHIAVINA Scr->Get_VU2DY(212)       

#define CPERCUSBOX2UP   Scr->Get_VU2UP(135)       
#define CPERCUSBOX2DWN  Scr->Get_VU2DWN(135)      
#define CPERCUSBOX2LFT  Scr->Get_VU2LF(135)       
#define CPERCUSBOX2RGT  Scr->Get_VU2RG(135)       
#define CPERCUSBOX2UP_CHIAVINA   Scr->Get_VU2UP(34)       
#define CPERCUSBOX2DWN_CHIAVINA  Scr->Get_VU2DWN(34)      
#define CPERCUSBOX2LFT_CHIAVINA  Scr->Get_VU2LF(34)       
#define CPERCUSBOX2RGT_CHIAVINA  Scr->Get_VU2RG(34)       
#define DELTAXCPERCUSBOX Scr->Get_VU2DX(135)       
#define DELTAYCPERCUSBOX Scr->Get_VU2DY(135)       
#define DELTAXCPERCUSBOX_CHIAVINA Scr->Get_VU2DX(34)       
#define DELTAYCPERCUSBOX_CHIAVINA Scr->Get_VU2DY(34)       

#define CPERCUS2LINES2UP   Scr->Get_VU2UP(131)       
#define CPERCUS2LINES2DWN  Scr->Get_VU2DWN(131)      
#define CPERCUS2LINES2LFT  Scr->Get_VU2LF(131)       
#define CPERCUS2LINES2RGT  Scr->Get_VU2RG(131)       
#define CPERCUS2LINES2UP_CHIAVINA   Scr->Get_VU2UP(161)       
#define CPERCUS2LINES2DWN_CHIAVINA  Scr->Get_VU2DWN(161)      
#define CPERCUS2LINES2LFT_CHIAVINA  Scr->Get_VU2LF(161)       
#define CPERCUS2LINES2RGT_CHIAVINA  Scr->Get_VU2RG(161)       
#define DELTAXCPERCUS2LINES Scr->Get_VU2DX(131)       
#define DELTAYCPERCUS2LINES Scr->Get_VU2DY(131)       
#define DELTAXCPERCUS2LINES_CHIAVINA Scr->Get_VU2DX(161)       
#define DELTAYCPERCUS2LINES_CHIAVINA Scr->Get_VU2DY(161)       

#define CVUOTA2UP   Scr->Get_VU2UP(66)       
#define CVUOTA2DWN  Scr->Get_VU2DWN(66)      
#define CVUOTA2LFT  Scr->Get_VU2LF(66)       
#define CVUOTA2RGT  Scr->Get_VU2RG(66)       
#define CVUOTA2UP_CHIAVINA   Scr->Get_VU2UP(192)       
#define CVUOTA2DWN_CHIAVINA  Scr->Get_VU2DWN(192)      
#define CVUOTA2LFT_CHIAVINA  Scr->Get_VU2LF(192)       
#define CVUOTA2RGT_CHIAVINA  Scr->Get_VU2RG(192)       
#define DELTAXCVUOTA Scr->Get_VU2DX(66)       
#define DELTAYCVUOTA Scr->Get_VU2DY(66)       

#define CBASSOOLD2UP   Scr->Get_VU2UP(130)       
#define CBASSOOLD2DWN  Scr->Get_VU2DWN(130)      
#define CBASSOOLD2LFT  Scr->Get_VU2LF(130)       
#define CBASSOOLD2RGT  Scr->Get_VU2RG(130)       
#define CBASSOOLD2UP_CHIAVINA   Scr->Get_VU2UP(160)       
#define CBASSOOLD2DWN_CHIAVINA  Scr->Get_VU2DWN(160)      
#define CBASSOOLD2LFT_CHIAVINA  Scr->Get_VU2LF(160)       
#define CBASSOOLD2RGT_CHIAVINA  Scr->Get_VU2RG(160)       
#define DELTAXCBASSOOLD Scr->Get_VU2DX(130)       
#define DELTAYCBASSOOLD Scr->Get_VU2DY(130)       
#define DELTAXCBASSOOLD_CHIAVINA Scr->Get_VU2DX(160)       
#define DELTAYCBASSOOLD_CHIAVINA Scr->Get_VU2DY(160)       

#define DELTAXCHIAVE Scr->Get_VU2DX(38)            
#define DELTAYCHIAVE Scr->Get_VU2DY(38)       
// prende i valori dalla chiave di violino e si utilizzano per tutte le chiavi


#define CVIOLINOSHIFT   2
#define CVIOLINO8SHIFT   2
#define CVIOLINO8SOPRASHIFT   2
#define CBASSOSHIFT     8
#define CBASSO8SHIFT     8
#define CBARITONOSHIFT CBASSOSHIFT
#define CTENORESHIFT 5
#define CTENORE8SHIFT 5
#define CCONTRALTOSHIFT CTENORESHIFT
#define CMEZZOSOPRANOSHIFT CTENORESHIFT
#define CSOPRANOSHIFT CTENORESHIFT
#define CBASSO8SOPRASHIFT   8
#define CTABSHIFT  8
#define CPERCUSBOXSHIFT  8
#define CPERCUS2LINESSHIFT  8
#define CVUOTASHIFT  8
#define CBASSOOLDSHIFT  8

// spostamento dell'altezza dell'armatura in riferimento al tipo di chiave
// e alla sua posizione (nelle espressioni vengono messe in rilievo le chiavi 
// rappresentate dallo stesso simbolo traslato sul pentagramma). 

#define ALTEZZA_CBASSO 6
#define ALTEZZA_CBASSO8 6
#define ALTEZZA_CBARITONO 4
#define ALTEZZA_CCONTRALTO 4
#define ALTEZZA_CTENORE 6
#define ALTEZZA_CTENORE8 6
#define ALTEZZA_CMEZZOSOPRANO 2
#define ALTEZZA_CSOPRANO 0
#define ALTEZZA_CVIOLINO 2
#define ALTEZZA_CVIOLINO8 2
#define ALTEZZA_CVIOLINO8SOPRA 2
#define ALTEZZA_CBASSO8SOPRA 6
#define ALTEZZA_CTAB 6
#define ALTEZZA_CPERCUSBOX 6
#define ALTEZZA_CPERCUS2LINES 6
#define ALTEZZA_CVUOTA 6
#define ALTEZZA_CBASSOOLD 6

#define ALTEZZA_CBASSO_INA 4
#define ALTEZZA_CBASSO8_INA 4
#define ALTEZZA_CBARITONO_INA 2
#define ALTEZZA_CCONTRALTO_INA 4
#define ALTEZZA_CTENORE_INA 6
#define ALTEZZA_CTENORE8_INA 6
#define ALTEZZA_CMEZZOSOPRANO_INA 2
#define ALTEZZA_CSOPRANO_INA 0
#define ALTEZZA_CVIOLINO_INA 2
#define ALTEZZA_CVIOLINO8_INA 2
#define ALTEZZA_CVIOLINO8SOPRA_INA 2
#define ALTEZZA_CBASSO8SOPRA_INA 6
#define ALTEZZA_CTAB_INA 6
#define ALTEZZA_CPERCUSBOX_INA 6
#define ALTEZZA_CPERCUS2LINES_INA 6
#define ALTEZZA_CVUOTA_INA 6
#define ALTEZZA_CBASSOOLD_INA 6


#define WDT_TEMPO_C 10

#define ARMATURA2UP_CVIOLINO   31
#define ARMATURA2UP_CBASSO   13
#define ARMATURA2UP_CTENORE 22  
#define ARMATURA_DEPTH  40
#define ARMATURA2LFT  5

#define INTESTAZIONE2UP   36
#define INTESTAZIONE2DWN  12
#define INTESTAZIONE2LFT  0


#define CODE_BFINERIT 145-256
#define CODE_BINIZIORIT 236-256
#define CODE_BINIZIOFIN 185-256 

#define CODE_RIPDOPPIABATTUTA 179-256
#define DELTAXRIPDOPPIABATTUTA Scr->Get_VU2DX(179)       
#define DELTAYRIPDOPPIABATTUTA Scr->Get_VU2DY(179)  

#define BARRA2UP 4*VU_PER_ROW
#define WDTBIGLINE 2
#define BDOPPIA2RGT 3
#define BFINALE2RGT 5
#define BINIZIORIT2RGT Scr->Get_VU2RG(236)       
#define BINIZIOFIN2RGT Scr->Get_VU2RG(185)       
#define BFINERIT2RGT Scr->Get_VU2RG(145)       
#define DELTAXBFINERIT Scr->Get_VU2DX(145)       


#define NUM_MAX_LAYER 12 
#define NUM_MAX_INTEST 3 



enum tipoBattuta {
	INIZIO_BRANO,
		FINE_BRANO, 
		INIZIO_PENTAGRAMMA,
		FINE_PENTAGRAMMA,
		GENERICA,
		INIZIO_PAGINA
}; 

enum tipoBarra {
	SINGOLA, 
		DOPPIA,
		FINALE,
		INIZIORIT,
		FINERIT,
		INIZIOFINERIT,
		INVISIBILE,
		TRATTEGGIATA
}; 


enum tipoArmaturaChiave {
	DO_maggiore,
		SOL_maggiore,
		RE_maggiore,
		LA_maggiore,
		MI_maggiore,
		SI_maggiore,
		FAd_maggiore,
		DOd_maggiore,
		FA_maggiore,
		SIb_maggiore,
		MIb_maggiore,
		LAb_maggiore,
		REb_maggiore,
		SOLb_maggiore,
		DOb_maggiore,
		LA_minore,
		MI_minore,
		SI_minore,
		FAd_minore,
		DOd_minore,
		SOLd_minore,
		REd_minore,
		LAd_minore,
		RE_minore,
		SOL_minore,
		DO_minore,
		FA_minore,
		SIb_minore,
		MIb_minore,
		LAb_minore
};


#endif //DEF_SM_HPP
