/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: giustif.hpp,v 1.1 2005/07/25 10:51:08 bellinpo Exp $ */


#ifndef GIUSTIF_HPP
#define GIUSTIF_HPP

#include <stdlib.h>
#include "fig/figura.hpp"

#define DIST_MIN 7

class Battuta;

// last = 0 sempre =1 solo se e' l'ultima figura del layer

struct Gelemento  {
public:
    double beat;
    Figura * fig;
    UL space;
    double durata;
    double fraz;
    Battuta *measure; 
	int layer;
	int end;
	int woutduration;
};


//////////////////
class Giustificazione  {
protected:
	Gelemento **Sims;
	Battuta **Bats;
	int ncolonne;
	int nrighe;
	int nmaxcolonne;  // numero massimo di colonne
	float den,num;
	
public:
    // costruttore
    Giustificazione() {Sims=NULL; Bats=NULL; nmaxcolonne=ncolonne=nrighe=0;};  
    // distruttore
    ~Giustificazione();   // ...cancella la tabella (array bidimensionale di
	//    strutture)
    // alloca la memoria per la tabella e inizializza 
    void CleanTable(void);
    // p[ulisci la sims dagli spazi gia' settati
    // per velocizzare
	
	
	int VerifAcc();
	
	
	void Costruisci(int nr, int nc);
    // inserisci le figure di una nuova battuta nelle ultime due colonne
    // della tabella in modo sequenziale
    void Inserimento(Battuta*);
    // sincronizza la struttura inserendo NoOperation nei beatlines
    // per i quali la voce non ha figure
    void Sincronizza();
    // metodo che stampa su file la struttura: per il debug
    void dump();  
    void dumpclean();  
	
	// metodo che setta i campi space della battuta per una giustificazione
    // logaritmica
    void GiustificaLog(double kGiust);
    // metodo che scorre la struttura e setta il parametro di giustificazione
    // per ogni figura della battuta
    void SetUpSpG(bool clearSpUt);
    void SetUpSpOr(bool clearSpUt);
    void GiustificaLin(double kGiust);  
    // Line Breaking
	void SetUpSpDLine();
    void SetUpSpOLine();
	
};
#endif
