/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#ifndef LAYER_HPP
#define LAYER_HPP


extern int DebugNormalMilla;
extern int DebugNormalMillaPos;

#include "wx/wx.h"
extern wxString msgdebug;

#include "drw/drawobje.hpp"
#include "bat/listafig.hpp"

#include "spa/def_spa.hpp"
#include "spa/pentagra.hpp" 



class Layer:public ListaFigure
{
private:
	
	int numeroFig;
	
	Bool isSelected;

	bool Opaque;
	Colore CurColor;

public:
	
	Layer();
	// Costruttore
	
	~Layer();
    // Distruttore
    
    NumCode Note2GruppoNote(Battuta* pbat,short current_layer, TipoInserimento tpIns, NumCode figCode1, NumCode figCode2);
	
	Bool GruppoNote2Note(GruppoNote* gruppo, Battuta *pbat,short current_layer);
	// Scioglie il gruppo note reinserendo le note o accordi singoli nella lista. 
	
	NumCode InsNota(Battuta *pbat,int Altezza, Bool SegnoAltezza, ClassID figID, short current_layer,short current_staff,
		      TipoInserimento GamboUp, Bool inAccordo, NumCode figCode,
			  Bool InsInTesta, NoteHead_ID ht, NumCode thisCode =0);
	
	Bool InsInAccordo(Battuta *pbat,Nota *pNota, Figura *pFig,TipoInserimento GamboUp, short current_layer,short current_staff);
	
	NumCode InsPausa(Battuta *pbat,int Altezza, Bool SegnoAltezza, ClassID figID, short current_layer,short current_staff, 
		TipoInserimento AltVariabile, Bool inAccordo, NumCode figCode,
		Bool InsInTesta, NumCode thisCode =0);
	
    NumCode InsSpazio(Battuta *pbat,short current_layer, NumCode figCode, Bool InsInTesta, short CodeCommand, 
		short current_staff,int positionrelat, NumCode thisCode =0);
	
	NumCode InsRipetizione(Battuta *pbat,ClassID figID, NumCode figCode, Bool InsInTesta, short current_layer,short current_staff);
	
	void EliminaGruppi(Battuta *pbat,short current_layer);
	
	void SetNumeroFig(unsigned long int numFig);
	
	unsigned long int GetNumeroFig();
	
	unsigned long int Calc_Fig_Layer();
	
	Bool GetChiaveLayer(unsigned long pos);
	
	void SetupSimboli(Bool beforeLegature,Battuta *pbat, short current_layer);
	
	void SetupGambi(Battuta *pbat, short current_layer);
	
	void SetPosLayer(Pentagramma *pentagr,Battuta *pBat, int xFigPos, short current_layer);
	
	void Draw();
	void DrawContour();

	void BeamingAuto(Battuta *pbat,short current_staff,short current_layer);
	
	float GetTotalDuration(float num, float den);

	const float GetAltezzaMedia();

	//*BIAN-VERR*
	Figura* GetFigura(NumCode figCode);
	//*BIAN-VERR*

	void Select();
	// seleziona l'oggetto impostando il colore di selezione e ridisegnando
	// l'oggetto.
	void Deselect();
	// deseleziona l'oggetto impostando il colore normale e ridisegnando
	// l'oggetto.

	void SetColor(const Colore & color);
	void UnsetColor();

	const Colore & GetColor();
	bool isOpaque();

	virtual void Raise(int delta_altezza);
};

#endif // LAYER_HPP
