/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: tempo.hpp,v 1.1 2005/07/25 10:51:10 bellinpo Exp $ */


#ifndef TEMPO_HPP
#define TEMPO_HPP

#include "drw/drawobje.hpp"
#include "drw/gscreen.hpp"
#include "drw/numtempo.hpp"

#include "wx/wx.h"
#include "wx/resource.h"


enum TimeSignatureStatus
{
	TimeSignature_NORMAL,
		TimeSignature_HIDDEN,
		TimeSignature_ALWAYSVISIBLE
};

class Tempo: public DrawObject
{
	
protected:
	NumTempo Numeratore, Denominatore;
	VUnit TEMPO2Rgt;
	Bool LetteraC;
    // TRUE se il tempo viene espresso tramite lettera.
public:
	Tempo();
	
	void SetVU2Rgt(VUnit vu);  
	virtual void SetColor(int col);
	VUnit GetVU2Up();
	VUnit GetVU2Dwn();
	VUnit GetVU2Lft();
	VUnit GetVU2Rgt();
	
	int GetNumeratore();  
	int GetDenominatore();  
	
	void SetVU();
	
	void SetPos(DrawObject *d,const Point& p);
	
	Bool SetTempo(char tmp[]);
    // Imposta il tipo di tempo.
	Bool GetTempo(char tmp[]);
	// Ritorna il tempo versione stringa
	void Draw();
    // Disegna il tempo della battuta.                           
	int operator!=(Tempo tempo);
    // controlla se due tempi sono diversi
	void operator=(Tempo);
    // assegna un tempo ad un altro tempo
	
	Bool HasSameDesc(char tmp[]);
	Bool HasSameDesc(Tempo*);
    // TRUE se l'oggetto ha la stessa descrizione di quello fornito.
	int Validator(wxString text,bool inner);
	
	int SaveXML(FILE *fp,TimeSignatureStatus status);
};

#endif //TEMPO_HPP
