/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */
// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//

#include "binistreaminputstream.hpp"

/////////////////////////////// PUBLIC /////////////////////////////////////

XERCES_CPP_NAMESPACE_USE

//============================= LIFECYCLE ==================================

BinIStreamInputStream::BinIStreamInputStream(wxInputStream& source, unsigned int length):
    BinInputStream(),mSource(source)
{
	_length = length;
	_start = mSource.TellI();
}// BinIStreamInputStream

BinIStreamInputStream::~BinIStreamInputStream()
{
}// ~BinIStreamInputStream

//============================= OPERATORS ==================================
//============================= OPERATIONS =================================
unsigned int BinIStreamInputStream::curPos() const
{
    return (mSource.TellI() - _start);
}

unsigned int BinIStreamInputStream::readBytes(XMLByte* const toFill,
                                              const unsigned int maxToRead)
{
	unsigned int remainToRead = _length - curPos();
	unsigned int toRead = (remainToRead < maxToRead ? remainToRead : maxToRead);
    return mSource.Read((char*)toFill,toRead).LastRead();
}

//============================= ACCESS      ================================
//============================= INQUIRY    =================================
/////////////////////////////// PROTECTED  /////////////////////////////////

/////////////////////////////// PRIVATE    /////////////////////////////////
