/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/**
  * Class BinIStreamInputStream ...
  * 
  * #include "binistreaminputstream.hpp"
  * 
  */ 
#ifndef BINISTREAMINPUTSTREAM_HPP
#define BINISTREAMINPUTSTREAM_HPP

// SYSTEM INCLUDES
//

#include <xercesc/util/BinInputStream.hpp>
//#include <istream>
#include <wx/stream.h>

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//

// FORWARD REFERENCES
//

class BinIStreamInputStream: public XERCES_CPP_NAMESPACE::BinInputStream
{
public:
    // LIFECYCLE

    /**
     * Default constructor.
     */
    BinIStreamInputStream(wxInputStream& source, unsigned int length);

    /**
     * Destructor.
     */
    ~BinIStreamInputStream(void);

    // OPERATORS
    // OPERATIONS
    unsigned int curPos() const;
    unsigned int readBytes(XMLByte* const toFill,
        const unsigned int maxToRead);
    // ACCESS
    // INQUIRY
protected:
private:
    wxInputStream& mSource;

	unsigned int _start;
	unsigned int _length;
};

// INLINE METHODS
//

// EXTERNAL REFERENCES
//

#endif //BINISTREAMINPUTSTREAM_H