/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#ifndef DEF_BIT_HPP
#define DEF_BIT_HPP

// DATA TYPES

enum Coding_Type
{
	RESF,				//reserved
		XMLF,			//XML
		GZIP,			//GZIP
		BIMF			//BIM
};

enum NotationFormat_Type
{
	RESN,				//reserved
		CWMN,			//WESTERN MUSIC
		BRLL,			//BRAILLE
		SPKN,			//SPOKEN
		OTHR			//OTHER
};

enum Chunk_Type 
{
	MAIN,				//MAIN PART
		PART,			//SINGLE PART
		SYNC,			//PERFORMANCE
		SMFL,			//SYMBOLIC FORMAT RULES
		LYRC,			//LYRIC PART
		FONT,			//FONT SPECS
		RES1,			//reserved
		RES2			//reserved
};

// BITSTREAM EXCLUSIVE

struct HEADER_COMMON
{
	unsigned int		audioObjectType;
	unsigned int		audioObjectTypeExt;
	unsigned int		samplingFrequencyIndex;
	unsigned int		channelConfiguration;
	unsigned int		version;				// unsigned int(4)
	unsigned int		pictureWidth;			// unsigned int(12) rendering window X size
	unsigned int		pictureHeight;			// unsigned int(12) rendering window Y size	
	unsigned int		isScoreMultiwindow;		// bit(1) 0: one window only - 1: multiple windows	
	unsigned int		numberOfParts;				// unsigned int(8) parts of the main score
	unsigned int		notationFormat;			// unsigned int(3) CWMN or other sets
};
	//vluimsbf8 MIDIStream_length;				// optional data (first byte in HEADER_COMMON)
	//byte(urlMIDIStream_length) urlMIDIStream;

struct HEADER_DECODER
{
	unsigned int		codingType;				// bit(2) coding of the XML chunks
};
	//vluimsbf8 decoder_config_length;				// optional data (first byte in HEADER_DECODER)
	//decoder_config_length			bit(decoder_config_length);

struct CHUNK_HASNEXT
{
	unsigned int		more_data;
};	

struct CHUNK_COMMON
{
	unsigned int		chunkType;
	unsigned int		reserved;
	unsigned int		Chunk_length_firstByte : 8;
};	
	//vluimsbf8 Chunk_length;				// optional data (first byte in CHUNK_COMMON)


#endif