#ifndef ODMAP_HPP
#define ODMAP_HPP

#include <vector>
#include <map>

class ESData
{
public:
	ESData(int id, int oti, int streamType, int bufferSizeDB, unsigned int maxBitRate, unsigned int avgBitRate, char *decInfo=NULL, int size=0)
	{
		_ESID=id;
		_OTI = oti;
		_streamType = streamType;
		_bufferSizeDB = bufferSizeDB;
		_maxBitRate = maxBitRate;
		_avgBitRate = avgBitRate;
		_decoderInfo = decInfo;
		_decoderInfoSize = size;
	}

	int getESID() { return _ESID; }
	int getOTI() { return _OTI; }
	int getStreamType() { return _streamType; }
	unsigned int getBufferSizeDB() { return _bufferSizeDB; } 
	unsigned int getMaxBitRate() { return _maxBitRate; } 
	unsigned int getAvgBitRate() { return _avgBitRate; } 

	char* geDecoderInfo() { return _decoderInfo; }
	int getDecoderInfoSize() { return _decoderInfoSize; }

private:
	int _ESID;
	char* _decoderInfo;
	int _decoderInfoSize;
	int _OTI;
	int _streamType;
	unsigned int _bufferSizeDB;
	unsigned int _avgBitRate;
	unsigned int _maxBitRate;
};

class ODMap
{
public:
	ODMap() {}
	~ODMap() {}
	void addOD(int oid, ESData* esData)
	{
		_OIDs.push_back(oid);
		_ESData[oid]=esData;
	}

	const std::vector<int>& getOIDs() { return _OIDs; }
	ESData* getESData(int oid) { return _ESData[oid]; }

private:
	std::vector<int>	  _OIDs;
	std::map<int,ESData*> _ESData;
};

#endif