/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: parent.cpp,v 1.1 2005/07/25 11:06:30 bellinpo Exp $ */


#include "bra/parent.hpp"

Parentesi::Parentesi()
{
	PSpaStart = PSpaEnd = NULL;  
	
}

Parentesi::~Parentesi()
{
	
}

void Parentesi::SetPSpaStart(Spartito *pS)
{ 
	PSpaStart = pS; 
}

void Parentesi::SetPSpaEnd(Spartito *pS)
{ 
	PSpaEnd = pS; 
}

Spartito *Parentesi::GetPSpaStart()
{ 
	return PSpaStart; 
}

Spartito *Parentesi::GetPSpaEnd()
{ 
	return PSpaEnd; 
}


void Parentesi::SetNumericCode(NumCode nc)
{ 
	NumericCode=nc; 
}

NumCode Parentesi::GetNumericCode()
{ 
	return NumericCode; 
}

void Parentesi::Draw()
{
	
}

void Parentesi::SetLivello(int liv)
{
	livello = liv;
	
}  

int Parentesi::GetLivello()
{
	return livello;
	
}  


Bool Parentesi::Hit(const Point& p, SelObj selObject,DrawObject*& drwObj,
					SymPath& symPath)
{
	
	Bool found=FALSE;
	
	if (DrawObject::Hit(p,selObject,drwObj,symPath))
		
	{
		drwObj=this;
		symPath.Array[BATTUTA_PATH_LEVEL]=GetNumericCode();
		symPath.Array[FIGURA1_PATH_LEVEL]=GetPSpaStart()->GetNumericCode();
		symPath.Array[FIGURA2_PATH_LEVEL]=GetPSpaEnd()->GetNumericCode();
		return TRUE;
	}
	else
		return FALSE;
}

Bool Parentesi::SymbolicHit(SymPath& symPath, SelObj sobj, DrawObject *&  
                            objsel)
{
	objsel=NULL;
	if((symPath.Array[BATTUTA_PATH_LEVEL]==GetNumericCode())&&
		(symPath.Array[FIGURA1_PATH_LEVEL]==GetPSpaStart()->GetNumericCode())&&
		(symPath.Array[FIGURA2_PATH_LEVEL]==GetPSpaEnd()->GetNumericCode()))
	{
		if(sobj==ANY_SEL)
			objsel=this;
		return TRUE;
	}
	return FALSE;
}


void Parentesi::Init(VUnit h)
{
	
}
