/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: parent.hpp,v 1.1 2005/07/25 11:06:30 bellinpo Exp $ */


#ifndef PARENTESI_HPP
#define PARENTESI_HPP

#include "lioo.hpp"
#include "drw/drawobje.hpp"
#include "spa/spartito.hpp"


class Parentesi: public DrawObject
{
protected:
    Spartito *PSpaStart, *PSpaEnd;
    
    NumCode NumericCode;
	// codice numerico della parentesi
	
    int livello;
	
	
public:
    Parentesi();
    ~Parentesi();
	
    void SetNumericCode(NumCode nc);
    NumCode GetNumericCode();
    
    void SetPSpaStart(Spartito *pS);
    void SetPSpaEnd(Spartito *pS);
    Spartito *GetPSpaStart();
    Spartito *GetPSpaEnd();
	
	
    virtual void Init(VUnit h);
	
    virtual void Draw();
	
    void SetLivello(int liv);
    int GetLivello();
    Bool Hit(const Point& p, SelObj selObject,DrawObject*& drwObj,
		SymPath& symPath);
    Bool SymbolicHit(SymPath& symPath, SelObj sobj, DrawObject *&  
		objsel);		    
	
	virtual int SaveXML(FILE *fp)=0;
};

#endif //PARENTESI_HPP
