/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: pargraff.hpp,v 1.1 2005/07/25 11:06:31 bellinpo Exp $ */


#ifndef PARGRAFFA_HPP
#define PARGRAFFA_HPP

#include "bra/parent.hpp"


class ParGraffa: public Parentesi
{ 
protected:
    VUnit Width, Height;
    unsigned char *BitMap;
	
public:
    ParGraffa();
    ParGraffa(VUnit h);
    ~ParGraffa();
	
    void Init(VUnit h);
	
    VUnit GetVU2Up();
    VUnit GetVU2Dwn();
    VUnit GetVU2Rgt();
    VUnit GetVU2Lft();
	
    void Draw();
	
	
	void Draw4single(int d4s_x, int d4s_y);
	void Print4single(int d4s_x, int d4s_y);
	
	virtual int SaveXML(FILE *fp);
};

#endif //PARGRAFFA_HPP
