/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: parquad.cpp,v 1.1 2005/07/25 11:06:31 bellinpo Exp $ */


#include "bra/parquad.hpp"


ParQuadra::ParQuadra() 
{
	ID=CL_PARQUADRA;
	Width = WIDTH_PARENTESI;
	Height = 0;
};

ParQuadra::~ParQuadra()
{
	
}

VUnit ParQuadra::GetVU2Up()
{ return Height; };

VUnit ParQuadra::GetVU2Dwn()
{ return 0; };

VUnit ParQuadra::GetVU2Rgt()
{ return Width; };

VUnit ParQuadra::GetVU2Lft()
{ return 0; };

void ParQuadra::Init(VUnit h)
{
	Height = h;
}


void ParQuadra::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	int x,y;
	int liv;
	
	x = GetAbsPos().x;
	y = GetAbsPos().y;
	liv = GetLivello();
	
	Scr->Line(Point(x,y), Point(x,y + Height),SOLID_LINE);
	Scr->Line(Point(x + 1,y), Point(x + 1,y + Height),SOLID_LINE);
	
	Scr->Line(Point(x, y + Height), Point(x + 10, y + Height + 4),SOLID_LINE);
	Scr->Line(Point(x + 1, y + Height), Point(x + 10, y + Height + 4),SOLID_LINE);
	
	Scr->Line(Point(x, y), Point(x + 10, y - 4),SOLID_LINE);
	Scr->Line(Point(x + 1, y), Point(x + 10, y - 4),SOLID_LINE);

	Scr->SetColor(oldcol);
}
