/* ISO_HEADER_START */

/*********************************************************************

  This software module was originally developed by
  
	Pierfrancesco Bellini (DISIT-DSI, University of Florence)
	Paolo Nesi (DISIT-DSI, University of Florence)
	Maurizio Campanai (EXITECH)
	
	  in the course of development of the MPEG-4 standard.
	  This software module is an implementation of a part of one or more
	  MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
	  of the MPEG-4 standard free license to this software module or
	  modifications thereof for use in hardware or software products
	  claiming conformance to MPEG-4. Those intending to use this software
	  module in hardware or software products are advised that its use may
	  infringe existing patents.  The original developer of this software
	  module and his/her company, the subsequent editors and their
	  companies, and ISO/IEC have no liability for use of this software
	  module or modifications thereof in an implementation.  Copyright is
	  not released for non MPEG-4 conforming products. The DISIT-DSI and 
	  EXITECH retains full right to use the code for its own purpose,
	  assign or donate the code to a third party and to inhibit third
	  parties from using the code for non MPEG-4 conforming products.  This
	  copyright notice must be included in all copies or derivative
	  works. Copyright (c) 2005.
	  
***********************************************************************/

/* ISO_HEADER_END */

#include "colore.hpp"

//#include <wx/colordlg.h>


//wxColourData* Colore::_palette = NULL;
//int Colore::_instances = 0;

Colore::Colore(const wxString& str)
{
	*this = str2wxC(str);
}

Colore::Colore(const unsigned char red, const unsigned char green, const unsigned char blue) 
:wxColour(red,green,blue)
{
}

Colore::Colore(const wxColour& colour):wxColour(colour)
{}

Colore::Colore(const ColorIcon& colour)
{	
	*this = Cin2wxC(colour);
	
}
/*
Colore::~Colore()
{
	_instances--;
	if (_instances == 0)
		delete _palette;
}

void Colore::Set(const unsigned char red, 
				 const unsigned char green, 
				 const unsigned char blue)
{
	wxColour::Set(red,green,blue);
	//	sprintf( _code, "%X%X%X", red, green, blue);
}

const Colore& Colore::Choose(wxWindow* parent)
{
	_palette->SetColour(*this);
	
	wxColourDialog dialog(parent, _palette);
	if (dialog.ShowModal() == wxID_OK)
	{
		wxColourData retData = dialog.GetColourData();
		wxColour col = retData.GetColour();
		Set(col.Red(), col.Green(), col.Blue());
	}
	
	return *this;
}
*/
const wxString Colore::GetCode() const
{
	return wxString::Format("%X%X%X%X%X%X", 
							Red()/16, Red()%16, 
							Green()/16, Green()%16, 
							Blue()/16, Blue()%16);
}
/*
void Colore::InitPalette()
{
//	_palette->SetChooseFull(TRUE);
	_palette = new wxColourData();
	// DEFAULT COLORS
	_palette->SetCustomColour(BIANCO, *wxWHITE);
	_palette->SetCustomColour(NERO, *wxBLACK);
	_palette->SetCustomColour(GRIGIO, *wxLIGHT_GREY);
	_palette->SetCustomColour(GRIGIOS, wxColour(96,96,96));
	_palette->SetCustomColour(VERDE, wxColour(0,206,103));
	_palette->SetCustomColour(VERDEC, *wxGREEN);
	_palette->SetCustomColour(VERDEA,wxColour(0,187,187));
	_palette->SetCustomColour(BLU,wxColour(0,0,255));
	_palette->SetCustomColour(CELESTE,*wxCYAN);
	_palette->SetCustomColour(VIOLA,wxColour(128,0,255));
	_palette->SetCustomColour(MAGENTA,wxColour(255,0,255));
	_palette->SetCustomColour(ROSSO,*wxRED);
	_palette->SetCustomColour(ARANCIO,wxColour(255,128,0));
	_palette->SetCustomColour(MARRONE,wxColour(128,64,0));
	_palette->SetCustomColour(GIALLO,wxColour(255,255,0));
	_palette->SetCustomColour(GIALLOC,wxColour(255,255,174));
	//
//	return data;
}*/
/*
const unsigned char Colore::Red()
{
return wxColour::Red();
}

  const unsigned char Colore::Green(): wxColour(red,green,blue)
  {
  return wxColour::Green();
  }
  
	const unsigned char Colore::Blue(): wxColour(red,green,blue)
	{
	return wxColour::Blue();
	}
*/

Colore& Colore::operator = (const wxString& str)
{
	//Colore(str);
	dynamic_cast<wxColour&>(*this) = str2wxC(str);
	return *this;
}

Colore& Colore::operator = (const ColorIcon& cin)
{
	//Colore(cin);
	dynamic_cast<wxColour&>(*this) = Cin2wxC(cin);
	return *this;
}

//PRIVATES
const wxColour Colore::str2wxC(const wxString& str)
{
	wxString code = str.Upper();
	if (code.StartsWith("#"))
		code = code.AfterFirst('#');

	unsigned char r=0,g=0,b=0;
	if (code.Length() == 6 )
	{
		unsigned char val=0;
		for (unsigned int i=0; i<6; i++)
		{
			switch (code[i])
			{
			case '0':
				val = 0;
				break;
			case '1':
				val = 1;
				break;
			case '2':
				val = 2;
				break;
			case '3':
				val = 3;
				break;
			case '4':
				val = 4;
				break;
			case '5':
				val = 5;
				break;
			case '6':
				val = 6;
				break;
			case '7':
				val = 7;
				break;
			case '8':
				val = 8;
				break;
			case '9':
				val = 9;
				break;
			case 'A':
				val = 10;
				break;
			case 'B':
				val = 11;
				break;
			case 'C':
				val = 12;
				break;
			case 'D':
				val = 13;
				break;
			case 'E':
				val = 14;
				break;
			case 'F':
				val = 15;
				break;
			}
		if (i%2==0)
			val *= 16;

		if (i == 0 || i== 1)
			r += val;
		if (i == 2 || i== 3)
			g += val;
		if (i == 4 || i== 5)
			b += val;
		}
	}
	else
	{
		unsigned long val;
		if (str.ToULong(&val))
		return Cin2wxC((ColorIcon)val);
	}

	return wxColour(r,g,b);
}

const wxColour Colore::Cin2wxC(const ColorIcon& cin)
{
	wxColour col;
	switch(cin)
	{
	case BIANCO :
		col = wxColour(255,255,255);
		break;
	case NERO :
		col = wxColour(0,0,0);
		break;
	case GRIGIO :
		col = wxColour(192,192,192);
		break;
	case GRIGIOS :
		col = wxColour(96,96,96);
		break;
	case VERDE :
		col = wxColour(0,206,103); 
		break;
	case VERDEC :
		col = wxColour(0,255,0); 
		break;
	case VERDEA :
		col = wxColour(0,187,187); 
		break;
	case BLU :
		col = wxColour(0,0,255); 
		break;
	case CELESTE :
		col = wxColour(0,255,255);
		break;
	case VIOLA :
		col = wxColour(128,0,255); 
		break;
	case MAGENTA :
		col = wxColour(255,0,255); 
		break;
	case ROSSO :
		col = wxColour(255,0,0); 
		break;
	case ARANCIO :
		col = wxColour(255,128,0); 
		break;
	case MARRONE :
		col = wxColour(128,64,0);
		break;
	case GIALLO :
		col = wxColour(255,255,0); 
		break;
	case GIALLOC :
		col = wxColour(255,255,174); 
		break;
	default:
		col = wxColour(0,0,0);
		break;
	}
	return col;
}

