/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#ifndef COLORE_HPP
#define	COLORE_HPP

#include "def_drw.hpp"
#include <wx/colour.h>

#include <wx/string.h>
//#include <wx/cmndata.h>

class Colore : public wxColour
{
public:
	//Costruttore di Default
	Colore(){};
	//Costruttore da stringa esadecimale: RRGGBB
	Colore(const wxString& str);
	//Costruttore da wxColour
	Colore(const wxColour& colour);
	//Costruttore da ColorIcon
	Colore(const ColorIcon& colour);
	//Costruttore da Red Green Blue
	Colore(const unsigned char red, const unsigned char green, const unsigned char blue);

	//Costruttore per assegnamento da stringa esadecimale: RRGGBB
	Colore& operator = (const wxString& str);
	//Costruttore per assegnamento da ColorIcon
	Colore& operator = (const ColorIcon& cin);

	//	~Colore();
	//Impostazione di Red Green Blue
//	void Set(const unsigned char red, 
//			 const unsigned char green, 
//			 const unsigned char blue);
	//Scelta Colore da ColorDialog
	//const Colore& Choose(wxWindow* parent = NULL);
	//Conversione in stringa esadecimale: RRGGBB
	const wxString GetCode() const;

private:
//	wxString			_code;
//	static wxColourData *_palette;
//	static int			_instances;

//	void InitPalette();

	const wxColour str2wxC(const wxString& str);
	const wxColour Cin2wxC(const ColorIcon& cin);
};

#endif	//COLORE_HPP

