/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: gdevice.cpp,v 1.1 2005/07/25 16:30:29 bellinpo Exp $ */


#include "drw/gdevice.hpp"

// Macro per traduzione coordinate.
#define xT(x) (x)
#define yT(y) (GetMaxPixY()  - (y))

GDevice::GDevice()
{  
	// Inizialmente nessun font attivo
	SetFont(-1);
	
	for(int i=0; i<10+6;i++)
		lista_font[i]=NULL;
}


GDevice::~GDevice()
{
}


void GDevice::Clear()
{ 
}


int GDevice::GetMaxPixX()
{
	return 0;
}


int GDevice::GetMaxPixY()
{
	return 0;
}


int GDevice::GetNumColors()
{ 
	return 256;
}

/*
void GDevice::SetColor(int col)
{
}


int GDevice::GetColor()
{ 
	return 0;
}
*/

void GDevice::SetDrwMode(DrwMode d)
{ 
}



void GDevice::PutPixel(const Point &p)
{ 
}

void GDevice::MoveTo(const Point &p)
{ 
	// Si limita a settare la variabile di riferimento.
	currentPos.x = p.x;
	currentPos.y = p.y; 
}


void GDevice::MoveTo(VUnit x, VUnit y)
{
	// Si limita a settare la variabile di riferimento.
	currentPos.x = x;
	currentPos.y = y;
}


Point GDevice::CurrentPos()
{ return currentPos; }


void GDevice::LineTo(const Point &p)
{ 
}


void GDevice::LineTo(VUnit x, VUnit y)
{
}


void GDevice::Line(const Point &p1, const Point &p2)
{
}


void GDevice::BigLine(const Point &p1, const Point &p2, VUnit width)
{
}


void GDevice::Rect(const Rectangle &r, Bool isfilled)
{
}

void GDevice::BigRect(const Rectangle &r, VUnit width)
{
}

void GDevice::ShadowRect(const Rectangle& r, Bool isOn)
{
}


void GDevice::Arc(const Rectangle& r, short Angle1, short Angle2, Bool isfilled)
{
}


void GDevice::Ellipse(const Rectangle& r,Bool isfilled)
{
}


FontID GDevice::SetFont(FontID nfnt)
{ 
	int ofont;
	
	// Se nessuna font e' attiva...
	// nfnt = -1 cosa vuol dire in termini di errori ?
	if(nfnt == -1)
	{
		return -1;
	}
	
	// Se la font scelta e' gia' attiva
	if(activeFont == nfnt)
		return nfnt;
	ofont = activeFont; 
	activeFont = nfnt;
	
	// Ritorna il font attivo precedentemente
	return ofont;
}


FontID GDevice::GetActiveFont()
{
	return activeFont;
}


int GDevice::GetFontAscent()
{ 
	return 0;
}


int GDevice::GetFontHeight()
{ 
	return 0;
}


void GDevice::TextTo(const Point& p)
{ 
	activeInitTextPos.x = p.x;
	activeInitTextPos.y = p.y; 
}


void GDevice::TextTo(VUnit x,VUnit y)
{  
	activeInitTextPos.x = x;
	activeInitTextPos.y = y; 
}


void GDevice::OutText(unsigned char *txt)
{
}                  


int GDevice::GetTextWidth(unsigned char *txt)
{ 
	return 0; 
}

int GDevice::GetTextHeight(unsigned char *txt)
{ 
	return 0;
}

long GDevice::ImageSize(const Rectangle &r)
{
	return ((r.PDwnRgt.x - r.PUpLft.x) * (r.PUpLft.y - r.PDwnRgt.y));
}



void GDevice::PutImage(const Point &p, void *buffer, int w, int h, 
					   DrwMode dMode)
{
}

int GDevice::Get_VU2UP(int carcode)
{
	return 0;
}

int GDevice::Get_VU2DWN(int carcode)
{
	return 0;
}

int GDevice::Get_VU2RG(int carcode)
{
	return 0;
}

int GDevice::Get_VU2LF(int carcode)
{
	return 0;
}

int GDevice::Get_VU2DX(int carcode)
{
	return 0;
}

int GDevice::Get_VU2DY(int carcode)
{
	return 0;
}
