/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: memenu.hpp,v 1.1 2005/07/25 16:30:31 bellinpo Exp $ */


#ifndef MEMENU_HPP
#define MEMENU_HPP

#include <wx/wx.h>
#include "gui/lioomenu.hpp"



class MEMenuBar : public wxMenuBar
{
protected:
	wxMenu *fileMenu;
	wxMenu *editMenu;
	wxMenu *viewMenu;
	wxMenu *lyricMenu;
	wxMenu *miscMenu;
	wxMenu *symbolsMenu;
	wxMenu *formatMenu;
	wxMenu *executionMenu;
	wxMenu *helpMenu;
	wxMenu *analysisMenu;
	
public:
	MEMenuBar();
	~MEMenuBar();
	
	wxMenu* GetfileMenu();
	wxMenu* GeteditMenu();
	wxMenu* GetviewMenu();
	wxMenu* GetlyricMenu();
	wxMenu* GetmiscMenu();
	wxMenu* GetsymbolsMenu();
	wxMenu* GetformatMenu();
	wxMenu* GetexecutionMenu();
	wxMenu* GethelpMenu();
	wxMenu* GetAnalysisMenu();
	void SetAnalysisMenu(wxMenu*);
	
	void CreateMenu(void);
	//Crea i menu contenuti nella barra dei menu
	
	void InitMenu();
	
	
	DECLARE_EVENT_TABLE()
};


//identificativi degli item dei menu
enum MenuItem
{
	FILE_IMPORTMIDI_ID,
		FILE_IMPORTOMR_ID,
		FILE_IMPORTFINALE_ID,
		FILE_IMPORTSCORE_ID,
		FILE_IMPORTMOODS_ID,
		FILE_EXPORTWDF_ID,
		FILE_EXPORTIWF_ID,
		FILE_EXPORTMOODS_ID,
		FILE_EXPORTMIDI_ID,
		FILE_EXPORTWNF_ID,
		FILE_CHANGESLIST_ID,
		FILE_LOADCHANGES_ID,
		FILE_SAVECHANGES_ID,
		FILE_SAVEASCHANGES_ID,
		FILE_PRINT_ID,
		FILE_PRINTPARAMETERS_ID,
		FILE_PRINTBRAILLE_ID,
		FILE_PRINTBRAILLEPARAMETERS_ID,
		FILE_CLOSE_ID,
		
		EDIT_FIRSTPAGEHEADER_ID,
		EDIT_IMPORTAPART_ID,
		EDIT_NEWPART_ID,
		EDIT_CUTAPART_ID,
		EDIT_COPYAPART_ID,	
		EDIT_PASTEAPART_ID,
		EDIT_SPLITTINGPART_ID,
		EDIT_MERGINGPARTS_ID,
		EDIT_JOININGPARTS_ID,
		EDIT_DISJOINPARTS_ID,
		EDIT_MOVEPARTS_ID,
		EDIT_MOVEALAYER_ID,
		EDIT_TRANSPOSITION_ID,
		
		EDIT_NEWMEASUREBEFORE_ID,
		EDIT_NEWMEASUREAFTER_ID,
		EDIT_NEWSMEASUREBEFORE_ID,
		EDIT_NEWSMEASUREAFTER_ID,
		EDIT_CUTAMEASURE_ID,
		EDIT_CUTSMEASURE_ID,
		EDIT_PASTEAMEASURE_ID,
		EDIT_PASTESMEASURE_ID,
		EDIT_COPYAMEASURE_ID,
		EDIT_COPYSMEASURE_ID,
		EDIT_CUTPAGEBOX_ID,
		EDIT_COPYPAGEBOX_ID,	
		EDIT_PASTEPAGEBOX_ID,
		
		VIEW_COMPUTERVIEW_ID,
		VIEW_PRINTVIEW_ID,
		VIEW_COMPUTERVIEWPARAMETERS_ID,
		VIEW_PRINTPARAMETERS_ID,
		VIEW_HIDEAPART_ID,
		VIEW_SHOWALLPARTS_ID,
		VIEW_VIEWLAYER_ID,
		VIEW_SEEBARLINES_ID,
		VIEW_FIT2WINDOW_ID,
		
		LYRIC_ADDLYRICTOAPART_ID,	
		LYRIC_EDITLYRIC_ID,
		LYRIC_REMOVELYRIC_ID,
		LYRIC_SELECTLYRIC_ID,
		
		MISC_OPENALL_ID,
		MISC_CLOSEALL_ID,
		
		MISC_JUMPTOSYMBOLIC_ID,
		MISC_JUMPTOIMAGE_ID,
		MISC_EDITIMAGES_ID,
		MISC_IMPORTMAINSCOREIMAGE_ID,
		MISC_IMPORTIMAGESCOREPARTS_ID,
		MISC_SEELINKS_ID,
		MISC_EDITLINK_ID,
		
		SYMB_TIMESIGNATURE_ID,
		SYMB_KEYSIGNATURE_ID,
		SYMB_DYNAMICS_ID,
		SYMB_ANNOTATIONS_ID,
		SYMB_GENERICTEXT_ID,
		SYMB_INSERTTEXT_ID,	
		SYMB_INSERTIMAGE_ID,	
		SYMB_FRETBOARDS_ID,
		SYMB_METRONOME_ID,
		SYMB_NOTES_ID,
		SYMB_NOTEHEADS_ID,
		SYMB_SMALLNOTES_ID,
		SYMB_BEAMING_ID,
		SYMB_RESTS_ID,
		SYMB_ACCIDENTALS_ID,
		SYMB_AUGMENTATIONS_ID,
		SYMB_REPEATS_ID,
		SYMB_BARLINES_ID,
		SYMB_CLEFS_ID,		
		SYMB_BRACKETS_ID,
		SYMB_HORIZONTALS_ID,
		SYMB_REFRAINS_ID,
		SYMB_EXPRESSIONS_ID,
		SYMB_GENERICEXP_ID,
		SYMB_ORNAMENTS_ID,	
		SYMB_KOREANORNAMENTS_ID,
		SYMB_FINGERING_ID,
		SYMB_MUTES_ID,
		SYMB_HARMONICS_ID,	
		SYMB_BREATHGLASS_ID,
		SYMB_STRINGS_ID,
		SYMB_PEDALS_ID,
		SYMB_VIOLIN_ID,
		SYMB_PERCUSSIONS_ID,
		
		FORM_CHECK_ID,
		FORM_JUSTIFICATION_ID,
		
		
		FORM_LINEBREAKING_ID,
		
		FORM_BEAMING_ID,
		FORM_UPDOWN_ID,
		FORM_FORMATTINGSETTINGS_ID,
		FORM_EDITMILLA_ID,
		FORM_LOADMILLA_ID,
		FORM_RELOADMILLA_ID,
		FORM_DEBUGNORMAL_ID,
		
		FORM_DEBUGMILLAINSERTION_ID, 
		FORM_DEBUGMILLAPOSITIONING_ID,
		
		
		
		FORM_SEEINVISIBLE_ID,
		FORM_SEEANCHOR_ID,
		
		
		FORM_EDITTABLE_ID,
		FORM_EDITTABLE1_ID,
		FORM_EDITTABLE2_ID,
		FORM_EDITTABLE3_ID,
		FORM_EDITGENERIC1_ID,
		FORM_EDITGENERIC2_ID,
		FORM_EDITGENERIC3_ID,
		FORM_EDITPERCUSSIONS_ID,
		FORM_EDITPEDALS_ID,
		FORM_LOADTABLE_ID,
		FORM_SCOREEXCERPT_ID,
		FORM_AUTOBEAMING_ID,
		
		EXEC_TIME_ID,
		EXEC_LABELS_ID,
		EXEC_MARKERS_ID,
		EXEC_ORCHESTRATION_ID,
		EXEC_SYNCHRONIZATION_ID,
		EXEC_SPOKENMUSIC_ID,
		EXEC_SPOKENMUSICPARAMETERS_ID,
		
		HELP_GUIDE_ID,
		HELP_ABOUT_ID
};


#endif // MEMENU_HPP
