/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: menu.hpp,v 1.1 2005/07/25 16:30:31 bellinpo Exp $ */


#ifndef MENU_HPP
#define MENU_HPP

#include "lioo.hpp"
#include "drw/drawobje.hpp"
#include "drw/scrobjec.hpp"
#include "drw/button.hpp"
#include <wx/string.h>
#include <wx/gdicmn.h>
#include "drw/memenu.hpp"

class Menu : public ScrObject
{
protected:
    Button *menuVect;
    int nItem;
    int lastPress,lastSel;
    VUnit menuHeight,menuWidth;
    Bool active;
    Bool Orizzontal;  //indica l'orientazione del Menu.	
	Bool Close;
	MenuItem menuItemID;  //identificativo del menuitem corrispondente al Menu.
	wxString title;  //titolo del menu.
	
public:
    Menu();
    Menu(wxString menutitle, MenuItem itemID, int nbutton,bool orizzontal = TRUE);
	
    ~Menu();
    
    void Enable();
    void Disable();
    
    void SetOrizzontal(Bool);
    Bool GetOrizzontal();
	
	Bool GetClose();
	void SetClose(Bool);
	
	MenuItem GetmenuItemID() { return menuItemID; };
    wxString GetTitle() { return title; };
	wxPoint GetPosition();
	//restituisce la posizione del menu
	
    void Init(int nit);
	
    void SetTextItem(int n, unsigned char *txt, int fnt, ActionFunction,
		AbilID=ABIL, Bool DrawArr = FALSE, short bc = gray,
		VUnit Width=BUTTON_WIDTH, VUnit Height=BUTTON_HEIGHT);
    void SetImageItem(int n, DrawFunction dfun, ActionFunction afun,
		AbilID=ABIL, Bool DrawArr = FALSE, short bc = gray,
		VUnit Width=BUTTON_WIDTH, VUnit Height=BUTTON_HEIGHT);
	
    void ChangeTextItem(int n, unsigned char *txt);
	void ChangeTextItem(int n, unsigned char *txt, int fnt);
    void ChangeImageItem(int n, DrawFunction);
	
    void CalcolaDimensioni();
	
    Button* GetButton(int n);
	// ritorna il pulsante del Menu con indice n
    int GetButton(Widget w);
	// ritorna il numero di pulsante con ScrWindow uguale a w
	// altrimenti ritorna -1
	
    void CloseMenu();
	//Salva il menu nel workspace e lo elimina
    
    int GetLastSel();
    void ResetLastSel();
	int GetLastPress();
    
    VUnit GetVU2Up();
    VUnit GetVU2Dwn();
    VUnit GetVU2Lft();
    VUnit GetVU2Rgt();
    
    void SetPos(DrawObject*,const Point&);
    void Draw();
	
	void Realize(int x = -1, int y = -1);
	//
    
    EventResult LeftButtonPress(const Point&);
    EventResult LeftButtonRelease(const Point&);
    
    EventResult KeyPressed(int key);
};

#endif // MENU_HPP
