/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: menufrm.cpp,v 1.1 2005/07/25 16:30:31 bellinpo Exp $ */



#include <wx/wx.h>
#include "drw/menu.hpp"
#include "drw/menufrm.hpp"
#include "drw/scorefrm.hpp"
#include "drw/scrlist.hpp"
#include "drw/musicedt.hpp"
#include "frmanage.hpp"

BEGIN_EVENT_TABLE(wxMEMenuFrame, wxMiniFrame)
EVT_CLOSE(wxMEMenuFrame::OnCloseWindow)
END_EVENT_TABLE()

extern wxMusicEditor *MusicEditor;

#ifdef __WXMSW__
wxMEMenuFrame::wxMEMenuFrame(Menu* framemenu, wxWindow *parent,const wxString& tit,const wxPoint& pos, const wxSize& siz) 
:wxMiniFrame(parent,-1, tit,pos,wxSize(siz.GetWidth(),siz.GetHeight()+25),
			 wxSYSTEM_MENU | wxTINY_CAPTION_VERT | wxTINY_CAPTION_HORIZ |wxSTAY_ON_TOP ) 
			 
#elif defined __WXGTK__
			 wxMEMenuFrame::wxMEMenuFrame(Menu* framemenu, wxWindow *parent,const wxString& tit,const wxPoint& pos, const wxSize& siz) 
			 :wxMiniFrame(parent,-1, tit,pos,siz,
			 wxSYSTEM_MENU | wxTINY_CAPTION_HORIZ )
#endif
{
	menucanvas = new wxMEMenuCanvas(this, wxPoint(0,0),siz);
	
	menu = framemenu;
}


wxMEMenuFrame::~wxMEMenuFrame()
{
	delete menucanvas; 
	if(FrameManager::currFrame==this)
		FrameManager::currFrame=NULL;
}

void wxMEMenuFrame::OnCloseWindow(wxCloseEvent& event)
{
	int menuitem = GetMenu()->GetmenuItemID();
	GetMenu()->CloseMenu(); 
	MusicEditor->CheckSymbolsMenu(menuitem,FALSE);
}

