/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: musicedt.hpp,v 1.1 2005/07/25 16:30:32 bellinpo Exp $ */


#ifndef MUSICEDT_HPP
#define MUSICEDT_HPP

#include "drw/menu.hpp"
#include "gui/lioowin.hpp"

class PrintParams;
class Partitura;
class SMRFile;
class wxMEScoreFrame;

class wxMusicEditor 
{
	
private:
	
	PrintParams *ComputerViewParams;
	PrintParams *PrintViewParams;
	int lastViewID;
	
	wxMEScoreFrame *scoreFrames[MAX_VIEW];
	
public:
	wxFrame *mainFrame;
    Partitura *mainScore;
	int nScore;
	SMRFile *smrf;
	
	// verifica se le due var sopra sono state create o no
	// se non sono state create fa un new altrimenti non fa nulla
	
	wxMusicEditor();
	
	Widget MakeMainDrawArea(int w,int h,char* title=NULL);
	Widget MakeMenuDrawArea(Menu* framemenu, int x, int y, int w,int h,char* title=NULL);
	
	void CloseMainDrawArea(Widget);
	int GetNewViewID();
	bool NewViewAvailable();
	wxMEScoreFrame *GetScoreFrame(int pos){return scoreFrames[pos];};
	
    void SetCommand(CmdID cmdId, SelType stype=NO_SEL, SelObj sobj=ANY_SEL, ArgType arg0=0,
		ArgType arg1=0, ArgType arg2=0, ArgType arg3=0, ArgType arg4=0, 
		char *txt=NULL, ArgType arg5=0, ArgType arg6=0, ArgType arg7=0,
				    ArgType arg8=0);
    void ShowTagli();
    void HideTagli();
	void RedrawViews(int modifiedScore,bool forceAll=false);
	void CheckSymbolsMenu(int menuID,int value);
	void Close();
	void CloseAllMenus();
	
	wxMEScoreFrame *GetLastView();
	wxMEScoreFrame *IsOpen(int currentscore,bool imgOrsymb);
	
	wxMEScoreFrame *GetCurrentViewFrame();
	
	void RedrawView(int currview);
	wxString GetWdfObjectPath();

	void New();
	bool Load(wxString);
	bool LoadMP4(wxString);
	void SetMainScore(Partitura* _mainScore);
	
};

extern wxMusicEditor *MusicEditor;

#endif //MUSICEDT_HPP
