/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: numtempo.cpp,v 1.1 2005/07/25 16:30:32 bellinpo Exp $ */


#include "drw/numtempo.hpp"
#include <stdlib.h>
#include <string.h>


NumTempo::NumTempo()
{
	TNumerico::TNumerico();
}


bool NumTempo::SetInternal(unsigned char *s)
{
	//s puo' essere solo una stringa numerica
	// perche' il tempo interno puo' solo essere nella forma a/d
	bool risult = true;
	short i;
	
	// Controllo DA MODIFICARE
	for(i=0; s[i]!='\0' && risult; i++)
	{
		if(strchr("0123456789",s[i])==NULL) 
		{
			return false;
		}
	}
	if (risult) 
	{
		Numero=atoi((char *)s);
		Setup();
	}
	return risult; 
}

unsigned char * NumTempo::GetExternal()
{
	return txt;
}

bool NumTempo::SetExternal(unsigned char *s) 
{
	// verifica se s e' a[+..+z]
	// Il simbolo '+' deve essere stato precedentemente 
	// trasformato in ''
	short i;
	bool risult=true;

	if(txt==NULL) return false;
	// Copia la stringa.
	strncpy((char *)txt, (char *)s, MAXCARATTERINUMERO);
	txt[MAXCARATTERINUMERO]='\0';
	
	// Controllo DA MODIFICARE
	for(i=0; txt[i]!='\0' && risult; i++)
	{
		if(strchr("0123456789",txt[i])==NULL) 
			risult=false;
	}
	
	if(risult)
		Setup();
	else
		txt[0]='\0';
	
	return risult; 
}


void NumTempo::SetPos(DrawObject *d, const Point& p)
{
	if(GetFont() == nMusicFont || GetFont() == nMusicFont2 )
	{
		vu2dwn = VU_PER_ROW;
		vu2up = -VU_PER_ROW;
		Text::SetPos(d,p);  
	}
	else if(GetFont() == nMenuFont)
	{
		vu2dwn = 0;
		vu2up = VU_PER_ROW;
		Text::SetPos(d, p+Point(-2, 6)); 
	}
	else Text::SetPos(d, p);
}
