/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: rectangl.hpp,v 1.1 2005/07/25 16:30:32 bellinpo Exp $ */


#ifndef RECTANGLE_HPP
#define RECTANGLE_HPP

#define Bool int

#include "drw/point.hpp"

class Rectangle
{    
public:
	Point PUpLft;
    // punto in alto a sinistra
	Point PDwnRgt;
    // punto in basso a destra
    
	Rectangle();  
	Rectangle(const Point& p1,const Point& p2);
	Rectangle(const Point& p,VUnit lft,VUnit rgt,VUnit up, VUnit dwn);
	
	void Adjust();
    // controlla la correttezza del rettangolo ed eventualmente lo riposiziona
	
	Bool hasIn(const Point& p);
    // Ritorna TRUE se il punto e' interno al rettangolo
	Bool isIn(const Rectangle& r);
    // Ritorna TRUE se i due rettangoli si sovrappongono.
	
	Rectangle Expand(VUnit x,VUnit y) const;
    // Ritorna il rettangolo esteso in x e y.
	Rectangle Expand(VUnit lft,VUnit rgt,VUnit up,VUnit dwn) const;
    // Ritorna il rettangolo esteso in x e y.
	
	Point Center() const;
    // Ritorna il punto centrale del rettangolo
	VUnit Width() const;
    // Ritorna la larghezza del rettangolo
	VUnit Height() const;
    // Ritorna l'altezza del rettangolo
	
};

#endif //RECTANGLE_HPP
