/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: scorefrm.hpp,v 1.2 2005/07/28 09:52:28 bellinpo Exp $ */


#ifndef SCOREFRM_HPP
#define SCOREFRM_HPP

#include "drw/memenu.hpp"
#include "drw/toolbar.hpp"
#include "drw/scorecan.hpp"

class LyricFrame;
class Nota;


class wxMEScoreFrame : public wxFrame
{
protected:
	MEMenuBar *menubar;  //barra dei menu principali
	ToolBar *toolbar;
	LyricFrame *lyr_frame;
	wxDC *currentMusicDC;
	wxGauge *progressSlide;
	
public:
    wxMEScoreCanvas *scorecanvas;
	
	wxMEScoreFrame(wxWindow* parent,const wxString& tit,const wxPoint& pos, const wxSize& siz);
    ~wxMEScoreFrame();
	
	MEMenuBar* Getmenubar() { return menubar; };
    wxMenu* GetfileMenu() { return menubar->GetfileMenu(); };
    wxMenu* GeteditMenu() { return menubar->GeteditMenu(); };
    wxMenu* GetviewMenu() { return menubar->GetviewMenu(); };
    wxMenu* GetlyricMenu() { return menubar->GetlyricMenu(); };
    wxMenu* GetmiscMenu() { return menubar->GetmiscMenu(); };
    wxMenu* GetsymbolsMenu() { return menubar->GetsymbolsMenu(); };
    wxMenu* GetformatMenu() { return menubar->GetformatMenu(); };
    wxMenu* GetexecutionMenu() { return menubar->GetexecutionMenu(); };
    wxMenu* GethelpMenu() { return menubar->GethelpMenu(); };
	
    ToolBar* Gettoolbar() { return toolbar; };
	
    void OnSize(wxSizeEvent& event);
    //riadatta anche le dimensioni del canvas che altrimenti rimane fisso
	
	void SaveinWorkspace();
	//Salva il frame e i menu aperti nel workspace.
	//Viene chiamato da WDFFrame::OnSaveWorkspace
	
	int GetViewID() { return scorecanvas->GetViewID(); };
	void SetViewID(int id) { scorecanvas->SetViewID(id); };
	LiooWindow* GetMusicWin() { return scorecanvas->GetMusicWin(); };
	void SetMusicWin(LiooWindow* win) { scorecanvas->SetMusicWin(win); };
	int GetNScore() { return scorecanvas->GetNScore(); };
	void SetNScore(int ns) { scorecanvas->SetNScore(ns); };
	bool GetSimbImg() { return scorecanvas->GetSimbImg(); };
	void SetSimbImg(bool si) { scorecanvas->SetSimbImg(si); };
	void OnKeyDown(wxKeyEvent& event);
	void OnKeyUp(wxKeyEvent& event);
	void OnAnalysis(wxCommandEvent& event);
	void OnIdle(wxIdleEvent& event);
	void OnCloseWindow(wxCloseEvent& event);
	
	//metodi corrispondenti agli item del menu File
	void OnImportMIDI(wxCommandEvent& event);
	void OnImportOMR(wxCommandEvent& event);
	void OnImportSCORE(wxCommandEvent& event);
	void OnImportMOODS(wxCommandEvent& event);
	void OnExportWDF(wxCommandEvent& event);
	void OnExportIWF(wxCommandEvent& event);
	void OnExportMOODS(wxCommandEvent& event);
	void OnExportMIDI(wxCommandEvent& event);
	void OnChangesList(wxCommandEvent& event);
	void OnLoadChanges(wxCommandEvent& event);
	void OnSaveChanges(wxCommandEvent& event);
	void OnSaveAsChanges(wxCommandEvent& event);
	void OnClose(wxCommandEvent& event);
	
	//metodi corrispondenti agli item del menu Edit
	void OnComputerView(wxCommandEvent& event);
	void OnPrintView(wxCommandEvent& event);
	void OnFirstPageHeader(wxCommandEvent& event);
	void OnImportAPart(wxCommandEvent& event);
	void OnNewPart(wxCommandEvent& event);
	void OnHideAPart(wxCommandEvent& event);
	void OnShowAllParts(wxCommandEvent& event);
	void OnCutAPart(wxCommandEvent& event);
	void OnCopyAPart(wxCommandEvent& event);	
	void OnPasteAPart(wxCommandEvent& event);
	
	void OnCutPageBox(wxCommandEvent& event);
	void OnCopyPageBox(wxCommandEvent& event);	
	void OnPastePageBox(wxCommandEvent& event);
	
	void OnSplittingPart(wxCommandEvent& event);
	void OnMergingParts(wxCommandEvent& event);
	void OnJoiningParts(wxCommandEvent& event);
	void OnDisjoinParts(wxCommandEvent& event);
	void OnMoveParts(wxCommandEvent& event);
	
	void OnMoveALayer(wxCommandEvent& event);
	void OnMoveALayer12(wxCommandEvent& event);
	void OnMoveALayer23(wxCommandEvent& event);
	void OnMoveALayer34(wxCommandEvent& event);
	void OnMoveALayer45(wxCommandEvent& event);
	void OnMoveALayer56(wxCommandEvent& event);
	void OnMoveALayer67(wxCommandEvent& event);
	void OnMoveALayer78(wxCommandEvent& event);
	void OnMoveALayer89(wxCommandEvent& event);
	void OnMoveALayer910(wxCommandEvent& event);
	void OnMoveALayer1011(wxCommandEvent& event);
	void OnMoveALayer1112(wxCommandEvent& event);
	void OnMoveALayer121(wxCommandEvent& event);
	void OnMoveALayer14(wxCommandEvent& event);
	void OnMoveALayer48(wxCommandEvent& event);
	void OnMoveALayer812(wxCommandEvent& event);
	
	void OnViewLayer(wxCommandEvent& event);
	void OnNewMeasureBefore(wxCommandEvent& event);
	void OnNewMeasureAfter(wxCommandEvent& event);
	void OnNewSMeasureBefore(wxCommandEvent& event);
	void OnNewSMeasureAfter(wxCommandEvent& event);
	void OnCutAMeasure(wxCommandEvent& event);
	void OnCutSMeasure(wxCommandEvent& event);
	void OnPasteAMeasure(wxCommandEvent& event);
	void OnPasteSMeasure(wxCommandEvent& event);
	void OnCopyAMeasure(wxCommandEvent& event);
	void OnCopySMeasure(wxCommandEvent& event);
	void OnImportMainScoreImage(wxCommandEvent& event);
	void OnImportImageScoreParts(wxCommandEvent& event);
	
	//metodi corrispondenti agli item del menu Misc
	static  LyricFrame* OpenLyricEditor(wxMEScoreFrame *linking);
	void OnAddLyricToAPart(wxCommandEvent& event);
	void OnEditLyric(wxCommandEvent& event);
	void OnRemoveLyric(wxCommandEvent& event);
	void OnSelectLyric(wxCommandEvent& event);
	void OnOpenAll(wxCommandEvent& event);
	void OnCloseAll(wxCommandEvent& event);
	void OnTransposition(wxCommandEvent& event);
	void OnEditImages(wxCommandEvent& event);
	void OnSeeLinks(wxCommandEvent& event);
	void OnEditLink(wxCommandEvent& event);
	void OnInsertText(wxCommandEvent& event);	
	void OnInsertImage(wxCommandEvent& event);	
	void OnFit2Window(wxCommandEvent& event);
	
	
	
	//metodi corrispondenti agli item del menu Symbols
	void OnTimeSignature(wxCommandEvent& event);
	void OnKeySignature(wxCommandEvent& event);
	void OnMetronome(wxCommandEvent& event);
	void OnDynamics(wxCommandEvent& event);
	void OnAnnotations(wxCommandEvent& event);
	void OnGenericText(wxCommandEvent& event);
	void OnFretboards(wxCommandEvent& event);
	void OnNotes(wxCommandEvent& event);
	void OnNoteheads(wxCommandEvent& event);
	void OnSmallNotes(wxCommandEvent& event);
	void OnBeaming(wxCommandEvent& event);
	void OnRests(wxCommandEvent& event);
	void OnAccidentals(wxCommandEvent& event);
	void OnAugmentations(wxCommandEvent& event);
	void OnRepeats(wxCommandEvent& event);
	void OnBarlines(wxCommandEvent& event);
	void OnClefs(wxCommandEvent& event);
	void OnBrackets(wxCommandEvent& event);
	void OnHorizontals(wxCommandEvent& event);
	void OnRefrains(wxCommandEvent& event);
	void OnExpressions(wxCommandEvent& event);
	void OnGenericExp(wxCommandEvent& event);
	void OnOrnaments(wxCommandEvent& event);
	void OnKoreanOrnaments(wxCommandEvent& event);
	void OnFingering(wxCommandEvent& event);
	void OnMutes(wxCommandEvent& event); 
	void OnHarmonics(wxCommandEvent& event);
	void OnBreathGlass(wxCommandEvent& event);
	void OnStrings(wxCommandEvent& event);
	void OnPedals(wxCommandEvent& event);
	void OnViolin(wxCommandEvent& event);
	void OnPercussions(wxCommandEvent& event);
	
	//metodi corrispondenti agli item del menu Format
	void OnFormat(wxCommandEvent& event);
	void OnCheck(wxCommandEvent& event);
	void OnJustification(wxCommandEvent& event);
	
	void OnLineBreaking(wxCommandEvent& event);
	void OnAutoBeaming(wxCommandEvent &event);
	
	void OnFormatBeaming(wxCommandEvent& event);
	void OnUpDown(wxCommandEvent& event);
	void OnFormattingSettings(wxCommandEvent& event);
	void OnEditMilla(wxCommandEvent& event);
	void OnLoadMilla(wxCommandEvent& event);
	void OnReLoadMilla(wxCommandEvent& event);
	void OnDebugMillaIns(wxCommandEvent& event);
	void OnDebugMillaPos(wxCommandEvent& event);
	
	void OnSeeInvisible(wxCommandEvent& event);
	void OnSeeAnchor(wxCommandEvent& event);
	void OnCompViewPar(wxCommandEvent& event);
	void OnPrintParams(wxCommandEvent& event);
	
	
	void OnEditTable(wxCommandEvent& event);
	void OnEditTable1(wxCommandEvent& event);
	void OnEditTable2(wxCommandEvent& event);
	void OnEditTable3(wxCommandEvent& event);
	void OnEditTableGen1(wxCommandEvent& event);
	void OnEditTableGen2(wxCommandEvent& event);
	void OnEditTableGen3(wxCommandEvent& event);
	void OnEditTablePercussions(wxCommandEvent& event);
	void OnEditTablePedals(wxCommandEvent& event);
	
	void OnLoadTable(wxCommandEvent& event);
	void OnScoreExcerpt(wxCommandEvent& event);
	
	//metodi corrispondenti agli item del menu Exec
	void OnTime(wxCommandEvent& event);
	void OnLabels(wxCommandEvent& event);
	void OnMarkers(wxCommandEvent& event);
	void OnOrchestration(wxCommandEvent& event);
	void OnSynchronization(wxCommandEvent& event);
	
	//metodi corrispondenti agli item del menu Help
	void OnHelp(wxCommandEvent& event);
	void OnAbout(wxCommandEvent& event);
	
	LyricFrame* OpenLyricFrame();
	LyricFrame* GetLyricFramePtr();
	void SetLyricFramePtr(LyricFrame *ptr);
	
	void PrepareCanvas();
	void UnprepareCanvas();
	
	void DisableResize();
	void EnableResize();
	
	void CreateProgressSlide(wxString info, int maxVal);
	void SetProgressSlide(int value, wxString info="");
	void DeleteProgressSlide();
	
	void OnOpenEtt(wxString ett);
	
	void OnActivate(wxActivateEvent& event);
	
	DECLARE_EVENT_TABLE()
};


#endif //SCOREFRM_HPP
