/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: scrobjec.hpp,v 1.1 2005/07/25 16:30:34 bellinpo Exp $ */

#ifndef SCROBJECT_HPP
#define SCROBJECT_HPP

#include "lioo.hpp"
#include "drw/drawobje.hpp"

typedef int EventResult;

#define ER_NO_HIT   0
#define ER_CONTINUE 1
#define ER_END      2

typedef void* Widget;


class ScrObject : virtual public DrawObject
{
  ScrObject *Next;
  Widget ScrWindow;
  Widget ScrDrawArea;
  int inView;
    // attributi utilizzato per la gestione delle finestre, con le classi
    // Menu e Button.
  public:
    ScrObject() { Next=NULL;ScrWindow=NULL;ScrDrawArea=NULL; inView=-1; };
    virtual ~ScrObject() {};

    void SetNext(ScrObject*);
    ScrObject* GetNext();
    
    void SetScrWindow(Widget);
    Widget GetScrWindow();
    void SetScrDrawArea(Widget);
    Widget GetScrDrawArea();
   
    virtual EventResult LeftButtonPress(const Point&);
    virtual EventResult LeftButtonRelease(const Point&);
    
    virtual EventResult RightButtonPress(const Point&);
    virtual EventResult RightButtonRelease(const Point&);
    
    virtual EventResult KeyPressed(int key);
    // La versione originale era KeyPress, ma e` in conflitto con le
    // librerie grafiche.

	int GetInView() { return inView; };
	void SetInView(int view) { inView=view; };
	bool isInCurrentView() { return inView==-1 || inView==currentView; };
};

#endif
