/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: text.cpp,v 1.1 2005/07/25 16:30:35 bellinpo Exp $ */


#include "drw/text.hpp"
#include <wx/font.h>

Text::Text()
{
	ID=CL_TEXT;
	txt=NULL;
	font=-1;
	wdt=vu2up=vu2dwn=-1;
	validSetup=false;
}


Text::~Text()
{
}

void Text::SetFont(int s)
{
	font=s; 
	Setup();
};

int Text::GetFont() 
{ 
	return font;
};

Bool Text::SetTxt(unsigned char *s) 
{
	txt=s; 
	Setup();
	return TRUE; 
};

Bool Text::SetTxt(unsigned char s) 
{
	txt= new unsigned char[2];
	if (txt==NULL) return FALSE;
	txt[0]=s;
	txt[1]=0;
	Setup();
	return TRUE; 
};

unsigned char *Text::GetTxt()
{ 
	return txt; 
};

VUnit Text::GetVU2Up() 
{
	if(!validSetup)
		Setup();
	return vu2up; 
}
VUnit Text::GetVU2Dwn() 
{ 
	if(!validSetup)
		Setup();
	return vu2dwn; 
}
void Text::SetVU2Up(VUnit v) { vu2up = v; };
void Text::SetVU2Dwn(VUnit v) {vu2dwn = v; };
VUnit Text::GetVU2Rgt() { return wdt; }
VUnit Text::GetVU2Lft() { return 0; }

void Text::Draw()
{ 
	if (GetAbsPos()==Point(0,0)) return;

	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	if(!validSetup)
		Setup();
	
	FontID ofont;
	ofont=Scr->SetFont(font);
	Scr->TextTo(GetAbsPos()+Point( GetDx(),GetDy() ));
	if(txt!=NULL)
		Scr->OutText(txt);
	Scr->SetFont(ofont);

	Scr->SetColor(oldcol);
}

void Text::Setup()
{
	FontID ofont;
	
	if(Scr==NULL)
		return;
	
	ofont=Scr->SetFont(font);
	vu2up=VUnit(Scr->GetFontAscent());
	vu2dwn=VUnit(Scr->GetFontHeight()-Scr->GetFontAscent());
	if(txt!=NULL) wdt=Scr->GetTextWidth(txt);
	Scr->SetFont(ofont);
	validSetup=(vu2up+vu2dwn>0);
}

