/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: text.hpp,v 1.1 2005/07/25 16:30:36 bellinpo Exp $ */


#ifndef TEXT_HPP
#define TEXT_HPP

#include "drw/drawobje.hpp"
#include "lioo.hpp"

#define MAXTEXTLEN 256

class Text : virtual public DrawObject
{
protected:
    unsigned char *txt;
	unsigned char testo[MAXTEXTLEN];
    int font;
    VUnit vu2up,vu2dwn,wdt;
    void Setup();
	bool validSetup;
public:
    Text();
    virtual ~Text();
    void SetFont(int s);
    int GetFont();
	
    virtual Bool SetTxt(unsigned char *s);
	// imposta il testo. per funzionare correttamente
	// deve essere gia' stato impostato il font.
	Bool SetTxt(unsigned char s); 
    unsigned char *GetTxt() ;
	
    VUnit GetVU2Up();
    VUnit GetVU2Dwn();
    void SetVU2Up(VUnit );
    void SetVU2Dwn(VUnit );
    VUnit GetVU2Rgt();
    VUnit GetVU2Lft();
	
    void Draw();
};

#endif //TEXT_HPP
