/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: textio.hpp,v 1.1 2005/07/25 16:30:36 bellinpo Exp $ */


#ifndef TEXTIO_HPP
#define TEXTIO_HPP

#include "drw/text.hpp"
#include "drw/scrobjec.hpp"

class TextIO : public Text, public ScrObject
{    
protected:                              
    Bool edit;
	// TRUE se e' ammesso l'editing
    int maxChar;
	// Numero massimo di caratteri
    int currPos;
	// Posizione corrente
    int minEditPos;
	// Numero del carattere prima del quale non e' permesso l'editing
    void DrawCursor();
	// disegna il cursore.
public:
    TextIO(int mc,VUnit wdt);
	// Inizializza l'oggetto con massimo mc caratteri
    ~TextIO();
	// disalloca la stringa.
    void Draw();
    
    void SetFont(FontID nfnt);
	
    EventResult KeyPressed(int);
	// Notifica la pressione di un tasto
    void SetMessage(unsigned char *str);
	// Imposta il messaggio contenuto in str e disabilita l'editing
    void EditMessage(unsigned char *str);
	// Imposta il messaggio contenuto in str e abilita l'editing
    unsigned char *GetMessage();
	// Ritorna il testo inserito dall'utente (da minEditChar in poi).  
};        

#endif // TEXTIO_HPP
