/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: tnumeric.cpp,v 1.1 2005/07/25 16:30:36 bellinpo Exp $ */


#include "drw/tnumeric.hpp"
#include <stdlib.h>
#include <string.h>


TNumerico::TNumerico()
{
	Text::Text();
	ID=CL_TNUMERICO;
	Numero = -1;   
	
	txt=&(TArray[0]);
	if(txt!=NULL) txt[0]='\0';
}


Bool TNumerico::SetNumero(int n)
{
	int num=n;
	short i, j, lungh;
	char c;
	Bool risult=FALSE;
	
	if(txt!=NULL && n>=0)
	{
		lungh = 0;
		risult=TRUE;
		// Genera le cifre in ordine inverso.
		do
		{
			txt[lungh] = num % 10 + '0';
			lungh++;
		} while ((num /= 10) > 0 && lungh <= MAXCARATTERINUMERO-1);
		if(num <= 0)
		{
			txt[lungh]='\0';
			// Inverte la stringa.
			for(i=0, j=lungh-1; i<j; i++, j--)
			{
				c=txt[i];
				txt[i]=txt[j];
				txt[j]=c;
			}
			Numero = n;
			Setup();
		}
		else
		{
			risult = FALSE;
			txt[0] = '\0';
		}
	}
	return risult;
};


int TNumerico::GetNumero() {return Numero;};


Bool TNumerico::SetTxt(unsigned char *s) 
{
	short i;
	Bool risult=TRUE;
	
	if(txt==NULL) return FALSE;
	// Copia la stringa.
	strncpy((char *)txt, (char *)s, MAXCARATTERINUMERO);
	txt[MAXCARATTERINUMERO]='\0';
	
	// Controllo. 
	for(i=0; txt[i]!='\0' && risult; i++)
	{
		if(txt[i]<'0' || txt[i]>'9') risult=FALSE;
	}
	if(risult)
	{
		SetNumero(atoi((char *)txt));
		Setup();
	}
	else txt[0]='\0';
	return risult; 
};


void TNumerico::SetPos(DrawObject *d, const Point& p)
{
	if(GetFont() == nMusicFont || GetFont() == nMusicFont2)
	{
		vu2dwn = VU_PER_ROW;
		vu2up = -VU_PER_ROW;
		//Text::SetPos(d, p+Point(0, VU_PER_ROW));
		Text::SetPos(d,p);   //(MS)
	}
	else if(GetFont() == nMenuFont)
	{
		vu2dwn = 0;
		vu2up = VU_PER_ROW;
		Text::SetPos(d, p+Point(-2, 6)); // DA SISTEMARE !
	}
	else Text::SetPos(d, p);
}
