/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: toolbar.cpp,v 1.1 2005/07/25 16:30:37 bellinpo Exp $ */


#include "drw/toolbar.hpp"
#include "gui/lioowin.hpp"
#include "drw/scorefrm.hpp"
#include "drw/musicedt.hpp"
#include "smr/smrmain.hpp"

extern wxDC *currDC;
extern wxDC *currMainDC;
extern wxMemoryDC *currMDC;
extern Bool accordo;
extern TipoInserimento aboveNota;
extern short mainLay;
extern NoteHead_ID headType;
extern LiooWindow *pMusicWin;
extern wxMEScoreCanvas *ScoreInExecution;
extern Colore GetColor(int);


BEGIN_EVENT_TABLE(ToolBar, wxSashLayoutWindow)
EVT_BUTTON(TOOL_EDITEXEC_ID, ToolBar::OnEditexec)
EVT_BUTTON(TOOL_TOP_ID, ToolBar::OnTop)
EVT_BUTTON(TOOL_MENO1PAG_ID, ToolBar::OnMeno1pag)
EVT_BUTTON(TOOL_MENO5_ID, ToolBar::OnMeno5)
EVT_BUTTON(TOOL_MENO1_ID, ToolBar::OnMeno1)
EVT_BUTTON(TOOL_PIU1_ID, ToolBar::OnPiu1)
EVT_BUTTON(TOOL_PIU5_ID, ToolBar::OnPiu5)
EVT_BUTTON(TOOL_PIU1PAG_ID, ToolBar::OnPiu1pag)
EVT_BUTTON(TOOL_BOTTOM_ID, ToolBar::OnBottom)
EVT_BUTTON(TOOL_JUMP_ID, ToolBar::OnJump)

EVT_BUTTON(EDIT_TOOL_LAYER_ID, ToolBar::OnEdit_layer)
EVT_BUTTON(EDIT_TOOL_CHORDNOTE_ID, ToolBar::OnEdit_chordnote)
EVT_BUTTON(EDIT_TOOL_NOTEHEAD_ID, ToolBar::OnEdit_notehead)
EVT_BUTTON(EDIT_TOOL_COLOR_ID, ToolBar::OnEdit_color)
EVT_BUTTON(EDIT_TOOL_LINESSTYLE_ID, ToolBar::OnEdit_linesstyle)
EVT_BUTTON(EDIT_TOOL_AUTO_ID, ToolBar::OnEdit_auto)
EVT_BUTTON(EDIT_TOOL_MENOSPACE_ID, ToolBar::OnEdit_menospace)
EVT_BUTTON(EDIT_TOOL_PIUSPACE_ID, ToolBar::OnEdit_piuspace)
EVT_BUTTON(EDIT_TOOL_EDIT_ID, ToolBar::OnEdit_edit)
EVT_BUTTON(EDIT_TOOL_DELETE_ID, ToolBar::OnEdit_delete)

EVT_BUTTON(EXEC_TOOL_COMPILE_ID, ToolBar::OnExec_compile)
EVT_BUTTON(EXEC_TOOL_INIT_ID, ToolBar::OnExec_init)
EVT_BUTTON(EXEC_TOOL_START_ID, ToolBar::OnExec_start)
EVT_BUTTON(EXEC_TOOL_PAUSE_ID, ToolBar::OnExec_pause)
EVT_BUTTON(EXEC_TOOL_STOP_ID, ToolBar::OnExec_stop)
EVT_BUTTON(EXEC_TOOL_MENO3_ID, ToolBar::OnExec_meno3)
EVT_BUTTON(EXEC_TOOL_PIU3_ID, ToolBar::OnExec_piu3)


END_EVENT_TABLE()





ToolBar::ToolBar(const wxString &toolbartype, wxWindow* parent, wxWindowID id, 
				 const wxPoint& pos, const wxSize& size, 
				 long style, const wxString& name) : 
wxSashLayoutWindow(parent, id, pos, size, style, name)
{
#ifdef __WXMSW__
	wxBitmap Top("TOOL_TOP", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Meno1pag("TOOL_MENO1PAG", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Meno5("TOOL_MENO5", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Meno1("TOOL_MENO1", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Piu1("TOOL_PIU1", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Piu5("TOOL_PIU5", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Piu1pag("TOOL_PIU1PAG", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Bottom("TOOL_BOTTOM", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Jump("TOOL_JUMP", wxBITMAP_TYPE_BMP_RESOURCE);
	
	wxBitmap Edit_ChordNote_chord("EDIT_CHORDNOTE_TOOL_CHORD", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_ChordNote_note("EDIT_CHORDNOTE_TOOL_NOTE", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead("EDIT_HEAD_TOOL_CLASSIC", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Linesstyle("EDIT_LINESSTYLE_TOOL_CONTINUOUS", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Menospace("EDIT_TOOL_MENOSPACE", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Piuspace("EDIT_TOOL_PIUSPACE", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Delete("EDIT_TOOL_DELETE", wxBITMAP_TYPE_BMP_RESOURCE);
	
	wxBitmap Exec_Compile("EXEC_TOOL_COMPILE", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Exec_Init("EXEC_TOOL_INIT", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Exec_Start("EXEC_TOOL_START", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Exec_Pause("EXEC_TOOL_PAUSE", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Exec_Stop("EXEC_TOOL_STOP", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Exec_Meno3("EXEC_TOOL_MENO3", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Exec_Piu3("EXEC_TOOL_PIU3", wxBITMAP_TYPE_BMP_RESOURCE);
	
#elif defined(__WXGTK__) || defined(__WXMOTIF__)
	wxBitmap Top(top_xpm);
	wxBitmap Meno1pag(meno1pag_xpm);
	wxBitmap Meno5(meno5_xpm);
	wxBitmap Meno1(meno1_xpm);
	wxBitmap Piu1(piu1_xpm);
	wxBitmap Piu5(piu5_xpm);
	wxBitmap Piu1pag(piu1pag_xpm);
	wxBitmap Bottom(bottom_xpm);
	wxBitmap Jump(jump_xpm);
	
	wxBitmap Edit_ChordNote_chord(chord_xpm);
	wxBitmap Edit_ChordNote_note(note_xpm);
	wxBitmap Edit_Notehead(classic_xpm);
	wxBitmap Edit_Linesstyle(continuous_xpm);
	wxBitmap Edit_Menospace(menospace_xpm);
	wxBitmap Edit_Piuspace(piuspace_xpm);
	wxBitmap Edit_Delete(delete_xpm);
	
	wxBitmap Exec_Compile(compile_xpm);
	wxBitmap Exec_Init(init_xpm);
	wxBitmap Exec_Start(start_xpm);
	wxBitmap Exec_Pause(pause_xpm);
	wxBitmap Exec_Stop(stop_xpm);
	wxBitmap Exec_Meno3(meno3_xpm);
	wxBitmap Exec_Piu3(piu3_xpm);
#endif
	
	
	messagedisplay = NULL;
	editexec = NULL;
	top = NULL;
	meno1pag = NULL;
	meno5 = NULL;
	meno1 = NULL;
	piu1 = NULL;
	piu5 = NULL;
	piu1pag = NULL;
	bottom = NULL;
	jump = NULL;
	
	separator = NULL;
	
	edit_layer = NULL;
	edit_chordnote = NULL;
	edit_notehead = NULL;
	edit_color = NULL;
	edit_linesstyle = NULL;
	edit_auto = NULL;
	edit_menospace = NULL;
	edit_piuspace = NULL;
	edit_edit = NULL;
	edit_delete = NULL;
	
	exec_compile = NULL;
	exec_init = NULL;
	exec_start = NULL;
	exec_pause = NULL;
	exec_stop = NULL;
	exec_meno3 = NULL;
	exec_status = NULL;
	exec_statusperc = NULL;
	exec_piu3 = NULL;
	
	
	type = toolbartype;
	
	//current_layer = layer1;
	current_linesstyle = continuous;
	current_notehead = classic;
	// current_chordnote = note;
	
	
	int currentX = 0;
	int exec_currentX = 0;
	int edit_currentX = 0;
	
	//crea i tool fissi
	messagedisplay = new wxTextCtrl(this, TOOL_MESSAGE_ID, "", wxPoint(currentX, -1), wxSize(160, 29));
	currentX = currentX + messagedisplay->GetSize().x;
	
	editexec = new wxButton(this, TOOL_EDITEXEC_ID, "", wxPoint(currentX, -1), wxSize(47, 29), 0, 
		wxDefaultValidator, "editexec");
	if (toolbartype == "editing")
	{
		messagedisplay->SetValue(" Editing");
		editexec->SetLabel("--> Exec");
	}
	if (toolbartype == "execution")
	{
		messagedisplay->SetValue(" Execution");
		editexec->SetLabel("--> Edit");
	}
	currentX = currentX + editexec->GetSize().x;
	
	top = new wxBitmapButton(this, TOOL_TOP_ID, Top, wxPoint(currentX, -1));
	currentX = currentX + top->GetSize().x;
	top->SetToolTip("Go top");
	
	meno1pag = new wxBitmapButton(this, TOOL_MENO1PAG_ID, Meno1pag, wxPoint(currentX, -1));
	currentX = currentX + meno1pag->GetSize().x;
	meno1pag->SetToolTip("Prev. page");
	
	meno5 = new wxBitmapButton(this, TOOL_MENO5_ID, Meno5, wxPoint(currentX, -1));
	currentX = currentX + meno5->GetSize().x;
	meno5->SetToolTip("-5 measures");
	
	meno1 = new wxBitmapButton(this, TOOL_MENO1_ID, Meno1, wxPoint(currentX, -1));
	currentX = currentX + meno1->GetSize().x;
	meno1->SetToolTip("-1 measure");
	
	piu1 = new wxBitmapButton(this, TOOL_PIU1_ID, Piu1, wxPoint(currentX, -1));
	currentX = currentX + piu1->GetSize().x;
	piu1->SetToolTip("+1 measure");
	
	piu5 = new wxBitmapButton(this, TOOL_PIU5_ID, Piu5, wxPoint(currentX, -1));
	currentX = currentX + piu5->GetSize().x;
	piu5->SetToolTip("+5 measures");
	
	piu1pag = new wxBitmapButton(this, TOOL_PIU1PAG_ID, Piu1pag, wxPoint(currentX, -1));
	currentX = currentX + piu1pag->GetSize().x;
	piu1pag->SetToolTip("Next page");
	
	bottom = new wxBitmapButton(this, TOOL_BOTTOM_ID, Bottom, wxPoint(currentX, -1));
	currentX = currentX + bottom->GetSize().x;
	bottom->SetToolTip("Go bottom");
	
	jump = new wxBitmapButton(this, TOOL_JUMP_ID, Jump, wxPoint(currentX, -1));
	currentX = currentX + jump->GetSize().x;
	jump->SetToolTip("Jump...");

	separator = new wxButton(this, SEPARATOR_ID, "", wxPoint(currentX, -1), wxSize(6, 29), 0, 
		wxDefaultValidator, "separator");
	currentX = currentX + separator->GetSize().x;
	
	
	//crea i tool per l'editing
	edit_currentX = currentX;
	
	edit_layer = new wxButton(this, EDIT_TOOL_LAYER_ID, "", wxPoint(edit_currentX, -1), wxSize(29, 29), 0, 
		wxDefaultValidator, "layer");
	edit_layer->SetToolTip("Layer");

	char bufnum[5];
	sprintf(bufnum,"L%d",mainLay);
	edit_layer->SetBackgroundColour(GetColor(mainLay-1));
	edit_layer->SetLabel(bufnum);
	edit_layer->Show(FALSE);
	edit_currentX = edit_currentX + edit_layer->GetSize().x;
	
	if (accordo)
		edit_chordnote = new wxBitmapButton(this, EDIT_TOOL_CHORDNOTE_ID, Edit_ChordNote_chord, wxPoint(edit_currentX, -1));
	else 
		edit_chordnote = new wxBitmapButton(this, EDIT_TOOL_CHORDNOTE_ID, Edit_ChordNote_note, wxPoint(edit_currentX, -1)); 
	edit_chordnote->SetToolTip("Note insert mode");
	edit_chordnote->Show(FALSE);
	edit_currentX = edit_currentX + edit_chordnote->GetSize().x;
	
	edit_notehead = new wxBitmapButton(this, EDIT_TOOL_NOTEHEAD_ID, Edit_Notehead, wxPoint(edit_currentX, -1));
	edit_notehead->SetToolTip("Note head");
	edit_notehead->Show(FALSE);
	edit_currentX = edit_currentX + edit_notehead->GetSize().x;
	
	edit_color = new wxButton(this, EDIT_TOOL_COLOR_ID, "Color", wxPoint(edit_currentX, -1), wxSize(35, 29), 0, 
		wxDefaultValidator, "Color");
	edit_color->Show(FALSE);
	edit_currentX = edit_currentX + edit_color->GetSize().x;
	
	edit_linesstyle = new wxBitmapButton(this, EDIT_TOOL_LINESSTYLE_ID, Edit_Linesstyle, wxPoint(edit_currentX, -1));
	edit_linesstyle->Show(FALSE);
	edit_currentX = edit_currentX + edit_linesstyle->GetSize().x;
	edit_linesstyle->SetToolTip("Line style");
	
	edit_auto = new wxButton(this, EDIT_TOOL_AUTO_ID, "", wxPoint(edit_currentX, -1), wxSize(35, 29), 0, 
		wxDefaultValidator, "auto");
	if (aboveNota == SOTTO)
		edit_auto->SetLabel("down");
	else if (aboveNota == SOPRA)
		edit_auto->SetLabel("up");
	else
		edit_auto->SetLabel("auto");
	edit_auto->SetToolTip("Insert position");
	edit_auto->Show(FALSE);
	edit_currentX = edit_currentX + edit_auto->GetSize().x;
	
	edit_menospace = new wxBitmapButton(this, EDIT_TOOL_MENOSPACE_ID, Edit_Menospace, wxPoint(edit_currentX, -1));
	edit_menospace->Show(FALSE);
	edit_currentX = edit_currentX + edit_menospace->GetSize().x;
	edit_menospace->SetToolTip("Dec. note spaceing");

	edit_piuspace = new wxBitmapButton(this, EDIT_TOOL_PIUSPACE_ID, Edit_Piuspace, wxPoint(edit_currentX, -1));
	edit_piuspace->Show(FALSE);
	edit_currentX = edit_currentX + edit_piuspace->GetSize().x;
	edit_piuspace->SetToolTip("Inc. note spaceing");
	
	edit_edit = new wxButton(this, EDIT_TOOL_EDIT_ID, "Edit", wxPoint(edit_currentX, -1), wxSize(31, 29), 0, 
		wxDefaultValidator, "edit");
	edit_edit->Show(FALSE);
	edit_currentX = edit_currentX + edit_edit->GetSize().x;
	
	edit_delete = new wxBitmapButton(this, EDIT_TOOL_DELETE_ID, Edit_Delete, wxPoint(edit_currentX, -1));
	edit_delete->Show(FALSE);
	edit_delete->SetToolTip("Delete symbols");
	
	//crea i tool per l'executing
	exec_currentX = currentX;
	
	exec_init = new wxBitmapButton(this, EXEC_TOOL_INIT_ID, Exec_Init, wxPoint(exec_currentX, -1));
	exec_init->Show(FALSE);
	exec_currentX = exec_currentX + exec_init->GetSize().x;
	exec_init->SetToolTip("Initialize execution");

	exec_start = new wxBitmapButton(this, EXEC_TOOL_START_ID, Exec_Start, wxPoint(exec_currentX, -1));
	exec_start->Show(FALSE);
	exec_currentX = exec_currentX + exec_start->GetSize().x;
	exec_start->SetToolTip("Play");
	
	exec_pause = new wxBitmapButton(this, EXEC_TOOL_PAUSE_ID, Exec_Pause, wxPoint(exec_currentX, -1));
	exec_pause->Show(FALSE);
	exec_currentX = exec_currentX + exec_pause->GetSize().x;
	exec_pause->SetToolTip("Pause");

	exec_stop = new wxBitmapButton(this, EXEC_TOOL_STOP_ID, Exec_Stop, wxPoint(exec_currentX, -1));
	exec_stop->Show(FALSE);
	exec_currentX = exec_currentX + exec_stop->GetSize().x;
	exec_stop->SetToolTip("Stop");

	exec_meno3 = new wxBitmapButton(this, EXEC_TOOL_MENO3_ID, Exec_Meno3, wxPoint(exec_currentX, -1));
	exec_meno3->Show(FALSE);
	exec_currentX = exec_currentX + exec_meno3->GetSize().x;
	exec_meno3->SetToolTip("Dec. velocity");

	exec_status = new wxTextCtrl(this, EXEC_TOOL_STATUS_ID, "", wxPoint(exec_currentX, -1), wxSize(40, 29));
	exec_status->Show(FALSE);
	exec_currentX = exec_currentX + exec_status->GetSize().x;
	
	exec_statusperc = new wxTextCtrl(this, EXEC_TOOL_STATUSPERC_ID, "", wxPoint(exec_currentX, -1), wxSize(40, 29));
	exec_statusperc->Show(FALSE);
	exec_currentX = exec_currentX + exec_statusperc->GetSize().x;
	
	exec_piu3 = new wxBitmapButton(this, EXEC_TOOL_PIU3_ID, Exec_Piu3, wxPoint(exec_currentX, -1));
	exec_piu3->Show(FALSE);
	exec_currentX = exec_currentX + exec_piu3->GetSize().x;
	exec_piu3->SetToolTip("Inc. velocity");
	
	if (toolbartype == "editing")
	{
		//visualizza i tool per l'editing
		edit_layer->Show(TRUE);
		edit_chordnote->Show(TRUE);
		edit_notehead->Show(TRUE);
		edit_color->Show(TRUE);
		edit_linesstyle->Show(TRUE);
		edit_auto->Show(TRUE);
		edit_menospace->Show(TRUE);
		edit_piuspace->Show(TRUE);
		edit_edit->Show(TRUE);
		edit_delete->Show(TRUE);
	}
	
	if (toolbartype == "execution")
	{
		//visualizza i tool per l'executing
		exec_init->Show(TRUE);
		exec_start->Show(TRUE);
		exec_pause->Show(TRUE);
		exec_stop->Show(TRUE);
		exec_meno3->Show(TRUE);
		exec_status->Show(TRUE);
		exec_statusperc->Show(TRUE);
		exec_piu3->Show(TRUE);
	}
	
}


ToolBar::~ToolBar()
{
	if (messagedisplay)
	{	 
		delete messagedisplay;
		messagedisplay = NULL;
	}
	if (editexec)
	{	 
		delete editexec;
		editexec = NULL;
	}
	if (top)
	{	 
		delete top;
		top = NULL;
	}
	if (meno1pag)
	{	 
		delete meno1pag;
		meno1pag = NULL;
	}
	if (meno5)
	{	 
		delete meno5;
		meno5 = NULL;
	}
	if (meno1)
	{	 
		delete meno1;
		meno1 = NULL;
	}
	if (piu1)
	{	 
		delete piu1;
		piu1 = NULL;
	}
	if (piu5)
	{	 
		delete piu5;
		piu5 = NULL;
	}
	if (piu1pag)
	{	 
		delete piu1pag;
		piu1pag = NULL;
	}
	if (bottom)
	{	 
		delete bottom;
		bottom = NULL;
	}
	if (jump)
	{	 
		delete jump;
		jump = NULL;
	}
	
	if (separator)
	{	 
		delete separator;
		separator = NULL;
	}
	
	if (edit_layer)
	{	 
		delete edit_layer;
		edit_layer = NULL;
	}
	if (edit_chordnote)
	{	 
		delete edit_chordnote;
		edit_chordnote = NULL;
	}
	if (edit_notehead)
	{	 
		delete edit_notehead;
		edit_notehead = NULL;
	}
	if (edit_color)
	{	 
		delete edit_color;
		edit_color = NULL;
	}
	if (edit_linesstyle)
	{	 
		delete edit_linesstyle;
		edit_linesstyle = NULL;
	}
	if (edit_auto)
	{	 
		delete edit_auto;
		edit_auto = NULL;
	}
	if (edit_menospace)
	{	 
		delete edit_menospace;
		edit_menospace = NULL;
	}
	if (edit_piuspace)
	{	 
		delete edit_piuspace;
		edit_piuspace = NULL;
	}
	if (edit_edit)
	{	 
		delete edit_edit;
		edit_edit = NULL;
	}
	
	if (exec_compile)
	{	 
		delete exec_compile;
		exec_compile = NULL;
	}
	if (exec_init)
	{	 
		delete exec_init;
		exec_init = NULL;
	}
	if (exec_start)
	{	 
		delete exec_start;
		exec_start = NULL;
	}
	if (exec_pause)
	{	 
		delete exec_pause;
		exec_pause = NULL;
	}
	if (exec_stop)
	{	 
		delete exec_stop;
		exec_stop = NULL;
	}
	if (exec_meno3)
	{	 
		delete exec_meno3;
		exec_meno3 = NULL;
	}
	if (exec_statusperc)
	{	 
		delete exec_statusperc;
		exec_statusperc = NULL;
	}
	if (exec_piu3)
	{	 
		delete exec_piu3;
		exec_piu3 = NULL;
	}
}


extern Widget LiooWidget;


wxTextCtrl* ToolBar::Getmessagedisplay()
{ 
	return messagedisplay;
};


wxTextCtrl* ToolBar::Getexec_status()
{ 
	return exec_status;
};

wxTextCtrl* ToolBar::Getexec_statusperc()
{ 
	return exec_statusperc;
};

void ToolBar::OnEditexec(wxCommandEvent& event)
{
	if (Gettype() == "editing")
	{
		if(ScoreInExecution!=NULL)
		{
			wxMessageBox("Only one view can be in execution!");
			return;
		}
		
		if(currentViewType==1)
		{
			wxMessageBox("Execution allowed only in Computer View!");
			return;
		}
		
		ScoreInExecution=((wxMEScoreFrame*)GetParent())->scorecanvas;
		
		Settype("execution");
		editexec->SetLabel("--> Edit");
		Getmessagedisplay()->SetValue(" Execution");
		
		//nascondi i tool per l'editing
		edit_layer->Show(FALSE);
		edit_chordnote->Show(FALSE);
		edit_notehead->Show(FALSE);
		edit_color->Show(FALSE);
		edit_linesstyle->Show(FALSE);
		edit_auto->Show(FALSE);
		edit_menospace->Show(FALSE);
		edit_piuspace->Show(FALSE);
		edit_edit->Show(FALSE);
		edit_delete->Show(FALSE);
		
		//visualizza i tool per l'executing
		exec_init->Show(TRUE);
		exec_start->Show(TRUE);
		exec_pause->Show(TRUE);
		exec_stop->Show(TRUE);
		exec_meno3->Show(TRUE);
		exec_status->Show(TRUE);
		exec_statusperc->Show(TRUE);
		exec_piu3->Show(TRUE);
	}
	
	else if (Gettype() == "execution")
	{
		extern EventResult ToEditOp();
		extern wxMusicEditor *MusicEditor;
		extern int ExeStatus();
		
		if (ExeStatus()) return;
		
		ScoreInExecution=NULL;
		
		wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
		wxClientDC maindc(canvas);
		currMainDC=&maindc;
		canvas->Prepare(); canvas->PrepareDC(maindc);
		Scr->GSetMainDrawArea();
		
		ToEditOp();
		
		Settype("editing");
		editexec->SetLabel("--> Exec");
		Getmessagedisplay()->SetValue(" Editing");
		
		//nascondi i tool per l'executing
		exec_init->Show(FALSE);
		exec_start->Show(FALSE);
		exec_pause->Show(FALSE);
		exec_stop->Show(FALSE);
		exec_meno3->Show(FALSE);
		exec_status->Show(FALSE);
		exec_statusperc->Show(FALSE);
		exec_piu3->Show(FALSE);
		
		//visualizza i tool per l'editing
		edit_layer->Show(TRUE);
		edit_chordnote->Show(TRUE);
		edit_notehead->Show(TRUE);
		edit_color->Show(TRUE);
		edit_linesstyle->Show(TRUE);
		edit_auto->Show(TRUE);
		edit_menospace->Show(TRUE);
		edit_piuspace->Show(TRUE);
		edit_edit->Show(TRUE);
		edit_delete->Show(TRUE);
		
		((wxMEScoreFrame*)GetParent())->EnableResize();
	}
	
}


void ToolBar::OnTop(wxCommandEvent& event)
{
	if (Gettype() == "execution") return;
	
	Getmessagedisplay()->SetValue("Move to first measure");
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	
	canvas->GoTop();
}

void ToolBar::OnMeno1pag(wxCommandEvent& event)
{
	extern EventResult GoBackward();
	if (Gettype() == "execution") return;
	
	Getmessagedisplay()->SetValue("Move one page before");
	wxScrolledWindow* canvas = (wxScrolledWindow*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	if (pMusicWin && pMusicWin->PPartit->GetPrintingStatus())
		GoBackward();
}


void ToolBar::OnMeno5(wxCommandEvent& event)
{
	if (Gettype() == "execution") return;
	
	Getmessagedisplay()->SetValue("Move 5 measures before");
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	
	canvas->GoBackward5();
}

void ToolBar::OnMeno1(wxCommandEvent& event)
{
	if (Gettype() == "execution") return;
	
	Getmessagedisplay()->SetValue("Move 1 measure before");
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	canvas->GoBackward();
}

void ToolBar::OnPiu1(wxCommandEvent& event)
{
	if (Gettype() == "execution") return;
	
	Getmessagedisplay()->SetValue("Move 1 measure after");
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	canvas->GoForward();
}

void ToolBar::OnPiu5(wxCommandEvent& event)
{
	if (Gettype() == "execution") return;
	
	Getmessagedisplay()->SetValue("Move 5 measures after");
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	canvas->GoForward5();
}

void ToolBar::OnPiu1pag(wxCommandEvent& event)
{
	extern EventResult GoForward();
	extern wxMusicEditor *MusicEditor;
	extern int ExeStatus();
	if (Gettype() == "execution") return;
	
	Getmessagedisplay()->SetValue("Move one page after");
	wxScrolledWindow* canvas = (wxScrolledWindow*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	if (pMusicWin && pMusicWin->PPartit->GetPrintingStatus())
		GoForward();
}

void ToolBar::OnBottom(wxCommandEvent& event)
{
	if (Gettype() == "execution") return;
	
	Getmessagedisplay()->SetValue("Move to the end");
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	canvas->GoBottom();
}

void ToolBar::OnJump(wxCommandEvent& event)
{
	extern EventResult NetJump();
	extern EventResult JumpOp();
	extern wxMusicEditor *MusicEditor;
	extern int ExeStatus();
	if (ExeStatus()) return;
	
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->Prepare(); canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	if(Gettype() == "execution")
		JumpOp();
	else
		NetJump();
}


void ToolBar::OnEdit_layer(wxCommandEvent& event)
{
	extern EventResult CLayer();
	int layval;
	
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->Prepare(); canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	char bufnum[5];
	if (mainLay+1>12) 
		layval=1;
	else 
		layval=mainLay+1;
	
	sprintf(bufnum,"L%d",layval);
	
	edit_layer->SetBackgroundColour(GetColor(layval-1));
	edit_layer->SetLabel(bufnum);
	edit_layer->Refresh(); 
	
	CLayer();
}

void ToolBar::OnEdit_chordnote(wxCommandEvent& event)
{
	extern EventResult CAccordo();
#ifdef __WXMSW__
	wxBitmap Edit_ChordNote_chord("EDIT_CHORDNOTE_TOOL_CHORD", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_ChordNote_note("EDIT_CHORDNOTE_TOOL_NOTE", wxBITMAP_TYPE_BMP_RESOURCE);
#elif defined(__WXGTK__) || defined(__WXMOTIF__)
	wxBitmap Edit_ChordNote_chord(chord_xpm);
	wxBitmap Edit_ChordNote_note(note_xpm);
#endif
	if (accordo)
	{
		edit_chordnote->SetBitmapLabel(Edit_ChordNote_note);
	}
	else
	{
		edit_chordnote->SetBitmapLabel(Edit_ChordNote_chord);
	} 
	edit_chordnote->Refresh(); 
	
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	canvas->Prepare();
	
	CAccordo();
}

void ToolBar::OnEdit_notehead(wxCommandEvent& event)
{
#ifdef __WXMSW__
	wxBitmap Edit_Notehead_classic("EDIT_HEAD_TOOL_CLASSIC", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_circlex("EDIT_HEAD_TOOL_CIRCLEX", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_croix("EDIT_HEAD_TOOL_CROIX", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_x("EDIT_HEAD_TOOL_X", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_dsharp("EDIT_HEAD_TOOL_DSHARP", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_fdiamond("EDIT_HEAD_TOOL_FDIAMOND", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_ediamond("EDIT_HEAD_TOOL_EDIAMOND", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_frythmic("EDIT_HEAD_TOOL_FRYTHMIC", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_erythmic("EDIT_HEAD_TOOL_ERYTHMIC", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_rythmic("EDIT_HEAD_TOOL_RYTHMIC", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_letter1("EDIT_HEAD_TOOL_LETTER1", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_letter2("EDIT_HEAD_TOOL_LETTER2", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_rnumber1("EDIT_HEAD_TOOL_RNUMBER1", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_rnumber2("EDIT_HEAD_TOOL_RNUMBER2", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Notehead_rnumber3("EDIT_HEAD_TOOL_RNUMBER3", wxBITMAP_TYPE_BMP_RESOURCE);
#elif defined(__WXGTK__) || defined(__WXMOTIF__)
	wxBitmap Edit_Notehead_classic(classic_xpm);
	wxBitmap Edit_Notehead_circlex(circlex_xpm);
	wxBitmap Edit_Notehead_croix(croix_xpm);
	wxBitmap Edit_Notehead_x(x_xpm);
	wxBitmap Edit_Notehead_dsharp(dsharp_xpm);
	wxBitmap Edit_Notehead_fdiamond(fdiamond_xpm);
	wxBitmap Edit_Notehead_ediamond(ediamond_xpm);
	wxBitmap Edit_Notehead_frythmic(f_rythmic_xpm);
	wxBitmap Edit_Notehead_erythmic(e_rythmic_xpm);
	wxBitmap Edit_Notehead_rythmic(rythmic_xpm);
	wxBitmap Edit_Notehead_letter1(letter_1_xpm);
	wxBitmap Edit_Notehead_letter2(letter_2_xpm);
	wxBitmap Edit_Notehead_rnumber1(rnumber1_xpm);
	wxBitmap Edit_Notehead_rnumber2(rnumber2_xpm);
	wxBitmap Edit_Notehead_rnumber3(rnumber3_xpm);
#endif
	
	Notehead_type style = current_notehead;
	switch (style)  
	{
	case classic:
		edit_notehead->SetBitmapLabel(Edit_Notehead_circlex);
		current_notehead = circlex;
		headType=HEAD_CIRCLEX;
		break;
	case circlex:
		edit_notehead->SetBitmapLabel(Edit_Notehead_croix);
		current_notehead = croix;
		headType=HEAD_CROIX;
		break;
	case croix:
		edit_notehead->SetBitmapLabel(Edit_Notehead_x);
		current_notehead = x;
		headType=HEAD_X;
		break;
	case x:
		edit_notehead->SetBitmapLabel(Edit_Notehead_dsharp);
		current_notehead = dsharp;
		headType=HEAD_DDIESIS;
		break;
	case dsharp:
		edit_notehead->SetBitmapLabel(Edit_Notehead_fdiamond);
		current_notehead = fdiamond;
		headType=HEAD_DIAMOND;
		break;
	case fdiamond:
		edit_notehead->SetBitmapLabel(Edit_Notehead_frythmic);
		current_notehead = frythmic;
		headType=HEAD_RHYTHMIC;
		break;
	case frythmic:
		edit_notehead->SetBitmapLabel(Edit_Notehead_letter1);
		current_notehead = letter1;
		headType=HEAD_ALPHANUM;
		break;
	case letter1:
		edit_notehead->SetBitmapLabel(Edit_Notehead_letter2);
		current_notehead = letter2;
		headType=HEAD_ALPHANUM_SQUARE;
		break;
	case letter2:
		edit_notehead->SetBitmapLabel(Edit_Notehead_rnumber3);
		current_notehead = rnumber3;
		headType=HEAD_ALPHANUM_REVERSE;
		break;
	case rnumber3:
		edit_notehead->SetBitmapLabel(Edit_Notehead_classic);
		current_notehead = classic;
		headType=HEAD_CLASSIC;
		break;
	}
	edit_notehead->Refresh(); 
	
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	canvas->Prepare();
	
	SymCmd *SC = pMusicWin->GetSymCmd();
	pMusicWin->SetCommand(SC->CommandId, SC->SelectionType, SC->SelObjType, 
		SC->ArgV[0],SC->ArgV[1], SC->ArgV[2], SC->ArgV[3], SC->ArgV[4], SC->Text,
		SC->ArgV[5],SC->ArgV[6],SC->ArgV[7],headType);
}

void ToolBar::OnEdit_color(wxCommandEvent& event)
{
	wxMessageBox(NOTYETIMPLEMENTED, "OnColor", wxOK);
}

void ToolBar::OnEdit_linesstyle(wxCommandEvent& event)
{
#ifdef __WXMSW__
	wxBitmap Edit_Linesstyle_continuous("EDIT_LINESSTYLE_TOOL_CONTINUOUS", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Linesstyle_dashed("EDIT_LINESSTYLE_TOOL_DASHED", wxBITMAP_TYPE_BMP_RESOURCE);
	wxBitmap Edit_Linesstyle_dotted("EDIT_LINESSTYLE_TOOL_DOTTED", wxBITMAP_TYPE_BMP_RESOURCE);
#elif defined(__WXGTK__) || defined(__WXMOTIF__)
	wxBitmap Edit_Linesstyle_continuous(continuous_xpm);
	wxBitmap Edit_Linesstyle_dashed(dashed_xpm);
	wxBitmap Edit_Linesstyle_dotted(dotted_xpm);
#endif
	extern LineType lineType;
	
	LinesStyle_type style = current_linesstyle;
	switch (style)  
	{
	case continuous:
		edit_linesstyle->SetBitmapLabel(Edit_Linesstyle_dashed);
		current_linesstyle = dashed;
		lineType=DASHED_LINE;
		break;
	case dashed:
		edit_linesstyle->SetBitmapLabel(Edit_Linesstyle_dotted);
		current_linesstyle = dotted;
		lineType=DOTTED_LINE;
		break;
	case dotted:
		edit_linesstyle->SetBitmapLabel(Edit_Linesstyle_continuous);
		current_linesstyle = continuous;
		lineType=SOLID_LINE;
		break;	
		
	}
	edit_linesstyle->Refresh(); 
	
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	canvas->Prepare();
	
}


void ToolBar::OnEdit_auto(wxCommandEvent& event)
{
	EventResult CSopra();
	
	wxString label = edit_auto->GetLabel();
	wxString newlabel = "";
	
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	canvas->Prepare();
	
	CSopra();
	
	if (aboveNota == SOTTO)
		newlabel = "down";
	else if (aboveNota == SOPRA)
		newlabel = "up";
	else if (aboveNota == AUTOMATICO)
		newlabel = "auto";
	else if (aboveNota == MID12)
		newlabel = "md12";
	else
		newlabel = "md23";
	edit_auto->SetLabel(newlabel);
	
}

void ToolBar::OnEdit_menospace(wxCommandEvent& event)
{
	extern EventResult CBatSubSp();
	
	extern wxMusicEditor *MusicEditor;
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	if(!SimbImg)
	{
		canvas->SetViewBarlines(true);
		canvas->Refresh();
		wxMEScoreFrame *scoreFrame=(wxMEScoreFrame*)GetParent();
		if(!scoreFrame->GetmiscMenu()->IsChecked(VIEW_SEEBARLINES_ID))
			scoreFrame->GetviewMenu()->Check(VIEW_SEEBARLINES_ID,true);
	}
	canvas->Prepare(); canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	CBatSubSp();
}

void ToolBar::OnEdit_piuspace(wxCommandEvent& event)
{
	extern EventResult CBatAddSp();
	
	extern wxMusicEditor *MusicEditor;
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	if(!SimbImg)
	{
		canvas->SetViewBarlines(true);
		canvas->Refresh();
		wxMEScoreFrame *scoreFrame=(wxMEScoreFrame*)GetParent();
		if(!scoreFrame->GetviewMenu()->IsChecked(VIEW_SEEBARLINES_ID))
			scoreFrame->GetviewMenu()->Check(VIEW_SEEBARLINES_ID,true);
	}
	canvas->Prepare(); canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	CBatAddSp();
}

void ToolBar::OnEdit_edit(wxCommandEvent& event)
{
	extern EventResult CEditSimboloOp();
	
	extern wxMusicEditor *MusicEditor;
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->Prepare();
	Scr->GSetMainDrawArea();
	
	CEditSimboloOp();
}

void ToolBar::OnEdit_delete(wxCommandEvent& event)
{
	extern EventResult CDelSimboloOp();
	
	extern wxMusicEditor *MusicEditor;
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->Prepare(); canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	CDelSimboloOp();
}



void ToolBar::OnExec_compile(wxCommandEvent& WXUNUSED(event))
{
	if(currentViewType==1)
	{
		wxMessageBox("Execution allowed only in Computer View!");
		return;
	}
	
	extern EventResult ImpOp();
	
	extern wxMusicEditor *MusicEditor;
	
	((wxMEScoreFrame*)GetParent())->DisableResize();
	
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->Prepare(); canvas->PrepareDC(maindc);
	ImpOp();
}

void ToolBar::OnExec_init(wxCommandEvent& event)
{
	if(currentViewType==1)
	{
		wxMessageBox("Execution allowed only in Computer View!");
		return;
	}
	
	extern EventResult InitOp();
	
	extern wxMusicEditor *MusicEditor;
	
	((wxMEScoreFrame*)GetParent())->DisableResize();
	
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->Prepare(); canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	InitOp();
}

void ToolBar::OnExec_start(wxCommandEvent& event)
{
	if(currentViewType==1)
	{
		wxMessageBox("Execution allowed only in Computer View!");
		return;
	}
	
	extern EventResult GoOp();
	
	extern wxMusicEditor *MusicEditor;
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->Prepare(); canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	canvas->SetFocus();
	GoOp();
}

void ToolBar::OnExec_pause(wxCommandEvent& event)
{
	extern EventResult pausaOp();
	
	extern wxMusicEditor *MusicEditor;
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->Prepare(); canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	canvas->SetFocus();
	pausaOp();
}

void ToolBar::OnExec_stop(wxCommandEvent& event)
{
	extern EventResult StopOp();
	
	extern wxMusicEditor *MusicEditor;
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->Prepare(); canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	StopOp();
}



void ToolBar::OnExec_meno3(wxCommandEvent& event)
{
	extern EventResult DecOp();
	
	extern wxMusicEditor *MusicEditor;
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->Prepare(); canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	DecOp();
}

void ToolBar::OnExec_piu3(wxCommandEvent& event)
{
	extern EventResult AccOp();
	
	extern wxMusicEditor *MusicEditor;
	wxMEScoreCanvas* canvas = (wxMEScoreCanvas*)GetParent()->FindWindow(wxMEScoreCanvas_ID);
	wxClientDC maindc(canvas);
	currMainDC=&maindc;
	canvas->Prepare(); canvas->PrepareDC(maindc);
	Scr->GSetMainDrawArea();
	
	AccOp();
}

LinesStyle_type ToolBar::Getcurrent_linesstyle() {return current_linesstyle;}
