/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: nbreve.cpp,v 1.1 2005/07/25 16:30:40 bellinpo Exp $ */


#include "fig/nbreve.hpp"
#include "drw/gscreen.hpp" 
#include "fig/def_fig.hpp"                


NBreve::NBreve()  : Nota(2)
{
	Init();
	// durata = 2;
} 


void NBreve::Init()
{
	Nota::Init();
	ID=CL_NBREVE; 
	HeadCode[0]=CODBREVE;
	HeadCode[1]=0;
    SetVU2RgtF(VU2RGTBREVE);
}


void NBreve::SetLGambo(VUnit lg) {}


void NBreve::SetCoda(Bool coda) {}


void NBreve::AdjustF()
{
	InitRectF();
	
	if (GetNotina())
	{
		SetVU2UpF(VU2UPBREVE1);
		SetVU2RgtF(VU2RGTBREVE1);  
		SetVU2DwnF(VU2DWNBREVE1);
		SetVU2LftF(VU2LFTBREVE1);
	}
	else
	{
		SetVU2UpF(VU2UPBREVE);
		SetVU2RgtF(VU2RGTBREVE);  
		SetVU2DwnF(VU2DWNBREVE);
		SetVU2LftF(VU2LFTBREVE);
	}  
	
}


void NBreve::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	if(HastobeDraw())
	{
		
		HeadCode[0]=CODBREVE;
		if(GetNotina()) HeadCode[0]=CODBREVE1;
		HeadCode[1]=0;
		
		Nota::Draw();  
		
	}

	Scr->SetColor(oldcol);
}


void NBreve::DrawForAccordo()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	HeadCode[0]=CODBREVE;
	if(GetNotina()) HeadCode[0]=CODBREVE1;
	HeadCode[1]=0;
	Nota::DrawForAccordo();  
	
	Scr->SetColor(oldcol);
};  

