/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: nsemibre.cpp,v 1.1 2005/07/25 16:30:43 bellinpo Exp $ */


#include "fig/nsemibre.hpp"
#include "drw/gscreen.hpp"                 


NSemibreve::NSemibreve()  : Nota(1)
{
	Init();
	//durata = 1;
} 


void NSemibreve::Init()
{
	Nota::Init();
	ID=CL_NSEMIBREVE;
	// L'ellisse della semibreve e' piu' grande di quella delle altre note,
	// percio':
	SetVU2RgtF(VU2RGTNSEMIBREVE);
}


void NSemibreve::SetLGambo(VUnit lg) {}


void NSemibreve::SetCoda(Bool coda) {}


void NSemibreve::AdjustF()
{
	// Poiche' questa nota non ha ne' gambo ne' coda, gli eventuali Adjust
	// gia' eseguiti non hanno cambiato VU2UpF, VU2Dwn, VU2Lft. Allora
	// basta controllare:
	if(GetNotina())
		SetVU2RgtF(VU2RGTNSEMIBREVE1);
	else
		SetVU2RgtF(VU2RGTNSEMIBREVE);
	
}


void NSemibreve::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	if(HastobeDraw())
	{
		Nota::Draw();  
	}

	Scr->SetColor(oldcol);
};  

