/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: pduebatt.cpp,v 1.1 2005/07/25 16:30:45 bellinpo Exp $ */

//--------------------------------------------------------------------------
// Per posizionare pausa due battute nel pentagramma impostare l'altezza a 5
//--------------------------------------------------------------------------
#include "fig/pduebatt.hpp" 

PDueBattute::PDueBattute()
{ 
	Init();
}



void PDueBattute::Init()
{
	Pausa::Init();
	ID=CL_PDUEBATTUTE;
	SetVU2RgtF(VU2RGTPDUEBATTUTE);
	SetVU2UpF(VU2UPPDUEBATTUTE);
	SetVU2DwnF(VU2DWNPDUEBATTUTE);
	SetVU2LftF(VU2LFTPDUEBATTUTE);
}


void PDueBattute::Adjust(Bool primaleg, Battuta *pBattuta, short current_layer, short curStaff)
{
	if (GetNotina())
	{
		SetVU2RgtF(VU2RGTPDUEBATTUTES);
		SetVU2UpF(VU2UPPDUEBATTUTES);
		SetVU2DwnF(VU2DWNPDUEBATTUTES);
		SetVU2LftF(VU2LFTPDUEBATTUTES);
	}
	else
	{
		SetVU2RgtF(VU2RGTPDUEBATTUTE);
		SetVU2UpF(VU2UPPDUEBATTUTE);
		SetVU2DwnF(VU2DWNPDUEBATTUTE);
		SetVU2LftF(VU2LFTPDUEBATTUTE);
	}
	Pausa::Adjust(primaleg, pBattuta, current_layer, curStaff);
}


void PDueBattute::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	if(HastobeDraw())
	{
		char code[2];
		int oldFont;
		if(isOpaque)
			Scr->SetColor(GetColor());
		
		code[0]=(GetNotina())? CODPDUEBATTUTES: CODPDUEBATTUTE;
		code[1]= '\0';
		
		
		Pausa::Draw();
		if (GetNotina())
		{
			oldFont=Scr->SetFont(nMusicFont2);
		}
		else
		{
			oldFont=Scr->SetFont(nMusicFont);
		}
		
		Scr->TextTo(GetAbsPos()+Point(DELTAXPDUEBATTUTE,DELTAYPDUEBATTUTE));
		Scr->OutText((unsigned char *)code);
		
		Scr->SetFont(oldFont);	
	}

	Scr->SetColor(oldcol);
};
