/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: pminima.cpp,v 1.1 2005/07/25 16:30:47 bellinpo Exp $ */


#include "fig/pminima.hpp" 

PMinima::PMinima() : Pausa(0.5)
{
	Init();
	//durata = 0.5;
}
////////////////////


void PMinima::Init()
{
	Pausa::Init();
	ID=CL_PMINIMA;
    SetVU2UpF(VU2UPFPMINIMA);
    SetVU2RgtF(VU2RGTFPMINIMA);  
	SetVU2DwnF(VU2DWNFPMINIMA);
    SetVU2LftF(VU2LFTFPMINIMA);
}


void PMinima::Adjust(Bool primaleg, Battuta *pBattuta, short current_layer, short curStaff)
{
	if (GetNotina())
	{
		SetVU2UpF(VU2UPFPMINIMAS);
		SetVU2RgtF(VU2RGTFPMINIMAS);  
		SetVU2DwnF(VU2DWNFPMINIMAS);
		SetVU2LftF(VU2LFTFPMINIMAS);
	}
	else
	{
		SetVU2UpF(VU2UPFPMINIMA);
		SetVU2RgtF(VU2RGTFPMINIMA);  
		SetVU2DwnF(VU2DWNFPMINIMA);
		SetVU2LftF(VU2LFTFPMINIMA);
	}
	
	Pausa::Adjust(primaleg, pBattuta,current_layer, curStaff);
}


void PMinima::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	if(HastobeDraw())
	{
		char code[2];
		int oldFont;
		if(isOpaque)
			Scr->SetColor(GetColor());
		
		code[0]=(GetNotina())? CODRETTANGOLINOS: CODRETTANGOLINO;
		code[1]= '\0';
		
		
		Pausa::Draw();
		// Disegna una piccola riga sulla quale si appoggia la pausa.
		// E' utile quando la pausa va disegnata fuori dal pentagramma.
		if (GetNotina())
		{
			oldFont=Scr->SetFont(nMusicFont2);
			Scr->MoveTo(GetAbsPos().x+APPOGGIOPAUSALFTS+DELTAXPMINIMAS,GetAbsPos().y);
			Scr->LineTo(GetAbsPos().x+APPOGGIOPAUSARGTS+DELTAXPMINIMAS,GetAbsPos().y);
		}
		else
		{
			oldFont=Scr->SetFont(nMusicFont);
			Scr->MoveTo(GetAbsPos().x+APPOGGIOPAUSALFT+DELTAXPMINIMA,GetAbsPos().y);
			Scr->LineTo(GetAbsPos().x+APPOGGIOPAUSARGT+DELTAXPMINIMA,GetAbsPos().y);
		}
		
		Scr->TextTo(GetAbsPos()+Point(DELTAXPMINIMA,DELTAYPMINIMA));
		Scr->OutText((unsigned char *)code);
		
		Scr->SetFont(oldFont);
	}

	Scr->SetColor(oldcol);
};
