/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: psemimin.cpp,v 1.1 2005/07/25 16:30:48 bellinpo Exp $ */


#include "fig/psemimin.hpp"

PSemiminima::PSemiminima() : Pausa(0.25)
{
	Init();
	//durata = 0.25;
}
//////////////////////////////



void PSemiminima::Init()
{
	Pausa::Init();
	ID=CL_PSEMIMINIMA;
    SetVU2UpF(VU2UPFPSEMIMINIMA);
    SetVU2RgtF(VU2RGTFPSEMIMINIMA);  
	SetVU2DwnF(VU2DWNFPSEMIMINIMA);
    SetVU2LftF(VU2LFTFPSEMIMINIMA);
}

void PSemiminima::Adjust(Bool primaleg, Battuta *pBattuta, short current_layer, short curStaff)
{
	if (GetNotina())
	{
		SetVU2UpF(VU2UPFPSEMIMINIMAS);
		SetVU2RgtF(VU2RGTFPSEMIMINIMAS);  
		SetVU2DwnF(VU2DWNFPSEMIMINIMAS);
		SetVU2LftF(VU2LFTFPSEMIMINIMAS);
	}
	else
	{
		SetVU2UpF(VU2UPFPSEMIMINIMA);
		SetVU2RgtF(VU2RGTFPSEMIMINIMA);  
		SetVU2DwnF(VU2DWNFPSEMIMINIMA);
		SetVU2LftF(VU2LFTFPSEMIMINIMA);
	}
	Pausa::Adjust(primaleg, pBattuta,current_layer, curStaff);
}


void PSemiminima::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	if(HastobeDraw())
	{
		char code[2];
		int oldFont;
		if(isOpaque)
			Scr->SetColor(GetColor());
		
		code[0]=(GetNotina())? CODPSEMIMINIMAS: CODPSEMIMINIMA;
		code[1]= '\0';
		
		
		Pausa::Draw();
		if (GetNotina())
		{
			oldFont=Scr->SetFont(nMusicFont2);
		}
		else
		{
			oldFont=Scr->SetFont(nMusicFont);
		}
		Scr->TextTo(GetAbsPos()+Point(DELTAXPSEMIMINIMA,DELTAYPSEMIMINIMA));
		Scr->OutText((unsigned char *)code);
		
		Scr->SetFont(oldFont);
		
	}

	Scr->SetColor(oldcol);
};
