/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: spazio.hpp,v 1.1 2005/07/25 16:30:51 bellinpo Exp $ */


#ifndef SPAZIO_HPP
#define SPAZIO_HPP     

#include "lioo.hpp"
#include "fig/figura.hpp"
#include "var/prfiato.hpp"


class Spazio: public Figura
{
private:
    CmdResult CmdSpazioPrFiato();
	
protected:
    PrFiato *PPrFiato;
	// Puntatore a PrFiato
	
	int relpos;
	// Posizione relativa dell'ancoraggio rispetto
	// alla figura precedente in percentuale della distanza
	// fra la figura precedente l'ancoraggio e quella ad esso
	// successiva. Ad es. relpos=50 => 50% => l'ancoraggio sta
	// a met tra le due figure, relpos=33 => l'ancoraggio
	//  a un terzo dalla figura precedente della distanza 
	// totale fino alla figura successiva.
	
public:
    Spazio();
    ~Spazio();
    void Init();
	// Inizializza lo spazio. Non fa altro che chiamare
	// l'inizializzazione di Figura.  
	
    void SetPPrFiato(PrFiato *prf);
	// Imposta il puntatore a prendere fiato
    PrFiato *GetPPrFiato();  
	// Restituisce il puntatore a prendere fiato
	
    void Adjust(Bool primaleg, Battuta *pBattuta, short current_layer, short current_staff);
    void Draw(); 
	
    Bool DeleteSym(DrawObject*);
	
    Bool Hit(const Point&,SelObj,DrawObject*&,SymPath&);
    Bool SymbolicHit(SymPath&,SelObj,DrawObject*&);
	// Decodifica un path.
	
    void Select();
    void Deselect();
	
    CmdResult SymCommand(SymCmd&, Battuta *pb=NULL);
	
    void Free();
	
	
    void Setrelpos(int pos);
    int  Getrelpos();
	
	int SaveXML(FILE *);
};

#endif //SPAZIO_HPP
