/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#include "lioo.hpp"
#include "wx/wxprec.h"
#include "wx/file.h"

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "fonttable.hpp"

FontTable::FontTable()
{
	for (int i=0; i<256; i++)
	{
		item[i].code=i;
		item[i].up=0;
		item[i].down=0;
		item[i].left=0;
		item[i].right=0;
		item[i].hor=0;
		item[i].ver=0;
		memset(item[i].name,'*',24);
		item[i].name[24]=0;
	}
};


int FontTable::GetCodefromPos(int POS)
{
	for (int idx=0;idx<256;idx++)
	{
		if (GetPos(idx)==POS)
			return(idx);
	}
	return(-1);
}



void FontTable::LoadFile(char *filename)
{	  
	
	FILE *tablefile; // Puntatore al file con le informazioni su vari VU2.. e DX e DY
	char *tablename;
	tablename = new char [25];
	strcpy(tablename,filename);
	tablename[strlen(filename)-3]='\0';
	tablename = strcat(tablename,"tbl");	  
	
	char *dirx,*env;
	dirx = new char[200];
	env= smrgetenv("SMR_FONT_PATH");
	if(env!=NULL)
	{
		strcpy (dirx, env);
		char *tablenameres;
		tablenameres = new char[256];
		tablenameres = strcat(dirx,tablename);
		tablefile = fopen(tablenameres, "r");
	}

	if(tablefile != NULL)
	{
		char riga[1000], tmpname[25]="";
		int tmpCar, tmpDW, tmpUP, tmpRG, tmpLF, tmpdx, tmpdy, ret;
		while(fgets(riga,1000,tablefile)!=NULL)
		{
			ret=sscanf(riga,"%i %i %i %i %i %i %i %s",&tmpCar,&tmpDW,&tmpUP,&tmpRG,
				&tmpLF,&tmpdx,&tmpdy,tmpname);
			
			if (ret==8 && tmpCar>=0 && tmpCar<256) 
			{
				item[tmpCar].code = tmpCar;
				item[tmpCar].up = tmpUP;
				item[tmpCar].down = tmpDW;
				item[tmpCar].right = tmpRG;
				item[tmpCar].left = tmpLF;
				item[tmpCar].hor = tmpdx;
				item[tmpCar].ver = tmpdy;
				strcpy(item[tmpCar].name,tmpname);
			}
		}
		fclose(tablefile);	
	}
};


void FontTable::SaveFile(char *filename)
{
	
	
	FILE *tablefile; // Puntatore al file con le informazioni su vari VU2.. e DX e DY
	char *tablename;
	tablename = new char [25];
	strcpy(tablename,filename);
	tablename[strlen(filename)-3]='\0';
	tablename = strcat(tablename,"tbl");	
	
	char *dirx,*env;
	dirx = new char[200];
	env= smrgetenv("SMR_FONT_PATH");
	if(env!=NULL)
	{
		strcpy (dirx, env);
		char *tablenameres;
		tablenameres = new char[256];
		tablenameres = strcat(dirx,tablename);
		tablefile = fopen(tablenameres, "w");
	}
		 	
	
	
	if(tablefile != NULL)
	{
		
		for (int idx=0;idx<256;idx++)
			if ((item[idx].name[0])!='*')
				fprintf(tablefile, "%i %i %i %i %i %i %i %s #\n", item[idx].code, item[idx].down, item[idx].up, item[idx].right, item[idx].left, item[idx].hor, item[idx].ver, item[idx].name );
		fclose(tablefile);	
	}
};


FontTable::~FontTable(){};

