/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/////////////////////////////////////////////////////////////////////////////
// Name:        wdftable.hpp
// Purpose:     FontTable
// Author:      Marius 
// Modified by:
// Created:     23.08.2000
/////////////////////////////////////////////////////////////////////////////

#ifndef FONTTABLE_HPP
#define FONTTABLE_HPP



typedef int FontID;


// Questa struttura contiene le carateristiche del carattere,
// serve per gestire i font non proporzionali convertiti in bitmap

struct Symbols
{
  char name[25];   // nome carattere
  int code, up, down, left, right, hor, ver, pos;
};


class FontTable
{
 protected:
	struct Symbols item[256];  // Tutti i caratteri 
	
 public:
    FontTable();
    ~FontTable();
	
	int GetCode(int CODE) {return item[CODE].code;};
	//void SetCode(int code, int CODE) {item[code].code = CODE;};
	
	char* GetName(int CODE) {return item[CODE].name;};
	//void SetName(int code, char *NAME) {strcpy(item[code].name,NAME);};

	int GetUp(int CODE) {return item[CODE].up;};
	void SetUp(int CODE, int UP) {item[CODE].up = UP;};

	int GetDown(int CODE) {return (item[CODE].down);};
	void SetDown(int CODE, int DOWN) {item[CODE].down=DOWN;};

	int GetLeft(int CODE) {return (item[CODE].left);};
	void SetLeft(int CODE, int LEFT) {item[CODE].left = LEFT;};

	int GetRight(int CODE) {return (item[CODE].right);};
	void SetRight(int CODE, int RIGHT) {item[CODE].right=RIGHT;};

	int GetHor(int CODE) {return (item[CODE].hor);};
	void SetHor(int CODE, int HOR) {item[CODE].hor = HOR;};

	int GetVer(int CODE) {return (item[CODE].ver);};
	void SetVer(int CODE, int VER) {item[CODE].ver=VER;};

	int GetPos(int CODE) {return (item[CODE].pos);};
	void SetPos(int CODE, int POS) {item[CODE].pos=POS;};

	int GetCodefromPos(int pos);
	// torna il Code dell'simbolo nella posizione pos nella listbox
	// se non lo trova torna -1

	void LoadFile(char *filename);
	void SaveFile(char *filename);

};

#endif

