/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#ifndef DIALOGS_HPP
#define DIALOGS_HPP

#include "lioo.hpp"


#include "par/partitur.hpp"
#include "wx/wx.h"
#include "fig/nota.hpp"
#include "fig/pausa.hpp"
#include "int/bend.hpp"
#include "int/forcella.hpp"
#include "int/legatura.hpp"
#include "drw/drawobje.hpp"
#include "str/arcosu.hpp"
#include "str/arcogiu.hpp"
#include "str/corda.hpp"
#include "str/pizzicat.hpp"
#include "str/ponticel.hpp"
#include "str/punta.hpp"
#include "str/tallone.hpp"
#include "str/tastiera.hpp"
#include "str/timpano.hpp"
#include "par/partitur.hpp"
#include "fig/accordo.hpp"
#include "pag/casellatxt.hpp"

// funzione di debug del milla
Bool WDebugMilla(void);

//Funzione per la chiamata della finestra di dialogo per l'editing delle note
Bool EditingNotesDlg(Nota *pNota, Battuta *currBat);

//Funzione per la chiamata della finestra di dialogo per l'editing delle pause
Bool EditingRestsDlg(Pausa *pPausa, Battuta *currBat);

//Funzione per la chiamata della finestra di dialogo per l'editing degli intervalli
Bool EditingIntervalsDlg(IntEsteso *pIntEsteso);

//Funzione per la chiamata della finestra di dialogo per l'editing delle barre
//Bool EditingBarlinesDlg(Barra *pBarra);

//Funzione per la chiamata della finestra di dialogo per l'editing dei marker
Bool EditingMarkersDlg(DrawObject *pDrawObject);

//Funzione per la chiamata della finestra di dialogo per l'editing degli accordi
//Bool EditingChordsDlg(Accordo *pAccordo);

//Funzione per la chiamata della finestra di dialogo della traspozione
Bool TranspositionsDlg(int *clef,wxString *measures, int *translation, int *interval, int *up, int *part,int *staff, Partitura *pPart,Bool *sharps, Bool *adjust);

//Funzione per la chiamata della finestra di dialogo del check
Bool CheckLogDlg(Partitura *pPart);

//Funzione per la chiamata della finestra di dialogo del view layer
Bool ViewLayerDial(Spartito *pSPa);

//Funzione per la chiamata della finestra di dialogo per il Beaming
Bool BeamingDlg(Partitura *pPart, int *start, int *end , int *type, int *part, bool *forceUnbeaming);

//Funzione per la chiamata della finestra di dialogo per l'UpDown Stem
Bool UpDownDlg(Partitura *pPart, int *start, int *end , int *type, int *part);

//Funzione per la chiamata della finestra di dialogo per il Joining Part
Bool MutipleChoiceDial(int *parti, Partitura *pPartit, int n_items, wxString title="");

//Fuzione per la chiamata alla dialog MoveLayer
Bool MoveLayerDial(int &from, int &to, int numLay);

Bool InputGenericText(char* txt, int len, bool& hidden, Align& align, wxFont& font, bool& pos, bool canHide=false);

#endif