/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */



#include "gui/dlg/addpart.hpp"

#include "../wxr/addpart.wxr"
#include "../wxr/addpart.h"

#include "drw/frmanage.hpp"

BEGIN_EVENT_TABLE(AddPartDlg, wxDialog)
EVT_BUTTON(ID_OK_BUTT, AddPartDlg::OnOk)
EVT_BUTTON(ID_CANCEL_BUTT, AddPartDlg::OnCancel)
END_EVENT_TABLE()



AddPartDlg::AddPartDlg()
{
	input_partname		= NULL;
	okButton			= NULL;
	cancelButton		= NULL;
	comboBox			= NULL;
}

AddPartDlg::~AddPartDlg()
{
	if(input_partname !=NULL) 
		delete input_partname;
	if(okButton !=NULL) 
		delete okButton;
	if(cancelButton !=NULL) 
		delete cancelButton;
	if(comboBox !=NULL)
		delete comboBox;
}


bool AddPartDlg::Initialize()
{
	wxResourceParseData(add_part);
	if (LoadFromResource(FrameManager::currFrame, "add_part"))
	{
		input_partname		= (wxTextCtrl *)wxFindWindowByName("input_partname", this);
		okButton				= (wxButton *)wxFindWindowByName("ok_button", this);
		cancelButton			= (wxButton *)wxFindWindowByName("cancel_button", this);
		comboBox				= (wxComboBox *)wxFindWindowByName("choice_staves",this);
		comboBox->SetSelection(0);
		return TRUE;
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, NULL);
		return FALSE;
	}
	
}

void AddPartDlg::OnOk(wxCommandEvent& event)
{
	EndModal(wxID_OK);
}

void AddPartDlg::OnCancel(wxCommandEvent& event)
{
	EndModal(wxID_CANCEL);
}

wxString AddPartDlg::GetNewPartName()
{
	return input_partname->GetValue();
}


short AddPartDlg::GetNumberOfStaff()
{
	return comboBox->GetSelection()+1;
}
