/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */



#include "wx/wx.h"
#include "wx/dialog.h"
#include "wx/resource.h"
#include "wx/utils.h"
#include "drw/frmanage.hpp"
#include "spa/spartito.hpp"

#include "lioo.hpp"
#include "wx/wxexpr.h"



class EditMeasureDlg : public wxDialog
{
protected:
	wxChoice *staff1, *staff2, *staff3, *timeSignatureStatus;
	wxCheckBox *mainPrintView, *mainCompView, *partPrintView, *partCompView;
	Spartito *psp;
	Battuta  *bat;
	
public:
	
	EditMeasureDlg();
	~EditMeasureDlg();
	
	void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
	
	int GetNStaff1();
	void SetNStaff1(int nstaff1);
	int GetNStaff2();
	void SetNStaff2(int nstaff2);
	int GetNStaff3();
	void SetNStaff3(int nstaff3);
	void DisableStaff(int staffnumber);
	void SetPsp(Spartito *pspart);
	void SetBat(Battuta *pbat);
	void Apply();
	void SetupLineBreaking();
	void EnableCheckBox(bool cb1,bool cb2,bool cb3,bool cb4);
	int  GetEnabledCheckBox();
	void SetTimeSignatureStatus(TimeSignatureStatus status);
	TimeSignatureStatus GetTimeSignatureStatus();
	
private:
	DECLARE_EVENT_TABLE()
};