/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/////////////////////////////////////////////////////////////////////////////
// Name:        ettmeasuredlg.hpp
// Purpose:     EttMeasureDlg
// Author:      Dario Baronti
// Modified by:
// Created:     
/////////////////////////////////////////////////////////////////////////////

#ifndef ETTMEASUREDLG_HPP
#define ETTMEASUREDLG_HPP

#include <wx/choice.h>
#include "wx/notebook.h"
#include "drw/frmanage.hpp"
#include "aud/audiosync.hpp"

enum EttDlg_States 
{
 INITIAL,  //otherwise
 CREATENEWITEM,  //user is creating a new item
 MODIFYITEM  //user is modifing a item
};


class EttMeasureDlg: public wxDialog
{
 protected:
   
	wxListBox *Item_lb;
	wxTextCtrl *From_tc;
	wxTextCtrl *To_tc;
	wxButton *New_b;
	wxButton *Save_b;
	wxButton *Delete_b;

	wxArrayString  *EttListAux;
	EttDlg_States CurrentState;
	AudioSyncWindow *SyncWindow;

 public:
   
	EttMeasureDlg(AudioSyncWindow *syncWindow);
	~EttMeasureDlg();

	void SetReadOnly();

	void TransferDataFromObject();

	bool InputDataValid();

	//DB
	void OnNew(wxCommandEvent& WXUNUSED(event));
	void OnDelete(wxCommandEvent& WXUNUSED(event));
	void OnText(wxCommandEvent& event);
	void OnSelect(wxCommandEvent& event);
	
	void OnOk(wxCommandEvent& event);	
	void OnCancel(wxCommandEvent& event);

	void StreamDataSync2Block();
	void Block2StreamDataSync();

	wxArrayString* GetEttListAux() {return EttListAux;}

    DECLARE_EVENT_TABLE()
};

#endif