/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#include "lioo.hpp"
#include "fonttabledlg.hpp"
#include "drw/rectangl.hpp"
#include "drw/musicedt.hpp" 
#include "liooext.hpp"
#include "fon/lioofont.hpp"


#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#if defined (__WXGTK__)
#include "../wxr/tablex.wxr"
#include "../wxr/tablex.h"
#endif


#if defined(__WXMSW__) 
#include "../wxr/tablew.wxr"
#include "../wxr/tablew.h"
#endif

#include "wx/resource.h"
#include "wx/font.h"
#include "drw/frmanage.hpp"

extern GScreen *Scr;

BEGIN_EVENT_TABLE(FontTableDlg, wxDialog)
EVT_BUTTON(ID_APPLY, FontTableDlg::OnUpdate)
EVT_BUTTON(ID_CONTROL119, FontTableDlg::OnCancel)
EVT_BUTTON(ID_BUTTON6001, FontTableDlg::OnOK)
EVT_LISTBOX(101, FontTableDlg::OnList)
EVT_CLOSE(FontTableDlg::OnCancel)
END_EVENT_TABLE()

int onlyone=false;

//        fontID puo' essere nMusicFont(0), nMusicFont2(1), nMusicFont3(2)
// oppure un font generico con ID da 5 in su
FontTableDlg::FontTableDlg(FontTable* fonttable,int fontID=1)
{
	onlyone=TRUE;
	WDFT = fonttable;
	font = fontID;
}

bool FontTableDlg::InitDlg()
{
	
	LastItem=-1;
	wxResourceParseData(tableedit); 
	
	if (LoadFromResource(FrameManager::currFrame, "tableedit"))
	{
		up_tc = (wxTextCtrl *)wxFindWindowByName("tc1", this);
		down_tc = (wxTextCtrl *)wxFindWindowByName("tc2", this);
		left_tc = (wxTextCtrl *)wxFindWindowByName("tc3", this);
		right_tc = (wxTextCtrl *)wxFindWindowByName("tc4", this);
		hor_tc = (wxTextCtrl *)wxFindWindowByName("tc5", this);
		ver_tc = (wxTextCtrl *)wxFindWindowByName("tc6", this);
		ShowBB_c = (wxCheckBox *)wxFindWindowByName("checkbox1", this);
		symblist_lb = new wxListBox( this, 101, wxPoint(12,25), wxSize(120,190), 0, NULL, wxLB_SORT, wxDefaultValidator, "symbol_list");
		Preview = new wxStaticBitmap(this,-1,wxBitmap(95,100),wxPoint(362,50));
		PreviewBox = (wxStaticBox *)wxFindWindowByName("staticbox1", this);
		
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, NULL);
		return FALSE;
	}
	
	//Changed by FM
	switch (font)
	{
	case 0:
		WDFT->LoadFile(MUSICFONT);
		break;
	case 1:
		WDFT->LoadFile(MUSICFONT2);
		break;
	case 2:
		WDFT->LoadFile(MUSICFONT3);
		break;
	default:
		// MariusG
		WDFT->LoadFile(Scr->lista_font[font]->GetNomeFont());
		break;
	};
	
//	wxColour mybcolor(0,0,255);
//	wxColour myfcolor(255,0,0);
	previewBitmap=new LPixmap(95,100);
	
	ShowBB_c->SetValue(True);
	TransferDataFromObject();
	
	SetModal(FALSE);
	return(true);
}


FontTableDlg::~FontTableDlg()
{
	if (up_tc!=NULL)
		up_tc -> Destroy();
	if (down_tc!=NULL)
		down_tc -> Destroy();
	if (left_tc!=NULL)
		left_tc -> Destroy();
	if (right_tc!=NULL)
		right_tc-> Destroy();
	if (hor_tc!=NULL)
		hor_tc -> Destroy();
	if (ver_tc!=NULL)
		ver_tc -> Destroy();
	if (symblist_lb!=NULL)
		symblist_lb -> Destroy(); 
	onlyone=false;
	delete WDFT;
}

void FontTableDlg::OnList(wxCommandEvent& WXUNUSED(event) )
{
	wxString str = "";
	int tmppos;
	
	// prima di visualizzare un'altro devo salvare quello di prima
	if (LastItem!=-1)
		TransferDataToObject(LastItem);
	
	tmppos = WDFT->GetCodefromPos(symblist_lb->GetSelection());
	
	str.Printf("%i", WDFT->GetUp(tmppos));
	up_tc->SetValue(str);
	
	str.Printf("%i", WDFT->GetDown(tmppos));
	down_tc->SetValue(str);
	
	str.Printf("%i", WDFT->GetLeft(tmppos));
	left_tc->SetValue(str);
	
	str.Printf("%i", WDFT->GetRight(tmppos));
	right_tc->SetValue(str);
	
	str.Printf("%i", WDFT->GetHor(tmppos));
	hor_tc->SetValue(str);
	
	str.Printf("%i", WDFT->GetVer(tmppos));
	ver_tc->SetValue(str);
	
	updatingpreview();
	
	LastItem=tmppos;
	
}



/*********************************************************/
void FontTableDlg::updatingpreview()
{
	int tmppos = WDFT->GetCodefromPos(symblist_lb->GetSelection());
	
	Point orig=Point(0,Scr->GetMaxPixY());
	extern wxMemoryDC *currMDC;
	Preview->Show();
	Scr->GSetPixmap(previewBitmap);
	Colore oldcol = Scr->GetColor();
    Scr->SetColor(BIANCO);
    Scr->Rect(class Rectangle(orig,orig+(Point(95,-100))*(1.0/Scr->GetMagnification())),TRUE);
    Scr->SetColor(NERO);
	
	int oldFont;
	switch (font)
    {
	case 0:
		{
			oldFont=Scr->SetFont(nMusicFont);
			break;
		}
	case 1:
		{
			oldFont=Scr->SetFont(nMusicFont2);
			break;
		}
	case 2:
		{
			oldFont=Scr->SetFont(nMusicFont3);
			break;
		}
	default:
		{
			oldFont=Scr->SetFont(font);
			break;
		}
	}
	Point centro=orig+Point(10,-60)*(1.0/Scr->GetMagnification());
	Point offset=Point(WDFT->GetHor(tmppos),WDFT->GetVer(tmppos));
	Scr->TextTo(centro);
	char code[2] = {0,0};
	code [1]=0;
	code[0]= WDFT->GetCode(tmppos);
	Scr->OutText((unsigned char *)code);
	Scr->SetFont(oldFont);
	
    if (ShowBB_c->GetValue())
    {
		centro=centro-offset;
		Scr->SetColor(BLU);
		Scr->Line(centro-Point(0,WDFT->GetDown(tmppos)+10),centro+Point(0,WDFT->GetUp(tmppos)+10),SOLID_LINE);
		Scr->Line(centro-Point(WDFT->GetLeft(tmppos)+10,0),centro+Point(WDFT->GetRight(tmppos)+10,0),SOLID_LINE);
		Scr->SetColor((ColorIcon)red);
		Scr->Line(centro-Point(WDFT->GetLeft(tmppos),WDFT->GetDown(tmppos)),centro+Point(WDFT->GetRight(tmppos),-WDFT->GetDown(tmppos)),SOLID_LINE);
		Scr->Line(centro-Point(WDFT->GetLeft(tmppos),WDFT->GetDown(tmppos)),centro+Point(-WDFT->GetLeft(tmppos),WDFT->GetUp(tmppos)),SOLID_LINE);
		Scr->Line(centro+Point(WDFT->GetRight(tmppos),WDFT->GetUp(tmppos)),centro+Point(WDFT->GetRight(tmppos),-WDFT->GetDown(tmppos)),SOLID_LINE);
		Scr->Line(centro+Point(WDFT->GetRight(tmppos),WDFT->GetUp(tmppos)),centro+Point(-WDFT->GetLeft(tmppos),WDFT->GetUp(tmppos)),SOLID_LINE);
	}
	Scr->SetColor(oldcol);
	Scr->GResetPixmap();
	
	if(currMDC!=NULL)
		currMDC->SelectObject(wxNullBitmap);
	Preview->SetBitmap(*(wxBitmap*)previewBitmap->GetPixmap());
	Preview->Refresh(); 
	
}

/*********************************************************/
void FontTableDlg::OnUpdate(wxCommandEvent& WXUNUSED(event) )
{ 
	// in realta dovrebbe essere OnSave ma visto che il pulsante si chiama UPDATE 
	Update();
	
	updatingpreview();
}

/*********************************************************/
void FontTableDlg::Update()
{
	extern wxMusicEditor *MusicEditor;
	
	TransferDataToObject(LastItem);
	//Changed by FM
	switch (font)
	{
	case 0:
		WDFT->SaveFile(MUSICFONT);
		Scr->UpdateFont(MUSICFONT_ID);
		break;
	case 1:
		WDFT->SaveFile(MUSICFONT2);
		Scr->UpdateFont(MUSICFONT2_ID);
		break;
	case 2:
		WDFT->SaveFile(MUSICFONT3);
		Scr->UpdateFont(MUSICFONT3_ID);
		break;
	default:
		WDFT->SaveFile(Scr->lista_font[font]->GetNomeFont());
		Scr->UpdateFont(font);
		break;
	};
	
	MusicEditor->RedrawViews(0,true);
}

void FontTableDlg::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
	onlyone=FALSE;
	Destroy();
}

void FontTableDlg::OnOK(wxCommandEvent& WXUNUSED(event) )
{
	Update();
	onlyone=FALSE;
	Destroy();
}

void FontTableDlg::SetReadOnly()
{
}

void FontTableDlg::TransferDataToObject(int LastIt)
{
	
	long up;
	up_tc->GetValue().ToLong(&up);
	WDFT->SetUp(LastIt,(int)up);
	
	long down;
	down_tc->GetValue().ToLong(&down);
	WDFT->SetDown(LastIt,(int)down);
	
	long left;
	left_tc->GetValue().ToLong(&left);
	WDFT->SetLeft(LastIt,(int)left);
	
	long right;
	right_tc->GetValue().ToLong(&right);
	WDFT->SetRight(LastIt,(int)right);
	
	long hor;
	hor_tc->GetValue().ToLong(&hor);
	WDFT->SetHor(LastIt,(int)hor);
	
	long ver;
	ver_tc->GetValue().ToLong(&ver);
	WDFT->SetVer(LastIt,(int)ver);
	
}

void FontTableDlg::TransferDataFromObject()
{	
	int idx=0;
	
	for (idx=0;idx<256;idx++)
		if ((WDFT->GetCode(idx)!=0) && (((WDFT->GetName(idx))[0])!='*'))
			symblist_lb->Append(WDFT->GetName(idx));
		for (idx=0;idx<256;idx++)
			if ((WDFT->GetCode(idx)!=0) && (((WDFT->GetName(idx))[0])!='*'))
				WDFT->SetPos(WDFT->GetCode(idx),symblist_lb->FindString(WDFT->GetName(idx)));			
}


bool EditFontTable(int fontID)
{
	if (onlyone) 
		return false;

	FontTable* fontTable=new FontTable;
	FontTableDlg* dialog = new FontTableDlg(fontTable,fontID);
	if (dialog==NULL) 
	{ 
		onlyone=FALSE;
		return FALSE;
	}
	
	dialog->InitDlg();
	
	dialog->Centre();
	if(dialog->Show(TRUE))
	{
		return TRUE;
	}
	else 
		return FALSE;
	
}