/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#ifndef TABLEDLG_HPP
#define TABLEDLG_HPP

#include "smrdlg.hpp"
#include "fon/fonttable.hpp"
#include "drw/rectangl.hpp"
class Rectangle;

class FontTableDlg: public wxDialog
{
 protected:
	
	FontTable *WDFT;
	int font;

	wxCheckBox *ShowBB_c;
	wxTextCtrl *up_tc;
	wxTextCtrl *down_tc;
	wxTextCtrl *left_tc;
	wxTextCtrl *right_tc;
	wxTextCtrl *hor_tc;
	wxTextCtrl *ver_tc;
	wxListBox *symblist_lb;
	wxStaticBox *PreviewBox;
	wxStaticBitmap *Preview;
	wxStaticBitmap *Preview1;
	LPixmap *previewBitmap;
	int LastItem;
 public:
	FontTableDlg(FontTable* fonttable,int fontID);
	~FontTableDlg();

	void SetReadOnly();

//	bool InputDataValid();

	void TransferDataToObject(int LastIt);
	void TransferDataFromObject();
	void Update();
	bool InitDlg();

	void OnUpdate(wxCommandEvent& event);
	void OnOK(wxCommandEvent& event);
	void updatingpreview();
	void OnCancel(wxCommandEvent& event);
	void OnList(wxCommandEvent& event);

    DECLARE_EVENT_TABLE()
};

bool EditFontTable(int fontID);

#endif