/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#include "wx/wx.h"
#include "wx/string.h"
#include "gui/dlg/linkdlg.hpp"

/*
#include "../wxr/linkoption.wxr"	
#include "../wxr/linkoption.h"

BEGIN_EVENT_TABLE(WdfLinkOptionDlg, wxDialog)
EVT_BUTTON(ID_ONOK, WdfLinkOptionDlg::OnOk)
EVT_BUTTON(ID_ONCANCEL, WdfLinkOptionDlg::OnCancel)
END_EVENT_TABLE()

WdfLinkOptionDlg::WdfLinkOptionDlg(int type)
{	
	wxResourceParseData(linkoption);
#ifndef WDFEDONLY
	if (LoadFromResource(FrameManager::currFrame, "linkoption"))
#else
	if (LoadFromResource(NULL, "linkoption"))
#endif
		choice=(wxRadioBox *)wxFindWindowByName("choice",this);
	else
		wxMessageBox("Error loading resources z!","Error!", wxOK | wxICON_EXCLAMATION, NULL);
#ifdef wx226
	if(type==1)
		choice->SetLabel(type, "Symbolic Viewer");
#endif		
}

WdfLinkOptionDlg::~WdfLinkOptionDlg()
{
	if(choice!=NULL)
		delete choice;
}



void WdfLinkOptionDlg::OnOk(wxCommandEvent& event)
{
	EndModal(wxID_OK);
}

void WdfLinkOptionDlg::OnCancel(wxCommandEvent& event)
{
	EndModal(wxID_CANCEL);
}

int WdfLinkOptionDlg::GetChoice()
{
	return(choice->GetSelection());
}
*/

#include "../wxr/linkoption3.wxr"
#include "../wxr/linkoption3.h"

BEGIN_EVENT_TABLE(LinkOption, wxDialog)
EVT_BUTTON(ID_ONOK, LinkOption::OnOk)
EVT_BUTTON(ID_ONCANCEL, LinkOption::OnCancel)
EVT_RADIOBUTTON(ID_RADIOBUTTON107,LinkOption::OnSwitch1)
EVT_RADIOBUTTON(ID_RADIOBUTTON108,LinkOption::OnSwitch2)
EVT_COMBOBOX(ID_COMBOBOX6001,LinkOption::OnCombo)	
END_EVENT_TABLE()

LinkOption::LinkOption()
{	
	wxResourceParseData(linkoption2);
	if (LoadFromResource(FrameManager::currFrame, "linkoption2"))
	{	
		choice=(wxRadioButton *)wxFindWindowByName("choice",this);
		choice2=(wxRadioButton *)wxFindWindowByName("choice2",this);
		choice3=(wxComboBox *)wxFindWindowByName("choice3",this);
		extlink=(wxTextCtrl *)wxFindWindowByName("extlink",this);
		intlink=(wxListBox *)wxFindWindowByName("intlink",this);
		choice->SetValue(true);

		LoadItems();
	}
	else
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, NULL);
}


LinkOption::~LinkOption()
{
	if(choice!=NULL)
		delete choice;
	if(choice2!=NULL)
		delete choice2;
}



void LinkOption::OnOk(wxCommandEvent& event)
{
	EndModal(wxID_OK);
}

void LinkOption::OnCancel(wxCommandEvent& event)
{
	EndModal(wxID_CANCEL);
}

bool LinkOption::GetChoice()	// Ritorna true se e' stato premuto lo switch 1, false se e' stato premuto lo switch 2 	
{
	return(choice->GetValue()); 
}

wxString LinkOption::GetLink()		      // Ritorna il link esterno contenuto nella dialog
{
	return (extlink->GetValue());
} 

void LinkOption::SetLink(wxString link)  // Assegna il link esterno nella dialog
{
	extlink->SetValue(link);
}

void LinkOption::OnSwitch1()			// Seleziona lo switch 1 nella dialog
{
	choice->SetValue(true);
	choice2->SetValue(false);
	extlink->SetEditable(true);
}

void LinkOption::OnSwitch2()		   // Seleziona lo switch 2 nella dialog
{
	choice2->SetValue(true);
	choice->SetValue(false);
	extlink->SetEditable(false);
	
}

void LinkOption::OnCombo()				// Gestisce la selezione degli items del ComboBox
{
/*
	extern wxMusicEditor *MusicEditor;
	SMRItemList *items;
	items=MusicEditor->smrf->GetItemsListPtr();
	wxWDFItemListNode *node;
	if(GetChoice()==false)
	{
		if(choice3->GetStringSelection()=="Audio")
		{		
			intlink->Clear();
			node = items->GetFirst();			
			while (node)
			{			
				WDFTreeItemData *wdfitem = node->GetData();			
				if(wdfitem->GetType()==WDF_Audio)
					intlink->Append(wdfitem->GetItemDescription(),wdfitem);
				node = node->GetNext();
			}
			return;
		}
		if(choice3->GetStringSelection()=="Video")
		{	
			intlink->Clear();
			node = items->GetFirst();			
			while (node)
			{			
				WDFTreeItemData *wdfitem = node->GetData();			
				if(wdfitem->GetType()==WDF_Video)
					intlink->Append(wdfitem->GetItemDescription(),wdfitem);
				node = node->GetNext();
			}
			return;
		}
		if(choice3->GetStringSelection()=="Images")
		{	
			intlink->Clear();
			node = items->GetFirst();			
			while (node)
			{			
				WDFTreeItemData *wdfitem = node->GetData();			
				if(wdfitem->GetType()==WDF_Images)
					intlink->Append(wdfitem->GetItemDescription(),wdfitem); 
				node = node->GetNext();
			}
			return;
		}
	}
*/
}

int LinkOption::GetSelected()			// Ritorna l'item selezionato nel ComboBox
{
	return (choice3->GetSelection());
}

void LinkOption::AppendItem(wxString item,void* data)	// Inserisce un item nel ListBox
{
	intlink->Append(item,data);
}

void* LinkOption::GetDataSelected()		// Ritorna il puntatore all'informazione associata all'item del ListBox
{	
	if(intlink->GetSelection()!=-1)
		return (intlink->GetClientData(intlink->GetSelection()));
	else return(NULL);
}

void LinkOption::SetSelected(wxString item)		// Seleziona un elemento del ComboBox
{
	int n = choice3->FindString(item);
	choice3->SetSelection(n);
}

void LinkOption::LoadItems()
{
/*
	bool audio=true,video=true,documents=true,images=true,performance=true;
	extern wxMusicEditor *MusicEditor;
	SMRItemList *items;
	items=MusicEditor->smrf->GetItemsListPtr();
	for ( SMRItemList::Node *node = items->GetFirst(); node; node = node->GetNext() )
	{
		WDFTreeItemData *current = node->GetData();
		switch(current->GetType())
		{
		case WDF_Audio:
			if(audio)
			{
				choice3->Append("Audio");
				audio=false;
			}
			break;
		case WDF_Video:
			if(video)
			{
				choice3->Append("Video");
				video=false;
			}
			break;
		case WDF_Documents:
			if(documents)
			{
				choice3->Append("Documents");
				documents=false;
			}
			break;
		case WDF_Images:
			if(images)
			{
				choice3->Append("Images");
				images=false;
			}
			break;
		case WDF_Performance:
			if(performance)
			{
				if(((ExecWF*)current)->GetSyncType() == SlideShow)
				{
					choice3->Append("Performance");
					performance=false;
				}
			}
			break;
		}
	}
*/
}

