/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#ifndef LINKDLG_HPP
#define LINKDLG_HPP

#include "wx/wx.h"
#include "wx/dialog.h"
#include "wx/resource.h"
#include "wx/utils.h"

#include "drw/frmanage.hpp"
#include "lioo.hpp"

/*
class WdfLinkOptionDlg : public wxDialog
{
protected:
	wxRadioBox *choice;

public:

	WdfLinkOptionDlg(int type=0);
	~WdfLinkOptionDlg();

	void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
	int GetChoice();

private:
	DECLARE_EVENT_TABLE()
};
*/

class LinkOption : public wxDialog
{
protected:
	wxRadioButton *choice;
	wxRadioButton *choice2;
	wxComboBox *choice3;
	wxTextCtrl *extlink;
	wxListBox  *intlink;


public:

	LinkOption();
	~LinkOption();

	void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
	bool GetChoice();					    // Ritorna quale RadioButton e' stato selezionato
	wxString GetLink(); 
    void SetLink(wxString link);
	void OnSwitch1();				        // Gestisce la selezione del RadioButton1
	void OnSwitch2();						// Gestisce la selezione del RadioButton2
	int GetSelected();								// Ritorna la selezione del ComboBox
	void SetSelected(wxString item);
	void AppendItem(wxString item,void* data=NULL);	// Inserisce un elemento nel ListBox
	void OnCombo();									// Gestisce la selezione di un elemento del ComboBox
	void* GetDataSelected();						// Ritorna il puntatore alle informazioni associate all'elemento cliccato del ListBox
	void LoadItems();
private:
	DECLARE_EVENT_TABLE()
};

#endif