/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#include "wx/wx.h"
#include "wx/dialog.h"
#include "wx/resource.h"
#include "drw/frmanage.hpp"
#include "lioo.hpp"



#if defined (__WXGTK__)
#include "../wxr/movelayerdialog.wxr"
#include "../wxr/movelayerdialog.h"
#endif

#if defined(__WXMSW__)
#include "../wxr/movelayerdialog.wxr"
#include "../wxr/movelayerdialog.h"

#endif





class MoveLayerDlg :public wxDialog
{
protected:
   	
	wxComboBox	*list1, *list2;
	
	
	
public:	
	MoveLayerDlg(int layerNum);
	//Costruttore
	
	~MoveLayerDlg();
	//Distruttore
	
	
	void OnOk(wxCommandEvent& event);
    
	void OnClose(wxCommandEvent& event);
	//Metodo per la chiusura e la distruzione della finestra
	void GetData(int &from, int &to);
	
	
	
	
	
private:
    DECLARE_EVENT_TABLE()
};




BEGIN_EVENT_TABLE(MoveLayerDlg, wxDialog)

EVT_BUTTON(ID_BUTTONCANCEL, MoveLayerDlg::OnClose)
EVT_BUTTON(ID_BUTTONOK, MoveLayerDlg::OnOk)
EVT_CLOSE(MoveLayerDlg::OnClose)	

END_EVENT_TABLE()



MoveLayerDlg::MoveLayerDlg(int layerNum) 
{
	
	
	list1			= NULL;
	list2			= NULL;
	
	
	wxResourceParseData(MoveLayer); 
	if (LoadFromResource(FrameManager::currFrame, "MoveLayer"))
	{
		
		list1					= (wxComboBox *)wxFindWindowByName("list1", this);
		list2					= (wxComboBox *)wxFindWindowByName("list2", this);
		
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, NULL);
	}
	
	
	wxString msg;
	
	for(int i=0; i<layerNum; i++)
	{
		msg.sprintf("Layer %d",i+1);
		list1->Append(msg);
		list2->Append(msg);
	}
	
	list1->SetSelection(0);
	list2->SetSelection(0);
	
	
}

MoveLayerDlg::~MoveLayerDlg()
{
	
	if(list1!=NULL) 
		delete list1;
	
	if(list2 !=NULL) 
		delete list2;
	
}

void MoveLayerDlg::GetData(int &from, int &to)
{
	from=list1->GetSelection();
	
	to=list2->GetSelection();
}



void MoveLayerDlg::OnOk(wxCommandEvent& event)
{
	EndModal(wxID_OK);
}

void MoveLayerDlg::OnClose(wxCommandEvent& event)
{
	
	EndModal(wxID_CANCEL);
}







/************Funzione di chiamata alla dialog**************************/



Bool MoveLayerDial(int &from, int &to, int numLay)
{
	
	
	MoveLayerDlg dialog(numLay);
	dialog.Centre();
	if(dialog.ShowModal()==wxID_OK)
	{
		dialog.GetData(from, to);
		return TRUE;
	}
	else 
		return FALSE;
	
}