/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/////////////////////////////////////////////////////////////////////////////
// Name:        prinpdlg.hpp
// Purpose:     PrintParamsDlg
// Author:      Andrea Mati
// Modified by: Marius (quite all)
// Created:     
/////////////////////////////////////////////////////////////////////////////

#ifndef PRINPDLG_HPP
#define PRINPDLG_HPP

#include "wx/button.h"
#include "smrdlg.hpp"
#include "prt/prtpara.hpp"



class PrintParamsDlg: public SMRDialog
{
 protected:
    PrintParams *printParams;
	PrintParams MusicFingerParameters;
	int nPage,nStaff;
	bool IsMainScore;

	wxTextCtrl *TopMargin_tc;
	wxTextCtrl *BottomMargin_tc;
	wxTextCtrl *LeftMargin_tc;
	wxTextCtrl *RightMargin_tc;

	wxChoice *PageFormat_c;
	wxChoice *Printer_c;
	wxChoice *Magnification_c;
    wxTextCtrl *LineLength_tc;


	//wxTextCtrl *NumStaff_tc;
	wxTextCtrl *NumSystems_tc;
	wxTextCtrl *Distance_tc;
	wxCheckBox *InsPageNum_c;
	wxCheckBox *InsTitle_c;
	//wxCheckBox *Braille_c;

	wxButton *Fing_b, *Calculate_b;

 public:
    PrintParamsDlg(formality_type formality, PrintParams* printp, int page, int nstaff, bool ismainscore,
                      wxWindow* parent = NULL, const wxWindowID id = -1, 
		              const wxString& title = "Print Parameters", 
                      const wxPoint& pos = wxPoint(-1,-1),
                      const wxSize& size = wxSize(-1,-1), 
			          const long windowStyle = wxDEFAULT_DIALOG_STYLE,
                      const wxString& name = "dialogBox",
                      structure_type structure = singlePanel);
	~PrintParamsDlg();

	void SetReadOnly();

    bool InputDataValid();
    //Nothing

	void TransferDataFromObject();
  	//Show information of the associated object in the dialog

	void TransferDataToObject();
	//Save data of the dialog in the associated object

	void OnFing();
	void OnBraille();

	PrintParams GetMusicFingerParameters() { return MusicFingerParameters; };
	void SetMusicFingerParameters(PrintParams MFP) { MusicFingerParameters = MFP; };

	void OnCalculateStaffDistance();

    DECLARE_EVENT_TABLE()
};


bool EditPrintParams(formality_type formality, PrintParams *printp, int nPage, int nStaff, bool isMainScore, wxWindow* parent);
//Open a PrintParamsDlg for view or edit(formality readonly or read/write) the information 
//of the object printp. It's call from 'WDFPrintRDlg::OnParameters'


#endif