/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/////////////////////////////////////////////////////////////////////////////
// Name:        prinpdlg.hpp
// Purpose:     PrintParamsDlg
// Author:      Marius
// Modified by:  
// Created:     08.2000
/////////////////////////////////////////////////////////////////////////////

#ifndef PRINPDLG_HPP
#define PRINPDLG_HPP

#include "wx/button.h"
#include "smrdlg.hpp"
#include "prt/prtpara.hpp"

class FingerParamsDlg: public SMRDialog
{
 protected:

    PrintParams *printParams;
	wxButton *Add_b;
	wxButton *AddText_b;
	wxButton *Del_b;
	wxListBox *Finger_lb;
	wxListBox *Docs_lb;
	wxRadioBox *WdfType_r;


 public:
    FingerParamsDlg(formality_type formality, PrintParams* printp, 
                      wxWindow* parent = NULL, const wxWindowID id = -1, 
		              const wxString& title = "Print Parameters Fingerprint", 
                      const wxPoint& pos = wxPoint(-1,-1),
                      const wxSize& size = wxSize(-1,-1), 
			          const long windowStyle = wxDEFAULT_DIALOG_STYLE,
                      const wxString& name = "dialogBox",
                      structure_type structure = singlePanel);
	~FingerParamsDlg();

	void SetReadOnly();

    bool InputDataValid();
    //Nothing

	void TransferDataFromObject();
  	//Show information of the associated object in the dialog

	void TransferDataToObject();
	//Save data of the dialog in the associated object

	void OnAdd();
	void OnDel();
	void OnAddText();

    DECLARE_EVENT_TABLE() 
};


bool EditFingerParams(formality_type formality, PrintParams& printp, wxWindow* parent);
//Open a FingerParamsDlg for view or edit(formality readonly or read/write) the information 
//of the object printp. It's call from 'PrintParamsDlg::OnFing()'


#endif