/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: extabil.cpp,v 1.1 2005/07/25 16:30:54 bellinpo Exp $ */


#include "lioo.hpp"
#include "gui/extabil.hpp"

ExtLiooAbil::ExtLiooAbil()
{
	// DRW
	Del[CL_DRAWOBJECT]=ABIL_LAST;
	Del[CL_RETTANGOLO]=ABIL_LAST;
	Del[CL_TEXT]=ABIL_LAST;
	Del[CL_BUTTON]=ABIL_LAST;
	Del[CL_MENU]=ABIL_LAST;
	Del[CL_WINDOW]=ABIL_LAST;
	Del[CL_TNUMERICO]=ABIL_LAST;
	Del[CL_TEXTIO]=ABIL_LAST;
	// SPA
	Del[CL_PENTAGRAMMA]=ABIL_LAST;
	Del[CL_SPARTITO]=ABIL_PARTE;                  // da rivedere
	// ALT
	Del[CL_DOPPIODIESIS]=ABIL_MODIFICA;
	Del[CL_DOPPIOBEMOLLE]=ABIL_MODIFICA;
	Del[CL_DIESIS]=ABIL_MODIFICA;
	Del[CL_DIESIS1Q]=ABIL_MODIFICA;
	Del[CL_DIESIS3Q]=ABIL_MODIFICA;
	Del[CL_BEMOLLE]=ABIL_MODIFICA;
	Del[CL_BEMOLLE1Q]=ABIL_MODIFICA;
	Del[CL_BEMOLLE3Q]=ABIL_MODIFICA;
	Del[CL_BEQUADRO]=ABIL_MODIFICA;
	// BAT
	Del[CL_BATTUTA]=ABIL_BATTUTA;
	Del[CL_INTESTAZIONE]=ABIL_BATTUTA;
	Del[CL_ARMATURACHIAVE]=ABIL_BATTUTA;
	Del[CL_TEMPO]=ABIL_BATTUTA;
	
	Del[CL_CVIOLINO]=ABIL_BATTUTA;
	Del[CL_CBASSO]=ABIL_BATTUTA;
	Del[CL_CBARITONO]=ABIL_BATTUTA;
	Del[CL_CTENORE]=ABIL_BATTUTA;
	Del[CL_CTENORE8]=ABIL_BATTUTA;
	Del[CL_CCONTRALTO]=ABIL_BATTUTA;
	Del[CL_CMEZZOSOPRANO]=ABIL_BATTUTA;
	Del[CL_CSOPRANO]=ABIL_BATTUTA;
	Del[CL_CVIOLINO8]=ABIL_BATTUTA;
	Del[CL_CVIOLINO8SOPRA]=ABIL_BATTUTA;
	Del[CL_CBASSO8]=ABIL_BATTUTA;
	Del[CL_CBASSO8SOPRA]=ABIL_BATTUTA;
	Del[CL_CTAB]=ABIL_BATTUTA;
	Del[CL_CPERCUSBOX]=ABIL_BATTUTA;
	Del[CL_CPERCUS2LINES]=ABIL_BATTUTA;
	Del[CL_CVUOTA]=ABIL_BATTUTA;
	Del[CL_CBASSOOLD]=ABIL_BATTUTA;
	Del[CL_BSINGOLA]=ABIL_BATTUTA;
	Del[CL_BDOPPIA]=ABIL_BATTUTA;
	Del[CL_BFINALE]=ABIL_BATTUTA;
	Del[CL_BINIZIORIT]=ABIL_BATTUTA;
	Del[CL_BFINERIT]=ABIL_BATTUTA;
	Del[CL_BINIZIOFINERIT]=ABIL_BATTUTA;
	//BRA
	Del[CL_PARGRAFFA]=ABIL_PARTE;
	Del[CL_PARQUADRA]=ABIL_PARTE;
	// FIG
	Del[CL_FIGURA]=ABIL_MODIFICA;
	Del[CL_PAUSA]=ABIL_MODIFICA;
	Del[CL_PQUATTROBATTUTE]=ABIL_MODIFICA;
	Del[CL_PDUEBATTUTE]=ABIL_MODIFICA;
	Del[CL_PSEMIBREVE]=ABIL_MODIFICA;
	Del[CL_PMINIMA]=ABIL_MODIFICA;
	Del[CL_PSEMIMINIMA]=ABIL_MODIFICA;
	Del[CL_PCROMA]=ABIL_MODIFICA;
	Del[CL_PSEMICROMA]=ABIL_MODIFICA;
	Del[CL_PBISCROMA]=ABIL_MODIFICA;
	Del[CL_PSEMIBISCROMA]=ABIL_MODIFICA;
	Del[CL_PFUSA]=ABIL_MODIFICA;
	Del[CL_PGENERICA]=ABIL_MODIFICA;
	Del[CL_SPAZIO]=ABIL_MODIFICA;
	Del[CL_NOTA]=ABIL_MODIFICA;
	Del[CL_NBREVE]=ABIL_MODIFICA;
	Del[CL_NSEMIBREVE]=ABIL_MODIFICA;
	Del[CL_NMINIMA]=ABIL_MODIFICA;
	Del[CL_NSEMIMINIMA]=ABIL_MODIFICA;
	Del[CL_NCROMA]=ABIL_MODIFICA;
	Del[CL_NSEMICROMA]=ABIL_MODIFICA;
	Del[CL_NBISCROMA]=ABIL_MODIFICA;
	Del[CL_NSEMIBISCROMA]=ABIL_MODIFICA;
	Del[CL_NFUSA]=ABIL_MODIFICA;
	Del[CL_GRUPPONOTE]=ABIL_MODIFICA;
	Del[CL_ACCORDO]=ABIL_MODIFICA;
	Del[CL_RIPTEMPO]=ABIL_MODIFICA;
	Del[CL_RIPBATTUTA]=ABIL_MODIFICA;
	Del[CL_RIPMEZZABATTUTA]=ABIL_MODIFICA;
	// INT
	Del[CL_LEGATURA_VALORE]=ABIL_MODIFICA;
	Del[CL_LEGATURA_QUADRA]=ABIL_MODIFICA;
	Del[CL_LEGATURA]=ABIL_LEGATURA;
	Del[CL_SILLABA]=ABIL_SILLABA;
	Del[CL_FORCELLA]=ABIL_FORCELLA;
	Del[CL_MODIFICA_OTTAVA]=ABIL_OTTAVA;
	Del[CL_CAMBIO_RITORNELLO]= ABIL_CAMBIORIT;
	Del[CL_ONDA]=ABIL_ONDA;
	Del[CL_FRECCIA]=ABIL_ONDA;
	// VAR
	Del[CL_CORONA]=ABIL_CORONA;
	Del[CL_OCCHIALI]=ABIL_OCCHIALI;
	Del[CL_PUNTOVALORE]=ABIL_MODIFICA;
	Del[CL_PRFIATO]=ABIL_PRFIATO;
	Del[CL_ARPEGGIO]=ABIL_ABBELLIM;
	Del[CL_SUDDIVISIONE]=ABIL_SUDDIVIS;
	// IND
	Del[CL_ARCOGIU]=ABIL_VIOLINO;
	Del[CL_ARCOSU]=ABIL_VIOLINO;
	Del[CL_ARCO]=ABIL_VIOLINO;
	Del[CL_PIZZICATO]=ABIL_VIOLINO;
	Del[CL_CORDAVUOTA]=ABIL_VIOLINO;
	Del[CL_STACCATO]=ABIL_ACCENTI;
	Del[CL_TENUTO]=ABIL_ACCENTI;
	Del[CL_MARTELLATO]=ABIL_ACCENTI;
	Del[CL_ACCENTO]=ABIL_ACCENTI;
	
	
	Del[CL_SFORZATO]=ABIL_ACCENTI;
	Del[CL_MARTDOLCE]=ABIL_ACCENTI;
	Del[CL_PUNTOALLUNGATO]=ABIL_ACCENTI;
	Del[CL_ESPGENERIC]=ABIL_ACCENTI;
	
	
	Del[CL_DITEGGIATO]=ABIL_DITEGGIATO;
	Del[CL_CONSORDINAOTTONI]=ABIL_SORDINA;
	Del[CL_CONSORDINAARCHI]=ABIL_SORDINA;
	Del[CL_CONSORDINATESTO]=ABIL_SORDINA;
	Del[CL_VIASORDINAOTTONI]=ABIL_SORDINA;
	Del[CL_VIASORDINAARCHI]=ABIL_SORDINA;
	Del[CL_VIASORDINATESTO]=ABIL_SORDINA;
	
	
	Del[CL_ARMONICIARCHI]=ABIL_SORDINA;
	Del[CL_ARMONICIOTTONI]=ABIL_SORDINA;
	
	
	// ABB
	Del[CL_TRILLO]=ABIL_ABBELLIM;
	Del[CL_TREMOLO]=ABIL_ABBELLIM;
	Del[CL_MINFERIORE]=ABIL_ABBELLIM;
	Del[CL_MSUPERIORE]=ABIL_ABBELLIM;
	Del[CL_GINFERIORE]=ABIL_ABBELLIM;
	Del[CL_GSUPERIORE]=ABIL_ABBELLIM;
	Del[CL_GSLASH]=ABIL_ABBELLIM;
	Del[CL_GUP]=ABIL_ABBELLIM;
	// STR
	Del[CL_PUNTA]=ABIL_VIOLINO;
	Del[CL_TALLONE]=ABIL_VIOLINO;
	Del[CL_TASTIERA]=ABIL_VIOLINO;
	Del[CL_PONTICELLO]=ABIL_VIOLINO;
	Del[CL_CORDA]=ABIL_VIOLINO;
	Del[CL_TIMPANO]=ABIL_TIMPANO;
	// TXT
	Del[CL_TDINAMICO]=ABIL_TDINAMICO;
	Del[CL_TGENERICO]=ABIL_TGENERICO;
	Del[CL_ANNOTAZIONE]=ABIL_ANNOTAZDIR;
	// SCA
	Del[CL_NUMBATTUTA]=ABIL;
	Del[CL_NUMUGUALE]=ABIL;
	Del[CL_NUMPAUSA]=ABIL_MODIFICA;
	Del[CL_TSALTO]=ABIL_MOVIMENTO;
	Del[CL_LETTERA]=ABIL_MOVIMENTO;
	Del[CL_SCANSIONE]=ABIL_MOVIMENTO;
	Del[CL_TMOVIMENTO]=ABIL_MOVIMENTO;
	Del[CL_METRONOMO]=ABIL_MOVIMENTO;
	Del[CL_MOVIMENTO]=ABIL_MOVIMENTO;
	//KOR
	Del[CL_SLIDINGUP]=ABIL_KOREANORN;
	Del[CL_SLIDINGDOWN]=ABIL_KOREANORN;
	Del[CL_SLIDINGDUP]=ABIL_KOREANORN;
	Del[CL_SLIDINGDOWNUP]=ABIL_KOREANORN;
	Del[CL_NONGHYNINC]=ABIL_KOREANORN;
	Del[CL_NONGHYNDEC]=ABIL_KOREANORN;
	Del[CL_NONGHYNARROW]=ABIL_KOREANORN;
	Del[CL_NONGHYNWIDE]=ABIL_KOREANORN;

};



// restituisce l'abilitazione per l'oggetto di classe ClassID 
int ExtLiooAbil::GetDelAbil(ClassID classobj)
{
	return (isAbil(Del[classobj]));
	
}


// settaggio delle abilitazioni

int ExtLiooAbil::LoadFromString(char *str)
{
	
	// settagggio dei valori impostati con il NetStart
	int set;
	set=LiooAbil::LoadFromString(str);
	// settaggio dell'interfaccia per i menu' padre dei diversi menu completamente disabilitabili
	setAbil(ABIL_TESTI_PRINC,(AbilVal)((isAbil(ABIL_TDINAMICO)) || (isAbil(ABIL_TGENERICO))
		|| (isAbil(ABIL_ANNOTAZDIR))));
	setAbil(ABIL_ARTICOL_PRINC,(AbilVal)((isAbil(ABIL_TESTI_PRINC)) || (isAbil(ABIL_ACCENTI))
		|| (isAbil(ABIL_ABBELLIM)) || (isAbil(ABIL_CORONA))
							 || (isAbil(ABIL_SUDDIVIS)) || (isAbil(ABIL_KOREANORN))));
	setAbil(ABIL_CHIAVI_PRINC,(AbilVal)((isAbil(ABIL_INTESTAZ)) || (isAbil(ABIL_BATTUTA))
		|| (isAbil(ABIL_PARTE))));
	setAbil(ABIL_STRUM_PRINC,(AbilVal)((isAbil(ABIL_DITEGGIATO)) || (isAbil(ABIL_SORDINA))
		|| (isAbil(ABIL_PRFIATO)) || (isAbil(ABIL_SAX)) 
		|| (isAbil(ABIL_OCCHIALI)) || (isAbil(ABIL_TIMPANO)) 
							 || (isAbil(ABIL_OBOE))));
	
	setAbil(ABIL_INTERV_PRINC,(AbilVal)((isAbil(ABIL_LEGATURA)) || (isAbil(ABIL_FORCELLA))
		|| (isAbil(ABIL_OTTAVA)) || (isAbil(ABIL_ONDA)) 
							 || (isAbil(ABIL_CAMBIORIT))));
	
	return(set);
};

