/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/*
 ***************************************************************************
 *
 *
 *	Finestra con pulsanti e listbox per selezionare la armatura chiave
 *
 *
 ***************************************************************************
 */
/////////////////////////////////////

#if defined (__WXGTK__)
#include "./wxr/keysignaturexdialog.wxr"
#include "./wxr/keysignaturexdialog.h"
#endif

#if defined (__WXMSW__)
#include "./wxr/keysignaturewdialog.wxr"
#include "./wxr/keysignaturewdialog.h"
#endif

#include "gui/keysigndlg.hpp"
#include "wx/wx.h"
#include "wx/resource.h"
#include "../bat/def_bat.hpp"
#include "../drw/frmanage.hpp"

BEGIN_EVENT_TABLE(KeySignDlg, wxDialog)
  	EVT_BUTTON(ID_BUTTON108, KeySignDlg::OnOk)
	EVT_BUTTON(ID_BUTTON111, KeySignDlg::OnCancel)
END_EVENT_TABLE()

KeySignDlg::KeySignDlg()
{
}

KeySignDlg::~KeySignDlg()
{
	listaKS->Destroy();
}

bool KeySignDlg::InitDlg()
{
	wxResourceParseData(KeySignatureDialog);
	if (LoadFromResource(FrameManager::currFrame, "KeySignatureDialog"))
	{
		return true;
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return false;
	}
}


void KeySignDlg::OnOk(wxCommandEvent& WXUNUSED(event) )
{
  if(listaKS->GetSelection()>=0)
    EndModal(ID_BUTTON108);
}

void KeySignDlg::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
  EndModal(ID_BUTTON111);
}


tipoArmaturaChiave KeySignDlg::GetKeySignature()
{
  // devo definire un vettore locale
  // perche' le armatura visualizzate nella dialog non sono 
  //ordinate con il tipo enumerativo
  static tipoArmaturaChiave arms[30] = 
  {
    DOd_maggiore,
    FAd_maggiore,  
    SI_maggiore,
    MI_maggiore,
    LA_maggiore,
    RE_maggiore,
    SOL_maggiore,
    DO_maggiore,
    FA_maggiore,
    SIb_maggiore,
    MIb_maggiore,
    LAb_maggiore,
    REb_maggiore,
    SOLb_maggiore,
    DOb_maggiore,
    LAd_minore,
    REd_minore,
    SOLd_minore,
    DOd_minore,
    FAd_minore,
    SI_minore,
    MI_minore,
    LA_minore,
    RE_minore,
    SOL_minore,
    DO_minore,
    FA_minore,
    SIb_minore,
    MIb_minore,
    LAb_minore
  }; 
  
  if (InitDlg()==true)
  {
	  listaKS = (wxListBox *)wxFindWindowByName("Armat_lb", this);	
  }
  else
  {
	 listaKS = NULL; 
  }
  Centre(wxBOTH);
  
  if (ShowModal() == ID_BUTTON108) //bottone di OK
  {
	  return arms[listaKS->GetSelection()];	  
  }

return arms[0];	  
}
