/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: lioomenu.hpp,v 1.1 2005/07/25 16:30:56 bellinpo Exp $ */


#ifndef LIOOMENU_HPP
#define LIOOMENU_HPP

#define TITLE "MSLIOO"
#define VERSION "1.1"

#include "drw/scrobjec.hpp"

void About();

enum TipiSord 
{
	ARCHI = 0,
		OTTONI,
		TESTO 
};

enum TipiFinger 
{
	NOTROUNDED = 0,
		ROUNDED1,
		ROUNDED2 
};

enum TipiStrings
{
	NOTCIRCLED = 0,
		BRACKETS,
		CIRCLED1,
		CIRCLED2 
};


// prototypes

EventResult GoTop();
EventResult GoBottom();
EventResult GoForward();
EventResult GoBackward();
EventResult NetPiu5();
EventResult NetMeno5();
EventResult NetJump();
EventResult LogMenu();

EventResult CSeeLinkOp(bool view);
EventResult CEditLinkOp(bool view2);


EventResult NewOp();
EventResult LoadOp();
EventResult SaveACLOp();
EventResult LoadACLOp();
EventResult ImportOp();
//
EventResult EncodeOp();
EventResult DecodeOp();
//
EventResult PrintOp();
EventResult AboutOp();
EventResult HelpOp();

EventResult ExitOp();
EventResult LoadImgOp();
EventResult CDelSimboloOp();
EventResult CLayer();

EventResult CNBreveOp();
EventResult CNSemibreveOp();
EventResult CNMinimaOp();
EventResult CNSemiminimaOp();
EventResult CNCromaOp();
EventResult CNSemicromaOp();
EventResult CNBiscromaOp();
EventResult CNSemibiscromaOp();
EventResult CNFusaOp();
EventResult CGambo();
EventResult CAccordo();

EventResult VisSpaziOp();
EventResult CAltezza();
EventResult CQuattroBatOp();
EventResult CPBreveOp();
EventResult CPSemibreveOp();
EventResult CPMinimaOp();
EventResult CPSemiminimaOp();
EventResult CPCromaOp();
EventResult CPSemicromaOp();
EventResult CPBiscromaOp();
EventResult CPSemibiscromaOp();
EventResult CPFusaOp();
EventResult CPGenericaOp();
EventResult CSpazioOp();

EventResult CDiesis1QOp();
EventResult CDiesis3QOp();
EventResult CDiesisOp();
EventResult CBemolleOp();
EventResult CBemolle1QOp();
EventResult CBemolle3QOp();
EventResult CBequadroOp();
EventResult C2DiesisOp();
EventResult C2BemolleOp();
EventResult CBequadro1QOp();
EventResult CBequadro3QOp();
EventResult CParentesizzaAlterazOp();


EventResult C1PuntoOp();
EventResult C2PuntiOp();
EventResult C3PuntiOp();
EventResult CLegaturaValore();

EventResult CNota2NotinaOp();
EventResult CNotina2NotaOp();
EventResult CAcciaccaturaOp();

EventResult CNote2GruppoNoteOp();
EventResult CGruppoNote2NoteOp();
EventResult CTerzine();


EventResult CRipTempoOp();
EventResult CRipBattutaOp();
EventResult CRipMezzaBattutaOp();
EventResult CRipDoppiaBattutaOp();

EventResult CViolinoOp();
EventResult CViolino8Op();
EventResult CViolino8SopraOp();
EventResult CBassoOp();
EventResult CBasso8Op();
EventResult CBaritonoOp();
EventResult CTenoreOp();
EventResult CTenore8Op();
EventResult CContraltoOp();
EventResult CMezzoSopranoOp();
EventResult CSopranoOp();
EventResult CBasso8SopraOp();
EventResult CTabOp();
EventResult CPercusBoxOp();
EventResult CPercus2LinesOp();
EventResult CVuotaOp();
EventResult CBassoOldOp();

EventResult CArmChvOp();

EventResult SyncOp();

EventResult CBarraSingolaOp();
EventResult CBarraDoppiaOp();
EventResult CBarraFinaleOp();
EventResult CBarraInizioRitOp();
EventResult CBarraFineRitOp();
EventResult CBarraInizioFineRitOp();
EventResult CBarraInvisibileOp();

EventResult InsBatDopoOp();
EventResult InsBatPrimaOp();
EventResult CDelBattutaOp();
EventResult CDelColonnaBatOp();
EventResult CCopiaBattOp();
EventResult CIncollaBattOp();
EventResult CCheckBattOp();

EventResult CAddSpartitoOp();
EventResult CSetNameSpaOp();
EventResult CAddGraffaOp();
EventResult CAddQuadraOp();
EventResult CDelSpartito();

EventResult CMovimentoOp();

EventResult CAddLegaturaOp();
EventResult CAddForcellaCrescOp();
EventResult CAddForcellaDiminOp();
EventResult CModifOttOp();
EventResult CModifOttbaOp();
EventResult CModifQuindOp();
EventResult CModifQuindbaOp();
EventResult CFrecciaOp();
EventResult COndaOp();
EventResult CLegQuaOp();
EventResult CCambiaRitOp();
EventResult CBendOp();
EventResult CBeamOp();
EventResult CPedaleFinoAOp();
EventResult CTrilloOndaOp();

EventResult CLayerInterv();
EventResult CInsertTextOp();	
EventResult CInsertImageOp();	

EventResult CSillabaOp();

EventResult CSopra();
EventResult CCoronaOp();
EventResult CCoronaQuadOp();
EventResult CCoronaTriangOp();
EventResult CSuddivisioneOp();

EventResult CEspGenericOp();
EventResult CEspPrevGenericOp();
EventResult CEspNextGenericOp();

EventResult CStaccatoOp();
EventResult CAccentoOp();
EventResult CMartellatoOp();
EventResult CSforzatoOp();
EventResult CTenutoOp();
EventResult CPuntoAllOp();
EventResult CMartDolceOp();


EventResult CTremoloOp();
EventResult CGlissatoOp();
EventResult CTrilloOp();

EventResult CGSup1Op();
EventResult CGInf1Op();
EventResult CMSupOp();
EventResult CMInfOp();
EventResult CM2SupOp();
EventResult CM2InfOp();
EventResult CArpeggioOp();
EventResult CTurnSlashOp();
EventResult CTurnUpOp();
EventResult CGlissondaOp();
EventResult CArpeggioUpOp();
EventResult CArpeggioDownOp();

EventResult CSlidingUpOp();
EventResult CSlidingDownOp();
EventResult CSlidingDUpOp();
EventResult CSlidingDownUpOp();
EventResult CNonghynIncOp();
EventResult CNonghynDecOp();
EventResult CNonghynArrowOp();
EventResult CNonghynWideOp();

EventResult CTDinamico();
EventResult CtgenericOp();
EventResult CAnnotazioneOp();

EventResult COcchialiOp();
EventResult CPrFiatoOp();
EventResult CPedalDownOp();
EventResult CPedalUpOp();
static EventResult CTimpanoOp();
EventResult CChitarraOp();

EventResult CDito0Op();
EventResult CDito1Op();
EventResult CDito2Op();
EventResult CDito3Op();
EventResult CDito4Op();
EventResult CDito5Op();
EventResult CTipoFinger();
EventResult CDiteggiatoCircled();

EventResult CTipoSord();
EventResult CConSordinaOp();
EventResult CViaSordinaOp();
EventResult CArmoniciArchiOp();
EventResult CArmoniciOttoniOp();

EventResult CArcoOp();
EventResult CArcoSuOp();
EventResult CArcoGiuOp();
EventResult CCordaOp();
EventResult CPizzicatoOp();
EventResult CPonticelloOp();
EventResult CTastieraOp();
EventResult CPuntaOp();
EventResult CTalloneOp();

EventResult CCordaVuotaOp();
EventResult CCordaUnoOp();
EventResult CCordaDueOp();
EventResult CCordaTreOp();
EventResult CCordaQuattroOp();
EventResult CCordaCinqueOp();
EventResult CCordaSeiOp();
EventResult CCordaSetteOp();
EventResult CStringsRoman();
EventResult CTipoStrings();
//EventResult CCordaSeiOp();
//EventResult CCordaSetteOp();

EventResult ImpOp();
EventResult InitOp();
EventResult GoOp();
EventResult StopOp();
EventResult JumpOp();
static EventResult SCROp();
EventResult ToEditOp();
EventResult VisualizzaMetr(int Metr, int Vel, int rate);
EventResult DecOp();
EventResult pausaOp();
EventResult AccOp();
EventResult MidiOp();

EventResult CMovePartOp();
EventResult CHidePartOp();
EventResult CShowAllPartsOp();
EventResult CSplittingPart();
EventResult CViewLayerOp();
EventResult CFormatBeamingOp();
EventResult CUpDownOp();
EventResult CScoreExcerpt();
EventResult SelSpaForLyrEdt();
EventResult CSelSpaForRemoveLyr();
EventResult CEditLyric();
EventResult CRemoveLyr();
EventResult CNewLyric();
EventResult CSelectLyric();

//////////////////////////////////////
EventResult CMergingParts();
EventResult CSwitchLayer();

EventResult CFit2Window();


// questo non serve assolutamente a nulla
// a meno che non si riesca in qualche modo
// a controllare la posizione delle finestre !!
#define MENU_POS Point(2,2)

// questo non e' usato, al suo posto viene usato OP_WIDTH
// il quale e' usato solo per inizializzare il menu' UpDown!!
#define PAGUD_POS Point(660,2)


#define MENU_RAP_POS Point(316,2)

#define NUMERO_LEN 4
#define TGENERICO_LEN 30
#define TCORTO_LEN 8

#define TEMPO_LEN 20
// lunghezza massima della stringa quando si inserisce il tempo di una battuta
//	es. 4/4

#define MENUCHIAVE_POSPENT Point(-10,-10)
#define VU_PER_ROW2 4
#define COD_CVIOLINO '&'
#define COD_CVIOLINO8 '\x56'
#define COD_CVIOLINO8SOPRA '\xa3'
//
#define COD_CBASSO8SOPRA '\xa8'
#define COD_CTAB '\xa6'
#define COD_CPERCUSBOX '\xa5'
#define COD_CPERCUS2LINES '\xa1'
#define COD_CVUOTA 93
#define COD_CBASSOOLD '\xa2'
//
#define COD_CFA '?'
#define COD_CFA8 '\x4a'
#define COD_CDO 'B'
#define COD_CDO8 '\x9c'
#define COD_PENTAGRAMMA "="
#define COD_NOTA "Q"

#define COD_GSUP 'T'
#define COD_GINF 'R' 
#define COD_MSUP 'm'
#define COD_MINF 'M' 
#define COD_M2INF '\xc4'	// 192 -> 196
#define COD_M2SUP '\xc5'	// 187 -> 197
#define COD_TURNSLASH '\x69'
#define COD_TURNUP '\x6a'
#define COD_ARPEGGIO_UP "\x6f"
#define COD_ARPEGGIO_DOWN "\x70"

#define DXCHIAVE 3
#define DGX -3   
#define DGY -13  
#define DXGRUP -3     
#define DYGRUP 8     

#define DXNOTA 9
#define DYNOTA 0 

#define DMX -3	   
#define DMY -16    

#define DXMORD -6   
#define DYMORD 10   



#define COD_ACCENTO '\x3e'		// 62
#define COD_MARTELLATO '\xa9'	// 169
#define COD_SFORZATO 94			// 94
#define COD_MARTDOLCE 60		// 60
#define COD_TENUTO '\x5f'		// 95
#define COD_PUNTOALL 176		// 176
#define COD_STACCATO '\x6b'		// 107

#define COD_ARM1 '\x23'
#define DXARM1 10
#define DYARM1 12
#define DXARM2 2
#define DYARM2 4
#define COD_ACC '\x71'
#define DXACC 6
#define DYACC1 1
#define DYACC2 -7
#define COD_TMP '\x34'
#define DXTMP 6
#define DYNUM 10  
#define DYDEN 0   
#define COD_ALT1 '\x23'
#define COD_ALT2 '\x71'
#define DXALT1 4
#define DXALT2 10
#define DYALT2 0
#define DYALT1 1


#define BARRA_SINGOLA "\x9f"
#define BARRA_DOPPIA "\x91"
#define BARRA_FINALE "\x8b"
#define BARRA_INIZIORIT "\xec"
#define BARRA_FINERIT "\x82"   //dec 130
#define BARRA_INIZIOFINERIT "\xdc"
#define BARRA_INVISIBILE "\xa4"
//

#define COD_LETTERA "\x25"
#define COD_CODA "\x66"
#define COD_SEGNO "\x25"
#define COD_FINE "\x59"
#define COD_DACAPO "\x4e"	//dec 78
#define COD_DASEGNO "\x4f"	//dec 79


#define NOTA_SING "\x53"    // dec 83
#define COD_FRECCIA "\xd2"
#define GRUPPONOTE "\xd3"
#define NOTAUP "\x71"
#define NOTADOWN "\x51"
#define COD_PAUSA "\xd7"
#define MANO "\x98"
#define COD_VIOLINO "\xe7"
#define PUNTO " \x2e"
#define COD_STRUMENTO "\x6c"
#define CANCELLINO "\xd6"
#define INDICAZIONE "\x50"
#define VARIAZIONE_VALORE "\x51 \x2e"
#define TERZINA "\x24" 		// dec 36

#define MENUFILE "\xae"

#define COD_LEGATURA "\x7b"
#define INTONDA "\xd4"    // dec 212
#define COD_CRESCENDO "\xc1"  //dec 193
#define COD_DIMINUENDO "\xc3"
#define INTFRECCIA "\x27"
#define MODOTTAVA "\x28"
#define CAMBIARIT "\x29"
#define LEGATURAVALORESOPRA "\x2a"
#define LEGATURAVALORESOTTO "\xb6"

#define FORTISSIMO "\x8e"
#define FORTE      "\x66"
#define MEZZOFORTE "\x46"
#define MEZZOPIANO "\x50"
#define PIANO      "\x70"
#define PIANISSIMO "\xd5"

#define PAGUP    "\x60"
#define PAGDOWN  "\x44"

#define NOTA_BREVE        "\xb8"
#define NOTA_SEMIBREVE    "\x77"
#define NOTA_MINIMA       "\x68"
#define NOTA_SEMIMINIMA   "\x71"
#define NOTA_CROMA        "\x65"
#define NOTA_SEMICROMA    "\x78"
#define NOTA_BISCROMA     "\x64"
#define NOTA_SEMIBISCROMA "\x72"
#define NOTA_FUSA    	  "\xb9"


#define PAUSA_SEMIBREVE    "\x8c"
#define PAUSA_MINIMA       "\xde"
#define PAUSA_SEMIMINIMA   "\xd7"
#define PAUSA_CROMA        "\x84"
#define PAUSA_SEMICROMA    "\x89"
#define PAUSA_BISCROMA     "\xf9"
#define PAUSA_SEMIBISCROMA "\x93"
#define PAUSA_FUSA         "\x4b"
#define PAUSA_GENERICA     "\x4c"		//dec 76  
#define PAUSA_2BATTUTE     "\x2f"		//dec 47
#define PAUSA_4BATTUTE     "\x30"		//dec 48

#define COD_DIESIS        "\x23"
#define COD_DOPPIODIESIS  "\x9a"
#define COD_BEMOLLE       "\x62"
#define COD_DOPPIOBEMOLLE "\xa7"
#define COD_BEQUADRO      "\x6e"
#define COD_BEQUADRO1Q    "\x73"
#define COD_BEQUADRO3Q    "\x74"
#define COD_PARENTESIZZA  "\x7d"
#define COD_NON_PARENTESIZZA  "\x7e"

#define COD_DIESIS1Q      "\xb1"   	// 177
#define COD_DIESIS3Q      "\xb2"	// 178
#define COD_BEMOLLE1Q     "\xc8"	// 180 -> 200 b0 = 176
#define COD_BEMOLLE3Q     "\xc9"	// 186 -> 201 c0 = 192	

#define COD_TREMOLO "\xf3"
#define COD_GLISSATO "\xbc"
#define COD_TRILLO  "\xeb"
#define COD_ONDA    "\xe6"
#define COD_ARPEGGIO        "\x2d"  	// dec 45
#define SUDDIVISIONE    "\x3a"		// dec 58

#define CORDAVUOTA "\x4c"
#define COD_ARCOGIU    "\xfc"
#define COD_ARCOSU     "\xfd"

#define CORONASOPRA "\x55"
#define CORONASOTTO "\x75"
#define CORONAQUADSOPRA "\xad"
#define CORONATRIANGSOPRA "\xaf"

#define COD_NOTINA "\x3b"
#define ACCIACCATURA "\x90"


#define NEW "\x21"        // dec 33
#define COD_TITOLO "\x04"	  // non sembra utilizzato - sul pulsante c'e la scritta
#define LOAD "\x36"		  // dec 54	
#define COMPRESS "\xbd"		  // dec 54	
#define SAVE "\x37"		  // dec 55 
#define SAVEAS "\x38"	  // dec 56
#define PRINT  "\x39"	  // dec 57
#define USCITA "\x2b"      // dec 43
#define COD_PEDALUP "\xee"   
#define COD_OCCHIALI "\xff"
#define COD_PEDALDOWN "\xed"  

#define VIA_SORDINAARCHI "\xfe"
#define VIA_SORDINAOTTONI "\x2d"
#define CON_SORDINAARCHI "\x49"  
#define CON_SORDINAOTTONI "\x2b"

#define ARMONICIARCHI  "\xca"
#define ARMONICIOTTONI "\xcb"

#define PRFIATO "\x2c"
#define COD_TALLONE "\xfa"
#define COD_PUNTA "\xfb"

#define COD_SLIDINGUP		"\xef" 
#define COD_SLIDINGDOWN		"\xF0" 
#define COD_SLIDINGDUP		"\xF1"
#define COD_SLIDINGDOWNUP	"\xF2" 
#define COD_NONGHYNINC		"\xF4" 
#define COD_NONGHYNDEC		"\xF5" 
#define COD_NONGHYNNARROW	"\xF6" 
#define COD_NONGHYNWIDE		"\xF7" 

#define AGG_BATTUTADX "\x44"
#define AGG_BATTUTASX "\x45"
#define AGG_SPARTITO  "\x46"
#define CAN_SPARTITO  "\x47"

#define DELBAT             "\xbf"
#define DELCOLBAT          "\xc0"
#define ASSEGNANOME        "\xc1"
#define COD_GRAFFA             "\xc2"
#define COD_QUADRA             "\xbe"

#define RIP_TEMPO "\x79"		    // dec 121
#define RIP_MEZZABAT "\x7c"         // dec 124
#define RIP_BATTUTA "\x7a"			// dec 122
#define RIP_DOPPIABATTUTA "\xa0"    // dec 160

#define GO_FORWARD   "\x40"         // dec 64
#define GO_BACKWARD  "\x41"			// dec 65
#define PAG_FORWARD  "\xb4"
#define PAG_BACKWARD "\xba"
#define GO_TOP       "\xbc"
#define GO_BOTTOM    "\xbb"

#define PAUSA_ESEC      "\xd9"
#define STOP       "\xda"
#define IMPAGINA   "\xdb"
#define GO         "\xcf"
#define INIT       "\xdf"

#endif //LIOOMENU_HPP
