/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: lioomsg.cpp versione wxWindows gen2000  */

/* Non esiste il file lioomsg.hpp: queste funzioni sono definite in
lioo.hpp e quindi sono accessibili da ogni classe.  */

#include "wx/wx.h"

// per il debug del MILLA
extern wxString msgdebug;
extern wxString msgtoken;


#if defined (__WXGTK__)
#include "moodsxdialog.wxr"
#include "moodsxdialog.h"
#include "tabxdialog.wxr"
#include "tabxdialog.h"
#include "debugmilla.wxr"
#include "debugmilla.h"
#define PATH_SEP "/"
#endif

// define di prova da mettere globale
#define NOTYETIMPLEMENTED "Sorry! Not Available in this version."

#if defined(__WXMSW__) 
#ifndef WDFEDONLY
#include "moodswdialog.wxr"
#include "moodswdialog.h"
#include "tabwdialog.wxr"
#include "tabwdialog.h"
#include "debugmilla.wxr"
#include "debugmilla.h"
#endif
#define PATH_SEP "\\"
#endif

#include "wx/wx.h"
#include "wx/resource.h"


#include <time.h>
#include <string.h>
typedef int Bool ;

#include "drw/frmanage.hpp"

#include "lioo.hpp"
#include "liooext.hpp"
#include "drw/rectangl.hpp"
#include "midistrumenti.h"
#include "midistrumenti.wxr"
#include "orchestra.h"
#include "orchestra.wxr"
#include "tempodinamico.h"
#include "tempodinamico.wxr"
#include "mdo/moodsmidiwrite.hpp"
#include "drw/musicedt.hpp"
#include "dialogs.hpp"
#include "net/mamass.hpp"
#include "drw/lwindow.hpp"
#include "net/logfile.hpp"
#include "drw/button.hpp"
#include "str/ditafile.hpp"
#include "str/ditacord.hpp"
#include "smr/smr.hpp"

#define INPUT_STRING_WIDTH 200

#define KEY_RETURN 13
#define KEY_ESC    27

#define DEFAULT_FONT "8x16"

void BeginWait();
void EndWait();

#ifndef WDFEDONLY
extern LogFile MyLog;

Bool WSaveACL(char *title,char *buffer,int max);
Bool WreadACL(char *title,char *buffer,int max);
Bool WFilterList(char *title);
#endif

static EventResult EndButton()
{
	return ER_END;
}

wxString ettFile;



/*
**************************************************************************************************
*
*
*	Finestra Message con pulsante OK	e	Finestra Message con pulsante OK e Cancel
*
*
**************************************************************************************************
*/


/////////////////////////////////////////////////////////////////
// tipo messaggio 1
void Message(char *msg)
{
	
#if defined (__WXGTK__)
	wxMessageDialog *dialog=new wxMessageDialog(NULL, msg, "  ", wxOK|wxCENTRE);
#endif
	
	
#if defined(__WXMSW__) 
#ifndef WDFEDONLY
	wxMessageDialog *dialog=new wxMessageDialog(NULL, msg, "  ", wxICON_INFORMATION|wxOK|wxCENTRE);
#else
	wxMessageDialog *dialog=new wxMessageDialog(NULL, msg, "  ", wxICON_INFORMATION|wxOK|wxCENTRE);
#endif
#endif
	
	dialog->ShowModal();
	
	
	dialog->Destroy();
	
}


/////////////////////////////////////////////////////////////////
// tipo messaggio 2
void Message(char *msg, char *title)
{
	
#if defined (__WXGTK__)
	wxMessageDialog *dialog=new wxMessageDialog(NULL, msg, title, wxOK|wxCENTRE);
#endif
	
	
#if defined(__WXMSW__) 
#ifndef WDFEDONLY
	wxMessageDialog *dialog=new wxMessageDialog(NULL, msg, title, wxICON_INFORMATION|wxOK|wxCENTRE);
#else
	wxMessageDialog *dialog=new wxMessageDialog(NULL, msg, title, wxICON_INFORMATION|wxOK|wxCENTRE);
#endif
#endif
	
	
	
	dialog->ShowModal();
	dialog->Destroy();
}

/////////////////////////////////////////////////////////////////
// tipo messaggio 3

Bool YNMessage(char *msg, char *title)
{
	
	
	
#ifndef WDFEDONLY
	wxMessageDialog *dialog=new wxMessageDialog(NULL, msg, title, wxYES_NO|wxCENTRE);
#else
	wxMessageDialog *dialog=new wxMessageDialog(NULL, msg, title, wxYES_NO|wxCENTRE);
#endif
	
	
	if (dialog->ShowModal()==wxID_YES)
	{
		dialog->Destroy();
		return TRUE;
	}
	else 
	{
		dialog->Destroy();
		return FALSE;
	}
	
	
	
}


/*
***************************************************************************
*
*
*	Finestra con pulsante Cancel e InputText
*
*
***************************************************************************
*/

Bool InputString(char *msg, char * buffer, int max, char * title)
{
	char locbuffer[1024];
	
	wxTextEntryDialog dialog(NULL, msg, title, buffer, wxOK|wxCANCEL);
	
	if (dialog.ShowModal() == wxID_OK) 
		strcpy(locbuffer,(dialog.GetValue()).c_str());
	else locbuffer[0]='\0';
	
	if (strlen(locbuffer)>(unsigned int)max) 
		locbuffer[max-1]=0;
	strcpy(buffer,locbuffer);
	
	if (strlen(buffer)==0) return FALSE;
	else return TRUE;
}

/*
***************************************************************************
*
*
*	Fai il parsing delle risorse definite con il dialog editor
*
*
***************************************************************************
*/

void LoadDialogs()
{
	////////////////////////////////
	wxResourceParseData(dtuplet);
	wxResourceParseData(dmetronome);
	wxResourceParseData(ETTdialog);
	wxResourceParseData(MDSdialog);
	wxResourceParseData(mdssave);
	wxResourceParseData(jump);
	wxResourceParseData(JMPBattuta);
	wxResourceParseData(print);
	wxResourceParseData(Midi);
	wxResourceParseData(jumpinexec);
	wxResourceParseData(Label);
	wxResourceParseData(giustificazione);
	wxResourceParseData(additional);
	wxResourceParseData(filteringoptions);
	wxResourceParseData(additional);
	wxResourceParseData(filteringoptions);
	wxResourceParseData(aclsave);
	wxResourceParseData(Tabl_Dial);
	wxResourceParseData(strummidi);
	wxResourceParseData(orchmidi);
	wxResourceParseData(tdinamidi);
	wxResourceParseData(cwparameters);
	wxResourceParseData(debugmilla);
	////////////////////////////////
}

/*
***************************************************************************
*
*
*	Finestra con pulsante Cancel , OK e flag  per l'inserimento delle terzine
*
*
***************************************************************************
*/

////////////////////////////////////////////////////////////////
class DTuplet : public wxDialog
{
public:
    wxTextCtrl *entrytup;
	wxCheckBox *checkdrawterz;
	void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
	
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DTuplet, wxDialog)
EVT_BUTTON(ID_BUTTOKTUP, DTuplet::OnOk)
EVT_BUTTON(ID_BUTTCANCTUP, DTuplet::OnCancel)
END_EVENT_TABLE()


void DTuplet::OnOk(wxCommandEvent& WXUNUSED(event) )
{
    EndModal(ID_BUTTOKTUP);
}

void DTuplet::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
	EndModal(ID_BUTTCANCTUP);
}


/////////////////////////

Bool InputTerzine(char *msg,char *buffer,int max,char *title,int *Draw)
{
	Bool FlagTerzine=FALSE;
	int DrawTerzine=0; 
	DTuplet dialog; 
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "dtuplet"))
	{
		dialog.entrytup = (wxTextCtrl *)wxFindWindowByName("textctrl3", &dialog);
		dialog.checkdrawterz = (wxCheckBox *)wxFindWindowByName("checkbox3", &dialog);
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	}
	
	// Il controllo serve per far funzionare il metodo anche quando non
	buffer[max-1] = '\0';
	
	
	
	dialog.Centre(wxBOTH);
	
	if (dialog.ShowModal() == ID_BUTTOKTUP)
	{
		strcpy(buffer,(dialog.entrytup->GetValue()));
		if (dialog.checkdrawterz->GetValue()) DrawTerzine=1;
		else DrawTerzine=0;
		
		FlagTerzine = TRUE;
	}
	else FlagTerzine = FALSE;
	
	dialog.Destroy();
	
	if (strlen(buffer)>(unsigned int)max) 
		buffer[max-1]=0;
	
	if (!FlagTerzine)
		buffer[0] = '\0';
	
	(*Draw)=DrawTerzine;
	
	return FlagTerzine;
}


/*
***************************************************************************
*
*
*	Finestra con pulsanti, lista ed InputBox per 		Inserimento del Metronomo
*
*
***************************************************************************
*/
/////////////////////////////////////
class DMetronome : public wxDialog
{
public:
    wxTextCtrl *entrymov;
	wxTextCtrl *entrynumfig;
	wxCheckBox *point;
	wxListBox *fract;
	
	void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
	
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DMetronome, wxDialog)
EVT_BUTTON(ID_BUTTONMETOK, DMetronome::OnOk)
EVT_BUTTON(ID_BUTTONMETCANC, DMetronome::OnCancel)
END_EVENT_TABLE()


void DMetronome::OnOk(wxCommandEvent& WXUNUSED(event) )
{
    EndModal(ID_BUTTONMETOK);
}

void DMetronome::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
	EndModal(ID_BUTTONMETCANC);
}


/////////////////////////

Bool WMetronomo(char *title,char *buffer,int max)
{
	
	Bool quitMetro;
	int LEN_Metro;
	
	LEN_Metro = max;
	quitMetro=FALSE;
	
	
	DMetronome dialog; 
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "dmetronome"))
	{
		dialog.entrymov = (wxTextCtrl *)wxFindWindowByName("textctrl17", &dialog);
		dialog.entrynumfig = (wxTextCtrl *)wxFindWindowByName("textctrl18", &dialog);
		dialog.point = (wxCheckBox *)wxFindWindowByName("checkbox2", &dialog);
		dialog.fract = (wxListBox *)wxFindWindowByName("listbox14", &dialog);	
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	}
	
	
	////////////////
	dialog.Centre(wxBOTH);
	
	if(buffer[0] != '\0')
	{
		long sel;
		wxString buf = buffer;
		wxString mov = buf.BeforeFirst('*');
		buf=buf.AfterFirst('*');
		wxString fract = buf.GetChar(0);
		wxString point = buf.GetChar(1);
		buf=buf.Remove(0,2);
		wxString numfig = buf;
		
		dialog.entrymov->SetValue(mov);
		dialog.entrynumfig->SetValue(numfig);
		if(point == "1")
			dialog.point->SetValue(true);
		else
			dialog.point->SetValue(false);
		fract.ToLong(&sel);
		dialog.fract->SetSelection((int)sel);	
	}
	
	if (dialog.ShowModal() == ID_BUTTONMETOK)
	{
		strcpy(buffer,(dialog.entrymov->GetValue()));
		strcat(buffer,"*");
		
		char c[2];
		
		c[0]=(dialog.fract->GetSelection())+'0';
		c[1]='\0';
		strcat(buffer,c);
		
		
		if (dialog.point->GetValue())
			strcat(buffer,"1");
		else strcat(buffer,"0");
		strcat(buffer,(dialog.entrynumfig->GetValue()));
	}
	else quitMetro=TRUE;
	
	dialog.Destroy();
	
	return (!quitMetro) ;
	
}

/*
***************************************************************************
*
*
*	Finestra con pulsanti Ok e Cancel, InputText e lista		Caricamento ETT
*
*
***************************************************************************
*/

class ETTDial : public wxDialog
{
public:
   	wxListBox *listaETT;
	wxTextCtrl *ETTFile;
	int max;
	void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
    void OnSelectList(wxCommandEvent& WXUNUSED(event));
	
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(ETTDial, wxDialog)
EVT_BUTTON(ID_ETT_BUTTOK, ETTDial::OnOk)
EVT_BUTTON(ID_ETT_BUTTCANC, ETTDial::OnCancel)
EVT_LISTBOX(ID_ETT_LISTBOX, ETTDial::OnSelectList)
END_EVENT_TABLE()

void ETTDial::OnSelectList(wxCommandEvent& WXUNUSED(event))
{
	
	ETTFile->SetValue(listaETT->GetStringSelection());
}

void ETTDial::OnOk(wxCommandEvent& WXUNUSED(event) )
{
    if (int (ETTFile->GetValue().Length())>max) Message("File name too long","Error");
	else EndModal(ID_ETT_BUTTOK);
}

void ETTDial::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
	EndModal(ID_ETT_BUTTCANC);
}


extern wxMusicEditor *MusicEditor;

Bool WReadETT(char *title,char* audioFile,char *buffer,char* nome,int max)
{
	SMRItemList ettList;
	int ok=FALSE;
	
	MusicEditor->smrf->GetItems(SMR_SynchInfo,ettList);
	int nETT=ettList.GetCount();
	bool nofilter=strcmp(audioFile,"")==0;
	
	if(strcmp(title,"")!=0)
		nETT++;
	
	if(nETT==0)
	{
		Message("No ETT files present");
		return FALSE;
	}
	wxString *etts=new wxString[nETT];
	SMRSynchInfoItem **ewf=new SMRSynchInfoItem*[nETT];
	
	int n=0;
	if(strcmp(title,"")!=0)
	{
		etts[0]=title;
		ewf[0]=NULL;
		n=1;
	}
	
	wxSMRItemListNode *node = ettList.GetFirst();
	while (node)
	{
		SMRSynchInfoItem *ettItem = (SMRSynchInfoItem*)node->GetData();
		
		etts[n]=ettItem->GetItemDescription();
		ewf[n]=ettItem;
		n++;
		node = node->GetNext();
	}
	if(n==0)
	{
		delete[] etts;
		delete[] ewf;
		wxMessageBox(wxString::Format("No SynchInfo files present for %s",audioFile));
		return FALSE;
	}
	
	if(ettFile.IsEmpty())
	{
		wxSingleChoiceDialog ettChoice(FrameManager::currFrame,"Select the performance","performance resources",n,etts);

		ettChoice.SetSize(500,200);
		ettChoice.Centre();

		if(ettChoice.ShowModal()==wxID_OK)
		{
			SMRSynchInfoItem *ett=(SMRSynchInfoItem*) ewf[ettChoice.GetSelection()];
			if(ett!=NULL)
			{
				wxString ettFile=ett->GetFilename();
				strncpy(buffer,ettFile,max);
				ok=TRUE;
			}
			else
			{
				strncpy(buffer,nome,max);
				ok=TRUE;
			}
		}
	}
	else
	{
		int pos;
		for(int i=0;i<=n;i++)
		{
			if(etts[i] == ettFile)
			{
				pos=i;
				break;
			}
		}
		
		SMRSynchInfoItem *ett=(SMRSynchInfoItem*) ewf[pos];
		if(ett!=NULL)
		{
				wxString ettFile=ett->GetFilename();
				strncpy(buffer,ettFile,max);
				ok=TRUE;
		}
		else
		{
			strncpy(buffer,nome,max);
			ok=TRUE;
		}
		
		ettFile = "";
	}
	
	delete[] etts;
	delete[] ewf;
	
	return ok;	
}



/*
***************************************************************************
*
*
*	Finestra con pulsanti Ok e Cancel, InputText e lista		Salvataggio ETT
*
*
***************************************************************************
*/



Bool WSaveETT(char *title,char* audioFile,char *buffer,char* nome,int max)
{
	
	int LEN_ETT;
	Bool quitETT;
	
	
	
	
	
	buffer[max] = '\0'; 
	LEN_ETT = max;
	quitETT=FALSE;
	
	ETTDial dialog; 
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "ETTdialog"))
	{
		dialog.SetTitle(title);		
		dialog.ETTFile = (wxTextCtrl *)wxFindWindowByName("textctrl3", &dialog);
		dialog.listaETT = (wxListBox *)wxFindWindowByName("listbox7", &dialog);	
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	}
	
	SMRItemList ettList;
	
	MusicEditor->smrf->GetItems(SMR_SynchInfo,ettList);
	int nETT=ettList.GetCount()+1;

/*	
	wxSMRItemListNode *node = ettList.GetFirst();
	while (node)
	{
		SMRSynchInfoItem *ettItem = (SMRSynchInfoItem*)node->GetData();
		
		if(ettItem->GetFilename()==audioFile)
			dialog.listaETT->Append(ettItem->GetFileSource());
		
		node = node->GetNext();
	}
*/

	//cerco se c'e' gia' un file ett con lo stesso nome, se c'e' gia' il nome viene rigenerato aggiungendo -1, -2,
	wxString ettFile=nome,ettFile2=ettFile;
	bool ok=false;
	int count=1;
	
	while(!ok)
	{
		ok=true;
		wxSMRItemListNode *node = ettList.GetFirst();
		while (node)
		{
			SMRSynchInfoItem *ettItem = (SMRSynchInfoItem*)node->GetData();
			
			if(ettItem->GetFilename()==ettFile2)
			{
				ok=false;
				break;
			}
			node = node->GetNext();
		}
		if(!ok)
		{
			ettFile2=ettFile.BeforeLast('.')+wxString::Format("-%d.ett",count);
			count++;
		}
	}
	
	dialog.ETTFile->SetValue(ettFile2);
	dialog.max=max;
	////////////////
	dialog.Centre(wxBOTH);
	
	if (dialog.ShowModal() == ID_ETT_BUTTOK)
	{
		
		strcpy(buffer,(dialog.ETTFile->GetValue()));
		
	}
	else quitETT=TRUE;
	
	
	strcpy(nome,buffer);
	
	int len=strlen(buffer)-4;
	
	if ((len<=0)||(strcmp(&buffer[strlen(buffer)-4],".ett")!=0)) strcat(buffer,".ett");
	
	return (!quitETT) ;
	
}




/*
***************************************************************************
*
*
*	Finestra con pulsanti Ok e Cancel, InputText e lista		Caricamento MDS
*
*
***************************************************************************
*/

///////////////////////////////////////////////////////////////////////
////////       classe 

class DMDSLoad : public wxDialog
{
public:
   	wxListBox *listaMDS;
	wxTextCtrl *MDSFile;
	int max;
	int quitMDS;
	char *NomeFile;
	
	void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
    void OnSelectList(wxCommandEvent& event);
	void OnDoubleClick(wxCommandEvent& WXUNUSED(event));
	void OnACL(wxCommandEvent& event);
    void OnInPort(wxCommandEvent& event);
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DMDSLoad, wxDialog)
EVT_BUTTON(ID_MDS_BUTTOK, DMDSLoad::OnOk)
EVT_BUTTON(ID_MDS_BUTTCANC, DMDSLoad::OnCancel)
EVT_LISTBOX(ID_MDS_LISTBOX, DMDSLoad::OnSelectList)
EVT_LISTBOX_DCLICK(ID_MDS_LISTBOX, DMDSLoad::OnDoubleClick)
EVT_BUTTON(ID_MDS_BUTTACL, DMDSLoad::OnACL)
EVT_BUTTON(ID_MDS_BUTTINPORT, DMDSLoad::OnInPort)

END_EVENT_TABLE()


Bool WreadACL(char *title,char *buffer,int max);


void DMDSLoad::OnSelectList(wxCommandEvent& WXUNUSED(event))
{
	
	MDSFile->SetValue(listaMDS->GetStringSelection());
}

void DMDSLoad::OnDoubleClick(wxCommandEvent& WXUNUSED(event))
{
	
	strcpy(NomeFile,listaMDS->GetStringSelection());
	quitMDS=1;
	EndModal(ID_MDS_LISTBOX);
}

void DMDSLoad::OnOk(wxCommandEvent& WXUNUSED(event) )
{
    if (int (MDSFile->GetValue().Length())>max) Message("File name too long","Error");
	
    strcpy(NomeFile,MDSFile->GetValue());
	
	quitMDS=1;
	
	
    EndModal(ID_MDS_BUTTOK);
}

void DMDSLoad::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
	quitMDS=0;
	EndModal(ID_MDS_BUTTCANC);
}

void DMDSLoad::OnACL(wxCommandEvent& WXUNUSED(event) )
{
	
	char Path[200];
	
	strcpy(Path,MDSFile->GetValue());
	strcat(Path,".mds"PATH_SEP);
	
	char Nome[200];
	strcpy(Nome,Path);
	
	
	
	if (WreadACL("Load ACL",Nome,90)) {
		// significa che l'utente ha effettivamente scelto un nome di ACL
		strcat(Path,Nome);	
		strcpy((char *)NomeFile,Path);
		quitMDS = 2;
		EndModal(ID_MDS_BUTTACL);
	}
	
}

void DMDSLoad::OnInPort(wxCommandEvent& WXUNUSED(event) )
{
	Message(NOTYETIMPLEMENTED,"Attention!");
}


//////////////////////////////////////////////////////////////
// funzione globale principale ///////////////////////////////
//////////////////////////////////////////////////////////////

int WReadMDS(char *title,char *Path,int max1,char *NomeFile,int max)
{
    Bool quitMDS1;
	
	char filesPath[200];
	
	
	NomeFile[max-1] = '\0'; 
	
	quitMDS1=FALSE;
	
	DMDSLoad dialog;
	dialog.NomeFile	= NomeFile;
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "MDSdialog"))
	{
		dialog.SetTitle(title);		
		dialog.MDSFile = (wxTextCtrl *)wxFindWindowByName("textctrl8", &dialog);
		dialog.listaMDS = (wxListBox *)wxFindWindowByName("listbox13", &dialog);	
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	}
	
	dialog.max=max;
	dialog.quitMDS=0;
	
	if (smrgetenv("SMR_FILES_PATH")!=NULL) 
		strcpy(filesPath, smrgetenv("SMR_FILES_PATH"));
    else strcpy(filesPath, ".");
	
	
	wxString f = wxFindFirstFile((wxString)filesPath + PATH_SEP "*.mds", wxDIR);
	while ( !f.IsEmpty())
	{
		f.Truncate(f.Length()-4);
		dialog.listaMDS->Append(wxFileNameFromPath(f));
		f = wxFindNextFile();
	}
	wxString filename=NomeFile;
    int n;
	
	n=dialog.listaMDS->FindString(filename.Truncate(filename.Length()-4));
	if (n!=-1)
	{
		dialog.listaMDS->SetSelection(n,TRUE);
		dialog.MDSFile->SetValue(dialog.listaMDS->GetStringSelection());
	}
	else
	{
		if (dialog.listaMDS->Number()!=0)
		{
			dialog.listaMDS->SetSelection(0,TRUE);
			dialog.MDSFile->SetValue(dialog.listaMDS->GetStringSelection());
		}
	}
	
	dialog.Centre(wxBOTH);
	
	
    dialog.ShowModal();
	quitMDS1=dialog.quitMDS;
    
	if (quitMDS1==0) 
	{
		dialog.Destroy();
		return quitMDS1; // uscito con cancel, non deve salvare una mazza !
	}
	
	
	char Finale[200];
	
	if (quitMDS1==3) 
		strcpy(Path,"workin"PATH_SEP);
	else if (quitMDS1==1) 
	{
		// caricamento normale (MDS)
		int len=strlen(NomeFile)-4;  
		if ((len<=0)||(strcmp(&NomeFile[strlen(NomeFile)-4],".mds")!=0)) strcat(NomeFile,".mds");
		
		strcpy(Path,NomeFile);
		// Se in Path c' workin devo entrare dentro e prendere il file
		// mds senza numero di fronte		
		
		strcat(Path,PATH_SEP);
		
	} 
	else 
	{
		// caricamento ACL
		char *Sep;
		strcpy(Finale,NomeFile);
		Sep=strstr(Finale,PATH_SEP);
		if (Sep!=NULL)
		{
			strcpy(NomeFile,Sep+1);
			(*(Sep+1))='\0';
			strcpy(Path,Finale);
		}
	}
	
	
	
	
	dialog.Destroy();
	return quitMDS1;
	
	
}


/*
***************************************************************************
*
*
*	Finestra con pulsanti Ok e Cancel, InputText e lista		Caricamento ACL
*
*
***************************************************************************
*/


// Ritorna in buffer il nome del file ACL da salvare, senza il path
// funzione globale principale
// usiamo la risorsa dell' ETT
Bool WreadACL(char *title,char *buffer,int max)
{
    int LEN_ACL;
    int quitACL;
		
	char filesPath[200];
	
	if (smrgetenv("SMR_FILES_PATH")!=NULL) 
		strcpy(filesPath, smrgetenv("SMR_FILES_PATH"));
    else strcpy(filesPath, ".");
    //////////
	// aggiunto elaboraz wx
	
    buffer[max-1] = '\0'; 
    LEN_ACL = max;
	quitACL=FALSE;
	
	// usiamo la risorsa ett perche' la finestra e' esattamente uguale
	ETTDial dialogo;
	
	if (dialogo.LoadFromResource(FrameManager::currFrame, "ETTdialog"))
	{
		dialogo.SetTitle(title);		
		dialogo.ETTFile = (wxTextCtrl *)wxFindWindowByName("textctrl3", &dialogo);
		dialogo.listaETT = (wxListBox *)wxFindWindowByName("listbox7", &dialogo);	
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	}
	
	dialogo.max=max;
	
	if (smrgetenv("SMR_FILES_PATH")!=NULL) 
		strcpy(filesPath, smrgetenv("SMR_FILES_PATH"));
    else strcpy(filesPath, ".");
	
	wxString f = wxFindFirstFile((wxString)filesPath +PATH_SEP+buffer+PATH_SEP "*.acl");
	while ( !f.IsEmpty())
	{
		f.Truncate(f.Length()-4);
		dialogo.listaETT->Append(wxFileNameFromPath(f));
		f = wxFindNextFile();
	}
	

	if (dialogo.listaETT->Number()!=0)
	{
		dialogo.listaETT->SetSelection(0,TRUE);
		dialogo.ETTFile->SetValue(dialogo.listaETT->GetStringSelection());
	}
	//}
	
	
	dialogo.Centre(wxBOTH);
	
	
	if (dialogo.ShowModal() == ID_ETT_BUTTOK)
	{
		strcpy(buffer,(dialogo.ETTFile->GetValue()));
		
	}
	else quitACL=TRUE;
	
	
    int len=strlen(buffer)-4;
	if ((len<=0)||(strcmp(&buffer[strlen(buffer)-4],".acl")!=0)) strcat(buffer,".acl");
	
    quitACL=!quitACL;
	return (quitACL);
}

///////////////////////////////////////////////	






/*
***************************************************************************
*
*
*	Finestra con pulsanti Ok e Cancel, InputText e lista		Salvataggio ACL
*
*
***************************************************************************
*/
//////////////////////classe////////////////////////

class ACLSave : public wxDialog
{
public:
   	wxListBox *listaACL;
	wxTextCtrl *ACLFile;
	int max;
	int quitACL;
	char *NomeFile;
	void OnSep(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
    void OnCong(wxCommandEvent& event);
	void OnSelectList(wxCommandEvent& event);
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(ACLSave, wxDialog)
EVT_BUTTON(ID_SAVEACLSEP, ACLSave::OnSep)
EVT_BUTTON(ID_SAVEACLCANCEL, ACLSave::OnCancel)
EVT_LISTBOX(ID_LISTBOXACL, ACLSave::OnSelectList)

EVT_BUTTON(ID_SAVEACLCONG, ACLSave::OnCong)


END_EVENT_TABLE()


void ACLSave::OnSelectList(wxCommandEvent& event)
{
	ACLFile->SetValue(listaACL->GetStringSelection());
}
void ACLSave::OnSep(wxCommandEvent& event)
{
	strcpy((char *)NomeFile,ACLFile->GetValue());
	if (strcmp((char *)NomeFile,""))
	{
		quitACL=3;
		EndModal(ID_SAVEACLSEP);
	} 
	else Message("Insert a valid name or press Cancel");	
	
}

void ACLSave::OnCong(wxCommandEvent& event)
{
	strcpy((char *)NomeFile,ACLFile->GetValue());
	if (strcmp((char *)NomeFile,""))
	{
		quitACL=2;
		EndModal(ID_SAVEACLCONG);
	} 
	else Message("Insert a valid name or press Cancel");
	
}
void ACLSave::OnCancel(wxCommandEvent& event)
{
	strcpy((char *)NomeFile,"");
	quitACL=0;
	EndModal(ID_SAVEACLCANCEL);
}	


/////////////////////////////////////////////////////////////////////
////////////////////////funzione principale//////////////////////////
/////////////////////////////////////////////////////////////////////
int WSaveACL(char *title,char *buffer,int max)
{
		
	char filesPath[200];
	int quitACL=0;
	buffer[max-1] = '\0'; 
	
	
	
	ACLSave dialog;
	dialog.NomeFile	= buffer;
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "aclsave"))
	{
		dialog.SetTitle(title);		
		dialog.ACLFile = (wxTextCtrl *)wxFindWindowByName("textctrl9", &dialog);
		dialog.listaACL = (wxListBox *)wxFindWindowByName("listbox8", &dialog);	
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	}
	
	dialog.max=max;
	dialog.quitACL=0;
	
	if (smrgetenv("SMR_FILES_PATH")!=NULL) 
	{
		strcpy(filesPath, smrgetenv("SMR_FILES_PATH"));
		strcat(filesPath,buffer);
		strcpy(buffer,"");    
	}
	else strcpy(filesPath, ".");
	
	
	
	wxString f = wxFindFirstFile((wxString)filesPath + PATH_SEP "*.acl");
	while ( !f.IsEmpty())
	{
		
		f.Truncate(f.Length()-4);
		dialog.listaACL->Append(wxFileNameFromPath(f));
		f = wxFindNextFile();
	}
	wxString filename=buffer;
    int n;
	n=dialog.listaACL->FindString(filename.Truncate(filename.Length()-4));
	if (n!=-1)
	{
		dialog.listaACL->SetSelection(n,TRUE);
		dialog.ACLFile->SetValue(dialog.listaACL->GetStringSelection());
	}
	else
	{
		if (dialog.listaACL->Number()!=0)
		{
			dialog.listaACL->SetSelection(0,TRUE);
			dialog.ACLFile->SetValue(dialog.listaACL->GetStringSelection());
		}
	}
	
	dialog.Centre(wxBOTH);
	
	
    dialog.ShowModal();
	quitACL=dialog.quitACL;
	
	
	
	
	
	// attacco l'estensione mds se salvo un nuovo mds oppure una estensione acl  
	int len=strlen(buffer)-4;  
	if ((len<=0)||(strcmp(&buffer[strlen(buffer)-4],".acl")!=0)) strcat(buffer,".acl");
	
	
	
	return (quitACL) ;
	
}


/***************************************************************************
*
*
*	Finestra con pulsanti Ok e Cancel, InputText e lista		Salvataggio MDS
*
*
***************************************************************************
*/


///////////////////////////////////////////////////////////////////////
////////       classe 

class DMDSsave : public wxDialog
{
public:
   	wxListBox *listaMDS;
	wxTextCtrl *MDSFile;
	int max;
	int quitMDS;
	char *NomeFile;
    void OnCancel(wxCommandEvent& event);
    void OnSelectList(wxCommandEvent& event);
    void OnExPort(wxCommandEvent& event);
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DMDSsave, wxDialog)
EVT_BUTTON(ID_MDS_CANC, DMDSsave::OnCancel)
EVT_LISTBOX(ID_LISTBOX, DMDSsave::OnSelectList)

EVT_BUTTON(ID_MDS_BUTTEXPORT, DMDSsave::OnExPort)

END_EVENT_TABLE()




void DMDSsave::OnSelectList(wxCommandEvent& WXUNUSED(event))
{
	
	MDSFile->SetValue(listaMDS->GetStringSelection());
}

void DMDSsave::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
	quitMDS=0;
	EndModal(ID_MDS_BUTTCANC);
}


void DMDSsave::OnExPort(wxCommandEvent& WXUNUSED(event) )
{
	Message(NOTYETIMPLEMENTED,"Attention!");
}


int WSaveMDS(char *title,char *Directory,char *NomeFile,int max)
{
    Bool quitMDS1;
	
	char filesPath[200];
	
	
	NomeFile[max-1] = '\0'; 
	
	quitMDS1=FALSE;
	
	DMDSsave dialog;
	dialog.NomeFile	= NomeFile;
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "mdssave"))
	{
		dialog.SetTitle(title);		
		dialog.MDSFile = (wxTextCtrl *)wxFindWindowByName("textctrl1", &dialog);
		dialog.listaMDS = (wxListBox *)wxFindWindowByName("listbox2", &dialog);	
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	}
	
	dialog.max=max;
	dialog.quitMDS=0;
	
	if (smrgetenv("SMR_FILES_PATH")!=NULL) 
		strcpy(filesPath, smrgetenv("SMR_FILES_PATH"));
    else strcpy(filesPath, ".");
	
	
	
	wxString f = wxFindFirstFile((wxString)filesPath + PATH_SEP "*.mds", wxDIR);
	while ( !f.IsEmpty())
	{
		
		f.Truncate(f.Length()-4);
		dialog.listaMDS->Append(wxFileNameFromPath(f));
		f = wxFindNextFile();
	}
	wxString filename=NomeFile;
    int n;
	n=dialog.listaMDS->FindString(filename.Truncate(filename.Length()-4));
	if (n!=-1)
	{
		dialog.listaMDS->SetSelection(n,TRUE);
		dialog.MDSFile->SetValue(dialog.listaMDS->GetStringSelection());
	}
	else
	{
		if (dialog.listaMDS->Number()!=0)
		{
			dialog.listaMDS->SetSelection(0,TRUE);
			dialog.MDSFile->SetValue(dialog.listaMDS->GetStringSelection());
		}
	}
	
	dialog.Centre(wxBOTH);
	
	
    dialog.ShowModal();
	quitMDS1=dialog.quitMDS;
	
	
	// buffer contiene il nome scelto dall'utente, con o senza estensioni
	// Verifico che non abbia scelto ACL o MDS.
	
	if (quitMDS1==0) {
		strcpy(NomeFile,"");
		strcpy(Directory,"");
		return quitMDS1; // uscito con cancel, non deve salvare una mazza !
	}
	
	
	if (quitMDS1==1) {
		
		
		// salvataggio normale (MDS)
		int len=strlen(NomeFile)-4;  
		if ((len<=0)||(strcmp(&NomeFile[strlen(NomeFile)-4],".mds")!=0)) strcat(NomeFile,".mds");
		strcpy(Directory,NomeFile);		
		strcat(Directory,PATH_SEP);
	} else {
		// in buffer ho il nome del file ACL con l'estensione (new.acl)		
		char Finale[200];
		char *Sep;
		strcpy(Finale,NomeFile);
		Sep=strstr(Finale,PATH_SEP);
		strcpy(NomeFile,Sep+1);
		(*(Sep+1))='\0';
		strcpy(Directory,Finale);
	}
	
	
	return quitMDS1;
}



/*
***************************************************************************
*
*
*	Finestra con pulsanti Ok e Cancel, InputText e lista		
*
*      EDITING:  GESTIONE SALTI AD ETICHETTA - BATTUTA - GOTOP - GOBOTTOM - GOBAT
*
*
***************************************************************************
*/

class DJump : public wxDialog
{
public:
   	char *data;
	void OnLabel(wxCommandEvent& event);
    void OnMeasure(wxCommandEvent& event);
    void OnGoTop(wxCommandEvent& event);
	void OnGoBottom(wxCommandEvent& event);
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DJump, wxDialog)
EVT_BUTTON(ID_JMPLABEL, DJump::OnLabel)
EVT_BUTTON(ID_JMPMEASURE, DJump::OnMeasure)
EVT_BUTTON(ID_JMPGOTOP, DJump::OnGoTop)
EVT_BUTTON(ID_JMPGOBOTTOM, DJump::OnGoBottom)

END_EVENT_TABLE() 



void DJump::OnLabel(wxCommandEvent& WXUNUSED(event) )
{
	
	strcpy((char *)data,"LAB");
	EndModal(ID_JMPLABEL);
}

void DJump::OnMeasure(wxCommandEvent& WXUNUSED(event) )
{
	strcpy((char *)data,"BAT");
	EndModal(ID_JMPMEASURE);
}

void DJump::OnGoTop(wxCommandEvent& WXUNUSED(event) )
{
	strcpy((char *)data,"TOP");
	EndModal(ID_JMPGOTOP);
}

void DJump::OnGoBottom(wxCommandEvent& WXUNUSED(event) )
{
	strcpy((char *)data,"BOT.");
	EndModal(ID_JMPGOBOTTOM);
}

///////////////////////////////////////////////////////////////
class DJumpMeasure : public wxDialog
{
public:
   	wxStaticText *genfirstMeasure;
	wxStaticText *LastMeasure;
	wxTextCtrl *InsMeasure;
	char *data;
	void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
    
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DJumpMeasure, wxDialog)
EVT_BUTTON(ID_BUTTONOK, DJumpMeasure::OnOk)
EVT_BUTTON(ID_BUTTONCANCEL, DJumpMeasure::OnCancel)


END_EVENT_TABLE() 



void DJumpMeasure::OnOk(wxCommandEvent& WXUNUSED(event) )
{
	int choice;
	strcpy((char *)data,InsMeasure->GetValue());
	choice=atoi((char *)data);
	if ((choice>0) && (choice<= atoi(LastMeasure->GetLabel())))
		EndModal(ID_BUTTONOK);
	else Message("Measure -- NOT --Present ","Error!");
}

void DJumpMeasure::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
	
	EndModal(ID_BUTTONCANCEL);
}



////////////////////////////////////////////////////////////////
//EDITING:

Bool EDJumpBat(char *title,char *buffer, int ultima_battuta)
{

	DJumpMeasure dialog;
	dialog.data=buffer;
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "JMPBattuta"))
	{
		dialog.SetTitle(title);
		dialog.genfirstMeasure = (wxStaticText *)wxFindWindowByName("statictext9", &dialog);
		dialog.LastMeasure = (wxStaticText *)wxFindWindowByName("statictext10", &dialog);
		dialog.InsMeasure = (wxTextCtrl *)wxFindWindowByName("textctrl5", &dialog);	
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	} 
	
	wxString measure;
	measure.sprintf("%d",ultima_battuta);
	dialog.genfirstMeasure->SetLabel("1");
	dialog.LastMeasure->SetLabel(measure);
	dialog.Centre(wxBOTH);
	
	
    if (dialog.ShowModal()==ID_BUTTONOK) return TRUE;
	else return FALSE;
	
	
	
	
}


////////////////////////////////////////////////////////////////////////////////
// // EDITING:

Bool EDJumpLab(char *title,char *buffer,int max,int num_etich,char *arrayLabel,int *arrayNumProg)
{
	
	
	wxString *array_label;
	
	buffer[max-1] = '\0'; 
	Bool quitJump=FALSE;
	
	// costruzione del vettore delle etichette presenti 
	//   e delle battute associate
	array_label=new wxString[num_etich];
    
	
	char c;
	int NumLabel=0; // NumLabel e' una variabile statica
	for (NumLabel=0;NumLabel<num_etich;NumLabel++)
	{  
		c=arrayLabel[NumLabel];
		array_label[NumLabel] = c;
	}
	
	wxSingleChoiceDialog dialog(FrameManager::currFrame,"",title,num_etich,array_label);
	
	if (dialog.ShowModal()==wxID_OK)
	{
		sprintf(buffer,"%d",arrayNumProg[dialog.GetSelection()]);
		quitJump=TRUE;
	}
	
	
	
	
	delete[] array_label;
	array_label = NULL;
	
	return quitJump;  
}

//////////////////////////////////////////////////////////////////////////////////
// // EDITING:

Bool EDWidgetJump(char *title,char *buffer,int max,int num_etich,int last_bat,char *arrayLabel,int* arrayNumProg)
{
	int ultima_battuta;
	ultima_battuta=last_bat;
	
	
	// controllo consistenza del brano: brano presente in memoria?
	if (ultima_battuta==1) 
	{
		Message("No score available ","Error!"); 
		return(FALSE);
	}	 
	
	Bool quitJump = FALSE;
	
	DJump dialog;
	dialog.data=buffer;
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "jump"))
	{
		dialog.SetTitle(title);		
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	} 
	
	dialog.Centre(wxBOTH);
	
	
    dialog.ShowModal();
	
	
	
	// fine del primo loop per la scelta : ricerca per label
	//                                     ricerca per battuta       
	
    if (!(strcmp(buffer,"LAB")))  
	{
		if (num_etich!=0)
		{
			//TypeJump = LABEL;
			quitJump=EDJumpLab("Label",buffer,max,num_etich,arrayLabel,arrayNumProg);
		}
		else Message("No label present","Error!");
		
	}
	
	else if (!(strcmp(buffer,"BAT")))
	{
		
		if (last_bat>0)
		{
			//TypeJump = BATTUTA;
			quitJump=EDJumpBat("Measure",buffer,ultima_battuta);
		}
		
		
	}  
	else if (!(strcmp(buffer,"TOP")))
	{
		quitJump = TRUE;
	}
	else if (!(strcmp(buffer,"BOT."))) 
	{
		quitJump = TRUE; 
	}   
	
	
	return (quitJump);
	
}



/*
***************************************************************************
*
*
*	Finestra con pulsanti Ok e Cancel, InputText e lista		Caricamento Etichetta
*
*
***************************************************************************
*/


class DLabel : public wxDialog
{
public:
   	
	wxTextCtrl *entry;
	wxListBox *list;
	
	char *data;
	void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DLabel, wxDialog)
EVT_BUTTON(ID_LABEL_OK, DLabel::OnOk)
EVT_BUTTON(ID_LABEL_CANCEL, DLabel::OnCancel)
END_EVENT_TABLE() 



void DLabel::OnOk(wxCommandEvent& WXUNUSED(event) )
{
	if(list->FindString(entry->GetValue())==-1)
	{
		wxString label=entry->GetValue();
		if(label.IsEmpty())
			EndModal(ID_LABEL_OK);
		
		if(label.GetChar(0)==' ')
			Message("Invalid Label","Error!");
		else
		{	
			strcpy((char *)data,label);
			EndModal(ID_LABEL_OK);
		}
	}
	else Message("Label already exists","Error!");
}

void DLabel::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
	
	EndModal(ID_LABEL_CANCEL);
}


Bool WReadEtich(char *title,char *buffer,int max,int num_etich,char *arrayLabel)
{
	
	Bool quitEtich=FALSE;
	
	DLabel dialog;
	dialog.data=buffer;
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "Label"))
	{
		dialog.SetTitle(title);
		dialog.entry = (wxTextCtrl *)wxFindWindowByName("entry", &dialog);
		dialog.list = (wxListBox *)wxFindWindowByName("list", &dialog);
		
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	} 
	
	int i=0;
	for (i=0;i<num_etich;i++)
	{
		dialog.list->Append(wxString(arrayLabel[i]));
	}
	
	dialog.Centre(wxBOTH);
	
	
    if (dialog.ShowModal()==ID_LABEL_OK) quitEtich=FALSE;
	return (!quitEtich) ;
	
}


/*
***************************************************************************
*
*
*	Finestra con pulsanti Ok e Cancel, InputText e lista		
*
*  ESECUZIONE: GESTIONE SALTI AD ETICHETTA E BATTUTA IN esecuzione
*
*
***************************************************************************
*/

///////////////////////////////////////////////////////////////////////////////
class DJumpInExec : public wxDialog
{
public:
   	char *data;
	void OnLabel(wxCommandEvent& event);
    void OnMeasure(wxCommandEvent& event);
    
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DJumpInExec, wxDialog)
EVT_BUTTON(ID_LABEL, DJumpInExec::OnLabel)
EVT_BUTTON(ID_MEASURE, DJumpInExec::OnMeasure)

END_EVENT_TABLE() 



void DJumpInExec::OnLabel(wxCommandEvent& WXUNUSED(event) )
{
	
	strcpy((char *)data,"LAB");
	EndModal(ID_LABEL);
}

void DJumpInExec::OnMeasure(wxCommandEvent& WXUNUSED(event) )
{
	strcpy((char *)data,"BAT");
	EndModal(ID_MEASURE);
}


//         ESECUZIONE:

Bool WidgetJump(char *title,char *buffer,int max,int num_etich,int last_bat)
{
	
	int ultima_battuta=last_bat;
	
	Bool quitJump = FALSE;
	char *array_label;
	int *arrayNumProg;
	// costruzione del vettore delle etichette presenti 
	array_label=new char[num_etich+1];
	arrayNumProg=new int[num_etich];
	// inserimento nel vettore  `array_label'  delle etichette presenti
	char c;
	int i=0;
	while ((c = pMusicWin->GetEtichetta(i)) != -1)
	{
		array_label[i] = c;
		arrayNumProg[i]=pMusicWin->GetBattEtichetta(c);
		i++;   
	}
	array_label[i]= '\0';
	
	// define widget
	// 
	DJumpInExec dialog;
	dialog.data=buffer;
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "jumpinexec"))
	{
		dialog.SetTitle(title);		
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	} 
	
	dialog.Centre(wxBOTH);
	
	
    dialog.ShowModal();  
	
	// fine del primo loop per la scelta : ricerca per label
	//                                     ricerca per battuta       
	if (!(strcmp(buffer,"LAB")))  
	{
		
		if (num_etich!=0)
		{
			
			quitJump=EDJumpLab("Label",buffer,max,num_etich,array_label,arrayNumProg);
		}
		else Message("No label present","Error!");
	}
	else if (!(strcmp(buffer,"BAT")))
	{
		if (last_bat>0)
		{
			quitJump=EDJumpBat("BAR",buffer,ultima_battuta);
		}
		else Message("No bar present","Error!"); 
	}
	
	return (quitJump);
}

/*
 **************************************************************************************************
 *
 *
 *	Finestra per il caricamento da File Midi
 *
 *
 **************************************************************************************************
 */
 

//////////////// classe
class DMidi : public wxDialog
{
public:
   	wxTextCtrl *format;
	wxTextCtrl *tracknumber;
	wxTextCtrl *PPQN;

	wxTextCtrl *NumTrack;
	wxComboBox *KeySign;
	int KeySignCode;

	char *path;
	
	void OnCancel(wxCommandEvent& event);
    void OnOk(wxCommandEvent& event);
	void InitInfo(wxString Filename);
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DMidi, wxDialog)
  	EVT_BUTTON(ID_MIDI_IMPORT, DMidi::OnOk)
	EVT_BUTTON(ID_MIDI_CANCEL, DMidi::OnCancel)
END_EVENT_TABLE()

//////////GLOBAL CONSTANTS///////////////////////

wxString keyM[15]={"Cb major","Gb major","Db major",
	"Ab major","Eb major","Bb major","F major",
	"C major","G major","D major","A major","E major",
	"B major","F# major","C# major"};
wxString keym[15]={"Ab minor","Eb minor","Bb minor",
	"F minor","C minor","G minor","D minor",
	"A minor","E minor","B minor","F# minor","C# minor",
	"G# minor","D# minor","A# minor"};

void DMidi::InitInfo(wxString Filename)
{
#ifdef WX226
	extern wxString keyM[], keym[];

	
	Midi_decoder midi_info ;
	Midi_struct info_struct;
	midi_info.Set_track_struct(&info_struct);
	wxString data;
	NumTrack->SetValue("0");
	midi_info.Load_file(Filename);
	midi_info.SMF_decode(TRACK_STRUCT);
	data.sprintf("%d", midi_info.Get_format());
	format->SetValue(data);
	data="0000";
	if (!midi_info.Get_format()) 
		data.sprintf("%d", midi_info.Get_Num_Midi_tracks());
	else data.sprintf("%d", midi_info.Get_Num_Midi_tracks()-1);
	tracknumber->SetValue(data);
	data="0000";
	data.sprintf("%d", midi_info.Get_PPQN());
	PPQN->SetValue(data);
	for(int i=0; i<15; i++)
		KeySign->Append(keyM[i]);
	for(i=0; i<15; i++)
		KeySign->Append(keym[i]);
	wxString key=info_struct.Get_key();
	if(pMusicWin==NULL)
	{
		if(MusicEditor!=NULL && MusicEditor->mainScore!=NULL)
			MusicEditor->mainScore->MIDI_coded_key=key;
	}
	else
		pMusicWin->PPartit->MIDI_coded_key=key;
	if(key == "MIDI key not coded")
		key = keyM[7]; //Do major valore di default
	KeySign->SetValue(key);
#endif
}

void DMidi::OnOk(wxCommandEvent& WXUNUSED(event))

{
	extern wxString keyM[], keym[];
	for (int i=0;i<15;i++)
	{	if (keym[i]==KeySign->GetValue()) 
			KeySignCode = i;
		if(keyM[i]==KeySign->GetValue())
			KeySignCode = i+15;
	}
	
	EndModal(ID_MIDI_IMPORT); 
}
  

void DMidi::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
  
  EndModal(ID_MIDI_CANCEL); 
}

//  Finestra di Input per i Files midi

int MidiReadWin(char *title,char *NomeFile, int *track, int &keySignCode)
{
  Bool quitMidi;
  char ctrak[10];
/*
  //  Il controllo serve per far funzionare il metodo anche quando non
  // esiste la finestra musicale (es. inizio del programma).
  if(pMusicWin!=NULL)
  {
     showTagli=pMusicWin->HideTagli();
  }
*/
  quitMidi=FALSE;

  strcpy(ctrak,"0 ");

  char filesPath[200];

  DMidi dialog;
/* chiamata alla finestra per il caricamento del file .mid
	memorizzi il percorso del file
*/
if (dialog.LoadFromResource(FrameManager::currFrame, "Midi"))
  {
	  dialog.SetTitle(title);		
	  dialog.format = (wxTextCtrl *)wxFindWindowByName("format", &dialog);
	  dialog.tracknumber = (wxTextCtrl *)wxFindWindowByName("tracks", &dialog);
	  dialog.PPQN = (wxTextCtrl *)wxFindWindowByName("ppqn", &dialog);
	  dialog.NumTrack = (wxTextCtrl *)wxFindWindowByName("trackselected", &dialog);
	  dialog.KeySign =(wxComboBox *)wxFindWindowByName("list_signature", &dialog);
  }
  else
  {
   wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
   return FALSE;
  }

	if (smrgetenv("SMR_MIDI_PATH")!=NULL) 
	  strcpy(filesPath, smrgetenv("SMR_MIDI_PATH"));
    else strcpy(filesPath, ".");

	try
	{
		wxString cwd=wxGetCwd();
		wxString filepath=wxFileSelector("Open Source File",filesPath,"","","Midi files (*.mid)|*.mid");
		wxSetWorkingDirectory(cwd);

		if(!filepath.IsEmpty())
		{
			dialog.InitInfo(filepath);
			dialog.Centre(wxBOTH);
		
			if (dialog.ShowModal()==ID_MIDI_IMPORT)
			{
				sprintf(ctrak,dialog.NumTrack->GetValue());
				quitMidi=TRUE;
				strcpy(NomeFile,filepath);
				ctrak[2]='U';
				ctrak[3]='\0';
				(*track)=atoi(ctrak);
				keySignCode = dialog.KeySignCode;
			}
		}
	}
	CATCHWXSTRING

 	return quitMidi;
}

/*
**************************************************************************************************
*
*
*	Finestra per Giustificazione
*
*
**************************************************************************************************
*/


//////////////// classe
class DJustify : public wxDialog
{
public:
   	// ne servir uno per tipo giust, uno per il parametro(ok textctrl)
	// uno per dabat uno per abat, textctrl
	// uno per measure
	// uno per i radiobox di perform operation
	wxTextCtrl *k;     // parametro k 
	wxTextCtrl *dbatt; // da battuta
	wxTextCtrl *abatt; // a battuta
	wxTextCtrl *meas;  // battuta singola 
	wxRadioBox *tipog;  // lineare o logaritmica 
	wxRadioButton *jall;  // just all 
	wxRadioButton *jdaa;  // just range 
	wxRadioButton *jmeas;  // just meas
	
	Bool YNJust;  // valore di ritorno della funzione globale
	// ritorna true solo se esco con OK
	int daBat;
    int aBat;
    TipoGiust tp;
	double kGiust;
	int nBatMax;
	
	void OnCancel(wxCommandEvent& event);
    void OnOk(wxCommandEvent& event);
	void OnHelp(wxCommandEvent& event);
    void OnChange(wxCommandEvent& event);
    void OnUpdate1(wxCommandEvent& event); 
    void OnUpdate2(wxCommandEvent& event); 
    void OnUpdate3(wxCommandEvent& event); 
    void OnCtrlenter(wxCommandEvent& event); 
    void OnClose(wxCommandEvent& event); 
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DJustify, wxDialog)
EVT_BUTTON(ID_JOK, DJustify::OnOk)
EVT_BUTTON(ID_JCANC, DJustify::OnCancel)
EVT_BUTTON(ID_JHELP, DJustify::OnHelp)
EVT_RADIOBOX(ID_RADIOBOX6134, DJustify::OnChange)
EVT_TEXT(ID_TEXTCTRL6149, DJustify::OnUpdate1)
EVT_TEXT(ID_TEXTCTRL6142, DJustify::OnUpdate2) 
EVT_TEXT(ID_TEXTCTRL6144, DJustify::OnUpdate3) 
EVT_TEXT_ENTER(ID_TEXTCTRL6144, DJustify::OnCtrlenter) 
EVT_CLOSE(DJustify::OnClose)

END_EVENT_TABLE()



void DJustify::OnOk(wxCommandEvent& WXUNUSED(event))
{
	// imposta dabattuta abattuta 
	// se jall da=1 a=0
	if (jall->GetValue()) 
	{
		daBat=1;
		aBat=0;
	}	  
	else if (jdaa->GetValue())	
	{
		daBat=atoi(dbatt->GetValue()); 
		aBat=atoi(abatt->GetValue()); 
	}  	
	else if (jmeas->GetValue())	
	{
		daBat=atoi(meas->GetValue()); 
		aBat=atoi(meas->GetValue()); 
	}  	
	
	// imposta il tipo di giustificazione
	if (tipog->GetSelection()==0) tp=G_LIN;
	else tp=G_LOG;
	
	// imposta il parametro k
	kGiust=atof(k->GetValue()); 
	
	if(daBat>nBatMax || aBat>nBatMax)
		Message("Measure not present");
	else
	{
		YNJust = TRUE;
		EndModal(ID_JOK);
	}
}

void DJustify::OnClose(wxCommandEvent& WXUNUSED(event) )
{
	YNJust = FALSE;
	EndModal(ID_JCANC); 
}


void DJustify::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
	YNJust = FALSE;
	EndModal(ID_JCANC); 
}

void DJustify::OnChange(wxCommandEvent& WXUNUSED(event) )
{
	if (tipog->GetSelection()==0) k->SetValue("12000");
	else k->SetValue("2");
}

void DJustify::OnUpdate1(wxCommandEvent& WXUNUSED(event) ) 
{ 
	jdaa->SetValue(TRUE); 
} 

void DJustify::OnUpdate2(wxCommandEvent& WXUNUSED(event) ) 
{ 
	jdaa->SetValue(TRUE); 
} 

void DJustify::OnUpdate3(wxCommandEvent& WXUNUSED(event) ) 
{ 
	jmeas->SetValue(TRUE); 
} 

void DJustify::OnCtrlenter(wxCommandEvent& WXUNUSED(event) ) 
{ 
    daBat=atoi(meas->GetValue());  
	aBat=atoi(meas->GetValue());  
	
	// imposta il tipo di giustificazione 
	if (tipog->GetSelection()==0) tp=G_LIN; 
	else tp=G_LOG; 
	
	// imposta il parametro k 
	kGiust=atof(k->GetValue());  
	
	if(daBat>nBatMax || aBat>nBatMax) 
		Message("Measure not present"); 
	else 
	{ 
		YNJust = TRUE; 
		EndModal(ID_JOK); 
	} 
	
} 


void DJustify::OnHelp(wxCommandEvent& WXUNUSED(event) )
{
	Message("Linear justification\n"
		"\t default value=12000 \n"
		"\t Give more to stretch and less to shrink \n"
		"\n Logarithmic justification\n"
		"\t default value=2 \n"
		"\t Give more to stretch and less to shrink \n ","Help");
	
}


////////////////////////////////
//funzione globale  
// parametri anche di uscita della finestra
// lin o log quale tipo di giustif
// param k
// all, range o singola misura    
Bool WJustify(int nBatMax,int* daBat, int* aBat, TipoGiust* tp, double* kGiust)
{
	
	
	Bool YNJust=FALSE;
    
	DJustify dialog;
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "giustificazione"))
	{
		dialog.SetTitle("Justification");		
		// controlla bene con dialoged quali sono i nomi dei controlli
		dialog.k = (wxTextCtrl *)wxFindWindowByName("t14", &dialog);
		dialog.dbatt = (wxTextCtrl *)wxFindWindowByName("t6", &dialog);
		dialog.abatt = (wxTextCtrl *)wxFindWindowByName("t9", &dialog);
		dialog.meas = (wxTextCtrl *)wxFindWindowByName("t11", &dialog);
		dialog.tipog = (wxRadioBox *)wxFindWindowByName("rb1", &dialog);
		dialog.jall = (wxRadioButton *)wxFindWindowByName("jall", &dialog);
		dialog.jdaa = (wxRadioButton *)wxFindWindowByName("jr", &dialog);
		dialog.jmeas = (wxRadioButton *)wxFindWindowByName("jm", &dialog);
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, NULL);
		return FALSE;
	}
	
	// setta i valori iniziali dei controlli
	
	// salva lo stato
	dialog.tipog->SetSelection(1); // per default la lineare
	dialog.k->SetValue("2");     // k di default della lineare=
	dialog.jall->SetValue(TRUE);  // per default giustifica tutto 
	dialog.nBatMax=nBatMax;
	
	dialog.Centre(wxBOTH);
	if (dialog.ShowModal()==ID_JOK)
	{
		// parametri di uscita
		*daBat=dialog.daBat;
		*aBat=dialog.aBat;
		*tp=dialog.tp;
		*kGiust=dialog.kGiust;
		
	}

	//valore di ritorno della funzione globale  
	YNJust=dialog.YNJust;
	
	
	return YNJust;
};




///////////////////////////////////////////////////////////////////////////////
//---------------------   Command List Widget  ------------------------------//
///////////////////////////////////////////////////////////////////////////////

//Implementazione oggetto finestra dialogo per ACL COMMAND LIST
class ACLDialog : public wxDialog
{
public:
   	wxListBox *listACL;
	
	void OnValidate(wxCommandEvent& event);
    void OnInvalidate(wxCommandEvent& event);
    void OnValidateAll(wxCommandEvent& event);
	void OnUndoLast(wxCommandEvent& event);
	void OnFlush(wxCommandEvent& event);
	void OnFind(wxCommandEvent& event);
	void OnFilter(wxCommandEvent& event);
	void OnLoad(wxCommandEvent& event);
	void OnSelect(wxCommandEvent& event);
	void OnSelectName(wxCommandEvent& event);
	void OnExit(wxCommandEvent& event); //equivale al Call_Ok
	void OnHelp(wxCommandEvent& event);
	
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(ACLDialog, wxDialog)
EVT_BUTTON(ID_ADDVALIDATE, ACLDialog::OnValidate)
EVT_BUTTON(ID_ADDINVAL, ACLDialog::OnInvalidate)
EVT_BUTTON(ID_ADDVALIDALL, ACLDialog::OnValidateAll)
EVT_BUTTON(ID_ADDUNDO, ACLDialog::OnUndoLast)
EVT_BUTTON(ID_ADDFLUSH, ACLDialog::OnFlush)
EVT_BUTTON(ID_ADDFIND, ACLDialog::OnFind)
EVT_BUTTON(ID_ADDFILTER, ACLDialog::OnFilter)
EVT_BUTTON(ID_ADDLOAD, ACLDialog::OnLoad)
EVT_CLOSE(ACLDialog::OnExit)
EVT_BUTTON(ID_ACLEXIT, ACLDialog::OnExit)
EVT_BUTTON(ID_ACLHELP, ACLDialog::OnHelp)
EVT_LISTBOX_DCLICK(ID_ADDLISTBOX,ACLDialog::OnSelectName)
EVT_LISTBOX(ID_ADDLISTBOX,ACLDialog::OnSelect)
END_EVENT_TABLE() 


static ACLDialog *acldialog=NULL;  

void ACLDialog::OnExit(wxCommandEvent& event)
{
	acldialog=NULL;
	Destroy();
}

void ACLDialog::OnHelp(wxCommandEvent& event)
{
	Message("Not yet implemented","Help");
}

void ACLDialog::OnValidate(wxCommandEvent& event)
{
	MyLog.Convalida(-1);
	if (MyLog.GetCurrentSelected()!=-1) listACL->SetSelection(MyLog.GetCurrentSelected());
}

void ACLDialog::OnInvalidate(wxCommandEvent& event)
{
	MyLog.Invalida(-1);
	if (MyLog.GetCurrentSelected()!=-1) listACL->SetSelection(MyLog.GetCurrentSelected());
}

void ACLDialog::OnValidateAll(wxCommandEvent& event)
{
	MyLog.ConvalidaAll();
}

void ACLDialog::OnUndoLast(wxCommandEvent& event)
{
	Message("Not yet implemented","Attention");
}

void ACLDialog::OnFlush(wxCommandEvent& event)
{
	MyLog.FlushFirstConvalidated();
}

void ACLDialog::OnFind(wxCommandEvent& event)
{
	if (MyLog.GetCurrentSelected()==-1) {
		Message("Select a Command.");
		return;
	}
	DrawObject *pFig;
	Battuta *pBat;

	LogListEntry *Entry;
	Entry=MyLog.GetEntry(MyLog.GetCurrentSelected(),TRUE);
	
	
	// Evidenzio la figura
	
	if (Entry==NULL || !MyLog.CatchFigure(&Entry->MyCmd,pBat,pFig)) {
		Message("Can't Find Object.");
		return;
	}
	if (pBat==NULL) {
		Message("Can't Find Object.");
		return;
	}
	// Vado alla battuta solo se non e' nella pagina corrente !
	pMusicWin->GoBattIfOut(pBat->GetNumProgress());
	if (pFig==NULL)  {
		// Evidenzio la battuta
		pBat->Select();
		Message("  Done  ");
		pBat->Deselect();
		return;
	}  
	Scr->GSetMainDrawArea();
	
	
	pFig->Select();
	Message("  Done  ");
	pFig->Deselect();
	
	return;
}

void ACLDialog::OnFilter(wxCommandEvent& event)
{
	WFilterList("Filtering Options");
	MyLog.ModifyWindow(FALSE);
}

void ACLDialog::OnLoad(wxCommandEvent& event)
{
	char NomeFile[10];
	
	if (!InputString("Filename : ",NomeFile,10,"Load & Execute ACL")) return;
	
	if (!MyLog.LoadAndExecute(NomeFile))
	{
		Message("Error Loading ACL");
	}
}

void ACLDialog::OnSelect(wxCommandEvent& event)
{
	MyLog.SetCurrentSelected(listACL->GetSelection());
}

void ACLDialog::OnSelectName(wxCommandEvent& event)
{
	char TextBox[255];
	MyLog.MakeDump(listACL->GetSelection(),TextBox);
	Message(TextBox,"Complete Symbolic Command Received");
}

/////////////////////////////////////////////////////////

#define LogDialogWidth	900
#define LogDialogHeight	300

#define DumpDialogWidth 250
#define DumpDialogHeight 160



void WCloseCommandList(void)
{
	if (acldialog!=NULL)
	{
		acldialog->Destroy();
		acldialog=NULL;
	}
}


void WUpdateCommandList(char** Stringhe,int cursel)
{ 
	int i=0;
	if (acldialog!=NULL)
	{
		if(acldialog->IsShown())
		{
			acldialog->listACL->Clear();
			while (Stringhe[i]!=NULL)
			{
				acldialog->listACL->Append(Stringhe[i]);
				i++;
			}
		}
		else
		{
			acldialog->Destroy();
			acldialog=NULL;
		}
	}
	
	
	MyLog.SetCurrentSelected(cursel); //funzione moods
}





/////////////////////////////////////////////////////////////////////
// funzione principale che gestisce la costruzione della ACLDialog //
/////////////////////////////////////////////////////////////////////
Bool WCommandList(char *title,/*const*/ char** Stringhe)
{	
	
	if (acldialog==NULL) 
	{ 
		acldialog = new ACLDialog();
		if (acldialog->LoadFromResource(FrameManager::currFrame, "additional"))
		{
			acldialog->SetTitle(title);
			acldialog->listACL = (wxListBox *)wxFindWindowByName("listbox14", acldialog);
			acldialog->Centre(wxBOTH);
		}
		else
		{
			wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
			return FALSE;
		} 
	}		
		
	acldialog->Show(TRUE);
	
	int i=0;
	
	BeginWait();
	
	acldialog->listACL->Clear();
	while (Stringhe[i]!=NULL)
	{
		acldialog->listACL->Append(Stringhe[i]);
		i++;
	}
	
	EndWait();
	
	return (TRUE) ;
	
}

//--------------------- Finestra di Filtraggio -----------------------------

class DFilter : public wxDialog
{
public:
   	wxListBox *listSx;
	wxListBox *listDx;
	wxTextCtrl *Measure;
	wxCheckBox *check;
	
	void OnToggleMeasure(wxCommandEvent& event);
	void OnWriteMeasure(wxCommandEvent& event);
    void OnReset(wxCommandEvent& event);
    void OnOk(wxCommandEvent& WXUNUSED(event));
	void OnCancel(wxCommandEvent& WXUNUSED(event));
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DFilter, wxDialog)
EVT_CHECKBOX(ID_BOXMEASURE, DFilter::OnToggleMeasure)
EVT_BUTTON(ID_FILTRESET, DFilter::OnReset)
EVT_BUTTON(ID_FILTOK, DFilter::OnOk)
EVT_BUTTON(ID_FILTCANCEL, DFilter::OnCancel)
EVT_TEXT(ID_FILTMEASURE, DFilter::OnWriteMeasure)
END_EVENT_TABLE()


void DFilter::OnCancel(wxCommandEvent& event)
{
	EndModal(ID_FILTCANCEL);
}

void DFilter::OnWriteMeasure(wxCommandEvent& event)
{
	if((!check->GetValue())&&(Measure->GetValue()!="")) 
	{
		check->SetValue(TRUE);
	}
}

void DFilter::OnToggleMeasure(wxCommandEvent& event)
{
	if (check->GetValue())
	{
		int Value=MyLog.CurrentFilter.GetNumBat();
		wxString Appo;
		Appo.Printf("%d",Value);
		Measure->SetValue(Appo);
	}
	else Measure->SetValue("");
	
}




void DFilter::OnReset(wxCommandEvent& event)
{
	MyLog.CurrentFilter.ResetFilter();
	EndModal(ID_FILTRESET);
}

void DFilter::OnOk(wxCommandEvent& WXUNUSED(event))
{
	if (check->GetValue())
	{
		MyLog.CurrentFilter.SetFilteringMode(FILTER_NUM_BAT);
		int Value=atoi (Measure->GetValue());
		MyLog.CurrentFilter.SetNumBat(Value);
	}
	else MyLog.CurrentFilter.ResetFilter();

	int Sel=listSx->GetSelection();
	if (Sel==0) MyLog.CurrentFilter.ClearFilteringMode(FILTER_PARTE);
	else
	{
		MyLog.CurrentFilter.SetFilteringMode(FILTER_PARTE);
		MyLog.CurrentFilter.SetNumPar(Sel-1);
	}
	
	EndModal(ID_FILTOK);
}	

////////////////////////////////////////////////////////////
////////////// funzione principale /////////////////////////
////////////////////////////////////////////////////////////
Bool WFilterList(char *title)
{
	
	char BattutaBox[255];
	
	
	DFilter dialog;
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "filteringoptions"))
	{
		dialog.SetTitle(title);
		dialog.Measure = (wxTextCtrl *)wxFindWindowByName("measure", &dialog);
		dialog.listSx = (wxListBox *)wxFindWindowByName("listsx", &dialog);
		dialog.listDx = (wxListBox *)wxFindWindowByName("listdx", &dialog);
		dialog.check=	(wxCheckBox *)wxFindWindowByName("check", &dialog);
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	} 
	
	if (MyLog.CurrentFilter.CheckFilter(FILTER_NUM_BAT)) 
	{
		sprintf(BattutaBox,"%d",MyLog.CurrentFilter.GetNumBat());
		dialog.check->SetValue(TRUE);
	} 
	else 
	{
		strcpy(BattutaBox,"");
		dialog.check->SetValue(FALSE);
	}
    
	dialog.Measure->SetValue(BattutaBox);
	
	// Creo e popolo la lista degli spartiti
	char Appo[200];
	
	dialog.listSx->Append("All");
	
	Spartito * Runner=pMusicWin->PPartit->GetFirstSpa();
	while(Runner!=NULL)
    {
		
		strcpy(Appo,"- ");
		strcat(Appo,Runner->GetNome());	        
		// Inserisco nella lista
		dialog.listSx->Append(Appo); 
		Runner=pMusicWin->PPartit->GetNextSpa(Runner);
    }
	
	
	
	if (MyLog.CurrentFilter.CheckFilter(FILTER_PARTE)) 
		dialog.listSx->SetSelection(MyLog.CurrentFilter.GetNumPar()+1);
	
	else 
		dialog.listSx->SetSelection(0);
	
	
	// Creo e popolo la lista dei musicanti
	
	char *Nome;
	int i=1;  
	int NumMusicisti=((MaMass *)(pMusicWin->PPartit))->GetNumMusicist();
	
	dialog.listDx->Append("All");
	
	while(i<=NumMusicisti)
    {
		strcpy(Appo,"- ");
		Nome=((MaMass *)(pMusicWin->PPartit))->GetMusicista(i-1);
		if (Nome!=NULL) 
			strcat(Appo,Nome);	
		else 
		{
			Message("Nome musicista mancante","Error!");        
			strcat(Appo,"Unknown");
		}
		// Inserisco nella lista
		dialog.listDx->Append(Appo);
		i++;    
	}
	
	
	
	
	if (MyLog.CurrentFilter.CheckFilter(FILTER_MUSICIST)) 
		dialog.listDx->SetSelection(MyLog.CurrentFilter.GetNumMus()+1);
	
	else 
		dialog.listDx->SetSelection(0);
	
	
	dialog.Centre(wxBOTH);
	dialog.ShowModal();

	return (True) ;
}

int WReadOper(char *title,char *Path,int max1,char *NomeFile,int max)
{
	ETTDial dialog; 
	Bool quitETT;
	
	
	quitETT=FALSE;
	wxString filesPath="/home/grassi/moods/source/opere/*";
	if (dialog.LoadFromResource(NULL, "ETTdialog"))
	{
		dialog.SetTitle(title);		
		dialog.ETTFile = (wxTextCtrl *)wxFindWindowByName("textctrl3", &dialog);
		dialog.listaETT = (wxListBox *)wxFindWindowByName("listbox7", &dialog);	
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, NULL);
		return FALSE;
	}
	
	
	dialog.max=max;
	wxString f = wxFindFirstFile(filesPath,wxDIR);
	while ( !f.IsEmpty())
	{
		dialog.listaETT->Append(wxFileNameFromPath(f));
		f = wxFindNextFile();
	}
	
	
	////////////////
	dialog.ETTFile->SetValue(dialog.listaETT->GetStringSelection());
	dialog.Centre(wxBOTH);
	
	if (dialog.ShowModal() == ID_ETT_BUTTOK)
	{
		strcpy(NomeFile,(dialog.ETTFile->GetValue()));
		
	}
	else quitETT=TRUE;
	strcpy(Path,NomeFile);
	strcat(Path,"/");
	
	return (!quitETT) ;
	
}



int WReadModo(char *title,char *Path,int max1,char *NomeFile,int max)
{
	return 0;
}


/*
**************************************************************************************
*
*
*	Finestra per la scelta dell'accordo (Cancel,Ok; 3 combo,1istbox +immagine)
*
*
**************************************************************************************
*/

#define TABL_CHORD_WIDTH  78
#define TABL_CHORD_HEIGHT 110

#if defined (__WXGTK__)
#define TABL_CHORD_POSX  365
#define TABL_CHORD_POSY 50
#endif


#if defined(__WXMSW__) 
#define TABL_CHORD_POSX 293
#define TABL_CHORD_POSY 64
#endif

class TablDial : public wxDialog
{
public:
    wxListBox *VarsList;
    wxComboBox *NStrings;
    wxComboBox *Notes;
    wxComboBox *Names;
    wxStaticBox *PreviewBox;
    wxStaticBitmap *Preview;
    void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
    void OnNStringsChange(wxCommandEvent& event);
    void OnNotesChange(wxCommandEvent& event);
    void OnNamesChange(wxCommandEvent& event);
    void OnVarsChange(wxCommandEvent& event);
    void Agg_Notes();
    void Agg_Names();
    void Agg_Vars();
    void Agg_Prev();
    void ClearChords();
    int CurNStrings;
    char CurNote[3];
    char CurName[30];
    DitaCorde *CurChord;
    DitaCorde **ListChords;
    int NChords;
    DitaFile *DB;
    LPixmap *previewBitmap;
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(TablDial, wxDialog)
EVT_BUTTON(ID_BUTTABLOK, TablDial::OnOk)
EVT_BUTTON(ID_BUTTABLCAN, TablDial::OnCancel)
EVT_COMBOBOX(ID_COMBONSTRINGS, TablDial::OnNStringsChange)
EVT_COMBOBOX(ID_COMBONOTES, TablDial::OnNotesChange)
EVT_COMBOBOX(ID_COMBONAMES, TablDial::OnNamesChange)
EVT_LISTBOX(ID_LISTVARS, TablDial::OnVarsChange)
END_EVENT_TABLE()

void TablDial::OnOk(wxCommandEvent& WXUNUSED(event) )
{
    EndModal(ID_BUTTABLOK);
}

void TablDial::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
	EndModal(ID_BUTTABLCAN);
}

void TablDial::OnNStringsChange(wxCommandEvent& WXUNUSED(event) )
{
	char app[2];
	strcpy(app,NStrings->GetStringSelection());
	CurNStrings=app[0]-'0';
	Agg_Notes();
	Agg_Names();
	Agg_Vars();
	Agg_Prev();
}

void TablDial::OnNotesChange(wxCommandEvent& WXUNUSED(event) )
{
	strcpy(CurNote,Notes->GetStringSelection());
	Agg_Names();
	Agg_Vars();
	Agg_Prev();
}

void TablDial::OnNamesChange(wxCommandEvent& WXUNUSED(event) )
{
	strcpy(CurName,Names->GetStringSelection());
	Agg_Vars();
	Agg_Prev();
}


void TablDial::OnVarsChange(wxCommandEvent& WXUNUSED(event) )
{
	CurChord=ListChords[VarsList->GetSelection()];
	Agg_Prev();
}

void TablDial::Agg_Notes(void)
{
	int appcount,i;
	char **matrix;
	
	Notes->Enable(TRUE);
	Notes->Clear();
	if((appcount=DB->NotesCount(CurNStrings))==0)
	{
		Notes->Append("None");
		Notes->Enable(FALSE);
		strcpy(CurNote,"");
		return;
	}
	matrix=(char **)malloc(appcount*sizeof(char *));
	for(i=0;i<appcount;i++)
		matrix[i]=(char *)malloc(3);
	DB->NotesList(CurNStrings,matrix);
	for(i=0;i<appcount;i++)
		Notes->Append(matrix[i]);
	free(matrix);
	if((i=Notes->FindString(CurNote))==-1)
		strcpy(CurNote,Notes->GetStringSelection());
	else
		Notes->SetSelection(i);   
}

void TablDial::Agg_Names(void)
{
	int appcount,i;
	char **matrix;
	char AppName[30];
	
	Names->Enable(TRUE);
	Names->Clear();
	if(CurNote[0]=='\0')
	{
		Names->Append("None");
		Names->Enable(FALSE);
		strcpy(CurName,"");
		return;
	}
	appcount=DB->NamesCount(CurNStrings,CurNote);
	matrix=(char **)malloc(appcount*sizeof(char *));
	for(i=0;i<appcount;i++)
		matrix[i]=(char *)malloc(30);
	DB->NamesList(CurNStrings,CurNote,matrix);
	for(i=0;i<appcount;i++)
		Names->Append(matrix[i]);
	free(matrix);
	strcpy(AppName,CurNote);
	strcat(AppName,(CurName[1]!='b')?CurName+1:CurName+2);
	strcpy(CurName,AppName);
	if((i=Names->FindString(CurName))==-1)
		strcpy(CurName,Names->GetStringSelection());
	else
		Names->SetSelection(i);   
}

void TablDial::Agg_Vars(void)
{
	int i;
	char **matrix,toAppend[60];
	int *vars;
	
	VarsList->Enable(TRUE);
	CurChord=NULL;
	ClearChords();
	VarsList->Clear();
	if(CurNote[0]=='\0')
	{
		VarsList->Append("None");
		VarsList->Enable(FALSE);
		return;
	}
	NChords=DB->VarsCount(CurNStrings,CurName);
	if(NChords>0)
	{
		matrix=(char **)malloc(NChords*sizeof(char *));
		vars=(int *)malloc(NChords*sizeof(int));
		ListChords=(DitaCorde **)malloc(NChords*sizeof(DitaCorde*));
		for(i=0;i<NChords;i++)
			matrix[i]=(char *)malloc(25);
		DB->VarsList(CurNStrings,CurName,matrix,vars,ListChords);
		for(i=0;i<NChords;i++)
		{
			sprintf(toAppend,"%-30s %d %-25s",CurName,vars[i],matrix[i]);
			VarsList->Append(toAppend);
		}
		free(matrix);
		CurChord=ListChords[0];
	}
}

void TablDial::Agg_Prev(void)
{
	extern wxMemoryDC *currMDC;
	Point orig=Point(0,Scr->GetMaxPixY());
	
	Scr->GSetPixmap(previewBitmap);
	Scr->SetColor(BIANCO);
	Scr->Rect(class Rectangle(orig,orig+Point(TABL_CHORD_WIDTH,-TABL_CHORD_HEIGHT)),TRUE);
	Scr->SetColor(NERO);
	
	if(CurChord!=NULL)
	{
		CurChord->SetPos(NULL,orig+Point(TABL_CHORD_WIDTH/2-5,-TABL_CHORD_HEIGHT/2));
		CurChord->Draw();
	}
	Scr->GResetPixmap();
	if(currMDC!=NULL)
		currMDC->SelectObject(wxNullBitmap);
	
	Preview->SetBitmap(*(wxBitmap*)previewBitmap->GetPixmap());
	Preview->Refresh(); 
}

void TablDial::ClearChords(void)
{
	int i;
	
	if(ListChords!=NULL)
		for(i=0;i<NChords;i++)
			delete(ListChords[i]);
		ListChords=NULL;
}

DitaCorde *InputTabl(char *TablFilePath)
{
	TablDial dialog;
	DitaCorde *Output;
	char str_nstrings[2]="0";
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "Tabl_Dial"))
	{
		dialog.VarsList = (wxListBox *)wxFindWindowByName("VarsList", &dialog);
		dialog.NStrings = (wxComboBox *)wxFindWindowByName("NStrings", &dialog);
		dialog.Notes = (wxComboBox *)wxFindWindowByName("Notes", &dialog);
		dialog.Names = (wxComboBox *)wxFindWindowByName("Names", &dialog);
		dialog.PreviewBox = (wxStaticBox *)wxFindWindowByName("PreviewBox", &dialog);
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, NULL);
		return NULL;
	}
	
	dialog.Centre(wxBOTH);
	dialog.Preview=new wxStaticBitmap(&dialog,-1,wxBitmap(TABL_CHORD_WIDTH,TABL_CHORD_HEIGHT),wxPoint(TABL_CHORD_POSX,TABL_CHORD_POSY));
	dialog.Preview->Show(TRUE);
	dialog.previewBitmap=new LPixmap(TABL_CHORD_WIDTH,TABL_CHORD_HEIGHT);
	dialog.DB=new DitaFile(TablFilePath);
	dialog.CurNStrings=6;
	dialog.NStrings->SetSelection(dialog.NStrings->FindString("6"));
	dialog.ListChords=NULL;
	dialog.CurChord=NULL;
	dialog.Agg_Notes();
	dialog.Agg_Names();
	dialog.Agg_Vars();
	dialog.Agg_Prev();
	if (dialog.ShowModal() == ID_BUTTABLOK && dialog.CurChord!=NULL)
	{
		Output=new DitaCorde(*(dialog.CurChord));
	}
	else
	{
		Output=NULL;
	} 
	dialog.ClearChords(); 
	dialog.DB->Close();
	delete dialog.previewBitmap;
	dialog.Destroy();
	return Output;
}


/*
***************************************************************************
*
*
*	Finestra con pulsanti, lista ed InputBox per ASSOCIAZIONE STRUMENTI-CANALI NEL MIDIEXPORT
*
*
***************************************************************************
*/
































/*
**************************************************************************************************
*
*
*	Finestra per Computer View Parameters
*
*
**************************************************************************************************
*/

//////////////// classe
class Dcwparameters : public wxDialog
{
public:
   	wxTextCtrl *top;  //prmode
	wxTextCtrl *bottom;  //res
	wxTextCtrl *left;  //staffn
	wxTextCtrl *right;
	wxTextCtrl *staffdistance;
	wxTextCtrl *scale;
	
	Bool YNCWpar;	//YNPrint
	int bottompar;  //resolution;
    int toppar;   //PMode;
    int leftpar;  //Pentnumber;
    int rightpar;  
    int staffdistpar;
	float scalepar;
	
	
	void OnCancel(wxCommandEvent& event);
    void OnOk(wxCommandEvent& event);
	void OnHelp(wxCommandEvent& event);
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(Dcwparameters, wxDialog)
EVT_BUTTON(ID_CWPAROK, Dcwparameters::OnOk)
EVT_BUTTON(ID_CWPARCANCEL, Dcwparameters::OnCancel)
EVT_BUTTON(ID_CWPARHELP, Dcwparameters::OnHelp)

END_EVENT_TABLE()



void Dcwparameters::OnOk(wxCommandEvent& WXUNUSED(event))
{
	
	toppar=atoi(top->GetValue());
	bottompar=atoi(bottom->GetValue());
	leftpar=atoi(left->GetValue());
	rightpar=atoi(right->GetValue());
	staffdistpar=atoi(staffdistance->GetValue());
	scalepar=atof(scale->GetValue());
	if(scalepar!=0.0)
	{
		YNCWpar = TRUE;
		EndModal(ID_CWPAROK);
	}
	else
		Message("Invalid scale factor.", "Error");
}


void Dcwparameters::OnCancel(wxCommandEvent& WXUNUSED(event) )
{
	YNCWpar = FALSE;
	EndModal(ID_CWPARCANCEL); 
}


void Dcwparameters::OnHelp(wxCommandEvent& WXUNUSED(event) )
{
	YNCWpar = FALSE;
	Message("Set the margins in the Computer View \n"
		,"Help");
	
}


////////////////////////////////
//funzione globale  
Bool ComputerViewParWindow(int* topparameter, int* bottomparameter, int* leftparameter, int* rightparameter, int* staffdistparameter, float* scaleparameter)  
{
	Bool YNCWpar=FALSE;
	
	Dcwparameters dialog;
	
	if (dialog.LoadFromResource(FrameManager::currFrame, "cwparameters"))
	{
		dialog.SetTitle("Computer View Parameters");		
		dialog.top = (wxTextCtrl *)wxFindWindowByName("textctrl90", &dialog);
		dialog.bottom = (wxTextCtrl *)wxFindWindowByName("textctrl93", &dialog);
		dialog.left = (wxTextCtrl *)wxFindWindowByName("textctrl94", &dialog);
		dialog.right = (wxTextCtrl *)wxFindWindowByName("textctrl2", &dialog);
		dialog.staffdistance = (wxTextCtrl *)wxFindWindowByName("textctrl1", &dialog);
		dialog.scale = (wxTextCtrl *)wxFindWindowByName("textctrl3", &dialog);		
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, FrameManager::currFrame);
		return FALSE;
	}
	
	
	wxString str;
	str.sprintf("%d",*topparameter);
	dialog.top->SetValue(str);

	str.sprintf("%d",*bottomparameter);
	dialog.bottom->SetValue(str);

	str.sprintf("%d",*leftparameter);
	dialog.left->SetValue(str);
	
	str.sprintf("%d",*rightparameter);
	dialog.right->SetValue(str);  
	
	str.sprintf("%d",*staffdistparameter);
	dialog.staffdistance->SetValue(str);
	
	str.sprintf("%.1f",*scaleparameter);
	dialog.scale->SetValue(str);
	
	dialog.Centre(wxBOTH);
	if (dialog.ShowModal()==ID_CWPAROK)
	{
		*topparameter=dialog.toppar;
		*bottomparameter=dialog.bottompar;
		*leftparameter=dialog.leftpar;
		*rightparameter=dialog.rightpar;
		*staffdistparameter=dialog.staffdistpar;
		*scaleparameter=dialog.scalepar;
	}
	
	
	YNCWpar=dialog.YNCWpar;
	
	
	return YNCWpar;
};



/*
**************************************************************************************************
*
*
*	Finestra per Debug MILLA
*
*
**************************************************************************************************
*/


//////////////// classe
class DDebugMilla : public wxDialog
{
public:
	wxTextCtrl *token;     // token 
	wxTextCtrl *rules; // rules and conditions
	
	
	Bool YNCWpar;	//YNPrint
	
	void OnOk(wxCommandEvent& event);
	void OnHelp(wxCommandEvent& event);
    
private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(DDebugMilla, wxDialog)
EVT_BUTTON(ID_BUTTON6001, DDebugMilla::OnOk)  //ok
EVT_BUTTON(ID_BUTTON6003, DDebugMilla::OnHelp)   //help

END_EVENT_TABLE()



void DDebugMilla::OnOk(wxCommandEvent& WXUNUSED(event))
{
    
	YNCWpar = TRUE;
	
	EndModal(ID_BUTTON6001);
	
}


void DDebugMilla::OnHelp(wxCommandEvent& WXUNUSED(event) )
{
	Message("On the left the tokens available for the symbol\n"
		"On the right the rules applied and the tokens \n"
		"verified belonging to the applied conditions \n");
	
}


////////////////////////////////
//funzione globale  

Bool WDebugMilla(void)
{
	
	Bool YNCWpar;
	
	DDebugMilla *dialog=new DDebugMilla;
	
	if (dialog->LoadFromResource(FrameManager::currFrame, "debugmilla"))
	{
		dialog->SetTitle("Debug MILLA");		
		// controlla bene con dialoged quali sono i nomi dei controlli
		dialog->token = (wxTextCtrl *)wxFindWindowByName("textctrl7", dialog);
		dialog->rules = (wxTextCtrl *)wxFindWindowByName("textctrl10", dialog);
		
		
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, NULL);
		return FALSE;
	}
	
	// setta i valori del liste testo multiline
	
	dialog->token->SetValue(msgtoken);  // token
	dialog->rules->SetValue(msgdebug);     // rules and conditions
	
	dialog->Centre(wxBOTH);
	
	dialog->Show(TRUE);
	
	
	
	
	
	YNCWpar=dialog->YNCWpar;
	
	
	return YNCWpar;
	
};
