/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: masaewin.hpp,v 1.2 2005/07/28 09:52:29 bellinpo Exp $ */

#ifndef MASAEWINDOW_HPP
#define MASAEWINDOW_HPP

#include "lioo.hpp"
#include "gui/lioowin.hpp"

class MasaeWindow: public LiooWindow
{
protected:
	
    Battuta *pBattutaExec;
	// battuta attualmente in esecuzione
    int DrawBarraPosX;
	// Posizione della baraa di riferimento
    
    short NumHit;
	// numero di correzioni di incremento e decremento della velocita' 
	// per la battuta attualmente in esecuzione
	
    
	// indica il numero di passi che devono essere
	// eseguiti per scrollare una battuta
    long Npassi;
    long NpassiTot;
    int InitialBatt;
    int Metr;
    int NumPagina;
    bool Terminata;
    bool Fine;
    
public:
	void WinInit(const Point&,VUnit w,VUnit h,Partitura *score=NULL);
	
    void StopScrolling();
    long GetNpassi();
    void CheckNpassi();
    short GetCountBatt();
    int GetInitialBatt();
	long GetNextTimeExec();
    void InitExec();
	void DrawScrollingIndicator(int color=black);
	int IncVelocEsec(int perc);
	Bool DecVelocEsec(int perc);

	int  GetNumHit( );
	void SetNumHit( int );
	
    Bool WaitStateEndBatt();
    Bool SetWaitState(Bool b);
    void JumpToBatt(NumCode);
    int GetJumpPos();
	
    void IncScrollingPos();
    Bool CheckScrollingEnd();    
    int GetScrollingWidth();
    int GetScrollingHeight();
	// ritorna il valore dell'altezza della porzione che 
	// verra' copiata durante lo scrolling
    
	// disegna l'indicatore di battuta
    void AltScrolling();    
    void StartScrolling();
	// attiva lo scrolling impostando il timer
	
    void TerminaImpaginazione();
	
    void SetMetr(int n);
    int GetMetr();
	
    void CursorWait();
    void CursorEditing();
    void CursorEsecuzione();
    void CursorGo();
    void Draw_Barre_Scrolling(void *data);
    void InitImpaginazione();
    void Draw_Barre_Scrolling_End(void *data);
    void Mio_Scrolling();
    void Fine_Esecuzione();
	
	void Draw();
	
};

#endif //MASAEWINDOW_HPP
