/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: masewin.hpp,v 1.1 2005/07/25 16:30:57 bellinpo Exp $ */


#ifndef MASEWINDOW_HPP
#define MASEWINDOW_HPP

#include "lioo.hpp"
#include "gui/lioowin.hpp"
#include "net/dimas.hpp"

class MaseWindow: public LiooWindow
{
protected:
    
public:
	void WinInit(const Point&,VUnit w,VUnit h,Partitura* score=NULL);
	
    void StopScrolling();
    void IncScrollingPos();
    Bool CheckScrollingEnd();    
    int GetScrollingWidth();
    int GetScrollingHeight();
	// ritorna il valore dell'altezza della porzione che 
	// verra' copiata durante lo scrolling
    
    void DrawScrollingIndicator(int color = black);
	// disegna l'indicatore di battuta
    
    void ImpostaBattPage(NumCode nc, NumCode np);
    Bool WaitStateEndBatt();
    Bool JumpStateEndBatt();
	
    void TerminaImpaginazione();
    void StartScrolling();
	// attiva lo scrolling impostando il timer
    void Draw_Barre_Scrolling(void *data);
};

#endif //MASEWINDOW_HPP
