/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/*
TimeSignDlg.hpp
*/

#ifndef TIMESIGNDLG_HPP
#define TIMESIGNDLG_HPP
#endif

#include "wx/wx.h"
#include "wx/resource.h"
#include "../bat/def_bat.hpp"
#include "../drw/frmanage.hpp"
#include "../bat/tempo.hpp"

class TimeSignDlg : public wxDialog
{
public:
   	TimeSignDlg();
	~TimeSignDlg();
		
	void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
	bool InitDlg();
	/* IMPLEMENTARE !!!!!!!!!
	Tempo GetTimeSignature();
    */
	// CANCELLARE
	wxString GetTimeSignature();
	//


protected:
	DECLARE_EVENT_TABLE()
    wxString TimeString; 
	// TimeString e' la stringa che rappresenta il tempo
	// Se il tempo ha rappresentazione interna ed esterna diverse 
	// ritorna una stringa concatenata con il token 
	
	//wxString Esterno, Interno;
	// Sono stringhe di appoggio per la rappresentazione esterna ed interna del tempo
	wxTextCtrl *tempo_interno; //l'utente vi inserisce il tempo esterno
	wxTextCtrl *tempo_esterno; //l'utente vi inserisce l'eventuale tempo esterno
	wxCheckBox *check_interno; //se ON l'utente inserisce manualmente il tempo interno
};



