/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: image.hpp,v 1.1 2005/07/25 16:31:14 bellinpo Exp $ */

#ifndef IMAGE_HPP
#define IMAGE_HPP
#include "drw/drawobje.hpp"


#include "wx/string.h"
class wxBitmap;

class Image : public DrawObject
{
  protected:
    Pixmap imap;
      // immagine caricata da file
    int w,h;
      // larghezza e altezza immagine
    wxString name;
	int scrhigh, scrwide;
	bool loaded;
	wxBitmap* Scale(wxBitmap* bitmap, int dh,int dw);
	bool isImageScore;
	wxArrayString imageVect;

  public:
     Image();
	 Image(int width, int height);
     ~Image();
     void Clear();
     void LoadImage(char *name);
	 void Load();
	 void LoadImage(char *fname, int Height, int Width);	
	 void UnLoad();
     void Draw();
     int GetVU2Up() { return h; };
     int GetVU2Dwn() { return 0; };
     int GetVU2Lft() { return 0; };
     int GetVU2Rgt() { return w; };
	 void Setup(char* fileName);
	 void SetName(wxString nameImg) {name = nameImg;};
	 void SetScrDimension( int , int );
	 void Fit2Window(){loaded = false;};
     char *GetName();
	 bool IsLoaded() {return loaded; };

	 void BlitImage(wxBitmap *pic, int x, int y); 
	 void RebuildPage();
	 void ScaleImg(int dh, int dw);
	 bool GetIsImageScore(){return isImageScore;}
	 void SetIsImageScore(bool isimgscore){isImageScore=isimgscore;}
	 wxArrayString * GetImageVect(){ return &imageVect;}
	 void SetDimension(int width, int height) {w=width; h=height;} 
};
#endif //IMAGE_HPP     
