/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: import.hpp,v 1.1 2005/07/25 16:31:15 bellinpo Exp $ */
/*---------------------------------------------------------------------
	File :  Import.hpp
	Modulo: IMP
	Descrizione: Header file che definisce la  generica classe di import
				da cui verranno derivate le varie implementazioni per i
				formati che MOODS dovra' gestire.
	
	Autore: 	Gambineri Luca (GL)
	Periodo:    Novembre 98
----------------------------------------------------------------------*/

#ifndef IMPORT_HPP
#define IMPORT_HPP


#include <stdio.h>
#include <stdlib.h>

class Partitura;

class Import
{
	protected:
		char *fileName;
		FILE *srcFile;
		Partitura *pPart;
	public:
		Import(char * = NULL);
		virtual ~Import();
		virtual char *GetFileName();
		virtual void SetPartitura(Partitura* pPartitura);
};

#endif // IMPORT.HPP
