/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: armonici.cpp,v 1.1 2005/07/25 16:31:17 bellinpo Exp $ */


#include "ind/armonici.hpp"
#include "drw/gscreen.hpp"
#include "gui/dialogs.hpp"


Armonici::Armonici(enum ClassID CL_ARM)
{
	if (CL_ARM==CL_ARMONICIARCHI)
	{
		ID=CL_ARMONICIARCHI;
		TipoArmonici='a';
	} 
	if (CL_ARM==CL_ARMONICIOTTONI)
	{ 
		ID=CL_ARMONICIOTTONI;
		TipoArmonici='o';
	}   
}

VUnit Armonici::GetVU2Up()
{
	if (TipoArmonici=='a')
		return ARMONICIARCHI2UP;
	if (TipoArmonici=='o')
		return ARMONICIOTTONI2UP; 
	return 0;
};

VUnit Armonici::GetVU2Dwn()
{
	if (TipoArmonici=='a')
		return ARMONICIARCHI2DWN;
	if (TipoArmonici=='o')
		return ARMONICIOTTONI2DWN;
	return 0;
};

VUnit Armonici::GetVU2Lft()
{
	if (TipoArmonici=='a')
		return ARMONICIARCHI2LFT;
	if (TipoArmonici=='o')
		return ARMONICIOTTONI2LFT;
	return 0;
};

VUnit Armonici::GetVU2Rgt()
{
	if (TipoArmonici=='a')
		return ARMONICIARCHI2RGT;
	if (TipoArmonici=='o')
		return ARMONICIOTTONI2RGT;
	return 0;
};


void Armonici::Draw()
{
	char code[2]={0,0};
	
	if (TipoArmonici=='a')
		code[0]=(char)CODE_ARMONICIARCHI;
	if (TipoArmonici=='o')
		code[0]=(char)CODE_ARMONICIOTTONI;
	
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	
	if (TipoArmonici=='a')
		Scr->TextTo(GetAbsPos()+Point(DELTAXARMONICIARCHI,DELTAYARMONICIARCHI)+Point( GetDx(),GetDy() ));
	if (TipoArmonici=='o')
		Scr->TextTo(GetAbsPos()+Point(DELTAXARMONICIOTTONI,DELTAYARMONICIOTTONI)+Point( GetDx(),GetDy() ));
	
	Scr->OutText((unsigned char *)code);
	

	Scr->SetColor(oldcol);
	
};

void Armonici::Edit(Battuta *pBat)

{
	
    EditingMarkersDlg(this);
	
}
