/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: def_ind.hpp,v 1.1 2005/07/25 16:31:18 bellinpo Exp $ */


#ifndef DEF_IND_HPP
#define DEF_IND_HPP

#define N_ESP_MAX 5  //Numero massimo di espressioni in espressione composta.

#define CODE_ARMONICIARCHI 200
#define DELTAXARMONICIARCHI Scr->Get_VU2DX(200)       
#define DELTAYARMONICIARCHI Scr->Get_VU2DY(200)       
#define ARMONICIARCHI2UP Scr->Get_VU2UP(200)          
#define ARMONICIARCHI2DWN Scr->Get_VU2DWN(200)        
#define ARMONICIARCHI2RGT Scr->Get_VU2RG(200)         
#define ARMONICIARCHI2LFT Scr->Get_VU2LF(200)         

#define CODE_ARMONICIOTTONI 201
#define DELTAXARMONICIOTTONI Scr->Get_VU2DX(201)       
#define DELTAYARMONICIOTTONI Scr->Get_VU2DY(201)       
#define ARMONICIOTTONI2UP Scr->Get_VU2UP(201)          
#define ARMONICIOTTONI2DWN Scr->Get_VU2DWN(201)        
#define ARMONICIOTTONI2RGT Scr->Get_VU2RG(201)         
#define ARMONICIOTTONI2LFT Scr->Get_VU2LF(201)         

#define CODE_MARTELLAUP 169-256 
#define UPDELTAXMARTELLA Scr->Get_VU2DX(169)       
#define UPDELTAYMARTELLA Scr->Get_VU2DY(169)       
#define UPMARTELLA2UP Scr->Get_VU2UP(169)          
#define UPMARTELLA2DWN Scr->Get_VU2DWN(169)         
#define UPMARTELLA2RGT Scr->Get_VU2RG(169)         
#define UPMARTELLA2LFT Scr->Get_VU2LF(169)         

#define CODE_MARTELLADWN 210-256
#define DWNMARTELLA2UP Scr->Get_VU2UP(210)         
#define DWNMARTELLA2DWN Scr->Get_VU2DWN(210)       
#define DWNMARTELLA2RGT Scr->Get_VU2RG(210)        
#define DWNMARTELLA2LFT Scr->Get_VU2LF(210)        
#define DWNDELTAXMARTELLA Scr->Get_VU2DX(210)       
#define DWNDELTAYMARTELLA Scr->Get_VU2DY(210)      

#define CODE_SFORZATOUP 94
#define UPDELTAXSFORZATO Scr->Get_VU2DX(94)       
#define UPDELTAYSFORZATO Scr->Get_VU2DY(94)       
#define UPSFORZATO2UP Scr->Get_VU2UP(94)          
#define UPSFORZATO2DWN Scr->Get_VU2DWN(94)        
#define UPSFORZATO2RGT Scr->Get_VU2RG(94)         
#define UPSFORZATO2LFT Scr->Get_VU2LF(94)         

#define CODE_SFORZATODWN 118
#define DWNSFORZATO2UP Scr->Get_VU2UP(118)          
#define DWNSFORZATO2DWN Scr->Get_VU2DWN(118)        
#define DWNSFORZATO2RGT Scr->Get_VU2RG(118)         
#define DWNSFORZATO2LFT Scr->Get_VU2LF(118)         
#define DWNDELTAXSFORZATO Scr->Get_VU2DX(118)       
#define DWNDELTAYSFORZATO Scr->Get_VU2DY(118)       

#define CODE_CONSORDINAOTTONI 43
#define DELTAXCONSORDINAOTTONI Scr->Get_VU2DX(43)       
#define DELTAYCONSORDINAOTTONI Scr->Get_VU2DY(43)       
#define CONSORDINAOTTONI2UP Scr->Get_VU2UP(43)          
#define CONSORDINAOTTONI2DWN Scr->Get_VU2DWN(43)        
#define CONSORDINAOTTONI2RGT Scr->Get_VU2RG(43)         
#define CONSORDINAOTTONI2LFT Scr->Get_VU2LF(43)         

#define CODE_CONSORDINAARCHI 133
#define DELTAXCONSORDINAARCHI Scr->Get_VU2DX(133)       
#define DELTAYCONSORDINAARCHI Scr->Get_VU2DY(133)       
#define CONSORDINAARCHI2UP Scr->Get_VU2UP(133)          
#define CONSORDINAARCHI2DWN Scr->Get_VU2DWN(133)        
#define CONSORDINAARCHI2RGT Scr->Get_VU2RG(133)         
#define CONSORDINAARCHI2LFT Scr->Get_VU2LF(133)         

#define CODE_VIASORDINAOTTONI 45
#define DELTAXVIASORDINAOTTONI Scr->Get_VU2DX(45)       
#define DELTAYVIASORDINAOTTONI Scr->Get_VU2DY(45)       
#define VIASORDINAOTTONI2UP Scr->Get_VU2UP(45)          
#define VIASORDINAOTTONI2DWN Scr->Get_VU2DWN(45)        
#define VIASORDINAOTTONI2RGT Scr->Get_VU2RG(45)         
#define VIASORDINAOTTONI2LFT Scr->Get_VU2LF(45)         

#define CODE_VIASORDINAARCHI 134
#define DELTAXVIASORDINAARCHI Scr->Get_VU2DX(134)       
#define DELTAYVIASORDINAARCHI Scr->Get_VU2DY(134)       
#define VIASORDINAARCHI2UP Scr->Get_VU2UP(134)          
#define VIASORDINAARCHI2DWN Scr->Get_VU2DWN(134)        
#define VIASORDINAARCHI2RGT Scr->Get_VU2RG(134)         
#define VIASORDINAARCHI2LFT Scr->Get_VU2LF(134)         

#define CODE_TENUTO 95
#define DELTAXTENUTO Scr->Get_VU2DX(95)       
#define DELTAYTENUTO Scr->Get_VU2DY(95)       
#define TENUTO2UP Scr->Get_VU2UP(95)          
#define TENUTO2DWN Scr->Get_VU2DWN(95)        
#define TENUTO2RGT Scr->Get_VU2RG(95)         
#define TENUTO2LFT Scr->Get_VU2LF(95)         

#define CODE_PUNTOALL 79
#define DELTAXPUNTOALL Scr->Get_VU2DX(79)    
#define DELTAYPUNTOALL Scr->Get_VU2DY(79)
#define PUNTOALL2UP Scr->Get_VU2UP(79)
#define PUNTOALL2DWN Scr->Get_VU2DWN(79)
#define PUNTOALL2RGT Scr->Get_VU2RG(79)
#define PUNTOALL2LFT Scr->Get_VU2LF(79)

#define CODE_STACCATO 107
#define DELTAXSTACCATO Scr->Get_VU2DX(107)       
#define DELTAYSTACCATO Scr->Get_VU2DY(107)       
#define STACCATO2UP Scr->Get_VU2UP(107)          
#define STACCATO2DWN Scr->Get_VU2DWN(107)        
#define STACCATO2RGT Scr->Get_VU2RG(107)         
#define STACCATO2LFT Scr->Get_VU2LF(107)         

#define CODE_ACCENTO 62
#define DELTAXACCENTO Scr->Get_VU2DX(62)       
#define DELTAYACCENTO Scr->Get_VU2DY(62)       
#define ACCENTO2UP Scr->Get_VU2UP(62)          
#define ACCENTO2DWN Scr->Get_VU2DWN(62)        
#define ACCENTO2RGT Scr->Get_VU2RG(62)         
#define ACCENTO2LFT Scr->Get_VU2LF(62)         

#define CODE_MARTDOLCEUP 60
#define UPDELTAXMARTDOLCE Scr->Get_VU2DX(60)       
#define UPDELTAYMARTDOLCE Scr->Get_VU2DY(60)       
#define UPMARTDOLCE2UP Scr->Get_VU2UP(60)          
#define UPMARTDOLCE2DWN Scr->Get_VU2DWN(60)         
#define UPMARTDOLCE2RGT Scr->Get_VU2RG(60)         
#define UPMARTDOLCE2LFT Scr->Get_VU2LF(60)         

#define CODE_MARTDOLCEDWN 61
#define DWNDELTAXMARTDOLCE Scr->Get_VU2DX(61)       
#define DWNDELTAYMARTDOLCE Scr->Get_VU2DY(61)       
#define DWNMARTDOLCE2UP Scr->Get_VU2UP(61)           
#define DWNMARTDOLCE2DWN Scr->Get_VU2DWN(61)          
#define DWNMARTDOLCE2RGT Scr->Get_VU2RG(61)         
#define DWNMARTDOLCE2LFT Scr->Get_VU2LF(61)         

#define CODE_DITEGGIATON0 '0'  
#define DELTAXDITEGGIATON0 Scr->Get_VU2DX(CODE_DITEGGIATON0, MUSICFONT2_ID) 
#define DELTAYDITEGGIATON0 Scr->Get_VU2DY(CODE_DITEGGIATON0, MUSICFONT2_ID)
#define DITEGGIATO2UPN0 Scr->Get_VU2UP(CODE_DITEGGIATON0, MUSICFONT2_ID) 
#define DITEGGIATO2DWNN0 Scr->Get_VU2DWN(CODE_DITEGGIATON0, MUSICFONT2_ID)
#define DITEGGIATO2RGTN0 Scr->Get_VU2RG(CODE_DITEGGIATON0, MUSICFONT2_ID) 
#define DITEGGIATO2LFTN0 Scr->Get_VU2LF(CODE_DITEGGIATON0, MUSICFONT2_ID) 

#define CODE_DITEGGIATON1 '1'  
#define DELTAXDITEGGIATON1 Scr->Get_VU2DX(CODE_DITEGGIATON1, MUSICFONT2_ID) 
#define DELTAYDITEGGIATON1 Scr->Get_VU2DY(CODE_DITEGGIATON1, MUSICFONT2_ID)
#define DITEGGIATO2UPN1 Scr->Get_VU2UP(CODE_DITEGGIATON1, MUSICFONT2_ID) 
#define DITEGGIATO2DWNN1 Scr->Get_VU2DWN(CODE_DITEGGIATON1, MUSICFONT2_ID)
#define DITEGGIATO2RGTN1 Scr->Get_VU2RG(CODE_DITEGGIATON1, MUSICFONT2_ID) 
#define DITEGGIATO2LFTN1 Scr->Get_VU2LF(CODE_DITEGGIATON1, MUSICFONT2_ID) 

#define CODE_DITEGGIATON2 '2'  
#define DELTAXDITEGGIATON2 Scr->Get_VU2DX(CODE_DITEGGIATON2, MUSICFONT2_ID) 
#define DELTAYDITEGGIATON2 Scr->Get_VU2DY(CODE_DITEGGIATON2, MUSICFONT2_ID)
#define DITEGGIATO2UPN2 Scr->Get_VU2UP(CODE_DITEGGIATON2, MUSICFONT2_ID) 
#define DITEGGIATO2DWNN2 Scr->Get_VU2DWN(CODE_DITEGGIATON2, MUSICFONT2_ID)
#define DITEGGIATO2RGTN2 Scr->Get_VU2RG(CODE_DITEGGIATON2, MUSICFONT2_ID) 
#define DITEGGIATO2LFTN2 Scr->Get_VU2LF(CODE_DITEGGIATON2, MUSICFONT2_ID) 

#define CODE_DITEGGIATON3 '3'  
#define DELTAXDITEGGIATON3 Scr->Get_VU2DX(CODE_DITEGGIATON3, MUSICFONT2_ID) 
#define DELTAYDITEGGIATON3 Scr->Get_VU2DY(CODE_DITEGGIATON3, MUSICFONT2_ID)
#define DITEGGIATO2UPN3 Scr->Get_VU2UP(CODE_DITEGGIATON3, MUSICFONT2_ID) 
#define DITEGGIATO2DWNN3 Scr->Get_VU2DWN(CODE_DITEGGIATON3, MUSICFONT2_ID)
#define DITEGGIATO2RGTN3 Scr->Get_VU2RG(CODE_DITEGGIATON3, MUSICFONT2_ID) 
#define DITEGGIATO2LFTN3 Scr->Get_VU2LF(CODE_DITEGGIATON3, MUSICFONT2_ID) 

#define CODE_DITEGGIATON4 '4'  
#define DELTAXDITEGGIATON4 Scr->Get_VU2DX(CODE_DITEGGIATON4, MUSICFONT2_ID) 
#define DELTAYDITEGGIATON4 Scr->Get_VU2DY(CODE_DITEGGIATON4, MUSICFONT2_ID)
#define DITEGGIATO2UPN4 Scr->Get_VU2UP(CODE_DITEGGIATON4, MUSICFONT2_ID) 
#define DITEGGIATO2DWNN4 Scr->Get_VU2DWN(CODE_DITEGGIATON4, MUSICFONT2_ID)
#define DITEGGIATO2RGTN4 Scr->Get_VU2RG(CODE_DITEGGIATON4, MUSICFONT2_ID) 
#define DITEGGIATO2LFTN4 Scr->Get_VU2LF(CODE_DITEGGIATON4, MUSICFONT2_ID) 

#define CODE_DITEGGIATON5 '5'  
#define DELTAXDITEGGIATON5 Scr->Get_VU2DX(CODE_DITEGGIATON5, MUSICFONT2_ID) 
#define DELTAYDITEGGIATON5 Scr->Get_VU2DY(CODE_DITEGGIATON5, MUSICFONT2_ID)
#define DITEGGIATO2UPN5 Scr->Get_VU2UP(CODE_DITEGGIATON5, MUSICFONT2_ID) 
#define DITEGGIATO2DWNN5 Scr->Get_VU2DWN(CODE_DITEGGIATON5, MUSICFONT2_ID)
#define DITEGGIATO2RGTN5 Scr->Get_VU2RG(CODE_DITEGGIATON5, MUSICFONT2_ID) 
#define DITEGGIATO2LFTN5 Scr->Get_VU2LF(CODE_DITEGGIATON5, MUSICFONT2_ID) 


#define CODE_DITEGGIATO1R0 65  
#define DELTAXDITEGGIATO1R0 Scr->Get_VU2DX(CODE_DITEGGIATO1R0, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO1R0 Scr->Get_VU2DY(CODE_DITEGGIATO1R0, MUSICFONT2_ID)
#define DITEGGIATO2UP1R0 Scr->Get_VU2UP(CODE_DITEGGIATO1R0, MUSICFONT2_ID) 
#define DITEGGIATO2DWN1R0 Scr->Get_VU2DWN(CODE_DITEGGIATO1R0, MUSICFONT2_ID)
#define DITEGGIATO2RGT1R0 Scr->Get_VU2RG(CODE_DITEGGIATO1R0, MUSICFONT2_ID) 
#define DITEGGIATO2LFT1R0 Scr->Get_VU2LF(CODE_DITEGGIATO1R0, MUSICFONT2_ID) 

#define CODE_DITEGGIATO1R1 66  
#define DELTAXDITEGGIATO1R1 Scr->Get_VU2DX(CODE_DITEGGIATO1R1, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO1R1 Scr->Get_VU2DY(CODE_DITEGGIATO1R1, MUSICFONT2_ID)
#define DITEGGIATO2UP1R1 Scr->Get_VU2UP(CODE_DITEGGIATO1R1, MUSICFONT2_ID) 
#define DITEGGIATO2DWN1R1 Scr->Get_VU2DWN(CODE_DITEGGIATO1R1, MUSICFONT2_ID)
#define DITEGGIATO2RGT1R1 Scr->Get_VU2RG(CODE_DITEGGIATO1R1, MUSICFONT2_ID) 
#define DITEGGIATO2LFT1R1 Scr->Get_VU2LF(CODE_DITEGGIATO1R1, MUSICFONT2_ID) 

#define CODE_DITEGGIATO1R2 67 
#define DELTAXDITEGGIATO1R2 Scr->Get_VU2DX(CODE_DITEGGIATO1R2, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO1R2 Scr->Get_VU2DY(CODE_DITEGGIATO1R2, MUSICFONT2_ID)
#define DITEGGIATO2UP1R2 Scr->Get_VU2UP(CODE_DITEGGIATO1R2, MUSICFONT2_ID) 
#define DITEGGIATO2DWN1R2 Scr->Get_VU2DWN(CODE_DITEGGIATO1R2, MUSICFONT2_ID)
#define DITEGGIATO2RGT1R2 Scr->Get_VU2RG(CODE_DITEGGIATO1R2, MUSICFONT2_ID) 
#define DITEGGIATO2LFT1R2 Scr->Get_VU2LF(CODE_DITEGGIATO1R2, MUSICFONT2_ID) 

#define CODE_DITEGGIATO1R3 68  
#define DELTAXDITEGGIATO1R3 Scr->Get_VU2DX(CODE_DITEGGIATO1R3, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO1R3 Scr->Get_VU2DY(CODE_DITEGGIATO1R3, MUSICFONT2_ID)
#define DITEGGIATO2UP1R3 Scr->Get_VU2UP(CODE_DITEGGIATO1R3, MUSICFONT2_ID) 
#define DITEGGIATO2DWN1R3 Scr->Get_VU2DWN(CODE_DITEGGIATO1R3, MUSICFONT2_ID)
#define DITEGGIATO2RGT1R3 Scr->Get_VU2RG(CODE_DITEGGIATO1R3, MUSICFONT2_ID) 
#define DITEGGIATO2LFT1R3 Scr->Get_VU2LF(CODE_DITEGGIATO1R3, MUSICFONT2_ID) 

#define CODE_DITEGGIATO1R4 69 
#define DELTAXDITEGGIATO1R4 Scr->Get_VU2DX(CODE_DITEGGIATO1R4, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO1R4 Scr->Get_VU2DY(CODE_DITEGGIATO1R4, MUSICFONT2_ID)
#define DITEGGIATO2UP1R4 Scr->Get_VU2UP(CODE_DITEGGIATO1R4, MUSICFONT2_ID) 
#define DITEGGIATO2DWN1R4 Scr->Get_VU2DWN(CODE_DITEGGIATO1R4, MUSICFONT2_ID)
#define DITEGGIATO2RGT1R4 Scr->Get_VU2RG(CODE_DITEGGIATO1R4, MUSICFONT2_ID) 
#define DITEGGIATO2LFT1R4 Scr->Get_VU2LF(CODE_DITEGGIATO1R4, MUSICFONT2_ID) 

#define CODE_DITEGGIATO1R5 70  
#define DELTAXDITEGGIATO1R5 Scr->Get_VU2DX(CODE_DITEGGIATO1R5, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO1R5 Scr->Get_VU2DY(CODE_DITEGGIATO1R5, MUSICFONT2_ID)
#define DITEGGIATO2UP1R5 Scr->Get_VU2UP(CODE_DITEGGIATO1R5, MUSICFONT2_ID) 
#define DITEGGIATO2DWN1R5 Scr->Get_VU2DWN(CODE_DITEGGIATO1R5, MUSICFONT2_ID)
#define DITEGGIATO2RGT1R5 Scr->Get_VU2RG(CODE_DITEGGIATO1R5, MUSICFONT2_ID) 
#define DITEGGIATO2LFT1R5 Scr->Get_VU2LF(CODE_DITEGGIATO1R5, MUSICFONT2_ID) 



#define CODE_DITEGGIATO2R0 71
#define DELTAXDITEGGIATO2R0 Scr->Get_VU2DX(CODE_DITEGGIATO2R0, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO2R0 Scr->Get_VU2DY(CODE_DITEGGIATO2R0, MUSICFONT2_ID)
#define DITEGGIATO2UP2R0 Scr->Get_VU2UP(CODE_DITEGGIATO2R0, MUSICFONT2_ID) 
#define DITEGGIATO2DWN2R0 Scr->Get_VU2DWN(CODE_DITEGGIATO2R0, MUSICFONT2_ID)
#define DITEGGIATO2RGT2R0 Scr->Get_VU2RG(CODE_DITEGGIATO2R0, MUSICFONT2_ID) 
#define DITEGGIATO2LFT2R0 Scr->Get_VU2LF(CODE_DITEGGIATO2R0, MUSICFONT2_ID) 

#define CODE_DITEGGIATO2R1 72 
#define DELTAXDITEGGIATO2R1 Scr->Get_VU2DX(CODE_DITEGGIATO2R1, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO2R1 Scr->Get_VU2DY(CODE_DITEGGIATO2R1, MUSICFONT2_ID)
#define DITEGGIATO2UP2R1 Scr->Get_VU2UP(CODE_DITEGGIATO2R1, MUSICFONT2_ID) 
#define DITEGGIATO2DWN2R1 Scr->Get_VU2DWN(CODE_DITEGGIATO2R1, MUSICFONT2_ID)
#define DITEGGIATO2RGT2R1 Scr->Get_VU2RG(CODE_DITEGGIATO2R1, MUSICFONT2_ID) 
#define DITEGGIATO2LFT2R1 Scr->Get_VU2LF(CODE_DITEGGIATO2R1, MUSICFONT2_ID) 

#define CODE_DITEGGIATO2R2 73 
#define DELTAXDITEGGIATO2R2 Scr->Get_VU2DX(CODE_DITEGGIATO2R2, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO2R2 Scr->Get_VU2DY(CODE_DITEGGIATO2R2, MUSICFONT2_ID)
#define DITEGGIATO2UP2R2 Scr->Get_VU2UP(CODE_DITEGGIATO2R2, MUSICFONT2_ID) 
#define DITEGGIATO2DWN2R2 Scr->Get_VU2DWN(CODE_DITEGGIATO2R2, MUSICFONT2_ID)
#define DITEGGIATO2RGT2R2 Scr->Get_VU2RG(CODE_DITEGGIATO2R2, MUSICFONT2_ID) 
#define DITEGGIATO2LFT2R2 Scr->Get_VU2LF(CODE_DITEGGIATO2R2, MUSICFONT2_ID) 

#define CODE_DITEGGIATO2R3 74
#define DELTAXDITEGGIATO2R3 Scr->Get_VU2DX(CODE_DITEGGIATO2R3, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO2R3 Scr->Get_VU2DY(CODE_DITEGGIATO2R3, MUSICFONT2_ID)
#define DITEGGIATO2UP2R3 Scr->Get_VU2UP(CODE_DITEGGIATO2R3, MUSICFONT2_ID) 
#define DITEGGIATO2DWN2R3 Scr->Get_VU2DWN(CODE_DITEGGIATO2R3, MUSICFONT2_ID)
#define DITEGGIATO2RGT2R3 Scr->Get_VU2RG(CODE_DITEGGIATO2R3, MUSICFONT2_ID) 
#define DITEGGIATO2LFT2R3 Scr->Get_VU2LF(CODE_DITEGGIATO2R3, MUSICFONT2_ID) 

#define CODE_DITEGGIATO2R4 75  
#define DELTAXDITEGGIATO2R4 Scr->Get_VU2DX(CODE_DITEGGIATO2R4, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO2R4 Scr->Get_VU2DY(CODE_DITEGGIATO2R4, MUSICFONT2_ID)
#define DITEGGIATO2UP2R4 Scr->Get_VU2UP(CODE_DITEGGIATO2R4, MUSICFONT2_ID) 
#define DITEGGIATO2DWN2R4 Scr->Get_VU2DWN(CODE_DITEGGIATO2R4, MUSICFONT2_ID)
#define DITEGGIATO2RGT2R4 Scr->Get_VU2RG(CODE_DITEGGIATO2R4, MUSICFONT2_ID) 
#define DITEGGIATO2LFT2R4 Scr->Get_VU2LF(CODE_DITEGGIATO2R4, MUSICFONT2_ID) 

#define CODE_DITEGGIATO2R5 76  
#define DELTAXDITEGGIATO2R5 Scr->Get_VU2DX(CODE_DITEGGIATO2R5, MUSICFONT2_ID) 
#define DELTAYDITEGGIATO2R5 Scr->Get_VU2DY(CODE_DITEGGIATO2R5, MUSICFONT2_ID)
#define DITEGGIATO2UP2R5 Scr->Get_VU2UP(CODE_DITEGGIATO2R5, MUSICFONT2_ID) 
#define DITEGGIATO2DWN2R5 Scr->Get_VU2DWN(CODE_DITEGGIATO2R5, MUSICFONT2_ID)
#define DITEGGIATO2RGT2R5 Scr->Get_VU2RG(CODE_DITEGGIATO2R5, MUSICFONT2_ID) 
#define DITEGGIATO2LFT2R5 Scr->Get_VU2LF(CODE_DITEGGIATO2R5, MUSICFONT2_ID) 


#define CODE_FITTIZIO_CONSORDINATESTO 26         
#define DELTAXCONSORDINATESTO Scr->Get_VU2DX(CODE_FITTIZIO_CONSORDINATESTO)           
#define DELTAYCONSORDINATESTO Scr->Get_VU2DY(CODE_FITTIZIO_CONSORDINATESTO)           

#define CODE_FITTIZIO_VIASORDINATESTO 27         
#define DELTAXVIASORDINATESTO Scr->Get_VU2DX(CODE_FITTIZIO_VIASORDINATESTO)           
#define DELTAYVIASORDINATESTO Scr->Get_VU2DY(CODE_FITTIZIO_VIASORDINATESTO)           



#endif //DEF_IND.HPP
