/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: espgenerica.cpp,v 1.1 2005/07/25 16:31:19 bellinpo Exp $ */


#include "ind/espgenerica.hpp"
#include "drw/gscreen.hpp" 
#include "liooext.hpp"

EspGenerica::EspGenerica(int Id)
{ 
	IDsym=Id;
	char *groupname;
	
	symname=simboli.GetSymName(Id);
	
	groupname=simboli.GetGroup(IDsym);
	IDgroup=simboli.GetGroupPos(groupname);
	
	ID=CL_ESPGENERIC;
	int fontid_tmp = IDgroup+6;
	simboli.SetDim(fontid_tmp, IDsym);
}

int EspGenerica::GetIDsym()
{
	return IDsym;
}
int EspGenerica::GetIDgroup()
{
	return IDgroup;
}

VUnit EspGenerica::GetVU2Up()
{
	return simboli.GetDim(IDsym,1);
}

VUnit EspGenerica::GetVU2Dwn()
{
	return simboli.GetDim(IDsym,2); 
}

VUnit EspGenerica::GetVU2Lft()
{
	return simboli.GetDim(IDsym,3); 
}

VUnit EspGenerica::GetVU2Rgt()
{
	return simboli.GetDim(IDsym,4);
}

void EspGenerica::Draw()
{
	int oldFont;
	int fontid_tmp;
	// qui devo ricevere il codice del simbolo dall'array di definizione del simbolo
	char code[2]={0,0};
	//fontid_tmp = simboli.GetGroupPos(simboli.GetGroup(IDsym))+6;
	fontid_tmp = IDgroup+6;
	// si trasla di 6 (i primi 6 font non sono generici)
	oldFont=Scr->SetFont(fontid_tmp);
	// salva il font corrente
	// set font in base al gruppo 	
	
	code[0]=simboli.GetCode(IDsym);
	
	simboli.SetDim(fontid_tmp, IDsym);
	// carica i numeri dal file .tbl
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());
	
	Scr->TextTo(GetAbsPos()+Point(simboli.GetDim(IDsym,5),simboli.GetDim(IDsym,6))+Point( GetDx(),GetDy() ));
	Scr->OutText((unsigned char *)code);
	Scr->SetFont(oldFont);
	// ripristina il vecchio font

	Scr->SetColor(oldcol);

};  
