/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: esprcomp.hpp,v 1.1 2005/07/25 16:31:19 bellinpo Exp $ */


#ifndef ESPRESSCOMPOSTA_HPP
#define ESPRESSCOMPOSTA_HPP

#include "lioo.hpp"
#include "ind/indicazi.hpp"
#include "ind/espressi.hpp"

class Nota;
class Battuta;


class EspressComposta : public Indicazione
{ 
	int n_espressioni;  //Numero di espressioni presenti in espressione composta.
	Espressione *espressioni[N_ESP_MAX];
	
public:              
	
    EspressComposta();
    ~EspressComposta();
    
    int Getn_espressioni();
	//Restituisce il numero di espressioni presenti nell'espressione composta
    Bool InserisciEsp(ClassID CL_ESP, TipoInserimento tpIns, Nota *pNota=NULL,
		Battuta *pBattuta=NULL, int IDsym=0);
    Bool InserisciEsp(ClassID CL_ESP,Bool AboveNota, int IDsym=0); 	
	//Inserisce una nuova espressione nell'espressione composta.
	//Restituisce TRUE se la nuova espressione viene inserita 
	//o FALSE altrimenti.
    Espressione *GetPEspressione(int i);
	//Restituisce l'i-esima espressione dell'espressione composta.	
    Espressione *GetPEspressione(CmdID MyId);
	
    Espressione *GetPEspressione(ClassID symbol, int IDsym=0);
    
    Bool DeleteSym(DrawObject *sym);
    Bool Hit(const Point&, SelObj, DrawObject*&, SymPath&);
    Bool SymbolicHit(SymPath&, SelObj, DrawObject*&);
    void Draw();
	
    VUnit GetVU2Up();
    VUnit GetVU2Dwn();
    VUnit GetVU2Lft();
    VUnit GetVU2Rgt();
	
    int SaveXML(FILE *);
};


#endif //ESPRESSCOMPOSTA_HPP
