/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: martdolc.cpp,v 1.1 2005/07/25 16:31:20 bellinpo Exp $ */


#include "ind/martdolc.hpp"
#include "drw/gscreen.hpp" 

MartDolce::MartDolce()
{ ID=CL_MARTDOLCE;}

VUnit MartDolce::GetVU2Up()
{
	if(aboveNota)
	{ 
		return UPMARTDOLCE2UP;
	}
	else
	{ 
		return DWNMARTDOLCE2UP;
	};
}; 

VUnit MartDolce::GetVU2Dwn()
{
	if(aboveNota)
	{
		return UPMARTDOLCE2DWN;
	}
	else
	{ 
		return DWNMARTDOLCE2DWN;
	};
};

VUnit MartDolce::GetVU2Lft()
{
	if(aboveNota)
	{
		return UPMARTDOLCE2LFT;
	}
	else
	{
		return DWNMARTDOLCE2LFT;
	};
};

VUnit MartDolce::GetVU2Rgt()
{
	if(aboveNota)
	{
		return UPMARTDOLCE2RGT;
	}
	else
	{
		return DWNMARTDOLCE2RGT;
	};
};

void MartDolce::Draw()
{
	char code[2]={0,0};
	
	if(aboveNota)
	{ 
		code[0]=CODE_MARTDOLCEUP; 
	}     
	else
	{
		code[0]=CODE_MARTDOLCEDWN;
	};
	
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	if(aboveNota)
	{
		Scr->TextTo(GetAbsPos()+Point(UPDELTAXMARTDOLCE,UPDELTAYMARTDOLCE)+Point( GetDx(),GetDy() ));
	}
	else
	{
		Scr->TextTo(GetAbsPos()+Point(DWNDELTAXMARTDOLCE,DWNDELTAYMARTDOLCE)+Point( GetDx(),GetDy() ));
	};
	
	
	Scr->OutText((unsigned char *)code);
	

	Scr->SetColor(oldcol);
};  
