/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: sordina.cpp,v 1.1 2005/07/25 16:31:22 bellinpo Exp $ */


#include "ind/sordina.hpp"


void Sordina::SetTipoSordina(char tipo)
{
	TipoSordina=tipo;
};

/*
void Sordina::SetColor(int col)
{ 
	Indicazione::SetColor(col);
	Text::SetColor(col);  
} 

int Sordina::GetColor()
{ 
	return Indicazione::GetColor();
}

void Sordina::SetOldColor(int col)
{ 
	Indicazione::SetOldColor(col);
	Text::SetOldColor(col); 
} 

int Sordina::GetOldColor()
{ 
	return Indicazione::GetOldColor();
}
*/

void Sordina::SetColor(const Colore& col)
{ 
	Indicazione::SetColor(col);
	Text::SetColor(col);  
} 

const Colore& Sordina::GetColor()
{ 
	return Indicazione::GetColor();
}

//void Sordina::SetOldColor(const Colore& col)
//{ 
//	Indicazione::SetOldColor(col);
//	Text::SetOldColor(col); 
//} 
//
//const Colore& Sordina::GetOldColor()
//{ 
//	return Indicazione::GetOldColor();
//}

void Sordina::SetPos(DrawObject *d,const Point& p)
{ 
	switch (TipoSordina)
	{ 
	case 'a':
	case 'o':
		Indicazione::SetPos(d,p);
		break;
	case 't':
		Text::SetPos(d,p); 
	}
}

void Sordina::Move(const Point& p)
{ 
	switch (TipoSordina)
	{ 
	case 'a':
	case 'o':
		Indicazione::Move(p);
		break;
	case 't':
		Text::Move(p); 
	}
}

Point Sordina::GetAbsPos()
{ 
	switch (TipoSordina)
	{ 
	case 'a':
	case 'o':
		return Indicazione::GetAbsPos();
		break;
	case 't':
		return Text::GetAbsPos(); 
	}
	return Point();
}

Bool Sordina::Hit(const Point& p, SelObj selObj, DrawObject*& drwObjSel,
				  SymPath& symPath)
{
	switch (TipoSordina)
	{ 
	case 'a':
	case 'o':
		return Indicazione::Hit(p, selObj, drwObjSel, symPath);
		break;
	case 't':
		return Text::Hit(p, selObj, drwObjSel, symPath);
	}
	return FALSE;
}


Bool Sordina::SymbolicHit(SymPath& symPath, SelObj selObj, DrawObject*& drwObjSel)
{
	switch (TipoSordina)
	{ 
	case 'a':
	case 'o':
		return Indicazione::SymbolicHit(symPath, selObj, drwObjSel);
		break;
	case 't':
		return Indicazione::SymbolicHit(symPath, selObj, drwObjSel); 
	}
	return FALSE;
}  

VUnit Sordina::GetVU2Up(){  return 0;
} 
VUnit Sordina::GetVU2Dwn(){  return 0;
}
VUnit Sordina::GetVU2Lft(){  return 0;
}
VUnit Sordina::GetVU2Rgt(){  return 0;
}   

void Sordina::Draw(){}

Bool Sordina::is(ClassID CLId)
{
	if (CLId==CL_SORDINA) return TRUE;
	return Indicazione::is(CLId);
} 


Bool Sordina::GetTraceMilla()
{
	return Indicazione::GetTraceMilla();
	
}


void Sordina::SetTraceMilla(Bool t)
{
	Indicazione::SetTraceMilla(t);
	
}
