/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: sordina.hpp,v 1.1 2005/07/25 16:31:22 bellinpo Exp $ */


#ifndef SORDINA_HPP
#define SORDINA_HPP

#include "ind/indicazi.hpp"
#include"drw/text.hpp"


class Sordina : public Indicazione, public Text
{ 
protected:
    char TipoSordina;
	// Attributo per indicare il tipo di sordina:
	// a se e' per archi, o se e' per ottoni, t se e' testo.
	
public:
    void SetTipoSordina(char tipo);
	// Imposta il tipo di sordina.
    void SetPos(DrawObject *d,const Point& p);
	// imposta la posizione assoluta dell'oggetto relativamente
	// al drawobject d. Se d==NULL imposta la posizione assoluta come 'p'.
    void Move(const Point& p);
	// Cambia la posizione dell'oggetto nello schermo      
    Point GetAbsPos();
	// Ritorna la posizione assoluta dell'oggetto grafico.
    //void SetColor(int col);
	// imposta il colore.
    //int GetColor();
	// ritorna il colore selezionato.
	//void SetOldColor(int col);
	//int GetOldColor();
 
	void SetColor(const Colore&);	//FFF
    const Colore& GetColor();//FFF

	//void SetOldColor(const Colore&);//FFF
	//const Colore& GetOldColor();//FFF


    Bool Hit(const Point& p, SelObj selObj, DrawObject*& drwObjSel,
	       SymPath& symPath);
    Bool SymbolicHit(SymPath& symPath, SelObj selObj, DrawObject*& drwObjSel);      
    
    VUnit GetVU2Up();
    VUnit GetVU2Dwn();
    VUnit GetVU2Lft();
    VUnit GetVU2Rgt();
    
    void Draw(); 
	
	
	Bool is(ClassID);
    // dice se l'oggetto puntato e' un'indicazione di sordina 
	
    //RDSRDS
    Bool GetTraceMilla();
    void SetTraceMilla(Bool t);
	//	void Edit(Battuta *pBat=NULL);

};

#endif //SORDINA_HPP
