/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: cambiori.cpp,v 1.1 2005/07/25 16:31:25 bellinpo Exp $ */


#include "int/cambiori.hpp"

void CambioRit::SetDim(VUnit w)
{
	SetWidth(w);
	SetHeight(Testo.GetHeight());
}


void CambioRit::SetText(unsigned char ch)
{
	unsigned char* pc;
	
	pc=new unsigned char[4];
	if(!pc)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","CambioRit","SetText"); 
	pc[0] =  ch;
	pc[1] = ' ';
	pc[2] = '.';
	pc[3] = '\0';
	
	Testo.SetFont(nTextFont);
	Testo.SetTxt(pc);
}

unsigned char CambioRit::GetText()
{
	unsigned char* pc = Testo.GetTxt();
	return pc[0];
}

void CambioRit::SetColor(int col)
{
	DrawObject::SetColor((ColorIcon)col);
	Testo.SetColor((ColorIcon)col);
	return;
}

void CambioRit::DrawSegm(IntEstSegment *p1)
{  
	Point p, pr;
	
	if(isOpaque)
		Scr->SetColor(GetColor());
	p = p1->AbsP + Point (DELTAXCAMBIORITLINE, DELTAYCAMBIORITLINE)+Point(GetDx(),GetDy());
;
	pr = p + Point(0,Testo.GetHeight());
	if ((p1 == GetPFirstSegm()) && (GetInizio()))
	{
		Testo.SetPos(NULL,p1->AbsP+Point(DELTAXCAMBIORIT,DELTAYCAMBIORIT)+Point(GetDx(),GetDy()));
		Testo.Draw();
		Scr->Line(p, pr ,SOLID_LINE);
	}
	
	Scr->Line(pr, pr + Point(GetWidth()+GetDxR()-GetDx(),0),SOLID_LINE);
}
