/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: def_int.hpp,v 1.1 2005/07/25 16:31:25 bellinpo Exp $ */


#ifndef DEF_INT_HPP
#define DEF_INT_HPP

#define INTERV_MIN_HEIGHT 3
#define INTERV_MAX_HEIGHT 200
#define INTERV_MIN_WIDTH 12
#define INTERV_MAX_WIDTH 120


// distinguere fra onda della classe onda e l'onda del trillonda
#define CODE_ONDA 114
#define DELTAXONDA Scr->Get_VU2DX(CODE_ONDA)       
#define DELTAYONDA Scr->Get_VU2DY(CODE_ONDA)       
#define ONDA2UP Scr->Get_VU2UP(CODE_ONDA)       
#define ONDA2DWN Scr->Get_VU2DWN(CODE_ONDA)       
#define ONDA2RGT Scr->Get_VU2RG(CODE_ONDA)       
#define ONDA2LFT Scr->Get_VU2LF(CODE_ONDA)       
#define WIDTHONDA 12

// distiuguere fra onda della classe onda e l'onda del trillonda
// QUESTA  L'ONDA DEL TRILLO CON ONDA A DUE PUNTI
#define CODE_FITTIZIO_ONDA_TRILLONDA 21
#define DELTAXONDATRILLONDA Scr->Get_VU2DX(CODE_FITTIZIO_ONDA_TRILLONDA)       
#define DELTAYONDATRILLONDA Scr->Get_VU2DY(CODE_FITTIZIO_ONDA_TRILLONDA)       

// ottava alta
#define CODE_OTTAVA 199
#define DELTAXOTTAVA Scr->Get_VU2DX(CODE_OTTAVA)       
#define DELTAYOTTAVA Scr->Get_VU2DY(CODE_OTTAVA)       
#define OTTAVA2UP Scr->Get_VU2UP(CODE_OTTAVA)          
#define OTTAVA2DWN Scr->Get_VU2DWN(CODE_OTTAVA)        
#define OTTAVA2RGT Scr->Get_VU2RG(CODE_OTTAVA)         
#define OTTAVA2LFT Scr->Get_VU2LF(CODE_OTTAVA)         
#define LUNGOTTAVA 15

// ottava bassa
#define CODE_OTTAVABA 154
#define DELTAXOTTAVABA Scr->Get_VU2DX(CODE_OTTAVABA, MUSICFONT2_ID)       
#define DELTAYOTTAVABA Scr->Get_VU2DY(CODE_OTTAVABA, MUSICFONT2_ID)       
#define OTTAVABA2UP Scr->Get_VU2UP(CODE_OTTAVABA, MUSICFONT2_ID)          
#define OTTAVABA2DWN Scr->Get_VU2DWN(CODE_OTTAVABA, MUSICFONT2_ID)        
#define OTTAVABA2RGT Scr->Get_VU2RG(CODE_OTTAVABA, MUSICFONT2_ID)         
#define OTTAVABA2LFT Scr->Get_VU2LF(CODE_OTTAVABA, MUSICFONT2_ID)         
#define LUNGOTTAVABA 15

// 15 MA
#define CODE_QMA 155
#define DELTAXQMA Scr->Get_VU2DX(CODE_QMA, MUSICFONT2_ID)       
#define DELTAYQMA Scr->Get_VU2DY(CODE_QMA, MUSICFONT2_ID)       
#define QMA2UP Scr->Get_VU2UP(CODE_QMA, MUSICFONT2_ID)          
#define QMA2DWN Scr->Get_VU2DWN(CODE_QMA, MUSICFONT2_ID)        
#define QMA2RGT Scr->Get_VU2RG(CODE_QMA, MUSICFONT2_ID)         
#define QMA2LFT Scr->Get_VU2LF(CODE_QMA, MUSICFONT2_ID)         
#define LUNGQMA 15

// 15 BA
#define CODE_QBA 156
#define DELTAXQBA Scr->Get_VU2DX(CODE_QBA, MUSICFONT2_ID)       
#define DELTAYQBA Scr->Get_VU2DY(CODE_QBA, MUSICFONT2_ID)       
#define QBA2UP Scr->Get_VU2UP(CODE_QBA, MUSICFONT2_ID)          
#define QBA2DWN Scr->Get_VU2DWN(CODE_QBA, MUSICFONT2_ID)        
#define QBA2RGT Scr->Get_VU2RG(CODE_QBA, MUSICFONT2_ID)         
#define QBA2LFT Scr->Get_VU2LF(CODE_QBA, MUSICFONT2_ID)         
#define LUNGQBA 15

#define LUNGTRATTO 6
#define LUN_SPAZIO 3
// verificare cosa significa; 

// tratto dell'ottava
#define CODE_FITTIZIO_TRATTOUP 19
#define DELTAXTRATTOUP Scr->Get_VU2DX(CODE_FITTIZIO_TRATTOUP)       
#define DELTAYTRATTOUP Scr->Get_VU2DY(CODE_FITTIZIO_TRATTOUP)       
#define TRATTOUP2UP Scr->Get_VU2UP(CODE_FITTIZIO_TRATTOUP)       
#define TRATTOUP2DWN Scr->Get_VU2DWN(CODE_FITTIZIO_TRATTOUP)       
#define TRATTOUP2RGT Scr->Get_VU2RG(CODE_FITTIZIO_TRATTOUP)       
#define TRATTOUP2LFT Scr->Get_VU2LF(CODE_FITTIZIO_TRATTOUP) 

// tratto dell'ottava
#define CODE_FITTIZIO_TRATTODWN 20
#define DELTAXTRATTODWN Scr->Get_VU2DX(CODE_FITTIZIO_TRATTODWN)       
#define DELTAYTRATTODWN Scr->Get_VU2DY(CODE_FITTIZIO_TRATTODWN)       
#define TRATTODWN2UP Scr->Get_VU2UP(CODE_FITTIZIO_TRATTODWN)       
#define TRATTODWN2DWN Scr->Get_VU2DWN(CODE_FITTIZIO_TRATTODWN)       
#define TRATTODWN2RGT Scr->Get_VU2RG(CODE_FITTIZIO_TRATTODWN)       
#define TRATTODWN2LFT Scr->Get_VU2LF(CODE_FITTIZIO_TRATTODWN) 

// classe LegatQuadra 
#define CODE_FITTIZIO_BEND 23
#define DELTAXBEND Scr->Get_VU2DX(CODE_FITTIZIO_BEND) 
#define DELTAYBEND Scr->Get_VU2DY(CODE_FITTIZIO_BEND) 
#define STANGHETTA Scr->Get_VU2LF(CODE_FITTIZIO_BEND)
#define YSHIFT Scr->Get_VU2RG(CODE_FITTIZIO_BEND)

// CambioRitornello 
#define CODE_FITTIZIO_CAMBIORIT 10
#define DELTAXCAMBIORIT Scr->Get_VU2DX(CODE_FITTIZIO_CAMBIORIT) 
#define DELTAYCAMBIORIT Scr->Get_VU2DY(CODE_FITTIZIO_CAMBIORIT) 

#define CODE_FITTIZIO_CAMBIORITLINE 9
#define DELTAXCAMBIORITLINE Scr->Get_VU2DX(CODE_FITTIZIO_CAMBIORITLINE) 
#define DELTAYCAMBIORITLINE Scr->Get_VU2DY(CODE_FITTIZIO_CAMBIORITLINE) 

// Freccia
#define FRECCIAMAXWIDTHPUNTA 20

// classe TrilloOnda
#define CODE_FITTIZIO_TRILLONDA 22
#define DELTAXTRILLONDA Scr->Get_VU2DX(CODE_FITTIZIO_TRILLONDA) 
#define DELTAYTRILLONDA Scr->Get_VU2DY(CODE_FITTIZIO_TRILLONDA) 


// classe pedale fino a
#define CODE_FITTIZIO_PEDFINOAUP 17
#define DELTAXPEDFINOAUP Scr->Get_VU2DX(CODE_FITTIZIO_PEDFINOAUP) 
#define DELTAYPEDFINOAUP Scr->Get_VU2DY(CODE_FITTIZIO_PEDFINOAUP) 
#define FROMPEDTOLINE 26

#define CODE_FITTIZIO_PEDFINOADWN 18
#define DELTAXPEDFINOADWN Scr->Get_VU2DX(CODE_FITTIZIO_PEDFINOADWN) 
#define DELTAYPEDFINOADWN Scr->Get_VU2DY(CODE_FITTIZIO_PEDFINOADWN) 

#define CODE_PALLINO 239                            
#define DELTAXPALLINO Scr->Get_VU2DX(CODE_PALLINO) 
#define DELTAYPALLINO Scr->Get_VU2DY(CODE_PALLINO) 

#define CODE_FITTIZIO_FORCELLA 4
#define DELTAXFORCELLA Scr->Get_VU2DX(CODE_FITTIZIO_FORCELLA) 
#define DELTAYFORCELLA Scr->Get_VU2DY(CODE_FITTIZIO_FORCELLA) 
// allargamento di sopra
#define UPFORCELLA     Scr->Get_VU2DWN(CODE_FITTIZIO_FORCELLA) 
// allargamento di sotto
#define DOWNFORCELLA   Scr->Get_VU2UP(CODE_FITTIZIO_FORCELLA) 

#endif //DEF_INT_HPP
