/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: forcella.cpp,v 1.1 2005/07/25 16:31:26 bellinpo Exp $ */


#include "int/forcella.hpp"
#include "gui/dialogs.hpp"

Forcella::Forcella()
{ 
	ID = CL_FORCELLA; lineType=SOLID_LINE; 
}

void Forcella::SetDim(VUnit w)
{
	VUnit h = 2*VU_PER_ROW+UPFORCELLA+DOWNFORCELLA; 
	
	SetWidth(w);
	
	// Per la simmetria del disegno, impone che Height sia pari.
	if(h % 2!=0)
		h--;
	SetHeight(h);               
}

void Forcella::SetCrescendo(Bool cr)
{ Crescendo = cr; }

Bool Forcella::GetCrescendo()
{ return Crescendo; }

void Forcella::SetLineType(LineType tp)
{ lineType = tp; }

LineType Forcella::GetLineType()
{ return lineType; }

int Forcella::GetHeight(void)
{
	SetHeight(2*VU_PER_ROW+UPFORCELLA);
	return (DrawObject::GetHeight()-DOWNFORCELLA);
}


void Forcella::AdjustVUFig()
{
	IntEsteso::AdjustVUFig();
	
	return;
	
	Figura *pF1, *pF2;
	IntEstSegment *p1 = PFirstSegm[currentView];
	
	if (p1==NULL) return;
	
	pF1 = GetPFigStart();
	if (pF1==NULL) return;
	
	pF2 = GetPFigEnd();
	if (pF2==NULL) return;
	
	if (Crescendo) 
	{ 
		if (Sopra) 
		{
			pF1->SetVU2Up(pF1->GetVU2Up()+2);
			if ((p1 != GetPFirstSegm()) || (!(GetInizio())))
				pF2->SetVU2Up(pF2->GetVU2Up()+3*GetHeight()/4+4);
			else
				pF2->SetVU2Up(pF2->GetVU2Up()+GetHeight()/2+4);
		}
		else
		{
			pF1->SetVU2Dwn(pF1->GetVU2Dwn()+2);
			if ((p1 != GetPFirstSegm()) || (!(GetInizio())))
				pF2->SetVU2Dwn(pF2->GetVU2Dwn()+3*GetHeight()/4+4);
			else
				pF2->SetVU2Dwn(pF2->GetVU2Dwn()+GetHeight()/2+4);
		}
	}
	else // Decrescendo 
	{
		if (Sopra) 
		{
			pF1->SetVU2Up(pF1->GetVU2Up()+GetHeight()+4);
			pF2->SetVU2Up(pF2->GetVU2Up()+2);
		}
		else
		{
			pF2->SetVU2Dwn(pF2->GetVU2Dwn()+2);
			if ((p1->pNext != NULL) || (!(GetFine())))
				pF1->SetVU2Dwn(pF1->GetVU2Dwn()+3*GetHeight()/4+4);
			else
				pF1->SetVU2Dwn(pF1->GetVU2Dwn()+GetHeight()/2+4);
		}
	}  
}


void Forcella::DrawSegm(IntEstSegment *p1)
{
	Point p;
	int alt=GetHeight();
	
	if(isOpaque)
		Scr->SetColor(GetColor());
	if(Crescendo)
	{
		if ((p1 != GetPFirstSegm()) || (!(GetInizio())))
		{
			p = p1->AbsP+Point(GetDx(),GetDy());
			Scr->Line(p + Point(0, 3*alt/4), 
                p1->AbsP + Point(GetWidth()+GetDxR(),alt+GetDy()),lineType);
			Scr->Line(p + Point(0, alt/4),
                p1->AbsP + Point(GetWidth()+GetDxR(), GetDy()),lineType);
		}
		else
		{
			p = p1->AbsP + Point(0, alt/2)+Point(GetDx(),GetDy());
			Scr->Line(p, p1->AbsP + Point(GetWidth()+GetDxR(), alt+GetDy()),lineType);
			Scr->Line(p, p1->AbsP + Point(GetWidth()+GetDxR(), GetDy()),lineType);
		}
	}
	
	else
	{
		if ((p1->pNext != NULL) || (!(GetFine())))
		{
			p = p1->AbsP + Point(GetWidth()+GetDxR(), GetDy());
			Scr->Line(p + Point(0, 3*alt/4), 
                p1->AbsP + Point(0, alt)+Point(GetDx(),GetDy()),lineType);
			Scr->Line(p+ Point(0, alt/4), p1->AbsP+Point(GetDx(),GetDy()),lineType);
		}
		else
		{
			p = p1->AbsP + Point(GetWidth()+GetDxR(), alt/2+GetDy());
			Scr->Line(p, p1->AbsP + Point(0, alt)+Point(GetDx(),GetDy()),lineType);
			Scr->Line(p, p1->AbsP+Point(GetDx(),GetDy()),lineType);
		}
	}
}

void Forcella::Edit(Battuta *pBat)
{
    EditingIntervalsDlg(this);
}