/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: freccia.cpp,v 1.1 2005/07/25 16:31:26 bellinpo Exp $ */


#include "int/freccia.hpp"

void Freccia::SetDim(VUnit w)
{
	VUnit h = w/6;
	
	SetWidth(w);
	
	// Per la simmetria del disegno, impone che Height sia pari.
	if(h%2!=0)
		h--;
	SetHeight(h);
}

void Freccia::DrawSegm(IntEstSegment *p1)
{
	Point p;
	VUnit largPunt;
	
	if(isOpaque)
		Scr->SetColor(GetColor());
	largPunt = (GetWidth()+GetDxR()-GetDx())*2/3;
	if (largPunt>FRECCIAMAXWIDTHPUNTA) largPunt = FRECCIAMAXWIDTHPUNTA;
	
	p = p1->AbsP + Point(GetWidth()+GetDxR(), GetHeight()/2+GetDy());

	Scr->Line(p,p1->AbsP+Point(GetDx(), GetHeight()/2+GetDy()),SOLID_LINE); 
	Scr->Line(p, p1->AbsP + Point(GetWidth()+GetDxR()-largPunt, GetDy()),SOLID_LINE);
	Scr->Line(p, p1->AbsP + Point(GetWidth()+GetDxR()-largPunt,GetHeight()+GetDy()),SOLID_LINE);  

}
