/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: interval.cpp,v 1.1 2005/07/25 16:31:26 bellinpo Exp $ */


#include "int/interval.hpp"

Bool Intervallo::TestAndSet(Figura *pFStart, Figura *pFEnd, Bool sopra)
{
	Bool result = TRUE;
	
	// Rifiuta i puntatori se coincidono.
	if(pFStart==pFEnd)
		return FALSE;
	
	// Gli estremi di un simbolo di intervallo possono essere solo note
	// ed accordi.
	
	if (pFStart != NULL)
	{
		switch(pFStart->GetID())
		{
		case CL_GRUPPONOTE:
		case CL_PQUATTROBATTUTE:
		case CL_PDUEBATTUTE:
		case CL_PSEMIBREVE:
		case CL_PMINIMA:
		case CL_PSEMIMINIMA:
		case CL_PCROMA:
		case CL_PSEMICROMA:
		case CL_PBISCROMA:
		case CL_PSEMIBISCROMA:
		case CL_RIPTEMPO:
		case CL_RIPBATTUTA:
		case CL_RIPMEZZABATTUTA:
			result = FALSE;
		}
	}
	
	if (pFEnd != NULL)
	{
		switch(pFEnd->GetID())
		{
		case CL_GRUPPONOTE:
		case CL_PQUATTROBATTUTE:
		case CL_PDUEBATTUTE:
		case CL_PSEMIBREVE:
		case CL_PMINIMA:
		case CL_PSEMIMINIMA:
		case CL_PCROMA:
		case CL_PSEMICROMA:
		case CL_PBISCROMA:
		case CL_PSEMIBISCROMA:
		case CL_RIPTEMPO:
		case CL_RIPBATTUTA:
		case CL_RIPMEZZABATTUTA:
			result = FALSE;
		}
	}
	
	if(result)
	{
		// Imposta gli attributi.
		PFigStart = pFStart;
		PFigEnd = pFEnd;
		Sopra = sopra;
	}
	return result;
}
