/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: legatval.cpp,v 1.1 2005/07/25 16:31:28 bellinpo Exp $ */


#include "int/legatval.hpp"
#include "fig/nota.hpp"

LegaturaValore::LegaturaValore()
{ 
	ID = CL_LEGATURA_VALORE; 
}

LegaturaValore::~LegaturaValore()
{ 
	if(PFigStart!=NULL)
		((Nota*)PFigStart)->SetTie(FALSE);
}

Bool LegaturaValore::TestAndSet(Figura *pFStart, Figura *pFEnd, Bool sopra)
{
	Bool result = IntEsteso::TestAndSet(pFStart,pFEnd,sopra);
	if (result)
		((Nota*)pFStart)->SetTie(TRUE);
	return result;
}
