/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: modifott.hpp,v 1.1 2005/07/25 16:31:28 bellinpo Exp $ */


#ifndef MODIFOTTAVA_HPP
#define MODIFOTTAVA_HPP

#include "lioo.hpp"

#include "int/interval.hpp"

enum Tipo8 {VA8, BA8, MA15, BA15};

class ModifOttava: public Intervallo
{
public:
    ModifOttava() { ID = CL_MODIFICA_OTTAVA; tipo8=VA8; Sopra=TRUE; };
    void SetDim(VUnit w);
	// imposta la larghezza passata come parametro e l'altezza calcolata in
	// base al tipo di simbolo musicale.
    Bool TestAndSet(Figura *pFStart, Figura *pFEnd, Bool sopra);
	// Controlla se i tipi di figura sono corretti per il tipo di
	// simbolo e, in caso affermativo, imposta gli attributi.
	
    void DrawSegm(IntEstSegment *);
	
	Tipo8 tipo8;
	void SetTipo8(Tipo8 tipo){tipo8 = tipo;};
	Tipo8 GetTipo8(){return tipo8;};
	
	int SaveXML(FILE *);
};


#endif //MODIFOTTAVA_HPP
