/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: pedalefinoa.cpp,v 1.1 2005/07/25 16:31:29 bellinpo Exp $ */


#include "int/pedalefinoa.hpp"


void PedaleFinoA::SetDim(VUnit w)
{
	VUnit h = 4*VU_PER_ROW; 
	
	SetWidth(w);
	SetHeight(h);
}


void PedaleFinoA::DrawSegm(IntEstSegment *p1)
{
	Point p;
	Point pr, prr;
	unsigned char ped[2];
	unsigned char pal[2];  
	
	if(isOpaque)
		Scr->SetColor(GetColor());
	
	ped[0]=CODE_PEDALDOWN;
	ped[1]=0;
	pal[0]=CODE_PALLINO;
	pal[1]=0;    
	
	if(Sopra)
		p = pr = p1->AbsP+Point(DELTAXPEDFINOAUP,DELTAYPEDFINOAUP)+Point(GetDx(),GetDy());  
	else
		p = pr = p1->AbsP+Point(DELTAXPEDFINOADWN,DELTAYPEDFINOADWN)+Point(GetDx(),GetDy());  
	
	Scr->TextTo(p);
	Scr->OutText((unsigned char *)ped);
	// line
	p.x=p.x+FROMPEDTOLINE;
	pr = pr + Point(GetWidth()+GetDxR()-GetDx(), 0);
	Scr->Line(p, pr,SOLID_LINE);
	// pallino
	prr = pr + Point (DELTAXPALLINO,DELTAYPALLINO);
	Scr->TextTo(prr);  
	Scr->OutText((unsigned char *)pal);
}




