/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#include "int/raggruppamento.hpp"
#include "liooext.hpp"
#include "gui/dialogs.hpp"

    
extern int DebugNormalMilla;
extern int DebugNormalMillaPos;
    
#define STAFF_DIST 23 
#define LGAMBOBEAMMIN 15

Raggruppamento::Raggruppamento(){

	Init();
}

void Raggruppamento::Init(){
	
//	Figura::Init();         
 	ID=CL_RAGGRUPPAMENTO;
	PFigStart=NULL;
 	// Imposta la lista vuota.
	this->FirstNota=NULL;
	this->LastNota=NULL;
	this->FirstRealFig=NULL;
	this->LastRealFig=NULL;
	//this->NumNote=0;
 	//first=NULL;
 	//last=NULL;
 	//numobject=0;
 	beamPos=BEAM_UP;//GB
 	// Inizializza gli attributi. 
 	//SetNumNote(); 
 	//SetFirstNota((Nota*)FirstFig);
 	//SetLastNota((Nota*)GetLastFigura());
	SetNotina(FALSE);
 	SetSpaceWidth(SPACEWIDTHDEF);
 	SetLGambo(0,1);
 	// Inizializza NoteID con CL_RAGGRUPPAMENTO come segnale che nel gruppo
 	// non ci sono ancora note.
 	SetNoteID(CL_RAGGRUPPAMENTO);
 	NBarre[1]=0;
 	GetBPoint1(1)=Point(0,0);
 	GetBPoint2(1)=Point(0,0);
	BSlope[currentView][1]=0;
}
/*FFF
int Raggruppamento::SaveXML(FILE *fp)
{
	return IntEsteso::SaveXML(fp,"BEAM");
}
FFF*/
void Raggruppamento::DrawSegm(IntEstSegment *p1)

{
	SetNumLayer();
	//Adjust(TRUE,this->GetFirstBattuta(),this->GetNumLayer(),1);
	//DrawBarre();
	if(GetFirstFigura()->HastobeDraw())
	{
		SetNumLayer();
		SetNumNote();
		//Adjust(TRUE,this->GetFirstBattuta(),this->GetNumLayer(),0);

 		//Node *pnode;
 		//Figura *pfig;
     
 //		Hilite(0,Scr);
 		
 	                                    
		if(isOpaque)
			Scr->SetColor(GetColor());  
 		//pfig=GetFirstFigura();
 		/*while(pfig!=NULL)
 		{         
			 //((Nota*)pfig)->SetCoda(FALSE);
			 
			 //pfig->Adjust(TRUE,pfig->GetPBattuta(),GetNumLayer(),0);
			 //pfig->Draw();
			 //pfig=GetNextFigura(pfig);
			 
			 //pnode=pnode->Next;
 		} */
 		
		//((GetFirstFigura()->GetPBattuta())->GetParentScore())->Draw();

     
		if(isOpaque)
			Scr->SetColor(GetColor());  //PB1
     
 		
		
			DrawBarre(p1->numSegment);
			//GetBPoint1(i)=Point(0,0);
 			//GetBPoint2(i)=Point(0,0);
	
		//DrawBarre(2);
		//DrawBarre(3);
     
 //		Hilite(1,Scr); 
			
		//if(pfig!=NULL)
		//((pfig->GetPBattuta())->GetParentScore())->DrawInExecution();

		//Adjust(TRUE,this->GetFirstBattuta(),this->GetNumLayer(),0);
	}

	//Adjust(TRUE,this->GetFirstBattuta(),this->GetNumLayer(),0);
	//((GetFirstFigura()->GetPBattuta())->GetParentScore())->Redraw();

	//Draw();
	
}

void Raggruppamento::AdjustVUFig(){


	/*if((FirstRealFig==NULL)&&(LastRealFig)){
		FirstRealFig=PFigStart;
		LastRealFig=PFigEnd;
	}*/
	SetNumLayer();
	for(int i=1; i<=MAX_NUM_SEGMENT;i++){
		GetBPoint1(i)=Point(0,0);
 		GetBPoint2(i)=Point(0,0);
	}

	IntEstSegment *p1;
	p1=this->GetPFirstSegm();
	int index=1;
	while(p1!=NULL){
		p1->numSegment=index;
		index++;
		p1=p1->pNext;
	}

	Figura *FirstFig, *LastFig;
	Battuta *FirstBat, *LastBat, *FirstRaggrupBat, *LastRaggrupBat, *FirstVisibleBat, *LastVisibleBat;
	Battuta *currentBat;
	int nFirstBat=0,nLastBat=0,nLastRaggrupBat=0,nFirstRaggrupBat=0,nFirstVisibleBat=0,nLastVisibleBat=0,ncurrentBat=0;
	FirstFig=GetFirstFigura();
	LastFig=GetLastFigura();
	FirstBat=GetFirstBattuta();
	LastBat=GetLastBattuta();
	if ((FirstFig!=NULL)&&(LastFig!=NULL)){
		FirstRaggrupBat=FirstFig->GetPBattuta();
		LastRaggrupBat=LastFig->GetPBattuta();
		FirstVisibleBat=(FirstRaggrupBat->GetParentScore())->GetfirstBatPage();
		Battuta *NextPageBat=(FirstRaggrupBat->GetParentScore())->GetfirstBatNextPage();
		if(NextPageBat!=NULL)
			LastVisibleBat=(FirstRaggrupBat->GetParentScore())->GetPrevBat(NextPageBat);
		else
			LastVisibleBat=(FirstRaggrupBat->GetParentScore())->GetLastBat();
	SetNumLayer();
	
	short current_staff=GetFirstFigura()->GetNStaff();
	short numSegment=1;
	nFirstBat=FirstBat->GetNumProgress();
 	nLastBat=LastBat->GetNumProgress();
	nFirstRaggrupBat=FirstRaggrupBat->GetNumProgress();
	nFirstVisibleBat=FirstVisibleBat->GetNumProgress();
	nLastVisibleBat=LastVisibleBat->GetNumProgress();
	nLastRaggrupBat=LastRaggrupBat->GetNumProgress();
	currentBat=LastBat;
	Battuta *FirstBattuta=NULL;
	int limite =GetBattuta(2)->GetNumProgress();
	if(limite>nLastVisibleBat)
		limite=nLastVisibleBat;
	FirstBattuta=FirstFig->GetPBattuta();
	ncurrentBat=currentBat->GetNumProgress();
	while((ncurrentBat<=limite)&&(FirstBattuta)){
		if(GetPSegment(numSegment)){
			GetPSegment(numSegment)->FirstFig=FirstFig;
			GetPSegment(numSegment)->LastFig=LastFig;
		}
		Adjust(TRUE,FirstFig->GetPBattuta(),this->GetNumLayer(),current_staff,numSegment,FirstFig,LastFig);
		if(ncurrentBat<limite){
			//FirstFig=(FirstBat->GetPLayer(GetNumLayer()))->GetNextFigura(LastFig);
			
			FirstBattuta=((FirstBattuta->GetParentScore())->GetNextBat(LastBat));
			if(FirstBattuta){
			FirstFig=(FirstBattuta->GetPLayer(GetNumLayer()))->GetFirstFig();
			//FirstFig=GetNextFigura(LastFig);
			LastFig=this->GetFineSegmento(FirstFig);
			currentBat=LastFig->GetPBattuta();
			ncurrentBat=currentBat->GetNumProgress();
			numSegment++;
			FirstBattuta=FirstFig->GetPBattuta();
			LastBat=LastFig->GetPBattuta();
			}
		}
		else ncurrentBat++;
		
	}
}
	/*IntEstSegment *p1;
	p1=this->GetPFirstSegm();
	int index=1;
	while(p1!=NULL){
		p1->numSegment=index;
		index++;
		p1=p1->pNext;
	}*/

}
/*FFF
void Raggruppamento::printSegm(IntEstSegment *p1)
{
	
			printBarre(p1->numSegment);
			
}
FFF*/
void Raggruppamento::SetDim(VUnit w)
{
	/*Adjust(TRUE,this->GetFirstBattuta(),this->GetNumLayer(),0);
	Figura *pfig=GetFirstFigura();
	VUnit a=(pfig->GetAbsPos()).x;
	//a+=pfig->GetVU2LftF();
	a+=((pfig->GetPBattuta())->GetAbsPos()).x;
	a+=(pfig->GetPBattuta())->GetSpazioIniziale();


	this->SetAbsPosX(a);*/
}



void Raggruppamento::SetNumNote(int nn){

	this->NumNote=nn;
}

void Raggruppamento::SetNumNote(){

	Figura *f1,*f2;
	f1=GetFirstFigura();
	f2=GetLastFigura();
	int nn=1;
	while((f1!=f2)&&(f1!=NULL)){
		nn++;
		f1=GetNextFigura(f1);	
		}
    SetNumNote(nn);
}

int Raggruppamento::GetNumNote()
{
	return NumNote;
}


void Raggruppamento::SetFirstNota(Nota *pn) 
{
	FirstNota=pn;
} 


Nota* Raggruppamento::GetFirstNota()
{ 
 	return FirstNota;
}    


void Raggruppamento::SetLastNota(Nota *pn)
{
 	LastNota=pn;
}                
 
 
Nota* Raggruppamento::GetLastNota()
{ 
 	return LastNota;
} 

void Raggruppamento::SetFirstFigura(Figura *pfig)
{
	SetPFigStart(pfig);
}

Figura* Raggruppamento::GetFirstFigura()
{
	Figura *FirstFig, *LastFig;
	Battuta *FirstRaggrupBat, *LastRaggrupBat, *FirstVisibleBat, *LastVisibleBat;
	Battuta *FirstNextRigoBat=NULL, *LastRigoBat=NULL;
	int nFirstRaggrupBat=0, nLastRaggrupBat=0, nFirstVisibleBat=0, nLastVisibleBat=0;
	int nFirstNextRigoBat=0, nLastRigoBat=0;
	FirstRaggrupBat=NULL;
	LastRaggrupBat=NULL;
	FirstVisibleBat=NULL;
	LastVisibleBat=NULL;
	FirstFig=GetPFigStart();
	LastFig=GetPFigEnd();
	/*if((FirstRealFig==NULL)&&(LastRealFig==NULL)){
		FirstRealFig=GetPFigStart();
		LastRealFig=GetPFigEnd();
	}
	FirstFig=FirstRealFig;
	LastFig=LastRealFig;*/
	if ((FirstFig!=NULL)&&(LastFig!=NULL)){
		FirstRaggrupBat=FirstFig->GetPBattuta();
		LastRaggrupBat=LastFig->GetPBattuta();
		FirstVisibleBat=(FirstRaggrupBat->GetParentScore())->GetfirstBatPage();
		Battuta *NextPageBat=(FirstRaggrupBat->GetParentScore())->GetfirstBatNextPage();
		if(NextPageBat!=NULL)
			LastVisibleBat=(FirstRaggrupBat->GetParentScore())->GetPrevBat(NextPageBat);
		else
			LastVisibleBat=(FirstRaggrupBat->GetParentScore())->GetLastBat();
		nFirstRaggrupBat=FirstRaggrupBat->GetNumProgress();
		nLastRaggrupBat=LastRaggrupBat->GetNumProgress();
		nFirstVisibleBat=FirstVisibleBat->GetNumProgress();
		nLastVisibleBat=LastVisibleBat->GetNumProgress();
		if((nFirstRaggrupBat<nFirstVisibleBat)&&(nLastRaggrupBat>=nFirstVisibleBat)){

			SetNumLayer();
			FirstFig=(FirstVisibleBat->GetPLayer(GetNumLayer()))->GetFirstFig();

		}
		
		
	}

	Battuta* currentBat;
	bool stop=FALSE;
	if(FirstFig!=NULL){
		currentBat=FirstFig->GetPBattuta();
	/*	while((currentBat!=NULL)&&(stop==FALSE)){
			nextBattuta=(currentBat->GetParentScore())->GetNextBat(currentBat);
			if(nextBattuta->GetBattuta()==INIZIO_PENTAGRAMMA){

				FirstNextRigoBat=nextBattuta;
				nFirstNextRigoBat=FirstNextRigoBat->GetNumProgress();
				LastRigoBat=currentBat;
				nLastRigoBat=LastRigoBat->GetNumProgress();
				stop=TRUE;
			}

		}*/
	}


	return FirstFig;
}

void Raggruppamento::SetLastFigura(Figura *pfig)
{
	SetPFigEnd(pfig);
}

Figura* Raggruppamento::GetLastFigura()
{
	Figura *FirstFig, *LastFig;
	Battuta *FirstRaggrupBat, *LastRaggrupBat, *FirstVisibleBat, *LastVisibleBat;
	Battuta *FirstNextRigoBat=NULL, *LastRigoBat=NULL;
	int nFirstRaggrupBat=0, nLastRaggrupBat=0, nFirstVisibleBat=0, nLastVisibleBat=0;
	int nFirstNextRigoBat=0, nLastRigoBat=0;
	FirstRaggrupBat=NULL;
	LastRaggrupBat=NULL;
	FirstVisibleBat=NULL;
	LastVisibleBat=NULL;
	FirstFig=GetPFigStart();
	LastFig=GetPFigEnd();
	if ((FirstFig!=NULL)&&(LastFig!=NULL)){
		FirstRaggrupBat=FirstFig->GetPBattuta();
		LastRaggrupBat=LastFig->GetPBattuta();
		FirstVisibleBat=(FirstRaggrupBat->GetParentScore())->GetfirstBatPage();
		Battuta *NextPageBat=(FirstRaggrupBat->GetParentScore())->GetfirstBatNextPage();
		if(NextPageBat!=NULL)
			LastVisibleBat=(FirstRaggrupBat->GetParentScore())->GetPrevBat(NextPageBat);
		else
			LastVisibleBat=(FirstRaggrupBat->GetParentScore())->GetLastBat();
		nFirstRaggrupBat=FirstRaggrupBat->GetNumProgress();
		nLastRaggrupBat=LastRaggrupBat->GetNumProgress();
		nFirstVisibleBat=FirstVisibleBat->GetNumProgress();
		nLastVisibleBat=LastVisibleBat->GetNumProgress();
		if((nLastRaggrupBat>nLastVisibleBat)&&(nFirstRaggrupBat<=nLastVisibleBat)){

			SetNumLayer();
			LastFig=(LastVisibleBat->GetPLayer(GetNumLayer()))->GetLastF();

		}
		
		
	}
	Battuta* currentBat, *nextBattuta;
	bool stop=FALSE;
	if(FirstFig!=NULL){
		currentBat=FirstVisibleBat;
		while((currentBat!=NULL)&&(stop==FALSE)&&(currentBat!=LastVisibleBat)){
			nextBattuta=(currentBat->GetParentScore())->GetNextBat(currentBat);
			
			if(nextBattuta){
				if(nextBattuta->GetBattuta()==INIZIO_PENTAGRAMMA){

					FirstNextRigoBat=nextBattuta;
					nFirstNextRigoBat=FirstNextRigoBat->GetNumProgress();
					LastRigoBat=currentBat;
					nLastRigoBat=LastRigoBat->GetNumProgress();
					stop=TRUE;
				}
			}
			currentBat=nextBattuta;
		}

	}
	if((LastRigoBat!=NULL)&&(nLastRigoBat<nLastVisibleBat)&&(nLastRigoBat>=nFirstRaggrupBat)&&(nLastRigoBat<nLastRaggrupBat))
		LastFig=(LastRigoBat->GetPLayer(GetNumLayer()))->GetLastF();


	return LastFig;
}

Figura* Raggruppamento::GetNextFigura(Figura *pfig)
{
	//Bool FINITO, TROVATO, BATTUTAPRESENTE;
	Battuta *bat;
	Spartito *spar=NULL;
	Figura *nextfig=NULL;
	Figura *tmp=NULL;
	bat=GetFirstBattuta();
//	FINITO=FALSE;
//	TROVATO=FALSE;
	/*if (bat!=NULL){
		spar=bat->GetParentScore();
		SetNumLayer();
		while((!TROVATO)&&(!FINITO)&&(bat!=NULL)){
			
			nextfig=(bat->GetPLayer(GetNumLayer()))->GetNextFigura(pfig);
			if (nextfig!=NULL){
				TROVATO=TRUE;
			}
			else {
				bat=spar->GetNextBat(bat); 
				if (bat==GetLastBattuta())
					FINITO=TRUE;
			}

		}
	}*/

	if (bat!=NULL){
		spar=bat->GetParentScore();
	}
	SetNumLayer();

	while((bat!=pfig->GetPBattuta())&&(bat!=GetLastBattuta())){
			bat=spar->GetNextBat(bat);
	}
	if((bat==pfig->GetPBattuta())&&(bat!=GetLastBattuta())){
		nextfig=(bat->GetPLayer(GetNumLayer()))->GetNextFigura(pfig);
		if(nextfig==NULL){
			bat=spar->GetNextBat(bat); 
			nextfig=(bat->GetPLayer(GetNumLayer()))->GetFirstFig();
		}
	}
	else if((bat==pfig->GetPBattuta())&&(bat==GetLastBattuta())){
		tmp=(bat->GetPLayer(GetNumLayer()))->GetFirstFig();
		while((tmp!=pfig)&&(tmp!=(bat->GetPLayer(GetNumLayer()))->GetLastF())&&(tmp!=NULL)&&(tmp!=(GetLastFigura()))){
			tmp=(bat->GetPLayer(GetNumLayer()))->GetNextFigura(tmp);
		}
		if((tmp==pfig)&&(tmp!=GetLastFigura()))
			nextfig=(bat->GetPLayer(GetNumLayer()))->GetNextFigura(pfig);	
	}
  return nextfig;
}


Figura* Raggruppamento::GetNextFig(Figura *pfig)
{

	Battuta *bat;
	Spartito *spar=NULL;
	Figura *nextfig=NULL;
	Figura *tmp=NULL;
	bat=GetBattuta(1);


	if (bat!=NULL){
		spar=bat->GetParentScore();
	}
	SetNumLayer();

	while((bat!=pfig->GetPBattuta())&&(bat!=GetBattuta(2))){
			bat=spar->GetNextBat(bat);
	}
	if((bat==pfig->GetPBattuta())&&(bat!=GetBattuta(2))){
		nextfig=(bat->GetPLayer(GetNumLayer()))->GetNextFigura(pfig);
		if(nextfig==NULL){
			bat=spar->GetNextBat(bat); 
			nextfig=(bat->GetPLayer(GetNumLayer()))->GetFirstFig();
		}
	}
	else if((bat==pfig->GetPBattuta())&&(bat==GetBattuta(2))){
		tmp=(bat->GetPLayer(GetNumLayer()))->GetFirstFig();
		while((tmp!=pfig)&&(tmp!=(bat->GetPLayer(GetNumLayer()))->GetLastF())&&(tmp!=NULL)&&(tmp!=(GetLastFigura()))){
			tmp=(bat->GetPLayer(GetNumLayer()))->GetNextFigura(tmp);
		}
		if((tmp==pfig)&&(tmp!=GetLastFigura()))
			nextfig=(bat->GetPLayer(GetNumLayer()))->GetNextFigura(pfig);	
	}
  return nextfig;
}

Figura* Raggruppamento::GetPrevFigura(Figura *pfig)
{
	Bool FINITO, TROVATO;
	Battuta *firstbat, *prevbat, *currentbat;
	Spartito *spar;
	Figura* prevfig=NULL;
	firstbat=(GetFirstFigura()->GetPBattuta());
	prevbat=(firstbat->GetParentScore())->GetPrevBat(firstbat);
	FINITO=FALSE;
	TROVATO=FALSE;
	currentbat=GetLastFigura()->GetPBattuta();
	while (currentbat!=NULL && currentbat!=prevbat && !TROVATO){

		spar=currentbat->GetParentScore();
		SetNumLayer();
		prevfig=(currentbat->GetPLayer(GetNumLayer()))->GetPrevF(pfig);
		if(prevfig!=NULL)
			TROVATO=TRUE;
		
		else
		currentbat=spar->GetPrevBat(currentbat);
		

		
	}

  return prevfig;
}

void Raggruppamento::SetFirstBattuta(Battuta *pbat)
{
	SetBattuta(1,pbat);
}

Battuta* Raggruppamento::GetFirstBattuta()
{
	//return GetBattuta(1);
	Battuta *pbat =NULL;
	if(GetFirstFigura()!=NULL)
		pbat=(GetFirstFigura()->GetPBattuta());
	return pbat;
	
}

void Raggruppamento::SetLastBattuta(Battuta *pbat)
{
	SetBattuta(2,pbat);
}

Battuta* Raggruppamento::GetLastBattuta()
{
	//return GetBattuta(2);
	//return GetBattuta(1);
	Battuta *pbat =NULL;
	if(GetLastFigura()!=NULL)
		pbat=(GetLastFigura()->GetPBattuta());
	return pbat;
}

void Raggruppamento::SetNumLayer()
{
	Battuta *FirstBat=GetBattuta(1);
	Figura *FirstFig=PFigStart;
	class Layer *tmp;
	Bool Trovato=FALSE;

	if(FirstBat != NULL)
	{		
			for(short i=0; (i< 12)&&(Trovato == FALSE); i++)
			{
				tmp = (FirstBat)->GetPLayer(i);  
				if(tmp!=NULL)
				{
					if(tmp->FindFig(FirstFig))
					{
						this->NumLayer = i;
						Trovato = TRUE;
					}
				}
			}
	}
}


int Raggruppamento::GetNumLayer()
{
	return this->NumLayer;
}
 
 
void Raggruppamento::SetNotina(Bool b)
{
 	Figura* pfig=PFigStart;	

	while(pfig!=NULL){

		pfig->SetNotina(b);
		pfig=GetNextFig(pfig);
	}

}
 
 
Bool Raggruppamento::GetNotina()
{
	if(PFigStart)
 		return PFigStart->GetNotina();
	else
		return false;
}

void Raggruppamento::SetSmallBeam(Bool var){
	

	Figura *tmp;
 	tmp=this->GetPFigStart();
 	if(tmp!=NULL)
 	{
 	   while(tmp!=NULL)
 	   {
		   if(tmp->GetID()==CL_ACCORDO)
		   {
			   if(var)
				   ((Accordo *)(tmp))->SetSmallAccordo();
			   else
				   ((Accordo *)(tmp))->SetBigAccordo();
		   }
		   else
 				((Nota *)(tmp))->SetNotina(var);
 		   tmp=GetNextFigura(tmp);
 	   }
 
	 }
	SetNotina(var);
}

void Raggruppamento::SetBeamUp()
{
	Figura *tmp;
	tmp=GetFirstFigura();
	if(tmp!=NULL)
	{
	   while(tmp!=NULL)
	   {
		   if (tmp->GetID()==CL_NCROMA || tmp->GetID()==CL_NSEMICROMA ||
               tmp->GetID()==CL_NBISCROMA || tmp->GetID()==CL_NSEMIBISCROMA ||
               tmp->GetID()==CL_NFUSA )
		       ((Nota *)(tmp))->SetGamboUp();
		   tmp=GetNextFigura(tmp);
	   }

	 }
}

void Raggruppamento::SetBeamDwn()
{
	Figura *tmp;
	tmp=GetFirstFigura();
	if(tmp!=NULL)
	{
	   while(tmp!=NULL)
	   {
		   if (tmp->GetID()==CL_NCROMA || tmp->GetID()==CL_NSEMICROMA ||
               tmp->GetID()==CL_NBISCROMA || tmp->GetID()==CL_NSEMIBISCROMA ||
               tmp->GetID()==CL_NFUSA )
				((Nota *)(tmp))->SetGamboDwn();
		   tmp=GetNextFigura(tmp);
	   }
	 }
}
void Raggruppamento::SetSpaceWidth(VUnit sw) 
{
	SpaceWidth=sw;
}
 
 
VUnit Raggruppamento::GetSpaceWidth()
{
 	return SpaceWidth;
}
 
 
void Raggruppamento::SetLGambo(VUnit lg, short numSegment)
{  
	if(GetNotina())
 	{
        if(abs(lg)<LGAMBOMIN/2)
         {
 			LGambo[numSegment] = (lg>=0)? LGAMBOMIN/2: -LGAMBOMIN/2;
         }   
         else        
         {
 			LGambo[numSegment]=lg;
         }
 	}
 	else  
	{
         if(abs(lg)<LGAMBOMIN)
         {
 			LGambo[numSegment] = (lg>=0)? LGAMBOMIN: -LGAMBOMIN;
         }   
         else        
         {
			LGambo[numSegment]=lg;
         }
 	}
}     
 
 
void Raggruppamento::SetGamboUp()
{
 	beamPos=BEAM_UP;
 	if(GetNotina())
 	{
         SetLGambo(LGAMBODEF/2,1);
 	}
	else
 	{
         SetLGambo(LGAMBODEF,1);
 	}
}
 
 
void Raggruppamento::SetGamboDwn()
{
 	beamPos=BEAM_DWN;
 	if(GetNotina())
 	{
         SetLGambo(-LGAMBODEF/2,1);
 	}
 	else
 	{
         SetLGambo(-LGAMBODEF,1);
 	}
}

void Raggruppamento::SetPos(DrawObject* d,const Point& p)
{
     
 	DrawObject::SetPos(d,p);

}

	
int Raggruppamento::GetStaffInBeam()
//modificata rispetto a grupponote perch faceva riferimento alla Lista
{
 	//Node *pnode;
 	Figura *pn;
 	
 	int s=0,n=0;
	
 	bool staff[3]={false,false,false};
 
 	//pnode = first;
	pn = this->GetFirstFigura();
 
 	while (pn!=NULL)
 	{  
 		
 		
 		if(pn->GetID()!=CL_SPAZIO)
 		{ 
 			s = pn->GetNStaff();
 			if(!staff[s])
 			{
 				n++;
 				staff[s]=true;
 			}
 		}
 		pn = this->GetNextFigura(pn);
 	}  
 	
 	return n;
}
 
float Raggruppamento::GetMedia()
{
	
 	Nota *pn;
 	
 	float a; 
 	float alt=0;
 	float num;
 	SetNumNote();
 	num = GetNumNote();
 	
 	
 
 	int staffinbeam=GetStaffInBeam();
	pn = this->GetFirstNota();
 
 	while (pn!=NULL)
 	{
 		
 		if(pn->GetID()!=CL_SPAZIO)
 		{ 
 			if (staffinbeam>1)
 			{
 				a = pn->GetAltezza()-4-pn->GetNStaff()*STAFF_DIST;
 			}
 			else
 			{
 			a = pn->GetAltezza()-4;
 			}
 			alt+=a;
 		}
 		pn = (Nota*)GetNextFigura(pn);
 	}  
 	
 	return alt/num; 
}  


float Raggruppamento::GetBeamDis()
{      
 	Nota *pn;       
 	//Node *pnode;  
 	float low, high, alt; 
 	
 	int staffinbeam=GetStaffInBeam();//GB
 	//pnode = first;
 	pn = (Nota*)GetPFigStart();  
    if (pn==NULL)
		return 0;
 	if(staffinbeam>1)//GB
 	{
 		high = pn->GetAltezza()-4-pn->GetNStaff()*STAFF_DIST;
 		low = pn->GetAltezza()-4-pn->GetNStaff()*STAFF_DIST;
 	}
 	else
 	{
	 	high = pn->GetAltezza()-4;
 		low = pn->GetAltezza()-4;
 	}
 	while (pn!=NULL)
 	{
 		//pn = (Nota*)pnode->ObjectPtr;
 		if(pn->GetID()!=CL_SPAZIO)
 		{
 			if(staffinbeam>1)//GB
 			{
 				alt = pn->GetAltezza()-4-pn->GetNStaff()*STAFF_DIST;
 			}
 			else
 			{
 				alt = pn->GetAltezza()-4;
 			}
 			if (alt>high)
 			{
 				high = alt;
 			}
 			if (alt<low)
 			{
 				low = alt;
 			} 
 		}      
 		//pnode = pnode->Next; 
		pn=(Nota*)GetNextFigura(pn);
 	}
 	
 	return (abs(high)-abs(low));
}  
 
float Raggruppamento::GetDelta()
{
 	float num, alt, high, low;
 	Nota *pn;
 	//Node *pnode;
 	SetNumNote();
 	num = GetNumNote();
 	
 	int staffinbeam=GetStaffInBeam();//GB
 	//pnode = first;    
 	pn = (Nota*)GetFirstFigura(); 
 
 	if(staffinbeam>1)//GB
 	{
 		high = pn->GetAltezza()-4-pn->GetNStaff()*STAFF_DIST;
 		low = pn->GetAltezza()-4-pn->GetNStaff()*STAFF_DIST;
 	}
 	else
 	{
 	high = pn->GetAltezza()-4;
 	low = pn->GetAltezza()-4;
 	}
 
 	while (pn!=NULL)
 	{
 		//pn = (Nota*)pnode->ObjectPtr;
 		if(pn->GetID()!=CL_SPAZIO)
 		{
 			if(staffinbeam>1)//GB
 			{
				alt = pn->GetAltezza()-4-pn->GetNStaff()*STAFF_DIST;
 			}
 			else
 			{
 				alt = pn->GetAltezza()-4;
 			}
 			if (alt>=high)
 			{
 				high = alt;
 			}
 			if (alt<=low)
 			{
 				low = alt;
 			}   
 		}   
 		pn = (Nota*)GetNextFigura(pn);    
 	}
 	
 	return (abs(high)-abs(low))/(num+1);
 	
} 

float Raggruppamento::GetMeanHighLow()
{
 	//Node *pnode;
 	Nota *pn;
 	
 	float high, low; 
 	float mean;
 	float alt;
 
 	int staffinbeam=GetStaffInBeam();//GB
 
 	//pnode = first;
 	pn = (Nota*)GetFirstFigura();
 	
 	if(staffinbeam>1)//GB
 	{
 		high = pn->GetAltezza()-4-pn->GetNStaff()*STAFF_DIST;
 		low = pn->GetAltezza()-4-pn->GetNStaff()*STAFF_DIST;
 	}
	else
	{
		high = pn->GetAltezza()-4;
		low = pn->GetAltezza()-4;
	}
 
 	while (pn!=NULL)
 	{
 		//pn = (Nota*)pnode->ObjectPtr;
		
 		if(pn->GetID()!=CL_SPAZIO)
 		{
 			if(staffinbeam>1)//GB
 			{
 				alt = pn->GetAltezza()-4-pn->GetNStaff()*STAFF_DIST;
 			}
 			else
 			{
 				alt = pn->GetAltezza()-4;
 			}
 			if (alt>high)
 			{
 				high = alt;
 			}
 			if (alt<low)
 			{
 				low = alt;
 			}
 		}        
 		pn = (Nota*)GetNextFigura(pn);    
	} 
 	
 	mean = (high+low)/2; 
 	return mean;
}   

Bool Raggruppamento::isOne(){
	
	return (GetFirstFigura()==GetLastFigura());
}

/*void Raggruppamento::Draw()
{
	if(GetFirstFigura()->HastobeDraw())
	{
		SetNumLayer();
		SetNumNote();
		Adjust(TRUE,this->GetFirstBattuta(),this->GetNumLayer(),0);

 		//Node *pnode;
 		Figura *pfig;
     
 		Hilite(0,Scr);
 		
 		// Disegna le note.                                     
		if(isOpaque)
		Scr->SetColor(GetColor());  
 		pfig=GetFirstFigura();
 		while(pfig!=NULL)
 		{         
			 pfig->Draw();
			 pfig=GetNextFigura(pfig);
			 
			 //pnode=pnode->Next;
 		} 
 		
     
	 if(isOpaque)
	 Scr->SetColor(GetColor());  //PB1
     
 		DrawBarre();
     
 		Hilite(1,Scr); 
	}
}*/

void Raggruppamento::DrawBarre(short numSegment)
{
 	//Node *pnode;
 	Figura *pfig;
 	Nota *pnota;
 	short Direz, i;
     //  float BSlope[currentView];
 	ClassID nID;
 	VUnit BThick, dYB;
     
 	//GB
     if(beamPos==BEAM_12 || beamPos==BEAM_23)
 	{
 		DrawBarreMiddle(numSegment);
 		return;
 	}
 	// Disegna le barrette solo se il metodo Adjust ha avuto buon esito.                   
 	if(GetBPoint1(numSegment)==Point(0,0) || GetBPoint1(numSegment).x==GetBPoint2(numSegment).x)
         return;            
 	
 	Direz = (((Nota*)(GetPSegment(numSegment)->FirstFig))->GetLGambo()>0)? 1: -1;
 	// GetBPoint2().y viene ricalcolato poiche' precedenti errori di approssimazione
 	// potrebbero guastare il parallelismo della barra superiore.
 	GetBPoint2(numSegment).y = GetBPoint1(numSegment).y + (VUnit)(BSlope[currentView][numSegment]*(GetBPoint2(numSegment).x-GetBPoint1(numSegment).x));
 	
 	BThick = (GetNotina()?THICKBARRETTA1:THICKBARRETTA);
 	dYB = (GetNotina()?DELTAYBARRETTE1:DELTAYBARRETTE);
 	
 	
 	// DISEGNO PER LE NOTE.
 	// Inizia dalla barra piu` esterna.
 	Scr->BigLine(GetBPoint1(numSegment)+Point(0, Direz*(NBarre[numSegment]-1)*dYB-(Direz*BThick)),
 		GetBPoint2(numSegment)+Point(0, Direz*(NBarre[numSegment]-1)*dYB-(Direz*BThick)),
 		Direz*BThick);
 	// Eventualmente prosegui con le barre interne.
 	for(i=0;i<NBarre[numSegment]-1;i++)
 	{
 		Tratto[currentView][numSegment][i].PRef = GetBPoint1(numSegment)+Point(0, Direz*(i)*dYB);
 		Tratto[currentView][numSegment][i].P1 = Point(0,0);     
 	}
     
     
 	//pnode = first;
	pfig=GetPSegment(numSegment)->FirstFig;
 	while(pfig!=NULL)
 	{
 		//pfig = (Figura*)pnode->ObjectPtr;
 		nID = pfig->GetID();
 		// Salta gli spazi
 		if(nID!=CL_SPAZIO)
 		{
             pnota = (Nota*)pfig;
 			
 			if(nID==CL_ACCORDO)
 				nID = ((Accordo*)pnota)->GetNoteID();
 			
 			switch(nID)
 			{
 			case CL_NCROMA:
 				DrawTratto(pnota, NBarre[numSegment]-1, Direz, BThick,numSegment);
 				break;
 			case CL_NSEMICROMA:
 				DrawTratto(pnota, NBarre[numSegment]-2, Direz, BThick,numSegment);
 				break;
 			case CL_NBISCROMA:
 				DrawTratto(pnota, NBarre[numSegment]-3, Direz, BThick,numSegment);
 				break;
 			case CL_NSEMIBISCROMA:
 				DrawTratto(pnota, NBarre[numSegment]-4, Direz, BThick,numSegment);
 				break;
 			case CL_NFUSA:
 				DrawTratto(pnota, NBarre[numSegment]-5, Direz, BThick,numSegment);
 				break;
 			}
 		}
 		//pnode=GetNext(pnode);
		pfig=GetNextFig(pfig);
				if(pfig){
					if(pfig==GetNextFig(GetFineSegmento(GetPSegment(numSegment)->FirstFig)))
						pfig=NULL;
				}
 		
 	}
 	// Concludi il disegno dei tratti.
 	DrawTratto(NULL, NBarre[numSegment]-1, Direz, BThick,numSegment);
}      

void Raggruppamento::DrawTratto(Nota *pnota, short nBarra, short Direz,
 							VUnit BThick, short numSegment)
{
 	short i;
 	
 	// Disegna le barre dal basso verso l'alto.
 	for(i=0;i<nBarra;i++)
 	{
         if(Tratto[currentView][numSegment][i].P1!=Point(0,0))
         {
 			if(Tratto[currentView][numSegment][i].P1==Tratto[currentView][numSegment][i].P2)
 			{
 				// Nota "isolata".
 				if(Tratto[currentView][numSegment][i].P1.x==GetBPoint1(numSegment).x)
 				{
 					// Nota iniziale del gruppo => mezzo tratto verso destra.
 					Tratto[currentView][numSegment][i].P2.x = Tratto[currentView][numSegment][i].P1.x + TRATTOMEZZABARRA;
 					Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].P1.y + (VUnit)(BSlope[currentView][numSegment]*TRATTOMEZZABARRA);
 				}
 				else
 				{
 					// Mezzo tratto verso sinistra.
 					Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
 					Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x - TRATTOMEZZABARRA;
 					Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y - (VUnit)(BSlope[currentView][numSegment]*TRATTOMEZZABARRA);
 				}
 			}
 			Scr->BigLine(Tratto[currentView][numSegment][i].P1-Point(0,(Direz*BThick)), Tratto[currentView][numSegment][i].P2-Point(0,(Direz*BThick)), Direz*BThick);
 			// Resetta l'inizio del tratto.
 			Tratto[currentView][numSegment][i].P1 = Point(0,0);
         }
 	}
 	
     
 	// Se siamo al termine, non necessita aggiornamento.
 	if(pnota==NULL)
         return;
 	// Aggiorna il punto finale dei tratti soprastanti.
 	for(i=nBarra;i<NBarre[numSegment]-1;i++)
 	{
         // DXGambo deve essere assegnato in base alla direzione ed alla
         // dimensione della nota.
         Tratto[currentView][numSegment][i].P2.x = pnota->GetXgambo();
         Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y +
 			VUnit(BSlope[currentView][numSegment] * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
 		
         // Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
         if(Tratto[currentView][numSegment][i].P1==Point(0,0))
 			Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
 	}
     
}                                            
 
void Raggruppamento::DrawBarreMiddle(short numSegment)
{
 	//Node *pnode_prec,*pnode_corr;
 	Figura *pfig_corr,*pfig_prec;
 
 	Nota *pnota_prec,*pnota_corr;
 	  // GB Puntatori alla nota attuale ed alla sua precedente
 	  // Si guarda indietro, poiche e' la prima nota a dominare
 	  // la parte da cui si disegna il tratto in base al suo gambo,
 	  // infatti se sopra o sotto la linea di mezzo.
 
 	short Direz;
//	short i,DirezNota;
     //  float BSlope[currentView];
// 	ClassID nID_corr;
	ClassID nID_prec=CL_NOTA;
 	VUnit BThick, dYB;
     
     
 	// Disegna le barrette solo se il metodo Adjust ha avuto buon esito.                   
 	if(GetBPoint1(numSegment)==Point(0,0) || GetBPoint1(numSegment).x==GetBPoint2(numSegment).x)
         return;            
 	
 	Direz = (GetLGambo(numSegment)>0)? 1: -1;
 	// GetBPoint2().y viene ricalcolato poiche' precedenti errori di approssimazione
 	// potrebbero guastare il parallelismo della barra superiore.
 	GetBPoint2(numSegment).y = GetBPoint1(numSegment).y + (VUnit)(BSlope[currentView][numSegment]*(GetBPoint2(numSegment).x-GetBPoint1(numSegment).x));
 	
 	BThick = (GetNotina()?THICKBARRETTA1:THICKBARRETTA);
 	dYB = (GetNotina()?DELTAYBARRETTE1:DELTAYBARRETTE);
 	
 	
 	// DISEGNO PER LE NOTE.
 	// GB Inizia dalla barra di mezzo che ora sta solo nel mezzo,
 	// e quando si tratta di beam tra gli staff c'e' sempre.
 	Scr->BigLine(GetBPoint1(numSegment),GetBPoint2(numSegment),BThick);
 
 	//Scr->BigLine(GetBPoint1()+Point(0, Direz*(NBarre-1)*dYB-(Direz*BThick)),
 	//	GetBPoint2()+Point(0, Direz*(NBarre-1)*dYB-(Direz*BThick)),
 	//	Direz*BThick);
 
 	//pnode_prec = first;
 	//pnode_corr = GetNext(pnode_prec);
	pfig_prec = GetPSegment(numSegment)->FirstFig;
	pfig_corr = GetNextFigura(pfig_prec);
 	while(pfig_prec!=NULL)
 	{
 		//pfig_corr = (Figura*)pnode_corr->ObjectPtr;
 		//pfig_prec = (Figura*)pnode_prec->ObjectPtr;
 		// Salta gli spazi
 		if(nID_prec!=CL_SPAZIO)
 		{
            pnota_corr = (Nota*)pfig_corr;
 			pnota_prec = (Nota*)pfig_prec;
 			
 			if(nID_prec==CL_ACCORDO)
 				nID_prec = ((Accordo*)pnota_prec)->GetNoteID();
 			
 			DrawTrattoMiddle(pnota_corr,pnota_prec,BThick,dYB,numSegment);
 		}
 		
		pfig_corr=GetNextFig(pfig_corr);
				if(pfig_corr){
					if(pfig_corr==GetNextFig(GetFineSegmento(GetPSegment(numSegment)->FirstFig)))
						pfig_corr=NULL;
				}
 		if(pfig_corr==NULL)
 		{
 			pfig_corr=pfig_prec;
 			pfig_prec=GetPrevFigura(pfig_prec);
 			break;
 		}
 		pfig_prec=GetNextFigura(pfig_prec);
 		
 		
 	}
 	// Concludi il disegno dei tratti.
 	//DrawTrattoMiddle(pnota_corr,pnota_prec,BThick,dYB);
} 

void Raggruppamento::DrawTrattoMiddle(Nota *pnota_corr,Nota *pnota_prec, VUnit BThick, VUnit dYB, short numSegment)
{
	short i,NBarre_corr=0,NBarre_prec=0,NBarre_Nota_prec=0,NBarre_Nota_corr=0;
//	short NBarre_in_comune;
	short comune,NMezzo_tratt_prec,NMezzo_tratt_corr;
 	ClassID nID_corr,nID_prec; 
 	
 
 	// GB Calcola il numero di barrette della nota corrente
 	nID_corr=pnota_corr->GetID();
 	if(nID_corr==CL_ACCORDO)
 		nID_corr=((Accordo*)pnota_corr)->GetNoteID();
 	NBarre_Nota_corr = nID_corr - CL_NCROMA + 1;
 		
 	// GB Calcola il numero di barrette della nota precedente
 	nID_prec=pnota_prec->GetID();
 	if(nID_prec==CL_ACCORDO)
 		nID_prec=((Accordo*)pnota_prec)->GetNoteID();
 	NBarre_Nota_prec = nID_prec - CL_NCROMA + 1;
 	
 
 	// GB si scalano di uno per via della barra centrale sempre presente
 	NBarre_corr = NBarre_Nota_corr - 1; // numero di barrette scalate di quella centrale
 	NBarre_prec = NBarre_Nota_prec - 1; // numero di barrette scalate di quella centrale
 
 	// GB barre che si possono unire delle due note, naturalmente escludendo quella centrale
 	comune = (NBarre_corr > NBarre_prec)? NBarre_prec:NBarre_corr;
 	
 	NMezzo_tratt_prec = NBarre_Nota_prec - comune - 1;
 	
 
 	// GB caso particolare nel caso la prima delle due sia una CROMA
 	if(NBarre_prec == 0 && (NBarre_corr >=0 && (GetLastNota()!=pnota_corr)))
 	{
 		return;
 	}
 	// GB caso particolare che la penultima sia una CROMA e l'ultima sia di durata minore
 	else if(NBarre_prec == 0 && (NBarre_corr >=0 && (GetLastNota()==pnota_corr)))
 	{
 		NMezzo_tratt_corr = NBarre_Nota_corr - comune - 1;
 		if((pnota_corr->GetNStaff() == 0 && beamPos == BEAM_12) || (pnota_corr->GetNStaff() <= 1 && beamPos == BEAM_23) )
 		{
 			for(i=0;i<NMezzo_tratt_corr;i++)
 			{
 				Tratto[currentView][numSegment][i].P1=Point(0,0);
 				Tratto[currentView][numSegment][i].PRef = GetBPoint2(numSegment)+Point(0, i*dYB);
 				// DXGambo deve essere assegnato in base alla direzione ed alla
 				// dimensione della nota.
 				Tratto[currentView][numSegment][i].P2.x = pnota_corr->GetXgambo();
 				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y +
 					VUnit((BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
 				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
 				if(Tratto[currentView][numSegment][i].P1==Point(0,0))
 					Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
 			}
 			for(i=0;i<NMezzo_tratt_corr;i++)
 			{
 				
 			
 				// Mezzo tratto verso sinistra, al di sopra della midline
 				Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
 				Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x - TRATTOMEZZABARRA;
 				Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y + (VUnit)((-BSlope[currentView][numSegment])*TRATTOMEZZABARRA);
 				Scr->BigLine(Tratto[currentView][numSegment][i].P1+Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2+Point(0,BThick+dYB/2),BThick);
 			}
 		}
 		else if((pnota_corr->GetNStaff() > 0 && (beamPos == BEAM_12) || (pnota_corr->GetNStaff() > 1 && beamPos == BEAM_23)))
 		{
 			for(i=0;i<NMezzo_tratt_corr;i++)
 			{
 				Tratto[currentView][numSegment][i].P1=Point(0,0);
 				Tratto[currentView][numSegment][i].PRef = GetBPoint2(numSegment)-Point(0, i*dYB);
 				// DXGambo deve essere assegnato in base alla direzione ed alla
 				// dimensione della nota.
 				Tratto[currentView][numSegment][i].P2.x = pnota_corr->GetXgambo();
 				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
 					VUnit((BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
 				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
 				if(Tratto[currentView][numSegment][i].P1==Point(0,0))
 					Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
 			}
 			for(i=0;i<NMezzo_tratt_corr;i++)
 			{
 				// DXGambo deve essere assegnato in base alla direzione ed alla
 				// dimensione della nota.
 				Tratto[currentView][numSegment][i].P2.x = pnota_corr->GetXgambo();
 				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
 					VUnit((BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
 
 				// Mezzo tratto verso sinistra, al di sotto delle midline
 				Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
 				Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x - TRATTOMEZZABARRA;
 				Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y - (VUnit)((BSlope[currentView][numSegment])*TRATTOMEZZABARRA);
 				Scr->BigLine(Tratto[currentView][numSegment][i].P1-Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2-Point(0,BThick+dYB/2),BThick);
 			}
 		}
 	} // GB caso in cui la prima nota sia isolata da una CROMA che segue
 	else if(((NBarre_prec >= 0 && (GetFirstNota() == pnota_prec)) && NBarre_corr == 0) || (NBarre_prec >= 0 && NBarre_corr == 0 ))
 	{
 		NMezzo_tratt_prec = NBarre_Nota_prec - comune - 1;
 		if((pnota_prec->GetNStaff() == 0 && beamPos == BEAM_12) || (pnota_prec->GetNStaff() <= 1 && beamPos == BEAM_23) )
 		{
 			for(i=0;i<NMezzo_tratt_prec;i++)
 			{
 				Tratto[currentView][numSegment][i].P1=Point(0,0);
 				Tratto[currentView][numSegment][i].PRef = GetBPoint1(numSegment)+Point(0, i*dYB);
 				// DXGambo deve essere assegnato in base alla direzione ed alla
 				// dimensione della nota.
 				Tratto[currentView][numSegment][i].P2.x = pnota_prec->GetXgambo();
 				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y +
 					VUnit((-BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
 				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
 				if(Tratto[currentView][numSegment][i].P1==Point(0,0))
 					Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
 			}
 			for(i=0;i<NMezzo_tratt_prec;i++)
 			{
 				
 			
 				// Mezzo tratto verso destra, al di sopra della midline
 				Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
 				Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x + TRATTOMEZZABARRA;
 				Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y + (VUnit)((BSlope[currentView][numSegment])*TRATTOMEZZABARRA);
 				Scr->BigLine(Tratto[currentView][numSegment][i].P1+Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2+Point(0,BThick+dYB/2),BThick);
 			}
 		}
 		else if((pnota_prec->GetNStaff() > 0 && (beamPos == BEAM_12) || (pnota_prec->GetNStaff() > 1 && beamPos == BEAM_23)))
 		{
 			for(i=0;i<NMezzo_tratt_prec;i++)
 			{
 				Tratto[currentView][numSegment][i].P1=Point(0,0);
 				Tratto[currentView][numSegment][i].PRef = GetBPoint1(numSegment)-Point(0, i*dYB);
 				// DXGambo deve essere assegnato in base alla direzione ed alla
 				// dimensione della nota.
 				Tratto[currentView][numSegment][i].P2.x = pnota_prec->GetXgambo();
 				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
 					VUnit(BSlope[currentView][numSegment] * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
 				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
 				if(Tratto[currentView][numSegment][i].P1==Point(0,0))
 					Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
 			}
 			for(i=0;i<NMezzo_tratt_prec;i++)
 			{
 				// DXGambo deve essere assegnato in base alla direzione ed alla
 				// dimensione della nota.
 				Tratto[currentView][numSegment][i].P2.x = pnota_prec->GetXgambo();
 				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
 					VUnit(BSlope[currentView][numSegment] * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
 
 				// Mezzo tratto verso destra, al di sotto delle midline
 				Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
 				Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x + TRATTOMEZZABARRA;
 				Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y - (VUnit)((-BSlope[currentView][numSegment])*TRATTOMEZZABARRA);
 				Scr->BigLine(Tratto[currentView][numSegment][i].P1-Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2-Point(0,BThick+dYB/2),BThick);
 			}
 		}
 	}
 
 	// GB disegna le barre prendendo come riferimento (nota dominante)
 	// la prima nota che ha una barra in piu rispetto alla centrale e 
 	// come verso, quello dalla parte dello staff di appartenenza.
 	else 
 	{
 		NMezzo_tratt_prec = NBarre_Nota_prec - comune - 1;
 		NMezzo_tratt_corr = NBarre_Nota_corr - comune - 1;
 		if((pnota_prec->GetNStaff() == 0 && beamPos == BEAM_12) || (pnota_prec->GetNStaff() <= 1 && beamPos == BEAM_23) )
 		{
 			for(i=0;i<=comune;i++)
 			{
 				Tratto[currentView][numSegment][i].P1=Point(0,0);
 				Tratto[currentView][numSegment][i].PRef.x = pnota_prec->GetXgambo();
 				Tratto[currentView][numSegment][i].PRef.y = pnota_prec->GetYgambo()+pnota_prec->GetLGambo();
 				Tratto[currentView][numSegment][i].PRef = Tratto[currentView][numSegment][i].PRef - Point(0,i*dYB);
 				// DXGambo deve essere assegnato in base alla direzione ed alla
 				// dimensione della nota.
 				if(nID_corr==CL_NCROMA)
 				{
 					Tratto[currentView][numSegment][i].P2.x = pnota_prec->GetXgambo();
 					Tratto[currentView][numSegment][i].P2.y = pnota_prec->GetYgambo()+pnota_prec->GetLGambo();
 				}
 				else
 				{
 					Tratto[currentView][numSegment][i].P2.x = pnota_corr->GetXgambo();
 					Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
 						VUnit((-BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
 				}
 				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
 				//if(Tratto[currentView][numSegment][i].P1==Point(0,0))
 				//	Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
 				Scr->BigLine(Tratto[currentView][numSegment][i].PRef+Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2+Point(0,BThick+dYB/2),BThick);
				Scr->Line(Tratto[currentView][numSegment][i-1].PRef,Tratto[currentView][numSegment][i-1].PRef+Point(0,BThick+dYB/2),SOLID_LINE); // per disegnare i prolongamenti dei gambi
				Scr->Line(Tratto[currentView][numSegment][i-1].P2,Tratto[currentView][numSegment][i-1].P2+Point(0,BThick+dYB),SOLID_LINE); // per disegnare i prolongamneti dei gambi

 			}
 			
 
 			/*
 			for(i=0;i<NMezzo_tratt_prec;i++)
 			{
				// Mezzo tratto della nota precedente verso sinistra, al di sopra della midline
 				Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
 				Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x - TRATTOMEZZABARRA;
 				Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y + (VUnit)((BSlope[currentView])*TRATTOMEZZABARRA);
 				Scr->BigLine(Tratto[currentView][numSegment][i].P1+Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2+Point(0,BThick+dYB/2),BThick);
 			}
 			*/
 		}
 		else if((pnota_prec->GetNStaff() > 0 && (beamPos == BEAM_12) || (pnota_prec->GetNStaff() > 1 && beamPos == BEAM_23)))
 		{
 			for(i=0;i<=comune;i++)
 			{
 				Tratto[currentView][numSegment][i].P1=Point(0,0);
 				Tratto[currentView][numSegment][i].PRef.x = pnota_prec->GetXgambo();
 				Tratto[currentView][numSegment][i].PRef.y = pnota_prec->GetYgambo()+pnota_prec->GetLGambo();
 				Tratto[currentView][numSegment][i].PRef = Tratto[currentView][numSegment][i].PRef - Point(0,i*dYB);
 				// DXGambo deve essere assegnato in base alla direzione ed alla
 				// dimensione della nota.
 				if(nID_corr==CL_NCROMA)
 				{
 					Tratto[currentView][numSegment][i].P2.x = pnota_prec->GetXgambo();
 					Tratto[currentView][numSegment][i].P2.y = pnota_prec->GetYgambo()+pnota_prec->GetLGambo();
 				}
 				else
 				{
 					Tratto[currentView][numSegment][i].P2.x = pnota_corr->GetXgambo();
 					Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
 						VUnit((-BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
 				}
 				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
 				if(Tratto[currentView][numSegment][i].P1==Point(0,0))
 					Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
 				Scr->BigLine(Tratto[currentView][numSegment][i].PRef+Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2+Point(0,BThick+dYB/2),BThick);
 			}

 			/*
 			for(i=0;i<NMezzo_tratt_prec;i++)
 			{
 				// DXGambo deve essere assegnato in base alla direzione ed alla
 				// dimensione della nota.
 				Tratto[currentView][numSegment][i].P2.x = pnota_prec->GetXgambo();
 				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
 					VUnit((BSlope[currentView]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
 
 				// Mezzo tratto verso destra, al di sotto delle midline
 				Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
 				Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x - TRATTOMEZZABARRA;
 				Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y - (VUnit)((BSlope[currentView])*TRATTOMEZZABARRA);
 				Scr->BigLine(Tratto[currentView][numSegment][i].P1-Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2-Point(0,BThick+dYB/2),BThick);
 			}
 			*/
 		}
 	}
}

void Raggruppamento::Adjust(Bool primaleg, Battuta *pBat, short current_layer, short current_staff, short numSegment, Figura *FirstFig, Figura *LastFig)
{
		
	//Node *pnode; 
 	Figura *pfig;
 	Nota *pnota;
 	Nota *pfn,*pln;
 	// Puntatori alla prima e all'ultima nota del gruppo.
 	Nota *PNSignif;
 	// Puntatore alla NOTA PIU' SIGNIFICATIVA del gruppo, presa come la nota
 	// piu' alta del gruppo se LGambo>0 o la piu' bassa se LGambo<0.  
 	VUnit x,dist,y=0,y0,lg,dx,dy;
	VUnit prova[12], anchorpos[12]; //GB
 	VUnit MHL=0;//GB
 	VUnit mindistMHL=0;//GB
 	Bool CorrectAdj;
 	// Segnala se Adjust sta lavorando correttamente.
    short Times, nb;
    ClassID nID;
	Battuta* pBattuta=pBat;
	//pfig=GetFirstFigura();
	//this->GetAbsPos().x;
	//int pos =(pfig->GetAbsPos()).x;
	//pos+=((pfig->GetPBattuta())->GetAbsPos()).x;
	//pos+=(pfig->GetPBattuta())->GetSpazioIniziale();
	//this->SetAbsPosX(pos);
//	BPoint1->x=pos;
//	pos=0;
	//this->DeleteRaggruppamento();
	for(int i=0; i< NUM_MAX_LAYER;i++)
		prova[i]=0;
     
 	if(primaleg)
 	{
 		// Inizializza i BPoint.
 		GetBPoint1(numSegment)=Point(0,0);
 		GetBPoint2(numSegment)=Point(0,0);                  
 		
 		// SCANSIONE DELLE NOTE PER DETERMINARE LA NOTA PIU' SIGNIFICATIVA
 		// E PER SISTEMARE LA POSIZIONE DELLE NOTE E DEGLI SPAZI.
 		//PNSignif=GetFirstNota();
		//PNSignif=(Nota*)GetFirstFigura();

		PNSignif=(Nota*)FirstFig;
		dx=0;
 		x=0;
 		NBarre[numSegment]=0;
 		//pnode=first;
		//pfig=GetFirstFigura();
		pfig=FirstFig;
    switch(beamPos)
		{             
		case BEAM_UP:
			while(pfig!=NULL)
			{          
				//pfig=(Figura*)pnode->ObjectPtr;
			//pfig->SetPBattuta(this->GetPBattuta());//commwnto provvisorio DS
				nID=pfig->GetID(); //PB1
				// Sistema le note e gli spazi. 
				// Se *pfig e' un accordo, prima di fare SetPos, occorre impostare
				// il gambo.
				/*if((pfig==GetFirstFigura())&&(pfig!=GetPFigStart())){

					dx+=(pfig->GetPBattuta())->GetSpazioIniziale();
					x+=(pfig->GetPBattuta())->GetSpazioIniziale();
				}*/

				if(nID==CL_SPAZIO) 
 				{
 					Spazio *figsp=(Spazio *)pfig;
  					anchorpos[current_layer]=((x-prova[current_layer])*figsp->Getrelpos())/100;//GB
					anchorpos[current_layer]+=prova[current_layer];//GB
				    pfig->SetPosWA(NULL,Point(this->GetAbsPos().x+UL2VU(anchorpos[current_layer]),pBattuta->GetIntest(pfig->GetNStaff())->GetAbsPos().y));//GB
				}
				else
				{
					prova[current_layer]=x; //GB
					if(nID==CL_ACCORDO) 
						((Accordo*)pfig)->SetLGambo(GetLGambo(numSegment));
					
					// RDS
					short nstaff=pfig->GetNStaff();//GB
					if(nstaff<0){//GB
						pfig->SetPosWA(NULL,Point(FirstFig->GetAbsPos().x+UL2VU(x)+dx,pBattuta->GetIntest(pfig->GetNStaff())->GetAbsPos().y));
					}
					else {//////////////////////////////////////////////////////////////////////////////////////
						pfig->SetPosWA(NULL,Point(FirstFig->GetAbsPos().x+UL2VU(x)+dx,pBattuta->GetIntest(pfig->GetNStaff())->GetAbsPos().y));
					}
					if(pfig->IsANote())
					{    
						pnota=(Nota*)pfig;
						//pnota->SetLGambo(GetLGambo());
	 					Bool gamboupdwn = TRUE;
 						int lgambo = int(posizionam.PosRule((DrawObject*)pnota, pnota, pnota->GetPBattuta(),
 						gamboupdwn, 0,pnota->GetNStaff()));
 						pnota->SetLGambo(lgambo);

						if(pnota->GetNStaff()<PNSignif->GetNStaff() ||
							(pnota->GetNStaff()==PNSignif->GetNStaff() &&
							pnota->GetAltezza()>PNSignif->GetAltezza()))
							PNSignif=pnota;
						// Calcola il numero di barrette.
						nID=pnota->GetID();
						if(nID==CL_ACCORDO)
							nID=((Accordo*)pnota)->GetNoteID();
						nb = nID - CL_NCROMA + 1;
						if(nb>NBarre[numSegment])
							NBarre[numSegment]=nb;
					}
				}
				//RDSRDS
//				if (pnota->GetTraceMilla())
//					this->SetTraceMilla(TRUE);
				//pnode=pnode->Next;
				
				
				// RDS
				x+=pfig->GetSp2NextFig(); //GetSpaceWidth();

				pfig=GetNextFig(pfig);
				if(pfig){
					if(pfig==GetNextFig(GetFineSegmento(FirstFig)))
						pfig=NULL;
				}
				if(pfig!=NULL)
				{
					Battuta* pBatt=pfig->GetPBattuta();
					if(pBatt!=pBattuta){
						//dx=(DIST_BATT_INTEST+17+(pBat->GetIntest())->GetWidth());
						dx=dx+pBatt->GetSpazioIniziale();
						x=x+pBatt->GetSpazioIniziale();
					}

					pBattuta=pBatt;
				}
			}
			break;
		case BEAM_DWN:
			while(pfig!=NULL)
			{
				//pfig=(Figura*)pnode->ObjectPtr;
				nID=pfig->GetID(); //PB1
				//pfig->SetPBattuta(this->GetPBattuta());//GB
				// Sistema le note e gli spazi. 
				// Se *pfig e' un accordo, prima di fare SetPos, occorre impostare
				// il gambo.
				/*if((pfig==GetFirstFigura())&&(pfig!=GetPFigStart())){

					dx+=(pfig->GetPBattuta())->GetSpazioIniziale();
					x+=(pfig->GetPBattuta())->GetSpazioIniziale();
				}*/
				if(nID==CL_SPAZIO) 
 				{
 					Spazio *figsp=(Spazio *)pfig;
  					anchorpos[current_layer]=((x-prova[current_layer])*figsp->Getrelpos())/100;//GB
					anchorpos[current_layer]+=prova[current_layer];//GB
				    pfig->SetPosWA(NULL,Point(this->GetAbsPos().x+UL2VU(anchorpos[current_layer]),pBattuta->GetIntest(pfig->GetNStaff())->GetAbsPos().y));//GB
				}
				else
				{
					prova[current_layer]=x; //GB
					if(nID==CL_ACCORDO) //PB1
						((Accordo*)pfig)->SetLGambo(GetLGambo(numSegment));
					// RDS
					short nstaff=pfig->GetNStaff();//GB
					if(nstaff<0){//GB
						pfig->SetPosWA(NULL,Point(FirstFig->GetAbsPos().x+UL2VU(x)+dx,pBattuta->GetIntest(pfig->GetNStaff())->GetAbsPos().y));
					}
					else {
						pfig->SetPosWA(NULL,Point(FirstFig->GetAbsPos().x+UL2VU(x)+dx,pBattuta->GetIntest(pfig->GetNStaff())->GetAbsPos().y));
					}
					if(pfig->IsANote())
					{    
						pnota=(Nota*)pfig;
//						pnota->SetLGambo(GetLGambo());
	 					Bool gamboupdwn = FALSE;
 						int lgambo = int(posizionam.PosRule((DrawObject*)pnota, pnota, pnota->GetPBattuta(),
 						gamboupdwn, 0,pnota->GetNStaff()));
 						pnota->SetLGambo(-lgambo);

						if(pnota->GetNStaff()>PNSignif->GetNStaff() ||
							(pnota->GetNStaff()==PNSignif->GetNStaff() &&
							pnota->GetAltezza()<PNSignif->GetAltezza()))
							PNSignif=pnota;
						// Calcola il numero di barrette.
						nID=pnota->GetID();
						if(nID==CL_ACCORDO)
							nID=((Accordo*)pnota)->GetNoteID();
						nb = nID - CL_NCROMA + 1;
						if(nb>NBarre[numSegment])
							NBarre[numSegment]=nb;
					}  
				}
				//pnode=pnode->Next;
				if (pnota->GetTraceMilla())
					this->SetTraceMilla(TRUE);
				
				
				x+=pfig->GetSp2NextFig();
				pfig=GetNextFig(pfig);
				if(pfig){
					if(pfig==GetNextFig(GetFineSegmento(FirstFig)))
						pfig=NULL;
				}
				if(pfig!=NULL)
				{
					Battuta* pBatt=pfig->GetPBattuta();
					if(pBatt!=pBattuta){
						//dx=(DIST_BATT_INTEST+17+(pBat->GetIntest())->GetWidth());
						dx=dx+pBatt->GetSpazioIniziale();
						x=x+pBatt->GetSpazioIniziale();
					}

					pBattuta=pBatt;
				}
			}
			break;
		case BEAM_12:
		case BEAM_23:
		{	
			VUnit nMax=0,nMin=0;
		    /*beamPos=BEAM_UP;
			Adjust(TRUE,this->GetFirstBattuta(),this->GetNumLayer(),current_staff);
			beamPos=BEAM_12;*/
			
			if((Nota*)FirstFig)//cast?
				GetBPoint1(numSegment)=Point(((Nota*)FirstFig)->GetXgambo(), y);
			if((Nota*)LastFig)
				GetBPoint2(numSegment)=Point(((Nota*)LastFig)->GetXgambo(), y);

			while(pfig!=NULL)
			{
				//pfig=(Figura*)pnode->ObjectPtr;
				nID=pfig->GetID(); //PB1
			//	pfig->SetPBattuta(this->GetPBattuta());//GB
				// Sistema le note e gli spazi. 
				// Se *pfig e' un accordo, prima di fare SetPos, occorre impostare
				// il gambo.
				if(nID==CL_SPAZIO) 
 				{
 					Spazio *figsp=(Spazio *)pfig;
  					anchorpos[current_layer]=((x-prova[current_layer])*figsp->Getrelpos())/100;//GB
					anchorpos[current_layer]+=prova[current_layer];//GB
				    pfig->SetPosWA(NULL,Point(this->GetAbsPos().x+UL2VU(anchorpos[current_layer]),pBattuta->GetIntest(pfig->GetNStaff())->GetAbsPos().y));//GB
				}
				else
				{
					prova[current_layer]=x; //GB
					if(nID==CL_ACCORDO) //PB1
						((Accordo*)pfig)->SetLGambo(GetLGambo(numSegment));
					short nstaff=pfig->GetNStaff();//GB
					if(nstaff<0){//GB
						pfig->SetPosWA(NULL,Point(FirstFig->GetAbsPos().x+UL2VU(x),pBattuta->GetIntest(pfig->GetNStaff())->GetAbsPos().y));
					}
					else {
						pfig->SetPosWA(NULL,Point(FirstFig->GetAbsPos().x+UL2VU(x),pBattuta->GetIntest(pfig->GetNStaff())->GetAbsPos().y));
					}
					if(pfig->IsANote())
					{    
						pnota=(Nota*)pfig;
						pnota->SetLGambo(GetLGambo(numSegment));
						if((beamPos==BEAM_12 && pnota->GetNStaff()!=2)||
							(beamPos==BEAM_23 && pnota->GetNStaff()!=0))
						{
							if(nMax==0 || pnota->GetAbsPos().y > nMax) nMax=pnota->GetAbsPos().y;
							if(nMin==0 || pnota->GetAbsPos().y < nMin) nMin=pnota->GetAbsPos().y;
						}
						// Calcola il numero di barrette.
						nID=pnota->GetID();
						if(nID==CL_ACCORDO)
							nID=((Accordo*)pnota)->GetNoteID();
						nb = nID - CL_NCROMA + 1;
						if(nb>NBarre[numSegment])
							NBarre[numSegment]=nb;
					}
				}
				if (pnota->GetTraceMilla()) 
					this->SetTraceMilla(TRUE);

				//pnode=pnode->Next;
							
				x+=pfig->GetSp2NextFig();
				pfig=GetNextFig(pfig);
				if(pfig){
					if(pfig==GetNextFig(GetFineSegmento(FirstFig)))
						pfig=NULL;
				}
				if(pfig!=NULL)
					pBattuta=pfig->GetPBattuta();
			}
			//pnode=first;
			pfig=FirstFig;
			MHL=(nMax+nMin)/2;
			mindistMHL=0;
			while(pfig!=NULL)
			{
				//pfig=(Figura*)pnode->ObjectPtr;
				
				if(pfig->IsANote())
				{    
					pnota=(Nota*)pfig;
					if(beamPos==BEAM_12 || beamPos==BEAM_23)
					{
						VUnit diff=pnota->GetAbsPos().y-MHL;
						VUnit dist=abs(diff);
						if(mindistMHL==0 || dist < mindistMHL)
						{
							mindistMHL=dist;
							PNSignif=pnota;
						}
						if(diff>0 )
							pnota->SetLGambo(-GetLGambo(numSegment));
						else
							pnota->SetLGambo(GetLGambo(numSegment));
					}
				}  
				//pnode=pnode->Next;
				pfig=GetNextFig(pfig);
				if(pfig){
					if(pfig==GetNextFig(GetFineSegmento(FirstFig)))
						pfig=NULL;
				}
				if(pfig!=NULL){
					
					Battuta* pBatt=pfig->GetPBattuta();
					if(pBatt!=pBattuta){
						//dx=(DIST_BATT_INTEST+17+(pBat->GetIntest())->GetWidth());
						dx=dx+pBatt->GetSpazioIniziale();
						x=x+pBatt->GetSpazioIniziale();
					}

					pBattuta=pBatt;
				}
			}
		}
		break;
		}      
		
		// RAGGRUPPAMENTO DELLE NOTE. 
		SetNumNote();
		
		if(GetNumNote()>1)
		{  
			pfn=(Nota*)FirstFig;
			pln=(Nota*)LastFig;
			// Imposta l'inclinazione delle barrette.
			//    dx=pln->GetAbsPos().x - pfn->GetAbsPos().x;
			//    printf("dx :%d\n",dx);
			
			BSlope[currentView][numSegment]=posizionam.PosRule(this, pfn, pfn->GetPBattuta(), 0, 0,0); // GB 4 e 5 zero sono current_layer e current_staff
			// ultimo zero e' traceconditionsmilla
			//    printf("BSlope:%f\n",BSlope);
						
			// Imposta il punto di riferimento per calcolare i gambi. Esso  preso
			// LGambo VUnit sopra (o sotto) la nota piu' significativa. Percio' anche
			// la lunghezza del gambo della nota piu' significativa viene modificata.
			if(beamPos==BEAM_UP || beamPos==BEAM_DWN)
			{
				//PNSignif->SetLGambo(GetLGambo());
			}
			else
				PNSignif->SetLGambo(MHL-PNSignif->GetAbsPos().y);//GB
			PNSignif->AdjustF();
			PNSignif->SetVU2Up(PNSignif->GetVU2UpF());
			PNSignif->SetVU2Dwn(PNSignif->GetVU2DwnF());
			PNSignif->SetVU2Lft(PNSignif->GetVU2LftF());
			PNSignif->SetVU2Rgt(PNSignif->GetVU2RgtF());  
			PNSignif->Adjust(TRUE,pBattuta,current_layer,current_staff);
			y0= PNSignif->GetYgambo() + PNSignif->GetLGambo();//GB
			CorrectAdj=FALSE;
			Times=0;
			
			// Di regola il corpo del seguente ciclo verra' eseguito una sola volta.
			// Se pero' qualche gambo si ritrova una lunghezza troppo bassa, il
			// valore di BSlope[currentView] viene cambiato e viene fatta una seconda iterazione.
			// La variabile Times impedisce i loop infiniti.
			while(!CorrectAdj && Times<2)
			{       
				Times++;
				// Suppone che l'impostazione avverra' correttamente.
				CorrectAdj=TRUE;
				// Scandisce la lista per impostare i gambi delle note.
				//pnode=first;
				pfig=FirstFig;
				pBattuta=pfig->GetPBattuta();
				while(pfig!=NULL && CorrectAdj)
				{      
					//pfig=(Figura*)pnode->ObjectPtr;
					nID=pfig->GetID();
					// Salta gli spazi, cambi chiave e pause.
					if(pfig->IsANote())
					{
						pnota=(Nota*)pfig;

						pnota->Adjust(TRUE,pBattuta,current_layer,current_staff);
						dist= pnota->GetXgambo() - PNSignif->GetXgambo();
						y=(int)(y0+BSlope[currentView][numSegment]*dist);
						lg=y - pnota->GetYgambo();
						// Se il gambo appena calcolato e' lungo meno di LGAMBOMIN/2 o e'
						// nella direzione opposta a quella desiderata, la scansione del
						// gruppo viene interrotta e va rifatta da capo, con un nuovo
						// valore di BSlope[currentView].
						if((pnota->GetLGambo()>0 && lg<(GetNotina()?LGAMBOBEAMMIN/2:LGAMBOBEAMMIN)) ||
							(pnota->GetLGambo()<0 && lg>-(GetNotina()?LGAMBOBEAMMIN/2:LGAMBOBEAMMIN)))
						{
							CorrectAdj=FALSE;       
							BSlope[currentView][numSegment]=0;
						}
						else
						{ 
							if(pnota==(Nota*)FirstFig)//cast?
								GetBPoint1(numSegment)=Point(pnota->GetXgambo(), y);
							if(pnota==(Nota*)LastFig)
								GetBPoint2(numSegment)=Point(pnota->GetXgambo(), y);
							if(pnota->GetLGambo()>0)
							{
								if(beamPos==BEAM_12 || beamPos==BEAM_23)
								{
									if(GetNotina())
										pnota->SetLGambo(lg);
									else
										pnota->SetLGambo(lg);
								}
								else
								{
									if(GetNotina())
										pnota->SetLGambo(lg+(NBarre[numSegment]-1)*DELTAYBARRETTE1);
									else
										pnota->SetLGambo(lg+(NBarre[numSegment]-1)*DELTAYBARRETTE-(THICKBARRETTA-THICKBARRETTA/3));
								}
							}
							else if(pnota->GetLGambo()<0)
							{
								if(beamPos==BEAM_12 || beamPos==BEAM_23)//GB
								{
									if(GetNotina())
										pnota->SetLGambo(lg);
									else
										pnota->SetLGambo(lg);
								}
								else
								{
									if(GetNotina())
										pnota->SetLGambo(lg-(NBarre[numSegment]-1)*DELTAYBARRETTE1);
									else
										pnota->SetLGambo(lg-(NBarre[numSegment]-1)*DELTAYBARRETTE+(THICKBARRETTA-THICKBARRETTA/3));
								}
							}
						}
						pnota->SetCoda(FALSE);
						
						pnota->AdjustF();
						pnota->SetVU2Up(pnota->GetVU2UpF());
						pnota->SetVU2Dwn(pnota->GetVU2DwnF());
						pnota->SetVU2Lft(pnota->GetVU2LftF());
						pnota->SetVU2Rgt(pnota->GetVU2RgtF());  
						
						pnota->Adjust(TRUE, pBattuta, current_layer,current_staff);
						//pnota->Draw();
						
					}
					else
						pfig->Adjust(TRUE, pBattuta, current_layer,current_staff);

					//pnode=pnode->Next;
					pfig=GetNextFig(pfig);
					if(pfig){
						if(pfig==GetNextFig(GetFineSegmento(FirstFig)))
							pfig=NULL;
					}
					if(pfig!=NULL)
						pBattuta=pfig->GetPBattuta();
				}  
			}
       }
	 }
     //else
     {
		 // CALCOLO DEI RETTANGOLI CHE CIRCONDANO IL GRUPPO.
		 pfig=FirstFig;
		 
		 
		 SetVU2UpF(0);
		 SetVU2DwnF(0);
		 SetVU2Up(0);
		 SetVU2Dwn(0);
		 //GetAbsPos()=();
		 //AbsPos[0].y=pfig->GetAbsPos().y;

		 SetAbsPosX(pfig->GetAbsPos().x);
		 SetAbsPosY(pfig->GetAbsPos().y);
		
		 //pnode=first;
		 //pfig=FirstFig;
		 while(pfig!=NULL)
		 {           
			 //pfig=(Figura*)pnode->ObjectPtr;

			 pfig->Adjust(FALSE, pBattuta, current_layer,current_staff); 
			 //aggiunto l'argomento da Titti..verificare
			 // quando sistemo Adjust del gruppo. 
			 dy=pfig->GetAbsPos().y-GetAbsPos().y;
			 if(pfig->GetVU2UpF()+dy > GetVU2UpF())
				 SetVU2UpF(pfig->GetVU2UpF()+dy);
			 if(pfig->GetVU2DwnF()-dy > GetVU2DwnF())
				 SetVU2DwnF(pfig->GetVU2DwnF()-dy);
			 if(pfig->GetVU2Up()+dy > GetVU2Up())
				 SetVU2Up(pfig->GetVU2Up()+dy);
			 if(pfig->GetVU2Dwn()-dy > GetVU2Dwn())
				 SetVU2Dwn(pfig->GetVU2Dwn()-dy);

			 //pnode=pnode->Next;
			 pfig=GetNextFig(pfig);
			 if(pfig){
					if(pfig==GetNextFig(GetFineSegmento(FirstFig)))
						pfig=NULL;
				}
			 	if(pfig!=NULL)
					pBattuta=pfig->GetPBattuta();
				//pfig->Draw();
		 }
		 
		 // Sistema il rettangolo attorno al gruppo di note.
		 //SetVU2LftF(((Figura*)first->ObjectPtr)->GetVU2LftF());   
		 SetVU2LftF((FirstFig)->GetVU2LftF());
		 SetVU2RgtF((LastFig)->GetVU2RgtF() +
			 (LastFig)->GetAbsPos().x -
			 (FirstFig)->GetAbsPos().x); 
		 if(GetNumNote()>0)
		 { 
			 dx = GetAbsPos().x - FirstFig->GetAbsPos().x +  //era getfirstnota
				 FirstFig->GetVU2Lft();//era getfirstnota
			 if(GetVU2LftF()<dx)
				 SetVU2Lft(dx);  
			 else
				 SetVU2Lft(GetVU2LftF());
			 dx = LastFig->GetAbsPos().x + LastFig->GetVU2Rgt() -//era getlastnota
				 GetAbsPos().x;
			 if(GetVU2RgtF()<dx)
				 SetVU2Rgt(dx);   
			 else
				 SetVU2Rgt(GetVU2RgtF());
		 }
		 else
		 {
			 // Se nel gruppo ci sono solo spazi.
			 SetVU2Lft(GetVU2LftF());
			 SetVU2Rgt(GetVU2RgtF());
		 }  
     }
	//pfig=GetFirstFigura();
	//VUnit a=(pfig->GetAbsPos()).x;
	//a+=pfig->GetVU2LftF();
	//a+=((pfig->GetPBattuta())->GetAbsPos()).x;
	//a+=(pfig->GetPBattuta())->GetSpazioIniziale();
	//this->SetAbsPosX(a);
	 if ((FirstFig!=NULL)&&(LastFig!=NULL)&&(this->isOne())){
				((Nota*)FirstFig)->SetCoda(TRUE);
 				return;
	}

	 if(LastFig!=PFigEnd){
		 GetBPoint2(numSegment).x +=7;
	 }

	 if(FirstFig!=PFigStart){
		 GetBPoint1(numSegment).x -=7;
	 }

	 
     return;
}  

void Raggruppamento::SetVU2UpF(VUnit vu)
{
  VU2UpF=vu;
}


void Raggruppamento::SetVU2DwnF(VUnit vu)
{
  VU2DwnF=vu;
}


void Raggruppamento::SetVU2LftF(VUnit vu)
{
  VU2LftF=vu;
}


void Raggruppamento::SetVU2RgtF(VUnit vu)
{
  VU2RgtF=vu;
}

    
VUnit Raggruppamento::GetVU2UpF()
{
  return VU2UpF;
}


VUnit Raggruppamento::GetVU2DwnF()
{
  return VU2DwnF;
}


VUnit Raggruppamento::GetVU2LftF()
{
  return VU2LftF;
}
  

VUnit Raggruppamento::GetVU2RgtF()
{
  return VU2RgtF;
}
      

void Raggruppamento::SetVU2Up(VUnit vu)
{
  VU2Up=vu;
}

  
void Raggruppamento::SetVU2Dwn(VUnit vu)
{
  VU2Dwn=vu;
}

  
void Raggruppamento::SetVU2Lft(VUnit vu)
{
  VU2Lft=vu;
}

  
void Raggruppamento::SetVU2Rgt(VUnit vu)
{
  VU2Rgt=vu;
}

    
VUnit Raggruppamento::GetVU2Up()
{
  return VU2Up;
}


VUnit Raggruppamento::GetVU2Dwn()
{
  return VU2Dwn;
}


VUnit Raggruppamento::GetVU2Lft()
{
  return VU2Lft;
}


VUnit Raggruppamento::GetVU2Rgt()
{
  return VU2Rgt;
}
          
void Raggruppamento::DeleteRaggruppamento(){
	
	Figura *FirstFig, *LastFig, *CurrentFig;
	FirstFig=GetPFigStart();

	LastFig=GetPFigEnd();

	CurrentFig = FirstFig;
	Bool gamboupdwn;
	Nota* pnota;
	int lgambo;

	while (CurrentFig!=NULL)
	{
		if (CurrentFig->IsANote())
		{
		pnota=(Nota*)CurrentFig;
		((Nota*)CurrentFig)->SetCoda(TRUE);
			if (immissione.ImmRule(pnota->GetID(), pnota, pnota->GetPBattuta(), NULL,GetNumLayer()))  				
			{ 
				if (pnota->GetNotina())
					pnota->SetGamboUp();
				else
				{ 
					gamboupdwn = TRUE;
					lgambo = int(posizionam.PosRule((DrawObject*)pnota, pnota, pnota->GetPBattuta(),
						gamboupdwn, GetNumLayer(),pnota->GetNStaff()));  
					pnota->SetLGambo(lgambo);
				}
			}	  
			else 
			{  
				if (pnota->GetNotina())
					pnota->SetGamboDwn();
				else
				{ 
					gamboupdwn = FALSE;
					lgambo = int(posizionam.PosRule((DrawObject*)pnota, pnota, pnota->GetPBattuta(),
						gamboupdwn, GetNumLayer(),pnota->GetNStaff()));  
					pnota->SetLGambo(-lgambo);
				}
			}	
		}
		CurrentFig=GetNextFig(CurrentFig);				
	}	
}

bool Raggruppamento::IsInRaggruppamento(Figura *pfig){

	Figura *FirstFig, *LastFig, *CurrentFig;
	bool IsIn=FALSE;
	FirstFig=GetFirstFigura();
	LastFig=GetLastFigura();
	CurrentFig=FirstFig;

	while ((CurrentFig!=NULL)&&(IsIn!=TRUE)){
		if(CurrentFig==pfig)
			IsIn=TRUE;
		else
			CurrentFig=GetNextFigura(CurrentFig);
	}

	return IsIn;

}

Bool Raggruppamento::Hit(const Point& p, SelObj selObj, DrawObject*& drwObjSel,
						 SymPath& symPath)
{
	bool		hit;   
	Point		p1;
	Figura		*pFig, *fig;
	Battuta		*pBattuta;
	Layer		*pLayer;
	int			level;
	
	pFig = GetFirstFigura();
	
	if ( pFig!=NULL )
		p1=p-(GetFirstFigura()->GetAbsPos());               
	hit = -p1.x <= GetVU2LftF() && p1.x <= GetVU2RgtF() &&
        -p1.y <= GetVU2DwnF() && p1.y <= GetVU2UpF();
	
	drwObjSel=NULL;
	level = symPath.Level;
	
	if(selObj==ANY_SEL)
	{		
		if(hit)
		{
			symPath.Level = FIGURA1_PATH_LEVEL;
			while (pFig != NULL)
			{	
				if(pFig->Hit(p,selObj,drwObjSel,symPath))
				{
					for(int layer=0;layer<NUM_MAX_LAYER;layer++)
					{
						pBattuta=	pFig->GetPBattuta();
						pLayer=		pBattuta->GetPLayer(layer);
						if(pLayer!=NULL)
						{
							fig = pLayer -> GetFirstF();
							while(fig != NULL)
							{
								if( fig == pFig )
								{
									symPath.Array[BATTUTA_PATH_LEVEL]=pBattuta->GetNumericCode();
									symPath.Array[LAYER_PATH_LEVEL]=layer + 1;
									return(TRUE);
								}  
								fig = pLayer -> GetNextF(fig);
							}
						}
					}
					break;
				}
				pFig = this->GetNextFigura(pFig);
			}
			
			drwObjSel=this;
			symPath.Level = level;
			symPath.Array[symPath.Level]=GetNumericCode();
			
			return(TRUE);
		}
		else return(FALSE);
	}
	
	return(FALSE);
}

 
/*FFF
void Raggruppamento::printBarre(short numSegment)
{
  //Node *pnode;
  Figura *pfig;
  Nota *pnota;
  short Direz, i;
//  float BSlope[currentView];
  ClassID nID;
  VUnit BThick, dYB;

  //GB
  if(beamPos==BEAM_12 || beamPos==BEAM_23)
  {
	  printBarreMiddle(numSegment);
	  return;
  }

  // Disegna le barrette solo se il metodo Adjust ha avuto buon esito.                   
  if(GetBPoint1(numSegment)==Point(0,0) || GetBPoint1(numSegment).x==GetBPoint2(numSegment).x)
    return;            
            
 // Direz = (GetLGambo(numSegment)>0)? 1: -1;
  Direz = (((Nota*)PFigStart)->GetLGambo()>0)? 1: -1;
  // GetBPoint2().y viene ricalcolato poiche' precedenti errori di approssimazione
  // potrebbero guastare il parallelismo della barra superiore.
  GetBPoint2(numSegment).y = GetBPoint1(numSegment).y + (VUnit)(BSlope[currentView][numSegment]*(GetBPoint2(numSegment).x-GetBPoint1(numSegment).x));
  

  BThick = (GetNotina()?THICKBARRETTA1:THICKBARRETTA);         
  dYB = (GetNotina()?DELTAYBARRETTE1:DELTAYBARRETTE);

    // DISEGNO PER LE NOTE.
    // Inizia dalla barra piu` esterna.
	  Prn->Write("newpath ");
	  Prn->Write(" %d PU %d PU moveto %d PU %d PU lineto \n",GetBPoint1(numSegment).x,GetBPoint1(numSegment).y+Direz*(NBarre[numSegment]-1)*dYB,GetBPoint2(numSegment).x,GetBPoint2(numSegment).y+Direz*(NBarre[numSegment]-1)*dYB);
	  Prn->Write(" %d PU %d PU lineto %d PU %d PU lineto \n",GetBPoint2(numSegment).x,GetBPoint2(numSegment).y+Direz*(NBarre[numSegment]-1)*dYB-(Direz*BThick),GetBPoint1(numSegment).x,GetBPoint1(numSegment).y+Direz*(NBarre[numSegment]-1)*dYB-(Direz*BThick));
	  Prn->Write("closepath fill \n");
	  Prn->Write("stroke \n");
	// Eventualmente prosegui con le barre interne.
    for(i=0;i<NBarre[numSegment]-1;i++)
    {
      Tratto[currentView][numSegment][i].PRef = GetBPoint1(numSegment)+Point(0, Direz*(i)*dYB);
      Tratto[currentView][numSegment][i].P1 = Point(0,0);     
    }


    //pnode = first;
	pfig=GetPSegment(numSegment)->FirstFig;
    while(pfig!=NULL)
    {
      //pfig = (Figura*)pnode->ObjectPtr;
      nID = pfig->GetID();
      // Salta gli spazi
      if(nID!=CL_SPAZIO)
      {
        pnota = (Nota*)pfig;

		if(nID==CL_ACCORDO)
		  nID = ((Accordo*)pnota)->GetNoteID();

		switch(nID)
		{
		  case CL_NCROMA:
		    printTratto(pnota, NBarre[numSegment]-1, Direz, BThick,numSegment);
	    	break;
		  case CL_NSEMICROMA:
		    printTratto(pnota, NBarre[numSegment]-2, Direz, BThick,numSegment);
	    	break;
		  case CL_NBISCROMA:
		    printTratto(pnota, NBarre[numSegment]-3, Direz, BThick,numSegment);
	    	break;
		  case CL_NSEMIBISCROMA:
		    printTratto(pnota, NBarre[numSegment]-4, Direz, BThick,numSegment);
	    	break;
	          case CL_NFUSA:
    	            printTratto(pnota, NBarre[numSegment]-5, Direz, BThick,numSegment);
        	break;
		}
      }
      //pnode=GetNext(pnode);
	  	pfig=GetNextFig(pfig);
				if(pfig){
					if(pfig==GetNextFig(GetFineSegmento(GetPSegment(numSegment)->FirstFig)))
						pfig=NULL;
				}

    }
    // Concludi il disegno dei tratti.
    printTratto(NULL, NBarre[numSegment]-1, Direz, BThick,numSegment);
	
}                                                  
                                                 

//GB
void Raggruppamento::printBarreMiddle(short numSegment)
{
	//Node *pnode_prec,*pnode_corr;
	Figura *pfig_corr,*pfig_prec;

	Nota *pnota_prec,*pnota_corr;
	  // GB Puntatori alla nota attuale ed alla sua precedente
	  // Si guarda indietro, poiche e' la prima nota a dominare
	  // la parte da cui si disegna il tratto in base al suo gambo,
	  // infatti se sopra o sotto la linea di mezzo.

	short Direz;
//	short i;
//	short DirezNota;
    //  float BSlope[currentView];
//	ClassID nID_corr;
	ClassID nID_prec;
	VUnit BThick, dYB;


  // Disegna le barrette solo se il metodo Adjust ha avuto buon esito.                   
  if(GetBPoint1(numSegment)==Point(0,0) || GetBPoint1(numSegment).x==GetBPoint2(numSegment).x)
    return;            
            
  Direz = (((Nota*)GetFirstFigura())->GetLGambo()>0)? 1: -1;
  // GetBPoint2().y viene ricalcolato poiche' precedenti errori di approssimazione
  // potrebbero guastare il parallelismo della barra superiore.
  GetBPoint2(numSegment).y = GetBPoint1(numSegment).y + (VUnit)(BSlope[currentView][numSegment]*(GetBPoint2(numSegment).x-GetBPoint1(numSegment).x));
  

  BThick = (GetNotina()?THICKBARRETTA1:THICKBARRETTA);         
  dYB = (GetNotina()?DELTAYBARRETTE1:DELTAYBARRETTE);

    // DISEGNO PER LE NOTE.
    // Inizia dalla barra piu` esterna.
	  Prn->Write("newpath ");
	  Prn->Write(" %d PU %d PU moveto %d PU %d PU lineto \n",GetBPoint1(numSegment).x,GetBPoint1(numSegment).y,GetBPoint2(numSegment).x,GetBPoint2(numSegment).y);//GB
	  Prn->Write(" %d PU %d PU lineto %d PU %d PU lineto \n",GetBPoint2(numSegment).x,GetBPoint2(numSegment).y+BThick,GetBPoint1(numSegment).x,GetBPoint1(numSegment).y+BThick);//GB
	  Prn->Write("closepath fill \n");
	  Prn->Write("stroke \n");


    //pnode_prec = first;
	//pnode_corr = GetNext(pnode_prec);
	 pfig_prec = GetPSegment(numSegment)->FirstFig;
	pfig_corr = GetNextFigura(pfig_prec);
	while(pfig_prec!=NULL)
	{
		//pfig_corr = (Figura*)pnode_corr->ObjectPtr;
		//pfig_prec = (Figura*)pnode_prec->ObjectPtr;
		// Salta gli spazi
		if(nID_prec!=CL_SPAZIO)
		{
            pnota_corr = (Nota*)pfig_corr;
			pnota_prec = (Nota*)pfig_prec;
			
			if(nID_prec==CL_ACCORDO)
				nID_prec = ((Accordo*)pnota_prec)->GetNoteID();
			
			printTrattoMiddle(pnota_corr,pnota_prec,BThick,dYB,numSegment);
		}
		//pnode_corr=GetNext(pnode_corr);
		pfig_corr=GetNextFig(pfig_corr);
				if(pfig_corr){
					if(pfig_corr==GetNextFig(GetFineSegmento(GetPSegment(numSegment)->FirstFig)))
						pfig_corr=NULL;
				}
		if(pfig_corr==NULL)
		{
			pfig_corr=pfig_prec;
			pfig_prec=this->GetPrevFigura(pfig_prec);
			break;
		}
		//pnode_prec=GetNext(pnode_prec);
		pfig_prec=GetNextFigura(pfig_prec);
		
		
	}
    // Concludi il disegno dei tratti.
    //printTrattoMiddle(NULL, NBarre-1, Direz, BThick);
	
}                                                  


void Raggruppamento::printTrattoMiddle(Nota *pnota_corr,Nota *pnota_prec, VUnit BThick, VUnit dYB, short numSegment)
{
  short i,NBarre_corr=0,NBarre_prec=0,NBarre_Nota_prec=0,NBarre_Nota_corr=0;
//  short NBarre_in_comune;
short comune,NMezzo_tratt_prec,NMezzo_tratt_corr;
	ClassID nID_corr,nID_prec; 

		// GB Calcola il numero di barrette della nota corrente
	nID_corr=pnota_corr->GetID();
	if(nID_corr==CL_ACCORDO)
		nID_corr=((Accordo*)pnota_corr)->GetNoteID();
	NBarre_Nota_corr = nID_corr - CL_NCROMA + 1;
		
	// GB Calcola il numero di barrette della nota precedente
	nID_prec=pnota_prec->GetID();
	if(nID_prec==CL_ACCORDO)
		nID_prec=((Accordo*)pnota_prec)->GetNoteID();
	NBarre_Nota_prec = nID_prec - CL_NCROMA + 1;
	

	// GB si scalano di uno per via della barra centrale sempre presente
	NBarre_corr = NBarre_Nota_corr - 1; // numero di barrette scalate di quella centrale
	NBarre_prec = NBarre_Nota_prec - 1; // numero di barrette scalate di quella centrale

	// GB barre che si possono unire delle due note, naturalmente escludendo quella centrale
	comune = (NBarre_corr > NBarre_prec)? NBarre_prec:NBarre_corr;
	
	NMezzo_tratt_prec = NBarre_Nota_prec - comune - 1;
	

	// GB caso particolare nel caso la prima delle due sia una CROMA
	if(NBarre_prec == 0 && (NBarre_corr >=0 && (GetLastNota()!=pnota_corr)))
	{
		return;
	}
	// GB caso particolare che la penultima sia una CROMA e l'ultima sia di durata minore
	else if(NBarre_prec == 0 && (NBarre_corr >=0 && (GetLastNota()==pnota_corr)))
	{
		NMezzo_tratt_corr = NBarre_Nota_corr - comune - 1;
		if((pnota_corr->GetNStaff() == 0 && beamPos == BEAM_12) || (pnota_corr->GetNStaff() <= 1 && beamPos == BEAM_23) )
		{
			for(i=0;i<NMezzo_tratt_corr;i++)
			{
				Tratto[currentView][numSegment][i].P1=Point(0,0);
				Tratto[currentView][numSegment][i].PRef = GetBPoint2(numSegment)+Point(0, i*dYB);
				// DXGambo deve essere assegnato in base alla direzione ed alla
				// dimensione della nota.
				Tratto[currentView][numSegment][i].P2.x = pnota_corr->GetXgambo();
				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y +
					VUnit((BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
				if(Tratto[currentView][numSegment][i].P1==Point(0,0))
					Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
			}
			for(i=0;i<NMezzo_tratt_corr;i++)
			{
				// Mezzo tratto verso sinistra, al di sopra della midline
				Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
				Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x - TRATTOMEZZABARRA;
				Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y + (VUnit)((-BSlope[currentView][numSegment])*TRATTOMEZZABARRA);
				//Scr->BigLine(Tratto[currentView][numSegment][i].P1+Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2+Point(0,BThick+dYB/2),BThick);
				Prn->Write("newpath ");
				Prn->Write(" %d PU %d PU moveto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P1.x,Tratto[currentView][numSegment][i].P1.y+(dYB),Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y+(dYB));
				Prn->Write(" %d PU %d PU lineto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y+(BThick+dYB),Tratto[currentView][numSegment][i].P1.x,Tratto[currentView][numSegment][i].P1.y+(BThick+dYB));
				Prn->Write("closepath fill \n");
				Prn->Write("stroke \n");
			}
		}
		else if((pnota_corr->GetNStaff() > 0 && (beamPos == BEAM_12) || (pnota_corr->GetNStaff() > 1 && beamPos == BEAM_23)))
		{
			for(i=0;i<NMezzo_tratt_corr;i++)
			{
				Tratto[currentView][numSegment][i].P1=Point(0,0);
				Tratto[currentView][numSegment][i].PRef = GetBPoint2(numSegment)-Point(0, i*dYB);
				// DXGambo deve essere assegnato in base alla direzione ed alla
				// dimensione della nota.
				Tratto[currentView][numSegment][i].P2.x = pnota_corr->GetXgambo();
				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
					VUnit((BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
				if(Tratto[currentView][numSegment][i].P1==Point(0,0))
					Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
			}
			for(i=0;i<NMezzo_tratt_corr;i++)
			{
				// DXGambo deve essere assegnato in base alla direzione ed alla
				// dimensione della nota.
				Tratto[currentView][numSegment][i].P2.x = pnota_corr->GetXgambo();
				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
					VUnit((BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));

				// Mezzo tratto verso sinistra, al di sotto delle midline
				Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
				Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x - TRATTOMEZZABARRA;
				Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y - (VUnit)((BSlope[currentView][numSegment])*TRATTOMEZZABARRA);
				//Scr->BigLine(Tratto[currentView][numSegment][i].P1-Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2-Point(0,BThick+dYB/2),BThick);
				Prn->Write("newpath ");
				Prn->Write(" %d PU %d PU moveto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P1.x,Tratto[currentView][numSegment][i].P1.y-(dYB),Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y-(dYB));
				Prn->Write(" %d PU %d PU lineto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y-(BThick+dYB),Tratto[currentView][numSegment][i].P1.x,Tratto[currentView][numSegment][i].P1.y-(BThick+dYB));
				Prn->Write("closepath fill \n");
				Prn->Write("stroke \n");
			}
		}
	} // GB caso in cui la prima nota sia isolata da una CROMA che segue
	else if(((NBarre_prec >= 0 && (GetFirstNota() == pnota_prec)) && NBarre_corr == 0) || (NBarre_prec >= 0 && NBarre_corr == 0 ))
	{
		NMezzo_tratt_prec = NBarre_Nota_prec - comune - 1;
		if((pnota_prec->GetNStaff() == 0 && beamPos == BEAM_12) || (pnota_prec->GetNStaff() <= 1 && beamPos == BEAM_23) )
		{
			for(i=0;i<NMezzo_tratt_prec;i++)
			{
				Tratto[currentView][numSegment][i].P1=Point(0,0);
				Tratto[currentView][numSegment][i].PRef = GetBPoint1(numSegment)+Point(0, i*dYB);
				// DXGambo deve essere assegnato in base alla direzione ed alla
				// dimensione della nota.
				Tratto[currentView][numSegment][i].P2.x = pnota_prec->GetXgambo();
				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y +
					VUnit((-BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
				if(Tratto[currentView][numSegment][i].P1==Point(0,0))
					Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
			}
			for(i=0;i<NMezzo_tratt_prec;i++)
			{
				
			
				// Mezzo tratto verso destra, al di sopra della midline
				Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
				Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x + TRATTOMEZZABARRA;
				Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y + (VUnit)((BSlope[currentView][numSegment])*TRATTOMEZZABARRA);
				//Scr->BigLine(Tratto[currentView][numSegment][i].P1+Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2+Point(0,BThick+dYB/2),BThick);
				Prn->Write("newpath ");
				Prn->Write(" %d PU %d PU moveto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P1.x,Tratto[currentView][numSegment][i].P1.y+dYB,Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y+dYB);
				Prn->Write(" %d PU %d PU lineto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y+(BThick+dYB),Tratto[currentView][numSegment][i].P1.x,Tratto[currentView][numSegment][i].P1.y+(BThick+dYB));
				Prn->Write("closepath fill \n");
				Prn->Write("stroke \n");
			}
		}
		else if((pnota_prec->GetNStaff() > 0 && (beamPos == BEAM_12) || (pnota_prec->GetNStaff() > 1 && beamPos == BEAM_23)))
		{
			for(i=0;i<NMezzo_tratt_prec;i++)
			{
				Tratto[currentView][numSegment][i].P1=Point(0,0);
				Tratto[currentView][numSegment][i].PRef = GetBPoint1(numSegment)-Point(0, i*dYB);
				// DXGambo deve essere assegnato in base alla direzione ed alla
				// dimensione della nota.
				Tratto[currentView][numSegment][i].P2.x = pnota_prec->GetXgambo();
				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
					VUnit(BSlope[currentView][numSegment] * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
				if(Tratto[currentView][numSegment][i].P1==Point(0,0))
					Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
			}
			for(i=0;i<NMezzo_tratt_prec;i++)
			{
				// DXGambo deve essere assegnato in base alla direzione ed alla
				// dimensione della nota.
				Tratto[currentView][numSegment][i].P2.x = pnota_prec->GetXgambo();
				Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
					VUnit(BSlope[currentView][numSegment] * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));

				// Mezzo tratto verso destra, al di sotto delle midline
				Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
				Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x + TRATTOMEZZABARRA;
				Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y - (VUnit)((-BSlope[currentView][numSegment])*TRATTOMEZZABARRA);
				//Scr->BigLine(Tratto[currentView][numSegment][i].P1-Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2-Point(0,BThick+dYB/2),BThick);
				Prn->Write("newpath ");
				Prn->Write(" %d PU %d PU moveto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P1.x,Tratto[currentView][numSegment][i].P1.y-dYB,Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y-dYB);
				Prn->Write(" %d PU %d PU lineto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y-(BThick+dYB),Tratto[currentView][numSegment][i].P1.x,Tratto[currentView][numSegment][i].P1.y-(BThick+dYB));
				Prn->Write("closepath fill \n");
				Prn->Write("stroke \n");
			}
		}
	}

	// GB disegna le barre prendendo come riferimento (nota dominante)
	// la prima nota che ha una barra in piu rispetto alla centrale e 
	// come verso, quello dalla parte dello staff di appartenenza.
	else 
	{
		NMezzo_tratt_prec = NBarre_Nota_prec - comune - 1;
		NMezzo_tratt_corr = NBarre_Nota_corr - comune - 1;
		if((pnota_prec->GetNStaff() == 0 && beamPos == BEAM_12) || (pnota_prec->GetNStaff() <= 1 && beamPos == BEAM_23) )
		{
			for(i=0;i<=comune;i++)
			{
				Tratto[currentView][numSegment][i].P1=Point(0,0);
				Tratto[currentView][numSegment][i].PRef.x = pnota_prec->GetXgambo();
				Tratto[currentView][numSegment][i].PRef.y = pnota_prec->GetYgambo()+pnota_prec->GetLGambo();
				Tratto[currentView][numSegment][i].PRef = Tratto[currentView][numSegment][i].PRef - Point(0,i*dYB);
				// DXGambo deve essere assegnato in base alla direzione ed alla
				// dimensione della nota.
				if(nID_corr==CL_NCROMA)
				{
					Tratto[currentView][numSegment][i].P2.x = pnota_prec->GetXgambo();
					Tratto[currentView][numSegment][i].P2.y = pnota_prec->GetYgambo()+pnota_prec->GetLGambo();
				}
				else
				{
					Tratto[currentView][numSegment][i].P2.x = pnota_corr->GetXgambo();
					Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
						VUnit((-BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
				}
				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
				if(Tratto[currentView][numSegment][i].P1==Point(0,0))
					Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;

				//Scr->BigLine(Tratto[currentView][numSegment][i].PRef+Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2+Point(0,BThick+dYB/2),BThick);
				Prn->Write("newpath ");
				Prn->Write(" %d PU %d PU moveto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].PRef.x,Tratto[currentView][numSegment][i].PRef.y+dYB,Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y+dYB);
				Prn->Write(" %d PU %d PU lineto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y+(BThick+dYB),Tratto[currentView][numSegment][i].PRef.x,Tratto[currentView][numSegment][i].PRef.y+(BThick+dYB));
				Prn->Write("closepath fill \n");
				Prn->Write("stroke \n");
				Prn->Write("%d PU %d PU %d PU %d PU lnt \n",Tratto[currentView][numSegment][i-1].PRef.x,Tratto[currentView][numSegment][i-1].PRef.y,Tratto[currentView][numSegment][i-1].PRef.x,Tratto[currentView][numSegment][i-1].PRef.y+BThick+dYB/2);// Prolungamenti gambi
				Prn->Write("%d PU %d PU %d PU %d PU lnt \n",Tratto[currentView][numSegment][i-1].P2.x,Tratto[currentView][numSegment][i-1].P2.y,Tratto[currentView][numSegment][i-1].P2.x,Tratto[currentView][numSegment][i-1].P2.y+BThick+dYB/2);// Prolungamenti gambi
			}
			
		}
		else if((pnota_prec->GetNStaff() > 0 && (beamPos == BEAM_12) || (pnota_prec->GetNStaff() > 1 && beamPos == BEAM_23)))
		{
			
			for(i=0;i<=comune;i++)
			{
				Tratto[currentView][numSegment][i].P1=Point(0,0);
				Tratto[currentView][numSegment][i].PRef.x = pnota_prec->GetXgambo();
				Tratto[currentView][numSegment][i].PRef.y = pnota_prec->GetYgambo()+pnota_prec->GetLGambo();
				Tratto[currentView][numSegment][i].PRef = Tratto[currentView][numSegment][i].PRef - Point(0,i*dYB);
				// DXGambo deve essere assegnato in base alla direzione ed alla
				// dimensione della nota.
				if(nID_corr==CL_NCROMA)
				{
					Tratto[currentView][numSegment][i].P2.x = pnota_prec->GetXgambo();
					Tratto[currentView][numSegment][i].P2.y = pnota_prec->GetYgambo()+pnota_prec->GetLGambo();
				}
				else
				{
					Tratto[currentView][numSegment][i].P2.x = pnota_corr->GetXgambo();
					Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y -
						VUnit((-BSlope[currentView][numSegment]) * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));
				}
				// Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
				if(Tratto[currentView][numSegment][i].P1==Point(0,0))
					Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
				//Scr->BigLine(Tratto[currentView][numSegment][i].PRef+Point(0,BThick+dYB/2), Tratto[currentView][numSegment][i].P2+Point(0,BThick+dYB/2),BThick);
				Prn->Write("newpath ");
				Prn->Write(" %d PU %d PU moveto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].PRef.x,Tratto[currentView][numSegment][i].PRef.y+dYB,Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y+dYB);
				Prn->Write(" %d PU %d PU lineto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y+(BThick+dYB),Tratto[currentView][numSegment][i].PRef.x,Tratto[currentView][numSegment][i].PRef.y+(BThick+dYB));
				Prn->Write("closepath fill \n");
				Prn->Write("stroke \n");
				Prn->Write("%d PU %d PU %d PU %d PU lnt \n",Tratto[currentView][numSegment][i].PRef.x,Tratto[currentView][numSegment][i].PRef.y,Tratto[currentView][numSegment][i].PRef.x,Tratto[currentView][numSegment][i].PRef.y+(BThick+dYB)); // Prolungamenti gambi
			}

		}
	}
}

void Raggruppamento::printTratto(Nota *pnota, short nBarra, short Direz,
			    VUnit BThick, short numSegment)
{
  short i;
  
  // Disegna le barre dal basso verso l'alto.
  for(i=0;i<nBarra;i++)
  {
    if(Tratto[currentView][numSegment][i].P1!=Point(0,0))
    {
      if(Tratto[currentView][numSegment][i].P1==Tratto[currentView][numSegment][i].P2)
      {
		// Nota "isolata".
		if(Tratto[currentView][numSegment][i].P1.x==GetBPoint1(numSegment).x)
		{
		  // Nota iniziale del gruppo => mezzo tratto verso destra.
		  Tratto[currentView][numSegment][i].P2.x = Tratto[currentView][numSegment][i].P1.x + TRATTOMEZZABARRA;
		  Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].P1.y + (VUnit)(BSlope[currentView][numSegment]*TRATTOMEZZABARRA);
		}
		else
		{
		  // Mezzo tratto verso sinistra.
		  Tratto[currentView][numSegment][i].P2 = Tratto[currentView][numSegment][i].P1;
		  Tratto[currentView][numSegment][i].P1.x = Tratto[currentView][numSegment][i].P2.x - TRATTOMEZZABARRA;
		  Tratto[currentView][numSegment][i].P1.y = Tratto[currentView][numSegment][i].P2.y - (VUnit)(BSlope[currentView][numSegment]*TRATTOMEZZABARRA);
		}
      }
	  Prn->Write("newpath ");
	  Prn->Write(" %d PU %d PU moveto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P1.x,Tratto[currentView][numSegment][i].P1.y,Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y);
	  Prn->Write(" %d PU %d PU lineto %d PU %d PU lineto \n",Tratto[currentView][numSegment][i].P2.x,Tratto[currentView][numSegment][i].P2.y-(Direz*BThick),Tratto[currentView][numSegment][i].P1.x,Tratto[currentView][numSegment][i].P1.y-(Direz*BThick));
	  Prn->Write("closepath fill \n");
	  Prn->Write("stroke \n");
	  
      // Resetta l'inizio del tratto.
      Tratto[currentView][numSegment][i].P1 = Point(0,0);
    }
  }
  

  // Se siamo al termine, non necessita aggiornamento.
  if(pnota==NULL)
    return;
  // Aggiorna il punto finale dei tratti soprastanti.
  for(i=nBarra;i<NBarre[numSegment]-1;i++)
  {
    // DXGambo deve essere assegnato in base alla direzione ed alla
    // dimensione della nota.
    Tratto[currentView][numSegment][i].P2.x = pnota->GetXgambo();
    Tratto[currentView][numSegment][i].P2.y = Tratto[currentView][numSegment][i].PRef.y +
      VUnit(BSlope[currentView][numSegment] * (Tratto[currentView][numSegment][i].P2.x - Tratto[currentView][numSegment][i].PRef.x));

    // Se questo e` l'inizio di un tratto, memorizza il punto iniziale.
    if(Tratto[currentView][numSegment][i].P1==Point(0,0))
      Tratto[currentView][numSegment][i].P1 = Tratto[currentView][numSegment][i].P2;
  }

}
FFF*/
float Raggruppamento::GetMean()
{
 	//Node *pnode;
 	Nota *pn;
 	Figura *pfig;
 	float a; 
 	float alt=0;
 	float mean=0;
 	float num;
 	SetNumNote();
 	num = GetNumNote();
 	
 	//pnode = first;
	pfig=GetFirstFigura();
 
 	int staffinbeam=GetStaffInBeam();//GB
 
 	while (pfig!=NULL)
 	{  
 		//pn = (Nota*)pnode->ObjectPtr;
		pn=(Nota*)pfig;
 		
 		if(pn->GetID()!=CL_SPAZIO)
 		{ 
 			if (staffinbeam>1)//GB
 			{
 				a = pn->GetAltezza()-4-pn->GetNStaff()*STAFF_DIST;
			}
 			else
 			{
 				a = pn->GetAltezza()-4; //DB: Prova!
 			}
 			alt+=a;
 		}
 		//pnode = pnode->Next;
		pfig=GetNextFigura(pfig);
 	}  
 	
 	if(num!=0) mean = alt/num; 
 	return mean;
}

void Raggruppamento::SetBeamPosition(BeamPos Bp)
{
 	beamPos=Bp;
 	if(Bp==BEAM_UP) SetGamboUp();
 	else if(Bp==BEAM_DWN) SetGamboDwn();
}

void Raggruppamento::GetMinMaxStaff(short& minStaff, short& maxStaff)
{
	Battuta* pbat=this->GetFirstBattuta();
	SetNumLayer();
	ListaFigure *plista=pbat->GetPLayer(GetNumLayer());
	plista->GetMinMaxStaff(minStaff,maxStaff);
}

void Raggruppamento::Edit(Battuta *pBat)

{
		int fac=0;
		

		wxString tmp;
		tmp.sprintf("MEAN=%f\nMHL=%f\nDELTA=%f\nBEAMDIS=%f\nSTAFFNUMBER=%d",
			GetMean(),
			GetMeanHighLow(),
			GetDelta(),
			GetBeamDis(),
			GetStaffInBeam());
		wxMessageBox(tmp);
	if(pBat==NULL)
		pBat=GetFirstBattuta();

    //EditingNotesDlg((Nota*)this, pBat);

}

Figura* Raggruppamento::GetFineSegmento(Figura *figuraIniziale){


Figura *FirstFig, *LastFig;
	Battuta *FirstRaggrupBat, *LastRaggrupBat, *FirstVisibleBat, *LastVisibleBat;
	Battuta *FirstNextRigoBat=NULL, *LastRigoBat=NULL;
	int nFirstRaggrupBat=0, nLastRaggrupBat=0, nFirstVisibleBat=0, nLastVisibleBat=0;
	int nFirstNextRigoBat=0, nLastRigoBat=0;
	FirstRaggrupBat=NULL;
	LastRaggrupBat=NULL;
	FirstVisibleBat=NULL;
	LastVisibleBat=NULL;
	FirstFig=figuraIniziale;
	LastFig=GetPFigEnd();
	if ((FirstFig!=NULL)&&(LastFig!=NULL)){
		FirstRaggrupBat=FirstFig->GetPBattuta();
		LastRaggrupBat=LastFig->GetPBattuta();
		FirstVisibleBat=(FirstRaggrupBat->GetParentScore())->GetfirstBatPage();
		Battuta *NextPageBat=(FirstRaggrupBat->GetParentScore())->GetfirstBatNextPage();
		if(NextPageBat!=NULL)
			LastVisibleBat=(FirstRaggrupBat->GetParentScore())->GetPrevBat(NextPageBat);
		else
			LastVisibleBat=(FirstRaggrupBat->GetParentScore())->GetLastBat();
		nFirstRaggrupBat=FirstRaggrupBat->GetNumProgress();
		nLastRaggrupBat=LastRaggrupBat->GetNumProgress();
		nFirstVisibleBat=FirstVisibleBat->GetNumProgress();
		nLastVisibleBat=LastVisibleBat->GetNumProgress();
		if((nLastRaggrupBat>nLastVisibleBat)&&(nFirstRaggrupBat<=nLastVisibleBat)){

			SetNumLayer();
			LastFig=(LastVisibleBat->GetPLayer(GetNumLayer()))->GetLastF();

		}
		
		
	}
	Battuta* currentBat, *nextBattuta;
	bool stop=FALSE;
	if(FirstFig!=NULL){
		//currentBat=FirstVisibleBat;
		currentBat=figuraIniziale->GetPBattuta();
		while((currentBat!=NULL)&&(stop==FALSE)&&(currentBat!=LastVisibleBat)){
			nextBattuta=(currentBat->GetParentScore())->GetNextBat(currentBat);
			
			if(nextBattuta){
				if((nextBattuta->GetBattuta()==INIZIO_PENTAGRAMMA)/*||(nextBattuta->GetBattuta()==INIZIO_BRANO)*/){

					FirstNextRigoBat=nextBattuta;
					nFirstNextRigoBat=FirstNextRigoBat->GetNumProgress();
					LastRigoBat=currentBat;
					nLastRigoBat=LastRigoBat->GetNumProgress();
					stop=TRUE;
				}
			}
			//nextBattuta=(currentBat->GetParentScore())->GetNextBat(currentBat);
			currentBat=nextBattuta;
			
		}

	}
	if((LastRigoBat!=NULL)&&(nLastRigoBat<nLastVisibleBat)&&(nLastRigoBat>=nFirstRaggrupBat)&&(nLastRigoBat<nLastRaggrupBat))
		LastFig=(LastRigoBat->GetPLayer(GetNumLayer()))->GetLastF();


	return LastFig;
}

IntEstSegment* Raggruppamento::GetPSegment(short numSegment){

	IntEstSegment *p1,*psegment=NULL;
	p1=this->GetPFirstSegm();
	
	while((p1!=NULL)&&(psegment==NULL)){
		if(p1->numSegment==numSegment)
			psegment=p1;
		p1=p1->pNext;
	}
	return psegment;
}

Status_ID Raggruppamento::GetStatus(){

	return (PFigStart->GetStatus());
}

void Raggruppamento::SetStatus(Status_ID s){

	Figura* pfig=PFigStart;	

	while(pfig!=NULL){

		pfig->SetStatus(s);
		pfig=GetNextFig(pfig);
	}

}