/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#include "int/trilloonda.hpp"

void TrilloOnda::SetDim(VUnit w)
{
	SetWidth(w);
	SetHeight(ONDA2DWN + ONDA2UP);
}


void TrilloOnda::DrawSegm(IntEstSegment *p1)
{
	char tr[2];
	char code[2];
	int i, NOnda;
	
	if(isOpaque)
		Scr->SetColor(GetColor());
	
	code[0]=CODE_ONDA;
	code[1]='\0';
	
	tr[0]=CODE_TRILLO;
	tr[1]='\0';
	
	NOnda = (p1->Wdt-GetDx()+GetDxR())/WIDTHONDA;
	
	Scr->TextTo(p1->AbsP + 
		Point(DELTAXTRILLONDA+GetDx(),DELTAYTRILLONDA+GetDy()));
	Scr->OutText((unsigned char*)tr);
	
	for(i=1;i<=(NOnda*1.24)+1;i++) 
	{   
		Scr->TextTo(p1->AbsP + Point((i-(0.8+(i-1)*0.2))*WIDTHONDA,0)+ 
			Point(DELTAXONDATRILLONDA+GetDx(),DELTAYONDATRILLONDA+GetDy()));
		Scr->OutText((unsigned char *)code);
	}
}  
