/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: abbellim.hpp,v 1.1 2005/07/25 10:09:01 bellinpo Exp $ */

class Scr;   

#ifndef DEF_KOR_HPP
#define DEF_KOR_HPP

//sliding Gup
#define CODE_SLIDINGUP	33 //codice per test, CAMBIARE

#define SLIDINGUP2UP	Scr->Get_VU2UP(CODE_SLIDINGUP, MUSICFONT3_ID)
#define SLIDINGUP2DWN	Scr->Get_VU2DWN(CODE_SLIDINGUP, MUSICFONT3_ID)
#define SLIDINGUP2RGT	Scr->Get_VU2RG(CODE_SLIDINGUP, MUSICFONT3_ID) 
#define SLIDINGUP2LFT	Scr->Get_VU2LF(CODE_SLIDINGUP, MUSICFONT3_ID)

#define DELTAXSLIDINGUP Scr->Get_VU2DX(CODE_SLIDINGUP, MUSICFONT3_ID)
#define DELTAYSLIDINGUP Scr->Get_VU2DY(CODE_SLIDINGUP, MUSICFONT3_ID)

//sliding Gdown
#define CODE_SLIDINGDOWN	34 //codice per test, CAMBIARE

#define SLIDINGDOWN2UP	Scr->Get_VU2UP(CODE_SLIDINGDOWN, MUSICFONT3_ID)
#define SLIDINGDOWN2DWN	Scr->Get_VU2DWN(CODE_SLIDINGDOWN, MUSICFONT3_ID)
#define SLIDINGDOWN2RGT	Scr->Get_VU2RG(CODE_SLIDINGDOWN, MUSICFONT3_ID) 
#define SLIDINGDOWN2LFT	Scr->Get_VU2LF(CODE_SLIDINGDOWN, MUSICFONT3_ID)

#define DELTAXSLIDINGDOWN Scr->Get_VU2DX(CODE_SLIDINGDOWN, MUSICFONT3_ID)
#define DELTAYSLIDINGDOWN Scr->Get_VU2DY(CODE_SLIDINGDOWN, MUSICFONT3_ID)

//sliding Dup
#define CODE_SLIDINGDUP	35 //codice per test, CAMBIARE

#define SLIDINGDUP2UP	Scr->Get_VU2UP(CODE_SLIDINGDUP, MUSICFONT3_ID)
#define SLIDINGDUP2DWN	Scr->Get_VU2DWN(CODE_SLIDINGDUP, MUSICFONT3_ID)
#define SLIDINGDUP2RGT	Scr->Get_VU2RG(CODE_SLIDINGDUP, MUSICFONT3_ID) 
#define SLIDINGDUP2LFT	Scr->Get_VU2LF(CODE_SLIDINGDUP, MUSICFONT3_ID)

#define DELTAXSLIDINGDUP Scr->Get_VU2DX(CODE_SLIDINGUP, MUSICFONT3_ID)
#define DELTAYSLIDINGDUP Scr->Get_VU2DY(CODE_SLIDINGUP, MUSICFONT3_ID)

//sliding DownUp
#define CODE_SLIDINGDOWNUP	36 //codice per test, CAMBIARE

#define SLIDINGDOWNUP2UP	Scr->Get_VU2UP(CODE_SLIDINGDOWNUP, MUSICFONT3_ID)
#define SLIDINGDOWNUP2DWN	Scr->Get_VU2DWN(CODE_SLIDINGDOWNUP, MUSICFONT3_ID)
#define SLIDINGDOWNUP2RGT	Scr->Get_VU2RG(CODE_SLIDINGDOWNUP, MUSICFONT3_ID) 
#define SLIDINGDOWNUP2LFT	Scr->Get_VU2LF(CODE_SLIDINGDOWNUP, MUSICFONT3_ID)

#define DELTAXSLIDINGDOWNUP Scr->Get_VU2DX(CODE_SLIDINGDOWNUP, MUSICFONT3_ID)
#define DELTAYSLIDINGDOWNUP Scr->Get_VU2DY(CODE_SLIDINGDOWNUP, MUSICFONT3_ID)

//nonghyun inc
#define CODE_NONGHYNINC	37 //codice per test, CAMBIARE

#define NONGHYNINC2UP	Scr->Get_VU2UP(CODE_NONGHYNINC, MUSICFONT3_ID)
#define NONGHYNINC2DWN	Scr->Get_VU2DWN(CODE_NONGHYNINC, MUSICFONT3_ID)
#define NONGHYNINC2RGT	Scr->Get_VU2RG(CODE_NONGHYNINC, MUSICFONT3_ID) 
#define NONGHYNINC2LFT	Scr->Get_VU2LF(CODE_NONGHYNINC, MUSICFONT3_ID)

#define DELTAXNONGHYNINC Scr->Get_VU2DX(CODE_NONGHYNINC, MUSICFONT3_ID)
#define DELTAYNONGHYNINC Scr->Get_VU2DY(CODE_NONGHYNINC, MUSICFONT3_ID)

//nonghyun dec
#define CODE_NONGHYNDEC	38 //codice per test, CAMBIARE

#define NONGHYNDEC2UP	Scr->Get_VU2UP(CODE_NONGHYNDEC, MUSICFONT3_ID)
#define NONGHYNDEC2DWN	Scr->Get_VU2DWN(CODE_NONGHYNDEC, MUSICFONT3_ID)
#define NONGHYNDEC2RGT	Scr->Get_VU2RG(CODE_NONGHYNDEC, MUSICFONT3_ID) 
#define NONGHYNDEC2LFT	Scr->Get_VU2LF(CODE_NONGHYNDEC, MUSICFONT3_ID)

#define DELTAXNONGHYNDEC Scr->Get_VU2DX(CODE_NONGHYNDEC, MUSICFONT3_ID)
#define DELTAYNONGHYNDEC Scr->Get_VU2DY(CODE_NONGHYNDEC, MUSICFONT3_ID)

//nonghyun arrow
#define CODE_NONGHYNARROW	39 //codice per test, CAMBIARE

#define NONGHYNARROW2UP		Scr->Get_VU2UP(CODE_NONGHYNARROW, MUSICFONT3_ID)
#define NONGHYNARROW2DWN	Scr->Get_VU2DWN(CODE_NONGHYNARROW, MUSICFONT3_ID)
#define NONGHYNARROW2RGT	Scr->Get_VU2RG(CODE_NONGHYNARROW, MUSICFONT3_ID) 
#define NONGHYNARROW2LFT	Scr->Get_VU2LF(CODE_NONGHYNARROW, MUSICFONT3_ID)

#define DELTAXNONGHYNARROW Scr->Get_VU2DX(CODE_NONGHYNARROW, MUSICFONT3_ID)
#define DELTAYNONGHYNARROW Scr->Get_VU2DY(CODE_NONGHYNARROW, MUSICFONT3_ID)

//nonghyun wide
#define CODE_NONGHYNWIDE	40 //codice per test, CAMBIARE

#define NONGHYNWIDE2UP	Scr->Get_VU2UP(CODE_NONGHYNWIDE, MUSICFONT3_ID)
#define NONGHYNWIDE2DWN	Scr->Get_VU2DWN(CODE_NONGHYNWIDE, MUSICFONT3_ID)
#define NONGHYNWIDE2RGT	Scr->Get_VU2RG(CODE_NONGHYNWIDE, MUSICFONT3_ID) 
#define NONGHYNWIDE2LFT	Scr->Get_VU2LF(CODE_NONGHYNWIDE, MUSICFONT3_ID)

#define DELTAXNONGHYNWIDE Scr->Get_VU2DX(CODE_NONGHYNWIDE, MUSICFONT3_ID)
#define DELTAYNONGHYNWIDE Scr->Get_VU2DY(CODE_NONGHYNWIDE, MUSICFONT3_ID)

#endif //DEF_KOR_HPP