/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: abbellim.hpp,v 1.1 2005/07/25 10:09:01 bellinpo Exp $ */
#include "kor/koreanorn.hpp"
#include "liooext.hpp"
#include "gui/dialogs.hpp" // per finestra debug milla

extern int DebugNormalMilla;
extern int DebugNormalMillaPos;


KoreanOrnament::KoreanOrnament()
{
	aboveNota=TRUE;
}

Bool KoreanOrnament::GetAboveNota()
{ return aboveNota; };

void KoreanOrnament::SetAboveNota(Bool above)
{ aboveNota=above;};

void KoreanOrnament::SetAboveNotaAuto(TipoInserimento tpIns,Nota* pNota,Battuta* pBattuta)
{	
	switch(tpIns)
	{
	case SOPRA:
		aboveNota=TRUE;
		break;
	case SOTTO:
		aboveNota=FALSE;
		break;
	case AUTOMATICO:
		aboveNota = immissione.ImmRule(GetID(), pNota, pBattuta, NULL, 0); // lo zero e'il current_layer //GB
		break;
	}
}

Bool KoreanOrnament::is(ClassID CLId)
{
	if (CLId==CL_KOREANORNAMENT) return TRUE;
	return DrawObject::is(CLId);
}

Bool KoreanOrnament::Hit(const Point& p, SelObj selObj, DrawObject*& drwObjSel, SymPath& symPath)
{
	if(DrawObject::Hit(p,selObj,drwObjSel,symPath))
		return TRUE;  
	return FALSE;
}   	       

Bool KoreanOrnament::SymbolicHit(SymPath& symPath, SelObj selObj, DrawObject*& drwObjSel)
{
	if(DrawObject::SymbolicHit(symPath, selObj, drwObjSel))
		return TRUE; 
	return FALSE;
} 	 

void KoreanOrnament::Edit(Battuta *pBat)
{
    EditingMarkersDlg(this);
}  
