/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: abbellim.hpp,v 1.1 2005/07/25 10:09:01 bellinpo Exp $ */

#ifndef KOREANORNAMENT_HPP
#define KOREANORNAMENT_HPP

#include "drw/drawobje.hpp"

class Nota;
class Battuta;


class KoreanOrnament : public DrawObject

{ 
protected:  
    Bool aboveNota;
	
	
public: 
    KoreanOrnament();
    
    Bool GetAboveNota();
    void SetAboveNota(Bool);
	
	void SetAboveNotaAuto(TipoInserimento tpIns, Nota* pNota, Battuta* pBattuta);
    Bool is(ClassID);
    // dice se l'oggetto puntato e' un korean-ornament              
    
    void Draw(){};
	// Disegna il korean-ornament 
	
    Bool Hit(const Point&, SelObj, DrawObject*&, SymPath&);
    Bool SymbolicHit(SymPath&, SelObj, DrawObject*&);
		
	// Descrive le propriet di korean-ornament in un comando di tipo SymCmd
	virtual void Edit(Battuta *pBat);

	int SaveXML(FILE *fp, char *type);
	virtual int SaveXML(FILE *fp)=0;

};


#endif //KOREANORNAMENT_HPP
