/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: abbellim.hpp,v 1.1 2005/07/25 10:09:01 bellinpo Exp $ */

#include "kor/nonghyndec.hpp"

NonghynDec::NonghynDec()
{ ID=CL_NONGHYNDEC; }

VUnit NonghynDec::GetVU2Up()
{return NONGHYNDEC2UP;};

VUnit NonghynDec::GetVU2Dwn()
{return NONGHYNDEC2DWN;};

VUnit NonghynDec::GetVU2Lft()
{return NONGHYNDEC2LFT;};

VUnit NonghynDec::GetVU2Rgt()
{return NONGHYNDEC2RGT;};

void NonghynDec::Draw()
{
  char code[2]={0,0};
  code[0]=CODE_NONGHYNDEC; 
  int oldFont;
     			
  oldFont=Scr->SetFont(nMusicFont3);
       
  Colore oldcol= Scr->GetColor();
  if(isOpaque)
	  Scr->SetColor(GetColor());

  Scr->TextTo(GetAbsPos()+Point(DELTAXNONGHYNDEC,DELTAYNONGHYNDEC)+Point(GetDx(),GetDy()));
  Scr->OutText((unsigned char *)code);

  Scr->SetFont(oldFont);

  Scr->SetColor(oldcol);
};  
