/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: lioo.cpp,v 1.1 2005/07/25 16:31:29 bellinpo Exp $ */



#include <string.h>
#include <stdio.h>

#include "lioo.hpp"
#include "drw/gscreen.hpp"
#include "drw/scrlist.hpp"
#include "liooext.hpp"
#include "gui/lioomenu.hpp"
#include "net/logfile.hpp"
#include "mil/posiz.hpp"
#include "mil/immissione.hpp"
#include "mil/priorita.hpp"
#include "mil/simboli.hpp"
#include "img/image.hpp"
#include "gui/masaewin.hpp"
#include "gui/dlioowin.hpp"

#include <wx/progdlg.h>

#undef LoadString
/*
int milloadError;
FILE *milin;
int millineno;
*/
void InitRegole();
int LoadRegole(char* FILE, Immissione* pruleimm, Posiz* prulepos, Priorita* prulepri, Simboli* psymbol, int msg);

extern int milparse(void);
extern int InitLoad(char* FILE, Immissione* pruleimm, Posiz* prulepos, Priorita* prulepri, Simboli* psymbol);
extern void LoadDialogs();
extern void ResetImgLoad();



ErrorManager EM;
// gestore errori
GScreen *Scr;
// puntatore allo schermo grafico

class Build
{
public:
	Build(void)
	{
	}
};

Build hook;
// Aggancia il puntatore
FontID nTextFont;
// Font testo
FontID nBigTextFont;
// Font testo grande
FontID nMusicFont;
// Font musicale grande  (per spartito)
FontID nMusicFont2;
// Font musicale grande  (per spartito)
FontID nMusicFont3;
// Font musicale grande  (per spartito)
FontID nMenuFont;
// Font musicale piccolo (per menu)
int  DimensioneX;
int  DimensioneY;
Bool SimbImg;
Bool Leg;
Bool ContrScrool;
Bool LIOOMaster;
// Indica se il processo LIOO e` master o slave.

TipoLeggio tipoLeggio;
// Indica la categoria di leggio (MASAE, DLIOO o PDLOO).

unsigned short WinMasaeWidth, WinMasaeHeight, 
WinDliooWidth, WinDliooHeight;
// Indicano le dimensioni dei leggii
// di default prendono le dimensioni indicate 
// in alcune define in lioo.hpp
// si possono cambiare da linea di comando

// Codici dei colori utilizzati
int black, red, gray, white, dgray, blue_xor;

LiooWindow *pMusicWin=NULL;
// Puntatore alla finestra contenente la partitura.
// Sostituisce SpartWin.

ScrList LiooList;
// lista degli ScrObject (deve essere vista anche da LiooCall)


Widget LiooWidget=NULL;
// Widget contenente LIOO;
ScrList LiooListWidget;
// Lista dei Widget di LIOO
Widget WindowActive;
//   Widget contenente la finestra attiva.
LogFile MyLog;


char *NomeEseguibile=NULL;
char *NomeNetStart=NULL;
char Array[50*1024];
// Buffer per la rete!

// roba per programma MILLA
Immissione immissione;
Posiz posizionam;
Priorita priorita;
Simboli simboli;

//EventResult LIOOIntro();
// presentazione programma
//EventResult GlobalMenu();
// menu a schermo per operazioni globali come New/Load/Save/Exit
// e per inserimento battute.
void InitMenu();
// inizializza i menu.

int OutOfMemory(size_t size)
{
	// se termina la memoria termina il programma.
	
	Scr->GClose();
	
	return 0;
}

int LoadRegole(char* FILE, Immissione* pruleimm, Posiz* prulepos, Priorita* prulepri, Simboli* psymbol, int msg)
{    
	int err = InitLoad(FILE, pruleimm, prulepos, prulepri, psymbol);
		
	pruleimm->sortRuleImm();
	pruleimm->InitRuleImm();	
	pruleimm->sortConditionImm();
	
	prulepos->sortRulePos();
	prulepos->InitRulePos();		
	prulepos->sortConditionPos();	
		
	return(err<=0);
}

#ifdef _DEBUG
void LIOOassert(char* exp,char* file,int line)
{
	Scr->GClose();
	Scr->WaitKey();
	exit(1);
}

#endif


void CopiaCommandStruct(SymCmd *MyCmd,SymCmd *CmdStrt)
{
	MyCmd->CommandId=CmdStrt->CommandId;
	MyCmd->SelectionType=CmdStrt->SelectionType;
	MyCmd->SelObjType=CmdStrt->SelObjType;
	MyCmd->Path1.Level=CmdStrt->Path1.Level;
	MyCmd->Path2.Level=CmdStrt->Path2.Level;
	MyCmd->Path3.Level=CmdStrt->Path3.Level;
	int i;
	for (i=0;i<PATH_LENGTH;i++) 
	{
		MyCmd->Path1.Array[i]=CmdStrt->Path1.Array[i];
		MyCmd->Path2.Array[i]=CmdStrt->Path2.Array[i];
		MyCmd->Path3.Array[i]=CmdStrt->Path3.Array[i];
	} 
	for (i=0;i<SYM_MAXARG;i++) 
		MyCmd->ArgV[i]=CmdStrt->ArgV[i];
	strncpy(MyCmd->Text,CmdStrt->Text,SYM_MAX_TEXT);
	
	return;
};


void SaveString(char *Stringa,FILE *fp)
{
	int len=strlen(Stringa);
	fwrite(&len,sizeof(len),1,fp);
	fwrite(Stringa,strlen(Stringa),1,fp);
	return;
}

void LoadString(char *Stringa,FILE *fp)
{ 
	int len;
	
	fread(&len,sizeof(len),1,fp);
	
	fread(Stringa,len,1,fp);
	
	Stringa[len]=0;
	
	return;
}

void SalvaCommandStruct(SymCmd *MyCmd,FILE *fp)
{
	int i;
	if (MyCmd==NULL) return;
	fwrite(&MyCmd->CommandId,sizeof(MyCmd->CommandId),1,fp);
	fwrite(&MyCmd->SelectionType,sizeof(MyCmd->SelectionType),1,fp);
	fwrite(&MyCmd->SelObjType,sizeof(MyCmd->SelObjType),1,fp);
	
	// Salvataggio Path 1
	fwrite(&MyCmd->Path1.Level,sizeof(MyCmd->Path1.Level),1,fp);
	for (i=0;i<PATH_LENGTH;i++) 
		fwrite(&MyCmd->Path1.Array[i],sizeof(MyCmd->Path1.Array[i]),1,fp);
	// Salvataggio Path 2
	fwrite(&MyCmd->Path2.Level,sizeof(MyCmd->Path2.Level),1,fp);
	for (i=0;i<PATH_LENGTH;i++) 
		fwrite(&MyCmd->Path2.Array[i],sizeof(MyCmd->Path2.Array[i]),1,fp);
	
	// Salvataggio Path 3   
	fwrite(&MyCmd->Path3.Level,sizeof(MyCmd->Path3.Level),1,fp);
	for (i=0;i<PATH_LENGTH;i++)
		fwrite(&MyCmd->Path3.Array[i],sizeof(MyCmd->Path3.Array[i]),1,fp);
	
	for (i=0;i<SYM_MAXARG;i++) 
		fwrite(&MyCmd->ArgV[i],sizeof(MyCmd->ArgV[i]),1,fp);
	
	SaveString(MyCmd->Text,fp);
	
	return;
};


void CaricaCommandStruct(SymCmd *MyCmd,FILE *fp)
{
	int i;
	if (MyCmd==NULL) {
		// Creo una struttura dati nuova, che ha il solo compito di far spostare il file
		// pointer al prossimo elemento.
		SymCmd NewCmd;
		MyCmd=&NewCmd;
		
		return;
	}
	fread(&MyCmd->CommandId,sizeof(MyCmd->CommandId),1,fp);
	fread(&MyCmd->SelectionType,sizeof(MyCmd->SelectionType),1,fp);
	fread(&MyCmd->SelObjType,sizeof(MyCmd->SelObjType),1,fp);
	// Caricamento Path 1
	fread(&MyCmd->Path1.Level,sizeof(MyCmd->Path1.Level),1,fp);
	for (i=0;i<PATH_LENGTH;i++) 
		fread(&MyCmd->Path1.Array[i],sizeof(MyCmd->Path1.Array[i]),1,fp);
	// SCaricamento Path 2
	fread(&MyCmd->Path2.Level,sizeof(MyCmd->Path2.Level),1,fp);
	for (i=0;i<PATH_LENGTH;i++) 
		fread(&MyCmd->Path2.Array[i],sizeof(MyCmd->Path2.Array[i]),1,fp);
	for (i=0;i<SYM_MAXARG;i++) 
		fread(&MyCmd->ArgV[i],sizeof(MyCmd->ArgV[i]),1,fp);
	
	LoadString(MyCmd->Text,fp);
	
	return;
}
