/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: lioo.hpp,v 1.1 2005/07/25 16:31:30 bellinpo Exp $ */

#ifndef LIOO_HPP
#define LIOO_HPP

#ifndef NULL
#define NULL 0L
#endif

#define MAX_LEN_LABEL 100

#define Bool int

#ifndef TRUE
#define TRUE  1
#define FALSE 0
#endif

// serve per EverJustified
#define NO 0
#define YES 1
#define DIR 0
#define ORC 1
#define PRINTVIEW 1
#define COMPUTERVIEW 0


#define True  1
#define False 0

#ifndef ABS                 
#define ABS(x) ((x)>=0 ? (x): -(x))
#endif

#ifdef __WXMSW__
#define PATH_SEP "\\"
#else
#define PATH_SEP "/"
#endif

struct listaindici;

enum ClassID {
	// DRW
	CL_DRAWOBJECT,
		CL_RETTANGOLO,
		CL_TEXT,
		CL_BUTTON,
		CL_MENU,
		CL_WINDOW,
		CL_TNUMERICO,
		CL_TEXTIO,
		// SPA
		CL_PENTAGRAMMA,
		CL_SPARTITO,
		// ALT
		CL_DOPPIODIESIS,
		CL_DOPPIOBEMOLLE,
		CL_DIESIS,
		CL_DIESIS1Q,
		CL_DIESIS3Q,
		CL_BEMOLLE,
		CL_BEMOLLE1Q,
		CL_BEMOLLE3Q,
		CL_BEQUADRO,
		CL_NATURAL, 
		// BAT
		CL_BATTUTA,
		CL_INTESTAZIONE,
		CL_ARMATURACHIAVE,
		CL_TEMPO,
		CL_CVIOLINO,
		CL_CVIOLINO8,
		CL_CBASSO,
		CL_CBASSO8,
		CL_CBARITONO,
		CL_CTENORE,
		CL_CCONTRALTO,
		CL_CMEZZOSOPRANO,
		CL_CSOPRANO,
		CL_BSINGOLA,
		CL_BDOPPIA,
		CL_BFINALE,
		CL_BINIZIORIT,
		CL_BFINERIT,
		CL_BINIZIOFINERIT,
		//BRA
		CL_PARGRAFFA,
		CL_PARQUADRA,
		// FIG
		CL_FIGURA,
		CL_PAUSA,
		CL_PQUATTROBATTUTE,
		CL_PDUEBATTUTE,
		CL_PSEMIBREVE,
		CL_PMINIMA,
		CL_PSEMIMINIMA,
		CL_PCROMA,
		CL_PSEMICROMA,
		CL_PBISCROMA,
		CL_PSEMIBISCROMA,
		CL_PFUSA,
		CL_PGENERICA,
		CL_SPAZIO,
		CL_NOTA,
		CL_NBREVE,
		CL_NSEMIBREVE,
		CL_NMINIMA,
		CL_NSEMIMINIMA,
		CL_NCROMA,
		CL_NSEMICROMA,
		CL_NBISCROMA,
		CL_NSEMIBISCROMA,
		CL_NFUSA,
		CL_GRUPPONOTE,
		CL_ACCORDO,
		CL_RIPTEMPO,
		CL_RIPBATTUTA,
		CL_RIPMEZZABATTUTA,
		// INT
		CL_LEGATURA_VALORE,
		CL_LEGATURA_QUADRA,
		CL_LEGATURA,
		CL_FORCELLA,
		CL_MODIFICA_OTTAVA,
		CL_CAMBIO_RITORNELLO,
		CL_ONDA,
		CL_FRECCIA,
		CL_SILLABA,
		CL_TRILLOONDA, 
		CL_PEDALE,
		CL_PEDALEFINOA,
		CL_BEND,
		CL_RAGGRUPPAMENTO,
		// VAR
		CL_CORONA,
		CL_OCCHIALI,
		CL_PUNTOVALORE,
		CL_PRFIATO,
		CL_ARPEGGIO,
		CL_SUDDIVISIONE,
		// IND
		CL_INDICAZIONE,
		CL_ESPRESSIONE,
		CL_STACCATO,
		CL_TENUTO,
		CL_MARTELLATO,
		CL_ACCENTO,
		CL_SFORZATO,
		CL_MARTDOLCE,
		CL_PUNTOALLUNGATO,
		CL_ESPGENERIC,
		CL_DITEGGIATO,
		CL_SORDINA,
		CL_CONSORDINA,
		CL_CONSORDINAOTTONI,
		CL_CONSORDINAARCHI,
		CL_CONSORDINATESTO,
		CL_VIASORDINA,
		CL_VIASORDINAOTTONI,
		CL_VIASORDINAARCHI,
		CL_VIASORDINATESTO,
		CL_ARMONICI,
		CL_ARMONICIARCHI,
		CL_ARMONICIOTTONI,
		// ABB
		CL_ABBELLIMENTO,
		CL_TRILLO,
		CL_TREMOLO,
		CL_MORDENTE,
		CL_MINFERIORE,
		CL_MSUPERIORE,
		CL_GRUPPETTO,
		CL_GINFERIORE,
		CL_GSUPERIORE,
		CL_GLISSATO,
		// STR
		CL_STRUMENTO,
		CL_DIREZARCO,
		CL_ARCOGIU,
		CL_ARCOSU,
		CL_ARCO,
		CL_VIOLINO,
		CL_PIZZICATO,
		CL_CORDAVUOTA,
		CL_PARTEARCO,
		CL_PUNTA,
		CL_TALLONE,
		CL_POSIZARCO,
		CL_TASTIERA,
		CL_PONTICELLO,
		CL_CORDA,
		CL_TIMPANO,
		CL_PEDAL,
		CL_PEDALDOWN,
		CL_PEDALUP,
		CL_DITACORDE,
		// TXT
		CL_TDINAMICO,
		CL_TGENERICO,
		CL_ANNOTAZIONE,
		// SCA
		CL_NUMBATTUTA,
		CL_NUMUGUALE,
		CL_NUMPAUSA,
		CL_TSALTO,
		CL_LETTERA,
		CL_SCANSIONE,
		CL_TMOVIMENTO,
		CL_METRONOMO,
		CL_MOVIMENTO,
		//BAT
		CL_CTENORE8,
		CL_CVIOLINO8SOPRA,
		CL_CBASSO8SOPRA,
		CL_CTAB,
		CL_CPERCUSBOX,
		CL_CPERCUS2LINES,
		CL_CVUOTA,
		CL_CBASSOOLD,
		//DRW
		CL_NUMTEMPO,
		//SCA
		CL_RIFERIMENTO,
		CL_SEGNO,
		CL_CODA,
		//BAT
		CL_BINVISIBILE,
		CL_BDASHED,
		//ALT
		CL_BEQUADRO1Q,
		CL_BEQUADRO3Q,
		//ABB
		CL_GSLASH,
		CL_GUP,
		//KOR
		CL_KOREANORNAMENT,
		CL_SLIDINGUP,
		CL_SLIDINGDOWN,
		CL_SLIDINGDUP,
		CL_SLIDINGDOWNUP,
		CL_NONGHYNINC,
		CL_NONGHYNDEC,
		CL_NONGHYNARROW,
		CL_NONGHYNWIDE,
};

#include "abb/def_abb.hpp"
#include "alt/def_alt.hpp"
#include "bat/def_bat.hpp"
#include "bra/def_bra.hpp"
#include "drw/def_drw.hpp"
#include "fig/def_fig.hpp"
#include "gui/def_gui.hpp"
#include "ind/def_ind.hpp"
#include "int/def_int.hpp"
#include "par/def_par.hpp"
#include "spa/def_spa.hpp"
#include "str/def_str.hpp"
#include "txt/def_txt.hpp"
#include "var/def_var.hpp"
#include "kor/def_kor.hpp"

enum SelType { 
	NO_SEL,        // nessuna selezione
		SINGLE_SEL,    // selezione di un singolo oggetto
		MULTI_SEL,     // selezione multipla
		RECT_SEL,      // selezione con rettangolo
		TWO_SEL,       // selezione di due oggetti
		INSERT_SEL,    // selezione per inserimento
		IMMEDIATE_SEL, // selezione per esecuzione immediata del comando
		DRAG_SEL		 // selezione tramite drag.
		
};

enum SelObj {
	ANY_SEL,        // seleziona qualsiasi oggetto
		SPARTITO_SEL,   // seleziona uno Spartito
		BATTUTA_SEL,    // seleziona una Battuta
		BATPART_SEL,    // seleziona una colonna di battute della partitura
		FIGURA_SEL,     // seleziona una Figura (Nota,Pausa o Accordo)
		NOTA_SEL,       // seleziona una Nota   (Nota o Accordo)
		NOTASING_SEL,   // seleziona una Nota
		GRUPPONOTE_SEL // seleziona un GruppoNote
		//IMAGE_SEL		  // seleziona un immagine (DB)
};

enum CmdID {
	CMD_DEL_SYMBOL,
		CMD_EDIT_SYMBOL,
		CMD_DEBUGMILLA_SEL_SYMBOL,
		CMD_DEL_COL_FIGURE,
		CMD_PARTITURA_ADD_GRAFFA,
		CMD_PARTITURA_ADD_QUADRA,
		CMD_PARTITURA_ADD_SPARTITO,
		CMD_PARTITURA_MOVE_PART,
		CMD_PARTITURA_DEL_SPARTITO,
		CMD_PARTITURA_COPY_SPARTITO,	
		CMD_PARTITURA_PASTE_SPARTITO,	
		CMD_PARTITURA_CUT_PAGEBOX,
		CMD_PARTITURA_COPY_PAGEBOX,	
		CMD_PARTITURA_PASTE_PAGEBOX,	
		CMD_PARTITURA_HIDE_PART,
		CMD_PARTITURA_SPLITTING_PART,
		CMD_PARTITURA_DISJOINING_PART,
		CMD_PARTITURA_JOINING_PART,
		CMD_PARTITURA_MERGING_PART,
		CMD_PARTITURA_VIEW_LAYER,
		CMD_PARTITURA_NEW,
		CMD_PARTITURA_LOAD,
		CMD_PARTITURA_SAVEAS,
		CMD_PARTITURA_SAVE,
		CMD_PARTITURA_PRINT,
		CMD_PARTITURA_IMPORT_MIDI,
		CMD_PARTITURA_EXPORT_MIDI,
		CMD_PARTITURA_END,
		
		CMD_PARTITURA_IMPAGINA,
		CMD_PARTITURA_INTERROMPI,
		CMD_PARTITURA_INITESECUZIONE,
		CMD_PARTITURA_AVVIOESECUZIONE,
		CMD_PARTITURA_PAUSA,
		CMD_PARTITURA_PAGINAZIONE,
		CMD_PARTITURA_JUMP,
		
		CMD_PARTITURA_NEW_LYRIC,
		CMD_PARTITURA_EDIT_LYRIC,
		CMD_PARTITURA_REMOVE_LYRIC,
		CMD_PARTITURA_SELECT_LYRIC,
		
		
		CMD_PARTITURA_DECELLERA,
		CMD_PARTITURA_ACCELLERA,
		
		CMD_PARTITURA_ADD_BATTUTA,
		CMD_PARTITURA_DEL_BATTUTA,
		CMD_PARTITURA_COPIA_BATTUTA,
		CMD_PARTITURA_INCOLLA_BATTUTA,
		CMD_PARTITURA_CHECK_BATTUTA,
		CMD_PARTITURA_JUSTIFY,
		CMD_PARTITURA_TRANSPOSE,
		CMD_PARTITURA_FORMAT_BEAMING,
		CMD_PARTITURA_UPDOWN,
		CMD_PARTITURA_INSERTTEXT,	  
		CMD_PARTITURA_INSERTIMAGE,  
		CMD_PARTITURA_SCORE_EXCERPT,
		CMD_PARTITURA_MOVE_LAYER,
		
		CMD_SPARTITO_ADD_LEGATURA,
		CMD_SPARTITO_ADD_LEGATURA_VALORE,
		CMD_SPARTITO_ADD_FORC_CRESC,
		CMD_SPARTITO_ADD_FORC_DIMIN,
		CMD_SPARTITO_ADD_FRECCIA,
		CMD_SPARTITO_ADD_ONDA,
		CMD_SPARTITO_ADD_LEG_QUADRA,
		CMD_SPARTITO_ADD_CAMBIO_RIT,
		
		CMD_SPARTITO_ADD_MODIF8,
		CMD_SPARTITO_ADD_MODIF8BA,
		CMD_SPARTITO_ADD_MODIF15MA,
		CMD_SPARTITO_ADD_MODIF15BA,
		CMD_SPARTITO_ADD_BEAM,
		
		CMD_SPARTITO_ADD_SILLABA,
		CMD_SPARTITO_ADD_TRILLOONDA,
		CMD_SPARTITO_ADD_BEND,
		CMD_SPARTITO_ADD_PEDALE,
		
		CMD_SPARTITO_NPENT,
		CMD_SPARTITO_SET_NAME,
		CMD_SPARTITO_EDIT_LYRIC,
		CMD_SPARTITO_REMOVE_LYRIC,
		
		CMD_BATTUTA_NOTE2GRUPPONOTE,
		CMD_BATTUTA_GRUPPONOTE2NOTE,
		CMD_BATTUTA_ELIMINAGRUPPI,
		CMD_BATTUTA_ERASE,
		CMD_BATTUTA_BSINGOLA,
		CMD_BATTUTA_BDOPPIA,
		CMD_BATTUTA_BINIZIORIT,
		CMD_BATTUTA_BFINERIT,
		CMD_BATTUTA_BINIZIOFINERIT,
		CMD_BATTUTA_BFINALE,
		
		CMD_BATTUTA_BINVISIBILE,
		CMD_BATTUTA_BDASHED,
		CMD_BATTUTA_BSINGOLA_RIP2B,
		//
		CMD_BATTUTA_NUGUALE,
		CMD_BATTUTA_TSALTO,
		
		CMD_BATTUTA_RIFERIMENTO,
		CMD_BATTUTA_SEGNO,
		CMD_BATTUTA_CODA,
		//
		CMD_BATTUTA_LETTERA,
		CMD_BATTUTA_SCANSIONE,
		CMD_BATTUTA_MOVIMENTO,
		CMD_BATTUTA_INS_NBREVE,
		CMD_BATTUTA_INS_NSEMIBREVE,
		CMD_BATTUTA_INS_NMINIMA,
		CMD_BATTUTA_INS_NSEMIMINIMA,
		CMD_BATTUTA_INS_NCROMA,
		CMD_BATTUTA_INS_NSEMICROMA,
		CMD_BATTUTA_INS_NBISCROMA,
		CMD_BATTUTA_INS_NSEMIBISCROMA,
		CMD_BATTUTA_INS_NFUSA,  
		CMD_BATTUTA_INS_PQUABATT,
		CMD_BATTUTA_INS_PDUEBATT,
		CMD_BATTUTA_INS_PSEMIBREVE,
		CMD_BATTUTA_INS_PMINIMA,
		CMD_BATTUTA_INS_PSEMIMINIMA,
		CMD_BATTUTA_INS_PCROMA,
		CMD_BATTUTA_INS_PSEMICROMA,
		CMD_BATTUTA_INS_PBISCROMA,
		CMD_BATTUTA_INS_PSEMIBISCROMA,  
		CMD_BATTUTA_INS_PFUSA,
		CMD_BATTUTA_INS_PGENERICA,
		CMD_BATTUTA_INS_SPAZIO,
		CMD_BATTUTA_INS_RIPTEMPO,
		CMD_BATTUTA_INS_RIPBATTUTA,
		CMD_BATTUTA_INS_RIPMEZZABATTUTA,
		CMD_BATTUTA_CVIOLINO,
		CMD_BATTUTA_CVIOLINO8,
		CMD_BATTUTA_CVIOLINO8SOPRA,
		CMD_BATTUTA_CBASSO,
		CMD_BATTUTA_CBASSO8,
		CMD_BATTUTA_CBASSO8SOPRA,
		CMD_BATTUTA_CBASSOOLD,
		CMD_BATTUTA_CBARITONO,
		CMD_BATTUTA_CTENORE,
		CMD_BATTUTA_CTENORE8,
		CMD_BATTUTA_CCONTRALTO,
		CMD_BATTUTA_CMEZZOSOPRANO,
		CMD_BATTUTA_CSOPRANO,
		CMD_BATTUTA_CPERCUSBOX,
		CMD_BATTUTA_CPERCUS2LINES,
		CMD_BATTUTA_CTAB,
		CMD_BATTUTA_CVUOTA,
		CMD_BATTUTA_ARMCHV_0D,
		CMD_BATTUTA_ARMCHV_1D,
		CMD_BATTUTA_ARMCHV_2D,
		CMD_BATTUTA_ARMCHV_3D,
		CMD_BATTUTA_ARMCHV_4D,
		CMD_BATTUTA_ARMCHV_5D,
		CMD_BATTUTA_ARMCHV_6D,
		CMD_BATTUTA_ARMCHV_7D,
		CMD_BATTUTA_ARMCHV_1B,
		CMD_BATTUTA_ARMCHV_2B,
		CMD_BATTUTA_ARMCHV_3B,
		CMD_BATTUTA_ARMCHV_4B,
		CMD_BATTUTA_ARMCHV_5B,
		CMD_BATTUTA_ARMCHV_6B,
		CMD_BATTUTA_ARMCHV_7B,
		//Se terminano con 'm' sono riferite alle armature minori
		CMD_BATTUTA_ARMCHV_0Dm,
		CMD_BATTUTA_ARMCHV_1Dm,
		CMD_BATTUTA_ARMCHV_2Dm,
		CMD_BATTUTA_ARMCHV_3Dm,
		CMD_BATTUTA_ARMCHV_4Dm,
		CMD_BATTUTA_ARMCHV_5Dm,
		CMD_BATTUTA_ARMCHV_6Dm,
		CMD_BATTUTA_ARMCHV_7Dm,
		CMD_BATTUTA_ARMCHV_1Bm,
		CMD_BATTUTA_ARMCHV_2Bm,
		CMD_BATTUTA_ARMCHV_3Bm,
		CMD_BATTUTA_ARMCHV_4Bm,
		CMD_BATTUTA_ARMCHV_5Bm,
		CMD_BATTUTA_ARMCHV_6Bm,
		CMD_BATTUTA_ARMCHV_7Bm,
		CMD_BATTUTA_TEMPO,
		CMD_BATTUTA_SPACE_ADD,
		CMD_BATTUTA_SPACE_SUB,
		CMD_BATTUTA_JUMPIMAGE,
		CMD_FIGURA_1PUNTO,
		CMD_FIGURA_2PUNTI,
		CMD_FIGURA_3PUNTI,
		CMD_FIGURA_CORONA,
		CMD_FIGURA_CORONAQUAD,
		CMD_FIGURA_CORONATRIANG,
		CMD_FIGURA_OCCHIALI,
		CMD_FIGURA_PEDALUP,
		CMD_FIGURA_PEDALDOWN,
		CMD_FIGURA_DITACORDE,
		CMD_FIGURA_PPPPPP,
		CMD_FIGURA_PPPPP,
		CMD_FIGURA_PPPP,
		CMD_FIGURA_PPP,
		CMD_FIGURA_PP,
		CMD_FIGURA_P,
		CMD_FIGURA_FFFFFF,
		CMD_FIGURA_FFFFF,
		CMD_FIGURA_FFFF,
		CMD_FIGURA_FFF,
		CMD_FIGURA_FF,
		CMD_FIGURA_F,
		CMD_FIGURA_MP,
		CMD_FIGURA_MF,
		CMD_FIGURA_SP,
		CMD_FIGURA_SF,
		CMD_FIGURA_FZ,
		CMD_FIGURA_SFZ,
		CMD_FIGURA_FP,
		CMD_FIGURA_RF,
		CMD_FIGURA_FFP,
		CMD_FIGURA_FFPP,
		CMD_FIGURA_FPP,
		CMD_FIGURA_RFZ,
		CMD_FIGURA_SFF,
		CMD_FIGURA_SFFF,
		CMD_FIGURA_SFFP,
		CMD_FIGURA_SFFZ,
		CMD_FIGURA_SFP,
		CMD_FIGURA_SFPP,
		CMD_FIGURA_TGENERICO,
		CMD_FIGURA_ANNOTAZIONE,
		CMD_FIGURA_SEELINK, 
		CMD_IMAGE_SEELINK,  
		CMD_IMAGE_EDITLINK,
		CMD_FIGURA_EDITLINK,
		CMD_NOSEL,	
		NO_COMMAND,
		
		CMD_NOTA_CORDA_0,
		CMD_NOTA_CORDA_1,
		CMD_NOTA_CORDA_2,
		CMD_NOTA_CORDA_3,
		CMD_NOTA_CORDA_4,
		CMD_NOTA_CORDA_5,
		CMD_NOTA_CORDA_6,
		CMD_NOTA_CORDA_7,
		CMD_NOTA_DIESIS,
		CMD_NOTA_DIESIS1Q,
		CMD_NOTA_DIESIS3Q,
		CMD_NOTA_BEMOLLE,
		CMD_NOTA_BEMOLLE1Q,
		CMD_NOTA_BEMOLLE3Q,
		CMD_NOTA_BEQUADRO,
		CMD_NOTA_BEQUADRO1Q,
		CMD_NOTA_BEQUADRO3Q,
		CMD_NOTA_2DIESIS,
		CMD_NOTA_2BEMOLLE,
		CMD_NOTA_TREMOLO,
		CMD_NOTA_TRILLO,
		CMD_NOTA_GLISSATO,
		CMD_NOTA_GLISSONDA,
		CMD_NOTA_GRUPPETTO_SUP_1,
		CMD_NOTA_GRUPPETTO_SUP_2,
		CMD_NOTA_TURN_SLASH,
		CMD_NOTA_TURN_UP,
		CMD_NOTA_GRUPPETTO_INF_1,
		CMD_NOTA_GRUPPETTO_INF_2,
		CMD_NOTA_MORDENTE_SUP,
		CMD_NOTA_MORDENTE2_SUP,
		CMD_NOTA_MORDENTE_INF,
		CMD_NOTA_MORDENTE2_INF,
		CMD_NOTA_SLIDING_UP,
		CMD_NOTA_SLIDING_DOWN,
		CMD_NOTA_SLIDING_DUP,
		CMD_NOTA_SLIDING_DOWNUP,
		CMD_NOTA_NONGHYN_INC,
		CMD_NOTA_NONGHYN_DEC,
		CMD_NOTA_NONGHYN_ARROW,
		CMD_NOTA_NONGHYN_WIDE,
		CMD_NOTA_NOTA2NOTINA,
		CMD_NOTA_NOTINA2NOTA,
		CMD_NOTA_ACCIACCATURA,
		CMD_NOTA_SUDDIVISIONE,
		CMD_NOTA_DITO_0,
		CMD_NOTA_DITO_1,
		CMD_NOTA_DITO_2,
		CMD_NOTA_DITO_3,
		CMD_NOTA_DITO_4,
		CMD_NOTA_DITO_5,
		CMD_NOTA_TENUTO,
		CMD_NOTA_PUNTOALL,
		CMD_NOTA_SFORZATO,
		CMD_NOTA_ACCENTO,
		CMD_NOTA_MARTELLATO,
		CMD_NOTA_MARTDOLCE,
		CMD_NOTA_STACCATO,
		CMD_NOTA_ESPGENERIC,
		CMD_NOTA_VIASORDINAOTTONI,
		CMD_NOTA_VIASORDINAARCHI,
		CMD_NOTA_VIASORDINATESTO,
		CMD_NOTA_CONSORDINAOTTONI,
		CMD_NOTA_CONSORDINAARCHI,
		CMD_NOTA_CONSORDINATESTO,
		CMD_NOTA_ARMONICIARCHI,
		CMD_NOTA_ARMONICIOTTONI,
		CMD_NOTA_ARCO,
		CMD_NOTA_PIZZICATO,
		CMD_PAUSA_TIMPANO,
		CMD_SPAZIO_PRFIATO,
		CMD_ACCORDO_ARPEGGIO,
		CMD_ACCORDO_ARPEGGIO_UP,
		CMD_ACCORDO_ARPEGGIO_DOWN,
		
		CMD_ARCO_PUNTA,
		CMD_ARCO_TALLONE,
		CMD_ARCO_TASTIERA,
		CMD_ARCO_PONTICELLO,
		CMD_ARCO_ARCOSU,
		CMD_ARCO_ARCOGIU,
		CMD_ARCO_CORDA,
		
		CMD_PARTITURA_COPIA_SINGOLABATTUTA,
		CMD_PARTITURA_INCOLLA_SINGOLABATTUTA,
		
		CMD_DEBUG_UNO,
		CMD_DEBUG_DUE,
		CMD_DEBUG_TRE,
		CMD_DEBUG_QUATTRO,
		CMD_DEBUG_CINQUE,
		CMD_DEBUG_SEI,
		CMD_DEBUG_SETTE,
		CMD_DEBUG_OTTO,
		CMD_DEBUG_NOVE
		
};

enum CmdResult {
	CMD_OK,
		CMD_FAIL,
		CMD_UNKNOWN
};

enum TipoInserimento
{
	SOTTO = 0,
		SOPRA,
		AUTOMATICO,
		MID12,
		MID23
};

enum TipoGiust
{
	G_LOG,
		G_LIN,
		G_NONE
};

enum NoteHead_ID {
	HEAD_CLASSIC,
		HEAD_ALPHANUM,
		HEAD_ALPHANUM_SQUARE,
		HEAD_ALPHANUM_REVERSE,
		HEAD_CIRCLEX,
		HEAD_CLUSTER,
		HEAD_X,
		HEAD_CROIX,
		HEAD_DDIESIS,
		HEAD_DIAMOND,
		HEAD_TRIANG,
		HEAD_TRIANG_UP,
		HEAD_TRIANG_DOWN,
		HEAD_TRIANG_LEFT,
		HEAD_TRIANG_RIGHT,
		HEAD_TRIANG_ROUND,
		HEAD_MOON,
		HEAD_PLUS,
		HEAD_RHYTHMIC,
		HEAD_SQUARE,
};

typedef void *CmdArg;
typedef CmdArg CmdArgV[];

typedef int FontID;

#define VU_PER_ROW 6  // distanza tra due righe del pentagramma

#define SELECTBOX_MARGIN   3

#define SELECTED_COLOR     red     // colore oggetti selezionati
#define NORMAL_COLOR       black   // colore oggetti non selezionati
#define XOR_SELECTED_COLOR blue_xor     // colore per oggetti selezionati in XORmode

// Nomi dei file contenenti i font da caricare
#define MUSICFONT   "musica__.ttf"
#define MUSICFONT2  "musica2_.ttf"
#define MENUFONT    "music2a_.fon"
#define TEXTFONT    "text.ttf"
#define BIGTEXTFONT "bigfont_.ttf"
#define MUSICFONT3  "musica3_.ttf"


#define MESSAGE_MAX_CHAR 80
#define MESSAGE_WIDTH    300
#define MESSAGE_POS      Point(6,13)

// Funzioni LIOOMSG
void Message(char*);
void Message(char*,char*);
Bool YNMessage(char*,char *title=NULL);
Bool InputString(char *msg,char *buffer,int maxChar,char *title=NULL);
void Message_Init(char *msg);
void Message_End();
Bool WSaveETT(char *title,char* filesPath,char *buffer,char* nome,int max);
Bool WReadETT(char *title,char* filesPath,char *buffer,char* nome,int max);
Bool WMetronomo(char *title,char *buffer,int max);
int WReadMDS(char *title,char *Path,int max1,char *NomeFile,int max);
int WReadModo(char *title,char *Path,int max1,char *NomeFile,int max);
Bool Comprimi(char *title);
int WReadOper(char *title,char *Path,int max1,char *NomeFile,int max);
int WSaveMDS(char *title,char *Directory,char *NomeFile,int max);
Bool WReadEtich(char *title,char *buffer,int max,int num_etich,char*);
Bool WidgetJump(char *title,char *buffer,int max,int num_etich,int last_bat);
Bool EDWidgetJump(char *title,char *buffer,int max,int num_etich,int last_bat,char *arrayLabel,int*);
Bool InputTerzine(char *msg,char *buffer,int max,char *title,int *Draw);
Bool PrintWindow(int* printmode, double* PrintUnit, int* PentNumber);

class DitaCorde;
DitaCorde *InputTabl(char *TablFilePath);

int MidiReadWin(char *title,char *NomeFile, int *trc, int &keySignCode);
int GetIDleader(char* parte);
int AttivaFinestraStru(int &gentotvoice, int  genorchestra[][3]);
class ListaSpartiti;
int AttivaFinestraLayer(unsigned long &gennumspa, int &gentotvoice,listaindici
						*genfirs1, int genorchestra[][3],ListaSpartiti *ptrLSpa);
int AttivaFinestraTempo(int * gentempod);
//----------------
Bool WJustify(int nBatMax,int* daBat, int* aBat, TipoGiust* tp, double* kGiust);

char* smrgetenv(char*);


#include "gui/errman.hpp"
extern ErrorManager EM;
// gestore degli errori

#ifndef OPD
#include "drw/gscreen.hpp"
extern class GScreen *Scr;
// gestore dello schermo grafico (puntatore)  
extern GScreen Gscr;
// schermo grafico
#endif OPD

extern int nTextFont,nBigTextFont,nMusicFont,nMusicFont2,nMusicFont3,nMenuFont;
// font selezionabili direttamente tramite ID.
extern int DimensioneX,DimensioneY;

extern Bool SimbImg;
extern Bool Leg;
extern Bool ContrScrool;

extern Bool LIOOMaster;
// Indica se il processo LIOO e` master o slave.
// Adesso serve solo a dire se disegnare un partitura o una parte,
// percio` CAMBIARLE NOME!

enum TipoLeggio{
	LEGGIO_MASAE, // Alloca tutta la partitura
		LEGGIO_MASE, // Alloca tutta la partitura
		LEGGIO_DLIOO, // Fa allocazione parziale
		LEGGIO_PDLOO  // Fa allocazione parziale
};

extern TipoLeggio tipoLeggio;

extern char Array[];


// Codici dei colori utilizzati
extern int black, red, gray, white, dgray, blue_xor;


// Definizioni per l'uso dei comandi simbolici.

// passare ad unsigned short !!
// per entrambi.
typedef short NumCode;
typedef short ArgType;

#define PATH_LENGTH 9
#define SYM_MAXARG 10
// Significato degli argomenti utilizzati nella rappresentazione simbolica del comando
//
// 0 -> ...
// 1 -> ...
// ...
// 5 -> utilizzato nella inserzione di un oggetto, indica se inserire in testa alla lista.
// 6 -> utilizzato dopo l'inserzione di una battuta, ritorna il NumericCode della nuova battuta.
//	oppure indica, nell'inserimento di armatura di chiave in mezzo a figure, il codice 
//	dell'armatura da inserire
// 7 -> utilizzato dopo l'inserzione di una battuta, ritorna il NumProgress della nuova battuta.

#define SYM_MAX_TEXT 200
#define NET_CMD_MAXARG 2 

enum PathLevels{
	SPARTITO_PATH_LEVEL = 0,
		LISTA_PATH_LEVEL,
		BATTUTA_PATH_LEVEL,
		LAYER_PATH_LEVEL,
		FIGURA1_PATH_LEVEL,
		FIGURA2_PATH_LEVEL,
		FIGURA3_PATH_LEVEL,
		SIMBOLO_PATH_LEVEL,
		STAFF_PATH_LEVEL
};

struct NomImm {
	char name[100];
	int Biniz;
	int Bfin;
};

typedef struct{
	NumCode Array[PATH_LENGTH];
	short Level;
} SymPath;

typedef struct{
	CmdID CommandId;
	SelType SelectionType;
	SelObj SelObjType;
	SymPath Path1;
	SymPath Path2;
	SymPath Path3;
	ArgType ArgV[SYM_MAXARG];
	char Text[SYM_MAX_TEXT];
} SymCmd;  


enum SymMsgID{
	MSG_GET_BATTUTA,
		MSG_SET_BATTUTA
};

typedef struct{
	CmdID CommandId;
	NumCode ArgV[NET_CMD_MAXARG];
} SymMsg;  


void CopiaCommandStruct(SymCmd *MyCmd,SymCmd *CmdStrt);
void SalvaCommandStruct(SymCmd *MyCmd,FILE *fp);
void CaricaCommandStruct(SymCmd *MyCmd,FILE *fp);
void SaveString(char *Stringa,FILE *fp);
void LoadString(char *Stringa,FILE *fp);

extern unsigned short WinMasaeWidth;
extern unsigned short WinMasaeHeight;
extern unsigned short WinDliooWidth;
extern unsigned short WinDliooHeight;

#define WIN_MASAE_WIDTH  1250
#define WIN_MASAE_HEIGHT 900

#define WIN_DLIOO_WIDTH  751
#define WIN_DLIOO_HEIGHT 900

#define WIN_PIXMAP_WIDTH  1600
#define WIN_PIXMAP_HEIGHT 1200

#define WIN_SPARTITO_DELTA_X 15
// Bordo fra la finestra musicale e DrawArea.
#define WIN_SPARTITO_DELTA_Y 71
// Differenza fra l'altezza di DrawArea e la finestra musicale.
#define WIN_SPARTITO_POS    Point(7,51)

#define WIN_SPARTITO_NPENT  4


//  VARIABILI DI STATO GLOBALI PER LINE BREAKING AUTOMATICO
// variabili di stato per il line breaking automatico
extern int AutoLineBreak;
// =0 line breaking automatico disabilitato
// =1 line breaking automatico 
extern int DirOrOrc;	
// =0 vista del direttoriale
// =1 vista dell'orchestrale
extern int currentViewType;
// =0 is computer view
// =1 is print view

#endif

