/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#include "lyr\lyrdlgint.hpp"
#include "lyrdlg.wxr"
#include "lyrdlg.h"


BEGIN_EVENT_TABLE(LyrDlgInt, wxDialog)
EVT_BUTTON(ID_BUTTON101, LyrDlgInt::OnOk)
EVT_BUTTON(ID_BUTTON102, LyrDlgInt::OnCancel)
END_EVENT_TABLE()



LyrDlgInt::LyrDlgInt()
{
	
	
    inputBaseLine = NULL;
	inputInterLine = NULL;
	okButton = NULL;
	CancelButton = NULL;
	
	
	
	
	
}
LyrDlgInt::~LyrDlgInt()
{
	if(inputBaseLine !=NULL) 
		delete inputBaseLine;
	if(inputInterLine !=NULL) 
		delete inputInterLine;
	if(okButton!=NULL) 
		delete okButton;
	if(CancelButton !=NULL) 
		delete CancelButton;
}



bool LyrDlgInt::Initialize(double baseLine, double linesDist)
{
	wxString BL;
	wxString IL;
	
	BL =wxString::Format("%f",baseLine);
	IL =wxString::Format("%f",linesDist);
	
	wxResourceParseData(LyrDlg);  
	if (LoadFromResource(FrameManager::currFrame, "LyrDlg"))
	{
		inputBaseLine			= (wxTextCtrl *)wxFindWindowByName("inputBaseLine", this);
		inputInterLine			= (wxTextCtrl *)wxFindWindowByName("inputInterLine", this);
		okButton				= (wxButton *)wxFindWindowByName("okButton", this);
		CancelButton			= (wxButton *)wxFindWindowByName("CancelButton", this);	 
	}
	else
	{
		wxMessageBox("Error loading resources!","Error!", wxOK | wxICON_EXCLAMATION, NULL);
		return FALSE;
	}
	
    inputBaseLine->SetValue(BL);
	inputInterLine->SetValue(IL);
	return true;
}

double LyrDlgInt::GetBaseLine()
{
	double bl=0.;
	wxString blv;
	blv = inputBaseLine->GetValue();
	blv.ToDouble(&bl);
	
	return bl;
}

double LyrDlgInt::GetLinesDist()
{
	double ldist=0.;
	wxString ldistv;
	ldistv = inputInterLine->GetValue();
	ldistv.ToDouble(&ldist);
	
	return ldist;
}


void LyrDlgInt::OnOk(wxCommandEvent& event)
{
	EndModal(wxID_OK);
}

void LyrDlgInt::OnCancel(wxCommandEvent& event)
{
	EndModal(wxID_CANCEL);
}








