/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */



// ----------------------------------------------------------------------------
// headers
// ----------------------------------------------------------------------------

#ifndef LYRICFRAME
#define LYRICFRAME

#ifdef __BORLANDC__
#pragma hdrstop
#endif


#include <wx/wx.h>

#include <wx/file.h>
#include <wx/event.h>
#include <wx/textfile.h>
#include <wx/textctrl.h>
#include <wx/toolbar.h>
#include <wx/log.h>
#include <wx/image.h>
#include <wx/dialog.h>

class wxMEScoreFrame;
class ListaSillabe;
class Spartito;
class Partitur;

#define USE_GENERIC_TBAR 0

// ----------------------------------------------------------------------------
// risorse
// ----------------------------------------------------------------------------

#if defined(__WXGTK__) || defined(__WXMOTIF__)//aggiungere XMP di View e Add
#include "mondrian.xpm"
#include "bitmaps/new.xpm"
#include "bitmaps/open.xpm"
#include "bitmaps/save.xpm"
#include "bitmaps/copy.xpm"
#include "bitmaps/cut.xpm"
#include "bitmaps/preview.xpm"  // paste XPM
#include "bitmaps/print.xpm"
#include "bitmaps/help.xpm"
#endif // GTK or Motif

// ----------------------------------------------------------------------------
// classes
// ----------------------------------------------------------------------------

class LyricFrame: public wxFrame
{
public:
    LyricFrame(wxFrame *parent,
		wxWindowID id = -1,
		const wxString& title = "",
		const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize,
		long style = wxDEFAULT_FRAME_STYLE,
		wxMEScoreFrame* framecaller=NULL
		);
	
    void RecreateToolbar();
    void OnQuit(wxCommandEvent& event);
	void OnNew(wxCommandEvent& event);
	void OnOpen( wxCommandEvent& event);
	void OnViewHTML(wxCommandEvent& event);
	void View(wxCommandEvent& event);
    void View();
	void Add(wxCommandEvent&);
	void LoadStringWithText();
	void LoadTextWithString();
	void Trasferimento(wxString Percorso);
	void Clear(wxString copia);
	void CutT(wxCommandEvent& event);
	void CopyT(wxCommandEvent& event);
	void PasteT(wxCommandEvent& event);
	void GetCompPath(wxString CompPath);
	wxString GetPartPath();
	
	
	void SaveRequest();
	void Avviso();
	void OnWriting(wxCommandEvent& event); 
	void SetTool();
	void ResetTool();
	void SetPuntMusEdt(wxMEScoreFrame* Ptr);
	void SetWriting();
	void WriteLyric(wxString text,Spartito *pSpa);
	wxString InsBlkToString(wxString str);
	wxString StringManage(wxString str);
	void SetIntLine();
	
	wxString ManagerAt(wxString Str);
	void OnQuitFromME();
	wxString AddNewLyric(wxString Name,Spartito *pSpartito);
	bool SyntaxCheck(wxString Text);
	bool DetectSymbolLyr(char s);
	bool DetectSymbolRefrain(char s);
	bool DetectSymbolLyrPar(char s);
	wxString InsertSpaceAmongSymbols(wxString imm);
	wxString DelView(wxString imm);
    wxString SpaceForNoView(wxString imm);
	wxString detectspcForNV(wxString imm);
	void OnSetShift(wxCommandEvent& event);
	double GetShift();
	double GetBllf();
	void SetShift(double s);
    void SetBllf(double b);
	
#if USE_GENERIC_TBAR
    virtual wxToolBar *OnCreateToolBar(long style,
		wxWindowID id,
		const wxString& name );
#endif // USE_GENERIC_TBAR
	
private:
    void DoToggleHelp();
	void SyntaxError(wxString msg,int pos);
	
    bool m_smallToolbar, m_horzToolbar;
    size_t m_rows;             // 1 or 2 only
	
    wxTextCtrl* m_textWindow;
	
	wxMEScoreFrame* LinkMusEdit;
	Spartito* pSpa;
	double indsh;
	double bash;
	
	bool Modified;
    
	wxString BufferS,Strada,BufferS1,PercorsoDefault,CompletePath,PathOpen,PartialPath;
	bool Editable;
	
    DECLARE_EVENT_TABLE()
};
// ----------------------------------------------------------------------------
// constants
// ----------------------------------------------------------------------------

const int ID_TOOLBAR = 500;


enum
{
	IDM_TOOLBAR_ADD = 200,
		IDM_TOOLBAR_VIEW,
		IDM_TOOLBAR_JUST
};

#endif 