/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#include "lyr/sillaba.hpp"
#include <string.h>
#include "drw/slur.hpp"

#define  INTER 1
#define  TRATTINO 4
#define  MIN_DIST_FIG 15
#define  ALT_LINE_TRAT 3



ProlLine::ProlLine()
{
	Wdt=0;
	Hgt=0;
	pNext=NULL;
	
};
// COSTRUTTORE //
// Inizializza i puntatori   //
// e i campi della variabile //   
//   strutturata ProlLine.   //


ProlLine::~ProlLine()
{
};

Sillaba::Sillaba(const char *initstring)
{
	PFigStart=PFigEnd=NULL;       // Poich il prolungamento pu
	for(int i=0; i<MAX_VIEW; i++)
	{
		PActLin[i]=NULL;                 // iniziare su un pentagramma
		PFirstLin[i]=NULL;               // e terminare sul successivo
		FirstLin[i]=NULL;                // deve prevedere di essere
        YSil[i]=-1;
	}
	SetFont(nTextFont);           // disegnato in pi parti.Ci si
	ID=CL_SILLABA;                // ottiene gestendo in sillaba una
	Prol=FALSE;                   // lista di posizioni ,inizializzate	
	ProlTrat=FALSE;               // dal costruttore.
	SegTraSil=FALSE;
	Numtoken= 0;
	char * silTxt=new char[strlen(initstring)+1];
	strcpy(silTxt,initstring);
	SetTxt((unsigned char *)silTxt);
	gs=' ';
	NumSep=0;
	Token='N';
	LineStrf=1;
	NLayer=0;
};


// DISTRUTTORE //

Sillaba::~Sillaba()
{
	DeallocaLin();
	delete GetTxt();
};


// RESTITUZIONE E SETTAGGIO  //
//         PUNTATORI         //

void Sillaba::SetPFigStart (Figura *pF)
{
	PFigStart=pF;
};

void Sillaba::SetPFigEnd(Figura *pF)
{
	PFigEnd=pF;
};
void Sillaba::ResetFirstLin()
{
	FirstLin[GetCurrentView()]=NULL;
};

Figura *Sillaba::GetPFigStart()
{
	return PFigStart; 
};

Figura *Sillaba::GetPFigEnd()
{
	return PFigEnd;
};

ProlLine* Sillaba::GetPFirstLin()
{
	return PFirstLin[GetCurrentView()];
};





// FUNZIONI CHE RESTITUISCONO UNA //
// VARIABILE BOOLEANA CHE DENOTA  //
// IL TIPO DI PROLUNGAMENTO DELLA //
//         SILLABA ESTESA.        //	

Bool Sillaba::GetProl()
{
	return Prol;
};

Bool Sillaba::GetProlTrat()
{
	return ProlTrat;
};

Bool Sillaba::GetSegTraSil()
{
	return SegTraSil;
};

int  Sillaba::GetNumtoken()
{
	return Numtoken;
};

int Sillaba::GetNumSep()
{
    return NumSep;
}

char Sillaba::GetToken()
{
    return Token;
}
void Sillaba::SetNumSep(int i)
{
	NumSep = i;
}

void Sillaba::SetToken(char tk)
{
    Token = tk;
}
void Sillaba::SetText(unsigned char *txt1)
{
	strcpy((char*)testo,(char*)txt1);
	txt=testo;
	   
}
void Sillaba::Setgs(char cr)
{
	gs = cr;
}
char Sillaba::Getgs()
{ 
	
	return gs;
	
}
////////////////////////////////////


void Sillaba::SetProl(Bool a)
{
	Prol=a;
};

void Sillaba::SetProlTrat(Bool a)
{
	ProlTrat=a;
};

void Sillaba::SetSegTraSil(Bool a)
{
	SegTraSil=a;
};
void Sillaba::SetNumtoken(int num)
{
	Numtoken=num;
};



// FUNZIONI DI IMPOSTAZIONE DELLE    //
// VARIABILI CHE TENGONO CONTO DELLA //
// ESTENSIONE DEL PROLUNGAMENTO TRA  //
// DUE BATTUTE(PAGINE) CONSECUTIVE.  //




Bool Sillaba::GetInizio()
{
	return Inizio[GetCurrentView()];
};

void Sillaba::SetInizio(Bool b)
{
	Inizio[GetCurrentView()] = b;
};

Bool Sillaba::GetFine()
{
	return Fine[GetCurrentView()];
};

void Sillaba::SetFine(Bool b)
{
	Fine[GetCurrentView()] = b;
};



// METODO SETTAGGIO DI FIGURA //
//        OCCUPATA.           //
// Affinch non sia possibile associare sillabe //
// a figure gi occupate  necessario settare   //
// l'attributo AppSil di ogni nota associata    //
// alla sillaba estesa che si vuole inserire    //
// nello Spartito.                              //




Figura *Sillaba::SetSilOcc(Figura *pCor,Figura *pFEnd,ListaFigure *pLayer,
						   int InterLine,int a)
						   
						   
{
	// Poich le strofe possibili sono 4,
	//  necessario anche specificare la
	// strofa a cui appartiene la sillaba
	// (InterLine).Se cos non si facesse
	// l'inserimento di una sillaba di una
	// altra strofa non sarebbe possibile
	// in quanto la nota sarebbe bollata
	// sempre come occupata.
	
	Figura *ptr = NULL;
	if(pLayer != NULL)
	{ 
		if(pLayer != NULL)
			ptr=pLayer->GetFirstFig();
		else
			return NULL;
	}
	
	
	while((pCor!=ptr)&&(ptr!=NULL))
		ptr=pLayer->GetNextFig();
	// Questo ciclo e' necessario
	// affinche' il metodo sopra
	// funzioni correttamente.
	
	if(ptr==NULL)
	{
		
		return NULL;
	}
	
	// Fin quando non termina la battuta o
	// la figura corrente corrisponde alla
	// ultima figura a cui  associata la
	// sillaba estesa...
	
	
	while((pCor!=NULL) && (pCor!=pFEnd))		    	
		
	{      	
		pCor->SetAppSil((InterLine-1),a);
        // Setta l'attributo di figura
		// AppSil secondo il valora
		// intero a.
		if(pCor != NULL)
		{
			if(pLayer!= NULL)
				pCor=(pLayer->GetNextFig());
			else
				return NULL;
		}
		
	};
	
	return pCor;
	
};

void Sillaba::SetReset(Figura *pFStart,Figura *pFEnd,int Layer,
					   Battuta *pBatCor,int InterLine,int a,Bool TipoProl)
					   
{
	Figura *punt1;
	Battuta *pBatSuc;
	ListaFigure *pLayer;
	GruppoNote *lastGruppoNote=NULL;
	
	
	if(listaBat==NULL || pBatCor==NULL)
		return;
	
    // Si vanno a considerare solo le figure
	// del Layer a cui  associata la LIRICA.
	
    pLayer = pBatCor->GetPLayer(Layer);
	
	
	// Se la sillaba estesa si estende a cavallo
	// tra una o pi battute il settaggio della
	// variabile che indica che la figura  occupata
	// deve proseguire anche nelle battute succesive
	// a quella in cui ha inizio.Il settaggio termina
	// quando la figura esaminata coincide con la
	// figura finale a cui  associata la sillaba
	// estesa.
	
	punt1=pFStart;
	pBatSuc=pBatCor;
	
	while((pBatSuc!=NULL) && (punt1!=pFEnd))
	{	                                              		
		punt1=SetSilOcc(punt1,pFEnd,pLayer,InterLine,a);
        pBatSuc=(Battuta*)(listaBat->GetNext((DrawObject*)(void*)pBatSuc));
		if (punt1==NULL)
		{
			pLayer = pBatCor->GetPLayer(Layer);
			if(pLayer != NULL) 
				punt1=pLayer->GetFirstFig();
			else 
				punt1=NULL; 			
		};	
	};
	if (punt1==pFEnd)
		if ((a==1) && (TipoProl))
			// Se la sillaba  del tipo estesa
			// con prolungamento tratteggiato
			// o continuo l'ultima figura deve
			// risultare non occupata ed associata
			// ad un'altra sillaba.
			pFEnd->SetAppSil((GetLine()-1),0);
		else
			pFEnd->SetAppSil((GetLine()-1),a);
};



// Settaggio dei puntatori e di //		
// conseguenza dell'attributo   //
// Prol.                        //



void Sillaba::SetPFig(Figura *pFStart,Figura *pFEnd,int Layer,int numtoken,
					  Battuta *pBatCor,int InterLine,Bool Trat,Bool TraSil)
{
	
	// Settaggio puntatori alla figura
	// iniziale e finale a cui  associata
	// la sillaba estesa.
	
	PFigStart=pFStart;
	PFigEnd=pFEnd;
	
	if (PFigStart!=PFigEnd)
	{
		Prol=TRUE;
		if(Trat)
		{
			ProlTrat=TRUE;
			// In questo caso non solo la
			// sillaba  estesa(prol==true),
			// ma  anche del tipo sillaba a
			// prolungamento tratteggiato.
			if (TraSil) SegTraSil=TRUE;
		}
	};
	
	Numtoken=numtoken;
	// Affinch non sia possibile associare sillabe
	// a figure gi occupate  necessario settare
	// l'attributo AppSil di ogni nota associata
	// alla sillaba estesa che si vuole inserire
	// nello Spartito.
    //InterLine =GetLine();
	SetReset(pFStart,pFEnd,Layer,pBatCor,/*InterLine*/GetLine(),1,ProlTrat);
};


// POSIZIONAMENTO DEL PUNTATORE CHE //
// TIENE CONTO DEL SEGMENTO DEL     //
// PROLUNGAMENTO DA POSIZIONARE IN  //
// CODA ALLA LISTA.                 //

void Sillaba::ResetPosLin()
{
	PActLin[GetCurrentView()]=PFirstLin[GetCurrentView()];
};


// SETTAGGIO NUMERO DI IDENTIFICAZIONE //


void Sillaba::SetNumCode(NumCode nc)
{
	NumericCode=nc;
};
NumCode Sillaba::GetNumCode()
{
	return NumericCode;
	
};


// SETTAGGIO DELLA POSIZIONE //
// Setta le coordinate grafiche del //
// segmento che costituisce il prol.//
// della sillaba estesa.            //


void Sillaba::SetAbsPosX(VUnit x)
{
	if (PActLin[GetCurrentView()]!=NULL)
		PActLin[GetCurrentView()]->AbsP.x=x;
	
	else
		EM.Error(MUSICAL_ERR_AREA,"EC_LIN_NOTFOUND","Sillaba","SetAbsPosX()");
	
};

void Sillaba::SetAbsPosY(VUnit y)
{
	if (PActLin[GetCurrentView()]!=NULL)
		PActLin[GetCurrentView()]->AbsP.y = y;	
	else
		EM.Error(MUSICAL_ERR_AREA,"EC_LIN_NOTFOUND","Sillaba","SetAbsPosY()");
	
};
// RESTITUZIONE POSIZIONE SEGMENTO //
//          ATTIVO.                //

Point Sillaba::GetAbsPos()
{
	if (PActLin[GetCurrentView()] != NULL)
		return PActLin[GetCurrentView()]->AbsP;
	else
		EM.Error(MUSICAL_ERR_AREA,"EC_LIN_NOTFOUND","Sillaba","GetAbsPos()");
	return Point();
};

// SETTA LA LARGHEZZA E L'ALTEZZA //
// DEL SEGMENTO ATTIVO.           //

void Sillaba::SetWidth(VUnit w)
{
	if (PActLin[GetCurrentView()]!=NULL)
		PActLin[GetCurrentView()]->Wdt = w;
	
	else
		EM.Error(MUSICAL_ERR_AREA,"EC_LIN_NOTFOUND","Sillaba","SetWidth()");
};

void Sillaba::SetHeight(VUnit hgt)
{
	if (PActLin[GetCurrentView()]!=NULL)
		PActLin[GetCurrentView()]->Hgt= hgt;
	else
		EM.Error(MUSICAL_ERR_AREA,"EC_LIN_NOTFOUND","Sillaba","SetHeigth()");
	
};

void Sillaba::SetDim(VUnit W)
{
	SetWidth(W);
	SetHeight(W/8);	
};
// RESTITUZIONE DELLA LARGHEZZA //
// DEL SEGMENTO DA POSIZIONARE  //

VUnit Sillaba::GetVu2Rgt()
{
	if (PActLin[GetCurrentView()]!=NULL)		
		return PActLin[GetCurrentView()]->Wdt;
	else
		EM.Error(MUSICAL_ERR_AREA,"EC_LIN_NOTFOUND","Sillaba","GetVU2Rgt()");
	return 0;
};

// RESTITUZIONE DELL'ESTREMO //
// DESTRO DEL RETTANGOLO CHE //
// CONTIENE LA SILLABA.      //

VUnit Sillaba::GetLeft()
{
	if(!Prol || SegTraSil)
		return (GetVU2Rgt()/2);
	return 0;
};


// SETTA COORDINATA Y DEL TESTO //
//      DELLA SILLABA.          //

void Sillaba::SetYSil(VUnit y)
{
	YSil[GetCurrentView()]=y;
};

VUnit Sillaba::GetYSil()
{
	return YSil[GetCurrentView()];
};


// INSERIMENTO DI UN SEGMENTO,CHE  //
// COSTITUISCE IL PROLUNGAMENTO,IN //
// CODA ALLA LISTA.                //


void Sillaba::AddLin()
{
	ProlLine *p1;
	p1=new ProlLine;
	
	if (p1==NULL)
		EM.Error(GENERAL_ERR_AREA,"EC-MEMORYFAULT","Sillaba","AddSil");
	else		
		if (PFirstLin[GetCurrentView()]==NULL)
		{
			// Se il segmento da inserire  il primo:
			
			PFirstLin[GetCurrentView()]=p1;
			PActLin[GetCurrentView()]=p1;
			FirstLin[GetCurrentView()]=p1;
		}
		else
		{       // Altrimenti..
			PActLin[GetCurrentView()]->pNext=p1;			
			PActLin[GetCurrentView()]=p1;
			p1->pNext=NULL;
		};				
};


// DEALLOCAZIONE //
// Dalloca tutta la lista di segmenti //
// che costituiscono il prolungamento //
// in esame,tranne il primo.          //


void Sillaba::DeallocaLin()
{
	if(FirstLin[GetCurrentView()]==NULL)
		return;
	
	ProlLine *p1=FirstLin[GetCurrentView()]->pNext;
	while (p1!=NULL)
  		{
		PActLin[GetCurrentView()]=p1->pNext;			
		delete p1;
		p1 = PActLin[GetCurrentView()];
 		 };
	PActLin[GetCurrentView()] = NULL;  	
	FirstLin[GetCurrentView()]->pNext = NULL;
	FirstLin[GetCurrentView()]->AbsP = Point(0,0);
	FirstLin[GetCurrentView()]->Wdt=0;
	FirstLin[GetCurrentView()]->Hgt=0;	
	PFirstLin[GetCurrentView()] = NULL;
	YSil[GetCurrentView()]=-1;
};

// METODI DI CREAZIONE DELLA //
//   SILLABA COME OGGETTO    //
//         GRAFICO.	     //



VUnit Sillaba::DrawText(int ns)

{           // La sillaba deve essere trasformata in //
	// in un oggetto grafico e centralizzata //
	// sulla figura a cui  associata.       //
	// Il seguente metodo disegna solo il    //
	// testo della sillaba.Viene richiamato  //
	// da ListaSillabe per disegnare SILLABE //
	// SINGOLE oppure dal metodo successivo  //
	// per il  disegno di SILLABE ESTESE.    //
	
	VUnit pRgtext;
	// Coordinata destra del rettangolo
	// contenente il testo della sillaba.
	VUnit pLftext;
	// Coordinata sinistra del rettangolo
	// contenente il testo della sillaba.
	VUnit Wdtext;
	// Larghezza ell'oggetto grafico testo
	// della sillaba.
	Figura *pfS=PFigStart;
	
	
	//    SETTAGGIO ESTREMI RETTANGOLO    //
	//   Questa operazione permette di    //
	//  impostare gli estremi del         //
	//  rettangolo contenente la stringa  //
	//  in modo da centralizzarla sulla   //
	//  figura.                           //
	
	Setup();
	
	wxString silTxt(txt);
	bool FindDoll = silTxt.IsSameAs('$');
	if(silTxt.Find("+")!= -1)
		return DrawSilWithSlur(ns);
	
	Wdtext = GetVU2Rgt();
	
	if(!Prol || SegTraSil)
	{
		pRgtext=Wdtext/2;
		pLftext=Wdtext/2;
	}
	else
	{
		pLftext=pfS->GetVU2LftF();
		pRgtext=Wdtext-pLftext;
	}
	
	
	FontID ofont;
	Colore oldcol = Scr->GetColor();
	Scr->SetColor((ColorIcon)black);
	ofont=Scr->SetFont(font);
	
	Scr->TextTo(DrawObject::GetAbsPos()+Point(pfS->GetAbsPos().x-pLftext , GetYSil()));
	
	// In questo modo la sillaba viene
	// centralizzata sulla figura a cui
	//  associata.
	
	
	if((txt!=NULL)&&(!FindDoll)) 
	{
		Scr->OutText(txt);
	}
	Scr->SetColor(oldcol);
	// Scrive il testo indicato con il font
	// attualmente selezionato.
	
	Scr->SetFont(ofont);
	
	return  Wdtext;
	// Questo valore viene restituito,per
	// poter essere nuovamente utilizzato
	// per disegnare il prolungamento nel
	// caso di SILLABA ESTESA:
	
};

VUnit Sillaba::DrawSilWithSlur(int ns)
{
	VUnit DeltaDx,DeltaSx,DeltaI;
	VUnit Wdtext;
	Point from,to;
	Figura *pfS=PFigStart;
	
	
	wxString sillabe(txt), silDx, silSx;	
	Text curDx,curSx,curI;
	
	
	
	silDx = sillabe.AfterFirst('+');
	silSx = sillabe.BeforeFirst('+');
	curSx.SetTxt((unsigned char *) silSx.c_str());
	curDx.SetTxt((unsigned char *) silDx.c_str());
	curI.SetTxt((unsigned char )'+');
	curSx.SetFont(nTextFont);
	curDx.SetFont(nTextFont);
	curI.SetFont(nTextFont);
	
	
	Wdtext = GetVU2Rgt();
	
	DeltaDx = curDx.GetVU2Rgt();
	DeltaSx = curSx.GetVU2Rgt();
	DeltaI = curI.GetVU2Rgt();
	
	VUnit pLftext;
	
	if(!Prol || SegTraSil)
	{
		pLftext=Wdtext/2;
	}
	else
	{
		pLftext=pfS->GetVU2LftF();
	}
	
	
	FontID ofont;
	Colore oldcol = Scr->GetColor();
	Scr->SetColor((ColorIcon)black);
	ofont=Scr->SetFont(font);
	
	Point start=DrawObject::GetAbsPos()+Point(pfS->GetAbsPos().x-pLftext , GetYSil());
	Scr->TextTo(start);
	
	/*Fase di scrittura delle sillabe coniugate e relativo slur*/
	
	// In questo modo la sillaba viene
	// centralizzata sulla figura a cui
	//  associata.
	
	if(txt!=NULL) 
	{
		Scr->OutText(curSx.GetTxt());//da togliere
	}
	Scr->SetColor(oldcol);
	//Seconda sillaba
	
	
	from=start+Point(DeltaSx,0);
	to=from+Point(DeltaI,0);
	Slur sl;
	sl.SetSlur(from, to, NERO);
	sl.SetBowUp(0);
	sl.Draw();
	
	
	Scr->TextTo(to);
	
	wxString tmp(curDx.GetTxt());
	if(tmp.Find("+")!= -1)
	{
		DrawSilWithMoreSlur(tmp,to);
	}
	else
	{
		Scr->OutText(curDx.GetTxt());
	}
	
	
	// Scrive il testo indicato con il font
	// attualmente selezionato.
	
	Scr->SetFont(ofont);
	
	return  Wdtext;
	
}

VUnit Sillaba::DrawLin(ProlLine *PAct,VUnit xIniz,int ns)
{
	VUnit x1=(PAct->AbsP).x;
	
	if((PAct!=PFirstLin[GetCurrentView()]) && (PAct->pNext!=NULL))
		x1=(PAct->AbsP).x;	
	
	if (PAct==PFirstLin[GetCurrentView()])
	{       // Caso di segmento che inizia e termina nella
		
		// stessa battuta o riga di pentagrasmma.
		
		if((GetInizio()) && (GetFine()))
			x1=xIniz+INTER;
		// In questo caso il disegno della
		// linea deve partire dopo la sillaba.
		// INTER  la distanza fissa che
		// separa la sillaba dalla x della da
		// disegnare.
		
		// Caso di segmento che iniziato
		// nella pagina precedente termina
		// in quella corrente.
		
		if ((GetInizio()==False) && (GetFine()))
			x1=(PAct->AbsP).x;
		
		// In questo caso si considera
		// la posizione propria del segmento,
		// fornita dai metodi di spartito che
	};                             	        // si preoccupano dell'aspetto grafico.
	
	return x1;
};

void  Sillaba::DrawSilProl(VUnit XEnd,int ns)
{
	// Nel caso in cui la Sillaba sia estesa anche //
	// il prolungamento deve essere disegnato.     //
	// Questo metodo richiamato da ListaSillabe si //
	// preoccupa di disegnare sul video una SILLABA//
	// ESTESA con prolungamento a tratto continuo, //
	// o tratteggiato sulla base dell'ingresso.    //
	
	VUnit xIniz;
	Figura *pfS=PFigStart;
	VUnit XStart,x2;
	Point from,to;
	VUnit Wdtext=0;
	
	if(GetYSil()>0)
		Wdtext=DrawText(GetLine());
	// Il metodo sopra disegna la sillaba
	// e restituisce la larghezza dello
	// oggetto grafico cos creato.
	
	if(GetToken() == '@')
		return;
	
	VUnit deltaX=0;
	if(Prol && !SegTraSil)
		deltaX=Wdtext;
	else
		deltaX=Wdtext/2;
	
	xIniz=(pfS->GetAbsPos().x)-pfS->GetVU2LftF()+deltaX;
	// Coordinata iniziale.
	
	
	PActLin[GetCurrentView()] = PFirstLin[GetCurrentView()];
	// Punta al primo segmento che costituisce
	// il prolungamento.
	while (PActLin[GetCurrentView()]!=NULL)
	{
		XStart=DrawLin(PActLin[GetCurrentView()],xIniz,1);
		// Restituisce la coordinata iniziale in
		// base al termine della battuta o del
		// rigo di pentagramma.
		x2=XStart+PActLin[GetCurrentView()]->Wdt-XEnd-deltaX;
		// Coordinata finale della linea da
		// disegnare nel caso di prolungamento
		// continuo;  estremit sinistra del
		// tratto tra due sillabe consegutive in
		// cui vanno posti i trattini,nel caso
		// di prolungamento tratteggiato.
		int y=PActLin[GetCurrentView()]->AbsP.y;
		
		
		if (Prol && !ProlTrat)
			// Se il prolungamento  a tratto continuo...
		{
			from=Point(XStart,y);
			// Punto iniziale della linea da disegnare.
			to=Point(x2,y);
			// Punto finale della linea da disegnare.	
			Scr->Line(from,to);
		}
		else
		{
			// Altrimenti se il prolungamento  a
			// tratto tratteggiato o composto da un
			// unico tratto...
			
			VUnit larg;
			// Larghezza tra due sillabe che
			// devono essere separate dal
			// tratteggio.
			VUnit Seg=TRATTINO;
			// Dimensione fissa del segmento
			// della  linea tratteggiata.
			int n,i;
			
			larg=x2-XStart;
			// Larghezza del tratto tra le
			// due sillabe consegutive.
			
			n=(int)((larg/((2*3+1)*Seg))); 
			if(n<1)
			{
				if((larg-Seg)/2>5)
					n=1;
				else
				{
					if(larg<=0) 
						n=0;
					else
					{
						Seg=2; 
						n=1;
					}
				}
			}
			
			// Caso in cui le note sono abbastanza
			// separate da permettere un prolungamento
			// costituito da almeno un segmento di
			// lunghezza fissata.
			
			// calcola la larghezza del bianco
			int b=0;
			if(n>0)
				b=(larg-n*Seg)/(2*n);
			if(b<0)
				b=1;
			
			if(isOpaque)
				Scr->SetColor(GetColor());
			for(i=1; i<=n; i++)
			{
				// Ciclo per la costruzione del
				// prolungamento tratteggiato.
				from=Point((XStart+b),y+ALT_LINE_TRAT);
				// Punto iniziale della linea da disegnare.
				to=Point((XStart+b+Seg),y+ALT_LINE_TRAT);
				// Punto finale della linea da disegnare.	
				Scr->Line(from,to);
				
				XStart+=2*b+Seg;
				// Coordinata di partenza per successivo
				// trattino costituente il segmento.
			};				
		};
		PActLin[GetCurrentView()] = PActLin[GetCurrentView()]->pNext;
	};
	PActLin[GetCurrentView()] = NULL;
};



// Funzioni per la gestione grafica di //
// eventuali prolungamenti che si      //
// estendono a cavallo tra due battute.//


void Sillaba::SetNumBat(short n, Battuta *pb)
{
	if (n==1)
		pbat1 = pb;
	else
		pbat2 = pb;
};

Battuta *Sillaba::GetBattuta(short n)
{
	if (n==1) 
		return pbat1;
	else 
		return pbat2;
};


void Sillaba::LinkTogetherTxt(char *s,int Numtoken ,char token)
{
	
	int DimSpazi=2*(Numtoken-1);
	// Numero di caratteri ' ' in totale
	// nella stringa finale.
	int DimTxt=strlen(s) +DimSpazi+Numtoken+1;
	
	char  *NewSil;
	// Nuovo testo della sillaba.
	NewSil=new char[DimTxt];
	// Allocazione di una nuova stringa
	// di dimensione fissata.
	
	int i;
	//Contatore.
	
	// Copia dei caratteri passati per
	// riferimento nella nuova stringa
	// nelle posizioni rispettive.
	for(i=0; i<(int)strlen(s); i++)
	{
		NewSil[i]=s[i];	
	};
	
	int k=DimSpazi;
	// Variabile temporanea che tiene conto
	// degli spaz<i gi disposti.
	for (int j=i; j<(DimTxt); j++)
	{
		NewSil[j]=token;
		if (k>0)
		{		
			NewSil[j+1]=' ';
			NewSil[j+2]=' ';
			k=k-2;
			j=j+2;
		};
	};
	NewSil[DimTxt-1]=0;
	// Si termina il testo con il caratttere nullo.
	
	delete GetTxt();
	// Dealloca il testo attuale.	
	SetTxt((unsigned char*)NewSil);
	//Setta il nuovo testo della sillaba,secondo
	// quello detertminato.
	Setup();
	return ;
	// Ritorna al chiamante.
	
	
};

void  Sillaba::LinkTogetherTxt(char *s1,char *s2 ,char token)
{
	
	
	   // Concatena il testo di due sillabe  //
	   // separate da un token,e aggiorna,con//
	   // il risultato il testo della sillaba//
	   // corrente.                          //
	
	int DimTxt=strlen(s1) +strlen(s2)+2;
	// Nuova dimensione della stringa.
	
	char  *NewSil;
	// Nuovo testo della sillaba.
	NewSil=new char[DimTxt];
	// Allocazione di una nuova stringa
	// di dimensione fissata.
	
	int i;
	// Contatore di caratteri.
	
	for(i=0; i<(int)strlen(s1); i++)
	{
		NewSil[i]=s1[i];	
	};
	
	NewSil[i]=token;
	// Aggiunge i token che separa le due
	// sillabe.
	
	for(int j=i+1; j<DimTxt-1; j++)
	{
		NewSil[j]=s2[j-(i+1)];	
	};
	
	
	NewSil[DimTxt-1]=0;
	// Si termina il testo con il caratttere nullo.
	delete (GetTxt());
	// Libera il testo della vecchia sillaba.
	SetTxt((unsigned char*)NewSil);
	//Setta il nuovo testo della sillaba,secondo
	// quello detertminato.
	Setup();
	
};

VUnit Sillaba::SetYStrofe(int ns,VUnit yy)
{
	int Dist2 = 20, Dist3 = 40, Dist4 = 60;
	VUnit Y;
	switch(ns)
	{
	case 1:
		Y=yy;
		break;
	case 2:
		Y=yy-Dist2;
		break;
	case 3:
		Y=yy-Dist3;
		break;
	case 4:
		Y=yy-Dist4;
		break;	
	};
	return Y;	
}

void Sillaba::SetLine(int ns)
{
	LineStrf = ns;
}

int Sillaba::GetLine()
{
    return LineStrf;
}

void Sillaba::SetNLayer(int NL)
{
	NLayer = NL;
}

int Sillaba::GetNLayer()
{
    return NLayer;
}

void Sillaba::DrawSilWithMoreSlur(wxString tmp,Point Ini)
{
	wxString sillabe(txt), silDx1, silSx1;	
	Text curDx1,curSx1,curI1;
	Point fromM,toM;
	
	VUnit DeltaDxM,DeltaSxM,DeltaIM ;
	
	silDx1 = tmp.AfterFirst('+');
	silSx1 = tmp.BeforeFirst('+');
	curSx1.SetTxt((unsigned char *) silSx1.c_str());
	curDx1.SetTxt((unsigned char *) silDx1.c_str());
	curI1.SetTxt((unsigned char )'+');
	curSx1.SetFont(nTextFont);
	curDx1.SetFont(nTextFont);
	curI1.SetFont(nTextFont);
	
	DeltaDxM = curDx1.GetVU2Rgt();
	DeltaSxM = curSx1.GetVU2Rgt();
	DeltaIM = curI1.GetVU2Rgt();
	
    Scr->OutText(curSx1.GetTxt());
	
	fromM=Point(Ini.x +DeltaSxM,GetYSil());
	toM=Point(Ini.x +DeltaSxM+DeltaIM,GetYSil());
	Slur sl;
	sl.SetSlur(fromM, toM, NERO);
	sl.SetBowUp(0);
	sl.Draw();
	
	
	Scr->TextTo(Ini.x +DeltaSxM+DeltaIM,GetYSil());
	
	wxString  cntr(curDx1.GetTxt());
	if(cntr.Find("+")!= -1)
	{
		DrawSilWithMoreSlur(cntr,toM);
	}
    else
	{
		Scr->OutText(curDx1.GetTxt());
	}	
}

bool Sillaba::GetAss()
{
	return Is_Assoceable;
}

void Sillaba::SetAss(bool Is_Ass)
{
	Is_Assoceable = Is_Ass;
}

double Sillaba::GetShift()
{
	return Shift;
}

void Sillaba::SetShift(double shft)
{
	Shift = shft;
}

////////////////////////////////

