/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */



#include "lyr/wordexploder.hpp"



// QUESTA CLASSE VIENE IMPIEGATA  //
// DA SPARTITO NELL'INSERIMENTO   //
// DELLE PAROLE DI LIRICA.        //
// LA PAROLA VIENE INSERITA COME  //
// SILLABE DIVISE DA DEFINITI     //
// SEPARATORI.                    //
// LA SUA FUNZIONE  LA DIVISIONE //
// DELLA PAROLA IN SILLABE SINGOLE//


WordExploder::WordExploder(const WordExploder& we)
{
	m_text=we.m_text;
	m_currentPos=we.m_currentPos;
	m_currentSyllableType=we.m_currentSyllableType;
	m_currentSyllable=we.m_currentSyllable;
	m_currentSeparatorType=we.m_currentSeparatorType;
	m_currentSeparatorCount=we.m_currentSeparatorCount;
}

SyllableType WordExploder::GetSyllable(wxString& syllable)
{
	char curChar=m_text[m_currentPos++];
	int braceCount=0;
	
	if(curChar=='\0')
	{
		m_currentSyllableType=SYL_END;
		m_currentSyllable="";
		m_currentSeparatorType=' ';
		m_currentSeparatorCount=0;
		m_currentPos--;
	}
	else if(isBlankSeparator(curChar) || curChar=='{')
	{
		bool repeat=true;
		m_currentSyllableType=SYL_TEXT;
		m_currentSyllable="";
		while(repeat && curChar!='\0')
		{
			while(isBlankSeparator(curChar))
			{
				m_currentSyllable+=curChar;
				curChar=m_text[m_currentPos++];
			}
			if(curChar=='{')
			{
				braceCount=0;
				bool repeat=true;
				while(repeat && curChar!='\0')
				{
					m_currentSyllable+=curChar;
					
					if(curChar=='{')
						braceCount++;
					else if(curChar=='}')
					{
						braceCount--;
						if(braceCount==0)
							repeat=false;
					}
					
					curChar=m_text[m_currentPos++];
				}
			}
			else
				repeat=false;
		}
		m_currentPos--;
		m_currentSeparatorType=' ';
		m_currentSeparatorCount=0;
	}
	else if(curChar=='@')
	{
		m_currentSyllableType=SYL_AT;
		m_currentSyllable="";
		m_currentSeparatorType='@';
		m_currentSeparatorCount=0;
		while(curChar=='@')
		{
			m_currentSeparatorCount++;
			curChar=m_text[m_currentPos++];
		}
		if(curChar==']')
			m_currentSyllable+=curChar;
		else
			m_currentPos--;
	}
	else
	{
		m_currentSyllableType=SYL_NORMAL;
		m_currentSyllable="";
		if(curChar!='/' && curChar!='-' && curChar!= '_' && curChar!='@' &&
			!isBlankSeparator(curChar) && curChar!='{' && curChar!='\0')
		{
			m_currentSyllable+=curChar;
			curChar=m_text[m_currentPos++];
		}
		while(curChar!='/' && curChar!='-' && curChar!= '_' && curChar!='@' &&
			!isBlankSeparator(curChar) && curChar!='{' && curChar!='\0' && curChar!='%' && curChar!='[' && curChar!=']')
		{
			m_currentSyllable+=curChar;
			curChar=m_text[m_currentPos++];
		}
		
		if(curChar==']')
		{
			m_currentSyllable+=curChar;
		}
		else
		{
			m_currentSeparatorCount=0;
			if(curChar=='/' || isBlankSeparator(curChar) || curChar=='\0')
			{
				m_currentSeparatorType=curChar;
				if(curChar=='\0')
					m_currentPos--;
				else
					m_currentSeparatorCount++;
			}
			else if(curChar=='-' || curChar== '_')
			{
				m_currentSeparatorType=curChar;
				while(curChar==m_currentSeparatorType)
				{
					m_currentSeparatorCount++;
					curChar=m_text[m_currentPos++];
				}
				m_currentPos--;
			}
			else if(curChar=='@' || curChar=='{' || curChar=='%' || curChar=='[')
			{
				m_currentSeparatorType='e'; //empty
				m_currentPos--;
			}
			if(curChar==']')
			{
				m_currentSyllable+=curChar;
				curChar=m_text[m_currentPos++];
			}
		}
	}
	
	syllable=m_currentSyllable;
	return m_currentSyllableType;
}



