/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#include <wx/string.h>

enum SyllableType { SYL_TEXT, SYL_AT, SYL_NORMAL, SYL_END };

inline bool isBlankSeparator(char s)
{
	return s==' ' || s=='\n' || s=='\t';
}

class WordExploder
{	
private:
	
	wxString m_text;
	
	unsigned int m_currentPos;
	
	SyllableType m_currentSyllableType;
	wxString m_currentSyllable;
	char m_currentSeparatorType;
	int m_currentSeparatorCount;
	
public:
	
	WordExploder(const wxString& text) : m_text(text) { m_currentPos=0; };
	WordExploder(const WordExploder& we);
	// Costruttore.
	
	void GoTop() { m_currentPos=0; };
	SyllableType GetSyllable(wxString& syllable);
	
	wxString GetCurrentSyllable() const { return m_currentSyllable; };
	SyllableType GetCurrentSyllableType() const { return m_currentSyllableType; };
	char GetCurrentSeparatorType() const { return m_currentSeparatorType; };
	int GetCurrentSeparatorCount() const { return m_currentSeparatorCount; };
	
};

