/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#include "mdo/midiparamvoice.hpp"

Midi_ParamVoice::Midi_ParamVoice()
{
	instrument = "";
	midicode = 0; 
	volume = 127;
	channel = 0;
	muting = false;
	solo=false;
	ch_ready = instr_ready = volume_ready = false;
}

Midi_ParamVoice::~Midi_ParamVoice()
{

}



void Midi_ParamVoice::Set_Instrument(wxString instr)
{
	instrument = instr;
}

void Midi_ParamVoice::Set_MidiCode(int code)
{
	midicode = code;
	if(midicode>=1 && midicode<=128)
		instr_ready=true;
}

void Midi_ParamVoice::Set_Volume(int vol)
{
	volume = vol;
	volume_ready = true;
}

void Midi_ParamVoice::Set_Channel(int ch)
{
	channel = ch;
	if(channel>=0 && channel<=16)
		ch_ready=true;
}

void Midi_ParamVoice::Set_Muting(bool mute)
{
	muting = mute;
}

void Midi_ParamVoice::Set_TrackNumber(int trknum)
{
	tracknumber = trknum;
}

void Midi_ParamVoice::Set_Solo(bool single)
{
	solo=single;
}

wxString Midi_ParamVoice::Get_Instrument()
{
	return instrument;
}

int Midi_ParamVoice::Get_MidiCode()
{
	return midicode;
}

int Midi_ParamVoice::Get_Volume()
{
	return volume;
}

int Midi_ParamVoice::Get_Channel()
{
	return channel;
}

bool Midi_ParamVoice::Get_Muting()
{
	return muting;
}

bool Midi_ParamVoice::Get_Solo()
{
	return solo;
}

int Midi_ParamVoice::Get_TrackNumber()
{
	return tracknumber;
}

bool Midi_ParamVoice::IsReady()
{
	return instr_ready;
}
	
bool Midi_ParamVoice::IsVolumeSet()
{
	return volume_ready;
}