/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#ifndef MIDIPARAMVOICE_HPP
#define MIDIPARAMVOICE_HPP

#include "wx/wx.h"



class Midi_ParamVoice 
{
protected:
	
	wxString instrument;
	int midicode;
	int volume;
	int channel;
	bool muting;
	bool solo;
	int tracknumber;
	bool ch_ready;
	bool instr_ready;
	bool volume_ready;

public:
	Midi_ParamVoice();
	~Midi_ParamVoice();

	void Set_Instrument(wxString instr);
	void Set_MidiCode(int code);
	void Set_Volume(int vol);
	void Set_Channel(int ch);
	void Set_Muting(bool mute);
	void Set_Solo(bool single);
	void Set_TrackNumber(int trknum);

	wxString Get_Instrument();
	int Get_MidiCode();
	int Get_Volume();
	int Get_Channel();
	bool Get_Muting();
	bool Get_Solo();
	int Get_TrackNumber();

	bool IsReady();
	bool IsVolumeSet();
};

#endif