/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#include "imp/midiseq.h"
#include "par/partitur.hpp"

struct datitrack0
{
     int t0num;      //numeratore traccia0
     int t0denom;    //denominat traccia0
     int t0tact3;    //terzo paramentro da passare alla funzione tact della traccia0
     unsigned long t0bpmsemiminima; //bpm traccia0
     unsigned long t0deltatime;     //delta time traccia0
} ;   

struct listaindici
 {
  int valore;
  listaindici * next;
 };     

class Figura;
class ListaFigure;

class MoodsMidiWrite : public Midi_symbolic_interface
{
	
protected :
	
	MEVT_EXTRA_INFO evt_info;
	
public:
	MoodsMidiWrite();

	int ppqn;
	int totvoice;
	//CAMPO CHE VIENE USATO IN ATTIVAFINESTRASTRU E ATTIVAFINESTRALAYER
	//E TIENE CONTO DEL NUMERO TOT DI VOCI (CANALE-VOLUME-STRUMENTO) INSERITE 
	//QUANDO PARTE LA PRIMA FINESTRA.

	int indice;
	//E' L'INDICE CORRENTE (PER LO SPARTITO IN QUESTIONE) DELLA RIGA DELLA
	//TABELLA  ORCHESTRA.
	Figura * altrafigura;
	//PUNTATORE A CLASSE FIGURA...SERVE PER POTER RECUPERARE IL TEMPO DINAMICO
	//RELATIVO A UNA FIGURA MA EVENTUALMENTE MARCATO SOLO NELLA FIGURA CORRISPONDENTE
	//APPARTENENTE ALL'ALTRO LAYER.
	ListaFigure * altralista;
	//PUNTATORE ALLA CLASSE LISTAFIGURE...SERVE COME SOPRA PER POTER PUNTARE ALLA
	//ALTRA LISTA DI FIGURE RISPETTO A QUELLA CHE SI STA SCORRENDO.
	//void orchestrazione(ListaSpartiti *ptrLSpa);
	void orchestrazione(Partitura *pPart);
	//FUNZIONE CHE PERMETTE L'ASSOCIAZIONE CANALE-VOLUME-STRUMENTO ALLE VARIE VOCI E
	//L'ASSOCIAZIONE VOCE-LAYER.
	int setrack0;
	//FLAG CHE SERVE PER EVIDENZIARE SE SI STA GENERANDO LA TRACCIA ZERO DEL MIDI
	//O UNA GENERICA TRACCIA MUSICALE
	int flagfaimidi;
	//FLAG AVVALORATO DA ORCHESTRA() CHE RENDE 0 SE LE VARIE FINESTRE DI SELEZIONE 
	//STRUMENTO-VOCI SONO TERMINATE CON OK. SE E' STATO PREMUTO CANCEL INVECE
	//TALE FLAG VALE 1 E NON VIENE FATTO IL FILE MIDI.
	listaindici *firs1;
	listaindici *firs2;
	//PUNTATORI ALLA STRUTTURA LISTAINDICI DI CUI DEFINITA SOPRA.INFATTI LA FUNZIONE 
	//ORCHESTRA AVVALORA UNA LISTA DI STURTTURE DI QUESTO TIPO DOVE IL CAMPO "VALORE" 
	//VALE L'INDICE DEL VETTORE ORCHESTRA ASSOCIATO ALLO SPARTITO CORRENTE.
	//(CIOE' NEL  PRIMO RECORD DELLA LISTA  "VALORE" E' LA RIGA DELLA TABELLA ORCHESTRA
	//ASSOCIATA ALLO SPARTITO NUMERO1, IL SECONDO "VALORE" E' LA RIGA DI ORCHESTRA ASSOCIATA
	//ALLO SPARTITO NUMERO2 E COSI' VIA...)
	datitrack0 lastset;
	//QUESTA STRUTTURA SERVE PER TENERE LE INFORMAZIONI DI METRONOMO CORRENTI...TUTTE LE VOLTE
	//CHE IN BATTUTA SI TROVANO LE INFORMAZIONI METRONOMICHE E IL TEMPO DELLA BATTUTA VIENE
	//CONFRONTATO SE SONO DIVERSE DA QUELLE IN QUESTA STRUTTURA E SOLAMENTE IN QUESTO CASO
	//VIENE AGGIORNATA LA STRUTTURA.
	int canale;
	//TIENE IL NUMERO DI CANALE
	unsigned long numerospartiti;
	//RAPPRESENTA IL NUMERO DI SPARTITI PRESENTI NELLA PARTITURA IN QUESTIONE
	int tipodichiave;
	//E' UN NUMERO DA 23 A 31 CHE RAPPRESENTA IL TIPO DI CHIAVE PRESENTE NELLA BATTUTA CORRENTE
	//(VEDERE IL TIPO ENUMERATO "CLASS ID" PRENSENTE IN LIOO.HPP.
	int armaturadichiave;
	//INTERO CHE TIENE UN NUMERO (DA 0 A 14) CHE RAPPRESENTA L'ARMATURA DI CHIAVE CORRENTE
	//OGNI VOLTA CHE UNA NUOVA BATTUTA HA L'ARMATURA DI CHIAVE VIENE CONFRONTATO CON TALE 
	//CAMPO E SE DIVERSO TALE CAMPO VIENE AGGIORNATO.
	//SE L'ARMATURA DI CHIAVE NON E' PRESENTE ALLORA TALE CAMPO VALE 0.
	int flagpolifonia;  
	//VALE 1 O 2 A SECONDA CHE SI STIA ANALIZZANDO LA PRIMA O LA SECONDA VOCE POLIFONICA DELLO SPARTITO 
	//IN QUESTINOE
	int flagisaccordo;
	//VALE 1 SE LA FIGURA CORRENTE E' UN ACCORDO.
	int tprecdinamico;
	//VALE DA 0 A 19 (VEDI IL TIPO ENUMERATO TDINAMICO PRESENTE IN CLASSE TEMPODINAMICO.
	int tempodinamico[20];
	//VETTORE CHE TIENE LE 20 PERCETUALI DI TEMPO DINAMICO.ES tempodinamico[5] (=P) = 50 SIGNIFICA
	//CHE VIENE FATTO IL 50% DI 127 E LE NOTE SONO ATTIVATE CON TALE VELOCITA' DI ATTACCO.
	float velocitadiattacco;
	//TIENE IN MEMORIA LA PRECEDENTE VELOCITA' DI ATTACCO DESCRITTA SOPRA.
	//SE LA VELOCITA' DI ATTACCO VARIA (CIOE' VARIA IL TEMPO DINAMICO) ALLORA 
	//VIENE AGGIORNATO QUESTO CAMPO. LE NOTE SONO TUTTE ATTIVATE CON LA VELOCITA' 
	//DI ATTACCO CONTENUTA IN QUESTO CAMPO.
	unsigned long tempo1battuta1;   //servono per la prima battuta
	unsigned long tempo1battuta2;   //che se non ha durata pari al
	//num/denom deve essere scritta
	//cosi' come e', cioe' con durata
	//inferiore e cosi' tutte le
	//prime battute di tutti gli
	//altri spartiti.
	
	unsigned long ticsaccordo;
	//RAPPRESENTA LA DURATA (IN TICS) DI UNA FIGURA DI TIPO ACCORDO.
	int flagprecalter[7];
	//VETTORE IN CUI LO 0 CORRSIPONDE AL DO, L'1 AL RE E COSI' VIA FINO AL SI CHE TIENE
	//MEMORIA DELL'ALTERAZIONE CORRENTE ASSOCIATA A TALE NOTA.
	//OGNI VOLTA CHE VARIA L'ALTERAZIONE VIENE AGGIORNATO QUESTO VETTORE.  
	//int orchestra[17][3];
	int orchestra[33][3];
	//TABELLA CHE MANTIENE L'ASSCIAZIONE STRUMENTO-VOLUME-CANALE.
	//SICCOME IL MIDI HA 16 POX CANALI CI SONO 16 RIGHE PIU' UNA 
	//PER GESTIRE L'EVENTUALITA' CHE QUALCHE LAYER(=SPARTITO) NON
	//SIA SELEZIONATO DALL'UTENTE->IN QUEL CASO SI DEVE ANDARE ALLA
	//SEDICESIMA RIGA DI TALE TABELLA.
	int spartitocorrente; //memorizza il numero dello spartito in corso
	//che puo' essere diverso dal canale se gli
	//spartiti sono + di16
	//SONO NUMERATI A PARTIRE DA 1
	unsigned long deltatimebattuta; 
	//TIENE CONTO DEL TEMPO IN TICS TRASCORSO DALL'INIZIO DELLA BATTUTA FINO ALLA FIGURA CORRENTE
	int transpose;
	// number of semitones to transpose the current score
	
	//****le seguenti var servono per la gestione delle legature di valore***   
	unsigned long tempolegatura;
	//TIENE CONTO DELLA DURATA IN TICS DELLA LEGATURA DI VALORE
	//OGNI VOLTA CHE VIENE ATTIVATA UNA NOTA VIENE DISATTIVATA
	//SOLO DOPO QUESTO tempolegatura  CHE PUO' DURARE ANCHE
	//PIU' DI UNA BATTUTRA
	int f;
	//FLAG CHE SERVE PER SAPERE SE DALLA FIGURA ACCORDO IN QUESTIONE PARTE ALMENO
	//UNA LEGATURA DI VALORE CON UNA FIGURA SUCCESSIVA.
	int flaglegatura;
	//FLAG CHE VALE->   ALTEZZA MIDI DELLA NOTA (IN CHIAVE DI SOL) SE LA LEGATURA PRECEDENTE ARRIVA DA
	//                  UNA NOTA SINGOLA.
	//                  -2 SE LA LEGATURA PRECEDENTE ARRIVA DA UNA NOTA CHE FA PARTE DI UN ACCORDO.
	//                  -1 SE NON C'E' LEGATURA PRECEDENTE. 
	int flaglegacc[10];
	//VETTORE DI 10 FLAG (10 SONO LE POX NOTE DI UN ACCORDO) OGNUNO DEI QUALI VALE -1 SE LA NOTA
	//DELL'ACCORDO NON E' LEGATA, ALTRIMENTI VALE L'ALTEZZA DELLA NOTA LEGATA.
	int indaccordo;
	//INDICE DEL VETTORE DI CUI SOPRA.
	int num;
	int denom;
	//TENGONO IL NUMERATORE E DENOMINATORE DEL TEMPO DELLA BATTUTA
	int flagfinelista;
	//FLAG CHE SERVE PER GESTIRE IL FATTO CHE IN  PRESENZA DI GRUPPI
	//IRREGOLARI (IL GETDURATA() DI FIGURA ANCORA NON RENDE IL VALORE 
	//ESATTO) LA SOMMA DELLE FIGURE IN UNA BATTUTA PUO' ECCEDERE IL TEMPO
	//DI BATTUTA...IN TALE CASO VIENE POSTO TALE FLAG A 1 E SI PASSA
	//ALLA SCANSIONE DELLA BATTUTA SUCCESSIVA SALTANDO LE FIGURE
	//IN ECCESSO.
	//************************************************************************
	
	void SetFlagPrevKeySign(tipoArmaturaChiave Archiave);
		
	Nota *StartTieNote;
		
	MEVT_EXTRA_INFO* Get_p_evt_info(){return &evt_info;}
};


class MoodsSequencerWrite : public MoodsMidiWrite
{

// attributes

	Midi_sequencer* p_seq;
	bool found_tempo;

// private functions

	void noteon(BYTE channel, BYTE pitch, BYTE velocity);
	void noteoff(BYTE channel, BYTE pitch, BYTE velocity);
	
public :

// public interface

	MoodsSequencerWrite(Midi_sequencer* _p_seq);
	
	// overriding functions

	void tempo(DWORD _tempo);
};	  

/////////////////////////////////////////////////