#include "orchestrationdlg.hpp"
#include "wx/listimpl.cpp"
#include "spa/spartito.hpp"
#include "mdo/midiparamvoice.hpp"




#define LIST_TAB 1

#define WIDTH	620	//650 per 1600
#define HEIGHT	720	//750 per 1600
#define FATT	0.75

BEGIN_EVENT_TABLE(MidiOrchDlg, wxDialog)
		EVT_BUTTON(SWITCHSLIDERS, MidiOrchDlg::OnChangeGroupOfSlider)
		EVT_BUTTON(RESETMUTEANDSOLO, MidiOrchDlg::OnResetMandS)
		EVT_BUTTON(OKBUTTON, MidiOrchDlg::OnOk)
		EVT_BUTTON(CANCELBUTTON, MidiOrchDlg::OnCancel)
		EVT_COMMAND_RANGE(SLIDERVOLUME,SLIDERVOLUME+16, wxEVT_COMMAND_SLIDER_UPDATED, MidiOrchDlg::OnSliderMoving)
		EVT_COMMAND_RANGE(MUTEBUTTON, MUTEBUTTON+15, wxEVT_COMMAND_BUTTON_CLICKED, MidiOrchDlg::OnMuting)
		EVT_COMMAND_RANGE(MUTEBUTTON, SOLOBUTTON+15, wxEVT_COMMAND_BUTTON_CLICKED, MidiOrchDlg::OnSolo)
		EVT_CLOSE(MidiOrchDlg::OnCancel)
END_EVENT_TABLE()

MidiOrchDlg::MidiOrchDlg(wxWindow *parent, const wxString& title ,const wxWindowID id, const wxPoint& pos ,
            const wxSize& size, long style):
        wxDialog(parent, id, title, pos, size, style) 
{
	scale=1;
	int height, width;
	wxDisplaySize(&width, &height);
	if(width<1024)
		scale = FATT;
	SetSize(WIDTH,(HEIGHT-10)*scale);
/*	wxColourDatabase col(wxKEY_STRING);
	col.Initialize();
	wxColour *color = col.FindColour("BLACK");
	SetBackgroundColour(*color);
	SetForegroundColour(*wxGREEN);*/
//Istruzioni per abilitare la bitmap di sfondo	
//	panel = new wxBitmap("ID_WOOD");
//	stcBmp = new wxStaticBitmap(this,-1,*panel,wxDefaultPosition,wxSize(650,750));
	stcBmp=this;
	
	volume[32]=0;
	for(int i=0; i<32; i++)
	{
		volume[i]=0;
		mute_status[i]=false;
		solo_status[i]=false;
	}
	Init();
	
//	Centre();
	
};
	
MidiOrchDlg::~MidiOrchDlg()
{
	if (tab!=NULL)
		delete tab;
	if (controlPanel!=NULL)
		delete controlPanel;
	if (master!=NULL)
		delete master;
	if(resetMandS!=NULL)
		delete resetMandS;
	if(group2ofslider!=NULL)
		delete group2ofslider;
	
	for(int i=0; i<17; i++)
	{
		if(mixer[i]!=NULL)
			delete mixer[i];
	}

	for(i=0; i<16; i++)
	{
		if(mute[i]!=NULL)
			delete mute[i];
		if(solo[i]!=NULL)
			delete solo[i];
		if(track[i]!=NULL)
			delete track[i];
	}

	for(i=0; i<10; i++)
	{
		if(indic_dinamic[i]!=NULL)
			delete indic_dinamic[i];
		if(dinamictxt[i]!=NULL)
			delete dinamictxt[i];
	}

	if(dinamiche!=NULL)
		delete dinamiche;
	if(ok_button!=NULL)
		delete ok_button;
	if(canc_button!=NULL)
		delete canc_button;

};
/*
void MidiOrchDlg::OnLeftClick(wxListEvent& event)
{
	wxString tmp;
	tmp=tab->GetItemText(event.m_itemIndex);
	wxMessageBox(tmp);
}*/


void MidiOrchDlg::Init()
{	
	
	//Se si usa la bitmap di sfondo va linkato a stcBmp
	int h, w, i;
	float fatt;
	GetSize(&w, &h);
	
	if(scale==1)
		fatt=1;
	else
		fatt=0.5;

	wxSize Listsize(605,(float )h /3*fatt);
//	wxColourDatabase col(wxKEY_STRING);
//	col.Initialize();
//	wxColour *color = col.FindColour("YELLOW GREEN");
	tab = new ListCtrl(stcBmp, LIST_TAB, wxPoint(5,5), Listsize, wxLC_REPORT); 
	//tab->SetBackgroundColour(*wxBLACK); //Da abilitare per ripristinare la radica
	//tab->SetForegroundColour(*wxGREEN); //Da abilitare per ripristinare la radica
	//tab->Refresh();
	
	tab->InsertColumn(0, "Trk");
	tab->InsertColumn(1, "Mute");
	tab->InsertColumn(2, "Track Name");
	tab->InsertColumn(3, "Instrument"); // , wxLIST_FORMAT_LEFT, 140);
    tab->InsertColumn(4, "Channel"); // , wxLIST_FORMAT_LEFT, 140);
     // , wxLIST_FORMAT_LEFT, 140);
	
	controlPanel = new wxStaticBox(this,-1, "Mixer", wxPoint(5,(float )h/3*fatt+10),wxSize(605,h/3*1/scale+10));
	

	mixer[0] = new wxSlider(stcBmp, SLIDERVOLUME, 127, 0, 127, wxPoint(40,(float )(h/3)*fatt+50), wxSize(20,30), wxSL_VERTICAL  | wxSL_LABELS);
	for(i=1; i<17; i++)
	{
		mixer[i] = new wxSlider(stcBmp, SLIDERVOLUME+i, 0, 0, 127, wxPoint(75+i*30,(float )(h/3)*fatt+50), wxSize(20,30), wxSL_VERTICAL | wxSL_LABELS);
		
	}
	wxString name;
	for(i=0; i<16; i++)
	{
		mute[i] = new CtrlButton(stcBmp, MUTEBUTTON+i, "M",wxPoint(75+(i+1)*30,(float)(h/3)*fatt+200),wxSize(20,20), ID_MUTE);
		solo[i]	= new CtrlButton(stcBmp, SOLOBUTTON+i, "S",wxPoint(75+(i+1)*30,(float)(h/3)*fatt+230),wxSize(20,20), ID_SOLO);
		mute[i]->SetBackgroundColour(*wxLIGHT_GREY);
		solo[i]->SetBackgroundColour(*wxLIGHT_GREY);
		mute[i]->SetForegroundColour(*wxBLACK);
		solo[i]->SetForegroundColour(*wxBLACK);
		name.sprintf("T%d",i+1);
		mute[i]->SetName(name);
		track[i] = new wxStaticText(this,-1,"",wxPoint(105+i*30,(float)(h/3)*fatt+30),wxSize(25,15));
		track[i]->SetLabel(name);
		name.Clear();
			
	}
	master = new wxStaticText(this,-1,"Master Volume",wxPoint(20,(float)(h/3)*fatt+30),wxSize(80,15));
	group2ofslider = new wxButton(stcBmp, SWITCHSLIDERS, "17-->32",wxPoint(20,(float)(h/3)*fatt+200),wxSize(50,20));
	group2ofslider->SetBackgroundColour(*wxLIGHT_GREY);
	group2ofslider->SetForegroundColour(*wxBLACK);
	
	resetMandS = new wxButton(stcBmp, RESETMUTEANDSOLO, "Play All",wxPoint(20,(float)(h/3)*fatt+230),wxSize(50,20));
	resetMandS->SetBackgroundColour(*wxLIGHT_GREY);
	resetMandS->SetForegroundColour(*wxBLACK);
	grp2status=false;

	tab->SetColumnWidth(2, 200);
	tab->SetColumnWidth(0, 30);
	tab->SetColumnWidth(1, 60);
	tab->SetColumnWidth(3, 200);
	tab->SetColumnWidth(4, 80);

	int din_y=(h/3*fatt+20+h/3*1/scale);//(2*h/3) valore per y in point
	int correcy=0;
	if (fatt!=1) correcy=30;
	dinamiche = new wxStaticBox(this,-1, "Dynamic Settings", wxPoint(5,din_y),wxSize(605,(h/4)-45+correcy)); 
	wxString din[10]= {"PPPP","PPP","PP", "P", "MP", "MF", "F", "FF", "FFF","FFFF"};
	int value[10] = { 10, 20, 30, 40, 50, 60, 70, 80, 90, 100};
	
	int offset = 0;
	if (scale==1)
		offset = 5;
	for(i=0; i<5; i++)
	{
		indic_dinamic[i] = new wxSlider(stcBmp, -1, value[i], 0, 100, wxPoint(75+50,din_y+i*20+15+offset), wxSize(30,20), wxSL_HORIZONTAL | wxSL_LABELS );
		dinamictxt[i] = new wxStaticText(stcBmp,-1,"",wxPoint(35+50,din_y+i*20+18+offset),wxSize(30,15));
		indic_dinamic[i+5] = new wxSlider(stcBmp, -1, value[i+5], 0, 100, wxPoint(350+50,din_y+i*20+15+offset), wxSize(30,20), wxSL_HORIZONTAL | wxSL_LABELS );
		dinamictxt[i+5]= new wxStaticText(stcBmp,-1,"",wxPoint(315+50,din_y+i*20+18+offset),wxSize(30,15));
		dinamictxt[i]->SetLabel(din[i]);
		dinamictxt[i+5]->SetLabel(din[i+5]);
				
	}
	if (fatt!=1) correcy=15;
	ok_button = new wxButton(stcBmp,OKBUTTON, "OK", wxPoint(635/2-180, h-75+correcy), wxSize(80,25));
	canc_button = new wxButton(stcBmp,CANCELBUTTON, "Cancel", wxPoint((635/2+100), h-75+correcy), wxSize(80,25));


}

void MidiOrchDlg::OnSolo(wxCommandEvent &event)
{
	long index;
	int i=event.GetId()-SOLOBUTTON;
	if(!grp2status)
		index = i;
	else
		index =i+16;
	CtrlButton *solotmp = solo[i];
	CtrlButton *mutetmp = mute[i];
	Colore colour;
	if (solotmp!=NULL)
		if(solotmp->IsPressed())
		{
		
			solotmp->SetPressed(false);
		
			tab->SetItem(index,1,"Play");
			
		}
		else
		{
		
			solotmp->SetPressed(true);
			mutetmp->SetPressed(false);
			solo_status[index]=true;
			mute_status[index]=false;
			for(i=0; i<16; i++)
			{
				if(!solo_status[i])
				{
					mute_status[i]=true;
					tab->SetItem(i,1,"Mute");
					if(!grp2status)
						mute[i]->SetPressed(true);
					
				}
				if(!solo_status[i+16])
				{
					mute_status[i+16]=true;
					tab->SetItem(i+16,1,"Mute");
					if(grp2status)
						mute[i]->SetPressed(true);
				}
				
			}
			
			
		
			tab->SetItem(index,1,"Solo");
			
		
		}

}

void MidiOrchDlg::OnSliderMoving(wxCommandEvent &event)
{
	long index;
	int i=event.GetId()-SLIDERVOLUME;
	
	if(!grp2status)
		index = i;
	else
		index =i+16;
	volume[index]=mixer[i]->GetValue();

}

void MidiOrchDlg::OnResetMandS()
{
	for(int i=0; i<16; i++)
	{
		mute_status[i]=false;
		solo_status[i]=false;
		mute_status[i+16]=false;
		solo_status[i+16]=false;
		tab->SetItem(i,1,"Play");
		tab->SetItem(i+16,1,"Play");
		//aggiornare lo stato delle voci
	}
	UpdateCtrlButton();
	
}

void MidiOrchDlg::OnMuting(wxCommandEvent &event)
{
	long index;
	int i=event.GetId()-MUTEBUTTON;
	if(!grp2status)
		index = i;
	else
		index =i+16;
	CtrlButton *muting = mute[i];
	CtrlButton *assolo = solo[i];
	Colore colour;
	if (muting!=NULL)
		if(muting->IsPressed())
		{
		
			muting->SetPressed(false);
			tab->SetItem(index,1,"Play");
		}
		else
		{
	
			muting->SetPressed(true);
			assolo->SetPressed(false);
			solo_status[i]=false;
			mute_status[i]=true;
			tab->SetItem(index,1,"Mute");
		
		}
}

void MidiOrchDlg::OnChangeGroupOfSlider(wxCommandEvent &event)
{
	
	int start, i;
	wxString name;
	if(!grp2status)
	{
		start=17;
		group2ofslider->SetLabel("1-->16");
		grp2status=!grp2status;
		UpdateSlider();
		UpdateCtrlButton();
	}
	else
	{
		start=1;
		group2ofslider->SetLabel("17-->32");
		grp2status=!grp2status;
		UpdateSlider();
		UpdateCtrlButton();
	}
	for(i=0; i<16; i++)
		{
			
			name.sprintf("T%d",i+start);
			track[i]->SetLabel(name);
			name.Clear();
				
		}

}

void MidiOrchDlg::UpdateSlider()
{
	if(!grp2status)
	{
		for(int i=0; i<16; i++)
		{
			mixer[i+1]->SetValue(volume[i+1]);
		}

	}
	else
	{
		for(int i=0; i<16; i++)
		{
			mixer[i+1]->SetValue(volume[i+17]);
		}
	}
}

void MidiOrchDlg::UpdateCtrlButton()
{
	int offset;
	if(!grp2status)
		offset=0;
	else
		offset=16;
	for(int i=0; i<16; i++)
		{
			mute[i]->SetPressed(mute_status[i+offset]);
			solo[i]->SetPressed(solo_status[i+offset]);
		}
}


void MidiOrchDlg::SetData(Partitura *partitura)
{
	Spartito *tmp;
	wxString buf;
	
	int i;

	pPart=partitura;

	tmp=pPart->GetFirstSpa();
	i=0;
	while(tmp!=NULL)
	{
		if(tmp->IsVisible())
		{
			buf.Clear();
			long idx = tab->InsertItem(i, wxString::Format(_T("%d"),i+1));
			//tab->SetItemData(idx, i*i);
			tab->SetItemData(idx, (long) tmp);

			buf.Printf(_T("Play"));
			tab->SetItem(i, 1, buf);

			buf.Printf("%s",tmp->GetNome());
			if(buf.IsEmpty())
				buf.Printf("(None)");
		
			tab->SetItem(i, 2, buf);
			buf = tmp->GetMidiAttrib()->Get_Instrument();
			if(buf.IsEmpty() && tmp->GetMidiAttrib()->Get_MidiCode()==-1)
				buf.Printf("(None)");
			else
				buf=tab->GetInstrChoice()->GetString(tmp->GetMidiAttrib()->Get_MidiCode()+1);
			tab->SetItem(i,3,buf);
			buf.Clear();
			buf.sprintf("Ch. %d", tmp->GetMidiAttrib()->Get_Channel());
			tab->SetItem(i,4,buf);
			volume[i+1]=tmp->GetMidiAttrib()->Get_Volume();
			solo_status[i] = tmp->GetMidiAttrib()->Get_Solo();
			if(solo_status[i])
				tab->SetItem(i,1,"Play");
			mute_status[i] = tmp->GetMidiAttrib()->Get_Muting();
			if(mute_status[i])
				tab->SetItem(i,1,"Mute");
			
			i++;	
		}
		tmp=pPart->GetNextSpa(tmp);
		
    }
	for(i=0; i<10; i++)
		indic_dinamic[i]->SetValue(pPart->GetListaSpa()->GetMidiDinamicIndValue(i));

	UpdateSlider();
	UpdateCtrlButton();
}

void MidiOrchDlg::OnOk()
{
	Midi_ParamVoice tmpMidiAtt;
	Spartito *tmp;
	wxListItem item;
	wxString channel, str_tmp;
	long ch, code;
//	long num;

	item.m_mask=wxLIST_MASK_TEXT;
	for(int i=0; i<tab->GetItemCount(); i++)
	{
		item.m_col=3;
		item.m_itemId=i;
		tab->GetItem(item);
		str_tmp = item.m_text.Before('(');
		tmpMidiAtt.Set_Instrument(str_tmp);
		str_tmp = item.m_text.AfterFirst('(');
		str_tmp.Replace("(","");
		str_tmp.Replace(")","");
		str_tmp.ToLong(&code);
		tmpMidiAtt.Set_MidiCode((int) code - 1);
		tmpMidiAtt.Set_Volume(volume[i+1]);
		item.m_col=4;
		tab->GetItem(item);
		channel = item.m_text;
		channel.Replace("Ch. ","");
		channel.ToLong(&ch);
		tmpMidiAtt.Set_Channel((int) ch);
		tmpMidiAtt.Set_Muting(mute_status[i]);
		tmpMidiAtt.Set_Solo(solo_status[i]);
		tmpMidiAtt.Set_TrackNumber(i);
		/*
		item.m_col=0;
		tab->GetItem(item);
		str_tmp.Clear();
		str_tmp = item.m_text;
		str_tmp.ToLong(&num);

		tmp = pPart->GetSpartNum((int) (num-1));*/
		tmp = (Spartito *) tab->GetItemData(i);
		tmp->SetMidiAttrib(&tmpMidiAtt);
	}
	for(i=0; i<10; i++)
		pPart->GetListaSpa()->SetMidiDinamicIndValue(i,indic_dinamic[i]->GetValue());
	
	EndModal(wxID_OK);
}

void MidiOrchDlg::OnCancel()
{
	EndModal(wxID_CANCEL);
}

/****************************************************************************************************/
BEGIN_EVENT_TABLE(ListCtrl, wxListCtrl)
	EVT_RIGHT_DOWN(ListCtrl::OnEditItem)
	EVT_LEFT_DOWN(ListCtrl::OnLeftDown)
	EVT_CHOICE(INSTRUMENTCHOICE, ListCtrl::OnInstrSelected)
	EVT_CHOICE(CHANNELCHOICE, ListCtrl::OnChanSelected)
		
END_EVENT_TABLE()


ListCtrl::ListCtrl(wxWindow *parent, const wxWindowID id, const wxPoint& pos, const wxSize& size, int style)
:wxListCtrl(parent, id, pos, size, style)
{
	
wxString gmprogname[129] ={"(None)","Acoustic Grand Piano","Brite Acoustic Piano", "Electric Grand Piano", "Honkey-tonk Piano", "Electric Piano 1", "Electric Piano 2", "Harpsichord",
  "Clavi", "Celesta", "Glockenspiel", "Music Box", "Vibraphone", "Marimba", "Xylophone", "Tubular Bells", "Dulcimer", "Drawbar Organ", "Percussive Orgn",
  "Rock Organ", "Church Organ", "Reed Organ", "Accordion", "Harmonica", "Tango Accordion", "Nylon Guitar", "Steel Guitar", "Jazz Guitar", "Clean Guitar",
  "Mute Guitar", "Overdriven Guitar", "Distortion Guitar", "Harmnics Guitar", "Acoustic Bass", "Finger Bass", "PickBass", "Fretless", "SlapBas1", "SlapBas2",
  "SynBass1", "SynBass2", "Violin", "Viola", "Cello", "Contrabass", "Tremolo String", "Pizzicato", "Harp", "Timpani", "Ensamble 1", "Ensamble 2", "Syn String 1",
  "Syn String 2", "Aah Choir", "Ooh Choir", "Syn Choir", "OrchHit", "Trumpet", "Trombone", "Tuba", "Mute Trumpet", "French Horn", "Brass Section", "Syn Brass 1",
  "Syn Brass 2", "Soprano Sax", "Alto Sax", "Tenor Sax", "Baritone Sax", "Oboe", "English Horn", "Bassoon", "Clarinet", "Piccolo", "Flute", "Recorder", "Pan Flute",
  "Bottle", "Shakhchi", "Whistle", "Ocarina", "Square Lead", "Saw Lead", "Caliope Lead", "Chiff Lead", "Charan Lead", "Voice Lead", "Fifth Lead", "Bass & Lead",
  "NewAge Pad", "Warm Pad", "PolySyn Pad", "Choir Pad", "Bowed Pad", "Metal Pad", "Halo Pad", "Sweep Pad", "Rain", "SoundTrk", "Crystal", "Atmosphere", "Bright",
  "Goblin", "Echoes", "SciFix", "Sitar", "Banjo",  "Shamisen", "Koto", "Kalimba", "Bagpipe", "Fiddle", "Shanai", "TnklBell", "Agogo", "Steel Drum", "WoodBlok",
  "Taiko Drum", "Melodic Tom",  "Synth Tom", "RevCymbl", "FretNoiz", "BrthNoiz", "Seashore", "Tweet", "Telphone", "Helicopter", "Applause", "Gunshot" };

	wxString channelstr[16];
	wxString number;
	for(int i=0; i<16; i++)
		channelstr[i].sprintf("Ch. %d",i);
	for(i=1; i<129; i++)
	{	
		number.Clear();
		number.Printf(" (%d)",i);
		gmprogname[i].Append(number);
	}

	instrument = new wxChoice(this, INSTRUMENTCHOICE, wxPoint(-1,-1),wxSize(-1,-1), 129, gmprogname);
	instrument->SetForegroundColour(*wxBLACK);
	instrument->Show(false);

	channel = new wxChoice(this, CHANNELCHOICE, wxPoint(-1,-1),wxSize(-1,-1),16, channelstr);
	channel->SetForegroundColour(*wxBLACK);
	channel->Show(false);
}




ListCtrl::~ListCtrl()
{
	if(instrument!=NULL)
		delete instrument;

	if(channel!=NULL)
		delete channel;
}

void ListCtrl::OnEditItem(wxMouseEvent &event)
{
	wxPoint point = event.GetPosition();
	wxPoint item_point;
	wxRect item_bound;
	
	int flag=wxLIST_HITTEST_ONITEM;
	long index = HitTest(point,flag);
	//long index = FindItem(-1, point,flag);
	if(index==-1)
		return;
	int x_instr_col = GetColumnWidth(0) + GetColumnWidth(1) + GetColumnWidth(2);
	int x_max_instr_col = x_instr_col + GetColumnWidth(3);
	int x_max_channel_col = x_max_instr_col + GetColumnWidth(4);
	GetItemPosition(index,item_point);
	GetItemRect(index, item_bound, wxLIST_RECT_LABEL);
	if(point.x>=x_instr_col && point.x<=x_max_instr_col)
	{
		
		if(!channel->IsShown())
		{
			if(!instrument->IsShown())
			{
				int w = GetColumnWidth(3);
				int y=item_point.y;
				if(index!=0)
					y=y-2;
				itemSelected = index;
				instrument->SetSize(x_instr_col,y,w,8);
				
				instrument->Show(true);
			}
		}
	}

	if(point.x>x_max_instr_col && point.x<=x_max_channel_col)
	{
		
		if(!instrument->IsShown())
		{
			if(!channel->IsShown())
			{
				int w = GetColumnWidth(4);
				int y=item_point.y;
				if(index!=0)
					y=y-2;
				itemSelected = index;
				channel->SetSize(x_max_instr_col,y,w,20);
				
				channel->Show(true);
			}
		}
	}
}

void ListCtrl::OnLeftDown(wxMouseEvent &event)
{
	wxPoint point = event.GetPosition();
	int x1, y1, x2, y2, w, h;

		if(channel->IsShown())
		{
			channel->GetPosition(&x1, &y1);
			channel->GetClientSize(&w,&h);
			x2=x1+w;
			y2=y1+h;
			if((point.x<x1 || point.x>x2) || (point.y<y1 || point.y>y2))
				channel->Show(false);
		}

		if(instrument->IsShown())
		{
			instrument->GetPosition(&x1, &y1);
			instrument->GetClientSize(&w,&h);
			x2=x1+w;
			y2=y1+h;
			if((point.x<x1 || point.x>x2) || (point.y<y1 || point.y>y2))
				instrument->Show(false);
		}
	
}

void ListCtrl::OnInstrSelected()
{
	//update value
	if(instrument->IsShown())
	{
		SetItem(itemSelected,3,instrument->GetStringSelection());
	
	
		instrument->Show(false);
		
	}
}

void ListCtrl::OnChanSelected()
{
	if(channel->IsShown())
	{
		SetItem(itemSelected,4,channel->GetStringSelection());
		
		channel->Show(false);
		
	}
}

wxChoice *ListCtrl::GetInstrChoice()
{
	return instrument;
}


/****************************************************************************************************/

CtrlButton::CtrlButton(wxWindow *parent, const wxWindowID id, const wxString& label, const wxPoint& pos,
			   const wxSize& size, int ID):
			   wxButton(parent, id, label, pos, size)
{
	pressed=false;
	IDButton=ID;

}

CtrlButton::~CtrlButton()
{

}

bool CtrlButton::IsPressed()
{
	return pressed;
}

void CtrlButton::SetPressed(bool status)
{
	Colore colour;
	
		if(!status)
		{
			colour.Set(0,0,0);
			SetForegroundColour(colour);
			
		}
		else
		{
			switch(IDButton)
			{
			case ID_MUTE:
				colour.Set(255,0,0);
				break;
			case ID_SOLO:
				colour.Set(0,255,0);
				break;
			}
			SetForegroundColour(colour);
			
		}
	
	pressed=status;

}


