/* $Id: orchestrationdlg.hpp,v 1.1.2.2 2002/01/23 13:43:09 ivanb Exp $ */

/*
 * Progetto......: WedelMusic
 * Modulo........: mdo
 * File..........: orchestrationdlg.hpp
 * Autore........: Ivan Bruno (IB)
 * Data revisione: 14/12/2001
 * Descrizione:
 *   Definizione classe Orchestrazione Midi
 */
#include "wx/wx.h"
#include "wx/listctrl.h"
#include "wx/slider.h"
#include "wx/list.h"
#include "wx/choice.h"
#include "wx/spinctrl.h"
#include "par/partitur.hpp"



#define RESETMUTEANDSOLO 9999
#define SWITCHSLIDERS 10000

#define MUTEBUTTON		10001
#define SOLOBUTTON		10100
#define OKBUTTON		10200
#define CANCELBUTTON	10201
#define SLIDERVOLUME	10300


#define ID_MUTE 0
#define ID_SOLO 1
#define ID_ALL	2

#define INSTRUMENTCHOICE	9900
#define CHANNELCHOICE		9990




class CtrlButton: public wxButton
{
protected:
	bool pressed;
	int IDButton;

public:
	CtrlButton(wxWindow *parent, const wxWindowID id, const wxString& label, const wxPoint& pos,
            const wxSize& size, int ID);

	~CtrlButton();
	bool IsPressed();
	void SetPressed(bool);

};

class ListCtrl: public wxListCtrl
{
protected:
	wxChoice *instrument;
	wxChoice *channel;

	int itemSelected;

	void OnEditItem(wxMouseEvent &event);
	void OnLeftDown(wxMouseEvent &event);

	void OnInstrSelected();
	void OnChanSelected();



public:
	ListCtrl(wxWindow *parent, const wxWindowID id, const wxPoint& pos, const wxSize& size, int style);
	~ListCtrl();
	wxChoice *GetInstrChoice();


	DECLARE_EVENT_TABLE()
};



class MidiOrchDlg: public wxDialog
{
protected:
	ListCtrl *tab;
	wxSlider *mixer[17];
	CtrlButton *mute[16];
	CtrlButton *solo[16];
	wxStaticText *track[16];
	wxStaticText *master;
	wxStaticBox *controlPanel;
	wxButton *group2ofslider;
	wxButton *resetMandS;
	bool grp2status;
	wxSlider *indic_dinamic[10];
	wxStaticBox *dinamiche;
	wxStaticText *dinamictxt[10];
	wxButton *ok_button;
	wxButton *canc_button;
	//wxStaticBitmap *stcBmp;
	//wxBitmap *panel;
	wxWindow *stcBmp;
	Partitura *pPart;
	int volume[33];
	bool mute_status[32];
	bool solo_status[32];
	float scale;	


	void Init();

	
	void OnMuting(wxCommandEvent &event);
	void OnSolo(wxCommandEvent &event);
	void OnSliderMoving(wxCommandEvent &event);
	void OnChangeGroupOfSlider(wxCommandEvent &event);
	void OnResetMandS();
	void OnOk();
	void OnCancel();
	
	


public:
	MidiOrchDlg(wxWindow *parent, const wxString& title = "Midi Orchestration" ,const wxWindowID id=-1, const wxPoint& pos = wxDefaultPosition,
            const wxSize& size = wxDefaultSize, long style=wxDEFAULT_DIALOG_STYLE);
	
	~MidiOrchDlg();

	
	void SetData(Partitura *partitura);
	void UpdateSlider();
	void UpdateCtrlButton();




	DECLARE_EVENT_TABLE()
};


