/*
 * Progetto......: LIOO
 * Modulo........: MDO
 * File..........: suona.cpp
 * Autore........: PONTICELLI MAZZOCCHI
 * Data revisione: 04/06/96
 * Descrizione:
 *   Implementazione FUNZIONE VIRTUALE SUONA
 */
 
/* QUESTE RIGHE DI CODICE IMPLEMENTANO LE FUNZIONI SU0NA DI TUTTE LE CLASSI
*CHE NE FANNO USO */

 
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <fstream>
#include "par/partitur.hpp"
#include "par/listaspa.hpp"
#include "spa/spartito.hpp"
#include "spa/listabat.hpp"
#include "bat/battuta.hpp"
#include "bat/listafig.hpp"
#include "fig/figura.hpp"
#include "bat/chiave.hpp"
#include "mdo/trasposizione.hpp"
#include "alt/altecomp.hpp"
#include "fig/pausa.hpp"
#include "fig/ncroma.hpp"
#include "alt/alterazi.hpp"
#include "fig/nota.hpp"
#include "bat/tempo.hpp"
#include "sca/moviment.hpp"
#include "drw/tnumeric.hpp"
#include "sca/metronom.hpp"
#include "txt/tdinamic.hpp"
#include "txt/def_txt.hpp"
#include "mdo/moodsmidiwrite.hpp"

#include "mdo/orchestrationdlg.hpp"
#include "drw/frmanage.hpp"


#include "abb/tremolo.hpp"   
   
#define DUR_ACCIACCATURA 0.03



//****************************************************************************************************************************
/*La classe Partitura e' gia' piena in memoria.
  *Chiamando suona da export midi dentro partitur.cpp si arriva qui.
  *ListaSpa e' un attributo di partitura.
  *ListaSpa.Suona si aggancia alla funzione suona della ListaSpa in memoria 
 */
 
 
  
bool Partitura::Suona(MoodsMidiWrite * mmw)           
{
#ifdef WX226
	int k;
	Spartito *tmp;
	bool callMidiDlg=true;

	mmw->flaglegatura=-1;
	for (k=0; k<10; k++)
	{
		mmw->flaglegacc[k]=-1;
	}   

	mmw->ppqn=480;

	tmp=GetFirstSpa();
	while(tmp!=NULL)
	{
		if(tmp->IsVisible())
			callMidiDlg = (callMidiDlg && tmp->GetMidiAttrib()->IsReady());
		tmp = GetNextSpa(tmp);
	}

	if(!callMidiDlg)
	{
		MidiOrchDlg dialog(FrameManager::currFrame);//,"Midi Orchestration",-1,wxDefaultPosition, wxSize(750,800),-1); //,wxDEFAULT_DIALOG_STYLE);
		dialog.SetData(this);
		if(dialog.ShowModal()==wxID_CANCEL)
			return false;
	}

	mmw->orchestrazione(this);
	if(listaSpa->Suona(mmw))
		return true;
	else
#endif
		return false;    
}

//*******************************************************LISTA SPARTITI*******************************************************
/*La classe ListsSpartiti e' gia' piena in memoria.
 *Con current=first punto al primo spartito della lista.
 *Si scorrono tutti gli spartiti e con getspart->Suona ci si aggancia alla parte di memoria che 
 *contiene lo spartito attuale. 
 */



bool ListaSpartiti::Suona(MoodsMidiWrite * mmw)
{
#ifdef WX226
  unsigned long numspa;
  
  numspa=GetNumObj(); 
  int ppqnn, tot;
//  unsigned int k;
  Spartito *SPtr, *SPtr_4trk0=NULL;


  mmw->numerospartiti= numspa;
  //c//out << mmw->numerospartiti;   
 // mmw->firs2 = NULL;
  mmw->flagfaimidi=0;
  mmw->indice=0;

 
  if (mmw->flagfaimidi==0)
  {
	  
	  tot=0;
 
	  mmw->firs1 = mmw->firs2;
	  //Questo pezzo serve a calcolare quanti sono gli spartiti da suonare
	  Node *current=first;
	  
	  while(current!=NULL)
	  {
		  SPtr = (Spartito*) current->ObjectPtr;
		  if(SPtr->IsVisible())
		  {
			if ((mmw->firs1->valore !=16) && mmw->orchestra[mmw->firs1->valore][1]!=0)
			{ 
				//SPtr = (Spartito*) current->ObjectPtr;
				tot = tot + 4*SPtr->GetNumberOfStaff();
				//tot++;
				if(SPtr_4trk0==NULL)
					SPtr_4trk0=SPtr;
			}
			mmw->firs1 = mmw->firs1->next; 
		  }
	      current = GetNext(current); 
	  }
		
	  
	  //*******************TESTATA DEL FILE MIDI*************************************************************************************
  
	    ppqnn=mmw->ppqn;
	  //mmw->head(1, 4*tot+1, ppqnn);       //NUMSPA+1 perche' ho la track0
		mmw->head(1, tot+1, ppqnn);
	  //*****************************************************************************************************************************
  
	  //Al primo giro si prende il primo spartito per la generazione della traccia 0
	  int i,j;

		mmw->setrack0=0; 
 		mmw->flagpolifonia=1; 
		current = first;
		mmw->firs1 = mmw->firs2;
		i=1;
        //SPtr = (Spartito*) current->ObjectPtr ;
	    mmw->spartitocorrente=i;
        mmw->track();
	    //SPtr->Suona(mmw);
		SPtr_4trk0->Suona(mmw);
        mmw->endtrack();
		SetPtrSpa4Midi(SPtr_4trk0);
		   	
/***********************************Fine Generazione Traccia 0*****************************************/
	  
	  
	  mmw->setrack0=1;
//	  for(j=1;j<=2;j++)   //SI SCORRE DUE VOLTE LA LISTA DI SPARTITI LA PRIMA VOLTA PER LA PRIMA VOCE POLIFONICA
							// =LISTAFIG1 E LA SECONDA PER LA SECONDA VOCE POLIFONICA 
//	  {
//			mmw->flagpolifonia=j; 
			current = first;
			mmw->firs1 = mmw->firs2;
			i=1;
			while (current)
			{
			  
			  SPtr = (Spartito*) current->ObjectPtr ;
			  if(SPtr->IsVisible())
			  {
				  mmw->spartitocorrente=i;
				  mmw->indice=mmw->firs1->valore;
				  mmw->firs1 = mmw->firs1->next;
				
				  if (((mmw->orchestra[mmw->indice][1]!=0) &&  (mmw->indice!=16)) )      
				  {
					int numstaff=SPtr->GetNumberOfStaff();
					for (j=1;j<=4*SPtr->GetNumberOfStaff();j++)
					{
						mmw->flagpolifonia=j;
						mmw->track();
						SPtr->Suona(mmw);
						mmw->endtrack();
					}
				  }
				  i++; 	
			  }
			  current = GetNext(current);   //la volta successiva successiva si scorre tutti gli spartiti (1 inc) per analizzare le note 
			                            
			}
	   //}      
	   return true; 
	 }
	 else
#endif
		 return false;
}






//***************************************************SPARTITO****************************************************************
/*La classe Spartito e' gia' piena in memoria.
 *Listabat e' un attributo di spartito e con listabat.suone ci si aggancia 
 *alla Lista battute di quello spartito
* GetStrumEsec e' una funzione di spartito che rende lo strumento a cui e' riferito quello spartito
 */

 void Spartito::Suona(MoodsMidiWrite * mmw)
 {
	 mmw->transpose=transpose;
	 listaBat.Suona(mmw); 
 }

//**************************************************LISTA BATTUTE**************************************************************
/*La classe ListaBattute e' gia' piena in memoria.
 *current =first serve per agganciarci alla prima battuta della lista.
 * BPtr = (Battuta*) current->ObjectPtr serve per andare dentro la battuta attuale
 */


 void ListaBattute::Suona(MoodsMidiWrite * mmw)
 {
	 Node *current, *nextnode;
	 Battuta *BPtr, *NextBPtr=NULL;
	 Figura *Fptr;
	 int count=0;
	 
	 
	 mmw->flagisaccordo=0;   //PONGO A ZERO IL FLAG CHE DICE CHE LA NOTA IN QUESTIONE NON FA PARTE DI UN ACCORDO
	 //TALE FLAG VIENE VARIATO DENTRO ACCORDO.SUONA()
	 //ALTRIMENTI SE NON CI SONO ACCORDI RIMANE ZERO PER TUTTE LA LISTA BATTUTE DI SPARTITO IN CORSO    
	 
	 current = first;
	 
	 if(mmw->setrack0==0) //modified by silvestre to implement the rendering of acciaccatura
	 {
		 while (current)
		 {
			 nextnode=GetNext(current);
			 BPtr = (Battuta*)current->ObjectPtr;
			 if(nextnode!=NULL){
				 NextBPtr = (Battuta*)nextnode->ObjectPtr;
			 }
			 if(NextBPtr!=NULL){
				 for (short i=0;i<12;i++){
					 if((NextBPtr->GetPLayer(i))!=NULL){
						 Fptr=(NextBPtr->GetPLayer(i))->GetFirstFig();
						 if(Fptr!=NULL){
							 Figura *parent =Fptr->GetParentFig();
							 (BPtr->GetPLayer(i))->SetFlagAcciaccatura(NULL);
							 (BPtr->GetPLayer(i))->SetNextAcciaccaturaLayer(NULL);
							 
							 if((Fptr->GetNotina())&&(parent && parent->GetID()==CL_GRUPPONOTE)||
								 ((Fptr->GetID()==CL_NCROMA) && (((NCroma*)Fptr)->GetAcciaccatura()))){
								 //qui posso settare un ptr apposito a figura che  diverso da null se la prima nota della battuta successiva 
								 // una acciaccatura
								 if (parent == NULL){
									 (BPtr->GetPLayer(i))->SetFlagAcciaccatura(Fptr);
									 //(BPtr->GetPLayer(i))->SetNextAcciaccaturaLayer(NextBPtr->GetPLayer(i));
								 }
								 else if ((parent && parent->GetID()==CL_GRUPPONOTE)){
									 (BPtr->GetPLayer(i))->SetFlagAcciaccatura(parent);
									 (BPtr->GetPLayer(i))->SetNextAcciaccaturaLayer(NextBPtr->GetPLayer(i));
									 
								 }
								 else{
									 (BPtr->GetPLayer(i))->SetFlagAcciaccatura(NULL);
									 (BPtr->GetPLayer(i))->SetNextAcciaccaturaLayer(NULL);
									 
								 }
								 
							 }
						 }
					 }				
				 }
			 }
			 BPtr->Suona(mmw);
			 current=nextnode;
		 }
		 return;
	 }
	 else if(mmw->setrack0==1)
	 {
		 while (current)
		 {
			 BPtr = (Battuta*) current->ObjectPtr ;
			 BPtr->Suona(mmw);
			 current = GetNext(current);
		 }
	 }	 
 }

//*******************************************BATTUTA***************************************************************************

/*La classe Battute e' gia' piena in memoria.
 *CPtr = GetChiave con questo comando si ottiene la chiave della battuta in memoria.
 *Archiave = GetArmatura si ottiene il numero da 1 a 14 di armatura di chiave . GetArmatura e' una funzione di Battuta
 *Anche GetChiave e' una funzione di Battuta
 *Getshift e Getaltezza sono delle funzioni di chiave che danno variazioni sull-armatura rispetto alla key di Violino
 * (GetID deve essere di DrawObject ma comunque usare CPtr->GetID rende un numero che si riferisce al tipo di chiave della battuta
 *ListaFig1 e 2 sono attributi di Battuta. Con listafigx.suona() si entra dentro la lista figure in memoria associata a quella battuta
 */



void Battuta::Suona(MoodsMidiWrite * mmw)
{
#ifdef WX226
	tipoArmaturaChiave Archiave;
	int num, denom,tnmetronomo=1, flag,j,strumento,volume;
	Tempo fraztempo;
	Movimento *MPtr;
	Metronomo *MEPtr;
	float valnotametron=0, tact3=0, bpmsemiminima=0 ; //tact3 e' il 3 param da passare a midiwrite tact
	TNumerico *TNPtr;
	unsigned long tics,b;

	b=NumProgress; 
	fraztempo=GetTempo();
	num=fraztempo.GetNumeratore();
	denom=fraztempo.GetDenominatore();
	mmw->num=num;
	mmw->denom=denom;

	mmw->Get_p_evt_info()->p_measure=this;
	start_ticks=mmw->Get_act_ticks();

	//**********************************METAEVENTI TRACCIA0********************************************************
	if (mmw->setrack0==0)
	{
		//Si ricava la notina nel metronomo e il colpo di metronomo

		if (b==1)
		{
			mmw->deltatimebattuta=0; 
			mmw->tempo1battuta1=0;
			mmw->tempo1battuta2=0;
			mmw->flagpolifonia=1;
			LayerVector[0]->Suona(mmw);
			mmw->tempo1battuta1=mmw->deltatimebattuta;
			mmw->deltatimebattuta=0;
			mmw->flagpolifonia=2;
			LayerVector[1]->Suona(mmw); 
			mmw->tempo1battuta2=mmw->deltatimebattuta;
			mmw->flagpolifonia=1;
			mmw->deltatimebattuta=0;

			for(int ind=2; ind<4; ind++)
			{	
				if(LayerVector[ind]!=NULL && !LayerVector[ind]->isEmpty())
					LayerVector[ind]->Suona(mmw);
			}

			if (mmw->tempo1battuta1<mmw->tempo1battuta2)
			{ 
				mmw->tempo1battuta1=mmw->tempo1battuta2;
			}
		}


		MPtr=GetPMovimento();
		if (MPtr)
		{
			MEPtr=MPtr->GetMetronomo();
			if (MEPtr)
			{
				valnotametron=MEPtr->GetValNota();
				tact3=(4*valnotametron)*24;
				TNPtr=MEPtr->GetTNumerico();
				if (TNPtr)
				{
					tnmetronomo=TNPtr->GetNumero();
					bpmsemiminima=(60000000*valnotametron)/(0.25*tnmetronomo);
				}
			}
		}

		//Si e' ora preso tutte le info temporali della battuta attuale**********************************************
		//****GENERIAMO LA TRACK0************************************************************************************
		flag=0; 
		if (b==1)
		{ 
			mmw->lastset.t0deltatime=0;
			if (tact3==0)
			{
				mmw->lastset.t0num=num;
				mmw->lastset.t0denom=denom;
				mmw->lastset.t0tact3=24;
				mmw->lastset.t0bpmsemiminima=500000; 

			}
			else
			{
				mmw->lastset.t0num=num;
				mmw->lastset.t0denom=denom;
				mmw->lastset.t0tact3=tact3;
				mmw->lastset.t0bpmsemiminima=bpmsemiminima;
		 }
			mmw->tact(mmw->lastset.t0num, mmw->lastset.t0denom, mmw->lastset.t0tact3, 8);
			mmw->tempo(mmw->lastset.t0bpmsemiminima);
		}
		if (b>1)
		{
			if ((num!=mmw->lastset.t0num | denom!=mmw->lastset.t0denom) && (tact3==0))
			{    	  
				mmw->lastset.t0num=num;
				mmw->lastset.t0denom=denom;
				flag=1;
		 }

			if ((num!=mmw->lastset.t0num | denom!=mmw->lastset.t0denom) && (tact3!=mmw->lastset.t0tact3)  && (tact3!=0))
			{    	  
				mmw->lastset.t0num=num;
				mmw->lastset.t0denom=denom;
				mmw->lastset.t0tact3=tact3;
				mmw->lastset.t0bpmsemiminima=bpmsemiminima;
				flag=1;
		 }

			if ((num==mmw->lastset.t0num && denom==mmw->lastset.t0denom) && (tact3!=mmw->lastset.t0tact3) && (tact3!=0))
			{    	  
				mmw->lastset.t0tact3=tact3;
				mmw->lastset.t0bpmsemiminima=bpmsemiminima;
				flag=1;
		 }
			if (flag==1)
		 {
			 flag=0;
			 mmw->time(mmw->lastset.t0deltatime);	  
			 mmw->tact(mmw->lastset.t0num, mmw->lastset.t0denom, mmw->lastset.t0tact3, 8);
			 mmw->tempo(mmw->lastset.t0bpmsemiminima);	
			 mmw->lastset.t0deltatime=0;
		 }
		}

		tics=mmw->ppqn*4*num/denom;
		mmw->lastset.t0deltatime=mmw->lastset.t0deltatime+tics;	 	  

	} 
	//*********************************************************************************************************** 

	//*****************ANDIAMO ORA A CREARE LE TRACCE MUSICALI (!=0)*********************************************             
	if (mmw->setrack0==1)
	{
		Archiave = GetArmatura(0);

		if (b==1)             //la prima battuta prendo sempre l'armatura di chiave
		{
			strumento = mmw->orchestra[mmw->indice][0];
			volume = mmw->orchestra[mmw->indice][1];    
			mmw->program(mmw->orchestra[mmw->indice][2],strumento);
			mmw->volume(mmw->orchestra[mmw->indice][2],volume);
			mmw->armaturadichiave=Archiave;
			mmw->key(Archiave,1);
		}   //APRO TRACCIA MUSICALE PER PRIMA VOCE POLIFONICA DI QUESTO SPARTITO}
		if (b>1 && mmw->armaturadichiave!=Archiave)  //per le battute successive riavvaloro l'armaturadichiave solo se e' cambiata
		{                                        //nella classe Moodsmidiwrite ho cosi' sempre il valore corretto dell'armat di chiave
			mmw->armaturadichiave=Archiave;
			mmw->key(Archiave,1);    
		}

		for (j=0;j<7;j++)
		{ mmw->flagprecalter[j]=0;}           //serve per mantenere le alterazioni di una nota precedente fino alla fine della battuta
		//cioe' se una nota ha la propria alterazione es do # allora fino alla fine della battuta
		// o fino a che non trovo un bequadro tutti i do (che nel moods ovviamente non ri-hanno
		// associata l'alterazione dato che vale la precedente) devono essere alterati 
		mmw->SetFlagPrevKeySign(Archiave);

		mmw->deltatimebattuta=0;

		if(LayerVector[mmw->flagpolifonia-1]!=NULL && !LayerVector[mmw->flagpolifonia-1]->isEmpty())
		{
			LayerVector[mmw->flagpolifonia-1]->Suona(mmw);
		}

		if ((mmw->deltatimebattuta<(mmw->ppqn*4*num/denom))  && (b>1))
		{
			mmw->time((mmw->ppqn*4*num/denom)-(mmw->deltatimebattuta));
		}  //serve per le 2 voci polifoniche se una battuta
		//non e' piena si aggiungono pause infondo.

		if (b==1)
		{
			if (mmw->deltatimebattuta < mmw->tempo1battuta1)
			{
				mmw->time((mmw->tempo1battuta1)-(mmw->deltatimebattuta));
			}
		}	         
	}
#endif
//**************************************************GENERATA TRACCIA MUSICALE****************************************
}

//*********************************************LISTAFIGURE************************************************************
/*Usare getnext e getfirstfig serve per visitare tutte le figure anche 
*internamente ai gruppi note
*Con Questi due comandi si riesce a entrare dentro la figura attuale in memoria
*/
void ListaFigure::Suona(MoodsMidiWrite * mmw)
{
#ifdef WX226
	Figura *FPtr, *NextFPtr, *AcciaccaturaPtr=NULL;//silvestre
	ClassID tipofigura;  
	TDinamicType  tempodinamico;
	TDinamico *PTdin;
	float durata_appoggiatura=0;

	int i;
	FPtr=GetFirstFig();
	NextFPtr=this->GetNextFigura(FPtr);//silvestre
	i=1;

	mmw->flagfinelista=0;

	while (FPtr)
	{

		while ((FPtr && FPtr->GetNotina())&&(NextFPtr && NextFPtr->GetNotina())){			
			FPtr=NextFPtr;
			NextFPtr=this->GetNextFigura(FPtr);//silvestre
		}

		tipofigura=FPtr->GetID();

		if ((tipofigura==65) && (mmw->flaglegatura>=0))
		{  mmw->time(mmw->tempolegatura);}

		if (mmw->setrack0==1)
		{

			tempodinamico = (TDinamicType) -1;     
			PTdin = FPtr->GetPTDinamico(); 
			if (PTdin)
			{ 
				tempodinamico = PTdin->GetTipo();
				mmw->volume(mmw->orchestra[mmw->indice][2],mmw->tempodinamico[tempodinamico%20]*127/100);
		 }
		}

		//nell'if di sotto non c' piu bisogno dell'acciaccatura
		//basta controllare se NextPtr  una acciaccatura o se  NULL controllare se in lista figure flagacciaccatura
		// diversa da NULL
		Figura *parent;
		if(NextFPtr!=NULL){
			parent =NextFPtr->GetParentFig();
		}
		if ((NextFPtr!=NULL)&&(NextFPtr->GetNotina())&&(parent && parent->GetID()==CL_GRUPPONOTE)||
			((NextFPtr!=NULL)&&(NextFPtr->GetID()==CL_NCROMA) && (((NCroma*)NextFPtr)->GetAcciaccatura()==True))){
			if (parent==NULL ){
				if((FPtr->GetID())==CL_ACCORDO){
					Node* current;
					Nota* NPtr;
					AcciaccaturaPtr=NextFPtr;
					float dur=FPtr->GetDurata();
					dur=dur-(DUR_ACCIACCATURA);
					FPtr->SetDurata(dur);
					current = ((Accordo*)FPtr)->first;
					while (current && (mmw->flagfinelista!=1)){

						NPtr=(Nota*)current->ObjectPtr;
						NPtr->SetDurata(dur);
						current = GetNext(current);
					}
				}
				else{
					AcciaccaturaPtr=NextFPtr;
					float dur=FPtr->GetDurata();
					dur=dur-(DUR_ACCIACCATURA);  
					FPtr->SetDurata(dur);
				}
			}
			else if ((parent && parent->GetID()==CL_GRUPPONOTE)){
				if((FPtr->GetID())==CL_ACCORDO){
					Node* current;
					Nota* NPtr;
					AcciaccaturaPtr=parent;
					float dur=FPtr->GetDurata();
					dur=dur-(DUR_ACCIACCATURA);
					FPtr->SetDurata(dur);
					current = ((Accordo*)FPtr)->first;
					while (current && (mmw->flagfinelista!=1)){
						NPtr=(Nota*)current->ObjectPtr;
						NPtr->SetDurata(dur);
						current = GetNext(current);
					}
				}
				else{
					AcciaccaturaPtr=parent;
					float dur=FPtr->GetDurata();
					dur=dur-(DUR_ACCIACCATURA); 
					FPtr->SetDurata(dur);
				}
			}
		}

		//qui devo mettere l'analogo per scavalcare la battuta
		if ((NextFPtr==NULL)&&(GetFlagAcciaccatura()!=NULL)){
			if((FPtr->GetID())==CL_ACCORDO){
				Node* current;
				Nota* NPtr;
				AcciaccaturaPtr=GetFlagAcciaccatura();
				float dur=FPtr->GetDurata();
				dur=dur-(DUR_ACCIACCATURA);
				current = ((Accordo*)FPtr)->first;
				while (current && (mmw->flagfinelista!=1)){
					NPtr=(Nota*)current->ObjectPtr;
					NPtr->SetDurata(dur);
					current = GetNext(current);
				}
			}
			else{
				AcciaccaturaPtr=GetFlagAcciaccatura();
				float dur=FPtr->GetDurata();
				dur=dur-(DUR_ACCIACCATURA); 
				FPtr->SetDurata(dur);
			}
		}
		if(FPtr->GetNotina())
		{
			Figura *parent =FPtr->GetParentFig();
			if(parent && parent->GetID()==CL_GRUPPONOTE){
				//deve fare l'acciaccatura del gruppetto
			}
			else if	(FPtr->GetID()!=CL_NCROMA){
				durata_appoggiatura=FPtr->SuonaAppoggiatura(mmw);
			}			
			else if ((FPtr->GetID()==CL_NCROMA) && (((NCroma*)FPtr)->GetAcciaccatura()==False)){
				durata_appoggiatura=FPtr->SuonaAppoggiatura(mmw);
			}
			else if ((FPtr->GetID()==CL_NCROMA) && (((NCroma*)FPtr)->GetAcciaccatura()==True)){
				//	FPtr->SuonaAsAcciaccatura(mmw);
			}
		}
		else if (FPtr->IsANote()){
			if(durata_appoggiatura!=0){
				FPtr->SuonaWithAppoggiatura(mmw,durata_appoggiatura);
				durata_appoggiatura=0;
			}
			else if (((Nota*)FPtr)->GetPAbbellimento()==NULL){	
				FPtr->Suona(mmw);
			}
			else if (((Nota*)FPtr)->GetPAbbellimento()->GetID()==CL_MSUPERIORE){
				FPtr->SuonaWithMordenteSuperiore(mmw);
			}
			else if (((Nota*)FPtr)->GetPAbbellimento()->GetID()==CL_MINFERIORE){
				FPtr->SuonaWithMordenteInferiore(mmw);
			}
			else if (((Nota*)FPtr)->GetPAbbellimento()->GetID()==CL_GSUPERIORE||((Nota*)FPtr)->GetPAbbellimento()->GetID()==CL_GUP||((Nota*)FPtr)->GetPAbbellimento()->GetID()==CL_GSLASH){
				FPtr->SuonaWithGruppettoSuperiore(mmw);
			}
			else if (((Nota*)FPtr)->GetPAbbellimento()->GetID()==CL_GINFERIORE){				
				FPtr->SuonaWithGruppettoInferiore(mmw);
			}
			else if (((Nota*)FPtr)->GetPAbbellimento()->GetID()==CL_TRILLO){
				FPtr->SuonaWithTrillo(mmw);
			}
			else if (((Nota*)FPtr)->GetPAbbellimento()->GetID()==CL_TREMOLO){
				SuonaTremolo(mmw,FPtr,NextFPtr);
				FPtr=NextFPtr;
				NextFPtr=this->GetNextFigura(FPtr);
			}
			else {		
				FPtr->Suona(mmw);
			}
		}
		else {				
			FPtr->Suona(mmw);
		}
		if (AcciaccaturaPtr!=NULL){
			if (AcciaccaturaPtr->GetID()!=CL_GRUPPONOTE){
				AcciaccaturaPtr->SetDurata(DUR_ACCIACCATURA);
				AcciaccaturaPtr->Suona(mmw);
				AcciaccaturaPtr->SetDurata(0);
				AcciaccaturaPtr=NULL;
				float dur = FPtr->GetDurata();
				dur=dur+DUR_ACCIACCATURA;
				FPtr->SetDurata(dur);
			}
			else if (AcciaccaturaPtr->GetID()==CL_GRUPPONOTE){
				int numnotine=((GruppoNote*)AcciaccaturaPtr)->GetNumNote();
				float dur_notina=DUR_ACCIACCATURA/numnotine;
				Figura* notina=((GruppoNote*)AcciaccaturaPtr)->GetFirstNota();
				for(int j=0;j<numnotine;j++){
					notina->SetDurata(dur_notina);
					notina->Suona(mmw);
					notina->SetDurata(0);
					if (this->GetNextFigura(notina)!=NULL){
						notina=this->GetNextFigura(notina);
					}
					else if (GetNextAcciaccaturaLayer()!=NULL && GetNextAcciaccaturaLayer()->GetNextFigura(notina)!=NULL){
						notina=this->GetNextAcciaccaturaLayer()->GetNextFigura(notina);
					}
				}

				float dur = FPtr->GetDurata();
				dur=dur+DUR_ACCIACCATURA;
				FPtr->SetDurata(dur);

				AcciaccaturaPtr=NULL;

				if((FPtr->GetID())==CL_ACCORDO){
					Node* current;
					Nota* NPtr;
					float dur=FPtr->GetDurata();
					//dur=dur+(DUR_ACCIACCATURA);
					current = ((Accordo*)FPtr)->first;
					while (current && (mmw->flagfinelista!=1)){
						NPtr=(Nota*)current->ObjectPtr;
						NPtr->SetDurata(dur);
						//NPtr->Suona(mmw);
						//SetDurata(durata);
						current = GetNext(current);
					}
				}		
			}	
		}

		while ((FPtr && FPtr->GetNotina())&&(NextFPtr && NextFPtr->GetNotina())){

			FPtr=NextFPtr;
			NextFPtr=this->GetNextFigura(FPtr);//silvestre
		}

		FPtr=NextFPtr;

		NextFPtr=this->GetNextFigura(FPtr);//silvestre
		i++;

		if (mmw->flagfinelista==1)
		{
			break;
		} 

	}
#endif  
}

 
void ListaFigure::SuonaTremolo(MoodsMidiWrite *mmw,Figura *FPtr, Figura *NextFPtr){

	float durata1= FPtr->GetDurata();
	float durata2= NextFPtr->GetDurata();
	float durata_totale=durata1+durata2;
	float durata_notina;
	short numbarre;
	numbarre = ((Tremolo*)(((Nota*)FPtr)->GetPAbbellimento()))->GetNumBarre();
	if(numbarre==1) durata_notina=0.125;
	else if (numbarre==2) durata_notina=0.0625;
	else if (numbarre==3) durata_notina=0.03125;
	else if (numbarre==4) durata_notina=0.015625;
	else if (numbarre==5) durata_notina=0.0078125;

	while (durata_totale >0){

		FPtr->SetDurata(durata_notina);
		NextFPtr->SetDurata(durata_notina);
		FPtr->Suona(mmw);
		NextFPtr->Suona(mmw);
		durata_totale=durata_totale -(2*durata_notina);


	}
	FPtr->SetDurata(durata1);
	NextFPtr->SetDurata(durata2);
	//FPtr=NextFPtr;
	//NextFPtr=this->GetNextFigura(FPtr);


}
  
 //***************************************************FIGURA*******************************************************************
 /*Ora siamo dentro alla figura che puo essere o una nota, una pausa o altro...dipende da quello che c'e' in memoria.
 * per noi basta usare FIGURA poi c'e' isanote o isarest che dicono se e' una nota o no e se e' un rest e' un rest con durata !=0 allora
 * e' una pausa.!!!!!!!!
 * GetAltezza,GetDurata, IsaNote e IsRest sono funzioni di Figura.
 * SUONA DI FIGURA SI E' DICHIARATA VIRTUALE infatti puo' chiamare sia suona di pausa che suona di nota.
 */
 
void Figura::Suona(MoodsMidiWrite * mmw)
{
   //Qui ci arriviamo solo se non e' ne' una nota ne' una pausa (ma resto!)
}

float ConvertDurata(Figura* ptr){
	
	ClassID id = ptr->GetID();
	float dur=0;
	switch (id)
	{
	case CL_NBREVE:dur=2;break;
	case CL_NSEMIBREVE:dur=1;break;
	case CL_NMINIMA:dur=0.5;break;
	case CL_NSEMIMINIMA:dur=0.25;break;
	case CL_NCROMA:dur=0.125;break;
	case CL_NSEMICROMA:dur=0.0625;break;
	case CL_NBISCROMA:dur=0.03125;break;
	case CL_NSEMIBISCROMA:dur=0.015625;break;
	case CL_NFUSA:dur=0.0078125;break;
		
	}
	return dur;	
}

 void Figura::Suonalanota(MoodsMidiWrite * mmw, float durata, int altezza){
 }

 void Nota::Suonalanota(MoodsMidiWrite * mmw, float durata, int altezza){
 }

 float Figura::SuonaAppoggiatura(MoodsMidiWrite * mmw){
		return 0;
 }

 void Figura::SuonaWithAppoggiatura(MoodsMidiWrite* mmw,float durata_appoggiatura){

 }

//**********************************************NOTA****************************************************************************
float Nota::SuonaAppoggiatura(MoodsMidiWrite* mmw)
{
	float durata_notina=ConvertDurata(this);
	SetDurata(durata_notina);
	Suona(mmw);
	SetDurata(0);
	return durata_notina;
}

void Nota::SuonaWithAppoggiatura(MoodsMidiWrite* mmw,float durata_appoggiatura)
{
	float den;
	den=mmw->denom;
	float durata=GetDurata();
   
	SetDurata(durata-durata_appoggiatura);
	Suona(mmw);
	SetDurata(durata);
}

void Accordo::SuonaWithAppoggiatura(MoodsMidiWrite* mmw,float durata_appoggiatura)
{
	float den;
	den=mmw->denom;
	float durata=GetDurata();
    Node* current;
	Nota* NPtr;
	current = first;
	while (current && (mmw->flagfinelista!=1)){		
		NPtr=(Nota*)current->ObjectPtr;
		NPtr->SetDurata(durata-durata_appoggiatura);
		current = GetNext(current);
	}
	Suona(mmw);
	current = first;
	while (current && (mmw->flagfinelista!=1)){		
		NPtr=(Nota*)current->ObjectPtr;
		NPtr->SetDurata(durata);
		current = GetNext(current);
	}
}

void Figura::SuonaAsAcciaccatura(MoodsMidiWrite * mmw){
}


void Figura::SuonaWithMordenteSuperiore(MoodsMidiWrite *mmw){
}

void Nota::SuonaWithMordenteSuperiore(MoodsMidiWrite *mmw){
	AlterazComposta *PAlterazComposta=NULL;
	AlterazComposta *PAlteraztmp=new AlterazComposta();
    PAlterazComposta=this->GetPAlterazComposta();
	Alterazione *alt_principale=NULL, *alt_sopra=NULL;
	if(PAlterazComposta){
		alt_principale= PAlterazComposta->GetPAlterazione(1);
	}
	
	alt_sopra=GetPAbbellimento()->GetPAltSopra();

	PAlteraztmp->SetPAlterazione(1,alt_sopra);
	float dur=this->GetDurata();
	float dur_notina;
	int alt=this->GetAltezza();

	if(GetPAbbellimento()->GetDoppio()==FALSE){
		dur_notina=dur/8;
		//////prima notina
		this->SetDurata(dur_notina);
		this->SetAltezza(alt);
		this->Suona(mmw);
		//////seconda notina
		this->SetPAlterazComposta(PAlteraztmp);
		this->SetAltezza(alt+1);
		this->Suona(mmw);
		//////terza nota (quella lunga)
		this->SetPAlterazComposta(PAlterazComposta);
		this->SetDurata(3*dur/4);
		this->SetAltezza(alt);
		this->Suona(mmw);
		//////si riporta la durata iniziale
		this->SetDurata(dur);
	}
	else if (GetPAbbellimento()->GetDoppio()){
		dur_notina=dur/8;
		//////prima notina
		this->SetDurata(dur_notina);
		//this->SetAltezza(alt);
		this->Suona(mmw);
		//////seconda notina
		this->SetPAlterazComposta(PAlteraztmp);
		this->SetAltezza(alt+1);
		this->Suona(mmw);
		//////terza notina
		this->SetPAlterazComposta(PAlterazComposta);
		this->SetAltezza(alt);
		this->Suona(mmw);
		//////quarta notina
		this->SetPAlterazComposta(PAlteraztmp);
		this->SetAltezza(alt+1);
		this->Suona(mmw);
		//////quinta nota (quella lunga)
		this->SetPAlterazComposta(PAlterazComposta);
		this->SetDurata(dur/2);
		this->SetAltezza(alt);
		this->Suona(mmw);
		//////si riporta la durata iniziale
		this->SetDurata(dur);
	}
}
void Figura::SuonaWithMordenteInferiore(MoodsMidiWrite *mmw){
}

void Nota::SuonaWithMordenteInferiore(MoodsMidiWrite *mmw){
	AlterazComposta *PAlterazComposta=NULL;
	AlterazComposta *PAlteraztmp=new AlterazComposta();
    PAlterazComposta=this->GetPAlterazComposta();
	Alterazione *alt_principale=NULL, *alt_sotto=NULL;
	if(PAlterazComposta){
		alt_principale= PAlterazComposta->GetPAlterazione(1);
	}
	
	alt_sotto=GetPAbbellimento()->GetPAltSopra();

	PAlteraztmp->SetPAlterazione(1,alt_sotto);
	float dur=this->GetDurata();
	float dur_notina;
	int alt=this->GetAltezza();

	if(GetPAbbellimento()->GetDoppio()==FALSE){
		dur_notina=dur/8;
		//////prima notina
		this->SetDurata(dur_notina);
		this->SetAltezza(alt);
		this->Suona(mmw);
		//////seconda notina
		this->SetPAlterazComposta(NULL);
		this->SetPAlterazComposta(PAlteraztmp);
		this->SetAltezza(alt-1);
		this->Suona(mmw);
		//////terza nota (quella lunga)
		this->SetPAlterazComposta(PAlterazComposta);
		this->SetDurata(3*dur/4);
		this->SetAltezza(alt);
		this->Suona(mmw);
		//////si riporta la durata iniziale
		this->SetDurata(dur);
	}
	else if (GetPAbbellimento()->GetDoppio()){
		dur_notina=dur/8;
		//////prima notina
		this->SetDurata(dur_notina);
		this->SetAltezza(alt);
		this->Suona(mmw);
		//////seconda notina
		this->SetPAlterazComposta(NULL);
		this->SetAltezza(alt-1);
		this->SetPAlterazComposta(PAlteraztmp);
		this->Suona(mmw);
		//////terza notina
		this->SetPAlterazComposta(PAlterazComposta);
		this->SetAltezza(alt);
		this->Suona(mmw);
		//////quarta notina
		this->SetPAlterazComposta(PAlteraztmp);
		this->SetAltezza(alt-1);
		this->Suona(mmw);
		//////quinta nota (quella lunga)
		this->SetPAlterazComposta(PAlterazComposta);
		this->SetDurata(dur/2);
		this->SetAltezza(alt);
		this->Suona(mmw);
		//////si riporta la durata iniziale
		this->SetDurata(dur);
	}
}

void Figura::SuonaWithGruppettoSuperiore(MoodsMidiWrite *mmw){

}
void Nota::SuonaWithGruppettoSuperiore(MoodsMidiWrite *mmw){
	AlterazComposta *PAlterazComposta=NULL;
	AlterazComposta *PAlteraztmp=new AlterazComposta();
    PAlterazComposta=this->GetPAlterazComposta();
	Alterazione *alt_principale=NULL, *alt_sopra=NULL,*alt_sotto=NULL;
	if(PAlterazComposta){
		alt_principale= PAlterazComposta->GetPAlterazione(1);
	}
	
	alt_sopra=GetPAbbellimento()->GetPAltSopra();
	alt_sotto=GetPAbbellimento()->GetPAltSotto();

	PAlteraztmp->SetPAlterazione(1,alt_sopra);
	float dur=this->GetDurata();
	float dur_notina;
	int alt=this->GetAltezza();
	
	dur_notina=dur/6;
	//////prima notina
	this->SetPAlterazComposta(PAlteraztmp);
	this->SetDurata(dur_notina);
	this->SetAltezza(alt+1);
	this->Suona(mmw);
	//////seconda notina
	this->SetPAlterazComposta(PAlterazComposta);
	this->SetAltezza(alt);
	this->Suona(mmw);
	//////terza notina
	PAlteraztmp->SetPAlterazione(1,alt_sotto);
	this->SetPAlterazComposta(PAlteraztmp);
	this->SetAltezza(alt-1);
	this->Suona(mmw);
	//////quarta nota (quella lunga)
	this->SetPAlterazComposta(PAlterazComposta);
	this->SetDurata(dur/2);
	this->SetAltezza(alt);
	this->Suona(mmw);
	//////si riporta la durata iniziale
	this->SetDurata(dur);
}

void Figura::SuonaWithGruppettoInferiore(MoodsMidiWrite *mmw){
}

void Nota::SuonaWithGruppettoInferiore(MoodsMidiWrite *mmw){
	AlterazComposta *PAlterazComposta=NULL;
	AlterazComposta *PAlteraztmp=new AlterazComposta();
    PAlterazComposta=this->GetPAlterazComposta();
	Alterazione *alt_principale=NULL, *alt_sopra=NULL,*alt_sotto=NULL;
	if(PAlterazComposta){
		alt_principale= PAlterazComposta->GetPAlterazione(1);
	}
	
	alt_sopra=GetPAbbellimento()->GetPAltSopra();
	alt_sotto=GetPAbbellimento()->GetPAltSotto();

	PAlteraztmp->SetPAlterazione(1,alt_sotto);
	float dur=this->GetDurata();
	float dur_notina;
	int alt=this->GetAltezza();
	
	dur_notina=dur/6;
	//////prima notina
	this->SetPAlterazComposta(PAlteraztmp);
	this->SetDurata(dur_notina);
	this->SetAltezza(alt-1);
	this->Suona(mmw);
	//////seconda notina
	this->SetPAlterazComposta(PAlterazComposta);
	this->SetAltezza(alt);
	this->Suona(mmw);
	//////terza notina
	PAlteraztmp->SetPAlterazione(1,alt_sopra);
	this->SetPAlterazComposta(PAlteraztmp);
	this->SetAltezza(alt+1);
	this->Suona(mmw);
	//////quarta nota (quella lunga)
	this->SetPAlterazComposta(PAlterazComposta);
	this->SetDurata(dur/2);
	this->SetAltezza(alt);
	this->Suona(mmw);
	//////si riporta la durata iniziale
	this->SetDurata(dur);
}

void Figura::SuonaWithTrillo(MoodsMidiWrite *mmw){
}

void Nota::SuonaWithTrillo(MoodsMidiWrite *mmw){
	float dur=this->GetDurata();
	float dur_notina;
	int alt=this->GetAltezza();
	
	AlterazComposta *PAlterazComposta=NULL;
	AlterazComposta *PAlteraztmp=new AlterazComposta();
    PAlterazComposta=this->GetPAlterazComposta();
	Alterazione *alt_principale=NULL, *alt_sopra=NULL;
	if(PAlterazComposta){
		alt_principale= PAlterazComposta->GetPAlterazione(1);
	}
	
	alt_sopra=GetPAbbellimento()->GetPAltSopra();

	PAlteraztmp->SetPAlterazione(1,alt_sopra);
	dur_notina=dur/8;
	//////prima notina
	this->SetDurata(dur_notina);
	this->SetPAlterazComposta(PAlterazComposta);
	//PAlterazComposta->SetPAlterazione(1,alt_principale);
	this->SetAltezza(alt);
	this->Suona(mmw);
	//////seconda notina
	this->SetAltezza(alt+1);
	//this->SetPAlterazComposta((AlterazComposta*)(GetPAbbellimento()->GetPAltSopra()));
	//PAlterazComposta->SetPAlterazione(1,alt_sopra);
	this->SetPAlterazComposta(PAlteraztmp);
	this->Suona(mmw);
	//////terza notina
	this->SetAltezza(alt);
	this->SetPAlterazComposta(PAlterazComposta);
	this->Suona(mmw);
	//////quarta nota
	this->SetAltezza(alt+1);
	//this->SetPAlterazComposta((AlterazComposta*)(GetPAbbellimento()->GetPAltSopra()));
	this->SetPAlterazComposta(PAlteraztmp);
	this->Suona(mmw);
	//////quinta nota
	this->SetAltezza(alt);
	this->SetPAlterazComposta(PAlterazComposta);
	this->Suona(mmw);
	//////sesta nota
	this->SetAltezza(alt+1);
	//this->SetPAlterazComposta((AlterazComposta*)(GetPAbbellimento()->GetPAltSopra()));
	this->SetPAlterazComposta(PAlteraztmp);
	this->Suona(mmw);
	//////settima nota
	this->SetAltezza(alt);
	this->SetPAlterazComposta(PAlterazComposta);
	this->Suona(mmw);
	//////ottava nota
	this->SetAltezza(alt+1);
	//this->SetPAlterazComposta((AlterazComposta*)(GetPAbbellimento()->GetPAltSopra()));
	this->SetPAlterazComposta(PAlteraztmp);
	this->Suona(mmw);
	//////riporta la durata iniziale
	this->SetDurata(dur);
	this->SetPAlterazComposta(PAlterazComposta);
	this->SetAltezza(alt);
}

void Figura::SuonaWithTremolo(MoodsMidiWrite *mmw){
}

void Nota::SuonaWithTremolo(MoodsMidiWrite *mmw){
	short numbarre;
	numbarre = ((Tremolo*)GetPAbbellimento())->GetNumBarre();

	if (numbarre==1){
	}
}

void Nota::Suona(MoodsMidiWrite * mmw)
{
#ifdef WX226 
	mmw->Get_p_evt_info()->p_item=(void*)this;

	int altezza,base12letter,f,k;
	TipoPitch*	pPitch;
	float durata;
	unsigned long tics;
	Bool tie;

	tie = GetTie();

	float den, num=4.0;
	den=mmw->denom;
	durata=Figura::GetDurata(den, num);

	tics=durata*mmw->ppqn*4; 

	if (mmw->setrack0==1)
	{		
		Chiave *pChiave =GetPBattuta()->GetChiave(GetNStaff());
		mmw->tipodichiave=pChiave->GetID();

		pPitch = GetPitch();
		if ( pPitch == NULL )
			pPitch = CreatePitch();

		//passo da base 7 in base 12
		switch(pPitch->Letter)
		{
		case 0:
			base12letter=0;
			break;	     
		case 1:
			base12letter=2;
			break;	     
		case 2:
			base12letter=4;
			break;	     
		case 3:
			base12letter=5;
			break;	     
		case 4:
			base12letter=7;
			break;	     
		case 5:
			base12letter=9;
			break;	     
		case 6:
			base12letter=11;
			break;	     
		}		
		altezza = 60 + ( pPitch->Octave - 3)*12 + base12letter + pPitch->Accidental + mmw->transpose;
	}

	//*******************Gestione del noteon e noteoff************************************************

	if (mmw->flagisaccordo==0)   //questa figura e' una nota
	{
		if (mmw->setrack0==0)
		{
			mmw->deltatimebattuta=mmw->deltatimebattuta+tics;
		} 		
		if (mmw->setrack0==1)
		{   		
			//SE SOMMA FIGURE IN BATTUTA ECCEDE DURATA DI BATTUTA................................  
			if ((mmw->deltatimebattuta+tics)>(mmw->num*mmw->ppqn*4/mmw->denom))
			{ 
				if (mmw->flaglegatura>=0)
				{
					mmw->time(mmw->tempolegatura);
					mmw->noteoff(mmw->orchestra[mmw->indice][2],mmw->flaglegatura,0);
					mmw->flaglegatura=-1;
				}
				if (mmw->flaglegatura==-2)
				{
					mmw->flaglegatura=-1; 
					for(k=0;k<10;k++)
					{
						if (mmw->flaglegacc[k]>=0)
						{ 
							mmw->noteoff(mmw->orchestra[mmw->indice][2],mmw->flaglegacc[k],0);
							mmw->flaglegacc[k]=-1;
						}
					}      	 
				} 
				mmw->time((mmw->num*mmw->ppqn*4/mmw->denom)-(mmw->deltatimebattuta));
				mmw->deltatimebattuta=(mmw->num*mmw->ppqn*4/mmw->denom);
				mmw->flagfinelista=1;
			}  	    
			else
			{     				
				mmw->deltatimebattuta=mmw->deltatimebattuta+tics;

				if ((tie==0) && (mmw->flaglegatura==-1))
				{         
					mmw->noteon(mmw->orchestra[mmw->indice][2],altezza,mmw->velocitadiattacco);
					mmw->time(tics);
					mmw->noteoff(mmw->orchestra[mmw->indice][2],altezza,0);
				}				
				if (mmw->flaglegatura!=-1)
				{
					mmw->flaglegatura=altezza;
					f=0;
					for (k=0; k<10; k++)
					{
						if (altezza==mmw->flaglegacc[k])
						{
							f=1;
							mmw->tempolegatura=tics;
						} 
					}
					if (f==0)
					{
						mmw->tempolegatura=mmw->tempolegatura+tics;
					}
					if (tie==0)  //e' l'ultima nota della legatura
					{
						mmw->Get_p_evt_info()->p_item=(void*)mmw->StartTieNote;
						mmw->time(mmw->tempolegatura);
						mmw->noteoff(mmw->orchestra[mmw->indice][2],altezza,0);
						mmw->flaglegatura=-1;												
					} 	   
				}

				if ((mmw->flaglegatura==-1) && (tie==1))  //prima nota di una legatura
				{
					mmw->noteon(mmw->orchestra[mmw->indice][2],altezza,mmw->velocitadiattacco);
					mmw->tempolegatura=tics;
					mmw->flaglegatura=altezza;

					mmw->StartTieNote = NULL;
				}


				for (k=0;k<10;k++)   //QUANDO ENTRA IN UNA NOTA SINGOLA I FLAG ACCORDO-LEGATURA DEVONO ESSERE POSTI A ZERO
				{
					mmw->flaglegacc[k]=-1;
				}				
			} 
		}
	}

	if (mmw->flagisaccordo==1)  //primo scorrimento delle note dell'accordo
	{
		//SE SOMMA FIGURE IN BATTUTA ECCEDE DURATA DI BATTUTA................................
		if ((mmw->deltatimebattuta+tics)>(mmw->num*mmw->ppqn*4/mmw->denom))
		{
			if (mmw->flaglegatura>=0)
			{
				mmw->noteoff(mmw->orchestra[mmw->indice][2],mmw->flaglegatura,0);
				mmw->flaglegatura=-1;
			}
			if (mmw->flaglegatura==-2)
			{
				for(k=0;k<10;k++)
				{
					if (mmw->flaglegacc[k]>=0)
					{ 
						mmw->noteoff(mmw->orchestra[mmw->indice][2],mmw->flaglegacc[k],0);
						mmw->flaglegacc[k]=-1;
					}
				}      	 

			} 
			mmw->time((mmw->num*mmw->ppqn*4/mmw->denom)-(mmw->deltatimebattuta));
			mmw->deltatimebattuta=(mmw->num*mmw->ppqn*4/mmw->denom);
			mmw->flagfinelista=1;
			mmw->f=0;
		}

		else
		{     	 
			mmw->ticsaccordo=tics;
			if  (mmw->setrack0==1)
			{     

				if (mmw->flaglegatura==-1)
				{
					mmw->noteon(mmw->orchestra[mmw->indice][2],altezza,mmw->velocitadiattacco);
				}
				else if ((mmw->flaglegacc[mmw->indaccordo]==-1) && (mmw->flaglegatura!=altezza))
				{ 
					mmw->noteon(mmw->orchestra[mmw->indice][2],altezza,mmw->velocitadiattacco);
				}
				if (tie==1)
				{
					mmw->flaglegacc[mmw->indaccordo]=altezza;
					mmw->f=1;
				}
				else
				{
					mmw->flaglegacc[mmw->indaccordo]=-1;
				}
			}	  
		}
	}  
	if  (mmw->setrack0==1)
	{
		if (mmw->flagisaccordo==2)  //secondo scorrimento delle note dell'accordo
		{
			if (mmw->flaglegacc[mmw->indaccordo]==-1)
			{
				//out<< "\n noteoff nota di accordo -";
				mmw->noteoff(mmw->orchestra[mmw->indice][2],altezza,0);
			} 
		}
	}
#endif
}  
 
/*******************************************************/
void Nota::SuonaAsAcciaccatura(MoodsMidiWrite * mmw)
{
  
}


//*******************************************PAUSA*************************************************
//Entriamo in pausa solo quando e' una pausa e ne ricava la durata


void Pausa::Suona(MoodsMidiWrite * mmw)
{
#ifdef WX226
	float durata;
	durata=GetDurata();
	unsigned long tics;
	int k;

	tics=durata*mmw->ppqn*4; 

	if (mmw->setrack0==0)
	{mmw->deltatimebattuta=mmw->deltatimebattuta+tics;}

	if (mmw->setrack0==1)
	{   
		//SE SOMMA FIGURE IN BATTUTA ECCEDE DURATA DI BATTUTA................................  
		if ((mmw->deltatimebattuta+tics)>(mmw->num*mmw->ppqn*4/mmw->denom))
		{
			if (mmw->flaglegatura>=0)
			{
				mmw->time(mmw->tempolegatura);
				mmw->noteoff(mmw->orchestra[mmw->indice][2],mmw->flaglegatura,0);
				mmw->flaglegatura=-1;
			}
			if (mmw->flaglegatura==-2)
			{
				mmw->flaglegatura=-1;
				for(k=0;k<10;k++)
				{
					if (mmw->flaglegacc[k]>=0)
					{ 
						mmw->noteoff(mmw->orchestra[mmw->indice][2],mmw->flaglegacc[k],0);
						mmw->flaglegacc[k]=-1;
					}
				}      	 

			} 
			mmw->time((mmw->num*mmw->ppqn*4/mmw->denom)-(mmw->deltatimebattuta));
			mmw->deltatimebattuta=(mmw->num*mmw->ppqn*4/mmw->denom);
			mmw->flagfinelista=1;
		}  
		else
		{
			mmw->time(tics);
			mmw->deltatimebattuta=mmw->deltatimebattuta+tics;
		}
	}
#endif
}   

//***************************************ACCORDO************************************************
void Accordo::Suona(MoodsMidiWrite * mmw)
{
#ifdef WX226
	int j;
	Node *current;
	Nota *NPtr;

	mmw->f=0;

	for(j=1;j<=2;j++)
	{
		current = first;
		mmw->flagisaccordo=j;
		if (j==2)
		{
			if (mmw->setrack0==1)
			{ 
				mmw->time(mmw->ticsaccordo);
			}
			mmw->deltatimebattuta=mmw->deltatimebattuta+mmw->ticsaccordo;
		}
		mmw->indaccordo=0;   
		while (current)
		{
			NPtr = (Nota*) current->ObjectPtr ;
			NPtr->Suona(mmw);
			current = GetNext(current);
			mmw->indaccordo++;
			if (mmw->flagfinelista==1)
			{
				break;
			} 
		}

		if (mmw->flagfinelista==1)
		{
			break;
		} 
	}

	mmw->flagisaccordo=0;

	if (mmw->f==0)   //serve per considerare le legature di valore fra quest'accordo e la figura successiva
	{
		mmw->flaglegatura=-1;
	}
	else
	{
		mmw->flaglegatura=-2;
	}
#endif
}
