/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

//-------MILLA KEYWORDS----------//
#include "mil/m.tab.h"
#include "mil/lgiust.h"	
	
KEYWORDMIL MilKeywords[] = {  
		{RELNOTA, "RELNOTA"},
		{RELNOTA, "RELNOTE"},
		{RELPAUSA, "RELPAUSA"},
		{RELPAUSA, "RELREST"},
		
		{RELSTAFF, "RELSTAFF"},
		{RELNOTES, "RELNOTES"},
		{DEFAULTX, "DEFAULT"},
		{ALTERNATIVE, "ALTERNATIVE"},
		{ONLEFT, "ONLEFT"},
		{ONRIGHT, "ONRIGHT"},
		{BELOW, "BELOW"},
		{ABOVE, "ABOVE"},
		{STEMUP, "STEMUP"},
		{STEMDOWN, "STEMDOWN"},
		{BEAM12, "BEAM12"},
		{BEAM23, "BEAM23"},
		{INMULTISTAFF, "INMULTISTAFF"},
		{STAFFNUMBER, "STAFFNUMBER"},
		{ONSTAFFNUMBER, "ONSTAFFNUMBER"},
		{STAFFLINES, "STAFFLINES"},
		{SAMESTEMONLEFT, "SAMESTEMONLEFT"},
		{SAMESTEMONRIGHT, "SAMESTEMONRIGHT"},
		{AVOIDINSTAFF, "AVOIDINSTAFF"},
		{OUTSIDESTAFF, "OUTSIDESTAFF"},
		{ANYWHERE, "ANYWHERE"},
		{ONSPACE, "ONSPACE"},
		{ONLINE, "ONLINE"},
		{ONSTAFF, "ONSTAFF"},
		{DOWNWARDS, "DOWNWARDS"},
		{UPWARDS, "UPWARDS"},
		{PAUSA, "PAUSA"},
		{PAUSA, "REST"},
		
		{NEARNOTA, "NEARNOTA"},
		{NEARNOTA, "NEARNOTE"},
		
		{PSEMIBREVE, "PSEMIBREVE"},
		{PSEMIBREVE, "REST1"},
		
		{PMINIMA, "PMINIMA"},
		{PMINIMA, "REST1_2"},
		
		{THEN, "THEN"},
		{immIF, "immIF"},
		{immIF, "insIF"},
		
		{posIF, "posIF"},
		{INMULTIVOICEUPPER, "INMULTIVOICEUPPER"},
		{INMULTIVOICELOWER, "INMULTIVOICELOWER"},
		{INENDBATTUTA, "INENDBATTUTA"},
		{INENDBATTUTA, "INENDMEASURE"},
		
		{INBEAM, "INBEAM"},
		{INTUPLET, "INTUPLET"},
		{INPUNTOVALORE, "INPUNTOVALORE"},
		{INPUNTOVALORE, "INAUGDOT"},
		
		{INCHORDSUSPENDED, "INCHORDSUSPENDED"},
		{INSTACCATO, "INSTACCATO"},
		{INLEGVALORE, "INLEGVALORE"},
		{INLEGVALORE, "INTIE"},
		
		{CORONA, "CORONA"},
		{CORONA, "FERMATA"},
		
		{NOT, "NOT"},
		{NOTE, "NOTE"},
		{NEARNOTA, "NEARNOTA"},
		{NEARNOTA, "NEARNOTE"},
		
		{NEARNOTES, "NEARNOTES"},
		{INCHORD, "INCHORD"},
		{INMULTIVOICE, "INMULTIVOICE"},
		{OPPOSITETOSTEM, "OPPOSITETOSTEM"},
		{ONSTEM, "ONSTEM"},
		{SUSPENDED, "SUSPENDED"},
		{UPPER, "UPPER"},
		{LOWER, "LOWER"},
		{INTERMEDIATE, "INTERMEDIATE"},
		{CAMBIOCHIAVE, "CAMBIOCHIAVE"},
		{CAMBIOCHIAVE, "CLEFCHANGE"},
		
		
		{AND, "AND"},
		{OR, "OR"},
		{XOR, "XOR"},
		{APP, "APP"},
		{ACC, "ACC"},
		{ACC, "ACCIACC"},
		
		{GRUP, "GRUP"},
		{GRUP, "TURN"},
		
		{MORD, "MORD"},
		{MORD, "MORDENT"},
		
		{TRILLO, "TRILLO"},
		{TRILLO, "TRILL"},
		
		{TREM, "TREM"},
		{TREM, "TREMOLO"},
		
		{ARP, "ARP"},
		{ARP, "ARPEGGIO"},
		
		{GLISS, "GLISS"},
		{GLISS, "GLISSANDO"},
		
		{DIESIS, "DIESIS"},
		{DIESIS, "SHARP"},
		
		{BEMOL, "BEMOL"},
		{BEMOL, "FLAT"},
		
		{DOPDIES, "DOPDIES"},
		{DOPDIES, "DSHARP"},
		
		{DOPBEMOL, "DOPBEMOL"},
		{DOPBEMOL, "DFLAT"},
		
		{MONES, "MONES"},
		{MONES, "SHARP1Q"},
		
		{TRIES, "TRIES"},
		{TRIES, "SHARP3Q"},
		
		{LEG, "LEG"},
		{LEG, "SLUR"},
		
		{STAC, "STAC"},
		{STAC, "STACCATO"},
		
		{SFOR, "SFOR"},
		{SFOR, "SFORZATO"},
		
		{ACCE, "ACCE"},
		{ACCE, "ACCENTO"},
		
		{MARTF, "MARTF"},
		{MARTF, "MARTELLATO"},
		
		{TEN, "TEN"},
		{TEN, "TENUTO"},
		
		{RULEIMM, "RULEIMM"},
		{RULEIMM, "RULEINS"},
		
		{RULEPOS, "RULEPOS"},
		{MART, "MART"},
		{MART, "MARTDOLCE"},
		
		{PUNTOALL, "PUNTOALL"},
		{PUNTOALL, "PUNTOALLUNGATO"},
		
		{LEGVAL, "LEGVAL"},
		{LEGVAL, "SLUR"},
		
		{PUNTOVAL, "PUNTOVAL"},
		{PUNTOVAL, "AUGDOT"},
		
		{SCALE, "SCALE"},
		{ANGLE, "ANGLE"},
		{STEM, "STEM"},
		{PSEMIMINIMA, "PSEMIMINIMA"},
		{PSEMIMINIMA, "REST1_4"},
		
		{PCROMA, "PCROMA"},
		{PCROMA, "REST1_8"},
		
		{PSEMICROMA, "PSEMICROMA"},
		{PSEMICROMA, "REST1_16"},
		
		{PBISCROMA, "PBISCROMA"},
		{PBISCROMA, "REST1_32"},
		
		{PSEMIBISCROMA, "PSEMIBISCROMA"},
		{PSEMIBISCROMA, "REST1_64"},
		
		{DELTAX, "DX"},
		{DELTAY, "DY"},
		{NUMDOWN, "NUMDOWN"},
		{NUMUP, "NUMUP"},
		{VAR, "VAR"},
		{LENGHT, "LENGHT"},
		{LENGHT, "LENGTH"},
		
		{WITH, "WITH"},
		{BEAM, "BEAM"},
		{INCHORDTRE, "INCHORDTRE"},
		{INCHORDTRE, "INCHORDTHREE"},
		
		{ALTERAZIONE, "ALTERAZIONE"},
		{ALTERAZIONE, "ACCIDENTAL"},
		
		{INCHORDSETTIMA, "INCHORDSETTIMA"},
		{INCHORDSETTIMA, "INCHORDSEVENTH"},
		
		{INCHORDminSETTIMA, "INCHORDminSETTIMA"},
		{INCHORDminSETTIMA, "INCHORDminSEVENTH"},
		
		{INCHORDSUSPINTERM, "INCHORDSUSPINTERM"},
		{INCHORDSUSPUPPER, "INCHORDSUSPUPPER"},
		{INCHORDSUSPLOWER, "INCHORDSUSPLOWER"},
		{ARCATA, "ARCATA"},
		
		{PIZZICATO, "PIZZICATO"},
		{CORDA, "CORDA"},
		{CORDA, "STRING"},
		
		{ARCATASU, "ARCATASU"},
		{ARCATASU, "BOWUP"},
		
		{ARCATAGIU, "ARCATAGIU"},
		{ARCATAGIU, "BOWDOWN"},
		
		{PUNTA, "PUNTA"},
		{TALLONE, "TALLONE"},
		{PONTICELLO, "PONTICELLO"},
		{TASTIERA, "TASTIERA"},
		{ARCO, "ARCO"},
		{OTTAVA, "OTTAVA"},
		{OTTAVA, "OCTAVE"},
		
		{INOTTAVASOPRA, "INOTTAVASOPRA"},
		{INOTTAVASOPRA, "IN8VA"},
		
		{INOTTAVASOTTO, "INOTTAVASOTTO"},
		{INOTTAVASOTTO, "IN8BA"},
		
		{DITEG, "DITEG"},
		{DITEG, "FINGER"},
		
		{INTWOSTAFF, "INTWOSTAFF"},
		{INSINGLELAYER, "INSINGLELAYER"},
		{NOTAWITH, "NOTAWITH"},
		{NOTAWITH, "NOTEWITH"},
		
		{NOTES, "NOTES"},
		{BISCROMA, "BISCROMA"},
		{BISCROMA, "NOTE1_32"},
		
		{FUSA, "FUSA"},
		{FUSA, "NOTE1_128"},
		
		{SEMIBISCROMA, "SEMIBISCROMA"},
		{SEMIBISCROMA, "NOTE1_64"},
		
		{RULEPRI, "RULEPRI"},
		{STEMHEIGHT, "STEMHEIGHT"},
		{CROMA, "CROMA"},
		{CROMA, "NOTE1_8"},
		
		{SEMIMINIMA, "SEMIMINIMA"},
		{SEMIMINIMA, "NOTE1_4"},
		
		{MINIMA, "MINIMA"},
		{MINIMA, "NOTE1_2"},
		
		{SEMIBREVE, "SEMIBREVE"},
		{SEMIBREVE, "NOTE1"},
		
		{BREVE, "BREVE"},
		{BREVE, "NOTE2"},
		
		{NOTINA, "NOTINA"},
		{NOTINA, "SMALLNOTE"},
		
		{SEMICROMA, "SEMICROMA"},
		{SEMICROMA, "NOTE1_16"},
		
		{MOBEMOL, "MOBEMOL"},
		{MOBEMOL, "FLAT1Q"},
		
		{TRIBEMOL, "TRIBEMOL"},
		{TRIBEMOL, "FLAT3Q"},
		
		{FIRSTUPPER, "FIRSTUPPER"},
		{FIRSTUPPER, "FIRSTUPEST"},
		
		{FIRSTLOWER, "FIRSTLOWER"},
		{FIRSTLOWER, "FIRSTLOWEST"},
		
		{PRECEED, "PRECEED"},
		{NBEAT, "NBEAT"},
		{TIME, "TIME"},
		{BATTUTA, "BATTUTA"},
		{BATTUTA, "MEASURE"},
		
		{COPPIE, "COPPIE"},
		{COPPIE, "COUPLES"},
		
		{OFF, "OFF"},
		{ON, "ON"},
		{GTinBEAT, "GTinBEAT"},
		{GREATER, "GREATER"},
		{LOWer, "LOWer"},
		{LOWer, "LOWER"},
		
		{GREATERe, "GREATERe"},
		{GREATERe, "GREATEREQ"},
		
		{LOWERe, "LOWERe"},
		{LOWERe, "LOWEREQ"},
		
		{UPPERD, "UPPERD"},
		{UPPERD, "UPESTD"},
		
		{LOWERD, "LOWERD"},
		{LOWERD, "LOWESTD"},

		{EQUAL, "EQUAL"},
		
		{NUMUP, "NUMUP"},
		{NUMDOWN, "NUMDOWN"},
		{MEAN, "MEAN"},
		{DELTA, "DELTA"},
		{BEAMDIS, "BEAMDIS"},
		{MHL, "MHL"},
		{PLUS, "PLUS"},
		{MIN, "MIN"},
		{DEFGROUP, "DEFGROUP"},
		{DEFSYM, "DEFSYM"},
		{CODE, "CODE"},
		{DIM, "DIM"},
		{GROUP, "GROUP"},
		{CONSORD, "CONSORD"},
		{CONSORD, "WITHMUTE"},
		
		{VIASORD, "VIASORD"},
		{VIASORD, "WITHOUTMUTE"},

		{KORN, "KORN"},
		{KORN, "KOREANORNAMENT"},
		
		{ARM, "ARM"},
		{ARM, "HARM"},
		
		{HEAD,"HEAD"}, 
		{CLASSIC, "CLASSIC"},
		{ALPHANUM, "ALPHANUM"},
		{ALPHANUM_SQUARE, "ALPHANUM_SQUARE"},
		{ALPHANUM_REVERSE, "ALPHANUM_REVERSE"},
		{CIRCLEX, "CIRCLEX"},
		{CLUSTER, "CLUSTER"},
		{X_HEAD, "X_HEAD"},
		{CROIX, "CROIX"},
		{DDIESIS, "DDIESIS"},
		{DDIESIS, "HSHARP"},
		
		{DIAMOND, "DIAMOND"},
		{TRIANG, "TRIANG"},
		{TRIANG_UP, "TRIANG_UP"},
		{TRIANG_DOWN, "TRIANG_DOWN"},
		{TRIANG_LEFT, "TRIANG_LEFT"},
		{TRIANG_RIGHT, "TRIANG_RIGHT"},
		{TRIANG_ROUND, "TRIANG_DOWN"},
		{MOON, "MOON"},
		{PLUS_HEAD, "PLUS_HEAD"},
		{RHYTHMIC, "RHYTHMIC"},
		{SQUARE, "SQUARE"},
		
		{STEMSTART,"STEMSTART"}
};

int MilKeywordNumber = sizeof(MilKeywords)/sizeof(KEYWORDMIL);
