/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#ifndef LGIUST_H
#define LGIUST_H

#include "drw/point.hpp"

#define MAXNUMITEM 1000
#define MAXNUMCONDITION 1000

#define NOTESTEMDOWN NOTE*1000+STEMDOWN 
//#define NOTA*1000+BELOW 
//#define NOTA*1000+ABOVE 
#define NOTESTEMUP NOTE*1000+STEMUP 
#define NOTEONSPACE NOTE*1000+ONSPACE 
#define NOTEONLINE NOTE*1000+ONLINE 
#define NOTEINMULTIVOICEUPPER NOTE*1000+INMULTIVOICEUPPER 
#define NOTEINMULTIVOICELOWER NOTE*1000+INMULTIVOICELOWER 
#define NOTEINPUNTOVALORE NOTE*1000+INPUNTOVALORE 
#define NOTEINCHORDSUSPENDED NOTE*1000+INCHORDSUSPENDED 
#define NOTEINCHORD NOTE*1000+INCHORD
#define NOTEINMULTIVOICE NOTE*1000+INMULTIVOICE
//#define STAC*1000+ACCE 
//#define SFOR*1000+STAC 
#define NEARNOTASTEMUP NEARNOTA*1000+STEMUP 
#define NEARNOTASTEMDOWN NEARNOTA*1000+STEMDOWN 
#define NEARNOTAINMULTIVOICEUPPER NEARNOTA*1000+INMULTIVOICEUPPER 
#define NEARNOTAINMULTIVOICELOWER NEARNOTA*1000+INMULTIVOICELOWER 
#define NOTESUSPENDED NOTE*1000+SUSPENDED
#define NOTEUPPER NOTE*1000+UPPER 
#define NOTEINTERMEDIATE NOTE*1000+INTERMEDIATE 
#define PAUSAINMULTIVOICEUPPER PAUSA*1000+INMULTIVOICEUPPER 
#define PAUSAINMULTIVOICELOWER PAUSA*1000+INMULTIVOICELOWER 
#define NOTEINSINGLELAYER NOTE*1000+INSINGLELAYER
#define NOTESSTEMUP NOTES*1000+STEMUP
#define NOTESSTEMDOWN NOTES*1000+STEMDOWN
#define NOTAWITHSTAC NOTAWITH*1000+STAC
#define NOTAWITHACCE NOTAWITH*1000+ACCE
#define NOTAWITHTEN NOTAWITH*1000+TEN
#define NOTESINSINGLELAYER NOTES*1000+INSINGLELAYER
#define NOTESINMULTIVOICEUPPER NOTES*1000+INMULTIVOICEUPPER
#define NOTESINMULTIVOICELOWER NOTES*1000+INMULTIVOICELOWER
#define NOTEBISCROMA NOTE*1000+BISCROMA
#define NOTESEMIBISCROMA NOTE*1000+SEMIBISCROMA
#define NOTEFUSA NOTE*1000+FUSA
#define NOTECROMA NOTE*1000+CROMA
#define NOTESEMICROMA NOTE*1000+SEMICROMA

#define NOTESEMIMINIMA NOTE*1000+SEMIMINIMA
#define NOTEMINIMA NOTE*1000+MINIMA
#define NOTESEMIBREVE NOTE*1000+SEMIBREVE
#define NOTEBREVE NOTE*1000+BREVE

#define NOTENOTINA NOTE*1000+NOTINA

#define NOTEFIRSTUPPER NOTE*1000+FIRSTUPPER
#define NOTEFIRSTLOWER NOTE*1000+FIRSTLOWER
#define STACPRECEEDTEN STAC*1000+TEN
#define TENPRECEEDSTAC TEN*1000+STAC
#define BSLOPE 111
#define RELATION 110

#define HEADCLASSIC HEAD*1000+CLASSIC
#define HEADALPHANUM HEAD*1000+ALPHANUM
#define HEADALPHANUM_SQUARE HEAD*1000+ALPHANUM_SQUARE
#define HEADALPHANUM_REVERSE HEAD*1000+ALPHANUM_REVERSE
#define HEADCIRCLEX HEAD*1000+CIRCLEX
#define HEADCLUSTER HEAD*1000+CLUSTER
#define HEADX HEAD*1000+X_HEAD
#define HEADCROIX HEAD*1000+CROIX
#define HEADDDIESIS HEAD*1000+DDIESIS
#define HEADDIAMOND HEAD*1000+DIAMOND
#define HEADTRIANG HEAD*1000+TRIANG
#define HEADTRIANG_UP HEAD*1000+TRIANG_UP
#define HEADTRIANG_DOWN HEAD*1000+TRIANG_DOWN
#define HEADTRIANG_LEFT HEAD*1000+TRIANG_LEFT
#define HEADTRIANG_RIGHT HEAD*1000+TRIANG_RIGHT
#define HEADTRIANG_ROUND HEAD*1000+TRIANG_ROUND
#define HEADMOON HEAD*1000+MOON
#define HEADPLUS HEAD*1000+PLUS_HEAD
#define HEADRHYTHMIC HEAD*1000+RHYTHMIC
#define HEADSQUARE HEAD*1000+SQUARE

#define NUM_MAX_CONDIZIONI 20

/* Struttura che contiene tutte le parole chiave */
typedef struct _KEYWORDMIL {
  int IdValue;
  char  *IdName;
} KEYWORDMIL;
typedef KEYWORDMIL *PKEYWORDMIL;

typedef struct _RANGES{
   double min;
   double max;
} RANGE;

typedef struct _ITEMSPOS {
   char * ItemName;
   int    ItemType;
   int    Type; //DEFAULT o ALTERNATIVE
   int    Symbol;
   int    rel;
   int    cat;
   int    staff;
   double lenght;
   int code;
   double dx;
   double dy;
   char * regola;
   RANGE  rangelenght;
   RANGE  rangedx;
   RANGE  rangedy;
   RANGE  rangeangle;
   double scale;
   double angle;
   int    shape;
   RANGE  coppie[3];
   int    abilterzine;
   
   Point GetPoint(int lgambo);
} ITEMPOS;
typedef ITEMPOS * PITEMPOS;

typedef struct _ITEMSIMM {
   char * ItemName;
   int    ItemType;
   int    Type; //DEFAULT o ALTERNATIVE
   int    Symbol;
   int    rel;
   int    cat;
} ITEMIMM;
typedef ITEMIMM * PITEMIMM;

typedef struct _CONDITIONREL{
  int f1;
  int Op;
  int f2;
  int res;
  double num;
} ConditionRel;
  
typedef struct _condizione {
   int cond;
   RANGE range;
   ConditionRel conditionrel;
} Condizione;
   
typedef struct _CONDITIONSIMM{
   Condizione condizioni[NUM_MAX_CONDIZIONI];
   char * RuleName;
   int Symbol;
   PITEMIMM Rule;
   int numCond;   
} CONDITIONIMM;   
typedef CONDITIONIMM *PCONDITIONIMM;

typedef struct _CONDITIONSPOS{
   Condizione condizioni[NUM_MAX_CONDIZIONI];
   char * RuleName;
   int Symbol;
   PITEMPOS Rule;
   int numCond;   
} CONDITIONPOS;   
typedef CONDITIONPOS *PCONDITIONPOS;

typedef struct _GROUPS{
   char * GroupName;
} GROUPS;   
typedef GROUPS *PGROUPS;
  
typedef struct _NEWSYMBOL{
   char * SymbolName;
   char * GroupName;
   bool fromXml;
   int Code;
   int DimUp;
   int DimDown;
   int DimSx;
   int DimDx;
   int DimDeltaX;
   int DimDeltaY;   
} NEWSYMBOL;   
typedef NEWSYMBOL *PNEWSYMBOL;

#define NAMELENG 20
#define ALLOCSIZE  2000


#endif 



