/********************************************************************/
/*  Progetto......: MOODS                                           */
/*  Modulo........: moods loader                                    */
/*  File..........: lgiust.y                                        */
/*  Autore........: Timna Panfietti Monaco (TMP)                    */
/*  Data revisione: 09/09/98                                        */
/*  Descrizione:    Parser moods                                    */                                               
/********************************************************************/

%{
#define YYSTACKSIZE 1500

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdarg.h>

#include "mil/lgiust.h"
#include "mil/immissione.hpp"
#include "mil/posiz.hpp"
#include "mil/priorita.hpp"
#include "mil/simboli.hpp"

int millex(void);
int milparse(void);

extern char *getenv(const char *);
void Errore(char * comm, char * nom, int num);
          
/* Variabili di lgiust.l */
#define MIL_CHAR char

extern MIL_CHAR *miltext;
extern int MilCompareId(const void * Element1, const void * Element2);
extern KEYWORDMIL MilKeywords[];
extern MilKeywordNumber;
extern ITEMPOS CurrentItemPos;
extern ITEMIMM CurrentItemImm;
extern CONDITIONIMM CurrentConditionImm;
extern CONDITIONPOS CurrentConditionPos;
extern ITEMPOS ItemListPos[];
extern ITEMPOS ItemListPos[];
extern CONDITIONIMM ConditionListImm[];
extern CONDITIONPOS ConditionListPos[];
extern PITEMPOS CurrentRulePos;
extern PITEMIMM CurrentRuleImm;
extern PCONDITIONIMM CurrentCondImm;
extern PCONDITIONPOS CurrentCondPos;
extern RANGE CurrentRange;
extern int CurrentConditionImmUsage;
extern int CurrentConditionPosUsage;

extern FILE *milin;
extern int mil_init;
extern struct mil_buffer_state* mil_scan_string(const char*);
extern void Restart();

extern int lasttoken;
extern int token;
extern int inruleimm;
extern int inrulepos;
extern int incondimm;
extern int incondpos;
extern int CurrentColImm;
extern int CurrentColPos;

Immissione* pimm;
Posiz* ppos;
Priorita* ppri;
Simboli* psym;

int millineno;
int milloadError;    
 
#define YYSTACKSIZE 1500 
   
%}

%union {
     double real;
     int integer;
     char *string;
}

/* ------- Lista dei token (Simboli terminali)------ */
 
%token  <integer> INTEGER
%token RELNOTA
%token RELPAUSA
%token RELSTAFF
%token RELNOTES
%token DEFAULTX
%token ALTERNATIVE
%token ONLEFT
%token ONRIGHT
%token BELOW 
%token ABOVE
%token STEMUP
%token STEMDOWN 
%token BEAM12
%token BEAM23
%token INMULTISTAFF
%token ONSTAFFNUMBER
%token STAFFNUMBER 
%token STAFFLINES
%token SAMESTEMONLEFT
%token SAMESTEMONRIGHT
%token AVOIDINSTAFF
%token OUTSIDESTAFF  
%token ANYWHERE 
%token ONSPACE
%token ONLINE
%token ONSTAFF
%token DOWNWARDS
%token UPWARDS
%token PAUSA
%token THEN 
%token immIF 
%token posIF
%token INMULTIVOICEUPPER 
%token INMULTIVOICELOWER
%token INENDBATTUTA
%token INBEAM
%token INTUPLET
%token INPUNTOVALORE
%token INCHORDSUSPENDED
%token INSTACCATO
%token INLEGVALORE
%token NOT  
%token NOTE
%token NEARNOTA
%token NEARNOTES
%token INCHORD
%token INMULTIVOICE
%token OPPOSITETOSTEM
%token ONSTEM
%token SUSPENDED
%token UPPER
%token LOWER
%token INTERMEDIATE
%token CAMBIOCHIAVE
%token AND 
%token OR
%token XOR 
%token APP
%token ACC
%token GRUP  
%token MORD
%token TRILLO
%token TREM
%token ARP
%token GLISS
%token DIESIS
%token BEMOL 
%token DOPDIES
%token DOPBEMOL 
%token MONES 
%token TRIES
%token LEG
%token STAC
%token IDENTIFIER
%token SFOR  
%token ACCE
%token MARTF
%token TEN
%token MART
%token PUNTOALL
%token LEGVAL
%token PUNTOVAL
%token CORONA
%token LEFTPAR 
%token RIGHTPAR
%token LEFTPARQ 
%token RIGHTPARQ 
%token <real >REAL
%token EQUAL
%token COMMA
%token MAGGIORE
%token MINORE
%token <string>STRING
%token SEMICOLON
%token SCALE
%token <string>RULE_NAME
%token RULEPOS
%token RULEIMM
%token ANGLE
%token STEM
%token PSEMIBREVE
%token PMINIMA
%token PSEMIMINIMA
%token PCROMA
%token PSEMICROMA
%token PBISCROMA
%token PSEMIBISCROMA
%token DELTAX
%token DELTAY
%token UPPERDIST
%token LOWERDIST
%token NUMDOWN
%token NUMUP
%token VAR
%token LENGHT
%token WITH

/*%token UPPERDmLOWERDeZ
%token UPPERDmLOWERDgtZ
%token UPPERDmLOWERDltZ
%token NUMUPmNUMDeZ
%token NUMUPmNUMDgtZ
%token NUMUPmNUMDltZ
%token MEANgtZ
%token MEANeZ
%token MEANltZ
%token DELTAlt2_5
%token DELTAlt0_5
%token DELTAgt0_5
%token DELTAgte2_5
%token BEAMDISgtZ
%token BEAMDISeZ
%token BEAMDISltZ*/

%token BEAM
%token INCHORDTRE
%token ALTERAZIONE
%token INCHORDSETTIMA
%token INCHORDminSETTIMA
%token INCHORDSUSPINTERM
%token INCHORDSUSPUPPER
%token INCHORDSUSPLOWER
%token ARCATA
%token PIZZICATO
%token CORDA
%token ARCATASU
%token ARCATAGIU
%token PUNTA
%token TALLONE
%token PONTICELLO
%token TASTIERA
%token ARCO
%token OTTAVA
%token INOTTAVASOPRA
%token INOTTAVASOTTO
%token INTWOSTAFF
%token INSINGLELAYER
%token NOTAWITH
%token NOTES
%token BISCROMA
%token SEMIBISCROMA
%token FUSA
%token CROMA
%token SEMICROMA

%token SEMIMINIMA
%token MINIMA
%token SEMIBREVE
%token BREVE

%token NOTINA

%token RULEPRI
%token STEMHEIGHT
%token MOBEMOL
%token TRIBEMOL
/*%token BSLOPE*/
%token FIRSTUPPER
%token FIRSTLOWER
%token PRECEED
/*%token MEANmMHLgt1_5*/
%token NBEAT
%token TIME
%token BATTUTA
%token COPPIE
%token OFF
%token ON
%token GTinBEAT

%token GREATER
%token LOWer
%token LOWERe
%token GREATERe

%token UPPERD 
%token LOWERD
%token MEAN
%token DELTA
%token BEAMDIS
%token MHL
%token PLUS
%token MIN


%type <real> singlevalue
%type <integer> Symbol
%type <integer> notapausa
%type <integer> time
%type <integer> factor
%type <integer> operation
%type <integer> result
%type <integer> HeadType

%token DEFGROUP 
%token DEFSYM
%token GROUP
%token CODE
%token DIM

%token CONSORD
%token VIASORD
%token ARM
%token DITEG

%token HEAD
%token CLASSIC
%token ALPHANUM
%token ALPHANUM_SQUARE
%token ALPHANUM_REVERSE
%token CIRCLEX
%token CLUSTER
%token X_HEAD
%token CROIX
%token DDIESIS
%token DIAMOND
%token TRIANG
%token TRIANG_UP
%token TRIANG_DOWN
%token TRIANG_LEFT
%token TRIANG_RIGHT
%token TRIANG_ROUND
%token MOON
%token PLUS_HEAD
%token RHYTHMIC
%token SQUARE

%token STEMSTART

/* ------ Rule section ------ */
%%

MILLA: IstMILLA 
       | IstMILLA MILLA

BodyIstMILLA: Situation 
              | FixedRule 
	          | Assignment
	          | Priority
		      | DefNewSymbol
		      | DefNewGroup
	   

IstMILLA: BodyIstMILLA SEMICOLON

DefNewGroup: DEFGROUP STRING 
             { 
			   psym->AddGroup($2);
			 }

DefNewSymbol: DEFSYM STRING { psym->AddSymbolName($2);} Group Code Dim 
              { psym->Incrementa();}
                  

Code: CODE EQUAL INTEGER
      {
	    psym->AddCode($3);
	  }

Group: GROUP EQUAL STRING 
       {
	     psym->AddGroupName($3);
	   }

Dim: | DIM EQUAL INTEGER COMMA INTEGER COMMA INTEGER COMMA INTEGER COMMA INTEGER
       COMMA INTEGER
       {
	     psym->AddDim($3,$5,$7,$9,$11,$13);
	   }   

FixedRule : RULEIMM RULE_NAME Type Rule { CurrentRuleImm = NULL; }
            | RULEPOS RULE_NAME Type Rule { CurrentRulePos = NULL; }
	     
Type :  | DEFAULTX 
        { SetType(); }
        | ALTERNATIVE
        { SetType(); }

Rule : Symbol rel cat staff coord other

Symbol : STEM 
         {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }
        | HEAD 
         {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }
        | STEMSTART
         {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }

	| BEAM
	 {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }
	| OTTAVA
	 {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }
	| BATTUTA
	 {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }
        | Abbellimenti 
	 {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }
        | Indicazioni 
	 {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }
	| Alterazioni 
	 {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }
	| Espressione 
	 { 
	    $$ = lasttoken;
	    SetSymbol();
	 }
	| VariazValore 
	 {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }
	| Pause
         {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }
	| Archi 
	 {
	    $$ = lasttoken;
	    SetSymbol(); 
	 }
	| STRING
	 {
	 // ricavo la posizione della stringa corrispondente al nome del
	 // gruppo dall'array in cui l'ho definito....
	 
	    
	    token=psym->GetGroupPos($1);
		//printf("token=%d\n",token);
	 
	    if(token!=-1)
		{
	     
	 	 // adesso assegno un numero alla stringa dipendente proprio dal numero
	     // ricavato..
	 
	      lasttoken=1000+token;		
		  SetSymbol();	
		}
		else 
		  printf("Line:%d Hai utilizzato nella regola un gruppo non definito\n", millineno);	 	    
	 }

	 
	 
Abbellimenti : APP 
               | ACC 
	       | GRUP 
	       | MORD 
	       | TRILLO 
	       | TREM 
	       | ARP 
	       | GLISS

Indicazioni : CONSORD 
               | VIASORD 
	       | ARM 
	       | DITEG

Alterazioni : DIESIS 
              | BEMOL 
	          | DOPDIES 
	          | DOPBEMOL 
	          | MONES 
	          | TRIES
	          | ALTERAZIONE
	          | MOBEMOL
	          | TRIBEMOL

Espressione : LEG 
              | STAC 
	          | SFOR 
	          | ACCE 
	          | MARTF 
	          | TEN 
	      	  | MART
	          | PUNTOALL

VariazValore: LEGVAL 
              | PUNTOVAL 
	      | CORONA

Pause : PSEMIBREVE 
        | PMINIMA 
	| PSEMIMINIMA 
	| PCROMA 
	| PSEMICROMA 
	| PBISCROMA 
	| PSEMIBISCROMA
	
Archi : ARCATA
        | PIZZICATO
	| CORDA
	| ARCATASU
	| ARCATAGIU
	| PUNTA
	| TALLONE
	| PONTICELLO
	| TASTIERA
	| ARCO
		          
rel : RELNOTA 
       { Setrel(); }
      | RELPAUSA 
       { Setrel(); }
      | RELSTAFF
       { Setrel(); }
      | RELNOTES
       { Setrel(); } 

cat : | wheresimbolo 
       { Setcat(); }
      | belwab 
       { Setcat(); } 
      | stem 
       { Setcat(); }
      | spaceline
       { Setcat(); }
      | rightleft 
       { Setcat(); }
      | SAMESTEMONLEFT 
       { Setcat(); }
      | SAMESTEMONRIGHT
       { Setcat(); } 
/*      | ONSTAFF 
           { Setcat(); }  
        | AVOIDINSTAFF 
           { Setcat(); }
        | lenght 
        | ANYWHERE 
           { Setcat(); }  */
	
rightleft : ONLEFT
            | ONRIGHT 

wheresimbolo : OPPOSITETOSTEM 
               | ONSTEM

belwab : BELOW 
         | ABOVE

stem : STEMUP 
       | STEMDOWN | BEAM12 | BEAM23

staff :| AVOIDINSTAFF 
        { Setstaff(); }
       | OUTSIDESTAFF 
        { Setstaff(); }
       | ANYWHERE 
        { Setstaff(); }
       | ONSTAFF
        { Setstaff(); }
       | lenght
       | code
       | nbeat
/*     | belwab
          { Setstaff(); }
       | spaceline 
          { Setstaff(); } */

spaceline : ONSPACE 
            | ONLINE

lenght : LENGHT EQUAL REAL
             { if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->lenght=$3;
		 }
	      } 
	 | LENGHT EQUAL INTEGER
             { if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->lenght=$3;
		 }
	      }     
	       
	 | LENGHT EQUAL VAR
             { if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->lenght=lasttoken;
		 }
	      }     
         | LENGHT EQUAL Range
	   { if (CurrentRulePos!=NULL)
	     {	
               CurrentRulePos->rangelenght.min=CurrentRange.min;
               CurrentRulePos->rangelenght.max=CurrentRange.max;	
	     }  
           }
	 | LENGHT EQUAL STEMHEIGHT
	   { if (CurrentRulePos!=NULL)
	     {	
               CurrentRulePos->lenght=lasttoken;	
	     }
           }   
   
code: CODE EQUAL INTEGER
             { if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->code=$3;
		 }
	      } 

nbeat:  NBEAT EQUAL REAL
             { if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->lenght=$3;
		 }
	      } 
	 | NBEAT EQUAL INTEGER
             { if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->lenght=$3;
		 }
	      }     
	      
   

Range : LEFTPARQ singlevalue SEMICOLON singlevalue RIGHTPARQ
         {
	   CurrentRange.min=$2;
	   CurrentRange.max=$4;
         }

coord : | dx dy | dy

dx : DELTAX EQUAL REAL 
       { if (CurrentRulePos!=NULL)
	  {
            CurrentRulePos->dx=$3;
          }
       } 
     | DELTAX EQUAL INTEGER 
       { if (CurrentRulePos!=NULL)
	  {
           CurrentRulePos->dx=$3;
          }
       }  
     | DELTAX EQUAL VAR
       { if (CurrentRulePos!=NULL)
	  {
            CurrentRulePos->dx=lasttoken;
          }
       }
     | DELTAX EQUAL Range
        { if (CurrentRulePos!=NULL)
	  {	
            CurrentRulePos->rangedx.min=CurrentRange.min;
            CurrentRulePos->rangedx.max=CurrentRange.max;	
	  }  
        }
   
dy : DELTAY EQUAL REAL 
       { if (CurrentRulePos!=NULL)
	  {
            CurrentRulePos->dy=$3;
          }
       } 
     | DELTAY EQUAL INTEGER 
       { if (CurrentRulePos!=NULL)
	  {
           CurrentRulePos->dy=$3;
          }
       }  
     | DELTAY EQUAL VAR
       { if (CurrentRulePos!=NULL)
	  {
            CurrentRulePos->dy=lasttoken;
          }
       }
     | DELTAY EQUAL Range
        { if (CurrentRulePos!=NULL)
	  {	
            CurrentRulePos->rangedy.min=CurrentRange.min;
            CurrentRulePos->rangedy.max=CurrentRange.max;	
	  }  
        }

singlevalue : REAL 
               { $$=$1; }
              | INTEGER 
	       { $$=$1; }
	      | VAR
	       { $$=lasttoken; }
	      
other : scale shape angle coppie abilterzine

scale : | SCALE EQUAL REAL
          { if (CurrentRulePos!=NULL)
	    {
              CurrentRulePos->scale=$3;
            }
          } 

angle : | ANGLE EQUAL REAL
          { if (CurrentRulePos!=NULL)
	    {
              CurrentRulePos->angle=$3;
            }
          }
/*	| ANGLE EQUAL BSLOPE
          { if (CurrentRulePos!=NULL)
	    {
              CurrentRulePos->angle=lasttoken;
            }
          }  */
	| ANGLE EQUAL Range   
	{ if (CurrentRulePos!=NULL)
	  {	
            CurrentRulePos->rangeangle.min=CurrentRange.min;
            CurrentRulePos->rangeangle.max=CurrentRange.max;	
	    CurrentRulePos->angle=BSLOPE;
	  }  
        }  

shape : | shapeis  

shapeis : DOWNWARDS
           { if (CurrentRulePos!=NULL)
             {
               CurrentRulePos->shape=lasttoken;
             }
           }
          | UPWARDS 
	   { if (CurrentRulePos!=NULL)
             {
               CurrentRulePos->shape=lasttoken;
             }
           }


coppie: | COPPIE EQUAL LEFTPARQ singlevalue COMMA singlevalue SEMICOLON
singlevalue COMMA singlevalue RIGHTPARQ
          {
	    CurrentRulePos->coppie[1].min=$4;
	    CurrentRulePos->coppie[1].max=$6;
	    CurrentRulePos->coppie[2].min=$8;
	    CurrentRulePos->coppie[2].max=$10;
           
	  } 
	  
abilterzine: | GTinBEAT EQUAL OFF
               {
	         CurrentRulePos->abilterzine=OFF;
	       } 
             | GTinBEAT EQUAL ON	  
	       {
	         CurrentRulePos->abilterzine=ON;
	       }
	        
Situation : immIF TypeCondition THEN RULE_NAME 
             { 
              // printf("Rule name %s\n",$4);
               
			   
	         CurrentCondImm->RuleName = (char *)malloc(strlen($4) + 1);
               if (CurrentCondImm->RuleName==NULL)
                 Errore("allocation","RuleName",0);
               strcpy(CurrentCondImm->RuleName, $4);
               CurrentColImm=0; 
	       CurrentCondImm = NULL;
             }
	    | posIF TypeCondition THEN RULE_NAME
	       { 
             //  printf("Rule name %s\n",$4);
               CurrentCondPos->RuleName = (char *)malloc(strlen($4) + 1);
               if (CurrentCondPos->RuleName==NULL)
                 Errore("allocation","RuleName",0);
               strcpy(CurrentCondPos->RuleName, $4);
               CurrentColPos=0; 
	       CurrentCondPos = NULL;
               }

TypeCondition : condition 
                | condition OpBool TypeCondition 
		| NOT condition

condition : notapausa wherenotapausa
            { 
	      token = $1;
	      SetCondizione(); 
	    } 
            | Symbol shapeis
	    { 
	      token = $1;
	      SetCondizione(); 
	    } 
	    | Symbol WITH Symbol 
	    {
	      token = $1;
	      SetCondizione();
	    } 
	    | NOTAWITH Symbol 
	    {
	      token = NOTAWITH;
	      SetCondizione();
	    }
	    | notapausa Range 
	    {
	      if (CurrentColImm<20)
	      { if (CurrentCondImm!=NULL)
	       {
	        token = $1;
                CurrentCondImm->condizioni[CurrentColImm].cond=token;
	        CurrentCondImm->condizioni[CurrentColImm].range.min=CurrentRange.min;
                CurrentCondImm->condizioni[CurrentColImm++].range.max=CurrentRange.max;
	        CurrentCondImm->numCond++;	
	       } 
	      }
	      if (CurrentColPos<20)
	      { if (CurrentCondPos!=NULL)
	       {
	        token = $1;
                CurrentCondPos->condizioni[CurrentColPos].cond=token;
	        CurrentCondPos->condizioni[CurrentColPos].range.min=CurrentRange.min;
                CurrentCondPos->condizioni[CurrentColPos++].range.max=CurrentRange.max;
	        CurrentCondPos->numCond++;	
	       } 
	      }  
            }
            | namecondition  
	    | where 
	    { 
	      SetCol();
	    }
	    | wheresimbolo 
	     { 
	      SetCol();
	     }
	    | notapausa kind  
	    { 
	      token = $1;
	      SetCondizione();
	    }  
	    | Symbol PRECEED Symbol
	    {
	      token = $1;
	      SetCondizione();
	    }
	    
          /*| UPPERDmLOWERDeZ
	    { 
	      SetCol(); 	    
	    }
	    | UPPERDmLOWERDgtZ
	    { 
	      SetCol(); 	    
	    } 
            | UPPERDmLOWERDltZ
	    { 
	      SetCol(); 	    
	    }
	    | NUMUPmNUMDeZ
	    { 
	      SetCol(); 	    
	    }
	    | NUMUPmNUMDgtZ
	    { 
	      SetCol(); 	    
	    }
	    | NUMUPmNUMDltZ
	    { 
	      SetCol(); 	    
	    }
	    | MEANgtZ
	    { 
	      SetCol(); 	    
	    }
            | MEANeZ
	    { 
	      SetCol(); 	    
	    }
	    | MEANltZ
	    { 
	      SetCol(); 	    
	    }
	    | DELTAlt2_5
	    { 
	      SetCol(); 	    
	    }
	    | DELTAlt0_5
	    { 
	      SetCol(); 	    
	    }
	    | DELTAgt0_5
	    { 
	      SetCol(); 	    
	    }
	    | DELTAgte2_5
	    { 
	      SetCol(); 	    
	    }
	    | BEAMDISgtZ
	    { 
	      SetCol(); 	    
	    }
	    | BEAMDISeZ
	    { 
	      SetCol(); 	    
	    }    
	    | BEAMDISltZ
	    { 
	      SetCol(); 	    
	    }
	    | MEANmMHLgt1_5
	    {
	      SetCol();
	    }*/
	    
	    | time EQUAL singlevalue SEMICOLON singlevalue
	    {
	      if (CurrentColImm<20)
	      { 
	      if (CurrentCondImm!=NULL)
	       {
		 token = $1;
        	 CurrentCondImm->condizioni[CurrentColImm].cond=token;
		 CurrentCondImm->condizioni[CurrentColImm].range.min=$3;
        	 CurrentCondImm->condizioni[CurrentColImm++].range.max=$5;
		 CurrentCondImm->numCond++;	
		} 
	      }
	      if (CurrentColPos<20)
	      { 
	      if (CurrentCondPos!=NULL)
	       {
		 token = $1;
        	 CurrentCondPos->condizioni[CurrentColPos].cond=token;
		 CurrentCondPos->condizioni[CurrentColPos].range.min=$3;
        	 CurrentCondPos->condizioni[CurrentColPos++].range.max=$5;
		 CurrentCondPos->numCond++;	
		} 
	       }  
             }  
	     | factor operation factor result REAL
	     {
	       if (CurrentColImm<20)
	       {
	        if (CurrentCondImm!=NULL)
	        {
		  token = $1;
	          CurrentCondImm->condizioni[CurrentColImm].cond=RELATION;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.f1=token;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.Op=$2;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.f2=$3;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.res=$4;
		  CurrentCondImm->condizioni[CurrentColImm++].conditionrel.num=$5;
		  CurrentCondImm->numCond++;
		 }
	       } 
	       if (CurrentColPos<20)
	       {
	        if (CurrentCondPos!=NULL)
	        {
		  token = $1;
	          CurrentCondPos->condizioni[CurrentColPos].cond=RELATION;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.f1=token;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.Op=$2;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.f2=$3;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.res=$4;
		  CurrentCondPos->condizioni[CurrentColPos++].conditionrel.num=$5;
		  CurrentCondPos->numCond++;
		 }
	       }
	     }
	     | factor result REAL
	     {
	       if (CurrentColImm<20)
	       {
	        if (CurrentCondImm!=NULL)
	        {
		  token = $1;
	          CurrentCondImm->condizioni[CurrentColImm].cond=RELATION;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.f1=token;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.Op=99;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.f2=99;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.res=$2;
		  CurrentCondImm->condizioni[CurrentColImm++].conditionrel.num=$3;
		  CurrentCondImm->numCond++;
		 }
	       } 
	       if (CurrentColPos<20)
	       {
	        if (CurrentCondPos!=NULL)
	        {
		  token = $1;
	          CurrentCondPos->condizioni[CurrentColPos].cond=RELATION;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.f1=token;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.Op=99;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.f2=99;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.res=$2;
		  CurrentCondPos->condizioni[CurrentColPos++].conditionrel.num=$3;
		  CurrentCondPos->numCond++;
		 }
	       }
	     }
	     |  HEAD HeadType
	     {
	     	token=HEAD;
	     	SetCondizione();
	     }

HeadType: CLASSIC
       { $$ = lasttoken; }     
          | ALPHANUM
       { $$ = lasttoken; }     
          | ALPHANUM_SQUARE
       { $$ = lasttoken; }     
          | ALPHANUM_REVERSE
       { $$ = lasttoken; }     
          | CIRCLEX
       { $$ = lasttoken; }     
          | CLUSTER
       { $$ = lasttoken; }     
          | X_HEAD
       { $$ = lasttoken; }     
          | CROIX
       { $$ = lasttoken; }     
          | DDIESIS
       { $$ = lasttoken; }     
          | DIAMOND
       { $$ = lasttoken; }     
          | TRIANG
       { $$ = lasttoken; }     
          | TRIANG_UP
       { $$ = lasttoken; }     
          | TRIANG_DOWN
       { $$ = lasttoken; }     
          | TRIANG_LEFT
       { $$ = lasttoken; }     
          | TRIANG_RIGHT
       { $$ = lasttoken; }     
          | TRIANG_ROUND
       { $$ = lasttoken; }     
          | MOON
       { $$ = lasttoken; }     
          | PLUS_HEAD
       { $$ = lasttoken; }     
          | RHYTHMIC
       { $$ = lasttoken; }     
          | SQUARE
       { $$ = lasttoken; }     

factor: UPPERD
       { $$ = lasttoken; }     
       | LOWERD
       { $$ = lasttoken; } 
       | NUMUP
       { $$ = lasttoken; }  
       | NUMDOWN
       { $$ = lasttoken; }  
       | MEAN
       { $$ = lasttoken; }  
       | DELTA
       { $$ = lasttoken; }  
       | BEAMDIS
       { $$ = lasttoken; }  
       | MHL
       { $$ = lasttoken; }  	 
       | STAFFNUMBER
       { $$ = lasttoken; }  	 
       | ONSTAFFNUMBER
       { $$ = lasttoken; }  	 
       | STAFFLINES
       { $$ = lasttoken; }  	 
		
		
operation: PLUS
          { $$ = PLUS; }
          | MIN
	  { $$ = MIN; }
	 
result: GREATER
       { $$ = GREATER; }
       | LOWer
       { $$ = LOWer; }
       | GREATERe
       { $$ = GREATERe; }
       | LOWERe
       { $$ = LOWERe; }
       | EQUAL
       { $$ = EQUAL; }
       		 		 		 
	     
time: TIME
       { $$ = lasttoken; }     
	    
notapausa : NOTE
             { $$ = lasttoken; }
            | NOTES
	     { $$ = lasttoken; }   
	    | PAUSA
	     { $$ = lasttoken; }
	    | NEARNOTA
	     { $$ = lasttoken; }
	    | PSEMIBREVE 
	     { $$ = lasttoken; }
	    | PMINIMA
	     { $$ = lasttoken; }
	    | NEARNOTES
	     { $$ = lasttoken; }
	      

wherenotapausa : where
                 | spaceline
		 | rightleft 
		 | INBEAM 
		 | INTUPLET 
		 | INPUNTOVALORE 
		 | INCHORDSUSPENDED
		 | INCHORDTRE
		 | INCHORDSUSPINTERM
		 | INCHORDSUSPUPPER
		 | INCHORDSUSPLOWER
		 | INSTACCATO 
		 | INLEGVALORE
                 
		 
where : INCHORD
        | INMULTIVOICE 
	| INMULTIVOICEUPPER 
	| INMULTIVOICELOWER 
	| INENDBATTUTA
	| INSINGLELAYER        
	| INCHORDSETTIMA 
	| INCHORDminSETTIMA 	
	| INOTTAVASOPRA
	| INOTTAVASOTTO
	| INTWOSTAFF
	| INMULTISTAFF	
       
       
kind : stem 
       | belwab 
       | SUSPENDED 
       | UPPER 
       | LOWER 
       | INTERMEDIATE 
       | CAMBIOCHIAVE
       | BISCROMA
       | SEMIBISCROMA
       | FUSA
       | CROMA
       | SEMICROMA
       | FIRSTUPPER
       | FIRSTLOWER
       | SEMIMINIMA
       | MINIMA
       | SEMIBREVE
       | BREVE
       | NOTINA
       

OpBool : AND 
         | OR 
	 | XOR

Assignment : namecondition EQUAL TypeCondition

namecondition : STRING

Priority : RULEPRI listsymbolpri

listsymbolpri : | symbolpri listsymbolpri

symbolpri : STAC 
            { ppri->AddPriority(lasttoken);}
            | TEN
	    	{ ppri->AddPriority(lasttoken);}
	    	| LEG 
	    	{ ppri->AddPriority(lasttoken);}
            | SFOR
	    	{ ppri->AddPriority(lasttoken);} 
	    	| ACCE 
	    	{ ppri->AddPriority(lasttoken);}
	    	| MARTF 
	    	{ ppri->AddPriority(lasttoken);}
	    	| MART
	    	{ ppri->AddPriority(lasttoken);}
	    	| PUNTOALL
	    	{ ppri->AddPriority(lasttoken);}
	    	| GRUP 
	    	{ ppri->AddPriority(lasttoken);}
	    	| MORD
	    	{ ppri->AddPriority(lasttoken);}
	    	| TRILLO 
	    	{ ppri->AddPriority(lasttoken);}
	    	| ARCATA
	    	{ ppri->AddPriority(lasttoken);}
	    	| ARCO
	    	{ ppri->AddPriority(lasttoken);}
            | PIZZICATO
	    	{ ppri->AddPriority(lasttoken);}
	    	| CORDA
	    	{ ppri->AddPriority(lasttoken);}
	    	| ARCATASU
	    	{ ppri->AddPriority(lasttoken);}
	    	| ARCATAGIU
	    	{ ppri->AddPriority(lasttoken);}
	    	| PUNTA
	    	{ ppri->AddPriority(lasttoken);}
	    	| TALLONE
	    	{ ppri->AddPriority(lasttoken);}
	    	| PONTICELLO 
	    	{ ppri->AddPriority(lasttoken);}
	    	| TASTIERA 
	    	{ ppri->AddPriority(lasttoken);}
	    	| CORONA 
	    	{ ppri->AddPriority(lasttoken);}
	    	| DITEG 
	    	{ ppri->AddPriority(lasttoken);}
	    	| ARM 
	    	{ ppri->AddPriority(lasttoken);}
	    	| CONSORD 
	    	{ ppri->AddPriority(lasttoken);}
	    	| VIASORD 
	    	{ ppri->AddPriority(lasttoken);}
			| STRING
			{ 	 
			  // ricavo la posizione della stringa corrispondente al nome del
	          // simbolo dall'array ....
	 	     
		      token=psym->GetSymbolPos($1);
	          if(token!=-1)
		      {

	          // adesso assegno un numero alla stringa dipendente proprio 
			  //dal numero ricavato..	         
		        
				ppri->AddPriorityGen(2000+token);
			  }
			  else 
			   printf("Linea:%d Hai inserito nella lista delle priorita' un simbolo non definito\n",millineno);
			}

%%
/* ------ Program section ------ */

void milerror(char *msg)  
{
  printf("Milla: %s line %d %s",msg,millineno,miltext);
  milloadError=1;
  fclose(milin);
  return;
}

void InitLoad(Immissione* pruleimm, Posiz* prulepos,
Priorita* prulepri, Simboli* psymbol)
{
  pimm = pruleimm;
  ppos = prulepos;
  ppri = prulepri;
  psym = psymbol;  
  
  
  // Fa il sort delle keywords per load
  qsort(MilKeywords, MilKeywordNumber, sizeof(KEYWORDMIL), MilCompareId);
  millineno = 1;
  milloadError = 0;
  
  CurrentColImm=0;
  CurrentColPos=0;
  pimm->Reset();
  ppos->Reset();
  ppri->Reset();
  psym->Reset();
}

void SetType()
{
   if (CurrentRuleImm!=NULL) 
   
   /*il puntatore CurrentRuleImm e' diverso da zero solo se sto 
     definendo una nuova regola. In questo caso allora non occorre
     piu' inrule=2*/
     
   {
     CurrentRuleImm->Type=lasttoken;
  
   /*questa operazione associa al campo Type della struttura ITEMIMM
     il numero associato al token che ha riconosciuto, in questo caso
     DEFAULT o ALTERNATIVE*/
     
   }
   
/*  if (CurrentRulePos!=NULL) 
   
   /*il puntatore CurrentRulePos e' diverso da zero solo se sto 
     definendo una nuova regola. In questo caso allora non occorre
     piu' inrule=2*/
     
  /* {
     CurrentRulePos->Type=lasttoken;
  
   /*questa operazione associa al campo Type della struttura ITEMPOS
     il numero associato al token che ha riconosciuto, in questo caso
     DEFAULT o ALTERNATIVE*/
     
  /* } */
}

void SetSymbol()
{
   if (CurrentRuleImm!=NULL) 
   {
     CurrentRuleImm->Symbol=lasttoken;
   }
   
   if (CurrentRulePos!=NULL) 
   {
     CurrentRulePos->Symbol=lasttoken;
   }
 
} 

void Setrel()
{
   if (CurrentRuleImm!=NULL) 
   {
     CurrentRuleImm->rel=lasttoken;
   }
   
   if (CurrentRulePos!=NULL) 
   {
     CurrentRulePos->rel=lasttoken;
   }
   
 
}

void Setcat()
{
   if (CurrentRuleImm!=NULL) 
   {
     CurrentRuleImm->cat=lasttoken;
   }
   
   if (CurrentRulePos!=NULL) 
   {
     CurrentRulePos->cat=lasttoken;
   }
}

void Setstaff()
{
   if (CurrentRulePos!=NULL) 
   {
     CurrentRulePos->staff=lasttoken;
   }
 
} 

void SetCol()
{ 
  if (CurrentColImm<20)
   {
     if (CurrentCondImm!=NULL)
      {
       CurrentCondImm->condizioni[CurrentColImm++].cond=lasttoken;
       CurrentCondImm->numCond++;
      }
   }
  if (CurrentColPos<20)
   {
     if (CurrentCondPos!=NULL)
      {
       CurrentCondPos->condizioni[CurrentColPos++].cond=lasttoken;
       CurrentCondPos->numCond++;
      }
   } 
}

void SetCondizione()
{
 if (CurrentColImm<20)
 {
   if (CurrentCondImm!=NULL)
    {
     CurrentCondImm->condizioni[CurrentColImm++].cond=1000*token+lasttoken;
     CurrentCondImm->numCond++;
    }
  }
 if (CurrentColPos<20)
 {
   if (CurrentCondPos!=NULL)
    {
     CurrentCondPos->condizioni[CurrentColPos++].cond=1000*token+lasttoken;
     CurrentCondPos->numCond++;
    }
  } 
}  
    



/*main()
{ 
    //Legge da un file 
  milin = fopen( "Milla", "r" );

  if(milin == NULL)
  {
    printf("File non trovato");
    exit(1);
  } 

  InitLoad();

  yyparse();

/*Eseguo l'ordinamento per simboli come ultima operazione in modo
da mantenere quella precedente in fase di elaborazione*/

/*  ruleManager.sortSymbol();
  ruleManager.sortCondition();
  ruleManager.seeItemListImm();
  ruleManager.seeItemListPos();
  ruleManager.seeConditionList();
  
  
  printf("Digitare il token relativo al simbolo da cercare:\n");
  scanf("%d",&CurrentItemImm.Symbol);
  pimm.searchSymbolImm(CurrentItemImm.Symbol);
  CurrentItemPos.Symbol=CurrentItemImm.Symbol;
  ppos.searchSymbolPos(CurrentItemPos.Symbol);

  fclose(milin);

  if(milloadError==1)
  {
    printf("Error in line %d",millineno);
    exit(1);
  } else 
  {
    printf("No error");
  }
   
 
  
  
}*/



