/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */



#ifndef POSIZ_HPP
#define POSIZ_HPP

#include "mil/rulemanager.hpp"
#include "drw/drawobje.hpp"

class Posiz: public RuleManager
{
protected:
	
    static int CurrentItemPosUsage;
    static int CurrentConditionPosUsage;
	
	
    static ITEMPOS ItemListPos[MAXNUMITEM];
    static CONDITIONPOS ConditionListPos[MAXNUMCONDITION];
	
	
public:
	
    Posiz();
    void Reset();
	
	void dump(void);
    int dumpsufile;
	///////////////////////////////////////
	
    PITEMPOS AddItemPos(char* Item, int ItemType);
    PCONDITIONPOS AddConditionPos();
	
    float PosRule(DrawObject* drw, Nota* pNota, Battuta* pBattuta, 
		Bool gamboupdwn, short current_layer=0,short current_staff=0);
    Point PosRuleP(DrawObject* drw, Nota* pNota, Battuta* pBattuta, 
		Bool gamboupdwn, short current_layer=0,short current_staff=0);	
    PITEMPOS PosRulePunt(DrawObject* drw, Nota* pNota, Battuta*
		pBattuta, Bool gamboupdwn, short current_layer,short current_staff, int traceconditionsmilla);
    float PosRuleBeam(DrawObject* drw, Nota* pNota, Battuta*
		pBattuta, Bool gamboupdwn, short current_layer, RANGE* coppie,short current_staff=0); 
    Bool PosRuleTer(DrawObject* drw, Nota* pNota, Battuta*
		pBattuta, Bool gamboupdwn, short current_layer,short current_staff=0); 
    int PosRuleHead(DrawObject* drw, Nota* pNota, Battuta*
		pBattuta, Bool gamboupdwn, short layer,short current_staff=0); 
    void PosRuleStartGambo(DrawObject* drw, Nota* pNota, Battuta*
		pBattuta, Bool gamboupdwn, short layer,short current_staff=0); 
	
    PITEMPOS searchConditionPos(int a, Nota* pNota, Battuta* pBattuta,
		DrawObject* drw, Bool gamboupdwn, short current_layer, short current_staff, int traceconditionsmilla);
	
    void InitRulePos();
    void sortSymbolPos(void);
    void seeConditionListPos(void);   
    void seeItemListPos(void);
    void sortConditionPos(void);
    void sortRulePos(void);
    PITEMPOS searchRulePos(char* ruleName);
    PITEMPOS SearchNamePos(char *name);
    PITEMIMM searchConditionPos(int a);
	
    // per debug milla
    void Posiz::TestTokenCond(Nota* pNota, DrawObject* drw,
		Battuta* pBattuta, Bool gamboupdown, short layer=0);
	
};

#endif //POSIZ_HPP
