/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */



#include "mil/rulemanager.hpp"
#include "mil/m.tab.h"
#include "mil/priorita.hpp"

int PriorityList[MAXNUMSYMBOLPRI];
int Priorita::CurrentPriorityUsage = 0;
int Priorita::list[NUMSYMBOLPRI];
int Priorita::LegPos = 0;

Priorita::Priorita()
{
	CurrentPriorityUsage = 0;
	
	list[LEG] = CL_LEGATURA;
	list[STAC] = CL_STACCATO;
	list[SFOR] = CL_SFORZATO;
	list[ACCE] = CL_ACCENTO;
	list[TEN] = CL_TENUTO; 
	list[MARTF] = CL_MARTELLATO;
	list[MART] = CL_MARTDOLCE;
	list[PUNTOALL] = CL_PUNTOALLUNGATO;
	list[TASTIERA] = CL_TASTIERA;
	list[PUNTA] = CL_PUNTA;
	list[TALLONE] = CL_TALLONE;
	list[PONTICELLO] = CL_PONTICELLO; 
	list[ARCATAGIU] = CL_ARCOGIU;
	list[ARCATASU] = CL_ARCOSU;
	list[PIZZICATO] = CL_PIZZICATO;
	list[ARCO] = CL_ARCO;
	list[CORDA] = CL_CORDA;
	list[MORD] = CL_MORDENTE;
	list[GRUP] = CL_GRUPPETTO;  
	list[TRILLO] = CL_TRILLO;
	list[CONSORD] = CL_CONSORDINA;
	list[VIASORD] = CL_VIASORDINA;  
	list[ARM] = CL_ARMONICI;
	list[DITEG] = CL_DITEGGIATO;

	list[KORN]		= CL_KOREANORNAMENT;
}

void Priorita::Reset()
{
	CurrentPriorityUsage = 0;
} 

void Priorita::AddPriority(int symbolpri)
{   
	PriorityList[CurrentPriorityUsage]=list[symbolpri];
	CurrentPriorityUsage++;
}

void Priorita::AddPriorityGen(int symbolprigen)
{   
	PriorityList[CurrentPriorityUsage]=symbolprigen;
	CurrentPriorityUsage++;
}

void Priorita::SetLegPos(void)
{
	int i;
	LegPos=-1;
	for(i=0; i<CurrentPriorityUsage; i++)
	{
		if(PriorityList[i]==CL_LEGATURA)
		{
			LegPos=i;
		}
	}
}

int Priorita::GetPriorityUsage(void)
{
	return CurrentPriorityUsage;
}

int Priorita::GetSymbolPri(int i)
{
	return PriorityList[i];
}  

int Priorita::GetLegPos(void)
{
	return LegPos;
}  

int Priorita::GetPosizione(long ID)
{
	int i;
	for(i=0; i<MAXNUMSYMBOLPRI; i++)
	{
		if(PriorityList[i]==ID)
			return i;
	}
	return -1;
}    

void Priorita::seePriorityList(void)
{ 
	int i;
	for (i=0;i<CurrentPriorityUsage;i++)
    {  
		fprintf(stdout,"Simbolo di priorita':%d\n",
			PriorityList[i]);          
    } 
}  


