/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#ifndef RULEMANAGER_HPP
#define RULEMANAGER_HPP


#define NUMEROID 1000

#include "mil/lgiust.h"
#include "bat/battuta.hpp"
#include "fig/nota.hpp"
#include "int/raggruppamento.hpp"

class RuleManager
{
	
protected:
	
	static int tab[NUMEROID];
	
public:
	
	RuleManager();
	
	
	void sortSymbol(void);
	// Permette di ordinare la lista delle regole (sia di immissione che di 
	// posizionamento) secondo il campo dei simboli e percio' non 
	// in ordine alfabetico rispetto ai nomi delle regole. Lo scopo e' quello 
	// di poter fare poi una successiva ricerca delle regole associate a 
	// determinati simboli scelti.
	
	Bool ValutaCondizioni(Condizione *pcond, Nota* pNota, Battuta* pBattuta, 
		DrawObject* drw, short current_layer, Bool	 gamboupdwn, int traceconditionsmilla);
	
	float ValutaFactor(int fact, Nota *pNota, DrawObject *drw);			 
    
    void ValutaCondizioniDebug(Nota* pNota, Battuta* pBattuta, 
		DrawObject* drw,short current_layer, Bool gamboupdwn );
	
    
};

#endif //RULEMANAGER_HPP
