/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#ifndef SIMBOLI_HPP
#define SIMBOLI_HPP

#define MAXNUMGROUPS 10 
#define MAXNUMSYM 256*MAXNUMGROUPS

#include "mil/rulemanager.hpp" 



class Simboli
{
protected:
	
    static int CurrentGroupUsage;
	static int CurrentSymbolUsage;
	static GROUPS Groups[MAXNUMGROUPS];
	static NEWSYMBOL Symbol[MAXNUMSYM];
	
    SMRFile* smrf;
	
public:
	
    Simboli();
    void Reset();
	
	void SetSMRFile(SMRFile *w) { smrf=w;};
	SMRFile* GetSMRFile() { return smrf;};
    
    void AddGroup(char *groupname, char *filename = "", int fontSize=50);
	void AddSymbolName(char *symbolname); 
	void AddGroupName(char *groupname); 
	void AddCode(int code);
	void AddDim(int dimup, int dimdown, int domsx, int dimdx, int deltax, int deltay);
	
	void SetDim(int id_font, int id_symb);
	// se non e' stato definito DIM in milla il simbolo prende le posizioni dal file.tbl 
	
	void seeStruct();
	void Incrementa();
	
	int GetGroupPos(char* groupname);
	int GetSymbolPos(char* symbolname);
    int GetSymbolUsage(void);
	int GetGroupUsage(void);
	
	char *GetGroup(int IDsym);
	
	VUnit GetDim(int IDsym, int a);
	int GetCode(int IDsym);	
	char *GetSymName(int ID);	
		
};

#endif //SIMBOLI_HPP

