/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#include "mil/smfl.hpp"
#include "mil/posiz.hpp"
#include "mil/immissione.hpp"
#include "mil/priorita.hpp"
#include "mil/simboli.hpp"

extern Immissione immissione;
extern Posiz posizionam;
extern Priorita priorita;
extern Simboli simboli;
extern int lineno;
extern int LoadRegole(char* FILE, Immissione* pruleimm, Posiz* prulepos, Priorita* prulepri, Simboli* psymbol, int msg);

SMFLManager* SMFLManager::m_instance=NULL;

SMFLManager* SMFLManager::Get()
{
	if(m_instance==NULL)
		m_instance=new SMFLManager();
	return m_instance;
}

SMFLManager::SMFLManager()
{
	m_loadStatus=NOTLOADED;
}
int SMFLManager::LoadCustom(const wxString& file, SMRFile *smrf)
{
	m_smflFilename = file;		
	simboli.SetSMRFile(smrf);
	if (!(LoadRegole((char*)(const char*)m_smflFilename, &immissione, &posizionam,&priorita, &simboli, 1)))
	{
		m_smflFilename="";
		m_loadStatus=NOTLOADED;
		return 0;
	}
	m_loadStatus=CUSTOM;
	return 1;
}
int SMFLManager::LoadDefault()
{
	if (m_loadStatus!=DEFAULT)
	{
		Scr->ReloadBasicFonts();
		m_smflFilename = (wxString)(smrgetenv("SMR_FONT_PATH"));
		if (m_smflFilename.Last()!='/' && m_smflFilename.Last()!='\\') m_smflFilename += PATH_SEP;
		m_smflFilename+="smfl.xml";		
		simboli.SetSMRFile(NULL);
		if (!(LoadRegole((char*)(const char*)m_smflFilename, &immissione, &posizionam,&priorita, &simboli, 1)))
		{
			m_smflFilename="";
			m_loadStatus=NOTLOADED;
			return 0;
		}
		m_loadStatus=DEFAULT;
	}
	return 1;
}

int SMFLManager::Reload()
{
	if (!(LoadRegole((char*)(const char*)m_smflFilename, &immissione, &posizionam,&priorita, &simboli, 1)))
	{
		return 0;
	}
	return 1;
}
