/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: dimas.cpp,v 1.1 2005/07/25 16:31:39 bellinpo Exp $ */


#include "net/dimas.hpp"
#include "net/def_net.hpp"
#include "liooext.hpp"

static Bool InizializzazioneExec = FALSE;
static Bool InizializzazioneImp = FALSE;

DiMas::DiMas() : LdMas(this)
{
}

DiMas::~DiMas()
{  
	
#ifdef WITH_NET   
#ifdef DEBUG_FREE
	FILE *pippo;
	
	pippo = fopen("/home/demo/integrazione/src/DEAL_NET.txt","a");
	fprintf(pippo,"\n\n\n ------------   DEALLOCO DiMAS ----------------\n\n\n");
	fclose(pippo);
#else
#endif 
#else
#endif 
}   


void DiMas::EditingGoBottom()
{
	LdMas::EditingGoBottom();
};     

void DiMas::EditingJumpBatt(int nbat)
{
	LdMas::EditingJumpBatt(nbat);
};

void DiMas::EditingGoTop()
{
	LdMas::EditingGoTop();
};

void DiMas::RequestJump()
{
	LdMas::RequestJump();
}

void DiMas::GestLabel()
{
	LdMas::GestLabel();
}


void DiMas::RichBattBackward(short nb)
{               
	LdMas::RichBattBackward(nb);
};

void DiMas::RichBattForward(short nb)
{   
	LdMas::RichBattForward(nb);
} 

void DiMas::NetInvioComando(SymCmd SC)
{  
	
	InvioComandosuRete(SC);
}  

void DiMas::ImpostaBattPage(NumCode nc, NumCode np)
{
	AggiungiPagina(nc,np);
}


void DiMas::SincrBatt()
{
#ifdef WITH_NET   
	
	short int CommandCode;
	int Altezza, NumPag, nbat, Larghezza, tsc;
	long te, tee, NPassi;
	char CommandStringa[DIM_COMMAND_STRING+1];
	char *ack_sincr;
	RetCode info_ack;
	Battuta *pbt, *pbt2, *pbt3, *pbtNext;
	NumCode NumBatt, nb, NumFirstBat;
	Spartito *psp;
	
	FILE *pippo; 
	
	// gestione riferimento battuta attuale di esecuzione
	strncpy(CommandStringa,Array+DIM_ID+DIM_COMMAND_STRING,DIM_COMMAND_STRING);
	CommandStringa[DIM_COMMAND_STRING] = '\0';
	CommandCode = DecodeCommand(CommandStringa);
	// in commandCode c'e il numero della battuta in formato 1 ...
	NumBatt = CommandCode;
	
	// gestione ack per il multicast
	ack_sincr=new char[DIM_ACK+DIM_ID+1];
	ack_sincr=FormaAck(my_ID,Array,'p',ack_sincr); 
	info_ack=SendAck(tid_MASAE, ack_sincr,MSG_ACK_MULTI);
	if (info_ack!=OK_SEND_ACK) 
	{
		EM.Error(NET_ERR_AREA,"EC_NO_ACK","DiMas","SincrBatt()");
	}
	delete[] ack_sincr;
	
	psp = GetFirstSpa();
	if (psp==NULL)
	{
		return;	
	}
	
	
	
	
	pbt = psp->GetfirstBatPage();
	if (pbt!=NULL) 
	{
		nb = pbt->GetNumProgress();
		while (pbt->GetNumPagMASE()==0)
		{
			nb--;
			pbt = psp->GetPrevBat(pbt);
			if (pbt==NULL) break;
		}
		
		if (pbt!=NULL) 
		{
			pbt = psp->GetPrevBat(pbt);
			if (pbt!=NULL) 
			{
				nb = pbt->GetNumProgress();
				while (pbt->GetNumPagMASE()==0)
				{
					nb--;
					pbt = psp->GetPrevBat(pbt);
					if (pbt==NULL) break;
				}
			}
		}
	}
	if (pbt==NULL) NumFirstBat = 0;
	else NumFirstBat = nb;
	
	
#ifdef DEBUG_EXEC
	pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
	fprintf(pippo,"\nNumero di Battuta=%d\n",NumBatt);
	fclose(pippo);
#endif
	
	pbt = psp->GetBattNumProg(NumBatt);
	if (pbt==NULL)
	{
#ifdef DEBUG_EXEC
		pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
		fprintf(pippo,"Non trovo la battuta\n");
		fclose(pippo);
#endif
		
		return;	
	}
	
	if ((pMusicWin->GetJumpState()) && (NumBattute == INITIAL_NUM_BATT))
		if (pbt->GetNumPagMASE()!=0)
			pMusicWin->SetJumpState(FALSE);
		
		if ((NumBattute > 0) && (!pMusicWin->GetJumpState()))
		{
			NumBattute--;
			return;
		}
		
#ifdef DEBUG_EXEC
		pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
		fprintf(pippo,"1\n");
		fclose(pippo);
#endif
		pMusicWin->SetcountBatt(NumBatt);
		
		if ((pMusicWin->GetJumpState()) && (NumBattute == INITIAL_NUM_BATT))
			te = MIN_CALL_TIMER*10;
		else
		{
			te = GetTimeExec(NumBatt);	
#ifdef DEBUG_EXEC
			pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
			fprintf(pippo,"1_a: te %d(%d)\n",te,GetTimeExec(NumBatt));
			fclose(pippo);
#endif
			te = ((te * 1000)/(1000 + pMusicWin->GetVelocEsec()));
		}
		
		if (te < 1) 
		{
#ifdef DEBUG_EXEC
			pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
			fprintf(pippo,"te e' minore di zero: %d\n",te);
			fclose(pippo);
#endif
			return;	
		}
		
#ifdef DEBUG_EXEC
		pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
		fprintf(pippo,"2: Velocit %d\n",pMusicWin->GetVelocEsec());
		fclose(pippo);
#endif
		
		nb = NumBatt - 1;
		pbt2 = psp->GetBattNumProg(nb);
		
		if (pbt2==NULL) return;	
		
		
		
#ifdef DEBUG_EXEC
		pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
		fprintf(pippo,"3\n");
		fclose(pippo);
#endif
		
		
		if (NumPagina == 0)
		{
			pbt3 = psp->GetBattNum(0);
			pbt3 = psp->GetNextBat(pbt3);
			while (pbt3->GetNumPagMASE()==0)
			{
				pbt3 = psp->GetNextBat(pbt3);
				if (pbt3==NULL) break;
			}
			
			if (pbt3==NULL) return; // puo' verificarsi solo se non e' ancora partito lo scrolling, oppure c'e' una sola pagina.
			else NumPagina = pbt3->GetNumProgress();
		}  
		
		NumFirstBat = NumPagina;
		
		if (NumBatt >= NumFirstBat)
		{
			
			// trovo la precedente battuta di inizio pagina (prima di pbt): se e' diversa da NumFirstBat, allora lo scrolling
			// e' rimasto indietro
			pbt3 = pbt;
			while (pbt3->GetNumPagMASE()==0)
			{
				pbt3 = psp->GetPrevBat(pbt3);
				if (pbt3==NULL) break;
			}
			
			
			if (pbt3==NULL) Larghezza = 0;
			else if (pbt3->GetNumProgress() != NumFirstBat) // lo scrolling e' indietro, e scrolla tutta una pagina intera
			{
				Larghezza = pMusicWin->GetWidth();
			}		
			else
			{
				Larghezza = (pMusicWin->GetAbsPos()).x + pMusicWin->GetWidth() - pMusicWin->GetScrollingPosX() + pbt->GetAbsPos().x;
			}
		}
		else
		{
			
			// trovo la successiva battuta di inizio pagina (dopo pbt): se e' diversa da NumFirstBat, allora lo scrolling
			// e' scappato
			pbt3 = pbt;
			while (pbt3->GetNumPagMASE()==0)
			{
				pbt3 = psp->GetNextBat(pbt3);
				if (pbt3==NULL) break;
			}
			
			
			if (pbt3==NULL) Larghezza = 0;
			else if (pbt3->GetNumProgress() != NumFirstBat) // lo scrolling e' scappato, allora si ferma ed attende
			{
				Larghezza = 0;
			}
			else
			{
				Larghezza = (pbt->GetAbsPos().x - pMusicWin->GetScrollingPosX());
			}
		}
		
		
		Larghezza -= pbt2->GetWidth()/2;
		if (Larghezza < 0) Larghezza = 0;
		
		pMusicWin->SetScrollingInc(SCR_INC);
		pMusicWin->SetScrollingTime(TIME_SCROLLING_CALL_BACK);
		NPassi = Larghezza / (pMusicWin->GetScrollingInc());
		if (NPassi == 0)
			pMusicWin->SetScrollingInc(0);
		else
		{
			tsc = te / NPassi;
			
#ifdef DEBUG_EXEC
			pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
			fprintf(pippo,"3a tsc %d, IncScr %d\n",tsc,pMusicWin->GetScrollingInc());
			fclose(pippo);
#endif
			
			while (tsc < MIN_CALL_TIMER) 
			{
				pMusicWin->SetScrollingInc(pMusicWin->GetScrollingInc() * 2);
				NPassi = Larghezza / (pMusicWin->GetScrollingInc());
				tsc = te / NPassi;
#ifdef DEBUG_EXEC
				pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
				fprintf(pippo,"3b tsc %d, IncScr %d\n",tsc,pMusicWin->GetScrollingInc());
				fclose(pippo);
#endif
			}
			
			pMusicWin->SetScrollingTime(tsc);
		}
		
#ifdef DEBUG_EXEC
		pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
		fprintf(pippo,"4\n");
		fclose(pippo);
#endif
		
		if ((pMusicWin->GetJumpState()) && (NumBattute == INITIAL_NUM_BATT))
		{   
#ifdef DEBUG_EXEC
			pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
			fprintf(pippo,"4a\n");
			fclose(pippo);
#endif
			pMusicWin->SetScrollingInc(Larghezza/10);
		}
		
		if (pMusicWin->GetJumpState())
		{
			if (NumBattute < INITIAL_NUM_BATT)
				pMusicWin->SetJumpState(FALSE);
		}
		
		
#ifdef DEBUG_EXEC
		pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
		fprintf(pippo,"te %d, tsc %d, Larghezza %d\n",te,tsc,Larghezza);
		fclose(pippo);
#endif
		
		if ((NumBattute==0) || (pMusicWin->GetJumpState()))
		{
			
			NumBattute = -1;
			pMusicWin->AttivaModEsecuzione(psp->GetfirstBatPage()->GetNumProgress());
			pMusicWin->SetInitialTime();
			pMusicWin->SetActualTime();
			pMusicWin->ScrollAll();
			Scr->GSetMainDrawArea();
#ifdef DEBUG_EXEC
			pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
			fprintf(pippo,"Avvio Scrolling\n");
			fclose(pippo);
#endif
		}
		
#else
#endif 
} 



void DiMas::ReadFromNetwork()
{
#ifdef WITH_NET 
	
	FILE *pippo;
	
	short int num_spa, CommandCode;
	
	int nbat, time, tsc, Altezza,  Larghezza;
	int indice, i, flag;		   
	short int num_par,inizioparentesi,fineparentesi,tipoparentesi,numcodepar;
	
	long te, NPassi;
	char *ack_sincr, *p;
	char Ack[DIM_ACK+1];  // Vedi struttura Ack in Network.
	char CommandStringa[DIM_COMMAND_STRING+1];
	
	RetCode info_ack;
	RetCode reccode = NO_MSG;   
	NumCode NumBatt, nb, nc, InitDel, EndDel;
	
	Battuta *pbt, *pbt2, *pbt3;
	Battuta *pbat, *pbat1;
	Spartito *psp, *psp1, *Entry;
	
	
	// interrogazione dalla rete    
    reccode=Receive();
    if (reccode==NO_MSG) return;
	
	// controllo ID ricevuto: pu essere solo quello del MASAE  
    if ((Array[0]-1)!=ID_MASAE) 
    {
		// gestione errore : arrivato un messaggio strano
		EM.Error(NET_ERR_AREA, "EC_NET_STRMSG", "LoMas","ReadFromNetwork()" );
		// Usato l'Array, lo pulisco 
		Array[0] = '\0'; 
		return;
    }
	
	// formazione Ack   
	FormaAck(my_ID,Array,'p',Ack);
	
	// decodifica tipo di messaggio ricevuto
    strncpy(CommandStringa,Array+DIM_ID,DIM_COMMAND_STRING);
    CommandStringa[DIM_COMMAND_STRING] = '\0';
    CommandCode = DecodeCommand(CommandStringa);   
	
#ifdef DEBUG_EXEC
	pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
	fprintf(pippo,"Dimas ReadFromNetwork %d\n",CommandCode);
	fclose(pippo);
#endif
	
	//
	// --------------------------------------  gestione messaggio ricevuto ---------------------------------------
	//
    
	
	flag=0;		 
	switch (CommandCode)
	{
    case (JUMP_TO_BATT):
		
		pMusicWin->SetJumpState(TRUE);
		strncpy(CommandStringa,Array+DIM_ID+DIM_COMMAND_STRING,DIM_COMMAND_STRING);
		NumBatt = DecodeCommand(CommandStringa);
		
		miaPartitura->GoBatt(NumBatt);
		
		
		psp = GetFirstSpa();
		pbt3 = psp->GetBattNumProg(NumBatt + 1);
		if (pbt3!=NULL) 
		{
			while (pbt3->GetNumPagMASE()==0)
			{
				pbt3 = psp->GetNextBat(pbt3);
				if (pbt3==NULL) break;
			}
		}
		
		if (pbt3==NULL) NumPagina = NumBatt;
		else NumPagina = pbt3->GetNumProgress();
		
		
		// invio dell ACK       
		info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
		if (info_ack!=OK_SEND_ACK) 
			EM.Error(NET_ERR_AREA,"EC_NO_ACK","DiMas","CommandProcess()");
		break;
		
		
	case (DELETE_BATTUTE):
		
		
		indice=DIM_ID+DIM_COMMAND_STRING;
		
		strncpy(CommandStringa,Array+indice,DIM_COMMAND_STRING); 
		CommandStringa[DIM_COMMAND_STRING] = '\0';
		InitDel = DecodeCommand(CommandStringa);
		indice+=DIM_COMMAND_STRING;
		
		strncpy(CommandStringa,Array+indice,DIM_COMMAND_STRING); 
		CommandStringa[DIM_COMMAND_STRING] = '\0';
		EndDel = DecodeCommand(CommandStringa);
		
		NumBatt = (NumCode)GetNumeroBattute();		   		 
		
		if ((EndDel-InitDel+1)>0)
		{
			if ((EndDel-InitDel+1)>=NumBatt)
				flag=1; 
			else 
				flag=0;
		}
		else 
			flag=0;
		
		psp=GetSpartNum(0);		 
		while (psp!=NULL)
		{     
			// ciclo per cancellare le battute che non mi servono
			for (i=InitDel;i<=EndDel;i++)
			{
				pbat= psp->GetBattNumProg(i);
				if (pbat!=NULL) psp->DeleteBat(pbat);
			} 
			if (flag==1) psp->Free(); 
			psp=GetNextSpa(psp);
		}
		
		// invio dell ACK       
		info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
		if (info_ack!=OK_SEND_ACK) 
		{
			EM.Error(NET_ERR_AREA,"EC_NO_ACK","Dimas","ReadFromNetwork()");
			//return;  //problemi con l'ack 
		}
		
		break;
		
		
	case (EXEC_ENDBATTUTE):
#ifdef DEBUG_EXEC
		pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
		fprintf(pippo,"EXEC_ENDBATTUTE 0\n");
		fclose(pippo);
#endif
		//  settaggio flag per controllo impaginazione 
		SetImpaginazione(END_BATT_ESEC);
		
#ifdef DEBUG_EXEC
		pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
		fprintf(pippo,"EXEC_ENDBATTUTE 1\n");
		fclose(pippo);
#endif
		
		// invio dell ACK       
		info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
#ifdef DEBUG_EXEC
		pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
		fprintf(pippo,"EXEC_ENDBATTUTE 2\n");
		fclose(pippo);
#endif
		if (info_ack!=OK_SEND_ACK) 
		{
			EM.Error(NET_ERR_AREA,"EC_NO_ACK","DiMas","ReadFromNetwork()");
			//return;  //problemi con l'ack 
		}  
		break;
		
		
	case (ALT_EXEC):
		NumBattute = INITIAL_NUM_BATT;
		
		// aggiornamento stato di scrolling          
		RichBatt=NO_BACKWARD;
		
		pMusicWin->SetWaitState(-1);
		pMusicWin->DisattivaModEsecuzione();
		pMusicWin->SetScrollingPosX(pMusicWin->GetVU2Rgt()-pMusicWin->GetScrollingInc()+1);
		
		// settaggio stato di impaginazione
		SetImpaginazione(END_IMP);
		
		// invio dell ACK       
		info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
		if (info_ack!=OK_SEND_ACK) 
		{
			EM.Error(NET_ERR_AREA,"EC_NO_ACK","DiMas","ReadFromNetwork()");
			//return;  //problemi con l'ack 
		} 
		break;
		
	case (FINE_EXEC):
		// aggiornamento stato di scrolling          
		RichBatt=NO_BACKWARD;
		
		// aggiornamento stato di impaginazione
		SetImpaginazione(END_IMP);
		
		// aggirnamento flag di stato di esecuzione
		pMusicWin->DisattivaModEsecuzione();
		
		// invio dell ACK       
		info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
		if (info_ack!=OK_SEND_ACK) 
		{
			EM.Error(NET_ERR_AREA,"EC_NO_ACK","DiMas","ReadFromNetwork()");
			//return;  //problemi con l'ack 
		} 
		break;
		
	case (INIT_EXEC):
		pMusicWin->SetJumpState(FALSE);
		NumPagina = 0;
		p=(char *)Array+DIM_ID+DIM_COMMAND_STRING+DIM_COMMAND_STRING;
		
		New();    // La New mi rialloca automaticamente uno spartito vuoto           
		
		// determinazione numero di battute presenti nell'opera
		strncpy(CommandStringa,Array+DIM_ID+DIM_COMMAND_STRING,DIM_COMMAND_STRING);
		nbat = DecodeCommand(CommandStringa);
		
		// costruzione vettore ett 
		BuildETT(nbat);
		
		// settaggio stato di impaginazione  
		SetImpaginazione(BEGIN_ESEC);
		
		pMusicWin->SetVelocEsec(0);
		
		//------------  Scansione del messaggio per la preparazione di tutti gli spartiti
		
		// 1) prendo il numero di spartiti	
		strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
		CommandStringa[DIM_COMMAND_STRING] = '\0';
		CommandCode = DecodeCommand(CommandStringa);
		num_spa=CommandCode;
		
		
		p=p+DIM_COMMAND_STRING;
		
		// 2)Setto i numeric code degli spartiti 	
		psp1 = GetFirstSpa();	   
		
#ifdef DEBUG_EXEC
		pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
		fprintf(pippo,"0 a\n");
		fclose(pippo);
#endif
		
		while (num_spa>0) 
		{
			strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
			CommandStringa[DIM_COMMAND_STRING] = '\0';
			CommandCode = DecodeCommand(CommandStringa);
			psp1->SetNumericCode(CommandCode);
			psp1->Free();
			p=p+DIM_COMMAND_STRING;
			num_spa--; 
			if (num_spa>0)
			{
				Entry=new Spartito;
				AddSpartito(Entry);
				psp1=GetNextSpa(psp1);  
			}
		}
		
#ifdef DEBUG_EXEC
		pippo = fopen("/home/demo/txtA/DimasExec.txt","a");
		fprintf(pippo,"0 b\n");
		fclose(pippo);
#endif
		
		//--------------------trattamento lista delle parentesi  
		// 1) prendo il numero delle parentesi	
		strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
		CommandStringa[DIM_COMMAND_STRING] = '\0';
		CommandCode = DecodeCommand(CommandStringa);
		num_par=CommandCode;	     
		p=p+DIM_COMMAND_STRING;
		
		// 2)Leggo inizio e fine delle parentesi 		   
		while (num_par>0) 
		{
			strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
			CommandStringa[DIM_COMMAND_STRING] = '\0';
			CommandCode = DecodeCommand(CommandStringa);        
			tipoparentesi=CommandCode;
			
			p=p+DIM_COMMAND_STRING;
			
			strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
			CommandStringa[DIM_COMMAND_STRING] = '\0';
			CommandCode = DecodeCommand(CommandStringa);        
			inizioparentesi=CommandCode;
			
			p=p+DIM_COMMAND_STRING;
			
			strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
			CommandStringa[DIM_COMMAND_STRING] = '\0';
			CommandCode = DecodeCommand(CommandStringa);        
			fineparentesi=CommandCode;
			
			p=p+DIM_COMMAND_STRING;
			
			strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
			CommandStringa[DIM_COMMAND_STRING] = '\0';
			CommandCode = DecodeCommand(CommandStringa);        
			numcodepar=CommandCode;
			
			p=p+DIM_COMMAND_STRING;
			
			if (tipoparentesi == CL_PARGRAFFA)
			{
				AddParentesiGraffa(inizioparentesi, fineparentesi, numcodepar);
			}
			else if (tipoparentesi == CL_PARQUADRA)
			{
				AddParentesiQuadra(inizioparentesi, fineparentesi, numcodepar);
			}
			
			num_par--; 
		}
		
		// trattamento dei nomi degli spartiti
		psp1 = GetFirstSpa();
		if (p[0]!=0)
		{
			char token[GROUP_PARTE_LEN+1],c;
			int tp,ind;
			
			tp=0;
			for(ind=0; ((c=p[ind])!='\0'); ind++)
			{
				// mette in token la stringa fino al prossimo separatore '\n'
				if (c!='\n')
					token[tp++]=c;
				else
				{
					token[tp]='\0';
					tp=0;
					// inserisco il nome dello spartito
					psp1->SetStrumEsec(token);         
					psp1=GetNextSpa(psp1);
					num_spa++;
				} 
			}
		}
		
		// aggiornamento flag di stato di esecuzione
		InizializzazioneExec = TRUE;
		NumBattute = INITIAL_NUM_BATT;
		pMusicWin->SetScrollingPosX(0);
		
		// invio dell ACK       
		info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
		if (info_ack!=OK_SEND_ACK) 
		{
			EM.Error(NET_ERR_AREA,"EC_NO_ACK","DiMas","ReadFromNetwork()");
			//return;  //problemi con l'ack 
		}
		break;
		
		
   case (ESEGUI_BATT_EXEC):  
	   // inserisce la battuta in lista e la visualizza sulla pagina attuale                
	   struct timeval timevI, timevF;
	   struct timezone timezI, timezF;
	   double timeD;
	   short int time1,time2;
	   // aggiornamento stato di attesa per impaginazione  
	   if ((Array[DIM_ID+DIM_COMMAND_STRING])!=BATTUTE_CONT)
		   wait = FALSE;
	   else
		   wait = TRUE;
	   
	   // lettura durata della battuta
	   strncpy(CommandStringa,Array+DIM_ID+DIM_COMMAND_STRING+1,DIM_COMMAND_STRING);
	   time1 = DecodeCommand(CommandStringa);
	   strncpy(CommandStringa,Array+DIM_ID+DIM_COMMAND_STRING+DIM_COMMAND_STRING+1,DIM_COMMAND_STRING);
	   time2 = DecodeCommand(CommandStringa);
	   time=time2+(time1*256);
	   
	   // determinazione della battuta in questione 
	   strncpy(CommandStringa,Array + DIM_ID + 3*DIM_COMMAND_STRING + 1, DIM_COMMAND_STRING);
	   nbat = DecodeCommand(CommandStringa);
	   
	   // settaggio nel vettore ett della durata della battuta
	   SetTimeExec(nbat + 1, time);
	   
	   // caricamento della battuta
	   gettimeofday(&timevI,&timezI);
	   LoadS(DIM_ID+(3*DIM_COMMAND_STRING)+1);
	   
	   // invio dell ACK       
	   info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
	   if (info_ack!=OK_SEND_ACK) 
	   {
		   EM.Error(NET_ERR_AREA,"EC_NO_ACK","DiMas","ReadFromNetwork()");
		   //return;  //problemi con l'ack 
	   }
	   
	   gettimeofday(&timevF,&timezF);
	   timeD = (double)((double)((timevF.tv_sec-timevI.tv_sec)*1000000 + timevF.tv_usec - timevI.tv_usec)/1000);
	   
	   // Usato l'Array, lo pulisco 
	   Array[0] = '\0'; 
	   
	   // controllo possibilita di impaginazione
	   if ((!(wait)) && (InizializzazioneExec))
	   {
		   InizializzazioneExec = FALSE;
		   GoTop();
		   Draw();
	   } 
	   break;
	   
	   case (SINCR_BATT):
		   // la gestione dell'ack viene fatta all'interno del metodo DiMass::SincrBatt();
		   SincrBatt();   
		   break; 
		   
	   case (INIT_PARTE): 
		   p=(char *)Array+DIM_ID+DIM_COMMAND_STRING;
		   
		   // aggiornamento stato di scrolling 
		   RichBatt=NO_BACKWARD;
		   
		   New();    // La New mi rialloca automaticamente uno spartito vuoto           
		   
		   //----------- Scansione del messaggio per la preparazione di tutti gli spartiti
		   
		   // 1) prendo il numero di spartiti	
		   strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
		   CommandStringa[DIM_COMMAND_STRING] = '\0';
		   CommandCode = DecodeCommand(CommandStringa);
		   num_spa=CommandCode;
		   
		   p=p+DIM_COMMAND_STRING;
		   
		   // 2)Setto i numeric code degli spartiti 	
		   psp1 = GetFirstSpa();	   
		   while (num_spa>0) 
		   {
			   strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
			   CommandStringa[DIM_COMMAND_STRING] = '\0';
			   CommandCode = DecodeCommand(CommandStringa);
			   psp1->SetNumericCode(CommandCode);
			   psp1->Free();
			   
			   p=p+DIM_COMMAND_STRING;
			   num_spa--; 
			   if (num_spa>0)
			   {
				   Entry=new Spartito;
				   AddSpartito(Entry);
				   psp1=GetNextSpa(psp1);  
			   }
		   }	
		   
		   //---------------------- trattamento dei margini
		   strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
		   CommandStringa[DIM_COMMAND_STRING] = '\0';
		   CommandCode = DecodeCommand(CommandStringa);
		   SetLeftMargin(float(CommandCode));
		   p=p+DIM_COMMAND_STRING;
		   
		   strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
		   CommandStringa[DIM_COMMAND_STRING] = '\0';
		   CommandCode = DecodeCommand(CommandStringa);
		   SetTopMargin(float(CommandCode));
		   p=p+DIM_COMMAND_STRING;
		   
		   strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
		   CommandStringa[DIM_COMMAND_STRING] = '\0';
		   CommandCode = DecodeCommand(CommandStringa);
		   SetBottomMargin(float(CommandCode));
		   p=p+DIM_COMMAND_STRING;
		   
		   // -------------------- trattamento lista delle parentesi  
		   // 1) prendo il numero delle parentesi	
		   strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
		   CommandStringa[DIM_COMMAND_STRING] = '\0';
		   CommandCode = DecodeCommand(CommandStringa);
		   num_par=CommandCode;
		   
		   p=p+DIM_COMMAND_STRING;
		   
		   // 2)Leggo inizio e fine delle parentesi 		   
		   while (num_par>0) 
		   {
			   strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
			   CommandStringa[DIM_COMMAND_STRING] = '\0';
			   CommandCode = DecodeCommand(CommandStringa);        
			   tipoparentesi=CommandCode;
			   
			   p=p+DIM_COMMAND_STRING;
			   
			   strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
			   CommandStringa[DIM_COMMAND_STRING] = '\0';
			   CommandCode = DecodeCommand(CommandStringa);        
			   inizioparentesi=CommandCode;
			   
			   p=p+DIM_COMMAND_STRING;
			   
			   strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
			   CommandStringa[DIM_COMMAND_STRING] = '\0';
			   CommandCode = DecodeCommand(CommandStringa);        
			   fineparentesi=CommandCode;
			   
			   p=p+DIM_COMMAND_STRING;
			   
			   strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
			   CommandStringa[DIM_COMMAND_STRING] = '\0';
			   CommandCode = DecodeCommand(CommandStringa);        
			   numcodepar=CommandCode;
			   
			   p=p+DIM_COMMAND_STRING;
			   
			   if (tipoparentesi == CL_PARGRAFFA)
				   AddParentesiGraffa(inizioparentesi, fineparentesi, numcodepar);
			   else if (tipoparentesi == CL_PARQUADRA)
				   AddParentesiQuadra(inizioparentesi, fineparentesi, numcodepar);
			   
			   num_par--; 
		   }
		   
		   // trattamento dei nomi degli spartiti
		   psp1 = GetFirstSpa();
		   if (p[0]!=0)
		   {
			   char token[GROUP_PARTE_LEN+1],c;
			   int tp,ind;
			   
			   tp=0;
			   for(ind=0; ((c=p[ind])!='\0'); ind++)
			   {
				   // mette in token la stringa fino al prossimo separatore '\n'
				   if (c!='\n')
					   token[tp++]=c;
				   else
				   {
					   token[tp]='\0';
					   tp=0;
					   // inserisco il nome dello spartito
					   psp1->SetStrumEsec(token);         
					   psp1=GetNextSpa(psp1);
					   num_spa++;
				   } 
			   }
		   }
		   
		   // invio dell ACK       
		   info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
		   if (info_ack!=OK_SEND_ACK) 
		   {
			   EM.Error(NET_ERR_AREA,"EC_NO_ACK","DiMas","ReadFromNetwork()");
			   //return;  //problemi con l'ack 
		   }
		   
		   break; 
		   
   case (ESEGUI_BATT_LOAD):
	   LoadS(DIM_ID+DIM_COMMAND_STRING); // Dovra' funzionare anche per il Dimas.
	   
	   // Usato l'Array, lo pulisco 
	   Array[0] = '\0'; 
	   
	   // invio dell ACK       
	   info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
	   if (info_ack!=OK_SEND_ACK)
		   return;  //problemi con l'ack 
	   
	   break;
	   
   case (ESEGUI_NEW):      
	   // Usato l'Array, lo pulisco 
	   Array[0] = '\0';
	   
	   // invio dell ACK       
	   info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
	   if (info_ack!=OK_SEND_ACK) 
	   {
		   EM.Error(NET_ERR_AREA,"EC_NO_ACK","DiMas","ReadFromNetwork()");
	   }
	   
	   // Esecuzione del comando di new: se qualcosa non va passare all
	   // error manager
	   New();      
	   GoTop();
	   
	   break;
	   
   case (ESEGUI_COMMAND) : 
	   EseguiCommand(NetSymCmd);
	   
	   // Usato l'Array, lo pulisco 
	   Array[0] = '\0';
	   
	   // invio dell ACK       
	   info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
	   if (info_ack!=OK_SEND_ACK) 
	   {
		   EM.Error(NET_ERR_AREA,"EC_NO_ACK","DiMas","ReadFromNetwork()");
	   }
	   Redraw();
	   
	   break;
	   
   case (END_INIT_PARTE) :
	   Redraw();          
	   
	   // Usato l'Array, lo pulisco 
	   Array[0] = '\0';
	   
	   // invio dell ACK       
	   info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
	   if (info_ack!=OK_SEND_ACK) 
	   {
		   EM.Error(NET_ERR_AREA,"EC_NO_ACK","DiMas","ReadFromNetwork()");
	   }
	   break;  
	   
   case (INIT_IMPAGINA):
	   //  Setto lo stato di inizio impaginazione :  Impaginazione=BEGIN_IMP 
	   pMusicWin->SetJumpState(FALSE);
	   SetImpaginazione(BEGIN_IMP);
	   
	   // Setto il tempo fra una chiamata e l'altra e la Porzione (in pixel) da copiare 
	   // ogni volta  (per lo scrolling)  
	   pMusicWin->SetScrollingTime(30);
	   pMusicWin->SetScrollingInc(50);
	   
	   // inizializzo il flag di stato per l'impaginazione 
	   InizializzazioneImp = TRUE;
	   
	   psp = GetFirstSpa();
	   while (psp!=NULL)
	   {
		   psp->Free();
		   psp = GetNextSpa(psp);
	   }
	   
	   pMusicWin->AttivaModEsecuzione();
	   
	   // invio dell ACK       
	   info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
	   if (info_ack!=OK_SEND_ACK) 
		   EM.Error(NET_ERR_AREA,"EC_NO_ACK","LoMas","ReadFromNetwork()");
	   
	   break;
	   
   case (ESEGUI_BATT_IMP):
	   // aggiornamento stato di attesa per impaginazione  
	   if ((Array[DIM_ID+DIM_COMMAND_STRING])==BATTUTE_COMPLETATE)
		   wait = FALSE;
	   else if ((Array[DIM_ID+DIM_COMMAND_STRING])==BATTUTE_TERMINATE)
	   {
		   wait = FALSE;
		   SetImpaginazione(END_BATT_IMP);
	   }
	   else
		   wait = TRUE;
	   
	   LoadS(DIM_ID+DIM_COMMAND_STRING+1);  
	   
	   // Usato l'Array, lo pulisco 
	   Array[0] = '\0'; 
	   
	   // invio dell ACK       
	   info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
	   if (info_ack!=OK_SEND_ACK) 
	   {
		   EM.Error(NET_ERR_AREA,"EC_NO_ACK","LoMas","ReadFromNetwork()");
		   //return;  //problemi con l'ack 
	   }
	   
	   // se e' terminata la trasmissione delle N battute(wait) e 
	   // siamo ancora in impaginazione (InizializzazioneImp)
	   if ((!(wait)) && (InizializzazioneImp))
	   {
		   InizializzazioneImp = FALSE;
		   pMusicWin->AttivaModEsecuzione();
		   pMusicWin->ScrollAll();
	   }
	   
	   break;
	   
   case (FINE_IMPAGINA):
	   // aggiornamento stato di scrolling          
	   RichBatt=NO_BACKWARD;
	   
	   // settaggio stato di impaginazione
	   SetImpaginazione(END_IMP);
	   
	   // settaggio stato di esecuzione in Dlioowin
	   pMusicWin->DisattivaModEsecuzione();
	   
	   // invio dell ACK       
	   info_ack = SendAck(tid_MASAE,Ack,MSG_ACK);
	   if (info_ack!=OK_SEND_ACK) 
	   {
		   EM.Error(NET_ERR_AREA,"EC_NO_ACK","LoMas","ReadFromNetwork()");
		   //return;  //problemi con l'ack 
	   }
	   
	   break;
	   
   case (TYPE_CURSOR):
	   LdMas::ReadFromNetwork();
	   Draw();
	   break;
	   
   default: 
	   // I comandi a comune tra DiMas ed LdMas verranno processati 
	   // dalla LdMas::ReadFromNetwork();
	   LdMas::ReadFromNetwork();
	   break;
	   
  }  
#else
#endif 
  
}


//
//--------------------  funzioni di utilita' ------------------------------------------------
//
void DfStampaSym(FILE *pippo,SymCmd sc)
{ int j;
fprintf(pippo,"%d %d %d ",sc.CommandId,sc.SelectionType,sc.SelObjType);
for (j=0;j<PATH_LENGTH;j++){fprintf(pippo,"%d ",sc.Path1.Array[j]);};
fprintf(pippo,"%d ",sc.Path1.Level);for (j=0;j<PATH_LENGTH;j++){\
fprintf(pippo,"%d ",sc.Path2.Array[j]);};
fprintf(pippo,"%d ",sc.Path1.Level);
for (j=0;j<SYM_MAXARG;j++){fprintf(pippo,"%d ",sc.ArgV[j]);};
fprintf(pippo,sc.Text);
fprintf(pippo,"\n");}



void DiMas::BEEP(char * Stringa)
{
	return;
}

void DiMas::BEEP(unsigned int Appo)
{
	
	return;
}



void DiMas::EseguiDebug(void *arg1, void *arg2, void *arg3) 
{
	
	FILE *pippo;
	
	Spartito  *psp;
	Battuta *pbt;
	
	int nb;
	
	switch(UsrSymCmd.CommandId)
	{
    case CMD_DEBUG_UNO:
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","Dimas","ReadFromNetwork()");
		break;
		
		
    case CMD_DEBUG_DUE:
		
		break;
		
		
    case CMD_DEBUG_TRE:
		break;
		
    case CMD_DEBUG_QUATTRO:
		break;        
    case CMD_DEBUG_CINQUE:
		
		
		break;        
    case CMD_DEBUG_SEI:
		pippo = fopen("/home/demo/txt/finestrMASE.txt","w");
		fprintf(pippo,"\n ------------   Finestra MASE ----------------\n\n\n");
		
		nb=1;
		psp=GetFirstSpa();
		pbt = psp->GetBattNumProg(nb);
		
		while(pbt!=NULL)
		{
			psp=GetFirstSpa();
			fprintf(pippo,"Battuta %d:",nb);
			while(psp!=NULL)
			{
				pbt = psp->GetBattNumProg(nb);
				fprintf(pippo,"\t%d",pbt->GetNumProgress());
				psp=GetNextSpa(psp);
			}
			
			fprintf(pippo,"\n");
			nb++;
			psp=GetFirstSpa();
			pbt = psp->GetBattNumProg(nb);
		}
        
		fclose(pippo);
		break;        
		
        
		break;        
    case CMD_DEBUG_SETTE:
		
        break;        
		
    case CMD_DEBUG_OTTO:
        break;
		
    case CMD_DEBUG_NOVE:
        break;
		
	}
	
}  

