/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: ldmas.hpp,v 1.1 2005/07/25 16:31:40 bellinpo Exp $ */


#ifndef LDMAS_HPP
#define LDMAS_HPP

#include "lioo.hpp"
#include "net/net.hpp"
#include "par/partitur.hpp"
#include "par/partel.hpp"
#include "spa/spartito.hpp"
#include "bat/battuta.hpp"

class LdMas: public Network

{
protected:
    int tid_MASAE;
    char ID_MASAE;
    Bool wait;
    int waitEditing;
    StateBat RichBatt;
	
    short int Amp, ind;
    NumCode* ListaPag;
	NumCode NumPagina;
    
    Partitura * miaPartitura;   // Puntatore per accedere ai membri di Partitura 
	
public:
    LdMas(Partitura * Entry);
    ~LdMas();
    int Gettid_MASAE();
	
    void SetNumPagina(NumCode);
    NumCode GetNumPagina();
	
    void RichBattBackward(short);
    void RichBattForward(short);
	
	void EditingGoBottom();     
	void EditingJumpBatt(int nbat);
	void EditingGoTop();
    void RequestJump();
    void GestLabel();
    void MenuJump(int NumBatt,int NumEtich,char*arrayLabel,int*);
	
    void InvioComandosuRete(SymCmd SC);
    void EseguiCommand(SymCmd& SC);
    void AggiungiPagina(NumCode nc, NumCode np);
    void RemoveListaPag();
    void SetPage();            
    void Req_NBat(short int nbat);
    void SendEndImp();
    
    virtual void ReadFromNetwork();
	
    void ImpostaBattPage(NumCode nc, NumCode np);
    void WaitState();
    void TypeCursor();
	
    // Funzioni di DeBug
    void BEEP(char * Stringa); // Beep "Virtuale" su disco
    void BEEP(unsigned int Appo);
    void StampaStato(void);
    
};

#endif //LDMAS_HPP
