/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: lomas.hpp,v 1.1 2005/07/25 16:31:41 bellinpo Exp $ */


#ifndef LOMAS_HPP
#define LOMAS_HPP

#include "lioo.hpp"
#include "par/partel.hpp"
#include "net/ldmas.hpp"


class LoMas: public ParteL, public LdMas
{
protected:
	// utilizzata durante l'esecuzione
	// conteggia i primi righi musicali che 
	// non devono essere scrollati
    short NumPentagrammi;
    Bool ScrollingAvviato;
	
public:
    LoMas(bool empty=false);
    ~LoMas();
	
	void EditingGoBottom();     
	void EditingJumpBatt(int nbat);
	void EditingGoTop();
	void RequestJump();
	void GestLabel();
    void InitEsecuzione(char*);
    void InitImpaginazione(); 
    void SincrBatt();
    void RichBattBackward(short);
    void RichBattForward(short);
    void NetInvioComando(SymCmd SC); 
	
    void ReadFromNetwork();    
    
	
    void EseguiDebug(void *arg1, void *arg2, void *arg3);
    
    int GetWaitEditing();
};

#endif //LOMAS_HPP
