/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: mamass.hpp,v 1.1 2005/07/25 16:31:41 bellinpo Exp $ */


#ifndef MAMASS_HPP
#define MAMASS_HPP

#include "par/partem.hpp"
#include "net/net.hpp"
#include "net/netoncm.hpp"
#include "net/logfile.hpp"

class MaMass: public ParteM, public Network
{
private:
    NetONCM netONCM;// Tabella di configurazioni.
protected:
    char NDliooInImp;
	
public:
    MaMass();
    ~MaMass();
	
    int OPD_TID, OPD_ID;  // tid e id dell'OPD
    void Send_Abil(unsigned char *, char *);   
	
    void New(void); 
	Bool DoCommand(const Point& p);
    Bool DoCommandRectSel(const Point& p);
	
    void KillLioo();
    void StartNodes();// Fa partire un DLIOO.
    void LoadPindex();// Carica sulla tabella dei nodi il nome della parte
    void InitParte(); 
    void ComprimiBattute();
    
    int ControlloLimiti(unsigned char id_mitt,int limite);
	
	void JumpEditing(int N,unsigned char id_mitt);
	void RequestJump();
	void GestLabel();
	void MenuJump(int NumBatt,int NumEtich,char *arrayLabel,int*);
	
    void BattutaNum(unsigned char, int); 
    void BattutaForward(unsigned char,short int, Bool fl, short nbat);
    void BattutaBackward(unsigned char, Bool fl, short nbat);
	
    void PageForward(unsigned char);
    void PageBackward(unsigned char); 
    void NetInvioComando(SymCmd SC);  
    void InitImpaginazione();
    void SendEndImp();
    void Send_NBat(int nbat,unsigned char id);
	
	
	
	Bool CatchFigure(SymCmd * MyCmd,DrawObject *& RetObj,Bool * InPage);
	
    void InitEsecuzione(char*);
    void JumpToBatt(NumCode&);
    void SendEndEsec();
    void Send_NextPag(unsigned char id, int npag = 1);
	// Invia in esecuzione la pagina successiva al DLIOO in questione 
	// con il vettore ett relativo alle battute inviate
	
    void SincrBatt(NumCode num_bat);
	// metodo per sincronizzare lo scorrimento delle battute in fase di esecuzione  
	// usando l'invio multicast , dopo il quale ci mettiamo in attesa degli ack   
	// messaggio del tipo
	//                 IDMASAE - SINCR_BATT - battuta attuale
	
	
	
    void SendWaitState(Bool ws);
	
    void SendVelocEsec(int d_time);
    void SendTypeCursor(CursorTypes ct, int fc);
	
	
	
    void InserisciComandoACLMaMass(SymCmd*);
    Bool CheckTrustedCommand(int ID,SymCmd * MyCmd);
    Bool InserisciComandoACL(int tid_mittente);
	
    void ReadFromNetwork();
    void Send_AltExec();
    
	
    void EseguiDebug(void *arg1, void *arg2, void *arg3);
	int GetNumMusicist(void) {return netONCM.NActiveLIOO-1;};
	char * GetMusicista(int Numseq);
	
	int GetIDleader(char* parte);
	void SetAbilCompress(char* parte, Bool abil);
    void SetAbilCompressAll(Bool abil);
	Bool GetAbil_Compress(int i);
    
};

#endif //MAMASS_HPP
