/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: net.cpp,v 1.1 2005/07/25 16:31:42 bellinpo Exp $ */


#include "net.hpp"
#ifndef OPD  
#include "liooext.hpp"
#else
#include "../gui/errman.hpp"
extern ErrorManager EM; 
#endif

Network::Network() {}
Network::~Network () {}

unsigned char Network::Getmy_ID()
{
	return(my_ID);
}


bool Network::Sym2String(char *CmdString, SymCmd SC)
{
	bool status = TRUE;
	unsigned short j;
	// int ind;
	char Codice[DIM_COMMAND_STRING+1];
	RetCode infoCode;
	
	CmdString[0] ='\0';
    
    //codifico CommandId  ===>  di tipo CmdID (short)
	if (SC.CommandId<0) 
	{
		EM.Error(GENERAL_ERR_AREA,"EC_NEG_IN_NET","Partitura","Sym2String()");
		status = FALSE;
	}
	else
	{ 
		infoCode = CodeCommand((short int)SC.CommandId,Codice);//1
		strcat(CmdString,Codice);
	};
	
    //codifico SelectionType
	if (SC.SelectionType<0) 
	{
		EM.Error(GENERAL_ERR_AREA,"EC_NEG_IN_NET","Partitura","Sym2String()");
		status = FALSE;
	}
	else 
	{
		infoCode = CodeCommand((short int)SC.SelectionType,Codice);//2
		strcat(CmdString,Codice);
	};
	
    //codifico SelObjType
	if (SC.SelObjType<0) 
	{
		EM.Error(GENERAL_ERR_AREA,"EC_NEG_IN_NET","Partitura","Sym2String()");
		status = FALSE;
	}
	else 
	{
		infoCode = CodeCommand((short int)SC.SelObjType,Codice);//3
		strcat(CmdString,Codice );
	};
	
    //codifico Path1
	for (j=0;j<PATH_LENGTH;j++)
	{
		if (SC.Path1.Array[j]<0) 
		{
			EM.Error(GENERAL_ERR_AREA,"EC_NEG_IN_NET","Partitura","Sym2String()");
			status = FALSE;
		}
		else 
		{ 
			infoCode = CodeCommand((short int)SC.Path1.Array[j],Codice);//PATH_LENGTH+3
			strcat(CmdString,Codice);
		};  
	};
	
    //codifico Path1.Level
	if (SC.Path1.Level<0) 
	{
		EM.Error(GENERAL_ERR_AREA,"EC_NEG_IN_NET","Partitura","Sym2String()");
		status = FALSE;
	}
	else 
	{
		infoCode = CodeCommand((short int)SC.Path1.Level,Codice);//PATH_LENGTH+4
		strcat(CmdString,Codice );
	};
	
    //codifico Path2
	for (j=0;j<PATH_LENGTH;j++)
	{
		if (SC.Path2.Array[j]<0) 
		{
			EM.Error(GENERAL_ERR_AREA,"EC_NEG_IN_NET","Partitura","Sym2String()");
			status = FALSE;
		}
		else 
		{
			infoCode = CodeCommand((short int)SC.Path2.Array[j],Codice);//2*PATH_LENGTH+4
			strcat(CmdString,Codice);
		};  
	};
	
	//codifico Path2.Level
	if (SC.Path2.Level<0) 
	{
		EM.Error(GENERAL_ERR_AREA,"EC_NEG_IN_NET","Partitura","Sym2String()");
		status = FALSE;
	}
	else 
	{
		infoCode = CodeCommand((short int)SC.Path2.Level,Codice);//2*PATH_LENGTH+5
		strcat(CmdString,Codice );
	};
	
	//codifico ArgV[j]
	for (j=0;j<SYM_MAXARG;j++)
	{
		if (SC.ArgV[j]<0) 
		{
			EM.Error(GENERAL_ERR_AREA,"EC_NEG_IN_NET","Partitura","Sym2String()");
			status = FALSE;
		}
		else
		{ 
			infoCode = CodeCommand((short int)SC.ArgV[j],Codice);//2*PATH_LENGTH+5+SYM_MAXARG
			strcat(CmdString,Codice);
		};
	};
	
	//codifico Text
	char text[SYM_MAX_TEXT+1];
	memcpy(text, SC.Text, SYM_MAX_TEXT);
	text[SYM_MAX_TEXT]='\0';

	strcat(CmdString,text);  
	
	//  CmdString[strlen(CmdString)]='\0'; //(2*PATH_LENGTH+5*DIM_COMMAND_STRING+SYM_MAXARG+SymCmd.Text size

	//int size = strlen(CmdString);
	//int maxs = (2*PATH_LENGTH+SYM_MAXARG+5)*DIM_COMMAND_STRING+SYM_MAX_TEXT;//(SymCmd.Text size;)

	return status;
}


bool Network::String2Sym(char *CmdString, SymCmd& SC)
{
	unsigned short j;
	unsigned short index_CmdString=0 ;
	
    // decodifico ComandId
	SC.CommandId = CmdID(DecodeCommand(CmdString));
	index_CmdString += LENGTH_COMMANDID*2;
	
    // decodifico SelectionType  
	SC.SelectionType = SelType(DecodeCommand(CmdString +  index_CmdString ));
	index_CmdString += LENGTH_SELECTIONTYPE*2;
	
    // decodifico  SelObjType
	SC.SelObjType = SelObj(DecodeCommand(CmdString +  index_CmdString ));
	index_CmdString += LENGTH_SELOBJTYPE*2;
	
    // decodifico Path1
	for (j=0;j<PATH_LENGTH;j++)
	{ 
		SC.Path1.Array[j] = NumCode(DecodeCommand(CmdString + index_CmdString ));
		index_CmdString += DIM_FIELD_SymCmd*2;
	};
    // decodifico  Path1.Level
	SC.Path1.Level = short(DecodeCommand(CmdString +  index_CmdString ));
	index_CmdString += DIM_FIELD_SymCmd*2;
	
    // decodifico Path2 
	for (j=0;j<PATH_LENGTH;j++)
	{ 
		SC.Path2.Array[j] = NumCode(DecodeCommand(CmdString + index_CmdString ));
		index_CmdString += DIM_FIELD_SymCmd*2;
	};
    // decodifico  Path1.Level
	SC.Path2.Level = short(DecodeCommand(CmdString +  index_CmdString ));
	index_CmdString += DIM_FIELD_SymCmd*2;
	
    // decodifico ArgV
	for (j=0;j<SYM_MAXARG;j++)
	{ 
		SC.ArgV[j] = ArgType(DecodeCommand(CmdString + index_CmdString ));
		index_CmdString += DIM_FIELD_SymCmd*2;
	};
	
    // decodifico Text
	SC.Text[0] = '\0';
	strcpy(SC.Text, CmdString + index_CmdString );
	CmdString[0]='\0';

	return TRUE;
}


short int Network::DecodeCommand(char* str_command)
{
	unsigned char  sb0, sb1 ,sb2 ,sb3;  // semibyte        
	unsigned char byte0, byte1;         // byte0 e byte1 del campo del symCmd  
	const unsigned char p = 112;        //  il valore binario  01110000
	short int   field_command_0, field_command_1;
	sb0 = str_command[0];
	sb1 = str_command[1];
	sb2 = str_command[2]; 
	sb3 = str_command[3];
	//
	// decodifica del primo byte del campo del SymCmd
	//
	sb0 <<= 4;
	sb0 >>= 4;
	sb1 <<=4;
	byte0 = sb0 | sb1;
	
	//
	// decodifica del secondo byte del campo del SymCmd
	//
	sb2 <<=4 ;
	sb2 >>= 4;
	sb3 <<=4;
	byte1 = sb2 | sb3 ;
	
	
	//
	// ricostruzione campo del symCmd
	//
	field_command_0 =(short int) byte0;     
	field_command_1 =(short int) byte1;
	field_command_1 <<= 8;
	
	return(field_command_0 | field_command_1);   // valore ricostruito
};


RetCode Network::CodeCommand(short int field_command, char* sb)
{
	short int field_command_1; // campo generico del symCmd
	const unsigned char p = 112;  //  il valore binario  01110000
	
	
	//  
	//codifica del primo byte del campo del SymCmd
	//     
	// codifica nel primo byte      
	sb[0] = (unsigned char)(field_command & 0xff);
	sb[0] &= 0x0f; 
	sb[0] |= p;
	
	// codifica nel secondo byte    
	sb[1] = (unsigned char)(field_command & 0xff);
	sb[1] &= 0xf0;
	sb[1] >>= 4;
	sb[1] |= p;
	
	//  
	//codifica del secondo byte del campo del SymCmd
	//        
	field_command_1 = field_command >> 8;
	
	// codifica nel terzo byte
	sb[2] = (unsigned char)(field_command_1 & 0xff);
	sb[2] &= 0x0f; 
	sb[2] |= p;
	
	// codifica nel quarto byte 
	sb[3] = (unsigned char)(field_command_1 & 0xff);
	sb[3] &= 0xf0;
	sb[3]>>= 4;
	sb[3] |=  p;
	
	sb[4]='\0';   
	
	return 0;  //in generale sara un codice di controllo
}



// invia un messaggio multicast a number LIOO con tid nel vettore all_tid
RetCode Network::SendMulticast(int *all_tid,int number)
{
#ifdef WITH_NET  
	
	
	// 
	// preparazione nel buffer del messaggio da inviare 
	//
	
	
	char copiaArray[50*1024];
	strcpy(copiaArray,Array);
	
	if (Packet(copiaArray)==NO_PACKET) return NO_PACKET;
	
	
	int info_send = pvm_mcast(all_tid,number,MSG_MULTICAST);
	if (info_send<0)
	{
		switch (info_send)
		{
		case -2:
			EM.Error(PVM_ERR_AREA,"EC_PVM_BADPAR","Network","SendMulticast");
			// errore nell'invio del messaggio
			return(NO_SEND_SEND);
			break;
		case -14:
			EM.Error(PVM_ERR_AREA,"EC_PVM_SYSERROR","Network","SendMulticast");
			// errore nell'invio del messaggio
			return(NO_SEND_SEND);
			break;
		case -15:
			EM.Error(PVM_ERR_AREA,"EC_PVM_NOBUF","Network","SendMulticast");
			// errore nell'invio del messaggio
			return(NO_SEND_SEND);
			break;  	
		}	
	}
	
	return (OK_SEND);
#else
	return 0;
#endif 
}


/* Schema dell'ACK !!!!!
ID_Tx(dell'ack) | ID_Rx + DIM_COMMAND_STRING | FLAG 
<-- Messaggio Ricevuto ---->          */


// riceve un messaggio di ack inviato con modalita multicast
// controlla anche che il messaggio sia quello atteso
// Restituisce : OK_SEND se tutto ok
//               NO_SEND se errore
// Il messaggio di ack formato su lomas deve essere del tipo 
//         ID MaMass - ID lomas - primi byte del messaggio ricevuto - 's'|'n'
RetCode Network::ReceiveAckMulticast(char* ack_atteso,unsigned char& id)
{
#ifdef WITH_NET   
	
	char Ack[DIM_ACK+DIM_ID+1];
	int info_ack = pvm_nrecv(ANY_SENDER,MSG_ACK_MULTI);  //attesa senza blocco
	if (info_ack==0) return(NO_MSG);
	
	if (info_ack<0)
	{
		switch (info_ack)
		{
		case -2:
			EM.Error(PVM_ERR_AREA,"EC_PVM_BADPAR","Network","ReceiveAckMulticast()");      
			return(NO_RECEIVE_ACK);
			break;
		case -14:
			EM.Error(PVM_ERR_AREA,"EC_PVM_SYSERROR","Network","ReceiveAckMulticast()");	
			return(NO_RECEIVE_ACK);
			break;
		}	
	}
    
	if (UnPacket(Ack)==NO_UNPACKET) return NO_UNPACKET;
	
	
	char Match_ack = 0;
	for (char i=1;i<=(DIM_ACK-DIM_ID-DIM_FLAG);i++)  
		Match_ack = ((Ack[i]==ack_atteso[i]) || (Match_ack));
	
	id=(Ack[0]-1);
	return(OK_RECEIVE);
	
#else
	return 0;
#endif 
	
}










/////////***************************************************************//


RetCode Network::SendMsg_ack_MaM(int tid_destinatario)
{
	
#ifdef WITH_NET   
	
	// 
	// preparazione nel buffer del messaggio da inviare 
	//
	
	
	
	
	char copiaArray[50*1024];
	strcpy(copiaArray,Array);
	
	if (Packet(copiaArray)==NO_PACKET) 
	{
		return NO_PACKET;
	}
	
	int info_send = pvm_send(tid_destinatario,MSG_EFFETTIVO);
	if (info_send<0)
	{
		switch (info_send)
		{
		case -2:
			EM.Error(PVM_ERR_AREA,"EC_PVM_BADPAR","Network","SendMsg_ack_MAM 1");
			// errore nell'invio del messaggio
			return(NO_SEND_SEND);
			break;
		case -14:
			EM.Error(PVM_ERR_AREA,"EC_PVM_SYSERROR","Network","SendMsg_ack_MAM 2");
			// errore nell'invio del messaggio
			return(NO_SEND_SEND);
			break;
		case -15:
			EM.Error(PVM_ERR_AREA,"EC_PVM_NOBUF","Network","SendMsg_ack_MAM 3");
			// errore nell'invio del messaggio
			return(NO_SEND_SEND);
			break;
			
		}	
		
	}
	
	
	//      
	// attesa Ack 
	//
	
	char Ack[DIM_ACK+1];
	int info_ack=0;
	int info_msg=0;
	int info_msg_up=0;
	
	while (1==1) 
	{
		info_ack = pvm_nrecv(tid_destinatario,MSG_ACK);  //attesa senza blocco
		
		{
			switch (info_ack)
			{
			case -2:
				EM.Error(PVM_ERR_AREA,"EC_PVM_BADPAR","Network","SendMsg_ack_MAM 4");
				// errore nella ricezione dell'ack  
				return(NO_RECEIVE_ACK);
				break;
			case -14:
				EM.Error(PVM_ERR_AREA,"EC_PVM_SYSERROR","Network","SendMsg_ack_MAM 5");
				// errore nella ricezione dell'ack  
				return(NO_RECEIVE_ACK);
				break;
			}	
		}
		
		
		if (info_ack>0)
		{ 
			//ricevuto messaggio di ack  
			if (UnPacket(Ack)==NO_UNPACKET) 
				return NO_UNPACKET;
			
			return (OK_SEND);
		}
		
		
		
		if (info_ack==0)  // non ricevuto ack...controllo deadlock
		{     
			info_msg = pvm_nrecv( tid_destinatario,MSG_EFFETTIVO);  //attesa senza blocco
			
			if (info_msg<0)   //pb in ricezione
			{
				
				switch (info_ack)
				{
				case -2:
					EM.Error(PVM_ERR_AREA,"EC_PVM_BADPAR","Network","SendMsg_ack_MAM 6");
					// errore nella ricezione dell'ack  
					return(NO_RECEIVE_ACK);
					break;
				case -14:
					EM.Error(PVM_ERR_AREA,"EC_PVM_SYSERROR","Network","SendMsg_ack_MAM 7");
					// errore nella ricezione dell'ack  
					return(NO_RECEIVE_ACK);
					break;
				}	
			}
			
			if (info_msg>0)   //ricevuto messaggio:deadlock 
			{
				
				char buffermsg[50*1024];
				if (UnPacket(buffermsg)==NO_UNPACKET) 
				{
					return NO_UNPACKET;
				} 
				
				
				// formazione  dell ACK negativo            
				FormaAck(0,buffermsg,'n',Ack);
				// l'ID del Masae e' sempre 0, La funzione lo converte in 1 per trasmetterlo
				
				// Trasmissione Ack negativo.         
				info_ack = SendAck(tid_destinatario,Ack,MSG_ACK); 
				if (info_ack!=OK_SEND_ACK) 
				{
					EM.Error(PVM_ERR_AREA,"EC_NO_ACK","Network","SendMsg_ack_MAM 8");
					return (NO_SEND_ACK);  //problemi con l'ack         
				} 
				buffermsg[0]='\0';        
			}
		}      
	}  
	return (OK_SEND);
#else
	return 0;
#endif 
	
}


// Adesso in sendMsg_ack di network si fa la gestione del deadlock sul
// multicast, pero' senza perdere informazioni,: cio una volta che ho ricevuto
// il messaggio di si sincr_batt non lo butto ma lo faccio eseguire dopo aver
// inviato l'ack per fare ripartire il masae.Se lo buttasssi, se la pagina 
// piccola pu accadere ....boH!!!, comunque meglio non buttarlo.
RetCode Network::SendMsg_ack(int tid_destinatario)
{
	
#ifdef WITH_NET   
	
	// 
	// preparazione nel buffer del messaggio da inviare 
	//
	
	RetCode info_ack,info_msg;
	char copiaArray[50*1024];
	strcpy(copiaArray,Array);
	
	if (Packet(copiaArray)==NO_PACKET) return NO_PACKET;
	
	int info_send = pvm_send(tid_destinatario, MSG_EFFETTIVO);
	if (info_send<0)
	{
		switch (info_send)
		{
		case -2:
			EM.Error(PVM_ERR_AREA,"EC_PVM_BADPAR","Network","SendMsg_ack");  	     
			return(NO_SEND_SEND);
			break;
		case -14:
			EM.Error(PVM_ERR_AREA,"EC_PVM_SYSERROR","Network","SendMsg_ack");
			return(NO_SEND_SEND);
			break;
		case -15:
			EM.Error(PVM_ERR_AREA,"EC_PVM_NOBUF","Network","SendMsg_ack");
			return(NO_SEND_SEND);
			break;
		}	
	}
	
	
	char Ack[DIM_ACK+1];
	while (1==1) 
	{
		info_ack = pvm_nrecv(tid_destinatario,MSG_ACK);  //attesa SENZA  blocco
		
		if (info_ack<0)   // pb nella ricezione del messaggio di ack
		{
			switch (info_ack)
			{
			case -2:
				EM.Error(PVM_ERR_AREA,"EC_PVM_BADPAR","Network","SendMsg_ack_MAM 4");
				return(NO_RECEIVE_ACK);
				break;
			case -14:
				EM.Error(PVM_ERR_AREA,"EC_PVM_SYSERROR","Network","SendMsg_ack_MAM 5");
				return(NO_RECEIVE_ACK);
				break;
			}	
		}
		
		if (info_ack>0)  //ricevuto messaggio di ack
		{         
			if (UnPacket(Ack)==NO_UNPACKET) 
			{ 
				return NO_UNPACKET;
			}
			
			
			
			
			if (Ack[DIM_ID+DIM_ID+DIM_COMMAND_STRING]=='p') 
				return OK_SEND;
			else	if (Ack[DIM_ID+DIM_ID+DIM_COMMAND_STRING]=='n') 
				return NEGATIVE_ACK;
			
		}
		
		if (info_ack==0)  // non ricevuto ack...,allora controllo un deadlock -- SUL MULTICAST
		{     
			info_msg = pvm_nrecv(tid_destinatario,MSG_MULTICAST);  //attesa non blocco    
			if (info_msg<0)   //pb nella ricezione del messaggio di Multicast
			{
				
				switch (info_ack)
				{
				case -2:
					EM.Error(PVM_ERR_AREA,"EC_PVM_BADPAR","Network","SendMsg_ack_MAM 6");
					return(NO_RECEIVE_ACK);
					break;
				case -14:
					EM.Error(PVM_ERR_AREA,"EC_PVM_SYSERROR","Network","SendMsg_ack_MAM 7");
					return(NO_RECEIVE_ACK);
					break;
				}	
			}
			
			if (info_msg>0)   //ricevuto messaggio MULTICAST: presenza di deadlock 
			{
				char buffermsg[50*1024];
				if (UnPacket(buffermsg)==NO_UNPACKET) 
				{
					return NO_UNPACKET;
				} 
				
				// gestione del tipo di messaggio MULTICAST ricevuto
				short int CommandCode;
				char CommandStringa[DIM_COMMAND_STRING+1];
				strncpy(CommandStringa,buffermsg+DIM_ID,DIM_COMMAND_STRING); 
				
				CommandStringa[DIM_COMMAND_STRING] = '\0';
				CommandCode = DecodeCommand(CommandStringa);
				FILE* pippo;  
				switch (CommandCode)
				{
				case (SINCR_BATT):         
					// sfrutto il messaggio   	 
					SincrBatt(); 
					break;
					
				case (WAIT_TIME):         
					// sfrutto il messaggio   	 
					WaitState();
					break;
				case (TYPE_CURSOR):
					
					//
					TypeCursor();
					break;
				default:
					// per ora niente
					break; 			
				}  
				buffermsg[0]='\0';       
				
			} 
		}   
	}  
	
	
	
#else
	return 0;
#endif 
	
}


RetCode Network::SendAck(int tid_destinatario, char* ack, TipoMsg Msg)
{ 
	
#ifdef WITH_NET   
	
	if (Packet(ack)==NO_PACKET) return NO_PACKET;
	
	int info_send = pvm_send(tid_destinatario, Msg);
	if (info_send<0)
	{
		switch (info_send)
		{
		case -2:
			EM.Error(PVM_ERR_AREA,"EC_PVM_BADPAR","Network","SendAck");
			// errore nell'invio del messaggio di ack
			return(NO_SEND_SEND);
			break;
		case -14:
			EM.Error(PVM_ERR_AREA,"EC_PVM_SYSERROR","Network","SendAck");
			// errore nell'invio del messaggio di ack
			return(NO_SEND_SEND);
			break;
		case -15:
			EM.Error(PVM_ERR_AREA,"EC_PVM_NOBUF","Network","SendAck");
			// errore nell'invio del messaggio di ack
			return(NO_SEND_SEND);
			break;
			
		}	
		
	}
	return(OK_SEND_ACK);
	
	
#else
	return 0;
#endif 
	
}




RetCode Network::Receive()
{
	
#ifdef WITH_NET   
	
	//   
	// interrogazione buffer di ricezione messaggi : se presente un messaggio
	// allora ricezione del messaggio in Array altrimenti esce
	int info_rec = pvm_nrecv(ANY_SENDER,MSG_EFFETTIVO);  
	if (info_rec<=0) info_rec = pvm_nrecv(ANY_SENDER,MSG_MULTICAST);  
	
	if (info_rec==0) return(NO_MSG);
	if (info_rec<0)
	{
		switch (info_rec)
		{
		case -2:
			EM.Error(PVM_ERR_AREA,"EC_PVM_BADPAR","Network","Receive()");
			// errore nella ricezione del messaggio  
			return(ERR_REC);
			break;
		case -14:
			EM.Error(PVM_ERR_AREA,"EC_PVM_SYSERROR","Network","Receive()");
			// errore nella ricezione del messaggio
			return(ERR_REC);
			break;
		}	
	}
	
	if (UnPacket(Array)==NO_UNPACKET) return NO_UNPACKET;
	
	return(OK_RECEIVE_MSG);
	
#else
	return 0;
#endif 
	
}

RetCode Network::Packet(char *Stringa)
{
#ifdef WITH_NET   
	int bufid = pvm_initsend(PvmDataDefault);
	if (bufid<0)
	{
		switch (bufid)
		{
		case -2:
			EM.Error(PVM_ERR_AREA,"EC_PVM_BADPAR","Network","Packet()");
			// errore nella inizializzazione del buffer  
			return(NO_PACKET);
			break;
		case -10:
			EM.Error(PVM_ERR_AREA,"EC_PVM_NOMEM","Network","Packet()");
			// errore nella inizializzazione del buffer  
			return(NO_PACKET);
			break;
		}
	}		
	
	int info_pack = pvm_pkstr(Stringa);
	if (info_pack<0)
	{
		switch (info_pack)
		{
		case -15:
			EM.Error(PVM_ERR_AREA,"EC_PVM_NOBUF","Network","Packet()");
			// errore nella inizializzazione del buffer  
			return(NO_PACKET);
			break;
		case -10:
			EM.Error(PVM_ERR_AREA,"EC_PVM_NOMEM","Network","Packet()");
			// errore nella inizializzazione del buffer  
			return(NO_PACKET);
			break;
		}		
	}
	return OK_PACKET;
	
#else
	return 0;
#endif 
	
}



RetCode Network::UnPacket(char * Stringa)
{
#ifdef WITH_NET   
	int info_upk_ack = pvm_upkstr(Stringa);
	if (info_upk_ack<0)
	{
		switch (info_upk_ack)
		{
		case -5:
			EM.Error(PVM_ERR_AREA,"EC_PVM_NODATA","Network","UnPacket");
			// errore nello spacchetare il messaggio di Ack  
			return(NO_UNPACKET);
			break;
		case -12:
			EM.Error(PVM_ERR_AREA,"EC_PVM_BADMSG","Network","UnPacket");
			// errore nello spacchetare il messaggio di Ack
			return(NO_UNPACKET);
			break;
		case -15:
			EM.Error(PVM_ERR_AREA,"EC_PVM_NOBUF","Network","UnPacket");
			// errore nello spacchetare il messaggio di Ack
			return(NO_UNPACKET);
			break;
		}	
	}
	return OK_UNPACKET;
	
#else
	return 0;
#endif 
	
}


//
// il flag e' del tipo
//   FLAG='n'   nel caso di ack negativo
//   FLAG='p'   nel caso di ack positivo
char * Network::FormaAck(char ID_Tx,char * buffermsg,char FLAG, char *Dest)
{ 
/* Schema dell'ACK !!!!!
ID_Tx | ID_Rx + DIM_COMMAND_STRING | FLAG 
	<-- Messaggio Ricevuto ----> */
	
	Dest[0]=ID_Tx+1; 
	strncpy(Dest+DIM_ID, buffermsg,DIM_ID+DIM_COMMAND_STRING);  
	Dest[DIM_ID+DIM_ID+DIM_COMMAND_STRING]=FLAG; 
	Dest[DIM_ID+DIM_ID+DIM_COMMAND_STRING+1] = '\0';
	
	return Dest;
}
