/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: net.hpp,v 1.1 2005/07/25 16:31:42 bellinpo Exp $ */




#ifndef NETWORK_HPP
#define NETWORK_HPP

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WITH_NET   

#include "/home/pvm/pvm3/include/pvm3.h"

#endif

#include "def_net.hpp"
#include "lioo.hpp"

extern char Array[];

class Network
{
private:
	
    RetCode Packet(char *Stringa);
    RetCode UnPacket(char *Stringa);
protected:  
    char my_ID;
	
public:
    Network();
	
	// Costruttore della classe.
    ~Network();
	// Distruttore
    unsigned char Getmy_ID();
    virtual void SincrBatt() {};
    virtual void WaitState() {};
    virtual void TypeCursor() {};
	
    RetCode SendMsg_ack_MaM(int); 
    RetCode SendMsg_ack(int);          
    RetCode SendMulticast(int *all_tid,int number);
	// invia un messaggio multicast a number LIOO con tid nel vettore all_tid
    
    RetCode SendAck(int , char*,TipoMsg Msg); 
	
	RetCode Receive();
	
    RetCode ReceiveAckMulticast(char* ack_atteso,unsigned char& id);
	// riceve un messaggio di ack inviato con modalita multicast
	// controlla anche che il messaggio sia quello atteso
	// Restituisce : OK_SEND se tutto ok
	//               NO_SEND se errore
	// Il messaggio di ack formato su lomas deve essere del tipo 
	//         ID lomas- primi byte del messaggio ricevuto
	
	bool Sym2String(char *CmdString, SymCmd SC);
	bool String2Sym(char *CmdString, SymCmd& SC);
	short int DecodeCommand(char* str_command);
	RetCode CodeCommand(short int field_command, char* sb);
	
	char * FormaAck(char ID_Tx,char * buffermsg,char FLAG, char *Dest);
};

#endif
