/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */
#include <wx/wx.h>

#include "smr/smr.hpp"
#include "pag/casellaimg.hpp"
#include "gui/dlg/casellaimgdlg.hpp"
#include "drw/musicedt.hpp"

#undef LoadImage

CasellaImg::CasellaImg()
{
	immagine=NULL;
	FileImg="";
}

CasellaImg::~CasellaImg()
{}


void CasellaImg::Draw()
{
	extern wxMusicEditor *MusicEditor;
	float magn = Scr->GetMagnification();
	bool removeAfterUse=false;

	SetPos(NULL,Point(X/magn,Y/magn));
	if(immagine==NULL)
	{	
		wxString d=MusicEditor->GetWdfObjectPath()+FileImg;
		SMRFile *smrf=MusicEditor->smrf;

		if(wxFileExists(d))
		{
			immagine= new Image();
			immagine->LoadImage((char *)(d.c_str()), Heigh, Width);	//DB: prova!
			if(immagine->IsLoaded())
			{	
				immagine->SetPos(NULL,Point(X/magn,Y/magn+(Heigh-immagine->GetHeight())));
				immagine->Draw();
			}
			if(removeAfterUse)
				wxRemoveFile(d);
		}
	}
	else
	{
		immagine->SetPos(NULL,Point(X/magn,Y/magn+(Heigh-immagine->GetHeight())));
		immagine->Draw();
	}
}

void CasellaImg::Edit(Battuta *pBat)
{
	extern wxMusicEditor *MusicEditor;
	extern LiooWindow *pMusicWin;
	wxString d;
	d.Clear();
	d=MusicEditor->GetWdfObjectPath();
	wxString x,y;
	CasellaImgDlg* dlg = new CasellaImgDlg();
	pMusicWin->PPartit->SetCasellaPtr(this);
	dlg->Centre();
	dlg->SetX(wxString::Format("%f",X));
	dlg->SetY(wxString::Format("%f",Y));
	dlg->SetHeight(wxString::Format("%d",Heigh));
	dlg->SetWidth(wxString::Format("%d",Width));
	dlg->SetPath(d+FileImg);
	if (dlg->ShowModal() == wxID_OK)
	{
		SetHeigh(dlg->GetHeight());
		SetWidth(dlg->GetWidth());
		SetX(dlg->GetX());
		SetY(dlg->GetY());
		SetFileImg(wxFileNameFromPath(dlg->GetPath()));
		ReLoad(dlg->GetPath(),dlg->GetHeight(),dlg->GetWidth());
		MusicEditor->RedrawViews(0,FALSE);
	}
}

void CasellaImg::ReLoad(wxString fileimg, int height, int width)
{
	immagine= new Image();
	immagine->LoadImage((char *)(fileimg.c_str()), height, width);
}

Casella* CasellaImg::Clone()
{
	CasellaImg *cas = new CasellaImg();
	cas->SetHeigh(Heigh);
	cas->SetWidth(Width);
	cas->SetFileImg(FileImg);
	return cas;
}
