/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: listapar.hpp,v 1.1 2005/07/25 16:31:45 bellinpo Exp $ */



#ifndef LISTAPARENTESI_HPP
#define LISTAPARENTESI_HPP

#include "bra/parent.hpp"
#include "lioo.hpp"
#include "lst/lista.hpp"

class ListaParentesi : public Lista
{
protected:
	NumCode CodeCounter;
	
public:
	ListaParentesi();
	~ListaParentesi();
	
	void Init();
	void Free();
	
	void SetCodeCounter(NumCode);
	NumCode GetCodeCounter();
	
	Parentesi *GetFirstPar();
	Parentesi *GetNextPar(Parentesi *r);
	
	
	Bool Add(CmdID cmd, Spartito *pS1, Spartito *pS2, ArgType& nc);
	void CancParentesiSpa(Spartito *psp);
	
	VUnit GetWidth();
	
	void Redraw(VUnit width,bool printing=false, int nsys=0);
	void Draw();
	void print(int nsys=0);
	
	Bool DeleteSym(DrawObject* sym);
	Bool Hit(const Point& p, SelObj sobj, DrawObject *& objsel,
		SymPath& symPath);
	Bool SymbolicHit(SymPath& symPath, SelObj sobj,
		DrawObject *& objsel);	    
	
	int SaveXML(FILE *fp);
};		       


#endif //LISTAPARENTESI_HPP
