/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: parted.cpp,v 1.1 2005/07/25 16:31:45 bellinpo Exp $ */


#include "par/parted.hpp"
#include "gui/extabil.hpp"
#include "liooext.hpp"

extern char Array[];
extern ExtLiooAbil liooAbil;



ParteD::ParteD()
{
}

ParteD::~ParteD() 
{
#ifdef DEBUG_FREE
#ifdef WITH_NET    
	FILE *pippo;
	pippo = fopen("/home/demo/integrazione/src/DEAL_NET.txt","a");
	fprintf(pippo,"\n\n\n ------------   DEALLOCO PARTE D  ----------------\n\n\n");
	fclose(pippo);
#else
	
#endif
#endif
	
} 


void ParteD::Free()
{
	listaSpa->Free();
	listaSpa->Init();
	Partitura::Free();
}




void ParteD::GoForward()
{ 
	if (((LoMas*)this)->GetWaitEditing() > 0) return;
	
	if (listaSpa->GoForward())  
	{
		//deseleziona gli oggetti
		DeselectAll();
		listaSel.Clear();
		Redraw();
		
		((DiMas*)this)->RichBattForward(1);
	}  
}



void ParteD::GoBackward()
{ 
	if (((LoMas*)this)->GetWaitEditing() > 0) return;
	
	if (listaSpa->GoBackward())
	{
		//deseleziona gli oggetti
		DeselectAll();
		listaSel.Clear();
		Redraw();
		
		((DiMas*)this)->RichBattBackward(1);
	}  
}

void ParteD::NetPiu5()
{
	
	if (GetFirstSpa() == NULL) return;
	
	if (((LoMas*)this)->GetWaitEditing() > 0) return;
	
	int j=0;
	int i=1;
	
	for (i=1;i<=5;i++)
		if (listaSpa->GoForward()) j++;
		
		if (j>0)
		{
			DeselectAll();
			listaSel.Clear();
			Redraw();
			
			((DiMas*)this)->RichBattForward(j);
		}
		
}
void ParteD::NetMeno5()
{
	
	if (GetFirstSpa() == NULL) return;
	
	if (((LoMas*)this)->GetWaitEditing() > 0) return;
	
	int i;
	int j=0;
	for (i=1;i<=5;i++)
		if (listaSpa->GoBackward()) j++;
		
		if (j>0)
		{
			//deseleziona gli oggetti
			DeselectAll();
			listaSel.Clear();
			Redraw();
			
			((DiMas*)this)->RichBattBackward(j);
		}
		
		
}


void ParteD::EditingGoBottom()
{
	
}

void ParteD::EditingJumpBatt(int nbat)
{
	
}


void ParteD::EditingGoTop()
{
	
	
}



void ParteD::RequestJump()
{
}

void ParteD::GestLabel()
{
}



Bool ParteD::ImmediateSel(const Point& p)
{
	DrawObject *obj, *spobj;
	int TmpCmd;
	Bool fl;
	
	switch(UsrSymCmd.CommandId)
	{
	case CMD_BATTUTA_CVIOLINO:
	case CMD_BATTUTA_CVIOLINO8:
	case CMD_BATTUTA_CVIOLINO8SOPRA:
	case CMD_BATTUTA_CBASSO:
	case CMD_BATTUTA_CBASSO8:
	case CMD_BATTUTA_CBASSO8SOPRA:
	case CMD_BATTUTA_CBASSOOLD:
	case CMD_BATTUTA_CBARITONO:
	case CMD_BATTUTA_CTENORE:
	case CMD_BATTUTA_CTENORE8:
	case CMD_BATTUTA_CCONTRALTO:
	case CMD_BATTUTA_CMEZZOSOPRANO:
	case CMD_BATTUTA_CSOPRANO:
	case CMD_BATTUTA_CPERCUSBOX:
	case CMD_BATTUTA_CPERCUS2LINES:
	case CMD_BATTUTA_CTAB:
	case CMD_BATTUTA_CVUOTA:
		
    case CMD_BATTUTA_ARMCHV_0D:
    case CMD_BATTUTA_ARMCHV_1D:
    case CMD_BATTUTA_ARMCHV_2D:
    case CMD_BATTUTA_ARMCHV_3D:
    case CMD_BATTUTA_ARMCHV_4D:
    case CMD_BATTUTA_ARMCHV_5D:
    case CMD_BATTUTA_ARMCHV_6D:
    case CMD_BATTUTA_ARMCHV_7D:
    case CMD_BATTUTA_ARMCHV_1B:
    case CMD_BATTUTA_ARMCHV_2B:
    case CMD_BATTUTA_ARMCHV_3B:
    case CMD_BATTUTA_ARMCHV_4B:
    case CMD_BATTUTA_ARMCHV_5B:
    case CMD_BATTUTA_ARMCHV_6B:
    case CMD_BATTUTA_ARMCHV_7B:
    case CMD_BATTUTA_ARMCHV_0Dm:
    case CMD_BATTUTA_ARMCHV_1Dm:
    case CMD_BATTUTA_ARMCHV_2Dm:
    case CMD_BATTUTA_ARMCHV_3Dm:
    case CMD_BATTUTA_ARMCHV_4Dm:
    case CMD_BATTUTA_ARMCHV_5Dm:
    case CMD_BATTUTA_ARMCHV_6Dm:
    case CMD_BATTUTA_ARMCHV_7Dm:
    case CMD_BATTUTA_ARMCHV_1Bm:
    case CMD_BATTUTA_ARMCHV_2Bm:
    case CMD_BATTUTA_ARMCHV_3Bm:
    case CMD_BATTUTA_ARMCHV_4Bm:
    case CMD_BATTUTA_ARMCHV_5Bm:
    case CMD_BATTUTA_ARMCHV_6Bm:
    case CMD_BATTUTA_ARMCHV_7Bm:
		ResetPath(UsrSymCmd);
		Hit(p,BATTUTA_SEL,spobj,UsrSymCmd.Path1);
		if(spobj==NULL)
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_BAT_NOTFOUND","ParteD","ImmediateSel()");
			return FALSE;
		}
		
		obj = ((Battuta*)spobj)->GetPLayer(0)->GetFirstF(); 
		if (obj != NULL)
		{
			if (p.x > obj->GetAbsPos().x) 
			{
				TmpCmd = UsrSymCmd.CommandId;
				SetCommand(CMD_BATTUTA_INS_SPAZIO,INSERT_SEL,BATPART_SEL,0,1,UsrSymCmd.CommandId);
				
				fl = InsertSel(p);
				
				UsrSymCmd.CommandId = (CmdID)TmpCmd;
				UsrSymCmd.SelectionType = IMMEDIATE_SEL;
				UsrSymCmd.SelObjType = BATTUTA_SEL;
				
				
				return fl;
			}
		}
		break;
		
    case CMD_BATTUTA_ERASE:
		ResetPath(UsrSymCmd);
		
        Hit(p,SPARTITO_SEL,spobj,UsrSymCmd.Path1);
        Hit(p,UsrSymCmd.SelObjType,obj,UsrSymCmd.Path1);
        if(spobj==NULL)
        {
			EM.Error(MUSICAL_ERR_AREA,"EC_SPA_NOTFOUND","ParteD","ImmediateSel()");
			return FALSE;
        }
		
		if (liooAbil.GetDelAbil(obj->GetID())==0) 
		{
			Message("Utente non abilitato a questa cancellazione");
			return FALSE;
		} 
		
#ifdef WITH_NET   
		NetInvioComando(UsrSymCmd);
		return TRUE;
#else
		return (((Spartito*)spobj)->SymCommand(UsrSymCmd)==CMD_OK);
#endif
		
    case CMD_PARTITURA_ADD_BATTUTA:
		return FALSE;
    case CMD_BATTUTA_BSINGOLA:
    case CMD_BATTUTA_BSINGOLA_RIP2B:
    case CMD_BATTUTA_BDOPPIA:
    case CMD_BATTUTA_BINIZIORIT:
    case CMD_BATTUTA_BFINERIT:
    case CMD_BATTUTA_BFINALE:
    case CMD_BATTUTA_BINIZIOFINERIT:
	case CMD_BATTUTA_BINVISIBILE:
		// Nuovi Aggiunti che non devono essere eseguiti :
    case CMD_SPARTITO_SET_NAME:
    case CMD_PARTITURA_DEL_BATTUTA:
    case CMD_PARTITURA_ADD_SPARTITO:
    case CMD_PARTITURA_ADD_GRAFFA:
		
		return FALSE;
    case CMD_DEL_COL_FIGURE:
		return FALSE;
    case CMD_BATTUTA_MOVIMENTO:
		return FALSE;
    default: ;
    }
	
	// chiede allo spartito se in p ci sono oggetti da selezionare
	ResetPath(UsrSymCmd);
	Hit(p,UsrSymCmd.SelObjType,obj,UsrSymCmd.Path1);
	
	
    // se obj e' NULL allora non c'e' stata selezione
	if(obj==NULL)
	{
		switch(UsrSymCmd.CommandId)
		{
			
		case CMD_NOTA_DIESIS:
		case CMD_NOTA_DIESIS1Q:
		case CMD_NOTA_DIESIS3Q:
		case CMD_NOTA_BEMOLLE:
		case CMD_NOTA_BEMOLLE1Q:
		case CMD_NOTA_BEMOLLE3Q:
		case CMD_NOTA_BEQUADRO:
		case CMD_NOTA_BEQUADRO1Q:
		case CMD_NOTA_BEQUADRO3Q:
		case CMD_NOTA_2DIESIS:
		case CMD_NOTA_2BEMOLLE:
			ResetPath(UsrSymCmd);
			Hit(p,ANY_SEL,obj,UsrSymCmd.Path1);
			
			// se obj e' NULL allora non c'e' stata selezione
			if(obj==NULL)
			{
				EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","Partitura","ImmediateSel()");
				return FALSE;
			}
			UsrSymCmd.SelObjType = ANY_SEL;
			
#ifdef WITH_NET   
			NetInvioComando(UsrSymCmd);
			return TRUE;
#else
			if (obj->SymCommand(UsrSymCmd)==CMD_OK)
			{
				NetInvioComando(UsrSymCmd);
				return TRUE;
			}
			else
				return FALSE;
#endif
			
			break;
			
		default:
			EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","Partitura","ImmediateSel()");
			return FALSE;
			
		}
		
	}
    
	switch(UsrSymCmd.CommandId)
	{
    case CMD_SPARTITO_ADD_LEGATURA_VALORE:
		SymbolicHit(UsrSymCmd.Path1,SPARTITO_SEL,spobj);
		
		if(spobj==NULL)
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_SPA_NOTFOUND","ParteD","ImmediateSel()");
			return FALSE;
		}
		
#ifdef WITH_NET   
		NetInvioComando(UsrSymCmd);
		return TRUE;
#else
		// Esegue immediatamente il comando impostato!
		if (((Spartito *)spobj)->SymCommand(UsrSymCmd)==CMD_OK) 
		{
			NetInvioComando(UsrSymCmd); // inutile!
			return TRUE;
		}
		else
			return FALSE;
#endif
		
    case CMD_DEL_SYMBOL:
		
		if (liooAbil.GetDelAbil(obj->GetID())==0) 
		{
			Message("Utente non abilitato a questa cancellazione");
			return FALSE;
		} 
		
#ifdef WITH_NET    
		
		NetInvioComando(UsrSymCmd);
		return TRUE;
#else
		
		return (DeleteSym((DrawObject*) obj));
#endif
		
    case CMD_PARTITURA_DEL_SPARTITO: 
		if (liooAbil.GetDelAbil(obj->GetID())==0) 
		{
			Message("Utente non abilitato a questa cancellazione");
			return FALSE;
		} 
#ifdef WITH_NET   
		NetInvioComando(UsrSymCmd);
		return TRUE;
#else
		return DelSpartito(UsrSymCmd);
#endif
		
    case CMD_BATTUTA_GRUPPONOTE2NOTE:
		if(DoCommandGruppo())
		{
			Redraw();
			return TRUE;
		}
		else
			return FALSE;
		
    default:
#ifdef WITH_NET   
		NetInvioComando(UsrSymCmd);
		return TRUE;
#else
		return (obj->SymCommand(UsrSymCmd)==CMD_OK);
#endif
	}
	
}


Bool ParteD::DoCommandGruppo()
{
	short layer;
	DrawObject *pObj;
	
	switch (UsrSymCmd.CommandId)
	{
		
    case CMD_BATTUTA_NOTE2GRUPPONOTE:
		// Controllo preliminare: le figure selezionate appartengono alla stessa
		// battuta ed allo stesso layer.
		if(UsrSymCmd.Path1.Array[BATTUTA_PATH_LEVEL]==0 ||
			UsrSymCmd.Path1.Array[BATTUTA_PATH_LEVEL]!=
			UsrSymCmd.Path2.Array[BATTUTA_PATH_LEVEL])
		{
			EM.Error(GENERAL_ERR_AREA,"EC_SELEZIONE_ERRATA","DiMas","DoCommandGruppo()");
			return FALSE;
		}
		layer = UsrSymCmd.Path1.Array[LAYER_PATH_LEVEL]-1;
		if(layer==0 || layer!=UsrSymCmd.Path2.Array[LAYER_PATH_LEVEL])
		{
			EM.Error(GENERAL_ERR_AREA,"EC_SELEZIONE_ERRATA","DiMas","DoCommandGruppo()");
			return FALSE;
		}
		
		// Rintraccia la battuta.
		SymbolicHit(UsrSymCmd.Path1,BATTUTA_SEL,pObj);
		if(pObj!=NULL)
		{     
			//	Imposta gli argomenti simbolici
			UsrSymCmd.ArgV[0] = (ArgType)layer;
			UsrSymCmd.ArgV[1] = (ArgType)(UsrSymCmd.Path1.Array[FIGURA1_PATH_LEVEL]);
			UsrSymCmd.ArgV[2] = (ArgType)(UsrSymCmd.Path2.Array[FIGURA1_PATH_LEVEL]);
			
#ifdef WITH_NET   
			NetInvioComando(UsrSymCmd);
			return TRUE;
#else
			return (((Battuta*)pObj)->SymCommand(UsrSymCmd)==CMD_OK);
#endif
		}
		
        EM.Error(MUSICAL_ERR_AREA,"EC_BAT_NOTFOUND","DiMas","DoCommandGruppo()");
		return FALSE;
		
		break;
		
    case CMD_BATTUTA_GRUPPONOTE2NOTE:
		// Rintraccia la battuta.
		SymbolicHit(UsrSymCmd.Path1,BATTUTA_SEL,pObj);
		if(pObj!=NULL)
		{
			// L'argomento e` gia` stato impostato
#ifdef WITH_NET   
			NetInvioComando(UsrSymCmd);
			return TRUE;
#else
			return (((Battuta*)pObj)->SymCommand(UsrSymCmd)==CMD_OK);
#endif
		}
        EM.Error(MUSICAL_ERR_AREA,"EC_BAT_NOTFOUND","DiMas","DoCommandGruppo()");
		return FALSE;
		
		break;
    default: ;
	}
    
	return FALSE;
}


CmdResult ParteD::SymCommand(SymCmd& SCmd, Battuta *pBattuta)
{ 
	DrawObject *pobj;
	
	switch(SCmd.CommandId)
	{
		// utilizzato solo dai DLIOO.
    case CMD_PARTITURA_END:
		exit(1);
		
	case CMD_DEL_SYMBOL:
		if (SymbolicHit(SCmd.Path1,SCmd.SelObjType,pobj))
		{ 
			if (DeleteSym((DrawObject*) pobj))
				return CMD_OK;
			else
            	   return CMD_FAIL;
		}
		else
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","ParteD","SymCommand()");
			return CMD_FAIL;
		}
		break;
		
    default:
		return Partitura::SymCommand(SCmd);
	}
	
	return CMD_UNKNOWN;
}

Bool ParteD::DoNetSymCmd()
{
	DrawObject *pObj, *pObj2;
	Battuta *pbat;
	
	
	Scr->GSetMainDrawArea();
	
	switch(NetSymCmd.CommandId)
	{
	case CMD_BATTUTA_CVIOLINO:
	case CMD_BATTUTA_CVIOLINO8:
	case CMD_BATTUTA_CVIOLINO8SOPRA:
	case CMD_BATTUTA_CBASSO:
	case CMD_BATTUTA_CBASSO8:
	case CMD_BATTUTA_CBASSO8SOPRA:
	case CMD_BATTUTA_CBASSOOLD:
	case CMD_BATTUTA_CBARITONO:
	case CMD_BATTUTA_CTENORE:
	case CMD_BATTUTA_CTENORE8:
	case CMD_BATTUTA_CCONTRALTO:
	case CMD_BATTUTA_CMEZZOSOPRANO:
	case CMD_BATTUTA_CSOPRANO:
	case CMD_BATTUTA_CPERCUSBOX:
	case CMD_BATTUTA_CPERCUS2LINES:
	case CMD_BATTUTA_CTAB:
	case CMD_BATTUTA_CVUOTA:
		
    case CMD_BATTUTA_ARMCHV_0D:
    case CMD_BATTUTA_ARMCHV_1D:
    case CMD_BATTUTA_ARMCHV_2D:
    case CMD_BATTUTA_ARMCHV_3D:
    case CMD_BATTUTA_ARMCHV_4D:
    case CMD_BATTUTA_ARMCHV_5D:
    case CMD_BATTUTA_ARMCHV_6D:
    case CMD_BATTUTA_ARMCHV_7D:
    case CMD_BATTUTA_ARMCHV_1B:
    case CMD_BATTUTA_ARMCHV_2B:
    case CMD_BATTUTA_ARMCHV_3B:
    case CMD_BATTUTA_ARMCHV_4B:
    case CMD_BATTUTA_ARMCHV_5B:
    case CMD_BATTUTA_ARMCHV_6B:
    case CMD_BATTUTA_ARMCHV_7B:
    case CMD_BATTUTA_ARMCHV_0Dm:
    case CMD_BATTUTA_ARMCHV_1Dm:
    case CMD_BATTUTA_ARMCHV_2Dm:
    case CMD_BATTUTA_ARMCHV_3Dm:
    case CMD_BATTUTA_ARMCHV_4Dm:
    case CMD_BATTUTA_ARMCHV_5Dm:
    case CMD_BATTUTA_ARMCHV_6Dm:
    case CMD_BATTUTA_ARMCHV_7Dm:
    case CMD_BATTUTA_ARMCHV_1Bm:
    case CMD_BATTUTA_ARMCHV_2Bm:
    case CMD_BATTUTA_ARMCHV_3Bm:
    case CMD_BATTUTA_ARMCHV_4Bm:
    case CMD_BATTUTA_ARMCHV_5Bm:
    case CMD_BATTUTA_ARMCHV_6Bm:
    case CMD_BATTUTA_ARMCHV_7Bm:
		
		SymbolicHit(NetSymCmd.Path1,SPARTITO_SEL,pObj);
		
		if(pObj==NULL)
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_SPA_NOTFOUND","ParteD","DoNetSymCmd()");
			return FALSE;
		}
		
		if (((Spartito *)pObj)->SymCommand(NetSymCmd)==CMD_OK) 
			return TRUE;
		else
			return FALSE;
		
		break;
		
    case CMD_SPARTITO_SET_NAME:
		return (SymCommand(NetSymCmd)==CMD_OK);
		
		break;
		
    case CMD_PARTITURA_ADD_SPARTITO:
		SymbolicHit(NetSymCmd.Path1,SPARTITO_SEL,pObj2);
		if(pObj2!=NULL)
		{
			AddNewSpartito((Spartito*)pObj2, (Bool)NetSymCmd.ArgV[0]);
			GoTop();
			return TRUE;
		} 
		else 
			return FALSE;
		
		break;
		
    case CMD_PARTITURA_END:
		SymCommand(NetSymCmd);
		return TRUE;
		break;
		
	case CMD_PARTITURA_PRINT:
		SymCommand(NetSymCmd);
		return TRUE;
		break;  
		
    case CMD_PARTITURA_NEW:
		if(SymCommand(NetSymCmd)==CMD_OK)
		{
			GoTop();
			return TRUE;
		}
		else 
			return FALSE;
        
		break;
		
    case CMD_SPARTITO_ADD_LEGATURA:
    case CMD_SPARTITO_ADD_LEGATURA_VALORE:
    case CMD_SPARTITO_ADD_FORC_CRESC:
    case CMD_SPARTITO_ADD_FORC_DIMIN:
    case CMD_SPARTITO_ADD_FRECCIA:
    case CMD_SPARTITO_ADD_ONDA:
    case CMD_SPARTITO_ADD_LEG_QUADRA:
    case CMD_SPARTITO_ADD_CAMBIO_RIT:
    case CMD_SPARTITO_ADD_MODIF8:
	case CMD_SPARTITO_ADD_MODIF15MA:
    case CMD_SPARTITO_ADD_MODIF8BA:
	case CMD_SPARTITO_ADD_MODIF15BA:
	case CMD_SPARTITO_ADD_BEAM:
		return DoCommandInterv(NetSymCmd);
		
		break;
		
    case CMD_DEL_SYMBOL:
		
		SymbolicHit(NetSymCmd.Path1,ANY_SEL,pObj);
		if(pObj!=NULL) return (SymCommand(NetSymCmd)==CMD_OK);
		else return FALSE;
		
		break;
		
    case CMD_BATTUTA_GRUPPONOTE2NOTE:
    case CMD_BATTUTA_NOTE2GRUPPONOTE:
		SymbolicHit(NetSymCmd.Path1,BATTUTA_SEL,pObj);
		if(pObj!=NULL)
			return (((Battuta*)pObj)->SymCommand(NetSymCmd)==CMD_OK);
		else 
			return FALSE;
		
		break;
		
    case CMD_PARTITURA_ADD_BATTUTA:
		
		SymbolicHit(NetSymCmd.Path1,SPARTITO_SEL,pObj2);
		if(pObj2!=NULL)
		{
			SymbolicHit(NetSymCmd.Path1,BATTUTA_SEL,pObj);
			if(pObj!=NULL)     
				return (((Spartito*)pObj2)->SymCommand(NetSymCmd)==CMD_OK);
			else 
				return FALSE;
		} 
		else 
			return FALSE;
		
		break;
		
		
    case CMD_DEL_COL_FIGURE:
    case CMD_PARTITURA_DEL_BATTUTA:
		SymbolicHit(NetSymCmd.Path1, SPARTITO_SEL, pObj);
		if(pObj!=NULL)
			return (((Spartito*)pObj)->SymCommand(NetSymCmd)==CMD_OK);
		else 
			return FALSE;
		
		break;
		
    default:
		SymbolicHit(NetSymCmd.Path1, BATTUTA_SEL,(DrawObject*&) pbat);
		SymbolicHit(NetSymCmd.Path1, NetSymCmd.SelObjType, pObj);
		if(pObj!=NULL)
			return (pObj->SymCommand(NetSymCmd,pbat)==CMD_OK);
		else 
			return FALSE;
		
		break;
  }
  
  return TRUE;
}


void ParteD::BEEP(char * Stringa) 
{ 
}
