/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: partel.cpp,v 1.1 2005/07/25 16:31:46 bellinpo Exp $ */


#include "par/partel.hpp"
#include "gui/extabil.hpp"
#include "liooext.hpp"
#include "drw/musicedt.hpp"  
#include "drw/scorecan.hpp"  
#include "bra/pargraff.hpp"  

extern char Array[];
extern ExtLiooAbil liooAbil;

ParteL::ParteL(bool empty) : Partitura(empty)
{
}

ParteL::~ParteL()
{  
#ifdef DEBUG_FREE
#ifdef WITH_NET    
	FILE *pippo;
	
	pippo = fopen("/home/demo/integrazione/src/DEAL_NET.txt","a");
	fprintf(pippo,"\n\n\n ------------   DEALLOCO PARTEL  ----------------\n\n\n");
	fclose(pippo);
#else
#endif
#endif
}

void ParteL::Free()
{
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if (pCurSpa != NULL) pCurSpa->Free();
	Partitura::Free();
}

void ParteL::Init()
{
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if (pCurSpa != NULL) pCurSpa->Init();
	Partitura::Free();
}


void ParteL::GoForward()
{ 
	short nb = 1;
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if (pCurSpa == NULL) return;
	
	
	if (((LoMas*)this)->GetWaitEditing() > 0) return;
	
	
	if (pCurSpa->GoForward())
	{
		//deseleziona gli oggetti
		DeselectAll();
		listaSel.Clear();
		Redraw();
		
		((LoMas*)this)->RichBattForward(nb);
	}
	
}


void ParteL::GoBackward()
{ 
	short nb;
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if (pCurSpa == NULL) return;
	
	if (((LoMas*)this)->GetWaitEditing() > 0) return;
	
	nb = 0;
	
	
	if (pCurSpa->GoBackward())
	{
		//deseleziona gli oggetti
		DeselectAll();
		listaSel.Clear();
		Redraw();
		
		((LoMas*)this)->RichBattBackward(nb);
	}
}


void ParteL::NetPiu5()
{
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if (pCurSpa == NULL) return;
	
	if (((LoMas*)this)->GetWaitEditing() > 0) return;
	
	int j=0;
	int i=1;
	for (i=1;i<=5;i++)
		if (pCurSpa->GoForward()) j++;
		
		if (j>0)
		{
			DeselectAll();
			listaSel.Clear();
			Redraw();
			
			((LoMas*)this)->RichBattForward(j);
		}		
}



void ParteL::NetMeno5()
{
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if (pCurSpa == NULL) return;
	
	if (((LoMas*)this)->GetWaitEditing() > 0) return;
	
	int j=0;
	
	for (int i=1;i<=5;i++)
		if (pCurSpa->GoBackward()) j++;
		
		if (j>0)
		{
			DeselectAll();
			listaSel.Clear();
			Redraw();
			
			((LoMas*)this)->RichBattBackward(j);
		}		
		
}




void ParteL::EditingGoBottom()
{
	
}

void ParteL::EditingJumpBatt(int nbat)
{
	
}


void ParteL::EditingGoTop()
{
	
	
}


void ParteL::RequestJump()
{
	//RequestJump();
}
void ParteL::GestLabel()
{
}


Bool ParteL::GoNextPage()
{	
    // va alla pagina successiva e la disegna in Disegno (finestra o pixmap)
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if (pCurSpa == NULL) return FALSE;
	
	if(pCurSpa->PageDwn())
	{
#ifdef SCR_FINESTRE
		Scr->GSetDrawArea(pMusicWin->GetDisegnoDrawingArea());  
		Redraw();
		Scr->GSetMainDrawArea();
#else
		Scr->GSetPixmap(Scr->GetLPixmapDisegno());
		Redraw();
		Scr->GResetPixmap();
#endif			
		return TRUE;
	}
	return FALSE;
}

Bool ParteL::GoPrevPage()
{	
    // va alla pagina precedente e la disegna in Disegno (finestra o pixmap)
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if (pCurSpa == NULL) return FALSE;
	
	if(pCurSpa->PageUp())
	{
#ifdef SCR_FINESTRE
		Scr->GSetDrawArea(pMusicWin->GetDisegnoDrawingArea());  
		Redraw();
		Scr->GSetMainDrawArea();
#else
		Scr->GSetPixmap(Scr->GetLPixmapDisegno());
		Redraw();
		Scr->GResetPixmap();
#endif			
		return TRUE;
	}
	return FALSE;
}


void ParteL::AddSpartito(Spartito *pSp)
{
    listaSpa->Add(pSp);
}


void ParteL::SetNPentagrammi(int n5)
{
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if (pCurSpa == NULL) return;
	
	if (!printing_status)
		pCurSpa->SetNPentagrammi(n5,listaSpa->GetMusicRect());
	else
	{
		if (pCurSpa->GetNumberOfStaff()!=1)
		{
			Rectangle PrintPar_rect=listaSpa->GetPrintRect();
			PrintPar_rect.PUpLft.x=PrintPar_rect.PUpLft.x+WIDTH_PAR_GRAFFA+2;
			pCurSpa->SetNPentagrammi(n5,PrintPar_rect,true);
		}
		else
			pCurSpa->SetNPentagrammi(n5,listaSpa->GetPrintRect(),true);
	}
}


void ParteL::DrawTagli(const Point& p)
{
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if (pCurSpa == NULL) return;
	
	pCurSpa->DrawTagli(p);
}

void ParteL::Redraw(bool printing)
{
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if(pMusicWin==NULL || Scr==NULL) return;
	
	if (pCurSpa == NULL) return;
	
	// abilita il disegno solo all'interno della finestra in modo da non
	// sporcare fuori.
	BeginPaint();
	
	if(!printing)
		Scr->SetMagnification(GetComputerViewParams()->GetMagnification());
	else
		Scr->SetMagnification(GetPrintViewParams()->GetMagnification());

	// cancella l'area interna
	pMusicWin->Clear(); 
	
	
	if (printing_status)
	{
		
		extern wxMusicEditor *MusicEditor;
		int nPage=pCurSpa->GetCurrentPage();
		int startx = GetPrintViewParams()->GetLeftMargin(nPage);
		int starty = GetPrintViewParams()->GetBottomMargin(nPage);
		int endx = (listaSpa->GetPrintRect().Width())+GetPrintViewParams()->GetLeftMargin(nPage);
		int endy = (listaSpa->GetPrintRect().Height())+GetPrintViewParams()->GetBottomMargin(nPage);
		wxScrolledWindow* canvas = (wxScrolledWindow*)MusicEditor->mainFrame->FindWindow(wxMEScoreCanvas_ID);
		int vw,vh;
		canvas->GetVirtualSize(&vw,&vh);
		if(vw/10 != listaSpa->GetPrintRect().Width()/10+2 || vh/10 != listaSpa->GetPrintRect().Height()/10+2)
			canvas->SetScrollbars(10, 10,(listaSpa->GetPrintRect().Width())/10+2, (listaSpa->GetPrintRect().Height())/10+2,0,0,TRUE);
		SetNPentagrammi(GetPrintViewParams()->GetNumStaff(nPage));
		pCurSpa->Redraw();
		Draw();
	}
	else 	
	{
		extern wxMusicEditor *MusicEditor;
		
		
		pCurSpa->Redraw();
		Draw();
		
		// imposta la regione di disegno precedente.
		EndPaint();
	}
}


void ParteL::Draw()
{
	
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	if (pCurSpa == NULL) return;
	
	// abilita il disegno solo all'interno della finestra in modo da non
	// sporcare fuori.
	BeginPaint();
	
	// cancella l'area interna
	pMusicWin->Clear();
	
	//  listaSpa->DrawPage();
	
	int Graffa_altezza;
	
	int nPage=pCurSpa->GetCurrentPage();
	if (printing_status)
	{
		
		int left = GetPrintViewParams()->GetLeftMargin(nPage);
		int bottom = GetPrintViewParams()->GetBottomMargin(nPage);
		int right = GetPrintViewParams()->GetRightMargin(nPage);
		int top = GetPrintViewParams()->GetTopMargin(nPage);
		int width = listaSpa->GetPrintRect().Width();
		int height = listaSpa->GetPrintRect().Height();
		Colore oldcol = Scr->GetColor();
		Scr->SetColor((ColorIcon)SELECTED_COLOR);
		Scr->SetDrwMode(XORMode);
		// segnala pagina in celeste - e' uguale al PrintRect
		Scr->Rect(class Rectangle(Point(0,0), Point(width,height)));
		Scr->SetDrwMode(DefMode);
		// segnala rettangolo di stampa (rosso) = pagina - margini
		Scr->Rect(class Rectangle(Point(left,bottom), Point(width-right+1,height-top)));
		Scr->SetColor((ColorIcon)NORMAL_COLOR);
		Scr->SetDrwMode(DefMode);
		pCurSpa->DrawPage();	
		if (pCurSpa->GetNumberOfStaff()>1)
			for(int idx=0;idx<GetPrintViewParams()->GetNumStaff(nPage);idx++) 
			{	  
				if (pCurSpa->GetIsUsed(idx))
				{
					Scr->Line(pCurSpa->GetAbsPos(idx) + Point(0,(pCurSpa->GetBaseVU2Up())), 
						pCurSpa->GetAbsPos(idx)+Point(0,-(pCurSpa->GetBaseVU2Dwn())),SOLID_LINE);
					Graffa_altezza = pCurSpa->GetBaseVU2Up()+pCurSpa->GetBaseVU2Dwn();
					ParGraffa pPar(Graffa_altezza);
					pPar.Draw4single(pCurSpa->GetAbsPos(idx).x,pCurSpa->GetAbsPos(idx).y+pCurSpa->GetBaseVU2Up());
				}
			}	
		Scr->SetColor(oldcol);
	}
	else
	{  
		pCurSpa->Draw();	
		Colore oldcol = Scr->GetColor();
		Scr->SetColor((ColorIcon)black); 
		if (pCurSpa->GetNumberOfStaff()>1)
			for(int idx=0;idx<pCurSpa->GetNPentagrammi();idx++)
			{
				if (pCurSpa->GetIsUsed(idx))
				{
					Scr->Line((pCurSpa->GetAbsPos(idx)) + Point(0,(pCurSpa->GetBaseVU2Up())), 
						pCurSpa->GetAbsPos(idx)+Point(0,-(pCurSpa->GetBaseVU2Dwn())),SOLID_LINE);
					Graffa_altezza = pCurSpa->GetBaseVU2Up()+pCurSpa->GetBaseVU2Dwn();
					ParGraffa pPar(Graffa_altezza);
					pPar.Draw4single(pCurSpa->GetAbsPos(idx).x,pCurSpa->GetAbsPos(idx).y+pCurSpa->GetBaseVU2Up());
				}
			}
		Scr->SetColor(oldcol);
	}
	// imposta la regione di disegno precedente.
	EndPaint();
	
}

Bool ParteL::ImmediateSel(const Point& p)
{
	Bool fl;
	int TmpCmd;
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	DrawObject *obj, *spobj;
	switch(UsrSymCmd.CommandId)
	{
	case CMD_BATTUTA_CVIOLINO:
	case CMD_BATTUTA_CVIOLINO8:
	case CMD_BATTUTA_CVIOLINO8SOPRA:
	case CMD_BATTUTA_CBASSO:
	case CMD_BATTUTA_CBASSO8:
	case CMD_BATTUTA_CBASSO8SOPRA:
	case CMD_BATTUTA_CBASSOOLD:
	case CMD_BATTUTA_CBARITONO:
	case CMD_BATTUTA_CTENORE:
	case CMD_BATTUTA_CTENORE8:
	case CMD_BATTUTA_CCONTRALTO:
	case CMD_BATTUTA_CMEZZOSOPRANO:
	case CMD_BATTUTA_CSOPRANO:
	case CMD_BATTUTA_CPERCUSBOX:
	case CMD_BATTUTA_CPERCUS2LINES:
	case CMD_BATTUTA_CTAB:
	case CMD_BATTUTA_CVUOTA:
		
    case CMD_BATTUTA_ARMCHV_0D:
    case CMD_BATTUTA_ARMCHV_1D:
    case CMD_BATTUTA_ARMCHV_2D:
    case CMD_BATTUTA_ARMCHV_3D:
    case CMD_BATTUTA_ARMCHV_4D:
    case CMD_BATTUTA_ARMCHV_5D:
    case CMD_BATTUTA_ARMCHV_6D:
    case CMD_BATTUTA_ARMCHV_7D:
    case CMD_BATTUTA_ARMCHV_1B:
    case CMD_BATTUTA_ARMCHV_2B:
    case CMD_BATTUTA_ARMCHV_3B:
    case CMD_BATTUTA_ARMCHV_4B:
    case CMD_BATTUTA_ARMCHV_5B:
    case CMD_BATTUTA_ARMCHV_6B:
    case CMD_BATTUTA_ARMCHV_7B:
		
    case CMD_BATTUTA_ARMCHV_0Dm:
	case CMD_BATTUTA_ARMCHV_1Dm:
	case CMD_BATTUTA_ARMCHV_2Dm:
	case CMD_BATTUTA_ARMCHV_3Dm:
	case CMD_BATTUTA_ARMCHV_4Dm:
	case CMD_BATTUTA_ARMCHV_5Dm:
	case CMD_BATTUTA_ARMCHV_6Dm:
	case CMD_BATTUTA_ARMCHV_7Dm:
	case CMD_BATTUTA_ARMCHV_1Bm:
	case CMD_BATTUTA_ARMCHV_2Bm:
	case CMD_BATTUTA_ARMCHV_3Bm:
	case CMD_BATTUTA_ARMCHV_4Bm:
	case CMD_BATTUTA_ARMCHV_5Bm:
	case CMD_BATTUTA_ARMCHV_6Bm:
	case CMD_BATTUTA_ARMCHV_7Bm:
		ResetPath(UsrSymCmd);
		Hit(p,BATTUTA_SEL,spobj,UsrSymCmd.Path1);
		if(spobj==NULL)
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_BAT_NOTFOUND","ParteD","ImmediateSel()");
			return FALSE;
		}
		
		obj = ((Battuta*)spobj)->GetPLayer(0)->GetFirstF();
		if (obj != NULL)
		{
			if (p.x > obj->GetAbsPos().x) 
			{
				TmpCmd = UsrSymCmd.CommandId;
				SetCommand(CMD_BATTUTA_INS_SPAZIO,INSERT_SEL,BATPART_SEL,0,1,UsrSymCmd.CommandId);
				
				fl = InsertSel(p);
				
				UsrSymCmd.CommandId = (CmdID)TmpCmd;
				UsrSymCmd.SelectionType = IMMEDIATE_SEL;
				UsrSymCmd.SelObjType = BATTUTA_SEL;
				
				
				return fl;
			}
		}
		break;
		
		
		
	case CMD_PARTITURA_ADD_BATTUTA:
#ifdef WITH_NET   
		return TRUE;
#else
		return DoCommandAddBattuta(p);
#endif
	case CMD_BATTUTA_ERASE:
		ResetPath(UsrSymCmd);
		UsrSymCmd.Path2.Array[SPARTITO_PATH_LEVEL] =
			pCurSpa->GetNumericCode();
		Hit(p,UsrSymCmd.SelObjType,obj,UsrSymCmd.Path1);
		
		if (liooAbil.GetDelAbil(obj->GetID())==0) 
		{
			Message("Utente non abilitato a questa cancellazione");
			return FALSE;
		} 
		
#ifdef WITH_NET   
		NetInvioComando(UsrSymCmd);
		return TRUE;
#else
		return (pCurSpa->SymCommand(UsrSymCmd)==CMD_OK);
#endif
		
	case CMD_BATTUTA_LETTERA:
		ResetPath(UsrSymCmd);
		Hit(p,BATTUTA_SEL,spobj,UsrSymCmd.Path1);
		if(spobj==NULL)
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_BAT_NOTFOUND","Partitura","ImmediateSel()");
			return FALSE;
		}
		
		return CmdAddLettera(UsrSymCmd);
		
	case CMD_BATTUTA_MOVIMENTO:
		return FALSE;
		
	default: ;
  }
  
  // chiede allo spartito se in p ci sono oggetti da selezionare
  ResetPath(UsrSymCmd);
  Hit(p,UsrSymCmd.SelObjType,obj,UsrSymCmd.Path1);
  
  // se obj e' NULL allora non c'e' stata selezione
  if(obj==NULL)
  {
	  switch(UsrSymCmd.CommandId)
	  {
		  
	  case CMD_PARTITURA_INSERTTEXT:	
		  if(GetPrintingStatus())
		  {
			  Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
			  listaPag->CmdInsertText(p,pCurSpa->GetCurrentPage());
			  return TRUE;
		  }
		  break; 
		  
      case CMD_PARTITURA_PASTE_PAGEBOX: 
		  {
			  Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1); 
			  if(GetPrintingStatus())
				  return pCurSpa->PastePageBox(p,pCurSpa->GetCurrentPage());
		  }
		  
	  case CMD_NOTA_DIESIS:
	  case CMD_NOTA_DIESIS1Q:
      case CMD_NOTA_DIESIS3Q:
      case CMD_NOTA_BEMOLLE:
      case CMD_NOTA_BEMOLLE1Q:
      case CMD_NOTA_BEMOLLE3Q:
      case CMD_NOTA_BEQUADRO:
      case CMD_NOTA_BEQUADRO1Q:
      case CMD_NOTA_BEQUADRO3Q:
      case CMD_NOTA_2DIESIS:
      case CMD_NOTA_2BEMOLLE:
		  ResetPath(UsrSymCmd);
		  Hit(p,ANY_SEL,obj,UsrSymCmd.Path1);
		  
		  // se obj e' NULL allora non c'e' stata selezione
		  if(obj==NULL)
		  {
			  EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","Partitura","ImmediateSel()");
			  return FALSE;
		  }
		  
		  UsrSymCmd.SelObjType = ANY_SEL;
		  
#ifdef WITH_NET   
		  NetInvioComando(UsrSymCmd);
		  return TRUE;
#else
		  if (obj->SymCommand(UsrSymCmd)==CMD_OK)
		  {
			  NetInvioComando(UsrSymCmd);
			  return TRUE;
		  }
		  else
			  return FALSE;
#endif
		  
		  break;
		  
	  default:
		  EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","Partitura","ImmediateSel()");
		  return FALSE;
		  
	  }
	  
  }
  
  switch(UsrSymCmd.CommandId)
  {
  case CMD_SPARTITO_ADD_LEGATURA_VALORE:
	  SymbolicHit(UsrSymCmd.Path1,SPARTITO_SEL,spobj);
	  
	  if(spobj==NULL)
	  {
		  EM.Error(MUSICAL_ERR_AREA,"EC_SPA_NOTFOUND","ParteL","ImmediateSel()");
		  return FALSE;
	  }
	  
#ifdef WITH_NET   
	  NetInvioComando(UsrSymCmd);
	  return TRUE;
#else
	  // Esegue immediatamente il comando impostato!
	  if (((Spartito *)spobj)->SymCommand(UsrSymCmd)==CMD_OK) 
	  {
		  NetInvioComando(UsrSymCmd); // inutile!
		  return TRUE;
	  }
	  else
		  return FALSE;
#endif
	  
  case CMD_DEBUGMILLA_SEL_SYMBOL:
	  
	  // ho fatto lo hit e ho il puntatore a drawobject (obj)
	  // pero per chiamare Immrule e posrule mi servono il puntatore a nota e 
	  // alla battuta per cui devo chiamare lo opportuno symbolichit
	  // che dal path simbolico che ho mi restituisce questi valori
	  //	SymbolicHit(UsrSymCmd.Path1,BATTUTA_SEL,spobj); questo ad esempio cerca il puntatore a spartito
	  // 
	  
	  obj->SetTraceMilla(TRUE);
	  
	  return TRUE;
	  /////////////////////////
  case CMD_DEL_SYMBOL:
#ifdef WITH_NET   
	  NetInvioComando(UsrSymCmd);
	  return TRUE;
#else
	  return (DeleteSym((DrawObject*) obj));
#endif
	  
  case CMD_BATTUTA_GRUPPONOTE2NOTE:
	  if(DoCommandGruppo())
	  {
		  //Redraw();
		  return TRUE;
	  }
	  else
		  return FALSE;
	  
  case CMD_EDIT_SYMBOL:
	  
	  {
		  Battuta* pBat=NULL;
		  
		  // viene determinata la battuta dell'oggetto per sapere se si e' in multivoice
		  SymbolicHit(UsrSymCmd.Path1,BATTUTA_SEL,(DrawObject*&)pBat);
		  {
			  obj->Edit(pBat);	  
		  }
		  
	  }
	  return TRUE;
	  
  case CMD_PARTITURA_INSERTTEXT:	
	  if(GetPrintingStatus())
	  {		
		  Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
		  listaPag->CmdInsertText(p,pCurSpa->GetCurrentPage());
		  return TRUE;
	  }
	  break; 
	  
	  
  case CMD_PARTITURA_CUT_PAGEBOX: 
	  {		
		  if(GetPrintingStatus())
			  return pCurSpa->CutPageBox(obj);
	  }
	  
	  
  case CMD_PARTITURA_COPY_PAGEBOX: 
	  {
		  if(GetPrintingStatus())
			  return pCurSpa->CopyPageBox(obj);
	  }
	  
	  
  case CMD_PARTITURA_PASTE_PAGEBOX: 
	  {
		  if(GetPrintingStatus())
			  return pCurSpa->PastePageBox(p,pCurSpa->GetCurrentPage());
	  }
	  
  case CMD_PARTITURA_DEL_SPARTITO: 
	  if (liooAbil.GetDelAbil(obj->GetID())==0) 
	  {
		  Message("Utente non abilitato a questa cancellazione");
		  return FALSE;
	  } 
#ifdef WITH_NET   
	  NetInvioComando(UsrSymCmd);
	  return TRUE;
#else
#endif
  case CMD_FIGURA_SEELINK:
	  {
		  Battuta* pBat=NULL;
		  SymbolicHit(UsrSymCmd.Path1,BATTUTA_SEL,(DrawObject*&)pBat);
		  if(pBat!=NULL)
		  {
#ifdef WITH_NET   
			  NetInvioComando(UsrSymCmd);
			  return TRUE;
#else
			  return (obj->SymCommand(UsrSymCmd, pBat)==CMD_OK);
#endif
		  }   
		  return FALSE;
	  }
  default:
#ifdef WITH_NET   
	  NetInvioComando(UsrSymCmd);
	  return TRUE;
#else
	  return (obj->SymCommand(UsrSymCmd)==CMD_OK);
#endif
  }

  return FALSE;
}


Bool ParteL::DoCommandGruppo()
{
	short layer;//, i;
	DrawObject *pObj;
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	
	switch (UsrSymCmd.CommandId)
	{
		
    case CMD_BATTUTA_NOTE2GRUPPONOTE:
		// Controllo preliminare: le figure selezionate appartengono alla stessa
		// battuta ed allo stesso layer.
		if(UsrSymCmd.Path1.Array[BATTUTA_PATH_LEVEL]==0 ||
			UsrSymCmd.Path1.Array[BATTUTA_PATH_LEVEL]!=
			UsrSymCmd.Path2.Array[BATTUTA_PATH_LEVEL])
		{
			EM.Error(GENERAL_ERR_AREA,"EC_SELEZIONE_ERRATA","ParteL","DoCommandGruppo()");
			return FALSE;
		}
		layer = UsrSymCmd.Path1.Array[LAYER_PATH_LEVEL]-1;
		if(layer==0 || layer!=UsrSymCmd.Path2.Array[LAYER_PATH_LEVEL])
		{
			EM.Error(GENERAL_ERR_AREA,"EC_SELEZIONE_ERRATA","ParteL","DoCommandGruppo()");
			return FALSE;
		}
		
		// Rintraccia la battuta.
		SymbolicHit(UsrSymCmd.Path1,BATTUTA_SEL,pObj);
		if(pObj!=NULL)
		{     
			//	Imposta gli argomenti simbolici
			UsrSymCmd.ArgV[0] = (ArgType)layer;
			UsrSymCmd.ArgV[1] = (ArgType)(UsrSymCmd.Path1.Array[FIGURA1_PATH_LEVEL]);
			UsrSymCmd.ArgV[2] = (ArgType)(UsrSymCmd.Path2.Array[FIGURA1_PATH_LEVEL]);
			
#ifdef WITH_NET   
			NetInvioComando(UsrSymCmd);
			return TRUE;
#else
			return (((Battuta*)pObj)->SymCommand(UsrSymCmd)==CMD_OK);
#endif
		}
		
        EM.Error(MUSICAL_ERR_AREA,"EC_BAT_NOTFOUND","ParteL","DoCommandGruppo()");
		return FALSE;
		
		break;
		
    case CMD_BATTUTA_GRUPPONOTE2NOTE:
		// Rintraccia la battuta.
		SymbolicHit(UsrSymCmd.Path1,BATTUTA_SEL,pObj);
		if(pObj!=NULL)
		{
			// L'argomento e` gia` stato impostato
#ifdef WITH_NET   
			NetInvioComando(UsrSymCmd);
			return TRUE;
#else
			return (((Battuta*)pObj)->SymCommand(UsrSymCmd)==CMD_OK);
#endif
		}
        EM.Error(MUSICAL_ERR_AREA,"EC_BAT_NOTFOUND","ParteL","DoCommandGruppo()");
		return FALSE;
		
		break;
    default: ;
	}
    
	return FALSE;
}


CmdResult ParteL::SymCommand(SymCmd& SCmd, Battuta *pBattuta)
{ 
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	DrawObject *pobj;
	
	switch(SCmd.CommandId)
	{
		// utilizzato solo dai DLIOO.
    case CMD_PARTITURA_END:
		exit(1);
    case CMD_DEL_SYMBOL:
		if (SymbolicHit(SCmd.Path1,SCmd.SelObjType,pobj))
		{ 
			if (DeleteSym((DrawObject*) pobj))
				return CMD_OK;
			else
				return CMD_FAIL;
		}
		else
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","ParteL","SymCommand()");
			return CMD_FAIL;
		}
    default:
		return Partitura::SymCommand(SCmd);
	}
	
	return CMD_UNKNOWN;
}

Bool ParteL::DoNetSymCmd()
{
	Spartito *pCurSpa=GetSpartNum(GetCurrentScore()-1);
	DrawObject *pObj;
	Battuta *pbat;
	
	Scr->GSetMainDrawArea();
	
	switch(NetSymCmd.CommandId)
	{
	case CMD_BATTUTA_CVIOLINO:
	case CMD_BATTUTA_CVIOLINO8:
	case CMD_BATTUTA_CVIOLINO8SOPRA:
	case CMD_BATTUTA_CBASSO:
	case CMD_BATTUTA_CBASSO8:
	case CMD_BATTUTA_CBASSO8SOPRA:
	case CMD_BATTUTA_CBASSOOLD:
	case CMD_BATTUTA_CBARITONO:
	case CMD_BATTUTA_CTENORE:
	case CMD_BATTUTA_CTENORE8:
	case CMD_BATTUTA_CCONTRALTO:
	case CMD_BATTUTA_CMEZZOSOPRANO:
	case CMD_BATTUTA_CSOPRANO:
	case CMD_BATTUTA_CPERCUSBOX:
	case CMD_BATTUTA_CPERCUS2LINES:
	case CMD_BATTUTA_CTAB:
	case CMD_BATTUTA_CVUOTA:
		
    case CMD_BATTUTA_ARMCHV_0D:
    case CMD_BATTUTA_ARMCHV_1D:
    case CMD_BATTUTA_ARMCHV_2D:
    case CMD_BATTUTA_ARMCHV_3D:
    case CMD_BATTUTA_ARMCHV_4D:
    case CMD_BATTUTA_ARMCHV_5D:
    case CMD_BATTUTA_ARMCHV_6D:
    case CMD_BATTUTA_ARMCHV_7D:
    case CMD_BATTUTA_ARMCHV_1B:
    case CMD_BATTUTA_ARMCHV_2B:
    case CMD_BATTUTA_ARMCHV_3B:
    case CMD_BATTUTA_ARMCHV_4B:
    case CMD_BATTUTA_ARMCHV_5B:
    case CMD_BATTUTA_ARMCHV_6B:
    case CMD_BATTUTA_ARMCHV_7B:
	case CMD_BATTUTA_ARMCHV_0Dm:
	case CMD_BATTUTA_ARMCHV_1Dm:
	case CMD_BATTUTA_ARMCHV_2Dm:
	case CMD_BATTUTA_ARMCHV_3Dm:
	case CMD_BATTUTA_ARMCHV_4Dm:
	case CMD_BATTUTA_ARMCHV_5Dm:
	case CMD_BATTUTA_ARMCHV_6Dm:
	case CMD_BATTUTA_ARMCHV_7Dm:
	case CMD_BATTUTA_ARMCHV_1Bm:
	case CMD_BATTUTA_ARMCHV_2Bm:
	case CMD_BATTUTA_ARMCHV_3Bm:
	case CMD_BATTUTA_ARMCHV_4Bm:
	case CMD_BATTUTA_ARMCHV_5Bm:
	case CMD_BATTUTA_ARMCHV_6Bm:
	case CMD_BATTUTA_ARMCHV_7Bm:
		
		SymbolicHit(NetSymCmd.Path1,SPARTITO_SEL,pObj);
		
		if(pObj==NULL)
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_SPA_NOTFOUND","ParteL","DoNetSymCmd()");
			return FALSE;
		}
		
		if (((Spartito *)pObj)->SymCommand(NetSymCmd)==CMD_OK) 
			return TRUE;
		else
			return FALSE;
		
		break;
		
		
    case CMD_PARTITURA_END:
		SymCommand(NetSymCmd);
		return TRUE;
		break;
		
    case CMD_PARTITURA_NEW:
		Scr->GSetMainDrawArea();
		if(SymCommand(NetSymCmd)==CMD_OK)
		{
			GoTop();
			return TRUE;
		}
		else 
			return FALSE;
        
		break;
		
    case CMD_SPARTITO_ADD_LEGATURA:
    case CMD_SPARTITO_ADD_LEGATURA_VALORE:
    case CMD_SPARTITO_ADD_FORC_CRESC:
    case CMD_SPARTITO_ADD_FORC_DIMIN:
    case CMD_SPARTITO_ADD_FRECCIA:
    case CMD_SPARTITO_ADD_ONDA:
    case CMD_SPARTITO_ADD_LEG_QUADRA:
    case CMD_SPARTITO_ADD_CAMBIO_RIT:
    case CMD_SPARTITO_ADD_MODIF8:
	case CMD_SPARTITO_ADD_MODIF15MA:
    case CMD_SPARTITO_ADD_MODIF8BA:
	case CMD_SPARTITO_ADD_MODIF15BA:
	case CMD_SPARTITO_ADD_BEAM:
		return DoCommandInterv(NetSymCmd);
		
		break;
		
    case CMD_DEL_SYMBOL:
		SymbolicHit(NetSymCmd.Path1,ANY_SEL,pObj);
		if(pObj!=NULL)
			return (SymCommand(NetSymCmd)==CMD_OK);
		else 
			return FALSE;
		
		break;
		
    case CMD_BATTUTA_GRUPPONOTE2NOTE:
    case CMD_BATTUTA_NOTE2GRUPPONOTE:
		SymbolicHit(NetSymCmd.Path1,BATTUTA_SEL,pObj);
		if(pObj!=NULL)
			return (((Battuta*)pObj)->SymCommand(NetSymCmd)==CMD_OK);
		else 
			return FALSE;
		
		break;
		
    case CMD_PARTITURA_ADD_BATTUTA:
		SymbolicHit(NetSymCmd.Path1,BATTUTA_SEL,pObj);
		if(pObj!=NULL)     
			return (pCurSpa->SymCommand(NetSymCmd)==CMD_OK);
		else 
			return FALSE;
		
		break;
		
    case CMD_BATTUTA_INS_NBREVE:
    case CMD_BATTUTA_INS_NSEMIBREVE:
    case CMD_BATTUTA_INS_NMINIMA:
    case CMD_BATTUTA_INS_NSEMIMINIMA:
    case CMD_BATTUTA_INS_NCROMA:
    case CMD_BATTUTA_INS_NSEMICROMA:
    case CMD_BATTUTA_INS_NBISCROMA:
    case CMD_BATTUTA_INS_NSEMIBISCROMA:
    case CMD_BATTUTA_INS_NFUSA:
    case CMD_BATTUTA_INS_PQUABATT:
    case CMD_BATTUTA_INS_PDUEBATT:
    case CMD_BATTUTA_INS_PSEMIBREVE:
    case CMD_BATTUTA_INS_PMINIMA:
    case CMD_BATTUTA_INS_PSEMIMINIMA:
    case CMD_BATTUTA_INS_PCROMA:
    case CMD_BATTUTA_INS_PSEMICROMA:
    case CMD_BATTUTA_INS_PBISCROMA:
    case CMD_BATTUTA_INS_PSEMIBISCROMA:
    case CMD_BATTUTA_INS_PFUSA:
    case CMD_BATTUTA_INS_PGENERICA:
    case CMD_BATTUTA_INS_SPAZIO:
    case CMD_BATTUTA_INS_RIPTEMPO:
    case CMD_BATTUTA_INS_RIPBATTUTA:
    case CMD_BATTUTA_INS_RIPMEZZABATTUTA:
		
		SymbolicHit(NetSymCmd.Path1, NetSymCmd.SelObjType, pObj);
		if(pObj!=NULL)
		{
			return (pObj->SymCommand(NetSymCmd)==CMD_OK);
		}
		else 
			return FALSE;
		
		break;
		
    case CMD_DEL_COL_FIGURE:
    case CMD_PARTITURA_DEL_BATTUTA:
		SymbolicHit(NetSymCmd.Path1, SPARTITO_SEL, pObj);
		if(pObj!=NULL)
			return (((Spartito*)pObj)->SymCommand(NetSymCmd)==CMD_OK);
		else 
			return FALSE;
		
		break;
		
    default:
		SymbolicHit(NetSymCmd.Path1, BATTUTA_SEL,(DrawObject*&) pbat);
		SymbolicHit(NetSymCmd.Path1, NetSymCmd.SelObjType, pObj);
		if(pObj!=NULL)
			return (pObj->SymCommand(NetSymCmd,pbat)==CMD_OK);
		else 
			return FALSE;
		
		break;
  }
  
  return TRUE;
}


