/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: partel.hpp,v 1.1 2005/07/25 16:31:46 bellinpo Exp $ */


#ifndef PARTEL_HPP
#define PARTEL_HPP

#include "lioo.hpp"
#include "par/partitur.hpp"

class ParteL: public Partitura
{
  protected:
    
  public:
    ParteL(bool empty=false);
    ~ParteL();
    void Free();
    void Init();
    
    void SetNPentagrammi(int n5);
      // Imposta il numero di pentagrammi per pagina. Necessita di
      // avere impostato MusicRect.

    void GoForward();
      // Avanza di una battuta.
    void GoBackward();
      // Indietreggia di una battuta.
    
    void NetPiu5();
    void NetMeno5();

    void EditingGoBottom();     
	void EditingJumpBatt(int nbat);
	void EditingGoTop();
	void RequestJump();
    void GestLabel();

    Bool GoNextPage(); 
      // avanza di una pagina  
    Bool GoPrevPage(); 
      // torna indietro di una pagina


    virtual void AddSpartito(Spartito *pSp);
      // Dovrebbe aggiungere lo spartito in basso, ma
      // per il momento vigila che non ci sia piu` di uno spartito.
    

    void DrawTagli(const Point&);
      // disegna i tagli necessari per arrivare al punto indicato.

    void Draw();
    void Redraw(bool printing=false);
    void InitParte() {};

    Bool ImmediateSel(const Point& p);
    Bool DoCommandGruppo();
    CmdResult SymCommand(SymCmd& SCmd, Battuta *pb=NULL);
    Bool DoNetSymCmd();
};

#endif //PARTEL_HPP
