/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: partem.cpp,v 1.1 2005/07/25 16:31:46 bellinpo Exp $ */


#include "par/partem.hpp"
#include "liooext.hpp"



ParteM::ParteM()
{
}

ParteM::~ParteM()
{  
	
#ifdef WITH_NET   
#ifdef DEBUG_FREE
	
	FILE *pippo;
	
	pippo = fopen("/home/demo/integrazione/src/DEAL_NET.txt","a");
	fprintf(pippo,"\n\n\n ------------   DEALLOCO PARTE M  ----------------\n\n\n");
	fclose(pippo);
#endif 
	
#else
	
#ifdef DEBUG_FREE
#endif 
	
#endif 
}   


void ParteM::Free()
{
	listaSpa->Free();
	Partitura::Free();
}


void ParteM::EditingGoBottom()
{
	GoBatt(GetNumeroBattute());
}

void ParteM::EditingJumpBatt(int nbat)
{
	GoBatt(nbat);
}


void ParteM::EditingGoTop()
{
	GoTop();
}

void ParteM::RequestJump()
{
}
void ParteM::GestLabel()
{
}



//
// Utilizzato da MASAE quando DLIOO o MASE gli chiede di eseguire un comando.
//
// Si occupa anche di rimandare il comando agli altri leggii!
//
Bool ParteM::DoNetSymCmd()
{
	
	DrawObject *pObj,*pObj2;
	Battuta *pbat;
	Spartito *psp;
	Point p;
	Bool Modificato;
	SymCmd TempCmd;
	
	
	Modificato=FALSE;
	if(Scr!=NULL)
		Scr->GSetMainDrawArea();
	
	switch(NetSymCmd.CommandId)
	{
	case CMD_BATTUTA_CVIOLINO:
	case CMD_BATTUTA_CVIOLINO8:
	case CMD_BATTUTA_CVIOLINO8SOPRA:
	case CMD_BATTUTA_CBASSO:
	case CMD_BATTUTA_CBASSO8:
	case CMD_BATTUTA_CBASSO8SOPRA:
	case CMD_BATTUTA_CBASSOOLD:
	case CMD_BATTUTA_CBARITONO:
	case CMD_BATTUTA_CTENORE:
	case CMD_BATTUTA_CTENORE8:
	case CMD_BATTUTA_CCONTRALTO:
	case CMD_BATTUTA_CMEZZOSOPRANO:
	case CMD_BATTUTA_CSOPRANO:
	case CMD_BATTUTA_CPERCUSBOX:
	case CMD_BATTUTA_CPERCUS2LINES:
	case CMD_BATTUTA_CTAB:
	case CMD_BATTUTA_CVUOTA:
		
    case CMD_BATTUTA_ARMCHV_0D:
    case CMD_BATTUTA_ARMCHV_1D:
    case CMD_BATTUTA_ARMCHV_2D:
    case CMD_BATTUTA_ARMCHV_3D:
    case CMD_BATTUTA_ARMCHV_4D:
    case CMD_BATTUTA_ARMCHV_5D:
    case CMD_BATTUTA_ARMCHV_6D:
    case CMD_BATTUTA_ARMCHV_7D:
    case CMD_BATTUTA_ARMCHV_1B:
    case CMD_BATTUTA_ARMCHV_2B:
    case CMD_BATTUTA_ARMCHV_3B:
    case CMD_BATTUTA_ARMCHV_4B:
    case CMD_BATTUTA_ARMCHV_5B:
    case CMD_BATTUTA_ARMCHV_6B:
    case CMD_BATTUTA_ARMCHV_7B:
	case CMD_BATTUTA_ARMCHV_0Dm:
	case CMD_BATTUTA_ARMCHV_1Dm:
	case CMD_BATTUTA_ARMCHV_2Dm:
	case CMD_BATTUTA_ARMCHV_3Dm:
	case CMD_BATTUTA_ARMCHV_4Dm:
	case CMD_BATTUTA_ARMCHV_5Dm:
	case CMD_BATTUTA_ARMCHV_6Dm:
	case CMD_BATTUTA_ARMCHV_7Dm:
	case CMD_BATTUTA_ARMCHV_1Bm:
	case CMD_BATTUTA_ARMCHV_2Bm:
	case CMD_BATTUTA_ARMCHV_3Bm:
	case CMD_BATTUTA_ARMCHV_4Bm:
	case CMD_BATTUTA_ARMCHV_5Bm:
	case CMD_BATTUTA_ARMCHV_6Bm:
	case CMD_BATTUTA_ARMCHV_7Bm:
		
		if (NetSymCmd.ArgV[2]!=0) 
		{
			NetSymCmd.CommandId = CMD_BATTUTA_INS_SPAZIO;
			NetSymCmd.SelectionType = INSERT_SEL;
			NetSymCmd.SelObjType = BATPART_SEL;
		}
		else
		{
			SymbolicHit(NetSymCmd.Path1, SPARTITO_SEL, pObj);
			if(pObj!=NULL)
			{
				if (((Spartito *)pObj)->SymCommand(NetSymCmd)==CMD_OK)
				{
					SetStatoEsecuzione(IMPAGINAZIONE);      
					NetInvioComando(NetSymCmd);
				}
				else
				{
					EM.Error(GENERAL_ERR_AREA,"EC_CMDNET_FAULT","ParteM","DoNetSymCmd()");
					return FALSE;
				}
			}
			else 
			{
				EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","ParteM","DoNetSymCmd()");
				return FALSE;
			}
		}
		
		break;
		
    case CMD_BATTUTA_INS_NBREVE:
    case CMD_BATTUTA_INS_NSEMIBREVE:
    case CMD_BATTUTA_INS_NMINIMA:
    case CMD_BATTUTA_INS_NSEMIMINIMA:
    case CMD_BATTUTA_INS_NCROMA:
    case CMD_BATTUTA_INS_NSEMICROMA:
    case CMD_BATTUTA_INS_NBISCROMA:
    case CMD_BATTUTA_INS_NSEMIBISCROMA:
    case CMD_BATTUTA_INS_NFUSA:
    case CMD_BATTUTA_INS_PQUABATT:
    case CMD_BATTUTA_INS_PDUEBATT:
    case CMD_BATTUTA_INS_PSEMIBREVE:
    case CMD_BATTUTA_INS_PMINIMA:
    case CMD_BATTUTA_INS_PSEMIMINIMA:
    case CMD_BATTUTA_INS_PCROMA:
    case CMD_BATTUTA_INS_PSEMICROMA:
    case CMD_BATTUTA_INS_PBISCROMA:
    case CMD_BATTUTA_INS_PSEMIBISCROMA:
    case CMD_BATTUTA_INS_PFUSA:
    case CMD_BATTUTA_INS_PGENERICA:
    case CMD_BATTUTA_INS_SPAZIO:
    case CMD_BATTUTA_INS_RIPTEMPO:
    case CMD_BATTUTA_INS_RIPBATTUTA:
    case CMD_BATTUTA_INS_RIPMEZZABATTUTA:
		// Inserimento di Note, Pause, Ripetizioni, Spazio
		
		SymbolicHit(NetSymCmd.Path1, NetSymCmd.SelObjType, pObj);
		if(pObj==NULL)
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","ParteM","DoNetSymCmd()");
			return FALSE;
		}
		
		if (((Battuta*)pObj)->SymCommand(NetSymCmd)==CMD_OK)
		{
			SetStatoEsecuzione(IMPAGINAZIONE);      
			NetInvioComando(NetSymCmd);
		}
		else
		{
			EM.Error(GENERAL_ERR_AREA,"EC_CMDNET_FAULT","ParteM","DoNetSymCmd()");
			return FALSE;
		}
		
		break;
		
		
		
    case CMD_SPARTITO_ADD_LEGATURA_VALORE:
		SymbolicHit(NetSymCmd.Path1,SPARTITO_SEL,pObj);
		
		if(pObj==NULL)
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_SPA_NOTFOUND","ParteM","DoNetSymCmd()");
			return FALSE;
		}
		
		// Esegue immediatamente il comando impostato!
		if (((Spartito *)pObj)->SymCommand(NetSymCmd)==CMD_OK) 
			NetInvioComando(NetSymCmd);
		else
		{
			EM.Error(GENERAL_ERR_AREA,"EC_CMDNET_FAULT","ParteM","DoNetSymCmd()");
			return FALSE;
		}
		
		break;
		
    case CMD_PARTITURA_ADD_SPARTITO:
		SymbolicHit(NetSymCmd.Path1,SPARTITO_SEL,pObj);
		if(pObj!=NULL)
		{
			AddNewSpartito((Spartito*)pObj, (Bool)NetSymCmd.ArgV[0], (Bool)NetSymCmd.ArgV[1], NetSymCmd.Text);
			GoTop();
			return TRUE;
		} 
		else 
			return FALSE;
		
		break;
		
    case CMD_PARTITURA_DEL_SPARTITO:
		return DelSpartito(NetSymCmd);
		break;
    case CMD_PARTITURA_DEL_BATTUTA:
		SymbolicHit(NetSymCmd.Path1, SPARTITO_SEL, pObj);
		if(pObj!=NULL)
			return (((Spartito*)pObj)->SymCommand(NetSymCmd)==CMD_OK);
		else 
			return FALSE;
		
		break;
		
    case CMD_SPARTITO_ADD_LEGATURA:
    case CMD_SPARTITO_ADD_FORC_CRESC:
    case CMD_SPARTITO_ADD_FORC_DIMIN:
    case CMD_SPARTITO_ADD_FRECCIA:
    case CMD_SPARTITO_ADD_ONDA:
    case CMD_SPARTITO_ADD_LEG_QUADRA:
    case CMD_SPARTITO_ADD_CAMBIO_RIT:
    case CMD_SPARTITO_ADD_MODIF8:
	case CMD_SPARTITO_ADD_MODIF15MA:
    case CMD_SPARTITO_ADD_MODIF8BA:
	case CMD_SPARTITO_ADD_MODIF15BA:
	case CMD_SPARTITO_ADD_BEAM:
		
		if (DoCommandInterv(NetSymCmd))
			NetInvioComando(NetSymCmd);
		else
		{
			EM.Error(GENERAL_ERR_AREA,"EC_CMDNET_FAULT","ParteM","DoNetSymCmd()");
			return FALSE;
		}
		
		break;
		
    case CMD_DEL_SYMBOL:
		SymbolicHit(NetSymCmd.Path1,ANY_SEL,pObj);
		if(pObj!=NULL)
		{   
			if (DeleteSym((DrawObject*) pObj))
				NetInvioComando(NetSymCmd);
			else
				return FALSE;
		}
		else 
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","ParteM","DoNetSymCmd()");
			return FALSE;
		}
		
		break;
		
    case CMD_BATTUTA_GRUPPONOTE2NOTE:
    case CMD_BATTUTA_NOTE2GRUPPONOTE:
		SymbolicHit(NetSymCmd.Path1,BATTUTA_SEL,pObj);
		if(pObj!=NULL)
		{
			if (((Battuta*)pObj)->SymCommand(NetSymCmd)==CMD_OK)
				NetInvioComando(NetSymCmd);
			else
			{
				EM.Error(GENERAL_ERR_AREA,"EC_CMDNET_FAULT","ParteM","DoNetSymCmd()");
				return FALSE;
			}
		}
		else 
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_BAT_NOTFOUND","ParteM","DoNetSymCmd()");
			return FALSE;
		}
		
		break;
		
    case CMD_PARTITURA_ADD_BATTUTA:
		
		SymbolicHit(NetSymCmd.Path1,SPARTITO_SEL,pObj2);
		if(pObj2!=NULL)
		{
			SymbolicHit(NetSymCmd.Path1,BATTUTA_SEL,pObj);
			if(pObj!=NULL)     
				return (((Spartito*)pObj2)->SymCommand(NetSymCmd)==CMD_OK);
			else 
				return FALSE;
		} 
		else 
			return FALSE;
		
		break;
		
    case CMD_BATTUTA_ERASE:
		SymbolicHit(NetSymCmd.Path2, SPARTITO_SEL, pObj);
		psp = (Spartito *)pObj;
		if(psp!=NULL)
		{
			SymbolicHit(NetSymCmd.Path1, NetSymCmd.SelObjType, pObj);
			if(pObj!=NULL)
			{
				if (psp->SymCommand(NetSymCmd)==CMD_OK)
					NetInvioComando(NetSymCmd);
				else
				{
					EM.Error(GENERAL_ERR_AREA,"EC_CMDNET_FAULT","ParteM","DoNetSymCmd()");
					return FALSE;
				}
			}
			else 
			{
				EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","ParteM","DoNetSymCmd()");
				return FALSE;
			}
		}
		else
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_SPA_NOTFOUND","ParteM","DoNetSymCmd()");
			return FALSE;
		}
		break;
		
    case CMD_BATTUTA_LETTERA:
		if (!CmdAddLettera(NetSymCmd))
			return FALSE;
		break;
		
    case CMD_BATTUTA_BSINGOLA:
    case CMD_BATTUTA_BSINGOLA_RIP2B:
    case CMD_BATTUTA_BDOPPIA:
    case CMD_BATTUTA_BINIZIORIT:
    case CMD_BATTUTA_BFINERIT:
    case CMD_BATTUTA_BFINALE:
    case CMD_BATTUTA_BINIZIOFINERIT:
    case CMD_BATTUTA_BINVISIBILE:
    case CMD_BATTUTA_TEMPO:
		SymbolicHit(NetSymCmd.Path1, NetSymCmd.SelObjType, pObj);
		if(pObj!=NULL)
		{
			if (pObj->SymCommand(NetSymCmd)==CMD_OK)
			{
				SetStatoEsecuzione(IMPAGINAZIONE);      
				NetInvioComando(NetSymCmd);
			}
			else
			{
				EM.Error(GENERAL_ERR_AREA,"EC_CMDNET_FAULT","ParteM","DoNetSymCmd()");
				return FALSE;
			}
		}
		else 
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","ParteM","DoNetSymCmd()");
			return FALSE;
		}
		
		break;
		
    default:
		SymbolicHit(NetSymCmd.Path1, BATTUTA_SEL,(DrawObject*&) pbat);
		SymbolicHit(NetSymCmd.Path1, NetSymCmd.SelObjType, pObj);
		if(pObj!=NULL)
		{
			if (pObj->SymCommand(NetSymCmd,pbat)==CMD_OK)
				NetInvioComando(NetSymCmd);
			else
			{
				EM.Error(GENERAL_ERR_AREA,"EC_CMDNET_FAULT","ParteM","DoNetSymCmd()");
				return FALSE;
			}
		}
		else 
		{
			EM.Error(MUSICAL_ERR_AREA,"EC_OGG_NOTFOUND","ParteM","DoNetSymCmd()");
			return FALSE;
		}
		
		break;
		
  }
  
  if (Modificato) CopiaCommandStruct(&NetSymCmd,&TempCmd);
  
  return TRUE;
}
