/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: def_sca.hpp,v 1.1 2005/07/25 16:31:47 bellinpo Exp $ */



#ifndef def_sca_hpp
#define def_sca_hpp

// codice decimale 36
#define CODE_CODA "\x24"
#define DELTAXCODA Scr->Get_VU2DX(36)       
#define DELTAYCODA Scr->Get_VU2DY(36)       

// codice decimale 37
#define CODE_SEGNO "\x25"
#define DELTAXSEGNO Scr->Get_VU2DX(37)       
#define DELTAYSEGNO Scr->Get_VU2DY(37)       

// etichetta code
#define CODE_FITTIZIO_LABEL 15
#define DELTAXLABEL Scr->Get_VU2DX(CODE_FITTIZIO_LABEL)       
#define DELTAYLABEL Scr->Get_VU2DY(CODE_FITTIZIO_LABEL)       

// TESTO PER SALTO
#define CODE_FITTIZIO_TSALTO 14
#define DELTAXTSALTO Scr->Get_VU2DX(CODE_FITTIZIO_TSALTO)       
#define DELTAYTSALTO Scr->Get_VU2DY(CODE_FITTIZIO_TSALTO)       

// TESTO PER MOVIMENTO
#define CODE_FITTIZIO_MOVIMENTO 13
#define DELTAXMOVIMENTO Scr->Get_VU2DX(CODE_FITTIZIO_MOVIMENTO)       
#define DELTAYMOVIMENTO Scr->Get_VU2DY(CODE_FITTIZIO_MOVIMENTO)       
#define MOVSPAZIO 2

// TESTO PER METRONOMO
#define CODE_FITTIZIO_METRONOMO 12
#define DELTAXMETRONOMO Scr->Get_VU2DX(CODE_FITTIZIO_METRONOMO)       
#define DELTAYMETRONOMO Scr->Get_VU2DY(CODE_FITTIZIO_METRONOMO)       
#define METROSPAZIO 4
#define METRONUMSPAZIO 4
#define METRONPUNTI 1

// TESTO PER SCANSIONE
#define CODE_FITTIZIO_SCANSIONE 11
#define DELTAXSCANSIONE Scr->Get_VU2DX(CODE_FITTIZIO_SCANSIONE)       
#define DELTAYSCANSIONE Scr->Get_VU2DY(CODE_FITTIZIO_SCANSIONE)       
#define DIMSCANSIONEUP Scr->Get_VU2UP(CODE_FITTIZIO_SCANSIONE)          
#define DIMSCANSIONEDWN Scr->Get_VU2DWN(CODE_FITTIZIO_SCANSIONE)        
#define SPACESCANSIONE Scr->Get_VU2RG(CODE_FITTIZIO_SCANSIONE)         
#define DIMSCANSIONE2LINE Scr->Get_VU2LF(CODE_FITTIZIO_SCANSIONE)         
#define BARRANLFT 0
#define MARGINE_SCA 1

#endif //def_sca_hpp
