/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: metronom.hpp,v 1.1 2005/07/25 16:31:48 bellinpo Exp $ */


#ifndef METRONOM_HPP
#define METRONOM_HPP

#include "drw/drawobje.hpp"
#include "drw/tnumeric.hpp"
#include "fig/nota.hpp"
#include "drw/text.hpp"


class Metronomo : public DrawObject
{
  protected:
    TNumerico  MetroTNum;
    Nota       *ptrNota;
    Text       TParAperta,TParChiusa,TUguale;
    VUnit      VU2Rgt,VU2Up,VU2Dwn,VU2Lft;

  public:
    Metronomo();
	
	Metronomo(Metronomo *);
    
    TNumerico* GetTNumerico();
    
    Bool SetTNNumero(int s);
    Bool SetNota(ClassID  ident, Bool punt);
    void SetPos (DrawObject *drwobj,const Point& posizione);
	Nota* GetNota(){return ptrNota;};
    
    virtual void SetColor(int col);
    
float GetTimeExec();
float GetValNota();
    

    VUnit GetVU2Up();
    VUnit GetVU2Rgt();
    VUnit GetVU2Dwn();
    VUnit GetVU2Lft();
    void Draw();

	int SaveXML(FILE *fp);
};

#endif // METRONOM_HPP
