/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: scansion.cpp,v 1.1 2005/07/25 09:35:27 bellinpo Exp $ */

#include "sca/scansion.hpp"

Scansione::Scansione()
{
	ID=CL_SCANSIONE;
	numscan=0;
};

void Scansione::SetNumScan (int nscans)
{ numscan=nscans;};

int Scansione::GetNumScan ()
{ return numscan;};


VUnit Scansione::GetVU2Up()
{ return DIMSCANSIONEUP+DIMSCANSIONEDWN;};

VUnit Scansione::GetVU2Dwn()
{ return DIMSCANSIONEDWN+DIMSCANSIONEDWN;};

VUnit Scansione::GetVU2Rgt()
{ return numscan+((numscan-1)*SPACESCANSIONE);};

VUnit Scansione::GetVU2Lft()
{ return BARRANLFT+DIMSCANSIONEDWN;};

void Scansione::Draw()
{
	Point p, pr;
	Point pu, pd;
	int i;
	p=GetAbsPos();
	if (p==Point(0,0)) return;

	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	pr = p + Point(DELTAXSCANSIONE, DELTAYSCANSIONE)+Point(GetDx(),GetDy());
	pu = pr  + Point(0,-DIMSCANSIONEUP);
	pd = pr  + Point(DIMSCANSIONE2LINE,DIMSCANSIONEUP);
	for (i=0; i < numscan ; i++)
	{
		Scr->Rect(Rectangle(pu,pd), TRUE); 
		pu=pu+Point(SPACESCANSIONE,0);    	
		pd=pd+Point(SPACESCANSIONE,0);    	
	};

	Scr->SetColor(oldcol);
};









