/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */



#include "wx/wx.h"
#include "wx/dialog.h"
#include "wx/resource.h"
#include "wx/utils.h"

#include "drw/frmanage.hpp"
#include "lioo.hpp"

enum ApplicationId {
	APP_TEXTEDITOR=0,
	APP_FONTEDITOR,
	APP_MILLAEDITOR,
	APP_FRETEDITOR,
	APP_IMAGESLICER,
	APP_IMAGEWATERMARKER,
	APP_IMAGEWATERMARKERREADER,
	APP_PRINTEDSCOREWATERMARKERREADER,
	APP_IMAGECONVERTER,
	APP_EXTERNALAUDIOPLAYER,
	APP_CDTRACEEXTRACTOR,
	APP_AUDIOCONVERTER,
	APP_AUDIOWATERMARKER,
	APP_AUDIOWATERMARKERREADER,
	APP_VIDEOPLAYER,
	APP_BROWSER
};

class SMRSettings : public wxObject
{
 protected:
	wxString Files, Midi, Err, Font, ImgScore, Apps;	
 public:
    		  
	 SMRSettings();
    ~SMRSettings();

	void SaveSettings();
	//Save settings in the registry.
	
	bool LoadSettings();
	//Read settings from the registry.

	void Execute(wxString parameters, ApplicationId ID_prg, bool remove=false);
		
	wxString GetFilesPath() { return Files; };
	void SetFilesPath(const wxString& files) { Files=files; };
	wxString GetMidiPath() { return Midi; };
	void SetMidiPath(const wxString& midi) { Midi=midi; };
	wxString GetErrPath() { return Err; };
	void SetErrPath(const wxString& err) { Err=err; };
	wxString GetFontPath() { return Font; };
	void SetFontPath(const wxString& font) { Font=font; };
	wxString GetImgScorePath() { return ImgScore; };
	void SetImgScorePath(const wxString& img) { ImgScore=img; };
	wxString GetAppsPath() { return Apps; };
	void SetAppsPath(const wxString& apps) { Apps=apps; };

	wxString GetGZipPath();
	wxString GetBimPath();
};

class SMREnvSettingsDlg : public wxDialog
{
protected:
	wxTextCtrl *envpath[4];;
	SMRSettings *wsettings;

public:

	SMREnvSettingsDlg(SMRSettings* ws);
	~SMREnvSettingsDlg();

	void OnOk(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);
	void ShowDlg();
	
	void UpdateDlg();
	void SetSettings();
private:
	DECLARE_EVENT_TABLE()
};

// FUNZIONI PER il controllo dei nomi dei file e per l'esecuzione

wxString GetExtension(wxString filename);
wxString CleanCommand(wxString open);