/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: pentagra.hpp,v 1.1 2005/07/25 09:35:31 bellinpo Exp $ */


#ifndef PENTAGRAMMA_HPP
#define PENTAGRAMMA_HPP

#include "drw/drawobje.hpp"

class Pentagramma : public DrawObject
{
protected:
    VUnit width[MAX_VIEW];
	// larghezza del pentagramma.
    VUnit MaxWidth[MAX_VIEW];
	// larghezza massima del pentagramma.
    VUnit spaceUpDwn[MAX_VIEW];
	// spazio sopra e sotto il pentagramma.
	
	int NRighi;	
	bool isUsed;
	
public:
    Pentagramma();
    Pentagramma(VUnit w);
	
    int GetNRighi(){return NRighi;}
	void SetNRighi(int nrighi){NRighi=nrighi;}
	VUnit GetPentHeight();
	
	void SetWidth(VUnit w);
    void SetMaxWidth(VUnit w);
    VUnit GetMaxWidth();   
	
    void SetSpaceUpDwn(VUnit spc);
    VUnit GetSpaceUpDwn();
	
    VUnit GetVU2Rgt();
    VUnit GetVU2Up();
    VUnit GetVU2Lft();
    VUnit GetVU2Dwn();
	
	VUnit GetBaseVU2Up();
	VUnit GetBaseVU2Dwn();
    
    void Draw();
    void DrawTagli(const Point&p);
	
	void printWM(char codeWM_1[5],  char codeWM_2[5],  char codeWM_3[5],  char codeWM_4[7], int idx);
	void printWM(int angle1[6],  int angle2[6],  int angle3[9], int angle4[6], int i);
	
	void SetIsUsed(bool used) { isUsed=used; };
	bool GetIsUsed() { return isUsed; };
};

#endif //PENTAGRAMMA_HPP
