/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: arco.hpp,v 1.1 2005/07/25 09:35:33 bellinpo Exp $ */


#ifndef ARCO_HPP
#define ARCO_HPP

#include "lioo.hpp"                       
#include "str/violino.hpp"

#include "str/posizarc.hpp"
#include "str/partearc.hpp"
#include "str/direzarc.hpp"


class Arco: public Violino
{
private:
    CmdResult CmdArcoPonticello(TipoInserimento tpIns, Nota* pNota,
		Battuta* pBattuta);
    CmdResult CmdArcoTastiera(TipoInserimento tpIns, Nota* pNota,
		Battuta* pBattuta);   
    CmdResult CmdArcoPunta(TipoInserimento tpIns, Nota* pNota,
		Battuta* pBattuta);
    CmdResult CmdArcoTallone(TipoInserimento tpIns, Nota* pNota,
		Battuta* pBattuta);   
    CmdResult CmdArcoArcoSu(TipoInserimento tpIns, Nota* pNota,
		Battuta* pBattuta);   		     
    CmdResult CmdArcoArcoGiu(TipoInserimento tpIns, Nota* pNota,
		Battuta* pBattuta);   		     
    CmdResult CmdArco(TipoInserimento tpIns, Nota* pNota,
		Battuta* pBattuta); 
	
protected:
	Bool ScrivereArco;
	
	DirezArco *PDirezArco;   
	ParteArco *PParteArco;
	PosizArco *PPosizArco;
	
public:
	Arco();
	~Arco();
	void Init();
	
	
	void Draw();
	void Free();
	
	void SetPParteArco(ParteArco *pa);
	ParteArco *GetPParteArco();
	
	void SetPDirezArco(DirezArco *pd);
	DirezArco *GetPDirezArco();
	
	void SetPPosizArco(PosizArco *pp);
	PosizArco *GetPPosizArco();
	
	Bool GetScrivereArco();
	void SetScrivereArco(Bool b);
	
	Bool DeleteSym(DrawObject *sym);
	// Cancella il simbolo specificato se e' fra quelli connessi ad Arco.
	// Ritorna TRUE se il simbolo e' stato cancellato
	
	Bool Hit(const Point&, SelObj, DrawObject*&, SymPath&);
	Bool SymbolicHit(SymPath&, SelObj, DrawObject*&);
	
	CmdResult SymCommand(SymCmd& SCmd, TipoInserimento tpIns, Nota* pNota,
        Battuta* pBattuta);
	DrawObject * GetObject(SymCmd * SCmd);
	
	int SaveXML(FILE *fp);
};

#endif //ARCO_HPP
