/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: arcosu.cpp,v 1.1 2005/07/25 09:35:33 bellinpo Exp $ */


#include "str/arcosu.hpp"
#include "gui/dialogs.hpp"


ArcoSu::ArcoSu()
{ ID=CL_ARCOSU; }

VUnit ArcoSu::GetVU2Up()
{return ARCOSU2UP;};

VUnit ArcoSu::GetVU2Dwn()
{return ARCOSU2DWN;};

VUnit ArcoSu::GetVU2Lft()
{return ARCOSU2LFT;};

VUnit ArcoSu::GetVU2Rgt()
{return ARCOSU2RGT;};

void ArcoSu::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	char code[2]={0,0};
	code[0]=CODE_ARCOSU; 
	
	Scr->TextTo(GetAbsPos()+Point(DELTAXARCOSU,DELTAYARCOSU)+Point(GetDx(),GetDy()));
	Scr->OutText((unsigned char *)code);

	Scr->SetColor(oldcol);
};

void ArcoSu::Edit(Battuta *pBat)

{
	
    EditingMarkersDlg(this);
	
} 
