/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: corda.cpp,v 1.1 2005/07/25 09:35:33 bellinpo Exp $ */


#include "str/corda.hpp"
#include "liooext.hpp"
#include "gui/dialogs.hpp"



extern int DebugNormalMilla;
extern int DebugNormalMillaPos;
extern wxString msgdebug;
#include "gui/dialogs.hpp"

Corda::Corda()
{
	SetFont(nMusicFont2);
	ID=CL_CORDA;
	aboveNota = TRUE;
	extern Bool GetStringsRoman();
	IsRoman = GetStringsRoman();
	extern TipiStrings GetTipoStrings();
	TipoCorda = GetTipoStrings();
}



void Corda::SetAboveNotaAuto(ClassID ID, Nota* pNota, Battuta* pBattuta)
{
	
	if (DebugNormalMilla || DebugNormalMillaPos)
	{ 
		
		msgdebug.sprintf("");
		
	}
	
	
	
	aboveNota = immissione.ImmRule(ID, pNota, pBattuta, NULL, 0);
	
	
	if (DebugNormalMilla || DebugNormalMillaPos)
	{ 
		posizionam.TestTokenCond(pNota, NULL, pBattuta, (int) NULL, 0);
		
		WDebugMilla(); 
		
	}
	
	
} 

void Corda::SetAboveNota(Bool above)
{aboveNota=above;};

Bool Corda::GetAboveNota()
{ return aboveNota; };

void Corda::SetNumCorda(short ncorda)
{
	nc=ncorda;
	if (GetIsRoman())
	{
		switch (GetTipoCorda())
		{
		case NOTCIRCLED:
			{
				switch(nc)
				{
				case 0:
				default:
					SetTxt(CODE_STR0_R_N);
					break;				
				case 1:
					SetTxt((unsigned char*)"\x4f");
					break;
				case 2:
					SetTxt((unsigned char*)"\x50");
					break;
				case 3:
					SetTxt((unsigned char*)"\x51");
					break;
				case 4:
					SetTxt((unsigned char*)"\x52");
					break;
				case 5:
					SetTxt((unsigned char*)"\x53");
					break;
				case 6:
					SetTxt((unsigned char*)"\x54");
					break;
				case 7:
					SetTxt((unsigned char*)"\x55");
					break;
				};
				break;
			}
		case BRACKETS:
			{
				switch(nc)
				{
				case 0:
				default:
					SetTxt(CODE_STR0_R_P);
					break;				
				case 1:
					SetTxt((unsigned char*)"\x56");
					break;
				case 2:
					SetTxt((unsigned char*)"\x57");
					break;
				case 3:
					SetTxt((unsigned char*)"\x58");
					break;
				case 4:
					SetTxt((unsigned char*)"\x59");
					break;
				case 5:
					SetTxt((unsigned char*)"\x5a");
					break;
				case 6:
					SetTxt((unsigned char*)"\x5b");
					break;
				case 7:
					SetTxt((unsigned char*)"\x5c");
					break;
				};
				break;
			}
		case CIRCLED1:
			{
				switch(nc)
				{
				case 0:
				default:
					SetTxt(CODE_STR0_R_R1);
					break;				
				case 1:
					SetTxt((unsigned char*)"\x5d");
					break;
				case 2:
					SetTxt((unsigned char*)"\x5e");
					break;
				case 3:
					SetTxt((unsigned char*)"\x5f");
					break;
				case 4:
					SetTxt((unsigned char*)"\x60");
					break;
				case 5:
					SetTxt((unsigned char*)"\x61");
					break;
				case 6:
					SetTxt((unsigned char*)"\x62");
					break;
				case 7:
					SetTxt((unsigned char*)"\x63");
					break;
				};
				break;
			}
		case CIRCLED2:
			{
				switch(nc)
				{
				case 0:
				default:
					SetTxt(CODE_STR0_R_R2);
					break;				
				case 1:
					SetTxt((unsigned char*)"\x64");
					break;
				case 2:
					SetTxt((unsigned char*)"\x65");
					break;
				case 3:
					SetTxt((unsigned char*)"\x66");
					break;
				case 4:
					SetTxt((unsigned char*)"\x67");
					break;
				case 5:
					SetTxt((unsigned char*)"\x68");
					break;
				case 6:
					SetTxt((unsigned char*)"\x69");
					break;
				case 7:
					SetTxt((unsigned char*)"\x6a");
					break;
				};
				break;
			}
		}
	}
	else  // VERSIONE CON NUMERI NORNALI
	{
		switch (GetTipoCorda())
		{
		case NOTCIRCLED:
			{
				switch(nc)
				{
				case 0:
				default:
					SetTxt(CODE_STR0_N);
					break;				
				case 1:
					SetTxt((unsigned char*)"\x9f");
					break;
				case 2:
					SetTxt((unsigned char*)"\xa0");
					break;
				case 3:
					SetTxt((unsigned char*)"\xa1");
					break;
				case 4:
					SetTxt((unsigned char*)"\xa2");
					break;
				case 5:
					SetTxt((unsigned char*)"\xa3");
					break;
				case 6:
					SetTxt((unsigned char*)"\xa4");
					break;
				case 7:
					SetTxt((unsigned char*)"\xa5");
					break;
				};
				break;
			}
		case BRACKETS:
			{
				switch(nc)
				{
				case 0:
				default:
					SetTxt(CODE_STR0_P);
					break;				
				case 1:
					SetTxt((unsigned char*)"\xa6");
					break;
				case 2:
					SetTxt((unsigned char*)"\xa7");
					break;
				case 3:
					SetTxt((unsigned char*)"\xa8");
					break;
				case 4:
					SetTxt((unsigned char*)"\xa9");
					break;
				case 5:
					SetTxt((unsigned char*)"\xaa");
					break;
				case 6:
					SetTxt((unsigned char*)"\xab");
					break;
				case 7:
					SetTxt((unsigned char*)"\xac");
					break;
				};
				break;
			}
		case CIRCLED1:
			{
				switch(nc)
				{
				case 0:
				default:
					SetTxt(CODE_STR0_R1);
					break;				
				case 1:
					SetTxt((unsigned char*)"\xad");
					break;
				case 2:
					SetTxt((unsigned char*)"\xae");
					break;
				case 3:
					SetTxt((unsigned char*)"\xaf");
					break;
				case 4:
					SetTxt((unsigned char*)"\xb0");
					break;
				case 5:
					SetTxt((unsigned char*)"\xb1");
					break;
				case 6:
					SetTxt((unsigned char*)"\xb2");
					break;
				case 7:
					SetTxt((unsigned char*)"\xb3");
					break;
				};
				break;
			}
		case CIRCLED2:
			{
				switch(nc)
				{
				case 0:
				default:
					SetTxt(CODE_STR0_R2);
					break;
				case 1:
					SetTxt((unsigned char*)"\xb4");
					break;
				case 2:
					SetTxt((unsigned char*)"\xb5");
					break;
				case 3:
					SetTxt((unsigned char*)"\xb6");
					break;
				case 4:
					SetTxt((unsigned char*)"\xb7");
					break;
				case 5:
					SetTxt((unsigned char*)"\xb8");
					break;
				case 6:
					SetTxt((unsigned char*)"\xb9");
					break;
				case 7:
					SetTxt((unsigned char*)"\xba");
					break;
				};
				break;
			}
		}
		
	};
}


short Corda::GetNumCorda()
{
	return nc;
}


void Corda::Edit(Battuta *pBat)

{
	
    EditingMarkersDlg(this);
	
}

Bool Corda::GetIsRoman()
{
	return IsRoman;
}

void Corda::SetIsRoman(Bool b)
{
	IsRoman = b;
}

TipiStrings Corda::GetTipoCorda()
{
	return TipoCorda;
}

void Corda::SetTipoCorda(TipiStrings ts)
{
	TipoCorda = ts;
}	

void Corda::Draw()   
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	int deltax, deltay;
	
	deltax=Scr->Get_VU2DX(txt[0], font);
	deltay=Scr->Get_VU2DY(txt[0], font);
	
	int ofont;
	ofont=Scr->SetFont(font);
	Scr->TextTo(GetAbsPos()+Point(deltax,deltay)+Point(GetDx(),GetDy()));
	if(txt!=NULL) 
	{ 
		Scr->OutText((unsigned char *)txt);
	}	
	Scr->SetFont(ofont);
	

	Scr->SetColor(oldcol);
};

VUnit Corda::GetVU2Up()
{
	
	return Scr->Get_VU2UP(txt[0],font);
};

VUnit Corda::GetVU2Dwn()
{
	
	return Scr->Get_VU2DWN(txt[0],font);
};

VUnit Corda::GetVU2Lft()
{
	
	
	return Scr->Get_VU2LF(txt[0],font);
};

VUnit Corda::GetVU2Rgt()
{
	
	return Scr->Get_VU2RG(txt[0],font);
};

char Corda::GetCode()
{
	unsigned  char code[2];
	code[0]='\0';
	
	if (GetIsRoman())
	{
		switch (GetTipoCorda())
		{
		case NOTCIRCLED:
			{
				switch(nc)
				{
				case 0:
				default:
					code[0]=CODE_STR0_R_N;
					break;				
				case 1:
					code[0]=CODE_STR1_R_N;
					break;
				case 2:
					code[0]=CODE_STR2_R_N;
					break;
				case 3:
					code[0]=CODE_STR3_R_N;
					break;
				case 4:
					code[0]=CODE_STR4_R_N;
					break;
				case 5:
					code[0]=CODE_STR5_R_N;
					break;
				case 6:
					code[0]=CODE_STR6_R_N;
					break;
				case 7:
					code[0]=CODE_STR7_R_N;
					break;
				};
				break;
			}
		case BRACKETS:
			{
				switch(nc)
				{
				case 0:
				default:
					code[0]=CODE_STR0_R_P;
					break;				
				case 1:
					code[0]=CODE_STR1_R_P;
					break;
				case 2:
					code[0]=CODE_STR2_R_P;
					break;
				case 3:
					code[0]=CODE_STR3_R_P;
					break;
				case 4:
					code[0]=CODE_STR4_R_P;
					break;
				case 5:
					code[0]=CODE_STR5_R_P;
					break;
				case 6:
					code[0]=CODE_STR6_R_P;
					break;
				case 7:
					code[0]=CODE_STR7_R_P;
					break;
				};
				break;
			}
		case CIRCLED1:
			{
				switch(nc)
				{
				case 0:
				default:
					code[0]=CODE_STR0_R_R1;
					break;				
				case 1:
					code[0]=CODE_STR1_R_R1;
					break;
				case 2:
					code[0]=CODE_STR2_R_R1;
					break;
				case 3:
					code[0]=CODE_STR3_R_R1;
					break;
				case 4:
					code[0]=CODE_STR4_R_R1;
					break;
				case 5:
					code[0]=CODE_STR5_R_R1;
					break;
				case 6:
					code[0]=CODE_STR6_R_R1;
					break;
				case 7:
					code[0]=CODE_STR7_R_R1;
					break;
				};
				break;
			}
		case CIRCLED2:
			{
				switch(nc)
				{
				case 0:
				default:
					code[0]=CODE_STR0_R_R2;
					break;				
				case 1:
					code[0]=CODE_STR1_R_R2;
					break;
				case 2:
					code[0]=CODE_STR2_R_R2;
					break;
				case 3:
					code[0]=CODE_STR3_R_R2;
					break;
				case 4:
					code[0]=CODE_STR4_R_R2;
					break;
				case 5:
					code[0]=CODE_STR5_R_R2;
					break;
				case 6:
					code[0]=CODE_STR6_R_R2;
					break;
				case 7:
					code[0]=CODE_STR7_R_R2;
					break;
				};
				break;
			}
		}
	}
	else  // VERSIONE CON NUMERI NORNALI
	{
		switch (GetTipoCorda())
		{
		case NOTCIRCLED:
			{
				switch(nc)
				{
				case 0:
				default:
					code[0]=CODE_STR0_N;
					break;				
				case 1:
					code[0]=CODE_STR1_N;
					break;
				case 2:
					code[0]=CODE_STR2_N;
					break;
				case 3:
					code[0]=CODE_STR3_N;
					break;
				case 4:
					code[0]=CODE_STR4_N;
					break;
				case 5:
					code[0]=CODE_STR5_N;
					break;
				case 6:
					code[0]=CODE_STR6_N;
					break;
				case 7:
					code[0]=CODE_STR7_N;
					break;
				};
				break;
			}
		case BRACKETS:
			{
				switch(nc)
				{
				case 0:
				default:
					code[0]=CODE_STR0_P;
					break;				
				case 1:
					code[0]=CODE_STR1_P;
					break;
				case 2:
					code[0]=CODE_STR2_P;
					break;
				case 3:
					code[0]=CODE_STR3_P;
					break;
				case 4:
					code[0]=CODE_STR4_P;
					break;
				case 5:
					code[0]=CODE_STR5_P;
					break;
				case 6:
					code[0]=CODE_STR6_P;
					break;
				case 7:
					code[0]=CODE_STR7_P;
					break;
				};
				break;
			}
		case CIRCLED1:
			{
				switch(nc)
				{
				case 0:
				default:
					code[0]=CODE_STR0_R1;
					break;				
				case 1:
					code[0]=CODE_STR1_R1;
					break;
				case 2:
					code[0]=CODE_STR2_R1;
					break;
				case 3:
					code[0]=CODE_STR3_R1;
					break;
				case 4:
					code[0]=CODE_STR4_R1;
					break;
				case 5:
					code[0]=CODE_STR5_R1;
					break;
				case 6:
					code[0]=CODE_STR6_R1;
					break;
				case 7:
					code[0]=CODE_STR7_R1;
					break;
				};
				break;
			}
		case CIRCLED2:
			{
				switch(nc)
				{
				case 0:
				default:
					code[0]=CODE_STR0_R2;
					break;
				case 1:
					code[0]=CODE_STR1_R2;
					break;
				case 2:
					code[0]=CODE_STR2_R2;
					break;
				case 3:
					code[0]=CODE_STR3_R2;
					break;
				case 4:
					code[0]=CODE_STR4_R2;
					break;
				case 5:
					code[0]=CODE_STR5_R2;
					break;
				case 6:
					code[0]=CODE_STR6_R2;
					break;
				case 7:
					code[0]=CODE_STR7_R2;
					break;
				};
				break;
			}
		}
		
	};
	
	return (char )code[0];
}