/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: def_str.hpp,v 1.1 2005/07/25 09:35:34 bellinpo Exp $ */

  
#ifndef DEF_STR_HPP
#define DEF_STR_HPP

#define LUNGFRECCIA 30
#define MARGINE 4

#define CODE_ARCO "Arco"
#define DELTAXARCO Scr->Get_VU2DX(2)        
#define DELTAYARCO Scr->Get_VU2DY(2)        
#define ARCO2UP Scr->Get_VU2UP(2)           
#define ARCO2DWN Scr->Get_VU2DWN(2)         
#define ARCO2RGT Scr->Get_VU2RG(2)          
#define ARCO2LFT Scr->Get_VU2LF(2)          


#define CODE_ARCOGIU 88 						
#define DELTAXARCOGIU Scr->Get_VU2DX(88)        
#define DELTAYARCOGIU Scr->Get_VU2DY(88)        
#define ARCOGIU2UP Scr->Get_VU2UP(88)           
#define ARCOGIU2DWN Scr->Get_VU2DWN(88)         
#define ARCOGIU2RGT Scr->Get_VU2RG(88)          
#define ARCOGIU2LFT Scr->Get_VU2LF(88)          

#define CODE_ARCOSU 104   						
#define DELTAXARCOSU Scr->Get_VU2DX(104)        
#define DELTAYARCOSU Scr->Get_VU2DY(104)        
#define ARCOSU2UP Scr->Get_VU2UP(104)           
#define ARCOSU2DWN Scr->Get_VU2DWN(104)          
#define ARCOSU2RGT Scr->Get_VU2RG(104)          
#define ARCOSU2LFT Scr->Get_VU2LF(104)          



#define CODE_PUNTA 121
#define DELTAXPUNTA Scr->Get_VU2DX(121)        
#define DELTAYPUNTA Scr->Get_VU2DY(121)        
#define PUNTA2UP Scr->Get_VU2UP(121)           
#define PUNTA2DWN Scr->Get_VU2DWN(121)         
#define PUNTA2RGT Scr->Get_VU2RG(121)          
#define PUNTA2LFT Scr->Get_VU2LF(121)          


#define CODE_TALLONE 120
#define DELTAXTALLONE Scr->Get_VU2DX(120)        
#define DELTAYTALLONE Scr->Get_VU2DY(120)        
#define TALLONE2UP Scr->Get_VU2UP(120)           
#define TALLONE2DWN Scr->Get_VU2DWN(120)         
#define TALLONE2RGT Scr->Get_VU2RG(120)            
#define TALLONE2LFT Scr->Get_VU2LF(120)          

#define CODE_FITTIZIO_TASTIERA 29          
#define DELTAXTASTIERA Scr->Get_VU2DX(CODE_FITTIZIO_TASTIERA)            
#define DELTAYTASTIERA Scr->Get_VU2DY(CODE_FITTIZIO_TASTIERA)           
#define TASTIERA2UP Scr->Get_VU2UP(CODE_FITTIZIO_TASTIERA)           
#define TASTIERA2DWN Scr->Get_VU2DWN(CODE_FITTIZIO_TASTIERA)         
#define TASTIERA2RGT Scr->Get_VU2RG(CODE_FITTIZIO_TASTIERA)            
#define TASTIERA2LFT Scr->Get_VU2LF(CODE_FITTIZIO_TASTIERA)          

#define CODE_FITTIZIO_PONTICELLO 28         
#define DELTAXPONTICELLO Scr->Get_VU2DX(CODE_FITTIZIO_PONTICELLO)           
#define DELTAYPONTICELLO Scr->Get_VU2DY(CODE_FITTIZIO_PONTICELLO)           

#define CODE_PIZZICATO "Pizz."
#define CODE_FITTIZIO_PIZZ 31          
#define DELTAXPIZZICATO Scr->Get_VU2DX(CODE_FITTIZIO_PIZZ)           
#define DELTAYPIZZICATO Scr->Get_VU2DY(CODE_FITTIZIO_PIZZ)            
#define PIZZICATO2UP Scr->Get_VU2UP(CODE_FITTIZIO_PIZZ)            
#define PIZZICATO2DWN Scr->Get_VU2DWN(CODE_FITTIZIO_PIZZ)           
#define PIZZICATO2RGT Scr->Get_VU2RG(CODE_FITTIZIO_PIZZ)           
#define PIZZICATO2LFT Scr->Get_VU2LF(CODE_FITTIZIO_PIZZ)           

#define CODE_PEDALDOWN 234                         
#define DELTAXPEDALDOWN Scr->Get_VU2DX(234)        
#define DELTAYPEDALDOWN Scr->Get_VU2DY(234)        
#define PEDALDOWN2UP Scr->Get_VU2UP(234)           
#define PEDALDOWN2DWN Scr->Get_VU2DWN(234)         
#define PEDALDOWN2RGT Scr->Get_VU2RG(234)          
#define PEDALDOWN2LFT Scr->Get_VU2LF(234)          


#define CODE_PEDALUP 42 						   
#define DELTAXPEDALUP Scr->Get_VU2DX(42)        
#define DELTAYPEDALUP Scr->Get_VU2DY(42)        
#define PEDALUP2UP Scr->Get_VU2UP(42)           
#define PEDALUP2DWN Scr->Get_VU2DWN(42)         
#define PEDALUP2RGT Scr->Get_VU2RG(42)          
#define PEDALUP2LFT Scr->Get_VU2LF(42)          


// NUMERI NORMALI

// per il momento  il 48 in effetti deve essere fdatto un font particolare
#define CODE_STR0_N 48
#define DELTAXSTRING0_N Scr->Get_VU2DX(CODE_STR0_N, MUSICFONT2_ID) 
#define DELTAYSTRING0_N Scr->Get_VU2DY(CODE_STR0_N, MUSICFONT2_ID)

#define CODE_STR1_N 159
#define DELTAXSTRING1_N Scr->Get_VU2DX(CODE_STR1_N, MUSICFONT2_ID) 
#define DELTAYSTRING1_N Scr->Get_VU2DY(CODE_STR1_N, MUSICFONT2_ID)

#define CODE_STR2_N 160
#define DELTAXSTRING2_N Scr->Get_VU2DX(CODE_STR2_N, MUSICFONT2_ID) 
#define DELTAYSTRING2_N Scr->Get_VU2DY(CODE_STR2_N, MUSICFONT2_ID)

#define CODE_STR3_N 161
#define DELTAXSTRING3_N Scr->Get_VU2DX(CODE_STR3_N, MUSICFONT2_ID) 
#define DELTAYSTRING3_N Scr->Get_VU2DY(CODE_STR3_N, MUSICFONT2_ID)

#define CODE_STR4_N 162
#define DELTAXSTRING4_N Scr->Get_VU2DX(CODE_STR4_N, MUSICFONT2_ID) 
#define DELTAYSTRING4_N Scr->Get_VU2DY(CODE_STR4_N, MUSICFONT2_ID)

#define CODE_STR5_N 163
#define DELTAXSTRING5_N Scr->Get_VU2DX(CODE_STR5_N, MUSICFONT2_ID) 
#define DELTAYSTRING5_N Scr->Get_VU2DY(CODE_STR5_N, MUSICFONT2_ID)

#define CODE_STR6_N 164
#define DELTAXSTRING6_N Scr->Get_VU2DX(CODE_STR6_N, MUSICFONT2_ID) 
#define DELTAYSTRING6_N Scr->Get_VU2DY(CODE_STR6_N, MUSICFONT2_ID)

#define CODE_STR7_N 165
#define DELTAXSTRING7_N Scr->Get_VU2DX(CODE_STR7_N, MUSICFONT2_ID) 
#define DELTAYSTRING7_N Scr->Get_VU2DY(CODE_STR7_N, MUSICFONT2_ID)


// per il momento  il 48 in effetti deve essere fdatto un font particolare
#define CODE_STR0_P 48
#define DELTAXSTRING0_P Scr->Get_VU2DX(CODE_STR0_P, MUSICFONT2_ID) 
#define DELTAYSTRING0_P Scr->Get_VU2DY(CODE_STR0_P, MUSICFONT2_ID)

#define CODE_STR1_P  166
#define DELTAXSTRING1_P Scr->Get_VU2DX(CODE_STR1_P, MUSICFONT2_ID) 
#define DELTAYSTRING1_P Scr->Get_VU2DY(CODE_STR1_P, MUSICFONT2_ID)

#define CODE_STR2_P 167
#define DELTAXSTRING2_P Scr->Get_VU2DX(CODE_STR2_P, MUSICFONT2_ID) 
#define DELTAYSTRING2_P Scr->Get_VU2DY(CODE_STR2_P, MUSICFONT2_ID)

#define CODE_STR3_P 168
#define DELTAXSTRING3_P Scr->Get_VU2DX(CODE_STR3_P, MUSICFONT2_ID) 
#define DELTAYSTRING3_P Scr->Get_VU2DY(CODE_STR3_P, MUSICFONT2_ID)

#define CODE_STR4_P 169
#define DELTAXSTRING4_P Scr->Get_VU2DX(CODE_STR4_P, MUSICFONT2_ID) 
#define DELTAYSTRING4_P Scr->Get_VU2DY(CODE_STR4_P, MUSICFONT2_ID)

#define CODE_STR5_P 170
#define DELTAXSTRING5_P Scr->Get_VU2DX(CODE_STR5_P, MUSICFONT2_ID) 
#define DELTAYSTRING5_P Scr->Get_VU2DY(CODE_STR5_P, MUSICFONT2_ID)

#define CODE_STR6_P 171
#define DELTAXSTRING6_P Scr->Get_VU2DX(CODE_STR6_P, MUSICFONT2_ID) 
#define DELTAYSTRING6_P Scr->Get_VU2DY(CODE_STR6_P, MUSICFONT2_ID)

#define CODE_STR7_P 172
#define DELTAXSTRING7_P Scr->Get_VU2DX(CODE_STR7_P, MUSICFONT2_ID) 
#define DELTAYSTRING7_P Scr->Get_VU2DY(CODE_STR7_P, MUSICFONT2_ID)


// per il momento  il 48 in effetti deve essere fdatto un font particolare
#define CODE_STR0_R1 48
#define DELTAXSTRING0_R1 Scr->Get_VU2DX(CODE_STR0_R1, MUSICFONT2_ID) 
#define DELTAYSTRING0_R1 Scr->Get_VU2DY(CODE_STR0_R1, MUSICFONT2_ID)

#define CODE_STR1_R1 173
#define DELTAXSTRING1_R1 Scr->Get_VU2DX(CODE_STR1_R1, MUSICFONT2_ID) 
#define DELTAYSTRING1_R1 Scr->Get_VU2DY(CODE_STR1_R1, MUSICFONT2_ID)

#define CODE_STR2_R1 174
#define DELTAXSTRING2_R1 Scr->Get_VU2DX(CODE_STR2_R1, MUSICFONT2_ID) 
#define DELTAYSTRING2_R1 Scr->Get_VU2DY(CODE_STR2_R1, MUSICFONT2_ID)

#define CODE_STR3_R1 175
#define DELTAXSTRING3_R1 Scr->Get_VU2DX(CODE_STR3_R1, MUSICFONT2_ID) 
#define DELTAYSTRING3_R1 Scr->Get_VU2DY(CODE_STR3_R1, MUSICFONT2_ID)

#define CODE_STR4_R1 176
#define DELTAXSTRING4_R1 Scr->Get_VU2DX(CODE_STR4_R1, MUSICFONT2_ID) 
#define DELTAYSTRING4_R1 Scr->Get_VU2DY(CODE_STR4_R1, MUSICFONT2_ID)

#define CODE_STR5_R1 177
#define DELTAXSTRING5_R1 Scr->Get_VU2DX(CODE_STR5_R1, MUSICFONT2_ID) 
#define DELTAYSTRING5_R1 Scr->Get_VU2DY(CODE_STR5_R1, MUSICFONT2_ID)

#define CODE_STR6_R1 178
#define DELTAXSTRING6_R1 Scr->Get_VU2DX(CODE_STR6_R1, MUSICFONT2_ID) 
#define DELTAYSTRING6_R1 Scr->Get_VU2DY(CODE_STR6_R1, MUSICFONT2_ID)

#define CODE_STR7_R1 179
#define DELTAXSTRING7_R1 Scr->Get_VU2DX(CODE_STR7_R1, MUSICFONT2_ID) 
#define DELTAYSTRING7_R1 Scr->Get_VU2DY(CODE_STR7_R1, MUSICFONT2_ID)


// per il momento  il 48 in effetti deve essere fdatto un font particolare
#define CODE_STR0_R2 48
#define DELTAXSTRING0_R2 Scr->Get_VU2DX(CODE_STR0_R2, MUSICFONT2_ID) 
#define DELTAYSTRING0_R2 Scr->Get_VU2DY(CODE_STR0_R2, MUSICFONT2_ID)

#define CODE_STR1_R2 180
#define DELTAXSTRING1_R2 Scr->Get_VU2DX(CODE_STR1_R2, MUSICFONT2_ID) 
#define DELTAYSTRING1_R2 Scr->Get_VU2DY(CODE_STR1_R2, MUSICFONT2_ID)

#define CODE_STR2_R2 181
#define DELTAXSTRING2_R2 Scr->Get_VU2DX(CODE_STR2_R2, MUSICFONT2_ID) 
#define DELTAYSTRING2_R2 Scr->Get_VU2DY(CODE_STR2_R2, MUSICFONT2_ID)

#define CODE_STR3_R2 182
#define DELTAXSTRING3_R2 Scr->Get_VU2DX(CODE_STR3_R2, MUSICFONT2_ID) 
#define DELTAYSTRING3_R2 Scr->Get_VU2DY(CODE_STR3_R2, MUSICFONT2_ID)

#define CODE_STR4_R2 183
#define DELTAXSTRING4_R2 Scr->Get_VU2DX(CODE_STR4_R2, MUSICFONT2_ID) 
#define DELTAYSTRING4_R2 Scr->Get_VU2DY(CODE_STR4_R2, MUSICFONT2_ID)

#define CODE_STR5_R2 184
#define DELTAXSTRING5_R2 Scr->Get_VU2DX(CODE_STR5_R2, MUSICFONT2_ID) 
#define DELTAYSTRING5_R2 Scr->Get_VU2DY(CODE_STR5_R2, MUSICFONT2_ID)

#define CODE_STR6_R2 185
#define DELTAXSTRING6_R2 Scr->Get_VU2DX(CODE_STR6_R2, MUSICFONT2_ID) 
#define DELTAYSTRING6_R2 Scr->Get_VU2DY(CODE_STR6_R2, MUSICFONT2_ID)

#define CODE_STR7_R2 186
#define DELTAXSTRING7_R2 Scr->Get_VU2DX(CODE_STR7_R2, MUSICFONT2_ID) 
#define DELTAYSTRING7_R2 Scr->Get_VU2DY(CODE_STR7_R2, MUSICFONT2_ID)


// NUMERI ROMANI

// per il momento  il 48 in effetti deve essere fdatto un font particolare
#define CODE_STR0_R_N 48
#define DELTAXSTRING0_R_N Scr->Get_VU2DX(CODE_STR0_R_N, MUSICFONT2_ID) 
#define DELTAYSTRING0_R_N Scr->Get_VU2DY(CODE_STR0_R_N, MUSICFONT2_ID)

#define CODE_STR1_R_N  79
#define DELTAXSTRING1_R_N  Scr->Get_VU2DX(CODE_STR1_R_N , MUSICFONT2_ID) 
#define DELTAYSTRING1_R_N  Scr->Get_VU2DY(CODE_STR1_R_N , MUSICFONT2_ID)

#define CODE_STR2_R_N 80
#define DELTAXSTRING2_R_N  Scr->Get_VU2DX(CODE_STR2_R_N , MUSICFONT2_ID) 
#define DELTAYSTRING2_R_N  Scr->Get_VU2DY(CODE_STR2_R_N , MUSICFONT2_ID)

#define CODE_STR3_R_N 81
#define DELTAXSTRING3_R_N  Scr->Get_VU2DX(CODE_STR3_R_N , MUSICFONT2_ID) 
#define DELTAYSTRING3_R_N  Scr->Get_VU2DY(CODE_STR3_R_N , MUSICFONT2_ID)

#define CODE_STR4_R_N 82
#define DELTAXSTRING4_R_N  Scr->Get_VU2DX(CODE_STR4_R_N , MUSICFONT2_ID) 
#define DELTAYSTRING4_R_N  Scr->Get_VU2DY(CODE_STR4_R_N , MUSICFONT2_ID)

#define CODE_STR5_R_N 83
#define DELTAXSTRING5_R_N  Scr->Get_VU2DX(CODE_STR5_R_N , MUSICFONT2_ID) 
#define DELTAYSTRING5_R_N  Scr->Get_VU2DY(CODE_STR5_R_N , MUSICFONT2_ID)

#define CODE_STR6_R_N 84
#define DELTAXSTRING6_R_N  Scr->Get_VU2DX(CODE_STR6_R_N , MUSICFONT2_ID) 
#define DELTAYSTRING6_R_N  Scr->Get_VU2DY(CODE_STR6_R_N , MUSICFONT2_ID)

#define CODE_STR7_R_N 85
#define DELTAXSTRING7_R_N  Scr->Get_VU2DX(CODE_STR7_R_N , MUSICFONT2_ID) 
#define DELTAYSTRING7_R_N  Scr->Get_VU2DY(CODE_STR7_R_N , MUSICFONT2_ID)


// per il momento  il 48 in effetti deve essere fdatto un font particolare
#define CODE_STR0_R_P 48
#define DELTAXSTRING0_R_P Scr->Get_VU2DX(CODE_STR0_R_P, MUSICFONT2_ID) 
#define DELTAYSTRING0_R_P Scr->Get_VU2DY(CODE_STR0_R_P, MUSICFONT2_ID)

#define CODE_STR1_R_P 86
#define DELTAXSTRING1_R_P Scr->Get_VU2DX(CODE_STR1_R_P, MUSICFONT2_ID) 
#define DELTAYSTRING1_R_P Scr->Get_VU2DY(CODE_STR1_R_P, MUSICFONT2_ID)

#define CODE_STR2_R_P 87
#define DELTAXSTRING2_R_P Scr->Get_VU2DX(CODE_STR2_R_P, MUSICFONT2_ID) 
#define DELTAYSTRING2_R_P Scr->Get_VU2DY(CODE_STR2_R_P, MUSICFONT2_ID)

#define CODE_STR3_R_P 88
#define DELTAXSTRING3_R_P Scr->Get_VU2DX(CODE_STR3_R_P, MUSICFONT2_ID) 
#define DELTAYSTRING3_R_P Scr->Get_VU2DY(CODE_STR3_R_P, MUSICFONT2_ID)

#define CODE_STR4_R_P 89
#define DELTAXSTRING4_R_P Scr->Get_VU2DX(CODE_STR4_R_P, MUSICFONT2_ID) 
#define DELTAYSTRING4_R_P Scr->Get_VU2DY(CODE_STR4_R_P, MUSICFONT2_ID)

#define CODE_STR5_R_P 90
#define DELTAXSTRING5_R_P Scr->Get_VU2DX(CODE_STR5_R_P, MUSICFONT2_ID) 
#define DELTAYSTRING5_R_P Scr->Get_VU2DY(CODE_STR5_R_P, MUSICFONT2_ID)

#define CODE_STR6_R_P 91
#define DELTAXSTRING6_R_P Scr->Get_VU2DX(CODE_STR6_R_P, MUSICFONT2_ID) 
#define DELTAYSTRING6_R_P Scr->Get_VU2DY(CODE_STR6_R_P, MUSICFONT2_ID)

#define CODE_STR7_R_P 92
#define DELTAXSTRING7_R_P Scr->Get_VU2DX(CODE_STR7_R_P, MUSICFONT2_ID) 
#define DELTAYSTRING7_R_P Scr->Get_VU2DY(CODE_STR7_R_P, MUSICFONT2_ID)


// per il momento  il 48 in effetti deve essere fdatto un font particolare
#define CODE_STR0_R_R1 48
#define DELTAXSTRING0_R_R1 Scr->Get_VU2DX(CODE_STR0_R_R1, MUSICFONT2_ID) 
#define DELTAYSTRING0_R_R1 Scr->Get_VU2DY(CODE_STR0_R_R1, MUSICFONT2_ID)

#define CODE_STR1_R_R1 93
#define DELTAXSTRING1_R_R1 Scr->Get_VU2DX(CODE_STR1_R_R1, MUSICFONT2_ID) 
#define DELTAYSTRING1_R_R1 Scr->Get_VU2DY(CODE_STR1_R_R1, MUSICFONT2_ID)

#define CODE_STR2_R_R1 94
#define DELTAXSTRING2_R_R1 Scr->Get_VU2DX(CODE_STR2_R_R1, MUSICFONT2_ID) 
#define DELTAYSTRING2_R_R1 Scr->Get_VU2DY(CODE_STR2_R_R1, MUSICFONT2_ID)

#define CODE_STR3_R_R1 95 
#define DELTAXSTRING3_R_R1 Scr->Get_VU2DX(CODE_STR3_R_R1, MUSICFONT2_ID) 
#define DELTAYSTRING3_R_R1 Scr->Get_VU2DY(CODE_STR3_R_R1, MUSICFONT2_ID)

#define CODE_STR4_R_R1 96 
#define DELTAXSTRING4_R_R1 Scr->Get_VU2DX(CODE_STR4_R_R1, MUSICFONT2_ID) 
#define DELTAYSTRING4_R_R1 Scr->Get_VU2DY(CODE_STR4_R_R1, MUSICFONT2_ID)

#define CODE_STR5_R_R1 97
#define DELTAXSTRING5_R_R1 Scr->Get_VU2DX(CODE_STR5_R_R1, MUSICFONT2_ID) 
#define DELTAYSTRING5_R_R1 Scr->Get_VU2DY(CODE_STR5_R_R1, MUSICFONT2_ID)

#define CODE_STR6_R_R1 98
#define DELTAXSTRING6_R_R1 Scr->Get_VU2DX(CODE_STR6_R_R1, MUSICFONT2_ID) 
#define DELTAYSTRING6_R_R1 Scr->Get_VU2DY(CODE_STR6_R_R1, MUSICFONT2_ID)

#define CODE_STR7_R_R1 99 
#define DELTAXSTRING7_R_R1 Scr->Get_VU2DX(CODE_STR7_R_R1, MUSICFONT2_ID) 
#define DELTAYSTRING7_R_R1 Scr->Get_VU2DY(CODE_STR7_R_R1, MUSICFONT2_ID)


// per il momento  il 48 in effetti deve essere fdatto un font particolare
#define CODE_STR0_R_R2 48
#define DELTAXSTRING0_R_R2 Scr->Get_VU2DX(CODE_STR0_R_R2, MUSICFONT2_ID) 
#define DELTAYSTRING0_R_R2 Scr->Get_VU2DY(CODE_STR0_R_R2, MUSICFONT2_ID)

#define CODE_STR1_R_R2  100
#define DELTAXSTRING1_R_R2 Scr->Get_VU2DX(CODE_STR1_R_R2, MUSICFONT2_ID) 
#define DELTAYSTRING1_R_R2 Scr->Get_VU2DY(CODE_STR1_R_R2, MUSICFONT2_ID)

#define CODE_STR2_R_R2 101
#define DELTAXSTRING2_R_R2 Scr->Get_VU2DX(CODE_STR2_R_R2, MUSICFONT2_ID) 
#define DELTAYSTRING2_R_R2 Scr->Get_VU2DY(CODE_STR2_R_R2, MUSICFONT2_ID)

#define CODE_STR3_R_R2 102
#define DELTAXSTRING3_R_R2 Scr->Get_VU2DX(CODE_STR3_R_R2, MUSICFONT2_ID) 
#define DELTAYSTRING3_R_R2 Scr->Get_VU2DY(CODE_STR3_R_R2, MUSICFONT2_ID)

#define CODE_STR4_R_R2 103
#define DELTAXSTRING4_R_R2 Scr->Get_VU2DX(CODE_STR4_R_R2, MUSICFONT2_ID) 
#define DELTAYSTRING4_R_R2 Scr->Get_VU2DY(CODE_STR4_R_R2, MUSICFONT2_ID)

#define CODE_STR5_R_R2 104
#define DELTAXSTRING5_R_R2 Scr->Get_VU2DX(CODE_STR5_R_R2, MUSICFONT2_ID) 
#define DELTAYSTRING5_R_R2 Scr->Get_VU2DY(CODE_STR5_R_R2, MUSICFONT2_ID)

#define CODE_STR6_R_R2 105
#define DELTAXSTRING6_R_R2 Scr->Get_VU2DX(CODE_STR6_R_R2, MUSICFONT2_ID) 
#define DELTAYSTRING6_R_R2 Scr->Get_VU2DY(CODE_STR6_R_R2, MUSICFONT2_ID)

#define CODE_STR7_R_R2 106
#define DELTAXSTRING7_R_R2 Scr->Get_VU2DX(CODE_STR7_R_R2, MUSICFONT2_ID) 
#define DELTAYSTRING7_R_R2 Scr->Get_VU2DY(CODE_STR7_R_R2, MUSICFONT2_ID)



#endif //DEF_STR_HPP
