/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: ditacord.hpp,v 1.1 2005/07/25 09:35:35 bellinpo Exp $ */


#ifndef DITACORDE_HPP
#define DITACORDE_HPP 

#define NTASTI 5 
#define CORDACENTRO (nstrings/2-(head?0:1))
#define TASTOCENTRO 3

#define DELTASIMB 6
#define DELTANUM 9
#define DELTANOME 10

#define DELTATASTO 8
#define DELTACORDA 7
#define DELTADITOX 5
#define DELTADITOY 7
#define HEIGHTCAPO 3

#define DELTACAPO ((!head)?HEIGHTCAPO:0)
#define DELTARGTASTO Scr->GetTextWidth((unsigned char*)"00 fr")

#define UPSIMB 3
#define UPNOME 20
#define DWNUM 1
#define RGTASTO 5

#define DWSPACE 10

#include "drw/slur.hpp"
#include "str/strument.hpp"
#include "drw/def_drw.hpp"


class DitaCorde : public Strumento
{
protected:
    int nstrings;
    char *name;
    char *frets;
    char *fingers;
    char barre[3];
    int head;
    int linestyle;
public:
    DitaCorde();
    DitaCorde(const char *INname,int INnstrings,const char *INfrets,const char *INbarre,int INhead,const char* INfingers);
    DitaCorde(const char *descr);
    DitaCorde(const DitaCorde &INChord);
    ~DitaCorde();
	
    char *GetName();
    char *GetNote();
    int GetNStrings();
	
    void Draw();
    void Dial_Preview();
	void GetFullDescription(char *OUTdesc, int len);
	
	int SaveXML(FILE *fp);
};

#endif //DITACORDE_HPP
