/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */


#include "str/pedalup.hpp"
#include "str/pedal.hpp"
#include "gui/dialogs.hpp"


PedalUp::PedalUp()
{
   ID = CL_PEDALUP;
//   aboveNota=FALSE;
}

VUnit PedalUp::GetVU2Up()
{ return PEDALUP2UP;}

VUnit PedalUp::GetVU2Dwn()
{ return PEDALUP2DWN;}; 

VUnit PedalUp::GetVU2Rgt()
{ return PEDALUP2RGT;}; 

VUnit PedalUp::GetVU2Lft()
{ return PEDALUP2LFT;}; 


void PedalUp::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

 
  char code[2];
   
  code[0]=CODE_PEDALUP; 
  code[1]='\0';

  Scr->TextTo(GetAbsPos()+Point(DELTAXPEDALUP,DELTAYPEDALUP)+Point(GetDx(),GetDy()));     
  Scr->OutText((unsigned char *)code);


  Scr->SetColor(oldcol);
    
  
};

void PedalUp::Edit(Battuta *pBat)

{

    EditingMarkersDlg(this);

}  
