/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: pizzicat.cpp,v 1.1 2005/07/25 09:35:36 bellinpo Exp $ */


#include "str/pizzicat.hpp"
#include "drw/gscreen.hpp"
#include "lioo.hpp"
#include "gui/dialogs.hpp"


Pizzicato::Pizzicato()
{
	ID=CL_PIZZICATO;
	Violino::Init();
	SetVU2Up(PIZZICATO2UP);
	SetVU2Dwn(PIZZICATO2DWN);
	SetVU2Lft(PIZZICATO2LFT);
	SetVU2Rgt(PIZZICATO2RGT);  
}


VUnit Pizzicato::GetVU2Up()
{return PIZZICATO2UP;};

VUnit Pizzicato::GetVU2Dwn()
{return PIZZICATO2DWN;};

VUnit Pizzicato::GetVU2Lft()
{return PIZZICATO2LFT;};

VUnit Pizzicato::GetVU2Rgt()
{return PIZZICATO2RGT;};


void Pizzicato::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	int oldFont;
	char code[6]=CODE_PIZZICATO;
	
	oldFont=Scr->SetFont(nTextFont);
	Scr->TextTo(GetAbsPos()+Point(DELTAXPIZZICATO,DELTAYPIZZICATO)+Point(GetDx(),GetDy()));
	Scr->OutText((unsigned char *)code);
	Scr->SetFont(oldFont);
	
	Violino::Draw();

	Scr->SetColor(oldcol);
	
};  


CmdResult Pizzicato::SymCommand(SymCmd& SCmd, Nota* pNota,
								Battuta* pBattuta)
{  
	TipoInserimento tpIns = (TipoInserimento)SCmd.ArgV[0];
	CmdResult cmdRes;
	
	switch(SCmd.CommandId)
	{
    case CMD_NOTA_CORDA_0:
    case CMD_NOTA_CORDA_1:
    case CMD_NOTA_CORDA_2:
    case CMD_NOTA_CORDA_3:
    case CMD_NOTA_CORDA_4:
    case CMD_NOTA_CORDA_5:
	case CMD_NOTA_CORDA_6:
	case CMD_NOTA_CORDA_7:
		cmdRes=Violino::SymCommand(SCmd, tpIns, pNota, pBattuta);
		if(cmdRes!=CMD_UNKNOWN)
			return(cmdRes);
		break; 
	}            
	return(CMD_UNKNOWN);
}



void Pizzicato::Edit(Battuta *pBat)

{
	
    EditingMarkersDlg(this);
	
}
