/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: ponticel.cpp,v 1.1 2005/07/25 09:35:37 bellinpo Exp $ */


#include "str/ponticel.hpp"
#include "gui/dialogs.hpp"


Ponticello::Ponticello()
{
	Init();
	ID=CL_PONTICELLO;
	SetFont(nTextFont);
	SetTxt((unsigned char*)"pont.");
}

void Ponticello::Draw()
{ 
	FontID ofont;
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	ofont=Scr->SetFont(font);
	Scr->TextTo(GetAbsPos() + Point(DELTAXPONTICELLO,DELTAYPONTICELLO)+Point(GetDx(),GetDy()));
	if(txt!=NULL) Scr->OutText((unsigned char *)txt);
	Scr->SetFont(ofont);
	

	Scr->SetColor(oldcol);
	
	
}

VUnit Ponticello::GetVU2Rgt() { return Text::GetVU2Rgt()/2+3; }
VUnit Ponticello::GetVU2Lft() { return Text::GetVU2Rgt()/2-4; }
VUnit Ponticello::GetVU2Up()  { return Text::GetVU2Up()-3; }
VUnit Ponticello::GetVU2Dwn() { return Text::GetVU2Dwn()+1; }

void Ponticello::Edit(Battuta *pBat)

{
	
    EditingMarkersDlg(this);
	
}
