/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: timpano.cpp,v 1.1 2005/07/25 09:35:39 bellinpo Exp $ */


#include"str/timpano.hpp"


Timpano::Timpano()
{
	//   ID = CL_TIMPANO;
	// questa istruzione dava l'errore:
	// request for member 'ID' is ambiguos.
	// allora e' stato introdotto il metodo SetId in DrawObject.
	
	Text::SetID(CL_TIMPANO);
	Strumento::SetID(CL_TIMPANO);
	
	
	ConFreccia = FALSE;
	vu2up = 0;
	vu2dwn = 0;
	Text::SetFont(nTextFont);
	SetTxt((unsigned char*)" ");
}
 
/*
void Timpano::SetColor(int col)
{ Text::SetColor(col); }

int Timpano::GetColor()
{ return Text::GetColor(); }
*/
void Timpano::SetColor(const Colore& col)
{ Text::SetColor(col); }

const Colore& Timpano::GetColor()
{ return Text::GetColor(); }


void Timpano::SetPos(DrawObject *d,const Point& p)
{ Text::SetPos(d,p); }

void Timpano::Move(const Point& p)
{ Text::Move(p); }

Point Timpano::GetAbsPos()
{ return Text::GetAbsPos(); }



VUnit Timpano::GetVU2Up()
{
	
	return (Text::GetVU2Up()+1);
}

VUnit Timpano::GetVU2Dwn()
{
	return MARGINE+1; 
}

VUnit Timpano::GetVU2Rgt()
{
	return Text::GetVU2Rgt()+MARGINE+1;
}

VUnit Timpano::GetVU2Lft()
{
	if(ConFreccia)
		return (Text::GetVU2Lft()+MARGINE+LUNGFRECCIA);
	else
		return (Text::GetVU2Lft()+MARGINE+1);
} 



Bool Timpano::SetTxt(unsigned char *s) 
{
	strcpy((char*)testo,(char*)s);
	return Text::SetTxt(testo);
}

void Timpano::SetFreccia(Bool f)
{ ConFreccia = f; }

Bool Timpano::GetFreccia()
{ return ConFreccia; }

void Timpano::Draw()
{
	Colore oldcol= Scr->GetColor();
	if(Strumento::isOpaque || Text::isOpaque)
		Scr->SetColor(GetColor());

	Text::Draw();
	
	Scr->Rect(Rectangle(GetAbsPos(),MARGINE,
		GetVU2Rgt(),GetVU2Up(),MARGINE));
	
	
	if(ConFreccia) DrawFreccia();
	

	Scr->SetColor(oldcol);
}; 

void Timpano::DrawFreccia()
{
	Point p;
	
	if ((GetAbsPos())!=Point(0,0))
	{
		p = GetAbsPos() + Point(-MARGINE,GetVU2Up()/2-2);
		
		
		Scr->Line(p,p+Point(-LUNGFRECCIA,0),SOLID_LINE); 
		Scr->Line(p, GetAbsPos() + Point(-LUNGFRECCIA/3-MARGINE, -2),SOLID_LINE);
		Scr->Line(p, GetAbsPos() + Point(-LUNGFRECCIA/3-MARGINE,GetVU2Up()-2),SOLID_LINE);
	}
}


Bool Timpano::Hit(const Point& p, SelObj selObj, DrawObject*& drwObjSel,
				  SymPath& symPath)
{
	
	if (Text::Hit(p, selObj, drwObjSel, symPath))
	{
		drwObjSel = (Strumento*)this;
		return TRUE;
	}
	else
		return FALSE;
	
	
}


Bool Timpano::SymbolicHit(SymPath& symPath, SelObj selObj, DrawObject*& drwObjSel)
{
	
	if (Text::SymbolicHit(symPath, selObj, drwObjSel))
	{
		drwObjSel=(Strumento*)this;
		return TRUE;
	}
	return FALSE;
	
}

DrawObject * Timpano::GetObject(SymCmd * SCmd)
{
	if (SCmd->CommandId==CMD_PAUSA_TIMPANO) return (DrawObject *)((Text *)(this));
	else 
		return NULL;
	
}

//void Timpano::Select()
//{
//	Text::SetOldColor(GetColor());
//	Text::SetColor((ColorIcon)SELECTED_COLOR);
//	Draw();
//}
//
//void Timpano::Deselect()
//{
//	Text::SetColor(Text::GetOldColor());
//	Draw();
//}



