/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: timpano.hpp,v 1.1 2005/07/25 09:35:39 bellinpo Exp $ */


#ifndef TIMPANO_HPP
#define TIMPANO_HPP

#include"lioo.hpp"
#include"drw/text.hpp"
#include"str/strument.hpp"



class Timpano : public Strumento, public Text
{  

	
protected:
	Bool ConFreccia;
public:
    Timpano();
	
    void SetPos(DrawObject *d,const Point& p);
	// imposta la posizione assoluta dell'oggetto relativamente
	// al drawobject d. Se d==NULL imposta la posizione assoluta come 'p'.
    void Move(const Point& p);
	// Cambia la posizione dell'oggetto nello schermo      
    Point GetAbsPos();
	// Ritorna la posizione assoluta dell'oggetto grafico
	
    ClassID GetID();
	// restituisce l'identificatore della classe. 
	
    //void SetColor(int col);
	// imposta il colore.
    //int GetColor();
	// ritorna il colore selezionato.

    void SetColor(const Colore& col);
    const Colore& GetColor();
	
    void SetFreccia(Bool f);
    Bool GetFreccia();
    VUnit GetVU2Up();
    VUnit GetVU2Dwn();
    VUnit GetVU2Lft();
    VUnit GetVU2Rgt();
	
    Bool SetTxt(unsigned char *s);
	// il SetTxt di Text non alloca la memoria necessaria.
	
    Bool Hit(const Point& p, SelObj selObj, DrawObject*& drwObjSel,
	       SymPath& symPath);
    Bool SymbolicHit(SymPath& symPath, SelObj selObj, DrawObject*& drwObjSel);
	
    void DrawFreccia();
    void Draw();
	void printFreccia();
    DrawObject * GetObject(SymCmd * SCmd);
    //void Select(void);
    //void Deselect(void);

	int SaveXML(FILE *fp) {return 1;};
};

#endif //TIMPANO_HPP
