/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: annotazi.cpp,v 1.1 2005/07/25 09:35:40 bellinpo Exp $ */


#include "txt/annotazi.hpp"
#include "drw/gscreen.hpp"
#include "gui/dialogs.hpp"

Annotazione::Annotazione()
{
	ID=CL_ANNOTAZIONE;
	SetFont(nTextFont);
}

Bool Annotazione::GetAboveNota()
{ return aboveNota; };

void Annotazione::SetAboveNota(Bool above)
{ aboveNota=above;};

Bool Annotazione::SetTxt(char *s)
{
	strcpy((char*)testo,(char*)s);
	return Text::SetTxt(testo);
}

VUnit Annotazione::GetVU2Rgt() { return Text::GetVU2Rgt()/2+1; }
VUnit Annotazione::GetVU2Lft() { return Text::GetVU2Rgt()/2+2; }

void Annotazione::Draw()
{
	FontID ofont;
	
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	ofont=Scr->SetFont(font);
	
	Scr->TextTo(GetAbsPos()+Point(GetDx(),GetDy()));
	
	
	if(txt!=NULL)
		Scr->OutText((unsigned char *)txt);
	Scr->SetFont(ofont);
	

	Scr->SetColor(oldcol);
}

void Annotazione::Edit(Battuta *pBat)
{
	char buffer[TGENERICO_LEN]="";
	bool hidden;
	Align align;
	wxFont font;
	bool pos=!GetAboveNota();
	strcat(buffer,(const char*)GetTxt());
	InputGenericText(buffer,TGENERICO_LEN,hidden,align,font,pos);
	SetAboveNota(!pos);
	SetTxt(buffer);
}
