/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: def_txt.hpp,v 1.1 2005/07/25 09:35:40 bellinpo Exp $ */


#ifndef DEF_TXT_HPP
#define DEF_TXT_HPP

#define CODE_RALLENTATO "rall."
#define DELTAXRALLENTATO -8
#define DELTAYRALLENTATO -4
#define RALLENTATO2UP 5
#define RALLENTATO2DWN 5
#define RALLENTATO2RGT 8
#define RALLENTATO2LFT 9

#define CODE_ACCELERATO "accel."
#define DELTAXACCELERATO -14
#define DELTAYACCELERATO -4
#define ACCELERATO2UP 5
#define ACCELERATO2DWN 5
#define ACCELERATO2RGT 15
#define ACCELERATO2LFT 15

enum TDinamicType{
	TD_PPPPPP,
		TD_PPPPP,
		TD_PPPP,
		TD_PPP,
		TD_PP,
		TD_P,
		TD_MP,
		TD_MF,
		TD_F,
		TD_FF,
		TD_FFF,
		TD_FFFF,
		TD_FFFFF,
		TD_FFFFFF,
		TD_FPP,
		TD_FFP,
		TD_FFPP,
		TD_SP,
		TD_SF,
		TD_SFF,
		TD_SFFF,
		TD_SFFP,
		TD_SFFZ,
		TD_SFP,
		TD_SFPP,
		TD_SFZ,
		TD_FZ,
		TD_FP,
		TD_RF,
		TD_RFZ
};

#define CODE_PPPPPP 229-256
#define DELTAXPPPPPP Scr->Get_VU2DX(229)        
#define DELTAYPPPPPP Scr->Get_VU2DY(229)        
#define PPPPPP2UP Scr->Get_VU2UP(229)           
#define PPPPPP2DWN Scr->Get_VU2DWN(229)       
#define PPPPPP2RGT Scr->Get_VU2RG(229)      
#define PPPPPP2LFT Scr->Get_VU2LF(229)      

#define CODE_PPPPP 228-256
#define DELTAXPPPPP Scr->Get_VU2DX(228)        
#define DELTAYPPPPP Scr->Get_VU2DY(228)        
#define PPPPP2UP Scr->Get_VU2UP(228)           
#define PPPPP2DWN Scr->Get_VU2DWN(228)       
#define PPPPP2RGT Scr->Get_VU2RG(228)      
#define PPPPP2LFT Scr->Get_VU2LF(228)      

#define CODE_PPPP 123
#define DELTAXPPPP Scr->Get_VU2DX(123)        
#define DELTAYPPPP Scr->Get_VU2DY(123)        
#define PPPP2UP Scr->Get_VU2UP(123)           
#define PPPP2DWN Scr->Get_VU2DWN(123)       
#define PPPP2RGT Scr->Get_VU2RG(123)      
#define PPPP2LFT Scr->Get_VU2LF(123)      

#define CODE_PPP 122
#define DELTAXPPP Scr->Get_VU2DX(122)        
#define DELTAYPPP Scr->Get_VU2DY(122)        
#define PPP2UP Scr->Get_VU2UP(122)           
#define PPP2DWN Scr->Get_VU2DWN(122)       
#define PPP2RGT Scr->Get_VU2RG(122)      
#define PPP2LFT Scr->Get_VU2LF(122)      


#define CODE_PP 213-256 
#define DELTAXPP Scr->Get_VU2DX(213)        
#define DELTAYPP Scr->Get_VU2DY(213)        
#define PP2UP Scr->Get_VU2UP(213)           
#define PP2DWN Scr->Get_VU2DWN(213)       
#define PP2RGT Scr->Get_VU2RG(213)      
#define PP2LFT Scr->Get_VU2LF(213)      

#define CODE_P 112
#define DELTAXP Scr->Get_VU2DX(112)        
#define DELTAYP Scr->Get_VU2DY(112)        
#define P2UP Scr->Get_VU2UP(112)           
#define P2DWN Scr->Get_VU2DWN(112)       
#define P2RGT Scr->Get_VU2RG(112)      
#define P2LFT Scr->Get_VU2LF(112)      

#define CODE_MP 80 
#define DELTAXMP Scr->Get_VU2DX(80)        
#define DELTAYMP Scr->Get_VU2DY(80)        
#define MP2UP Scr->Get_VU2UP(80)           
#define MP2DWN Scr->Get_VU2DWN(80)       
#define MP2RGT Scr->Get_VU2RG(80)      
#define MP2LFT Scr->Get_VU2LF(80)      

#define CODE_FFFFFF 227-256
#define DELTAXFFFFFF Scr->Get_VU2DX(227)        
#define DELTAYFFFFFF Scr->Get_VU2DY(227)        
#define FFFFFF2UP Scr->Get_VU2UP(227)           
#define FFFFFF2DWN Scr->Get_VU2DWN(227)       
#define FFFFFF2RGT Scr->Get_VU2RG(227)      
#define FFFFFF2LFT Scr->Get_VU2LF(227)      

#define CODE_FFFFF 226-256
#define DELTAXFFFFF Scr->Get_VU2DX(226)        
#define DELTAYFFFFF Scr->Get_VU2DY(226)        
#define FFFFF2UP Scr->Get_VU2UP(226)           
#define FFFFF2DWN Scr->Get_VU2DWN(226)       
#define FFFFF2RGT Scr->Get_VU2RG(226)      
#define FFFFF2LFT Scr->Get_VU2LF(226)      

#define CODE_FFFF 137-256       
#define DELTAXFFFF Scr->Get_VU2DX(137)        
#define DELTAYFFFF Scr->Get_VU2DY(137)        
#define FFFF2UP  Scr->Get_VU2UP(137)          
#define FFFF2DWN Scr->Get_VU2DWN(137)         
#define FFFF2RGT Scr->Get_VU2RG(137)          
#define FFFF2LFT Scr->Get_VU2LF(137)          

#define CODE_FFF 225-256        
#define DELTAXFFF Scr->Get_VU2DX(225)        
#define DELTAYFFF Scr->Get_VU2DY(225)        
#define FFF2UP  Scr->Get_VU2UP(225)          
#define FFF2DWN Scr->Get_VU2DWN(225)         
#define FFF2RGT Scr->Get_VU2RG(225)          
#define FFF2LFT Scr->Get_VU2LF(225)          

#define CODE_FF 224-256
#define DELTAXFF Scr->Get_VU2DX(224)        
#define DELTAYFF Scr->Get_VU2DY(224)        
#define FF2UP  Scr->Get_VU2UP(224)          
#define FF2DWN Scr->Get_VU2DWN(224)         
#define FF2RGT Scr->Get_VU2RG(224)          
#define FF2LFT Scr->Get_VU2LF(224)          

#define CODE_F 102        
#define DELTAXF Scr->Get_VU2DX(102)        
#define DELTAYF Scr->Get_VU2DY(102)        
#define F2UP  Scr->Get_VU2UP(102)          
#define F2DWN Scr->Get_VU2DWN(102)         
#define F2RGT Scr->Get_VU2RG(102)          
#define F2LFT Scr->Get_VU2LF(102)          

#define CODE_MF 70
#define DELTAXMF Scr->Get_VU2DX(70)        
#define DELTAYMF Scr->Get_VU2DY(70)        
#define MF2UP Scr->Get_VU2UP(70)           
#define MF2DWN Scr->Get_VU2DWN(70)         
#define MF2RGT Scr->Get_VU2RG(70)          
#define MF2LFT Scr->Get_VU2LF(70)          

#define CODE_SP 115
#define DELTAXSP Scr->Get_VU2DX(115)        
#define DELTAYSP Scr->Get_VU2DY(115)        
#define SP2UP Scr->Get_VU2UP(115)           
#define SP2DWN Scr->Get_VU2DWN(115)        
#define SP2RGT Scr->Get_VU2RG(115)        
#define SP2LFT Scr->Get_VU2LF(115)        

#define CODE_SF 116 
#define DELTAXSF Scr->Get_VU2DX(116)        
#define DELTAYSF Scr->Get_VU2DY(116)        
#define SF2UP Scr->Get_VU2UP(116)           
#define SF2DWN Scr->Get_VU2DWN(116)        
#define SF2RGT Scr->Get_VU2RG(116)        
#define SF2LFT Scr->Get_VU2LF(116)        

#define CODE_SFZ 126
#define DELTAXSFZ Scr->Get_VU2DX(126)        
#define DELTAYSFZ Scr->Get_VU2DY(126)        
#define SFZ2UP Scr->Get_VU2UP(126)           
#define SFZ2DWN Scr->Get_VU2DWN(126)        
#define SFZ2RGT Scr->Get_VU2RG(126)        
#define SFZ2LFT Scr->Get_VU2LF(126)        

#define CODE_FZ 125
#define DELTAXFZ Scr->Get_VU2DX(125)         
#define DELTAYFZ Scr->Get_VU2DY(125)         
#define FZ2UP Scr->Get_VU2UP(125)            
#define FZ2DWN Scr->Get_VU2DWN(125)        
#define FZ2RGT Scr->Get_VU2RG(125)        
#define FZ2LFT Scr->Get_VU2LF(125)        

#define CODE_FP 136-256
#define DELTAXFP Scr->Get_VU2DX(136)         
#define DELTAYFP Scr->Get_VU2DY(136)         
#define FP2UP Scr->Get_VU2UP(136)            
#define FP2DWN Scr->Get_VU2DWN(136)        
#define FP2RGT Scr->Get_VU2RG(136)        
#define FP2LFT Scr->Get_VU2LF(136)        

#define CODE_RF 155-256
#define DELTAXRF Scr->Get_VU2DX(155)         
#define DELTAYRF Scr->Get_VU2DY(155)         
#define RF2UP Scr->Get_VU2UP(155)            
#define RF2DWN Scr->Get_VU2DWN(155)        
#define RF2RGT Scr->Get_VU2RG(155)        
#define RF2LFT Scr->Get_VU2LF(155)        


#define CODE_FFP 240-256
#define DELTAXFFP Scr->Get_VU2DX(240)        
#define DELTAYFFP Scr->Get_VU2DY(240)        
#define FFP2UP Scr->Get_VU2UP(240)           
#define FFP2DWN Scr->Get_VU2DWN(240)       
#define FFP2RGT Scr->Get_VU2RG(240)      
#define FFP2LFT Scr->Get_VU2LF(240)      

#define CODE_FFPP 241-256
#define DELTAXFFPP Scr->Get_VU2DX(241)        
#define DELTAYFFPP Scr->Get_VU2DY(241)        
#define FFPP2UP Scr->Get_VU2UP(241)           
#define FFPP2DWN Scr->Get_VU2DWN(241)       
#define FFPP2RGT Scr->Get_VU2RG(241)      
#define FFPP2LFT Scr->Get_VU2LF(241)      

//I seguenti so trovano nel Musica2
#define CODE_FPP 113
#define DELTAXFPP Scr->Get_VU2DX(113,MUSICFONT2_ID)
#define DELTAYFPP Scr->Get_VU2DY(113, MUSICFONT2_ID)
#define FPP2UP Scr->Get_VU2UP(113,MUSICFONT2_ID)           
#define FPP2DWN Scr->Get_VU2DWN(113, MUSICFONT2_ID)       
#define FPP2RGT Scr->Get_VU2RG(113, MUSICFONT2_ID)      
#define FPP2LFT Scr->Get_VU2LF(113, MUSICFONT2_ID)      

#define CODE_RFZ 114
#define DELTAXRFZ Scr->Get_VU2DX(114, MUSICFONT2_ID)        
#define DELTAYRFZ Scr->Get_VU2DY(114, MUSICFONT2_ID)        
#define RFZ2UP Scr->Get_VU2UP(114, MUSICFONT2_ID)           
#define RFZ2DWN Scr->Get_VU2DWN(114, MUSICFONT2_ID)       
#define RFZ2RGT Scr->Get_VU2RG(114, MUSICFONT2_ID)      
#define RFZ2LFT Scr->Get_VU2LF(114, MUSICFONT2_ID)      

#define CODE_SFF 115
#define DELTAXSFF Scr->Get_VU2DX(115, MUSICFONT2_ID)        
#define DELTAYSFF Scr->Get_VU2DY(115, MUSICFONT2_ID)        
#define SFF2UP Scr->Get_VU2UP(115, MUSICFONT2_ID)           
#define SFF2DWN Scr->Get_VU2DWN(115, MUSICFONT2_ID)       
#define SFF2RGT Scr->Get_VU2RG(115, MUSICFONT2_ID)      
#define SFF2LFT Scr->Get_VU2LF(115, MUSICFONT2_ID)      

#define CODE_SFFF 116
#define DELTAXSFFF Scr->Get_VU2DX(116, MUSICFONT2_ID)        
#define DELTAYSFFF Scr->Get_VU2DY(116, MUSICFONT2_ID)        
#define SFFF2UP Scr->Get_VU2UP(116, MUSICFONT2_ID)           
#define SFFF2DWN Scr->Get_VU2DWN(116, MUSICFONT2_ID)       
#define SFFF2RGT Scr->Get_VU2RG(116, MUSICFONT2_ID)      
#define SFFF2LFT Scr->Get_VU2LF(116, MUSICFONT2_ID)      

#define CODE_SFFP 117
#define DELTAXSFFP Scr->Get_VU2DX(117, MUSICFONT2_ID)        
#define DELTAYSFFP Scr->Get_VU2DY(117, MUSICFONT2_ID)        
#define SFFP2UP Scr->Get_VU2UP(117, MUSICFONT2_ID)           
#define SFFP2DWN Scr->Get_VU2DWN(117, MUSICFONT2_ID)       
#define SFFP2RGT Scr->Get_VU2RG(117, MUSICFONT2_ID)      
#define SFFP2LFT Scr->Get_VU2LF(117, MUSICFONT2_ID)      

#define CODE_SFFZ 118
#define DELTAXSFFZ Scr->Get_VU2DX(118, MUSICFONT2_ID)        
#define DELTAYSFFZ Scr->Get_VU2DY(118,  MUSICFONT2_ID)       
#define SFFZ2UP Scr->Get_VU2UP(118, MUSICFONT2_ID)           
#define SFFZ2DWN Scr->Get_VU2DWN(118, MUSICFONT2_ID)       
#define SFFZ2RGT Scr->Get_VU2RG(118, MUSICFONT2_ID)      
#define SFFZ2LFT Scr->Get_VU2LF(118, MUSICFONT2_ID)      

#define CODE_SFP 119
#define DELTAXSFP Scr->Get_VU2DX(119, MUSICFONT2_ID)        
#define DELTAYSFP Scr->Get_VU2DY(119, MUSICFONT2_ID)        
#define SFP2UP Scr->Get_VU2UP(119,  MUSICFONT2_ID)          
#define SFP2DWN Scr->Get_VU2DWN(119, MUSICFONT2_ID)     
#define SFP2RGT Scr->Get_VU2RG(119,  MUSICFONT2_ID)     
#define SFP2LFT Scr->Get_VU2LF(119, MUSICFONT2_ID)      

#define CODE_SFPP 120
#define DELTAXSFPP Scr->Get_VU2DX(120, MUSICFONT2_ID)        
#define DELTAYSFPP Scr->Get_VU2DY(120,  MUSICFONT2_ID)       
#define SFPP2UP Scr->Get_VU2UP(120, MUSICFONT2_ID)           
#define SFPP2DWN Scr->Get_VU2DWN(120, MUSICFONT2_ID)       
#define SFPP2RGT Scr->Get_VU2RG(120, MUSICFONT2_ID)      
#define SFPP2LFT Scr->Get_VU2LF(120, MUSICFONT2_ID)      

#endif //DEF_TXT_HPP

