/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: tgeneric.cpp,v 1.1 2005/07/25 09:35:41 bellinpo Exp $ */


#include "txt/tgeneric.hpp"
#include "drw/gscreen.hpp"
#include "gui/dialogs.hpp"

TGenerico::TGenerico()
{ 
	ID=CL_TGENERICO; 
	SetFont(nTextFont);
	hidden=false;
}

Bool TGenerico::GetAboveNota()
{ return aboveNota; };

void TGenerico::SetAboveNota(Bool above)
{ aboveNota=above;};

Bool TGenerico::GetHidden()
{ return hidden; };

void TGenerico::SetHidden(Bool hddn)
{ hidden=hddn;};

Bool TGenerico::SetTxt(char *s)
{
	strcpy((char*)testo,(char*)s);
	return Text::SetTxt(testo);
}


VUnit TGenerico::GetVU2Rgt() { return Text::GetVU2Rgt()/2+1; }
VUnit TGenerico::GetVU2Lft() { return Text::GetVU2Rgt()/2+2; }

void TGenerico::Draw()
{
	FontID ofont;
	extern bool visible;
	
	if(!hidden || visible)
	{
		Colore oldcol= Scr->GetColor();
		if(isOpaque)
			Scr->SetColor(GetColor());

		ofont=Scr->SetFont(font);
		Scr->TextTo(GetAbsPos()+Point(-GetWidth()/2,0)+Point(GetDx(),GetDy()));
		if(txt!=NULL)	  
			Scr->OutText((unsigned char *)txt);
		
		Scr->SetFont(ofont);

		Scr->SetColor(oldcol);
	}
	
}

void TGenerico::Edit(Battuta *pBat)
{
	char buffer[TGENERICO_LEN]="";
	bool hidden=GetHidden();
	Align align;
	wxFont font;
	bool pos=!GetAboveNota();
	strcat(buffer,(const char*)GetTxt());
	InputGenericText(buffer,TGENERICO_LEN,hidden,align,font,pos,true);
	SetAboveNota(!pos);
	SetTxt(buffer);
	SetHidden(hidden);
} 
