/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: def_var.hpp,v 1.1 2005/07/25 09:35:43 bellinpo Exp $ */


#ifndef DEF_VAR_HPP
#define DEF_VAR_HPP

#define CODE_CORONAUP 85
#define UPDELTAXCORONA Scr->Get_VU2DX(85)     
#define UPDELTAYCORONA Scr->Get_VU2DY(85)     
#define UPCORONA2UP Scr->Get_VU2UP(85)     
#define UPCORONA2DWN Scr->Get_VU2DWN(85)     
#define UPCORONA2RGT Scr->Get_VU2RG(85)     
#define UPCORONA2LFT Scr->Get_VU2LF(85)     

#define CODE_CORONADWN 117
#define DWNCORONA2UP Scr->Get_VU2UP(117)     
#define DWNCORONA2DWN Scr->Get_VU2DWN(117)     
#define DWNCORONA2RGT Scr->Get_VU2RG(117)     
#define DWNCORONA2LFT Scr->Get_VU2LF(117)     
#define DWNDELTAXCORONA Scr->Get_VU2DX(117)     
#define DWNDELTAYCORONA Scr->Get_VU2DY(117)     

#define CODE_CORONAQUADUP 173
#define UPDELTAXCORONAQUAD Scr->Get_VU2DX(173)      
#define UPDELTAYCORONAQUAD Scr->Get_VU2DY(173)      
#define UPCORONAQUAD2UP Scr->Get_VU2UP(173)      
#define UPCORONAQUAD2DWN Scr->Get_VU2DWN(173)      
#define UPCORONAQUAD2RGT Scr->Get_VU2RG(173)      
#define UPCORONAQUAD2LFT Scr->Get_VU2LF(173)

#define CODE_CORONAQUADDWN 123
#define DWNDELTAXCORONAQUAD Scr->Get_VU2DX(123, MUSICFONT2_ID)      
#define DWNDELTAYCORONAQUAD Scr->Get_VU2DY(123, MUSICFONT2_ID)      
#define DWNCORONAQUAD2UP Scr->Get_VU2UP(123, MUSICFONT2_ID)      
#define DWNCORONAQUAD2DWN Scr->Get_VU2DWN(123, MUSICFONT2_ID)      
#define DWNCORONAQUAD2RGT Scr->Get_VU2RG(123, MUSICFONT2_ID)      
#define DWNCORONAQUAD2LFT Scr->Get_VU2LF(123, MUSICFONT2_ID)         

#define CODE_CORONATRIANGUP 175
#define UPDELTAXCORONATRIANG Scr->Get_VU2DX(175)      
#define UPDELTAYCORONATRIANG Scr->Get_VU2DY(175)      
#define UPCORONATRIANG2UP Scr->Get_VU2UP(175)      
#define UPCORONATRIANG2DWN Scr->Get_VU2DWN(175)      
#define UPCORONATRIANG2RGT Scr->Get_VU2RG(175)     
#define UPCORONATRIANG2LFT Scr->Get_VU2LF(175)

#define CODE_CORONATRIANGDWN 124
#define DWNDELTAXCORONATRIANG Scr->Get_VU2DX(124, MUSICFONT2_ID)      
#define DWNDELTAYCORONATRIANG Scr->Get_VU2DY(124, MUSICFONT2_ID)      
#define DWNCORONATRIANG2UP Scr->Get_VU2UP(124, MUSICFONT2_ID)      
#define DWNCORONATRIANG2DWN Scr->Get_VU2DWN(124, MUSICFONT2_ID)      
#define DWNCORONATRIANG2RGT Scr->Get_VU2RG(124, MUSICFONT2_ID)     
#define DWNCORONATRIANG2LFT Scr->Get_VU2LF(124, MUSICFONT2_ID)         

enum CoronaType{
	Classic,
		Quad,
		Triang
};

enum TipiDirezioneArpeggio
{
	NO_DIRECTION,
		UPWARD,
		DOWNWARD
};

//

// per mancanza di spazio gli occhiali sono passati nel secondo font (musica2)

#define CODE_OCCHIALI 33
#define DELTAXOCCHIALI Scr->Get_VU2DX(33, MUSICFONT2_ID)     
#define DELTAYOCCHIALI Scr->Get_VU2DY(33, MUSICFONT2_ID)     
#define OCCHIALI2UP Scr->Get_VU2UP(33, MUSICFONT2_ID)     
#define OCCHIALI2DWN Scr->Get_VU2DWN(33, MUSICFONT2_ID)     
#define OCCHIALI2RGT Scr->Get_VU2RG(33, MUSICFONT2_ID)     
#define OCCHIALI2LFT Scr->Get_VU2LF(33, MUSICFONT2_ID)     

#define CODE_PRFIATO 44
#define DELTAXPRFIATO Scr->Get_VU2DX(44)     
#define DELTAYPRFIATO Scr->Get_VU2DY(44)     
#define PRFIATO2UP Scr->Get_VU2UP(44)     
#define PRFIATO2DWN Scr->Get_VU2DWN(44)      
#define PRFIATO2LFT Scr->Get_VU2LF(44)      
#define PRFIATO2RGT Scr->Get_VU2RG(44)     
#define ALT_PRFIATO 11

#define PUNTOVALORE2UP 2
#define PUNTOVALORE2DWN 1
#define PUNTOVALORE2RGT 5
#define PUNTOVALORE2LFT 1
#define PVAL_MAX 4
#define CODE_PUNTO 46

#define NUMARPEGMAX 6
#define CODE_ARPEGGIO 214
#define CODE_ARPEGGIO_UP 223
#define CODE_ARPEGGIO_DOWN 231
#define DELTAXARPEGGIO Scr->Get_VU2DX(214)     
#define DELTAYARPEGGIO Scr->Get_VU2DY(214)     

#define ALTEZZAARP 10
#define ARPEGGIO2RGT Scr->Get_VU2RG(214) 
#define ARPEGGIO2LFT Scr->Get_VU2LF(214)
#define NEWARPEGGIO 9

#define CODE_SUDDIVISIONE 113
#define SUDDIVISIONE2UP Scr->Get_VU2UP(113)     
#define SUDDIVISIONE2DWN Scr->Get_VU2DWN(113)     
#define SUDDIVISIONE2RGT Scr->Get_VU2RG(113)     
#define SUDDIVISIONE2LFT Scr->Get_VU2LF(113)     
#define DELTAXSUDDIVISIONEDOWN Scr->Get_VU2DX(113)     
#define DELTAYSUDDIVISIONEDOWN Scr->Get_VU2DY(113)     
#define DELTAXSUDDIVISIONEUP DELTAXSUDDIVISIONEDOWN+6
#define DELTAYSUDDIVISIONEUP DELTAYSUDDIVISIONEDOWN+20
#define SUDD_STEPY 3

#endif //DEF_VAR_HPP

