/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: occhiali.cpp,v 1.1 2005/07/25 09:35:43 bellinpo Exp $ */


#include "var/occhiali.hpp"
#include "drw/gscreen.hpp"
#include "gui/dialogs.hpp"

Occhiali::Occhiali()
{ ID=CL_OCCHIALI; aboveNota=TRUE;}

VUnit Occhiali::GetVU2Up()
{ return OCCHIALI2UP;}

VUnit Occhiali::GetVU2Dwn()
{ return OCCHIALI2DWN;}; 

VUnit Occhiali::GetVU2Rgt()
{ return OCCHIALI2RGT;}; 

VUnit Occhiali::GetVU2Lft()
{ return OCCHIALI2LFT;}; 

void Occhiali::SetAboveNota(Bool above)
{ aboveNota=above;};

Bool Occhiali::GetAboveNota()
{ return aboveNota; };

void Occhiali::Draw()
{
	int oldFont;
	char code[2]={0,0}; 
	oldFont=Scr->SetFont(nMusicFont2);
	code[0]=CODE_OCCHIALI; 
	
	Colore oldcol= Scr->GetColor();
	if(isOpaque)
		Scr->SetColor(GetColor());

	Scr->TextTo(GetAbsPos()+Point(DELTAXOCCHIALI,DELTAYOCCHIALI)+Point(GetDx(),GetDy()));
	
	Scr->OutText((unsigned char *)code);
	Scr->SetFont(oldFont);	
	
	Scr->SetColor(oldcol);
};  

void Occhiali::Edit(Battuta *pBat)
{
    EditingMarkersDlg(this);
}  
