/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#include <xercesc/dom/deprecated/DOMParser.hpp>
#include <xercesc/dom/deprecated/DOM.hpp>
#include "wdfcomponentparser.hpp"
#include <wx/msgdlg.h>

static wxString getNodeValue(const DOM_Node& node)
{
	if(node.isNull())
		return "";
	return node.getNodeValue().transcode();
}

WDFComponentParser::WDFComponentParser() : WDFDOMParser()
{
}

WDFComponentParser::WDFComponentParser(char *s) : WDFDOMParser(s)
{
}

bool WDFComponentParser::ReadLyrics(SMRLyricsItem *item)
{
	bool parseinit;
	int i=0;
	
	parseinit=Parse();
	if(parseinit)
	{
		return false;
	}
	DOM_Document doc = WDFParser->getDocument();
	DOM_Node wdfheader=doc.getFirstChild();
	if(wdfheader.isNull())
		return false;
	DOM_Node child = wdfheader.getFirstChild();
	if(child==0) // Se c'e' il DOCTYPE lo si salta
	{
		wdfheader=wdfheader.getNextSibling();
		child = wdfheader.getFirstChild();
	}
	
	DOM_NamedNodeMap attr=wdfheader.getAttributes();
	DOM_Node scoreId=attr.getNamedItem("SCOREID");
	int id=atoi(getNodeValue(scoreId));
	item->SetPartID(id);
	while( child != 0)
    {
		/*SKIP if(child.getNodeName().equals("WDFCID"))
		{
		}
		if(child.getNodeName().equals("Identification"))
		{
		}
		if(child.getNodeName().equals("WDFID"))
		{
		}
		if(child.getNodeName().equals("Classification"))
		{
			i++;
			ParseClassification(child,item,i);
		}
		if(child.getNodeName().equals("Dimension"))
		{
			ParseDimension(child,item);
		}
		if(child.getNodeName().equals("Checksum"))
		{
			ParseChecksum(child,item);
		}*/
		if(child.getNodeName().equals("Language"))
		{
			item->SetLanguage(getNodeValue(child.getFirstChild()));
		}
		/*SKIP if(child.getNodeName().equals("Author"))
		{
			item->SetAuthor(getNodeValue(child.getFirstChild()));
		}*/
		child = child.getNextSibling();
	}
	return true;
}
