/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "xmldefines.hpp"
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sstream>

#include <wx/string.h>

#include <xercesc/dom/deprecated/dom.hpp>

XERCES_CPP_NAMESPACE_USE

#include "par/partitur.hpp"
#include "par/listaspa.hpp"

#include "spa/spartito.hpp"
#include "spa/listabat.hpp"

#include "bat/listafig.hpp"
#include "bat/battuta.hpp"

#include "fig/nbreve.hpp"
#include "fig/nsemibre.hpp"
#include "fig/nminima.hpp"
#include "fig/nsemimin.hpp"
#include "fig/ncroma.hpp"
#include "fig/nsemicro.hpp"
#include "fig/nbiscrom.hpp"
#include "fig/nsemibis.hpp"
#include "fig/nfusa.hpp"
#include "fig/pquabatt.hpp"
#include "fig/pduebatt.hpp"
#include "fig/pgeneric.hpp"
#include "fig/pfusa.hpp"
#include "fig/psemibre.hpp"
#include "fig/pminima.hpp"
#include "fig/psemimin.hpp"
#include "fig/pcroma.hpp"
#include "fig/psemicro.hpp"
#include "fig/pbiscrom.hpp"
#include "fig/psemibis.hpp"
#include "fig/spazio.hpp"
#include "fig/gruppono.hpp"
#include "fig/accordo.hpp"

#include "alt/altecomp.hpp"
#include "alt/diesis.hpp"
#include "alt/bemolle.hpp"
#include "alt/bequadro.hpp"
#include "alt/bequadro1q.hpp"
#include "alt/bequadro3q.hpp"
#include "alt/doppiobe.hpp"
#include "alt/doppiodi.hpp"
#include "alt/diesis1q.hpp"
#include "alt/diesis3q.hpp"
#include "alt/bemoll1q.hpp"
#include "alt/bemoll3q.hpp"

#include "var/puntoval.hpp"
#include "var/corona.hpp"
#include "var/arpeggio.hpp"
#include "var/occhiali.hpp"
#include "var/prfiato.hpp"
#include "var/suddivis.hpp"

#include "bat/cviolino.hpp"
#include "bat/cbasso.hpp"
#include "bat/cbariton.hpp"
#include "bat/ctenore.hpp"
#include "bat/ctenore8.hpp"
#include "bat/ccontral.hpp"
#include "bat/cmezzoso.hpp"
#include "bat/csoprano.hpp"
#include "bat/cviolin8.hpp"
#include "bat/cbasso8.hpp"
#include "bat/chiave.hpp"
#include "bat/cviolino8sopra.hpp"
#include "bat/cbasso8sopra.hpp"
#include "bat/ctab.hpp"
#include "bat/cpercusbox.hpp"
#include "bat/cpercus2lines.hpp"
#include "bat/cvuota.hpp"
#include "bat/cbassoold.hpp"


#include "bat/bsingola.hpp"
#include "bat/bfinale.hpp"
#include "bat/bdoppia.hpp"
#include "bat/bfinerit.hpp"
#include "bat/binizior.hpp"
#include "bat/binifine.hpp"
#include "bat/battuta.hpp"
#include "bat/binvisibile.hpp"

#include "ind/sforzato.hpp"
#include "ind/accento.hpp"
#include "ind/viasord.hpp"
#include "ind/consord.hpp"
#include "ind/indicazi.hpp"
#include "ind/sordina.hpp"
#include "ind/puntoall.hpp"
#include "ind/martella.hpp"
#include "ind/martdolc.hpp"
#include "ind/tenuto.hpp"
#include "ind/staccato.hpp"
#include "ind/viasord.hpp"
#include "ind/consord.hpp"
#include "ind/sordina.hpp"
#include "ind/espgenerica.hpp"

#include "abb/abbellim.hpp"
#include "abb/ginferio.hpp"
#include "abb/gsuperio.hpp"
#include "abb/gup.hpp"
#include "abb/gslash.hpp"
#include "abb/minferio.hpp"
#include "abb/msuperio.hpp"
#include "abb/trillo.hpp"
#include "abb/tremolo.hpp"

#include "kor/koreanorn.hpp"
#include "kor/slidingup.hpp"
#include "kor/slidingdown.hpp"
#include "kor/slidingdup.hpp"
#include "kor/slidingdownup.hpp"
#include "kor/nonghyninc.hpp"
#include "kor/nonghyndec.hpp"
#include "kor/nonghynarrow.hpp"
#include "kor/nonghynwide.hpp"

#include "txt/tdinamic.hpp"
#include "txt/tgeneric.hpp"

#include "int/intestes.hpp"
#include "int/onda.hpp"
#include "int/freccia.hpp"
#include "int/forcella.hpp"
#include "int/legatura.hpp"
#include "int/cambiori.hpp"
#include "int/modifott.hpp"
#include "int/legatqua.hpp"
#include "int/legatval.hpp"
#include "int/trilloonda.hpp"
#include "int/bend.hpp"
#include "int/pedalefinoa.hpp"

#include "sca/numbatt.hpp"
#include "sca/numgrand.hpp"
#include "sca/numpausa.hpp"
#include "sca/lettera.hpp"
#include "sca/tsalto.hpp"
#include "sca/metronom.hpp"
#include "sca/scansion.hpp"
#include "sca/moviment.hpp"
#include "sca/numugual.hpp"
#include "sca/tmovimen.hpp"

#include "str/strument.hpp"
#include "str/violino.hpp"
#include "str/corda.hpp"
#include "str/arco.hpp"
#include "str/arcogiu.hpp"
#include "str/arcosu.hpp"
#include "str/direzarc.hpp"
#include "str/posizarc.hpp"
#include "str/partearc.hpp"
#include "str/pizzicat.hpp"
#include "str/ponticel.hpp"
#include "str/tastiera.hpp"
#include "str/punta.hpp"
#include "str/tallone.hpp"
#include "str/timpano.hpp"
#include "str/ditacord.hpp"

/*	DB */
#include "pag/listapagine.hpp"
#include "pag/pagina.hpp"
#include "pag/casella.hpp"
#include "pag/casellatxt.hpp"
#include "pag/casellaimg.hpp"
/*  DB */


#include "fig/riptempo.hpp"
#include "fig/ripmbat.hpp"
#include "fig/ripbatt.hpp"

#include "bra/parent.hpp"
#include "bra/parquad.hpp"
#include "bra/pargraff.hpp"

#include "abb/glissato.hpp"

#include "drw/musicedt.hpp"  //(MS)
#include "smr/smr.hpp"

extern int Mkdir(char*,int);
extern wxString XMLFormatString(const wxString& s);
extern wxMusicEditor* MusicEditor;
extern int strreplace(char* str, char a, char b);

wxString CheckLink(wxHashTable *table,wxString oldLink);

#define COMPUTER_VIEW 0
#define PRINT_VIEW 1
wxHashTable* oldCidMap=NULL;

#define SAVE_COLOR 

static wxString DxDyAttr(DrawObject* drw) 
{
	wxString str;
	if(drw->GetDxMainScore(COMPUTER_VIEW)!=0)
		str+=wxString::Format("MAINDX=\"%5.2f\" ",drw->GetDxMainScore(COMPUTER_VIEW));
	if(drw->GetDyMainScore(COMPUTER_VIEW)!=0)
		str+=wxString::Format("MAINDY=\"%5.2f\" ",drw->GetDyMainScore(COMPUTER_VIEW));
	if(drw->GetDxPart(COMPUTER_VIEW)!=0)
		str+=wxString::Format("PARTDX=\"%5.2f\" ",drw->GetDxPart(COMPUTER_VIEW));
	if(drw->GetDyPart(COMPUTER_VIEW)!=0)
		str+=wxString::Format("PARTDY=\"%5.2f\" ",drw->GetDyPart(COMPUTER_VIEW));

	if(drw->GetDxMainScore(PRINT_VIEW)!=0)
		str+=wxString::Format("PMAINDX=\"%5.2f\" ",drw->GetDxMainScore(PRINT_VIEW));
	if(drw->GetDyMainScore(PRINT_VIEW)!=0)
		str+=wxString::Format("PMAINDY=\"%5.2f\" ",drw->GetDyMainScore(PRINT_VIEW));
	if(drw->GetDxPart(PRINT_VIEW)!=0)
		str+=wxString::Format("PPARTDX=\"%5.2f\" ",drw->GetDxPart(PRINT_VIEW));
	if(drw->GetDyPart(PRINT_VIEW)!=0)
		str+=wxString::Format("PPARTDY=\"%5.2f\" ",drw->GetDyPart(PRINT_VIEW));

	return str;
}

static wxString DxDyRAttr(IntEsteso* intEst) 
{
	wxString str;
	if(intEst->GetDxRMainScore(COMPUTER_VIEW)!=0)
		str+=wxString::Format("MAINDXR=\"%5.2f\" ",intEst->GetDxRMainScore(COMPUTER_VIEW));
	if(intEst->GetDyRMainScore(COMPUTER_VIEW)!=0)
		str+=wxString::Format("MAINDYR=\"%5.2f\" ",intEst->GetDyRMainScore(COMPUTER_VIEW));
	if(intEst->GetDxRPart(COMPUTER_VIEW)!=0)
		str+=wxString::Format("PARTDXR=\"%5.2f\" ",intEst->GetDxRPart(COMPUTER_VIEW));
	if(intEst->GetDyRPart(COMPUTER_VIEW)!=0)
		str+=wxString::Format("PARTDYR=\"%5.2f\" ",intEst->GetDyRPart(COMPUTER_VIEW));

	if(intEst->GetDxRMainScore(PRINT_VIEW)!=0)
		str+=wxString::Format("PMAINDXR=\"%5.2f\" ",intEst->GetDxRMainScore(PRINT_VIEW));
	if(intEst->GetDyRMainScore(PRINT_VIEW)!=0)
		str+=wxString::Format("PMAINDYR=\"%5.2f\" ",intEst->GetDyRMainScore(PRINT_VIEW));
	if(intEst->GetDxRPart(PRINT_VIEW)!=0)
		str+=wxString::Format("PPARTDXR=\"%5.2f\" ",intEst->GetDxRPart(PRINT_VIEW));
	if(intEst->GetDyRPart(PRINT_VIEW)!=0)
		str+=wxString::Format("PPARTDYR=\"%5.2f\" ",intEst->GetDyRPart(PRINT_VIEW));

	return str;
}

//provvisorio
wxString XMLFormatString(const wxString& s)
{
	wxString r;

	for(unsigned int i=0; i<s.Len(); i++)
	{
		switch(s[i])
		{
		case '&':
			r+="&amp;";
			break;
		case '<':
			r+="&lt;";
			break;
		case '>':
			r+="&gt;";
			break;
		case '\'':
			r+="&apos;";
			break;
		case '"':
			r+="&quot;";
			break;
		default:
			{
				unsigned char c=s[i];
				if((s[i] & 0x80)==0)
				{
					if(isprint((unsigned char)s[i]))
						r+=s[i];
					else
					{
						unsigned char c=(unsigned char)s[i];
						r+=wxString::Format("&#x%X;",(int)c);
					}
				}
				else
				{
					if((c & 0xE0)==0xC0) //UTF-8 with 2 bytes
					{
						unsigned char c2=s[i+1];
						if((c2 & 0xC0)==0x80)
						{
							unsigned int x= (c & 0x1F);
							x<<=6;
							x|=(c2&0x3F);
							r+=wxString::Format("&#x%X;",x);
							i++; 
						}
					}
					else if((c & 0xF0)==0xE0) //UTF-8 with 3 bytes
					{
						unsigned char c2=s[i+1];
						unsigned char c3=s[i+2];
						if((c2 & 0xC0)==0x80 && (c3 & 0xC0)==0x80)
						{
							unsigned int x= (c & 0x0F);
							x<<=6;
							x|=(c2&0x3F);
							x<<=6;
							x|=(c3&0x3F);
							r+=wxString::Format("&#x%X;",x);
							i+=2; 
						}
					}
					else if((c & 0xF8)==0xF0) //UTF-8 with 4 bytes
					{
						unsigned char c2=s[i+1];
						unsigned char c3=s[i+2];
						unsigned char c4=s[i+3];
						if((c2 & 0xC0)==0x80 && (c3 & 0xC0)==0x80 && (c4 & 0xC0)==0x80)
						{
							unsigned int x= (c & 0x0F);
							x<<=6;
							x|=(c2&0x3F);
							x<<=6;
							x|=(c3&0x3F);
							x<<=6;
							x|=(c4&0x3F);
							r+=wxString::Format("&#x%X;",x);
							i+=3; 
						}
					}
				}
			}
/*
			if(isprint((unsigned char)s[i]))
				r+=s[i];
			else
			{
				unsigned char c=(unsigned char)s[i];
				r+=wxString::Format("&#x%x;",(int)c);
			}
*/
		}
	}
	return r;
}

// **************** Oggetti di alto livello ****************
#include <xercesc/util/xmlunidefs.hpp>

std::ostream& operator<<(std::ostream& target, const DOMString& s)
{
	char *p = s.transcode();
	target << p;
	free(p); 
	
	// il delete [] p non si puo'usare in debug
	// probabilmente l'ogg. e'stato allocato con il new standard e 
	// non quello delle wx ma il delete e'quello ridefinito dalle wx...
	// spero che usando il free tutto sia ok...
	
	return target;
};

void outputContent(std::ostream& target, const DOMString &toWrite)
{
	// Questo metodo  necessario per definire lo
	// operatore di libreria che permette il salvataggio
	// della Lirica su un file del disco.
	// Il codice  stato ripreso dalla documentazione
	// XML gi esistente e precisamente dal file DOMPRINT.
	
	int            length = toWrite.length();
	const XMLCh*   chars  = toWrite.rawBuffer();
	
	int index;
	for (index = 0; index < length; index++)
	{
		switch (chars[index])
		{
		case chAmpersand :
			target << "&amp;";
			break;
			
		case chOpenAngle :
			target << "&lt;";
			break;
			
		case chCloseAngle:
			target << "&gt;";
			break;
			
		case chDoubleQuote :
			target << "&quot;";
			break;
			
		default:
			
			target << toWrite.substringData(index, 1);
			break;
		}
	}
	
	return;
};

std::ostream& operator<<(std::ostream& target, DOM_Node& toWrite)
{
	DOMString   nodeName = toWrite.getNodeName();
	DOMString   nodeValue = toWrite.getNodeValue();
	
	switch (toWrite.getNodeType())
	{
	case DOM_Node::TEXT_NODE:
		{
			outputContent(target, nodeValue);
			break;
		}
		
	case DOM_Node::PROCESSING_INSTRUCTION_NODE :
		{
			target  << "<?"
				<< nodeName
				<< ' '
				<< nodeValue
				<< "?>";
			break;
		}
		
	case DOM_Node::DOCUMENT_NODE :
		{
			target << "<?xml version='1.0' encoding='ISO-8859-1' ?>\n";
			DOM_Node child = toWrite.getFirstChild();
			while( child != 0)
			{
				target << child << std::endl;
				child = child.getNextSibling();
			}
			
			break;
		}
		
	case DOM_Node::ELEMENT_NODE :
		{
			
			target << '<' << nodeName;
			
			DOM_NamedNodeMap attributes = toWrite.getAttributes();
			int attrCount = attributes.getLength();
			for (int i = 0; i < attrCount; i++)
			{
				DOM_Node  attribute = attributes.item(i);
				
				target  << ' ' << attribute.getNodeName()
					<< " = \"";
				
				outputContent(target, attribute.getNodeValue());
				target << '"';
			}
			DOM_Node child = toWrite.getFirstChild();
			if (child != 0)
			{
				
				target << ">";
				while( child != 0)
				{
					target << child;
					child = child.getNextSibling();
				}
				
				
				target << "</" << nodeName << ">" << std::endl;
			}
			else
			{
				target << "/>" << std::endl;
			}
			break;
		}
		
	case DOM_Node::ENTITY_REFERENCE_NODE:
		{
			DOM_Node child;
			for (child = toWrite.getFirstChild(); child != 0; child = child.getNextSibling())
				target << child;
			break;
		}
		
	case DOM_Node::CDATA_SECTION_NODE:
		{
			target << "<![CDATA[" << nodeValue << "]]>";
			break;
		}
		
	case DOM_Node::COMMENT_NODE:
		{
			target << "<!--" << nodeValue << "-->";
			break;
		}
		
	default:
		//cerr << "Unrecognized node type = "
		//<< (long)toWrite.getNodeType() << endl;
		break;
	}
	return target;
};

int Partitura::SaveMainScoreXML(const char* fname)
{
	FILE *fp;
	int rc=0;
	
	fp = fopen(fname, "w");
	if(!fp)
    {
		Message("Can't open file");
		return -1;
    }
	
	fprintf(fp,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
		       "<SMXF_Main xmlns=\"urn:mpeg:mpeg-4:schema:smr:smxf-mainscore:2007\">");
	/*	(FF) TO DO  Sostituire con save fatto nell'elaborato per Ident e class*/
#ifdef SWF
	if(rc>=0) rc=fprintf(fp, "<%s/>",ELFont_FON);
	if(rc>=0) rc=fprintf(fp, "<%s/>", ELFont_PS);
	if(rc>=0) rc=fprintf(fp, "<%s/>", ELFont_Table);
#endif

	Spartito *spa=GetFirstSpa();
	while(spa)
	{
		fprintf(fp, "<partRef SCOREID=\"%d\"/>", spa->GetNumericCode());

		spa = GetNextSpa(spa);
	}

	if(rc>=0) rc=fprintf(fp, "<midiinfo>");
	for(int i=0;i<10; i++)
	{
		char *dynType[]={"PPPP","PPP","PP", "P", "MP", "MF", "F", "FF", "FFF","FFFF"};
		if(rc>=0) rc=fprintf(fp, "<mididynmap DYN=\"%s\" VOLUME=\"%d\"/>", dynType[i],GetListaSpa()->GetMidiDinamicIndValue(i));
	}
	if(rc>=0) rc=fprintf(fp, "</midiinfo>");


	PrintParams *cv=GetComputerViewParams(); 
	PrintParams *pv=GetPrintViewParams();
	
	if(rc>=0 && cv!=NULL)
	{
		rc=cv->SaveComputerViewXML(fp);
	}

	if(rc>=0 && pv!=NULL)
	{
		rc=pv->SavePrintViewXML(fp,true);
	}
    
	//Salvo la lista delle parentesi
	if(rc>=0 && listaPar->SaveXML(fp) < 0)
		printf("Error while writing\n");

	//Salvo la lista delle annotazioni
	//	if(rc>=0) rc=fputs("<Annotation PART=\"\" MEASURE=\"\" LAYER=\"\" FIGURE=\"\" CHORD.OR.BEAM=\"\" CHORD.IN.BEAM=\"\">ANNOTAZIONE</Annotation>", fp);
	
	if(rc>=0) rc=listaPag->SaveXML(fp);	//DB

	if(selections)
	{
		DOM_Node* nodeSelections=(DOM_Node*)selections;
		
		DOM_Node n=nodeSelections->getFirstChild();
		while(!n.isNull() && !n.getNodeName().equals("selections"))
			n=n.getNextSibling();
			
		if(!n.isNull())
		{
			std::ostringstream ostr;
			ostr << n;
			if(rc>=0) rc=fprintf(fp,"%s",ostr.str().c_str());
		}
	}

#ifdef SWF
	if(rc>=0) rc=fprintf(fp,"</%s>", ELSWF_Main);
#else
	if(rc>=0) rc=fprintf(fp,"</SMXF_Main>");

#endif
	
	fclose(fp);
	return rc;
	//  printf("Ho terminato il salvataggio\n");
}
int Partitura::SavePartXML(const char* fname, int pos)
{
	//FFF const Context blank = BLANK_CONTEXT;
	FILE *fp;
	int rc=0;
	
	fp = fopen(fname,"w");
	if(!fp)
    {
		Message("Can't open file");
		return -1;
    }

	fprintf(fp,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
		       "<SMXF_Part xmlns=\"urn:mpeg:mpeg-4:schema:smr:smxf-part:2007\">");
	Spartito* spa=(Spartito*)listaSpa->AtPos(pos-1);

	if(spa)
		rc=spa->SaveXML(fp,NULL);

	fclose(fp);
	
	return rc;
}

int ListaParentesi::SaveXML(FILE *fp)
{
	// Salvataggio lista delle parentesi
	Node *current, *next;
	Parentesi *PPtr, *next_PPtr;
	int rc;
	
	//printf("Sto salvando la lista delle parentesi\n");
	
	current = first;
	if(current)
		next = GetNext(current);
	else
		next = NULL;
	
	rc = 1; 
	while(rc && current)
	{
		PPtr = (Parentesi *)current->ObjectPtr;
		if(next)
			next_PPtr = (Parentesi*) next->ObjectPtr;		
		
		rc = PPtr->SaveXML(fp);		
		current = next;
		if(current)
			next = GetNext(current);
	}
	return rc;
}

int ParQuadra::SaveXML(FILE *fp)
{
	int rc=0;

	if(GetPSpaStart() && GetPSpaEnd())
		rc=fprintf(fp, "<bracket ID=\"%d\" TYPE=\"BRACKET\" STARTPARTID=\"%d\" ENDPARTID=\"%d\"/>", GetNumericCode(), GetPSpaStart()->GetNumericCode(), GetPSpaEnd()->GetNumericCode());
	
	return rc;
}

int ParGraffa::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<bracket ID=\"%d\" TYPE=\"BRACE\" STARTPARTID=\"%d\" ENDPARTID=\"%d\"/>", GetNumericCode(), GetPSpaStart()->GetNumericCode(), GetPSpaEnd()->GetNumericCode());
	return rc;
}

int ListaSpartiti::SaveXML(FILE *fp,char *fileName, char *Path)
{
	Node *current, *next;
	Spartito *SPtr, *next_SPtr;
	char *Name = new char[90];
	int rc=1;
	FILE *fpnew;
	
	current = first;
	if(current)
		next = GetNext(current);
	else
		next = NULL;
	
	while(rc >= 0 && current)
	{
		SPtr = (Spartito*) current->ObjectPtr;
		if(next)
			next_SPtr = (Spartito*) next->ObjectPtr;		
		sprintf(Name, "%d.%s",SPtr->GetNumericCode(),fileName);
		
		char *dirx;
		dirx = new char[256];
		strcpy (dirx, smrgetenv("SMR_FILES_PATH"));
		strcat(dirx,Path);
		char *filenameres;
		filenameres = new char[256];
		
		filenameres = strcat(dirx,Name);
		filenameres = strcat(dirx,".xml");
		
		fpnew = fopen(filenameres, "w");
		rc = SPtr->SaveXML(fpnew);
		fclose(fpnew);
		
		current = next;
		if(current)
			next = GetNext(current);
	}
	return rc;
}

int Spartito::SaveXML(FILE *fp, char* lyrFileName)
{
	int rc=0;
	
	char numberofstaff[100]="";
    if(GetNumberOfStaff()!=1)
		sprintf(numberofstaff," NUMBEROFSTAFFS=\"%d\"",GetNumberOfStaff());

	char tablaturesize[100]="";
	char tab[100]="";
	for(int i=0;i<NumberOfStaff;i++)
	{
		if(NCorde[i]!=5)	// DB
		{
			sprintf(tab," TABLATURESIZE%d=\"%d\"",i+1,GetNCorde(i));
			strcat(tablaturesize,tab);
		}
	}

	char lyric[100]="";
	if(currentLyrItem!=NULL)
		sprintf(lyric," LYRIC=\"%s\"",currentLyrItem->GetID().c_str());

	char transp[100]="";
	if(GetTranspose()!=0)
		sprintf(transp," TRANSPOSE=\"%d\"", GetTranspose());

	char save_size[100]="";
	if(IsSmallSize())
		sprintf(save_size," SIZE=\"SMALL\"");

	char save_shortname[100]="";
	if(strlen(GetShortInstrName())>0)
		sprintf(save_shortname," SHORTINSTRNAME=\"%s\"",XMLFormatString(GetShortInstrName()).c_str());

	if(rc>=0) rc=fprintf(fp, "<score ID=\"%d\" TYPE=\"NORMAL\" INSTRUMENT=\"%s\"%s%s%s%s%s%s>",GetNumericCode(),XMLFormatString(GetStrumEsec()).c_str(),save_shortname,numberofstaff,tablaturesize,lyric,transp,save_size);
	
	if(rc>=0) rc=fprintf(fp, "<origin FROM=\"WEDELED\"/>");

	if(rc>=0) rc=fprintf(fp, "<midiinfo CODE=\"%d\" VOLUME=\"%d\" CHANNEL=\"%d\"/>",
		midiAttrib.Get_MidiCode(),
		midiAttrib.Get_Volume(),
		midiAttrib.Get_Channel());

	PrintParams *cv=GetComputerViewParams(); 
	PrintParams *pv=GetPrintViewParams();

	if (rc>0 && cv!=NULL)
	{
		cv->SaveComputerViewXML(fp);
	}

	if(rc>=0 && pv!=NULL)
	{
		pv->SavePrintViewXML(fp,false); // false=!isMainScore
	}
	
    if(rc>=0) rc=listaBat.SaveXML(fp);

	if (rc >= 0) rc = listaInt.SaveXML(fp);
	
	if(rc>=0) rc=fprintf(fp, "</score>");
	
	if(rc>0) rc=listaPag.SaveXML(fp);
#ifdef SWF
	if(rc>=0) rc=fprintf(fp, "</%s>", ELSWF_Part);
#else
	if(rc>=0) rc=fprintf(fp, "</SMXF_Part>");
#endif

	if(listaSil.GetNumObj()!=0 && currentLyrItem!=NULL)
	{
		if(currentLyrItem->GetPartID()==0)
			currentLyrItem->SetPartID(GetNumericCode());

		listaSil.SalvaLyr(currentLyrItem,lyrFileName);
	}
	
	return rc;
}

int ListaBattute::SaveXML(FILE *fp)
{
	Node *current, *next;
	Battuta *BPtr, *next_BPtr;
	int rc = 0;
	
	current = first;
	if(current)
		next = GetNext(current);
	else
		next = NULL;
	
	while(rc >= 0 && current)
    {
		BPtr = (Battuta*) current->ObjectPtr;
		if(next)
			next_BPtr = (Battuta*) next->ObjectPtr;
		
		
		rc = BPtr->SaveXML(fp);
		
		current = next;
		if(current)
			next = GetNext(current);
    }
	
	return rc;
}

int Battuta::SaveXML(FILE *fp)
{
	int rc;
	char numberofstaff[100]="";
	if(GetNumberOfStaff()!=1)
		sprintf(numberofstaff," NUMBEROFSTAFFS=\"%d\"", GetNumberOfStaff());

	rc=fprintf(fp, "<measure PROGRESSIVE=\"%d\" ID=\"%d\"%s>",GetNumProgress(), GetNumericCode(), numberofstaff);
	if(rc>=0) rc=fprintf(fp, "<justification ", ELmeasurejustification);
	if(Gettipogiust(COMPUTER_VIEW)!=G_NONE)
	{
		if(rc>=0) rc=fprintf(fp, "MAINTYPE=\"%s\" MAINJUST=\"%f\" ", Gettipogiust(COMPUTER_VIEW)==G_LIN?"LINEAR":"LOG", Getkgiustificazione(COMPUTER_VIEW));
	}
	if(Gettipogiustparte(COMPUTER_VIEW)!=G_NONE)
	{
		if(rc>=0) rc=fprintf(fp, "PARTTYPE=\"%s\" PARTJUST=\"%f\" ", Gettipogiustparte(COMPUTER_VIEW)==G_LIN?"LINEAR":"LOG", Getkgiustificazioneparte(COMPUTER_VIEW));
	}
	if(Gettipogiust(PRINT_VIEW)!=G_NONE)
	{
		if(rc>=0) rc=fprintf(fp, "PMAINTYPE=\"%s\" PMAINJUST=\"%f\" ", Gettipogiust(PRINT_VIEW)==G_LIN?"LINEAR":"LOG", Getkgiustificazione(PRINT_VIEW));
	}
	if(Gettipogiustparte(PRINT_VIEW)!=G_NONE)
	{
		if(rc>=0) rc=fprintf(fp, "PPARTTYPE=\"%s\" PPARTJUST=\"%f\" ", Gettipogiustparte(PRINT_VIEW)==G_LIN?"LINEAR":"LOG", Getkgiustificazioneparte(PRINT_VIEW));
	}
	if(GetMainScoreLineBreak(COMPUTER_VIEW))
	{
		if(rc>=0) rc=fprintf(fp, "MAINLINEBREAK=\"true\" ");
	}
	if(GetMainScoreLineBreak(PRINT_VIEW))
	{
		if(rc>=0) rc=fprintf(fp, "PMAINLINEBREAK=\"true\" ");
	}
	if(GetPartLineBreak(COMPUTER_VIEW))
	{
		if(rc>=0) rc=fprintf(fp, "PARTLINEBREAK=\"true\" ");
	}
	if(GetPartLineBreak(PRINT_VIEW))
	{
		if(rc>=0) rc=fprintf(fp, "PPARTLINEBREAK=\"true\" ");
	}
	if(rc>=0) rc=fprintf(fp, "/>");

	if(ptrRiferimento)
		if(rc>=0) rc=ptrRiferimento->SaveXML(fp);

	if(ptrLettera)
		if(rc>=0) rc=ptrLettera->SaveXML(fp);
				
	if(ptrTSalto)
		if(rc>=0) rc=ptrTSalto->SaveXML(fp);
	//Salvo l'intestazione
	for(int i=0; i<this->GetNumberOfStaff(); i++)
	{
		Intestazione *curr_Intest=GetIntest(i);
		if(rc>=0) rc = curr_Intest->SaveXML(fp);
	}
	if(rc>=0) rc = GetTempo().SaveXML(fp,GetIntest()->GetTimeSignatureStatus());
	if(ptrScansione)
		if(rc>=0) rc=ptrScansione->SaveXML(fp);
		
		/*	(FF) TO DO			
		<numgrande/>
		*/					
	if(ptrMovimento)
		if(rc>=0) rc=ptrMovimento->SaveXML(fp);
						
	for(int l=0; l<NUM_MAX_LAYER; l++)
	{
		if(LayerVector[l]==NULL)
			continue;

		if(rc>=0) rc=fprintf(fp, "<%s %s=\"%d\">", ELlayer, ATNUMBER,l+1);

		if(GetDirSp2FirstFigUt(l,COMPUTER_VIEW)!=0 || GetOrcSp2FirstFigUt(l,COMPUTER_VIEW)!=0 ||
			GetDirSp2FirstFigUt(l,PRINT_VIEW)!=0 || GetOrcSp2FirstFigUt(l,PRINT_VIEW)!=0)
		{
			if(rc>=0) fprintf(fp,"<userspacing ");
			if(rc>=0 && GetDirSp2FirstFigUt(l,COMPUTER_VIEW)!=0)
				fprintf(fp,"SPACEMAIN=\"%d\" ",GetDirSp2FirstFigUt(l,COMPUTER_VIEW));
			if(rc>=0 && GetOrcSp2FirstFigUt(l,COMPUTER_VIEW)!=0)
				fprintf(fp,"SPACEPART=\"%d\" ",GetOrcSp2FirstFigUt(l,COMPUTER_VIEW));
			if(rc>=0 && GetDirSp2FirstFigUt(l,PRINT_VIEW)!=0)
				fprintf(fp,"SPACEPMAIN=\"%d\" ",GetDirSp2FirstFigUt(l,PRINT_VIEW));
			if(rc>=0 && GetOrcSp2FirstFigUt(l,PRINT_VIEW)!=0)
				fprintf(fp,"SPACEPPART=\"%d\" ",GetOrcSp2FirstFigUt(l,PRINT_VIEW));
			if(rc>=0) fprintf(fp,"/>");
		}

		if(rc >= 0)
			rc=LayerVector[l]->SaveXML(fp);
		if(rc>=0) rc=fprintf(fp, "</%s>", ELlayer);
	}
	if(rc>=0) rc=ptrBarra->SaveXML(fp);
						
	if(rc>=0) rc=fprintf(fp, "</%s>", ELmeasure);
						
	return rc;
}

int ListaFigure::SaveXML(FILE *fp)
{
	Figura *current;
	
	int rc;
	
	current = GetFirstF(); 
	
	rc = 0;
	while(rc >= 0 && current)
	{
		
		switch(current->GetID())
		{
		case CL_ACCORDO: 
			rc = ((Accordo *)(current))->SaveXML(fp, current);
			break;
		case CL_GRUPPONOTE:
			rc = current->SaveXML(fp);
			break;
		default:
			rc = current->SaveXML(fp);     
		}
		current = GetNextF(current);
	}
	return rc;
}

// **************** Intestazione: chiavi, armature e tempi ****************

int Intestazione::SaveXML(FILE *fp)
{
	Chiave *CPtr;
	ArmaturaChiave AC;
	int rc;
	
	CPtr = GetChiave();
	AC = GetArmatura();
	
	rc=fprintf(fp,"<header>");
	if(rc>=0) rc=CPtr->SaveXML(fp);
	if(rc>=0) rc=AC.SaveXML(fp);
	if(rc>=0) rc=fprintf(fp,"</header>");
	return rc;
}


int CViolino::SaveXML(FILE *fp)
{
	if(GetNumericCode()==0)
		return fprintf(fp, "<clef TYPE=\"TREBLE\"%s/>", GetChiavina()?" SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"TREBLE\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CBasso::SaveXML(FILE *fp)
{
	if(GetNumericCode()==0)
		return fprintf(fp, "<clef TYPE=\"BASS\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"BASS\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CBaritono::SaveXML(FILE *fp)
{
	if(GetNumericCode()==0)
		return fprintf(fp, "<clef TYPE=\"BARITONE\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"BARITONE\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CTenore::SaveXML(FILE *fp)
{
	if(GetNumericCode()==0)
		return fprintf(fp, "<clef TYPE=\"TENOR\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"TENOR\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CContralto::SaveXML(FILE *fp)
{
	if(GetNumericCode()==0)
		return fprintf(fp, "<clef TYPE=\"ALTO\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"ALTO\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CMezzoSoprano::SaveXML(FILE *fp)
{
	if(GetNumericCode()==0)
		return fprintf(fp, "<clef TYPE=\"MEZZOSOPRANO\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"MEZZOSOPRANO\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CSoprano::SaveXML(FILE *fp)
{
	if(GetNumericCode()==0)
		return fprintf(fp, "<clef TYPE=\"SOPRANO\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"SOPRANO\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CViolino8::SaveXML(FILE *fp)
{
	if(GetNumericCode()==0)
		return fprintf(fp, "<clef TYPE=\"TREBLE8\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"TREBLE8\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CBasso8::SaveXML(FILE * fp)
{
	if(GetNumericCode()==0)	
		return fprintf(fp, "<clef TYPE=\"BASS8\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"BASS8\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CViolino8Sopra::SaveXML(FILE *fp)
{
	if(GetNumericCode()==0)
		return fprintf(fp, "<clef TYPE=\"8TREBLE\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"8TREBLE\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CTenore8::SaveXML(FILE *fp)
{
	if(GetNumericCode()==0)
		return fprintf(fp, "<clef TYPE=\"TENOR8\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"TENOR8\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CBasso8Sopra::SaveXML(FILE * fp)
{
	if(GetNumericCode()==0)	
		return fprintf(fp, "<clef TYPE=\"8BASS\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"8BASS\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CBassoOld::SaveXML(FILE * fp)
{
	if(GetNumericCode()==0)	
		return fprintf(fp, "<clef TYPE=\"BASSOLD\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"BASSOLD\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CVuota::SaveXML(FILE * fp)
{
	if(GetNumericCode()==0)	
		return fprintf(fp, "<clef TYPE=\"EMPTY\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"EMPTY\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CTab::SaveXML(FILE * fp)
{
	if(GetNumericCode()==0)	
		return fprintf(fp, "<clef TYPE=\"TAB\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"TAB\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CPercusBox::SaveXML(FILE * fp)
{
	if(GetNumericCode()==0)	
		return fprintf(fp, "<clef TYPE=\"PERCUSBOX\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"PERCUSBOX\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int CPercus2Lines::SaveXML(FILE * fp)
{
	if(GetNumericCode()==0)	
		return fprintf(fp, "<clef TYPE=\"PERCUS2LINES\"%s/>", GetChiavina()?"SIZE=\"SMALL\"" :"");
	return fprintf(fp, "<changeclef ID=\"%d\" TYPE=\"PERCUS2LINES\" SIZE=\"%s\" STAFF=\"%d\"/>", GetNumericCode(), GetChiavina()?"SMALL" :"NORMAL", GetNStaff());
}

int ArmaturaChiave::SaveXML(FILE *fp)
{
	char* type="";
	
	switch(GetArmatura())
	{
	case DO_maggiore:
		type="DOM";
		break;
	case SOL_maggiore:    
		type="SOLM";
		break;
	case RE_maggiore:
		type="REM";
		break;
	case LA_maggiore:
		type="LAM";
		break;
	case MI_maggiore:
		type="MIM";
		break;
	case SI_maggiore:
		type="SIM";
		break;
	case FAd_maggiore:
		type="FAdM";
		break;
	case DOd_maggiore:
		type="DOdM";
		break;
	case FA_maggiore:
		type="FAM";
		break;
	case SIb_maggiore:
		type="SIbM";
		break;
	case MIb_maggiore:
		type="MIbM";
		break;
	case LAb_maggiore:
		type="LAbM";
		break;
	case REb_maggiore:
		type="REbM";
		break;
	case SOLb_maggiore:
		type="SOLbM";
		break;
	case DOb_maggiore:
		type="DObM";
		break;	

	case DO_minore:
		type="DOm";
		break;
	case SOL_minore:    
		type="SOLm";
		break;
	case RE_minore:
		type="REm";
		break;
	case LA_minore:
		type="LAm";
		break;
	case MI_minore:
		type="MIm";
		break;
	case SI_minore:
		type="SIm";
		break;
	case FAd_minore:
		type="FAdm";
		break;
	case DOd_minore:
		type="DOdm";
		break;
	case FA_minore:
		type="FAm";
		break;
	case SIb_minore:
		type="SIbm";
		break;
	case MIb_minore:
		type="MIbm";
		break;
	case LAd_minore:
		type="LAdm";
		break;
	case REd_minore:
		type="REdm";
		break;
	case SOLd_minore:
		type="SOLdm";
		break;
	case LAb_minore:
		type="LAbm";
		break;
	}
	if(GetNumericCode()==0)
		fprintf(fp, "<keysignature TYPE=\"%s\"/>",type);
	else
		fprintf(fp, "<changekeysignature ID=\"%d\" TYPE=\"%s\" STAFF=\"%d\"/>",GetNumericCode(), type, GetNStaff());
	return 0;
}

int Tempo::SaveXML(FILE *fp, TimeSignatureStatus status)
{
	int rc;
	char stat[40]="";
	switch(status)
	{
	case TimeSignature_NORMAL:
		break;
	case TimeSignature_HIDDEN:
		sprintf(stat,"STATUS=\"HIDDEN\" ");
		break;
	case TimeSignature_ALWAYSVISIBLE:
		sprintf(stat,"STATUS=\"ALWAYSVISIBLE\" ");
		break;
	}
	
	if(LetteraC)
    {
		if(Numeratore.GetNumero() == 4)
			rc=fprintf(fp, "<timesignature TYPE=\"C\" %s/>",stat);
		else
			rc=fprintf(fp, "<timesignature TYPE=\"CSLASH\" %s/>",stat);
    }
	else
	{
		char num[MAXCARATTERINUMERO];
		char den[MAXCARATTERINUMERO];

		strncpy(num,(char*)Numeratore.GetTxt(),MAXCARATTERINUMERO);
		strncpy(den,(char*)Denominatore.GetTxt(),MAXCARATTERINUMERO);

		int nr=strreplace(num,'','+');
		nr+=strreplace(den,'','+');

		if(nr==0)
			rc=fprintf(fp, "<timesignature TYPE=\"FRACTION\" NUMERATOR=\"%s\" DENOMINATOR=\"%s\" %s/>",num, den, stat);
		else
			rc=fprintf(fp, "<timesignature TYPE=\"FRACTION\" NUMERATOR=\"%s\" DENOMINATOR=\"%s\" TIMENUMERATOR=\"%d\" TIMEDENOMINATOR=\"%d\" %s/>",num, den, Numeratore.GetNumero(), Denominatore.GetNumero(), stat);
	}
	return rc;
}


// **************** Barre ****************

int Barra::SaveXML(FILE *fp)
{
	return fprintf(fp,"<barline TYPE=\"%s\"/>",SaveXML());
}

char *BSingola::SaveXML()
{
	return "SINGLE";
}

int BSingola::SaveXML(FILE *fp)
{
	char *ltype="";

	switch(GetLineType())
	{
	case SOLID_LINE:
		//ltype=" LINETYPE=\"SOLID\"";
		break;
	case DOTTED_LINE:
		ltype=" LINETYPE=\"DOT\"";
		break;
	case DASHED_LINE:
		ltype=" LINETYPE=\"DASH\"";
		break;
	}
	return fprintf(fp,"<barline TYPE=\"SINGLE\"%s%s/>", ltype, RepeatDoubleMeasure ? " REPEAT=\"true\"":"");
}

char *BDoppia::SaveXML()
{
	return "DOUBLE";
}

char *BInizioRit::SaveXML()
{
	return "START_REFRAIN";
}

char *BFineRit::SaveXML()
{
	return "END_REFRAIN";
}

char *BFinale::SaveXML()
{
	return "END"; 
}

char *BInizioFine::SaveXML()
{
	return "START_END_REFRAIN"; 
}

char *BInvisibile::SaveXML()
{
	return "INVISIBLE";
}

// **************** Figure: note, pause, gruppi, spazi ****************

int Figura::SaveXML(FILE * fp)
{
	
	Strumento *StrPtr;
	Corona *CoPtr;
	PuntoValore *PVPtr;
	TDinamico *TDPtr;
	TGenerico *TGenPtr;
	Annotazione *AnnPtr;
	Occhiali *OccPtr;
	DitaCorde *DitPtr;
	int rc=0;
	
	PVPtr = GetPPuntoValore();
	if(PVPtr)
		if(rc>=0) rc=PVPtr->SaveXML(fp);

	StrPtr = GetPStrumento();
	if(StrPtr)
		if(rc>=0) rc=StrPtr->SaveXML(fp);
		
	CoPtr = GetPCorona();
	if(CoPtr)
		if(rc>=0) rc=CoPtr->SaveXML(fp);
							
	TDPtr = GetPTDinamico();
	if(TDPtr)
		if(rc>=0) rc=TDPtr->SaveXML(fp);

	TGenPtr = GetPTGenerico();
	if(TGenPtr)
		if(rc>=0) rc=TGenPtr->SaveXML(fp);
						
	AnnPtr = GetPAnnotazione();
	if(AnnPtr)
		if(rc>=0) rc=AnnPtr->SaveXML(fp);
							
	OccPtr = GetPOcchiali();
	if(OccPtr)
		if(rc>=0) rc=OccPtr->SaveXML(fp);
								
	DitPtr = GetPDitaCorde();
	if(DitPtr)
		if(rc>=0) rc=DitPtr->SaveXML(fp);
									
	return rc;
}


int Figura::SaveXMLGiust(FILE *fp)
{
	int rc=0;

	if(GetSpDirUt(COMPUTER_VIEW)!=0 || GetSpOrcUt(COMPUTER_VIEW)!=0 ||
	   GetSpDirUt(PRINT_VIEW)!=0 || GetSpOrcUt(PRINT_VIEW)!=0)
	{
		rc=fprintf(fp,"<userspacing");
		if(rc>=0 && GetSpDirUt(COMPUTER_VIEW)!=0) rc=fprintf(fp, " SPACEMAIN=\"%d\"", GetSpDirUt(COMPUTER_VIEW));
		if(rc>=0 && GetSpOrcUt(COMPUTER_VIEW)!=0) rc=fprintf(fp, " SPACEPART=\"%d\"", GetSpOrcUt(COMPUTER_VIEW));
		if(rc>=0 && GetSpDirUt(PRINT_VIEW)!=0) rc=fprintf(fp, " SPACEPMAIN=\"%d\"", GetSpDirUt(PRINT_VIEW));
		if(rc>=0 && GetSpOrcUt(PRINT_VIEW)!=0) rc=fprintf(fp, " SPACEPPART=\"%d\"", GetSpOrcUt(PRINT_VIEW));
		if(rc>=0) rc=fprintf(fp,"/>");
	}
	return rc;
}



int GruppoNote::SaveXML(FILE *fp)
{
	Figura *current, *next, *last;
	int rc;
	char *stems="";

	current = GetFirstNota();
	if(current)
		next = GetNextF(current);
	else
		next = NULL;
	
	last = GetLastNota();
	switch(beamPos)
	{
	case BEAM_UP:
		stems="UP";
		break;
	case BEAM_DWN:
		stems="DOWN";
		break;
	case BEAM_12:
		stems="STAFF12";
		break;
	case BEAM_23:
		stems="STAFF23";
		break;
	}
	
	char *sstatus="";
	switch(status)
	{
	case NORMAL:
		//sstatus="NORMAL";
		break;
	case GRACED:
		sstatus="STATUS=\"GRACED\"";
		break;
	case HIDDEN:
		sstatus="STATUS=\"HIDDEN\"";
		break;
	case GHOSTED:
		sstatus="STATUS=\"GHOSTED\"";
		break;
	}

	rc=fprintf(fp, "<beam ID=\"%d\" STEMS=\"%s\" %s>",GetNumericCode(), stems, sstatus);
	
	while(current)
    {
		//if(rc >= 0) rc = current->SaveXML(fp);     
		switch(current->GetID())
		{
		case CL_ACCORDO: 
			if(rc>0) rc = ((Accordo *)(current))->SaveXML(fp, current);
			break;
		default:
			if(rc>=0) rc=current->SaveXML(fp);
			break;
		}
		current = next;
		if(current)
			next = GetNextF(current);
    }
	if(rc >= 0) rc = fprintf(fp, "</beam>");
	return rc;
}

int Accordo::SaveXML(FILE *fp, Figura *principale)
{ 
	TipoPitch			*pPitch;
	Figura *current, *next; //, *principale;
	VUnit LGambo;
	ClassID tipoaccordo;
	Abbellimento *AbPtr;
	KoreanOrnament *KoPtr;
	EspressComposta *EsCPtr;
	Sordina *SordPtr;
	Strumento *StrPtr;
	Corona *CoPtr;
	PuntoValore *PVPtr;
	Annotazione *AnnPtr;
	TDinamico *TDPtr;
	TGenerico *TGenPtr;
	Occhiali *OccPtr;
	Armonici *ArmPtr;
	AlterazComposta *AltComp;
	Suddivisione *suddiv;
	Diteggiato *diteg;
	char desc[256]=""; 
	char head[256]="";
	char headcode[256]="";
	char stem[256]="";
	char acciacc[256]="";
	char ditegg[256]="";
	int rc=0;
	
	current = GetFirstF();
	if(current)
		next = GetNextF(current);
	else
		next = NULL;
	
	tipoaccordo = GetNoteID();
	switch(tipoaccordo)
    {
	case CL_NBREVE:
		strcpy(desc, "D2" );
		break;
		
	case CL_NSEMIBREVE:
		strcpy(desc, "D1");
		break;
		
	case CL_NMINIMA:
		strcpy(desc, "D1_2");
		break;
		
	case CL_NSEMIMINIMA:
		strcpy(desc, "D1_4");
		break;
		
	case CL_NCROMA:
		strcpy(desc, "D1_8");
		break;
		
	case CL_NSEMICROMA:
		strcpy(desc, "D1_16");
		break;
		
	case CL_NBISCROMA:
		strcpy(desc, "D1_32");
		break;
		
	case CL_NSEMIBISCROMA:
		strcpy(desc, "D1_64");
		break;
		
	case CL_NFUSA:
		strcpy(desc, "D1_128");
		break;
	}

	if(GetParentFig()==NULL) //accordo non in gruppo note
	{
		LGambo = GetLGambo();
		if(LGambo != 0)        // La semibreve non ha gambo
		{
			if(LGambo > 0)
				strcpy(stem, " STEM=\"UP\"");
			else
				strcpy(stem, " STEM=\"DOWN\"");
		}
	}

	if(current!=NULL && current->GetID()==CL_NCROMA && ((NCroma *)current)->GetAcciaccatura())
		strcpy(acciacc," ACCIACCATURA=\"true\"");
	else
		strcpy(acciacc,"");

	//se almeno una nota dell'accordo ha un diteggiato salva l'attributo FINGERING
	strcpy(ditegg,"");
	while(current!=NULL)
	{
		if(((Nota*)current)->GetPDiteggiato()!=NULL)
		{
			sprintf(ditegg," FINGERING=\"%s\"",GetDiteggiatoUp()? "UP": "DOWN");
			break;
		}
		current=GetNextF(current);
	}

	char *sstatus="";
	switch(status)
	{
	case NORMAL:
		//sstatus=" STATUS=\"NORMAL\"";
		break;
	case GRACED:
		sstatus=" STATUS=\"GRACED\"";
		break;
	case HIDDEN:
		sstatus=" STATUS=\"HIDDEN\"";
		break;
	case GHOSTED:
		sstatus=" STATUS=\"GHOSTED\"";
		break;
	}
	

	Set_Link(CheckLink(oldCidMap,Get_Link()));
	wxString slink=Get_Link();
	if(slink!="")
	{
		slink=" LINK=\""+XMLFormatString(slink)+"\"";
	}
	
	if(rc>=0) rc=fprintf(fp, "<chord ID=\"%d\" DURATION=\"%s\"%s%s%s%s%s%s>",
		GetNumericCode(), desc, GetNotina()? " SIZE=\"SMALL\"" : "", stem, sstatus, ditegg, acciacc,slink.c_str());

	current = GetFirstF();
	if(current)
		next = GetNextF(current);
	else
		next = NULL;

	while(current)
    {
		switch(((Nota*)current)->GetHeadType())
		{
		case HEAD_CLASSIC:
			strcpy(head, "");
			//strcpy(head, " HEAD=\"CLASSIC\"");
			break;
		case HEAD_ALPHANUM:
			strcpy(head, " HEAD=\"ALPHANUM\"");
			break;
		case HEAD_ALPHANUM_SQUARE:
			strcpy(head, " HEAD=\"ALPHANUM_SQUARE\"");
			break;
		case HEAD_ALPHANUM_REVERSE:
			strcpy(head, " HEAD=\"ALPHANUM_REVERSE\"");
			break;
		case HEAD_CIRCLEX:
			strcpy(head, " HEAD=\"CIRCLEX\"");
			break;
		case HEAD_X:
			strcpy(head, " HEAD=\"X\"");
			break;
		case HEAD_CROIX:
			strcpy(head, " HEAD=\"CROIX\"");
			break;
		case HEAD_DDIESIS:
			strcpy(head, " HEAD=\"DSHARP\"");
			break;
		case HEAD_DIAMOND:
			strcpy(head, " HEAD=\"DIAMOND\"");
			break;
		case HEAD_TRIANG:
			strcpy(head, " HEAD=\"TRIANG\"");
			break;
		case HEAD_TRIANG_UP:
			strcpy(head, " HEAD=\"UPTRIANG\"");
			break;
		case HEAD_TRIANG_DOWN:
			strcpy(head, " HEAD=\"DOWNTRIANG\"");
			break;
		case HEAD_TRIANG_LEFT:
			strcpy(head, " HEAD=\"LEFTTRIANG\"");
			break;
		case HEAD_TRIANG_RIGHT:
			strcpy(head, " HEAD=\"RIGHTTRIANG\"");
			break;
		case HEAD_TRIANG_ROUND:
			strcpy(head, " HEAD=\"TRIANGROUND\"");
			break;
		case HEAD_MOON:
			strcpy(head, " HEAD=\"MOON\"");
			break;
		case HEAD_PLUS:
			strcpy(head, " HEAD=\"PLUS\"");
			break;
		case HEAD_RHYTHMIC:
			strcpy(head, " HEAD=\"RHYTHMIC\"");
			break;
		case HEAD_SQUARE:
			strcpy(head, " HEAD=\"SQUARE\"");
		}
		switch(((Nota*)current)->GetHeadType())
		{
		case HEAD_ALPHANUM:
		case HEAD_ALPHANUM_SQUARE:
		case HEAD_ALPHANUM_REVERSE:
			sprintf(headcode, " HEAD_ALPHANUM=\"%s\"",XMLFormatString(((Nota*)current)->GetHeadCode()).c_str());
			break;
		}

		char sstaff[20]="";
		if(GetPBattuta()==NULL || GetPBattuta()->GetNumberOfStaff()>1)
			sprintf(sstaff," STAFF=\"%d\"",current->GetNStaff());

		Colore col = current->GetColor();
		char scolor[20]="";
#ifdef SAVE_COLOR
		if(col.GetCode()!="000000")
			sprintf(scolor," COLOR=\"#%s\" ", col.GetCode().c_str());
#endif
		
		if(rc>=0) rc=fprintf(fp, "<chordnote ID=\"%d\"%s%s HEIGHT=\"%d\"%s%s>", current->GetNumericCode(), head, headcode, current->GetAltezza(), sstaff, scolor);
		
		pPitch = ((Nota*)current)->GetPitch();
		if(pPitch){
			if(rc>=0)
				rc=fprintf(fp,"<pitch ");
			if(rc>=0){
				if(pPitch->Accidental == 1)
					rc=fprintf(fp,"BASE=\"%c\" SHIFT=\"#\" OCTAVE=\"%d\" ", NoteChars[pPitch->Letter], pPitch->Octave);
				else if(pPitch->Accidental == -1)
					rc=fprintf(fp,"BASE=\"%c\" SHIFT=\"b\" OCTAVE=\"%d\" ", NoteChars[pPitch->Letter], pPitch->Octave);
				else
					rc=fprintf(fp,"BASE=\"%c\" OCTAVE=\"%d\" ", NoteChars[pPitch->Letter], pPitch->Octave);
			}	
			if(rc>=0)
				rc=fprintf(fp,"/>");
		}

		if(AltComp=((Nota *)(current))->GetPAlterazComposta())
			rc=AltComp->SaveXML(fp);
		if(diteg=((Nota *)(current))->GetPDiteggiato())
			rc=diteg->SaveXML(fp);
		if(rc>=0) rc=fprintf(fp, "</chordnote>");
		current = next;
		if(current)
			next = GetNextF(current);
    }

	if(GetPArpeggio())
		if(rc>=0) rc=	(GetPArpeggio())->SaveXML(fp);

	current = GetFirstF();
	PVPtr = current->GetPPuntoValore();
	if(PVPtr)
		if(rc>=0) rc=PVPtr->SaveXML(fp);

	AbPtr = ((Accordo *)(principale))->GetPAbbellimento();
	if(AbPtr)
		if(rc>=0) rc=AbPtr->SaveXML(fp);
	KoPtr = ((Accordo *)(principale))->GetPKoreanOrnament();
	if(KoPtr)
		if(rc>=0) rc=KoPtr->SaveXML(fp);
	suddiv=GetPSuddivisione();
	if(suddiv)
		if(rc>=0) rc=suddiv->SaveXML(fp);

	EsCPtr = GetPEspressComposta();
	if(EsCPtr)
		if(rc>=0) rc=EsCPtr->SaveXML(fp);

	SordPtr = GetPSordina();
	if(SordPtr)
		if(rc>=0) rc=SordPtr->SaveXML(fp);
	ArmPtr = GetPArmonici();
	if(ArmPtr)
		if(rc>=0) rc=ArmPtr->SaveXML(fp);

	StrPtr = GetPStrumento();
	if(StrPtr)
		if(rc>=0) rc=StrPtr->SaveXML(fp);
	CoPtr = GetPCorona();
	if(CoPtr)
		if(rc>=0) rc=CoPtr->SaveXML(fp);
	TDPtr = GetPTDinamico();
	if(TDPtr)
		if(rc>=0) rc=TDPtr->SaveXML(fp);
	TGenPtr = GetPTGenerico();
	if(TGenPtr)
		if(rc>=0) rc=TGenPtr->SaveXML(fp);
	AnnPtr = GetPAnnotazione();
	if(AnnPtr)
		if(rc>=0) rc=AnnPtr->SaveXML(fp);
	OccPtr = GetPOcchiali();
	if(OccPtr)
		if(rc>=0) rc=OccPtr->SaveXML(fp);

	if(rc>=0) rc=SaveXMLGiust(fp);

	if(rc>=0) rc=fprintf(fp, "</chord>");
	return rc;
}

int Nota::SaveXML(FILE *fp)
{
	// ------------- Variabili di contesto richieste -------------
	// 
	// -----------------------------------------------------------
	TipoPitch			*pPitch;
	AlterazComposta		*ACPtr;
	Diteggiato			*DiPtr;
	Abbellimento		*AbPtr;
	KoreanOrnament		*KoPtr;
	Suddivisione		*SudPtr;
	EspressComposta		*EsCPtr;
	Sordina				*SordPtr;
	Armonici			*ArmoniciPtr;
	int rc=0;
	
	VUnit LGambo;
	
	if(GetParentFig()==NULL) // nota semplice non in un gruppo
	{
		LGambo = GetLGambo();
		if(LGambo != 0)        // La semibreve non ha gambo
			rc=fprintf(fp,"STEM=\"%s\" ", LGambo>0 ? "UP":"DOWN");
	}
			
	if(rc>=0) rc=fprintf(fp,"HEIGHT=\"%d\" ", GetAltezza());
	if(GetPBattuta() ==NULL || GetPBattuta()->GetNumberOfStaff()>1)
		if(rc>=0) rc=fprintf(fp,"STAFF=\"%d\" ", GetNStaff());			
			
	if(GetNotina())
	{
		if(rc>=0) 
			rc=fprintf(fp,"SIZE=\"SMALL\" ");
		if(GetID()==CL_NCROMA && ((NCroma *)this)->GetAcciaccatura())
		{
			if(rc>=0) 
				rc=fprintf(fp,"ACCIACCATURA=\"true\" ");
		}
	}
				
    switch(HeadType)
    {
	case HEAD_CLASSIC:
		// rc=fprintf(fp, "HEAD=\"CLASSIC\" ");
		break;
	case HEAD_ALPHANUM:
		rc=fprintf(fp, "HEAD=\"ALPHANUM\" ");
		break;
	case HEAD_ALPHANUM_SQUARE:
		rc=fprintf(fp, "HEAD=\"ALPHANUM_SQUARE\" ");
		break;
	case HEAD_ALPHANUM_REVERSE:
		rc=fprintf(fp, "HEAD=\"ALPHANUM_REVERSE\" ");
		break;
	case HEAD_CIRCLEX:
		rc=fprintf(fp, "HEAD=\"CIRCLEX\" ");
		break;
	case HEAD_X:
		rc=fprintf(fp, "HEAD=\"X\" ");
		break;
	case HEAD_CROIX:
		rc=fprintf(fp, "HEAD=\"CROIX\" ");
		break;
	case HEAD_DDIESIS:
		rc=fprintf(fp, "HEAD=\"DSHARP\" ");
		break;
	case HEAD_DIAMOND:
		rc=fprintf(fp, "HEAD=\"DIAMOND\" ");
		break;
	case HEAD_TRIANG:
		rc=fprintf(fp, "HEAD=\"TRIANG\" ");
		break;
	case HEAD_TRIANG_UP:
		rc=fprintf(fp, "HEAD=\"UPTRIANG\" ");
		break;
	case HEAD_TRIANG_DOWN:
		rc=fprintf(fp, "HEAD=\"DOWNTRIANG\" ");
		break;
	case HEAD_TRIANG_LEFT:
		rc=fprintf(fp, "HEAD=\"LEFTTRIANG\" ");
		break;
	case HEAD_TRIANG_RIGHT:
		rc=fprintf(fp, "HEAD=\"RIGHTTRIANG\" ");
		break;
	case HEAD_TRIANG_ROUND:
		rc=fprintf(fp, "HEAD=\"TRIANGROUND\" ");
		break;
	case HEAD_MOON:
		rc=fprintf(fp, "HEAD=\"MOON\" ");
		break;
	case HEAD_PLUS:
		rc=fprintf(fp, "HEAD=\"PLUS\" ");
		break;
	case HEAD_RHYTHMIC:
		rc=fprintf(fp, "HEAD=\"RHYTHMIC\" ");
		break;
	case HEAD_SQUARE:
		rc=fprintf(fp, "HEAD=\"SQUARE\" ");
    }
	if(HeadType==HEAD_ALPHANUM || HeadType==HEAD_ALPHANUM_SQUARE ||HeadType==HEAD_ALPHANUM_REVERSE)
	{
		if(rc>=0)
			rc=fprintf(fp,"HEAD_ALPHANUM=\"%s\" ", XMLFormatString(HeadCode).c_str());
	}
	Set_Link(CheckLink(oldCidMap,Get_Link()));
	if(Get_Link()!="")
	{
		if(rc>=0)
			rc=fprintf(fp,"LINK=\"%s\" ", XMLFormatString(Get_Link()).c_str());
	}

	char *sstatus="NORMAL";
	switch(status)
	{
	case NORMAL:
		sstatus="NORMAL";
		break;
	case GRACED:
		sstatus="GRACED";
		break;
	case HIDDEN:
		sstatus="HIDDEN";
		break;
	case GHOSTED:
		sstatus="GHOSTED";
		break;
	}

	if(rc>=0 && status!=NORMAL)
		rc=fprintf(fp,"STATUS=\"%s\" ", sstatus);

#ifdef SAVE_COLOR
	if(rc>=0 && GetColor().GetCode()!="000000")
	{
		rc=fprintf(fp,"COLOR=\"#%s\" ", GetColor().GetCode().c_str());
	}
#endif

	if(rc>=0)
		rc=fprintf(fp,">");

	pPitch = GetPitch();
	if(pPitch){
		if(rc>=0)
			rc=fprintf(fp,"<pitch ");
		if(rc>=0){
			if(pPitch->Accidental == 1)
				rc=fprintf(fp,"BASE=\"%c\" SHIFT=\"#\" OCTAVE=\"%d\" ", NoteChars[pPitch->Letter], pPitch->Octave);
			else if(pPitch->Accidental == -1)
				rc=fprintf(fp,"BASE=\"%c\" SHIFT=\"b\" OCTAVE=\"%d\" ", NoteChars[pPitch->Letter], pPitch->Octave);
			else
				rc=fprintf(fp,"BASE=\"%c\" OCTAVE=\"%d\" ", NoteChars[pPitch->Letter], pPitch->Octave);
		}	
		if(rc>=0)
			rc=fprintf(fp,"/>");
	}
	
	ACPtr = GetPAlterazComposta();
	if(ACPtr)
		if(rc>=0) rc=ACPtr->SaveXML(fp);

	if(rc>=0) rc=Figura::SaveXML(fp);
					
	DiPtr = GetPDiteggiato();
	if(DiPtr)
		if(rc>=0) rc=DiPtr->SaveXML(fp);
							
	AbPtr = GetPAbbellimento();
	if(AbPtr)
		if(rc>=0) rc=AbPtr->SaveXML(fp);
								
	KoPtr = GetPKoreanOrnament();
	if(KoPtr)
		if(rc>=0) rc=KoPtr->SaveXML(fp);
								
	SudPtr = GetPSuddivisione();
	if(SudPtr)
		if(rc>=0) rc=SudPtr->SaveXML(fp);
									
	EsCPtr = GetPEspressComposta();
	if(EsCPtr)
		if(rc>=0) rc=EsCPtr->SaveXML(fp);
										
	SordPtr = GetPSordina();
	if(SordPtr)
		if(rc>=0) rc=SordPtr->SaveXML(fp);
											
	ArmoniciPtr = GetPArmonici();
	if(ArmoniciPtr)
		if(rc>=0) rc=ArmoniciPtr->SaveXML(fp);
																																				
	return rc;
}

  
int NBreve::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<note ID=\"%d\" DURATION=\"D2\" ", GetNumericCode());
	if(rc>=0) rc=Nota::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</note>");
	return rc;
}


int NSemibreve::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<note ID=\"%d\" DURATION=\"D1\" ", GetNumericCode());
	if(rc>=0) rc=Nota::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</note>");
	return rc;
}

int NMinima::SaveXML(FILE *fp)
{
	int rc;
	
	rc=fprintf(fp, "<note ID=\"%d\" DURATION=\"D1_2\" ", GetNumericCode());
	if(rc>=0) rc=Nota::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</note>");
	return rc;
}

int NSemiminima::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<note ID=\"%d\" DURATION=\"D1_4\" ", GetNumericCode());
	if(rc>=0) rc=Nota::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</note>");
	return rc;
}

int NCroma::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<note ID=\"%d\" DURATION=\"D1_8\" ", GetNumericCode());
	if(rc>=0) rc=Nota::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</note>");
	return rc;
}

int NSemicroma::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<note ID=\"%d\" DURATION=\"D1_16\" ", GetNumericCode());
	if(rc>=0) rc=Nota::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</note>");
	return rc;
}

int NBiscroma::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<note ID=\"%d\" DURATION=\"D1_32\" ", GetNumericCode());
	if(rc>=0) rc=Nota::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</note>");
	return rc;
}

int NSemibiscroma::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<note ID=\"%d\" DURATION=\"D1_64\" ", GetNumericCode());
	if(rc>=0) rc=Nota::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</note>");
	return rc;
}

int NFusa::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<note ID=\"%d\" DURATION=\"D1_128\" ", GetNumericCode());
	if(rc>=0) rc=Nota::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</note>");
	return rc;
}

int Pausa::SaveXML(FILE *fp)
{
	int rc;

	char *sstatus="";
	switch(status)
	{
	case NORMAL:
		//sstatus=" STATUS=\"NORMAL\"";
		break;
	case GRACED:
		sstatus=" STATUS=\"GRACED\"";
		break;
	case HIDDEN:
		sstatus=" STATUS=\"HIDDEN\"";
		break;
	case GHOSTED:
		sstatus=" STATUS=\"GHOSTED\"";
		break;
	}

	char sstaff[20]="";
	if(GetPBattuta()==NULL || GetPBattuta()->GetNumberOfStaff()>1)
		sprintf(sstaff," STAFF=\"%d\"",GetNStaff());

	char scolor[20]="";
#ifdef SAVE_COLOR
	if(GetColor().GetCode()!="000000")
		sprintf(scolor," COLOR=\"#%s\" ", GetColor().GetCode().c_str());
#endif

	rc=fprintf(fp, "HEIGHT=\"%d\"%s%s%s%s", GetAltezza(), sstaff, GetNotina()?" SIZE=\"SMALL\"":"",sstatus,scolor);

	Set_Link(CheckLink(oldCidMap,Get_Link()));
	if(rc>=0 && Get_Link()!="")
		fprintf(fp," LINK=\"%s\"",XMLFormatString(Get_Link()).c_str());
	
	if(rc>=0)
		fprintf(fp,">");
	if(rc>=0) rc=Figura::SaveXML(fp);
	return rc;
}

int PSemibreve::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<rest ID=\"%d\" DURATION=\"D1\" ", GetNumericCode());
	if(rc>=0) rc=Pausa::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</rest>");
	return rc;
}

int PMinima::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<rest ID=\"%d\" DURATION=\"D1_2\" ", GetNumericCode());
	if(rc>=0) rc=Pausa::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</rest>");
	return rc;
}

int PSemiminima::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<rest ID=\"%d\" DURATION=\"D1_4\" ", GetNumericCode());
	if(rc>=0) rc=Pausa::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</rest>");
	return rc;
}

int PCroma::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<rest ID=\"%d\" DURATION=\"D1_8\" ", GetNumericCode());
	if(rc>=0) rc=Pausa::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</rest>");
	return rc;
}


int PSemicroma::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<rest ID=\"%d\" DURATION=\"D1_16\" ", GetNumericCode());
	if(rc>=0) rc=Pausa::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</rest>");
	return rc;
}

int PBiscroma::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<rest ID=\"%d\" DURATION=\"D1_32\" ", GetNumericCode());
	if(rc>=0) rc=Pausa::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</rest>");
	return rc;
}

int PSemibiscroma::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<rest ID=\"%d\" DURATION=\"D1_64\" ", GetNumericCode());
	if(rc>=0) rc=Pausa::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</rest>");
	return rc;
}

int PFusa::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<rest ID=\"%d\" DURATION=\"D1_128\" ", GetNumericCode());
	if(rc>=0) rc=Pausa::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</rest>");
	return rc;
}

int PDueBattute::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<rest ID=\"%d\" DURATION=\"D2M\" ", GetNumericCode());
	if(rc>=0) rc=Pausa::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</rest>");
	return rc;
}

int PQuattroBattute::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<rest ID=\"%d\" DURATION=\"D4M\" ", GetNumericCode());
	if(rc>=0) rc=Pausa::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</rest>");
	return rc;
}

int PGenerica::SaveXML(FILE *fp)
{
	int rc;
	NumGrande *pnumg=owner->GetPNumGrande();
	char* n=pnumg?(char*)pnumg->GetTxt():"1";
	
	rc=fprintf(fp, "<rest ID=\"%d\" DURATION=\"DGENERIC\" MEASURES=\"%s\" ", GetNumericCode(), n);
	if(rc>=0) rc=Pausa::SaveXML(fp);	
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp, "</rest>");
	return rc;
}

int Spazio::SaveXML(FILE *fp)
{
	
	TGenerico *TGenPtr;
	Occhiali *OccPtr;
	Annotazione *AnnPtr;
	int rc;
	
	
	rc=fprintf(fp, "<anchorage ID=\"%d\" STAFF=\"%d\" SIZE=\"%d\">", GetNumericCode(), GetNStaff(), relpos);
	
	if(PPrFiato != NULL)
		if(rc>0) rc=PPrFiato->SaveXML(fp);
		
	TGenPtr = GetPTGenerico();
	if(TGenPtr)
		if(rc>0) rc=TGenPtr->SaveXML(fp);
			
	AnnPtr = GetPAnnotazione();
	if(AnnPtr)
		if(rc>0) rc=AnnPtr->SaveXML(fp);
				
	OccPtr = GetPOcchiali();
	if(OccPtr)
		if(rc>0) rc=OccPtr->SaveXML(fp);
					
	if(rc>=0) rc=fprintf(fp, "</anchorage>");
	return rc;				
}

int PrFiato::SaveXML(FILE *fp)
{
	return fprintf(fp, "<breath %s/>",DxDyAttr(this).c_str());  
}
// **************** Alterazioni, espressioni e variazioni ****************



int Sforzato::SaveXML(FILE * fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "SFORZATO", GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str());
}

int Accento::SaveXML(FILE * fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "ACCENTO",  GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str());
}

int Tenuto::SaveXML(FILE * fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "TENUTO",  GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str());
}

int Staccato::SaveXML(FILE * fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "STACCATO",  GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str());
}

int EspGenerica::SaveXML(FILE * fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" NAME=\"%s\" %s/>", "GENERIC", GetAboveNota()?"UP" :"DOWN", symname, DxDyAttr(this).c_str());
} 

int MartDolce::SaveXML(FILE * fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "MARTDOLCE",  GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str());
}

int Martellato::SaveXML(FILE * fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "MARTELLATO",  GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str());
}

int PuntoAllung::SaveXML(FILE * fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "PUNTOALLUNGATO",  GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str());
}

int Diteggiato::SaveXML(FILE * fp)
{	
	char *type="";
	switch(GetTipoDito())
	{
	case 1:
		type="CIRCLED1";
		break;
	case 2:
		type="CIRCLED2";
		break;
	default:
		type="NORMAL";
		break;
	}
	return fprintf(fp, "<fingering FINGER=\"%d\" UPDOWN=\"%s\" TYPE=\"%s\" %s/>", dito, GetAboveNota()?"UP" :"DOWN",type,DxDyAttr(this).c_str());
}






// *****************************************************************
//  ABBELLIMENTI



int Abbellimento::SaveXML(FILE *fp, char *type, int num)
{
	int rc;
	char accsup[200]="";
	char accinf[200]="";
	
	if(GetPAltSopra()!=NULL || GetPAltSotto()!=NULL)
	{
		if(GetPAltSopra()!=NULL)
		{
			sprintf(accsup," ACCSUP=\"%s\"",GetPAltSopra()->GetXMLDesc());
		}
		if(GetPAltSotto()!=NULL)
		{
			sprintf(accinf," ACCINF=\"%s\"",GetPAltSotto()->GetXMLDesc());
		}
	}
	if(num>-1)
		rc=fprintf(fp, "<ornament TYPE=\"%s\" NUMBER=\"%d\" UPDOWN=\"%s\"%s%s %s/>", type, num , GetAboveNota()?"UP" :"DOWN", accsup, accinf, DxDyAttr(this).c_str());
	else
		rc=fprintf(fp, "<ornament TYPE=\"%s\" UPDOWN=\"%s\"%s%s %s/>", type, GetAboveNota()?"UP" :"DOWN", accsup, accinf, DxDyAttr(this).c_str());
	return rc;

}

int GInferiore::SaveXML(FILE *fp)
{
	return Abbellimento::SaveXML(fp, "TURN");
}

int GSuperiore::SaveXML(FILE *fp)
{
	return Abbellimento::SaveXML(fp, "TURNBACK");
}

int GUp::SaveXML(FILE *fp)
{
	return Abbellimento::SaveXML(fp, "TURNUP");
}

int GSlash::SaveXML(FILE *fp)
{
	return Abbellimento::SaveXML(fp, "TURNSLASH");
}

int MInferiore::SaveXML(FILE *fp)
{
	if(GetDoppio())
		return Abbellimento::SaveXML(fp, "DMORDENT");
	else
		return Abbellimento::SaveXML(fp, "MORDENT");
}

int MSuperiore::SaveXML(FILE *fp)
{
	// ------------- Variabili di contesto richieste -------------
	// -----------------------------------------------------------
	
	if(GetDoppio())
		return Abbellimento::SaveXML(fp, "DMORDENTSUP");
	else  
		return Abbellimento::SaveXML(fp, "MORDENTSUP");
	
}

int Trillo::SaveXML(FILE *fp)
{
	return Abbellimento::SaveXML(fp, "TRILL", numtrilli);
}

int Tremolo::SaveXML(FILE *fp)
{
	return Abbellimento::SaveXML(fp, "TREMOLO", NBarre);
}

// ************************* Korean Ornaments ********************
// ***************************************************************

int KoreanOrnament::SaveXML(FILE *fp, char *type)
{
	int rc=0;
	rc=fprintf(fp, "<korean-ornament TYPE=\"%s\" UPDOWN=\"%s\" %s/>", type, GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str());
	return rc;
}

int SlidingUp::SaveXML(FILE *fp)
{
	return KoreanOrnament::SaveXML(fp, "SLIDINGUP1");
}

int SlidingDown::SaveXML(FILE *fp)
{
	return KoreanOrnament::SaveXML(fp, "SLIDINGDOWN");
}

int SlidingDUp::SaveXML(FILE *fp)
{
	return KoreanOrnament::SaveXML(fp, "SLIDINGDUP2");
}

int SlidingDownUp::SaveXML(FILE *fp)
{
	return KoreanOrnament::SaveXML(fp, "SLIDINGUPDOWN");
}

int NonghynInc::SaveXML(FILE *fp)
{
	return KoreanOrnament::SaveXML(fp, "NONGHYNINC");
}

int NonghynDec::SaveXML(FILE *fp)
{
	return KoreanOrnament::SaveXML(fp, "NONGHYNDEC");
}

int NonghynArrow::SaveXML(FILE *fp)
{
	return KoreanOrnament::SaveXML(fp, "NONGHYNARROW");
}

int NonghynWide::SaveXML(FILE *fp)
{
	return KoreanOrnament::SaveXML(fp, "NONGHYNWIDE");
}

// **************************** Alterazioni***********************
// ***************************************************************

int AlterazComposta::SaveXML(FILE *fp)
{
	int i;
	int rc=0;
	
	for(i=0;i<n_alterazioni;i++)
	{
		if(alterazioni[i]!=NULL)
		{
			if(rc>=0) rc=alterazioni[i]->SaveXML(fp);
		}
	}
	return rc;
}

int Diesis::SaveXML(FILE *fp)
{
	return fprintf(fp, "<accidental TYPE=\"%s\" ROUNDBRACKET=\"%s\" %s/>", GetXMLDesc(), this->GetParentesi()?"YES":"NO",DxDyAttr(this).c_str());
}

int Bemolle::SaveXML(FILE *fp)
{
	return fprintf(fp, "<accidental TYPE=\"%s\" ROUNDBRACKET=\"%s\" %s/>", GetXMLDesc(), this->GetParentesi()?"YES":"NO",DxDyAttr(this).c_str());
}

int Bequadro::SaveXML(FILE *fp)
{
	return fprintf(fp, "<accidental TYPE=\"%s\" ROUNDBRACKET=\"%s\" %s/>", GetXMLDesc(), this->GetParentesi()?"YES":"NO",DxDyAttr(this).c_str());
}

int Bequadro1Q::SaveXML(FILE *fp)
{
	return fprintf(fp, "<accidental TYPE=\"%s\" ROUNDBRACKET=\"%s\" %s/>", GetXMLDesc(), this->GetParentesi()?"YES":"NO",DxDyAttr(this).c_str());
}

int Bequadro3Q::SaveXML(FILE *fp)
{
	return fprintf(fp, "<accidental TYPE=\"%s\" ROUNDBRACKET=\"%s\" %s/>", GetXMLDesc(), this->GetParentesi()?"YES":"NO",DxDyAttr(this).c_str());
}

int DoppioDiesis::SaveXML(FILE *fp)
{
	return fprintf(fp, "<accidental TYPE=\"%s\" ROUNDBRACKET=\"%s\" %s/>", GetXMLDesc(), this->GetParentesi()?"YES":"NO",DxDyAttr(this).c_str());
}

int DoppioBemolle::SaveXML(FILE *fp)
{
	return fprintf(fp, "<accidental TYPE=\"%s\" ROUNDBRACKET=\"%s\" %s/>", GetXMLDesc(), this->GetParentesi()?"YES":"NO",DxDyAttr(this).c_str());
}

int Bemolle1Q::SaveXML(FILE *fp)
{
	return fprintf(fp, "<accidental TYPE=\"%s\" ROUNDBRACKET=\"%s\" %s/>", GetXMLDesc(), this->GetParentesi()?"YES":"NO",DxDyAttr(this).c_str());
}

int Bemolle3Q::SaveXML(FILE *fp)
{
	return fprintf(fp, "<accidental TYPE=\"%s\" ROUNDBRACKET=\"%s\" %s/>", GetXMLDesc(), this->GetParentesi()?"YES":"NO",DxDyAttr(this).c_str());
}

int Diesis1Q::SaveXML(FILE *fp)
{
	return fprintf(fp, "<accidental TYPE=\"%s\" ROUNDBRACKET=\"%s\" %s/>", GetXMLDesc(), this->GetParentesi()?"YES":"NO",DxDyAttr(this).c_str());
}

int Diesis3Q::SaveXML(FILE *fp)
{
	return fprintf(fp, "<accidental TYPE=\"%s\" ROUNDBRACKET=\"%s\" %s/>", GetXMLDesc(), this->GetParentesi()?"YES":"NO",DxDyAttr(this).c_str());
}


char* Diesis::GetXMLDesc()
{
	return "SHARP";
}

char* Bemolle::GetXMLDesc()
{
	return "FLAT";
}

char* Bequadro::GetXMLDesc()
{
	return "NATURAL";
}

char* DoppioDiesis::GetXMLDesc()
{
	return "DSHARP";
}

char* DoppioBemolle::GetXMLDesc()
{
	return "DFLAT";
}

char* Bemolle1Q::GetXMLDesc()
{
	return "FLAT1Q";
}

char* Bemolle3Q::GetXMLDesc()
{
	return "FLAT3Q";
}

char* Diesis1Q::GetXMLDesc()
{
	return "SHARP1Q";
}

char* Diesis3Q::GetXMLDesc()
{
	return "SHARP3Q";
}

char* Bequadro1Q::GetXMLDesc()
{
	return "NATURALUP";
}

char* Bequadro3Q::GetXMLDesc()
{
	return "NATURALDOWN";
}

// **********************   Corona   ***********************************
// *********************************************************************

int Corona::SaveXML(FILE *fp)
{
	char *type="?";

	switch(tipo)
	{
	case Classic:
		type="MEDIUM";
		break;
	case Quad:
		type="LONG";
		break;
	case Triang:
		type="SHORT";
		break;
	}

	return fprintf(fp, "<fermata UPDOWN=\"%s\" TYPE=\"%s\" %s/>", GetAboveNota()?"UP" :"DOWN", type, DxDyAttr(this).c_str());
}

// **********************   PuntoValore   *******************************
// **********************************************************************


int PuntoValore::SaveXML(FILE *fp)
{
	return fprintf(fp,"<augmentation DOTS=\"%d\" %s/>", numpunti, DxDyAttr(this).c_str());
}

int TDinamico::SaveXML(FILE *fp)
{
	char desc[DESCRIPTION_MAXLEN];
	TDinamicType tp;
	
	tp=GetTipo();
	switch(tp)
	{
	case TD_PPPPPP:
		strcpy(desc, "PPPPPP");
		break;
	case TD_PPPPP:
		strcpy(desc, "PPPPP");
		break;
	case TD_PPPP:
		strcpy(desc, "PPPP");
		break;
	case TD_PPP:
		strcpy(desc, "PPP");
		break;
	case TD_PP:
		strcpy(desc, "PP");
		break;
	case TD_P:
		strcpy(desc, "P");
		break;
	case TD_MP:
		strcpy(desc, "MP");
		break;
	case TD_MF:
		strcpy(desc, "MF");
		break;
	case TD_F:
		strcpy(desc, "F");
		break;
	case TD_FF:
		strcpy(desc, "FF");
		break;
	case TD_FFF:
		strcpy(desc, "FFF");
		break;
	case TD_FFFF:
		strcpy(desc, "FFFF");
		break;
	case TD_FFFFF:
		strcpy(desc, "FFFFF");
		break;
	case TD_FFFFFF:
		strcpy(desc, "FFFFFF");
		break;
	case TD_SF:
		strcpy(desc, "SF");
		break;
	case TD_SP:
		strcpy(desc, "SP");
		break;
	case TD_SFZ:
		strcpy(desc, "SFZ");
		break;
	case TD_FZ:
		strcpy(desc, "FZ");
		break;
	case TD_FP:
		strcpy(desc, "FP");
		break;
	case TD_RF:
		strcpy(desc, "RF");
		break;
	case TD_FFP:
		strcpy(desc, "FFP");
		break;
	case TD_FFPP:
		strcpy(desc, "FFPP");
		break;
	case TD_FPP:
		strcpy(desc, "FPP");
		break;
	case TD_RFZ:
		strcpy(desc, "RFZ");
		break;
	case TD_SFF:
		strcpy(desc, "SFF");
		break;
	case TD_SFFF:
		strcpy(desc, "SFFF");
		break;
	case TD_SFFP:
		strcpy(desc, "SFFP");
		break;
	case TD_SFFZ:
		strcpy(desc, "SFFZ");
		break;
	case TD_SFP:
		strcpy(desc, "SFP");
		break;
	case TD_SFPP:
		strcpy(desc, "SFPP");
		break;
	default:
		strcpy(desc, "?");
	}
	
	return fprintf(fp, "<dynamictext DYNAMIC=\"%s\" UPDOWN=\"%s\" %s/>", desc, GetAboveNota()?"UP" :"DOWN",DxDyAttr(this).c_str());
}

int TGenerico::SaveXML(FILE *fp)
{
	char *hiddenAttr="";

	if(hidden)
		hiddenAttr=" HIDDEN=\"true\"";


	return fprintf(fp, "<text UPDOWN=\"%s\" %s%s>%s</text>", GetAboveNota()?"UP" :"DOWN",DxDyAttr(this).c_str(), hiddenAttr, XMLFormatString(GetTxt()).c_str());
}

int Annotazione::SaveXML(FILE *fp)
{
	return fprintf(fp, "<annotation UPDOWN=\"%s\" %s>%s</annotation>", GetAboveNota()?"UP" :"DOWN",DxDyAttr(this).c_str(), XMLFormatString(GetTxt()).c_str());
}

int ConSord::SaveXML(FILE *fp)
{
	char desc[DESCRIPTION_MAXLEN];
	switch(TipoSordina)
	{
	case 'o' :
		strcpy(desc, "PLUS");
		break;     
	case 'a' :
		strcpy(desc, "ON");
		break;     
	case 't' :
		strcpy(desc, "IN");
		break;     
	}
	return fprintf(fp, "<mute UPDOWN=\"%s\" TYPE=\"%s\" %s/>", GetAboveNota()?"UP" :"DOWN", desc, DxDyAttr((Indicazione*)this).c_str());
}

int ViaSord::SaveXML(FILE *fp)
{
	char desc[DESCRIPTION_MAXLEN];
	
	switch(TipoSordina)
	{
	case 'o' :
		strcpy(desc, "MINUS");
		break;     
	case 'a' :
		strcpy(desc, "OFF");
		break;     
	case 't' :
		strcpy(desc, "VIA");
		break;     
	}
	return fprintf(fp, "<mute UPDOWN=\"%s\" TYPE=\"%s\" %s/>", GetAboveNota()?"UP" :"DOWN", desc,DxDyAttr((Indicazione*)this).c_str());
}



int ListaIntEst::SaveXML(FILE *fp)
{
	Node *current, *next;
	IntEsteso *IEPtr;
	int rc = 0;
	
	current = first;
	if(current)
		next = GetNext(current);
	else
		next = NULL;
	
	while(rc >= 0 && current)
	{
		IEPtr = (IntEsteso*)current->ObjectPtr; 
		
		rc=IEPtr->SaveXML(fp); 
		
		current = next;
		if(current)
			next = GetNext(current);
	}
	
	return rc;
}

int IntEsteso::SaveXML(FILE *fp, char* type)
{
	int rc;
	SymPath sp1,sp2;
	char *stems="";
	char *sstatus="NORMAL";
	char sbeamdata[1024]="";
	short notina=0;
	
	if(type=="BEAM"){
		switch(((Raggruppamento*)this)->GetBeamPosition())
		{
		case Raggruppamento::BEAM_UP:
			stems="UP";
			break;
		case Raggruppamento::BEAM_DWN:
			stems="DOWN";
			break;
		case Raggruppamento::BEAM_12:
			stems="STAFF12";
			break;
		case Raggruppamento::BEAM_23:
			stems="STAFF23";
			break;
		}
		
		
		switch(((Raggruppamento*)this)->GetStatus()){
			
		case NORMAL:
			sstatus="NORMAL";
			break;
		case GRACED:
			sstatus="GRACED";
			break;
		case HIDDEN:
			sstatus="HIDDEN";
			break;
		case GHOSTED:
			sstatus="GHOSTED";
			break;
		}
		
		notina=((Raggruppamento*)this)->GetNotina();
		sprintf(sbeamdata," BEAM.STEMS=\"%s\" BEAM.STATUS=\"%s\" %s BEAM.SIZE=\"%s\"", stems, sstatus, notina ? "SMALL" :"NORMAL");		
	}
	if(GetBattuta(1)->FigPtr2SymPath(sp1,GetPFigStart()) && 
		GetBattuta(2)->FigPtr2SymPath(sp2,GetPFigEnd()))
	{
		char scolor[20]="";
#ifdef SAVE_COLOR
		if(GetColor().GetCode()!="000000")
			sprintf(scolor," COLOR=\"#%s\" ", GetColor().GetCode().c_str());
#endif
		
		rc=fprintf(fp,"<horizontal ID=\"%d\" TYPE=\"%s\" UPDOWN=\"%s\" %s %s %s>", 
			GetNumericCode(), type, GetSopra()?"UP" :"DOWN",scolor, sbeamdata, DxDyAttr(this).c_str(),DxDyRAttr(this).c_str());
		if(rc>=0) rc=fprintf(fp,"<address MEASURE=\"%d\" LAYER=\"%d\" FIGURE=\"%d\" CHORD.OR.BEAM=\"%d\" CHORD.IN.BEAM=\"%d\"/>",sp1.Array[2],sp1.Array[3],sp1.Array[4],sp1.Array[5],sp1.Array[6]);
		if(rc>=0) rc=fprintf(fp,"<address MEASURE=\"%d\" LAYER=\"%d\" FIGURE=\"%d\" CHORD.OR.BEAM=\"%d\" CHORD.IN.BEAM=\"%d\"/>",sp2.Array[2],sp2.Array[3],sp2.Array[4],sp2.Array[5],sp2.Array[6]);
		if(rc>=0) rc=fprintf(fp,"</horizontal>");
	}
	else 
		return 0;
	return rc;
}

int Onda::SaveXML(FILE *fp)
{
	return IntEsteso::SaveXML(fp,"WAVE");
}

int TrilloOnda::SaveXML(FILE *fp)
{
	return IntEsteso::SaveXML(fp,"TRILL");
}

int Freccia::SaveXML(FILE *fp)
{
	return IntEsteso::SaveXML(fp,"ARROW");
}

int Legatura::SaveXML(FILE *fp)
{
	char * type;
	int rc;
	SymPath sp1,sp2;

	switch(GetLineType())
	{
	case SOLID_LINE:
		type="SLUR";
		break;
	case DOTTED_LINE:
		type="SLURDOT";
		break;
	case DASHED_LINE:
		type="SLURDASH";
		break;
	}
	
	if(GetBattuta(1)->FigPtr2SymPath(sp1,GetPFigStart()) && 
	   GetBattuta(2)->FigPtr2SymPath(sp2,GetPFigEnd()))
	{
		rc=fprintf(fp,"<horizontal ID=\"%d\" TYPE=\"%s\" UPDOWN=\"%s\" %s %s", GetNumericCode(), type, GetSopra()?"UP" :"DOWN",DxDyAttr(this).c_str(),DxDyRAttr(this).c_str());
		if(deforcustom==SLUR_CUSTOM)
		{
			if(rc>=0) rc=fprintf(fp," KNOT1=\"%f\" KNOT2=\"%f\"",p1y,p2y);
		}
		rc=fprintf(fp,">");
		if(rc>=0) rc=fprintf(fp,"<address MEASURE=\"%d\" LAYER=\"%d\" FIGURE=\"%d\" CHORD.OR.BEAM=\"%d\" CHORD.IN.BEAM=\"%d\"/>",sp1.Array[2],sp1.Array[3],sp1.Array[4],sp1.Array[5],sp1.Array[6]);
		if(rc>=0) rc=fprintf(fp,"<address MEASURE=\"%d\" LAYER=\"%d\" FIGURE=\"%d\" CHORD.OR.BEAM=\"%d\" CHORD.IN.BEAM=\"%d\"/>",sp2.Array[2],sp2.Array[3],sp2.Array[4],sp2.Array[5],sp2.Array[6]);
		if(rc>=0) rc=fprintf(fp,"</horizontal>");
	}
	else 
		return 0;
	return rc;
}

int LegaturaValore::SaveXML(FILE *fp)
{
	switch(GetLineType())
	{
	case SOLID_LINE:
		return IntEsteso::SaveXML(fp,"TIE");
	case DOTTED_LINE:
		return IntEsteso::SaveXML(fp,"TIEDOT");
	case DASHED_LINE:
		return IntEsteso::SaveXML(fp,"TIEDASH");
	}
	return -1;
}

int ModifOttava::SaveXML(FILE *fp)
{
	switch(tipo8)
	{
	case VA8:
		return IntEsteso::SaveXML(fp,"OCTVA");
	case BA8:
		return IntEsteso::SaveXML(fp,"OCTBA");
	case MA15:
		return IntEsteso::SaveXML(fp,"QUINDMA");
	case BA15:
		return IntEsteso::SaveXML(fp,"QUINDBA");
	}
	return 0;
}

int Forcella::SaveXML(FILE *fp)
{
	switch(GetLineType())
	{
	case SOLID_LINE:
		if(GetCrescendo())
			return IntEsteso::SaveXML(fp,"CRESCENDO");
		else
			return IntEsteso::SaveXML(fp,"DIMINUENDO");
	case DOTTED_LINE:
		if(GetCrescendo())
			return IntEsteso::SaveXML(fp,"CREDOT");
		else
			return IntEsteso::SaveXML(fp,"DIMDOT");
	case DASHED_LINE:
		if(GetCrescendo())
			return IntEsteso::SaveXML(fp,"CREDASH");
		else
			return IntEsteso::SaveXML(fp,"DIMDASH");
	}
	return -1;
}

int CambioRit::SaveXML(FILE *fp)
{
	int rc;
	SymPath sp1;
	rc=fprintf(fp,"<horizontal ID=\"%d\" TYPE=\"%s\" UPDOWN=\"%s\" REFNUMBER=\"%c\" %s %s>", GetNumericCode(), "CHANGEREF", GetSopra()?"UP" :"DOWN", GetText(), DxDyAttr(this).c_str(),DxDyRAttr(this).c_str());
	
	if(GetBattuta(1)->FigPtr2SymPath(sp1,GetPFigStart()))
	{
		if(rc>=0) rc=fprintf(fp,"<address MEASURE=\"%d\" LAYER=\"%d\" FIGURE=\"%d\" CHORD.OR.BEAM=\"%d\" CHORD.IN.BEAM=\"%d\"/>",sp1.Array[2],sp1.Array[3],sp1.Array[4],sp1.Array[5],sp1.Array[6]);
	}
	else 
		return -1;
	if(GetBattuta(2)->FigPtr2SymPath(sp1,GetPFigEnd()))
	{
		if(rc>=0) rc=fprintf(fp,"<address MEASURE=\"%d\" LAYER=\"%d\" FIGURE=\"%d\" CHORD.OR.BEAM=\"%d\" CHORD.IN.BEAM=\"%d\"/>",sp1.Array[2],sp1.Array[3],sp1.Array[4],sp1.Array[5],sp1.Array[6]);
	}
	else 
		return -1;
	if(rc>=0) rc=fprintf(fp,"</horizontal>");
	return rc;	
}

int LegatQuadra::SaveXML(FILE *fp)
{
	int rc;
	SymPath sp1;
	rc=fprintf(fp,"<horizontal ID=\"%d\" TYPE=\"%s\" UPDOWN=\"%s\" TUPLENUMBER=\"%d\" TUPLELINE=\"%s\" %s %s>", GetNumericCode(), "TUPLE", GetSopra()?"UP" :"DOWN", GetNumero(),GetSenzaLinea()?"false": "true",DxDyAttr(this).c_str(),DxDyRAttr(this).c_str());
	
	if(GetBattuta(1)->FigPtr2SymPath(sp1,GetPFigStart()))
	{
		if(rc>=0) rc=fprintf(fp,"<address MEASURE=\"%d\" LAYER=\"%d\" FIGURE=\"%d\" CHORD.OR.BEAM=\"%d\" CHORD.IN.BEAM=\"%d\"/>",sp1.Array[2],sp1.Array[3],sp1.Array[4],sp1.Array[5],sp1.Array[6]);
	}
	else 
		return -1;
	if(GetBattuta(2)->FigPtr2SymPath(sp1,GetPFigEnd()))
	{
		if(rc>=0) rc=fprintf(fp,"<address MEASURE=\"%d\" LAYER=\"%d\" FIGURE=\"%d\" CHORD.OR.BEAM=\"%d\" CHORD.IN.BEAM=\"%d\"/>",sp1.Array[2],sp1.Array[3],sp1.Array[4],sp1.Array[5],sp1.Array[6]);
	}
	else 
		return -1;
	if(rc>=0) rc=fprintf(fp,"</horizontal>");
	return rc;	
}

int NumBattuta::SaveXML(FILE *fp)
{
	return 0;
}

int Scansione::SaveXML(FILE *fp)
{
	return fprintf(fp, "<beatscan NBEATS=\"%d\" %s/>", GetNumScan(),DxDyAttr(this).c_str());
}

int Lettera::SaveXML(FILE *fp)
{
	return fprintf(fp, "<label TYPE=\"TEXT\" %s>%s</label>",DxDyAttr(this).c_str(),(char*)XMLFormatString(GetTxt()).c_str());
}

int Coda::SaveXML(FILE *fp)
{
	return fprintf(fp, "<label TYPE=\"CODA\" %s/>",DxDyAttr(this).c_str());
}

int Segno::SaveXML(FILE *fp)
{
	return fprintf(fp, "<label TYPE=\"SEGNO\" %s/>",DxDyAttr(this).c_str());
}

int TSalto::SaveXML(FILE *fp)
{
	return fprintf(fp, "<jump TYPE=\"TEXT\" %s>%s</jump>",DxDyAttr(this).c_str(),(char*)XMLFormatString(GetTxt()).c_str());
}

int Movimento::SaveXML(FILE *fp)
{
	int rc; 
	rc=fprintf(fp, "<metronome ");
	if(rc>=0) rc=fprintf(fp, "MOVEMENTTEXT=\"%s\" %s ",XMLFormatString(TMov.GetTxt()).c_str(),DxDyAttr(this).c_str());
	if(rc>=0 && ptrMetr!=NULL)
		rc=ptrMetr->SaveXML(fp);
//	else
//		rc=fprintf(fp, "<metronome NOTETYPE=\"BREVE\" DOT=\"FALSE\"/>");
	if(rc>=0) rc=fprintf(fp, "/>");
	return rc;
}

int Metronomo::SaveXML(FILE *fp)
{
	
	int rc;
	ClassID idnota;
	char notetype[256];
	char dot[256];
	
	if(ptrNota!=NULL)
	{
		idnota=ptrNota->GetID();
		
		switch(idnota)
		{
		case CL_NBREVE:
			strcpy(notetype, "D2");
			break;
			
		case CL_NSEMIBREVE:
			strcpy(notetype, "D1");
			break;
			
		case CL_NMINIMA:
			strcpy(notetype, "D1_2");
			break;
			
		case CL_NSEMIMINIMA:
			strcpy(notetype, "D1_4");
			break;
			
		case CL_NCROMA:
			strcpy(notetype, "D1_8");
			break;
			
		case CL_NSEMICROMA:
			strcpy(notetype, "D1_16");
			break;
			
		case CL_NBISCROMA:
			strcpy(notetype, "D1_32");
			break;
			
		case CL_NSEMIBISCROMA:
			strcpy(notetype, "D1_64");
			break;
			
		case CL_NFUSA:
			strcpy(notetype, "D1_128");
			break;
			
		default:
			strcpy(notetype, "D1");
			break;
		}
		if(ptrNota->GetPPuntoValore()!=NULL)
			strcpy(dot, "1");
		else
			strcpy(dot, "0");
		
	}
	else
	{
		strcpy(notetype, "BREVE");
		strcpy(dot, "0");
	}
	
	rc=fprintf(fp, " NOTETYPE=\"%s\" DOTS=\"%s\" VALUE=\"%d\" ", notetype, dot, MetroTNum.GetNumero());
	
	return rc;
}

int DitaCorde::SaveXML(FILE *fp)
{
	int rc;
	
	rc=fprintf(fp, "<fretboard UPDOWN=\"%s\" NUMBER=\"%d\" NAME=\"%s\" FRETS=\"%s\" FINGERS=\"%s\" BARRE=\"%s\" HEAD=\"%d\"/>",
					GetAboveNota()?"UP" :"DOWN", nstrings, name, frets, fingers, barre, head);
	return rc;
}

int Arco::SaveXML(FILE *fp)
{
	int rc=0;
	Corda *CordaPtr;
	PosizArco *PosArcPtr;
	ParteArco *ParArcPtr;
	DirezArco *DirArcPtr;

	if(GetScrivereArco())
		rc=fprintf(fp,"<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "ARCO", GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str());

	CordaPtr = GetPCorda();
	if(CordaPtr && rc>=0)
		rc=CordaPtr->SaveXML(fp);

	PosArcPtr = GetPPosizArco();
	if(PosArcPtr)
		if(rc>=0) rc=PosArcPtr->SaveXML(fp);
		
	ParArcPtr = GetPParteArco();
	if(ParArcPtr)
		if(rc>=0) rc=ParArcPtr->SaveXML(fp);
			
	DirArcPtr = GetPDirezArco();
	if(DirArcPtr)
		if(rc>=0) rc=DirArcPtr->SaveXML(fp);

	return rc;
}

int Pizzicato::SaveXML(FILE *fp)
{
	int rc=0;
	Corda *CordaPtr;

	CordaPtr = GetPCorda();
	if(CordaPtr && rc>=0)
		rc=CordaPtr->SaveXML(fp);

	if(rc>=0) rc=fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "PIZZ", GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str());
	
	return rc;
}


int Ponticello::SaveXML(FILE *fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "PONTICELLO" ,GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str() );   
}

int Tastiera::SaveXML(FILE *fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "TASTIERA", GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str() );   
}

int Punta::SaveXML(FILE *fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "PUNTA",GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str() );   
}

int Tallone::SaveXML(FILE *fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "TALLONE" ,GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str() );   
}


int ArcoSu::SaveXML(FILE *fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "BOWUP" ,GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str() );   
}

int ArcoGiu::SaveXML(FILE *fp)
{
	return fprintf(fp, "<marker TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "BOWDOWN" ,GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str() );   
}


int Corda::SaveXML(FILE *fp)
{
	char *type=NULL;

	switch(this->GetTipoCorda())
	{
	case NOTCIRCLED:
		type="NORMAL";
		break;
	case BRACKETS:
		type="BRACKETS";
		break;
	case CIRCLED1:
		type="CIRCLED1";
		break;
	case CIRCLED2:
		type="CIRCLED2";
		break;
	}
	return fprintf(fp, "<strings STRING=\"%d\" UPDOWN=\"%s\" ROMAN=\"%s\" TYPE=\"%s\" %s/>", 
		GetNumCorda(), GetAboveNota()?"UP" :"DOWN", GetIsRoman()?"true":"false", type, DxDyAttr(this).c_str());
}



int RipTempo::SaveXML(FILE *fp)
{
	int rc=fprintf(fp, "<repetition ID=\"%d\" TYPE=\"%s\" STAFF=\"%d\">", GetNumericCode(), "BEAT", GetNStaff() );
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp,"</repetition>");
	return rc;
}

int RipMezzaBattuta::SaveXML(FILE *fp)
{
	int rc=fprintf(fp, "<repetition ID=\"%d\" TYPE=\"%s\" STAFF=\"%d\">", GetNumericCode(), "TWOBEAT", GetNStaff() );   
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp,"</repetition>");
	return rc;
}

int RipBattuta::SaveXML(FILE *fp)
{
	int n=0;
	Battuta *pBat=GetPBattuta();
	if(pBat!=NULL && pBat->GetPNumGrande()!=NULL)
		n=atoi((char*)pBat->GetPNumGrande()->GetTxt());
	int rc=fprintf(fp, "<repetition ID=\"%d\" TYPE=\"%s\" STAFF=\"%d\" MEASURES=\"%d\">", GetNumericCode(), "MEASURE", GetNStaff(), n );   
	if(rc>=0) rc=SaveXMLGiust(fp);
	if(rc>=0) rc=fprintf(fp,"</repetition>");
	return rc;
}


int Arpeggio::SaveXML(FILE *fp)
{
	char *direction="";

	switch(GetDirezioneArpeggio())
	{
	case NO_DIRECTION:
		direction="NONE";
		break;
	case UPWARD:
		direction="UP";
		break;
	case DOWNWARD:
		direction="DOWN";
		break;
	}

	return fprintf(fp, "<arpeggio DIRECTION=\"%s\" %s/>", direction, DxDyAttr(this).c_str());
}

int NumGrande::SaveXML(FILE *fp)
{
	return 0;
}


int Occhiali::SaveXML(FILE *fp)
{
	return fprintf(fp, "<glasses UPDOWN=\"%s\" %s/>", 	GetAboveNota()?"UP" :"DOWN", DxDyAttr(this).c_str());
}

int EspressComposta::SaveXML(FILE * fp)
{
	int i;
	int rc=1; 
	for(i=0;i<n_espressioni;i++)
		if(espressioni[i]!=NULL)
// nesi-rc=1
			if(rc>=0) 
				rc=espressioni[i]->SaveXML(fp);
			return rc;
}



int Suddivisione::SaveXML(FILE *fp)
{
	return fprintf(fp, "<ornament TYPE=\"%s\" NUMBER=\"%d\" %s/>", "STEMTREMOLO", NTratti, DxDyAttr(this).c_str());
}

int Armonici::SaveXML(FILE *fp)
{
	return fprintf(fp, "<harmonic UPDOWN=\"%s\" TYPE=\"%s\" %s/>", GetAboveNota()?"UP" :"DOWN", (TipoArmonici=='a')? "STRINGS": "FLUTES",DxDyAttr(this).c_str());
}

int Glissato::SaveXML(FILE *fp)
{
	if(GetGlissonda())
		return Abbellimento::SaveXML(fp, "GLISSWAVE");
	return Abbellimento::SaveXML(fp, "GLISSLINE");
}

int PedalUp::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<piano TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "PEDALUP", GetAboveNota()?"UP" :"DOWN",DxDyAttr(this).c_str());
	return rc;
	
}

int PedalDown::SaveXML(FILE *fp)
{
	int rc;
	rc=fprintf(fp, "<piano TYPE=\"%s\" UPDOWN=\"%s\" %s/>", "PEDALDOWN", GetAboveNota()?"UP" :"DOWN",DxDyAttr(this).c_str());
	return rc;
	
}

int Bend::SaveXML(FILE *fp)
{
	switch(GetLineType())
	{
	case SOLID_LINE:
		return IntEsteso::SaveXML(fp,"BEND");
	case DOTTED_LINE:
		return IntEsteso::SaveXML(fp,"BENDDOT");
	case DASHED_LINE:
		return IntEsteso::SaveXML(fp,"BENDDASH");
	}
	return -1;
}

int PedaleFinoA::SaveXML(FILE *fp)
{
	return IntEsteso::SaveXML(fp,"PIANOPEDAL");
}

int ListaPagine::SaveXML(FILE *fp)
{
    int rc=fprintf(fp, "<printpages>"); 
	Node *ptr=first;
	while(ptr)
	{
		((Pagina*)ptr->ObjectPtr)->SaveXML(fp);
		ptr=ptr->Next;	
	}
	if(rc>=0) rc=fprintf(fp, "</printpages>");
	return rc;
}

int Pagina::SaveXML(FILE *fp)
{
	int rc=fprintf(fp, "<page NUMBER=\"%d\">",GetNPagina()); 
	Node *ptr=first;
	while(ptr)
	{	
		((Casella*)ptr->ObjectPtr)->SaveXML(fp);
		ptr=ptr->Next;
	}
	if(rc>=0) rc=fprintf(fp, "</page>");
	return rc;
}

int CasellaTxt::SaveXML(FILE *fp)
{
	wxString align;
	switch(GetAllineamento())
	{
	case A_Left:
		align="LEFT";
		break;
	case A_Right:
		align="RIGHT";
		break;
	case A_Centre:
		align="CENTER";
		break;
	}
	wxString style;
	switch(GetFont().GetStyle())
	{
	case wxNORMAL:
		style="NORMAL";
		break;
	case wxSLANT:
	case wxITALIC:
		style="ITALIC";
		break;
	}
	wxString weight;
	switch(GetFont().GetWeight())
	{
	case wxNORMAL:
		weight="NORMAL";
		break;
	case wxLIGHT:
		weight="LIGHT";
		break;
	case wxBOLD:
		weight="BOLD";
		break;
	}

	int rc=fprintf(fp, "<textbox X=\"%f\" Y=\"%f\" ALIGN=\"%s\" FONTNAME=\"%s\" FONTWEIGHT=\"%s\" FONTSTYLE=\"%s\" FONTSIZE=\"%d\" >",GetX(),GetY(),
		align,GetFont().GetFaceName(),weight,style,GetFont().GetPointSize()); 
	if(rc>=0) rc=fprintf(fp, "%s",XMLFormatString(GetTesto()).c_str());
	if(rc>=0) rc=fprintf(fp, "</textbox>");
	return rc;	
}


int CasellaImg::SaveXML(FILE *fp)
{
	int rc=fprintf(fp, "<imagebox X=\"%f\" Y=\"%f\" H=\"%d\" W=\"%d\" IMAGEFILE=\"%s\">",
		GetX(),GetY(),GetHeigh(),GetWidth(),XMLFormatString(GetFileImg()).c_str());
	if(rc>=0) rc=fprintf(fp, "</imagebox>");
	return rc;
}
	
int Raggruppamento::SaveXML(FILE *fp)
{
	return IntEsteso::SaveXML(fp,"BEAM");
}

int PrintParams::SaveComputerViewXML(FILE* fp)
{
	char scale[255]="";
	if(GetScaleFactor()!=1.0)
		sprintf(scale," SCALE=\"%.1f\"",GetScaleFactor());
	int rc=fprintf(fp,"<formatpagecomputerview "
		"TOPMARGIN=\"%d\" BOTTOMMARGIN=\"%d\" "
		"LEFTMARGIN=\"%d\" RIGHTMARGIN=\"%d\" STAFFDISTANCE=\"%d\"%s/>",
		GetTopMargin(),GetBottomMargin(),
		GetLeftMargin(),GetRightMargin(),GetStaffDistance(),scale);
	return rc;
}

int PrintParams::SavePrintViewXML(FILE* fp, bool isMainScore)
{
	int rc=fprintf(fp,"<formatpageprintview "
		"PAGEFORMAT=\"%s\" "
		"SCALE=\"%.1f\" "
		"RESOLUTION=\"%s\" "
		"FING1=\"%s\" "
		"FING2=\"%s\" "
		"FING3=\"%s\" >",
		GetPageFormatAsString().c_str(),
		GetScaleFactor(),
		GetPrinterAsString().c_str(),
		XMLFormatString(GetFingerPrint1()).c_str(),
		XMLFormatString(GetFingerPrint2()).c_str(),
		XMLFormatString(GetFingerPrint3()).c_str());

	char *nsys_nstf=NULL;
	int nsys_nstf1,nsys_nstf2;

	if(isMainScore)
	{
		nsys_nstf="NSYSTEMS";
		nsys_nstf1=GetNumSystems(1);
		nsys_nstf2=GetNumSystems(2);
	}
	else
	{
		nsys_nstf="NSTAFFS";
		nsys_nstf1=GetNumStaff(1);
		nsys_nstf2=GetNumStaff(2);
	}


	if(rc>=0)
		rc=fprintf(fp,"<formatpage PAGE=\"1\" "
		"TOPMARGIN=\"%d\" BOTTOMMARGIN=\"%d\" "
		"LEFTMARGIN=\"%d\" RIGHTMARGIN=\"%d\" STAFFDISTANCE=\"%d\" "
		"%s=\"%d\" INSPAGENUM=\"%s\" INSTITLE=\"%s\"/>"
		"<formatpage PAGE=\"DEFAULT\" "
		"TOPMARGIN=\"%d\" BOTTOMMARGIN=\"%d\" "
		"LEFTMARGIN=\"%d\" RIGHTMARGIN=\"%d\" STAFFDISTANCE=\"%d\" "
		"%s=\"%d\" INSPAGENUM=\"%s\" INSTITLE=\"%s\"/>",
		GetTopMargin(1),GetBottomMargin(1),
		GetLeftMargin(1),GetRightMargin(1),GetStaffDistance(1),
		nsys_nstf,nsys_nstf1,GetInsPageNum(1)?"true":"false",GetInsTitle(1)?"true":"false",
		GetTopMargin(2),GetBottomMargin(2),
		GetLeftMargin(2),GetRightMargin(2),GetStaffDistance(2),
		nsys_nstf,nsys_nstf2,GetInsPageNum(2)?"true":"false",GetInsTitle(2)?"true":"false");
	if(rc>=0)
		rc=fprintf(fp,"</formatpageprintview>");

	return rc;
}

wxString CheckLink(wxHashTable *table,wxString oldLink)
{
	wxString tmpLink;

	if(table == NULL)
		return oldLink;
	
	if(oldLink.Contains("WdfCid:"))
		tmpLink = oldLink.AfterLast(':');
	else
		return oldLink;

	wxString* newlink = (wxString*)table->Get(tmpLink);
	if(newlink == NULL)
		return "";
	else
		return "WdfCid:"+*newlink;
}


