/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

// File:  MusicScoreProxy.h
//
// Author: Pierfrancesco Bellini, pbellini@dsi.unifi.it
//
// Modified:
//
// Description:
//   The definition of the proxy object used by the presenter
//   to render the MusicScore node.
//
// Created: December, 1998.
//
//
///////////////////////////////////////////////////////////////////////////


#ifndef MUSICSCORE_PROXY_H
#define MUSICSCORE_PROXY_H

#include "DrawableImage.h"

class MusicScoreProxy : public DrawableImage
{
public:
	MusicScoreProxy(MediaObject* pMO);
	~MusicScoreProxy();
	 void DeleteObject();


	// Return a pointer to the MusicScore node that this node is the proxy for
	MusicScore* GetMusicScore() const { return (MusicScore*)GetObject(); }

	// Functions inherited from the base classes
	void PreRender(Effects & ){}
	void PreRender(Effects & effects,DrawableContext* pContext);
	void OnEndOfStream();
	BOOL GetOpenStreamFlag(){return m_OpenStreamIsBeingUsed; }
	void ResetOpenStreamFlag() {m_OpenStreamIsBeingUsed=FALSE;}
private:
	BOOL m_firstTimeAtStartTime;
	BOOL m_firstTimeAtStopTime;
	BOOL m_endOfTimeReached;
	double m_startTime;
	int m_timesStarted;
	double tempTime;
	double currentTime;
	int count;
	//TRUE if the associated decoder is still active
	BOOL m_OpenStreamIsBeingUsed;

	Vec3f m_mousePosition;

	Vec2f PosInit;
	// Private implementation details
};


#endif // MUSICSCORE_PROXY_H
