#include "par/partitur.hpp"
#include "wdf/wdfmain.hpp"
#include "wdf/dlg/settings.hpp"
#include "liooext.hpp"
#include "gui/masaewin.hpp"
#include "wx/image.h"

#include "Score.h"

extern int printstat;
extern wxMemoryDC *currMDC;

WedelDecoder::WedelDecoder(char* path, int nscore, int battuta,int width,int height)
{
	app.Initialize();
	
	wdf.Load(path);

	partitura = wdf.GetPartitura();

	Scr=new DecoderGScreen(width,height);
	Scr->SetMouse(new Mouse);
	pixmap=new LPixmap(width,height);
	Scr->GSetPixmap(pixmap);
	
	if(nscore==0)
		pMusicWin=new MasaeWindow;
	else
		pMusicWin=new LiooWindow;
	pMusicWin->WinInit(Point(0,0),width,height,partitura);
	pMusicWin->PPartit->SetCurrentScore(nscore);

	if(nscore==0)
	{
		tipoLeggio=LEGGIO_MASAE;
		Leg=false;
	}
	else
	{
		tipoLeggio=LEGGIO_DLIOO;
		Leg=true;
	}
	SimbImg=1;
	AutoLineBreak=1;
	DebugNormalMillaPos=0;
	printstat=0;
	Scr->SetFont(0);
	
	if(partitura==NULL)
		return;

	if(battuta==0)
		partitura->GoTop();
	else
		partitura->GoBatt(battuta);
	//delete currMDC;
}

void WedelDecoder::Decode(void* videobuffer,int width,int height)
{
	wxBitmap* bitmap=new wxBitmap();
	bitmap=(wxBitmap*)pixmap->GetPixmap();
	wxImage img(*bitmap);
	void *rawdata=img.GetData();
    memcpy(videobuffer, rawdata,width*height*3);
}

void WedelDecoder::JumpToMeasure(int measure)
{
	partitura->GoBatt(measure);
}

int WedelDecoder::GetMeasureCount()
{
	return partitura->GetNumeroBattute();
}

