/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: lioomenu.cpp,v 1.1 2005/07/25 16:30:55 bellinpo Exp $ */



#include "lioo.hpp"
#include <wx/wx.h>

// variabile globale di appoggio per debug milla
int DebugNormalMilla=FALSE;
int DebugNormalMillaPos=FALSE;
wxString msgdebug="";

int strcasecmp(char*,char*);
#include "drw/menu.hpp"
#include "smr/smrmain.hpp"  //per usare SMRApp::GetApp()
#include "smr/workspac.hpp"
#include "drw/scorefrm.hpp"
#include "drw/frmanage.hpp"
#include <wx/dc.h>
#include "drw/musicedt.hpp"

#include "gui/masaewin.hpp"
#include "gui/dialogs.hpp" 
#include "gui/dlg/addpart.hpp" 

//#include "bit/smrbitstream.hpp"

#if defined (__WXGTK__)
#include "moodsxdialog.wxr"
#include "moodsxdialog.h"
#include "./wxr/keysignaturexdialog.wxr"
#include "./wxr/keysignaturexdialog.h"
#include "./wxr/timesignaturexdialog.wxr"
#include "./wxr/timesignaturexdialog.h"
#define PATH_SEP "/"
#endif

#if defined(__WXMSW__) 
#include "moodswdialog.wxr"
#include "moodswdialog.h"
#include "./wxr/keysignaturewdialog.wxr"
#include "./wxr/keysignaturewdialog.h"
#include "./wxr/timesignaturewdialog.wxr"
#include "./wxr/timesignaturewdialog.h"
#include "./wxr/editslurwdialog.wxr"
#include "./wxr/editslurwdialog.h"
#define PATH_SEP "\\"
#endif

#include "gui/keysigndlg.hpp"
#include "gui/timesigndlg.hpp"
#include "gui/editslurdlg.hpp"
#include <math.h>
#include "int/legatura.hpp"

extern wxMusicEditor *MusicEditor;

// FROM SPACE.CPP
void SetViewSpace(Bool vs);
Bool GetViewSpace(void);


#include "gui/lioomenu.hpp"
#include "liooext.hpp"
#include "net/logfile.hpp"

#include "gui/dlg/casellatxtdlg.hpp"	
#include "gui/dlg/casellaimgdlg.hpp"	
#include "pag/casellatxt.hpp"			
#include "pag/casellaimg.hpp"			
#include "lst/lista.hpp"
#include "bat/listafig.hpp"


#ifdef TINYMOODS
#define ABIL_LOG FALSE
#else
#define ABIL_LOG TRUE
#endif


extern ScrList LiooListWidget;
extern LogFile MyLog;

// gestione dello stato per l'esecuzione in modo da evitare di premere 
// bottoni che poortano a fare confuzione
#define EXE_NONE      -1
#define EXE_COMPILE   0
#define EXE_INIT      1
#define EXE_START     2
#define EXE_PAUSE     3
#define EXE_STOP      4
int exe_status=EXE_NONE;

int ExeStatus()
{
	if (exe_status==EXE_START || exe_status==EXE_PAUSE) return 1;
	return 0;
}

void StopExeStatus()
{
	exe_status=EXE_STOP;
}


void Setmessagedisplay(wxString msg)
{	 
	if(FrameManager::currFrame!=NULL && dynamic_cast<wxMEScoreFrame*>(FrameManager::currFrame)!=NULL) //PB
		((wxMEScoreFrame*)FrameManager::currFrame)->Gettoolbar()->Getmessagedisplay()->SetValue(msg);
}



#define MAX_LAYERS 4
/*
*	Indica il numero massimo di layer che si possono scgliere.
*	Dovra' essere spostato.
*
* 	Introduzione alla gestione di piu' Layers
*
*/

short mainLay = 1;
/*
*	la variabile "mainLay" fa riferimento a due pulsanti che si trovano in:
*		- Menu Modifica
*		- Menu legature
*
*	Se viene premuto uno dei due pulsanti, l'altro e' automaticamente aggiornato.
*
*/


Bool accordo = FALSE;
/* 
*	la variabile "accordo" fa riferimento a due pulsanti che si trovano in:
*		- Menu Note
*		- Menu Pause
*
*	Quando viene premuto uno dei due, automaticamente si aggiorna l'altro.
*
*/

static Bool insDopo = TRUE;

TipoInserimento aboveNota = AUTOMATICO;
/* 
*	la variabile "aboveNota" fa riferimento a due pulsanti che si trovano in:
*		- Menu Articolazioni
*		- Menu Strumenti
*
*	Quando viene premuto uno dei due, automaticamente si aggiorna l'altro.
*
*/

enum TipiSord TipoSord = ARCHI;

enum TipiFinger TipoFinger = NOTROUNDED;

TipiFinger GetTipoFinger()
{
	Menu *pm = (Menu *)LiooListWidget.GetNodoItemID(SYMB_FINGERING_ID);  
	if (pm!=NULL)
		return TipoFinger;
	else
		TipoFinger = NOTROUNDED;
	return TipoFinger;
}

enum TipiStrings TipoStrings = NOTCIRCLED;

TipiStrings GetTipoStrings()
{
	Menu *pm = (Menu *)LiooListWidget.GetNodoItemID(SYMB_STRINGS_ID);  
	if (pm!=NULL)
		return TipoStrings;
	else
		TipoStrings = NOTCIRCLED;
	return TipoStrings;
}

Bool StringsRoman = TRUE;
Bool GetStringsRoman() {return StringsRoman;}

/*
*	Ogni Layer inoltre ha una propria variabile booleana che indica se la legatura, o piu'
*	in generale l'Intervallo (come e' stato chiamato in questo progetto), debba essere posto
*	sopra o sotto. 
*	Quando si cambia Layer, viene automaticamente aggiornato il pulsante Intervallo Sopra/Sotto.
*
*/

static Bool DrawInt = TRUE; // flag per il controllo del disegno delle terzine


static char tcorto[TCORTO_LEN];
static char tgenerico[TGENERICO_LEN];
static char numero[NUMERO_LEN];
static char fileName[FILE_NAME_LEN];
static char tempo[TEMPO_LEN];
static char name_spar[STRUM_NAME_LEN];

static Bool Alterazione_Con_Parentesi = FALSE;
Bool Get_Alterazione_Con_Parentesi() {return Alterazione_Con_Parentesi;};

LineType lineType=SOLID_LINE;
NoteHead_ID headType=HEAD_CLASSIC;

/*
*	
*	
*	Menu Moods
*	
*	
*/

void CreateNotaMenu();
void CreateSmallNotesMenu();
void CreateBeamingMenu();
void CreateRestsMenu();
void CreateAccidentalsMenu();
void CreateAugmentationsMenu();
void CreateRepeatsMenu();
void CreateBarlinesMenu();
void CreateClefsMenu();
void CreateBracketsMenu();
void CreateHorizontalsMenu();
void CreateRefrainsMenu();
void CreateExpressionsMenu();
void CreateGenericExpMenu();
void CreateOrnamentsMenu();
void CreateKoreanOrnamentsMenu();
void CreateFingeringMenu();
void CreateMutesMenu();
void CreateHarmonicsMenu();
void CreateBreathGlassMenu();
void CreateStringsMenu();
void CreatePedalsMenu();
void CreateViolinMenu();

EventResult InsTempoMenu();

EventResult EditSlurOperation();



/*
*	CallBack dei pulsanti
*	
*	Comandi relativi ai pulsanti
*/


static EventResult COrizzontal();
static EventResult CChiudi();

static EventResult SaveAsOp();
static EventResult SaveOp();
static EventResult ComprimiOp();
static EventResult CDelColonnaFigure();



static EventResult CScansioneOp();
static EventResult CTSaltoOp();
EventResult CLetteraOp();
static EventResult CSegnoOp();
static EventResult CCodaOp();
static EventResult CFineOp();
static EventResult CDaCapoOp();
static EventResult CDaSegnoOp();


static EventResult UnoOp();
static EventResult DueOp();
static EventResult TreOp();
static EventResult QuattroOp();
static EventResult CinqueOp();
static EventResult SeiOp();
static EventResult SetteOp();
static EventResult OttoOp();
static EventResult NoveOp();


/*
*	
*	
*	questi metodi sono stati implementati in fondo al file.
*	
*	
*/


EventResult CmdNotImplem();
static EventResult LegNotEnabled();
Bool InputNumber(char *msg,char *buffer,int max,char *title, short& n);



short indice_MenuFile;
short indice_MenuModifiche;
short indice_MenuChiave;
short indice_MenuIntervalli;
short indice_MenuArticolazioni;
short indice_MenuStrumenti;
short indice_MenuEsecuzione;
short indice_MenuDebug;
short indice_Sopra;
short indice_Log;
short indice_Del;


static EventResult ChangeMmExecMode();
static EventResult ChangeDeclickMode();


/*
*
*	Menu GoForward/GoBackWard
*
*/

EventResult GoTop()
{
	pMusicWin->GoTop();
	return ER_CONTINUE;
}

EventResult GoBottom()
{
	pMusicWin->GoBottom();
	return ER_CONTINUE;
}

EventResult GoForward()
{
	
	pMusicWin->GoForward();
	return ER_CONTINUE;
}

EventResult GoBackward()
{
	pMusicWin->GoBackward();
	return ER_CONTINUE;
}

EventResult LogMenu()
{
#ifdef TINYMOODS
	Message("Not available on tinyMoods");
#else
	MyLog.OpenWindow("Additional Command Window");
#endif
	return ER_CONTINUE;
}

EventResult NetPiu5()
{
	pMusicWin->NetPiu5();
	return ER_CONTINUE;
}

EventResult NetMeno5()
{
	pMusicWin->NetMeno5();
	return ER_CONTINUE;
}


EventResult NetJump()
{
	
	// Richiesta al MASAE di informazioni per gestire il salto ad etichetta e battuta
	
	pMusicWin->RequestJump();
	
	return ER_CONTINUE;
}


void DrawCViolino(const class Rectangle& r);
void DrawSforzato(const class Rectangle& r);


EventResult NewOp()
{
	char *msg = "Would you lost the score?";
	
	if (tipoLeggio==LEGGIO_MASAE)
	{
		if ( YNMessage(msg,"New main score"))
		{
			pMusicWin->SetCommand(CMD_PARTITURA_NEW);
			pMusicWin->DoCommand();
			pMusicWin->HideTagli();
		}
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		if ( YNMessage(msg,"New main score"))
		{
			pMusicWin->SetCommand(CMD_PARTITURA_NEW);
			pMusicWin->DoCommand();
			pMusicWin->HideTagli();
		}
#endif
	}
	
	Scr->GSetMainDrawArea();
	return ER_CONTINUE;
}



EventResult LoadOp()
{ 
	char Path[FILE_NAME_LEN];
	
	Bool Abilitazione;
	
#ifdef WITH_NET 
	if (tipoLeggio==LEGGIO_MASAE) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#else
	if ((tipoLeggio==LEGGIO_MASAE) || (tipoLeggio==LEGGIO_MASE)) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#endif
	
    
	if (!Abilitazione) {
		LegNotEnabled();
		return ER_CONTINUE;
	}
	pMusicWin->PPartit->SetModo(FALSE);  
	int TipoACL;
	TipoACL=WReadMDS("Load file mds",Path,FILE_NAME_LEN,fileName,FILE_NAME_LEN);
	if (TipoACL==0) 
		return ER_CONTINUE;
	
	if (TipoACL==1) 
	{    
		// WReadMDS ritorna il nome di file MDS
		pMusicWin->PPartit->SetSaveMethod(MDS_SAVE);
		pMusicWin->PPartit->SetPathLoadName(Path);
		
		
		pMusicWin->SetCommand(CMD_PARTITURA_LOAD,NO_SEL,ANY_SEL,0,0,0,0,0,fileName);
		pMusicWin->DoCommand();
		
		pMusicWin->HideTagli();	  
	} 
	else 
	{
		// WReadMDS ritorna il nome di file ACL
		char NomeFileACL[200];
		
		strcpy(NomeFileACL,smrgetenv("SMR_FILES_PATH"));
		strcat(NomeFileACL,Path);
		strcat(NomeFileACL,fileName);
		
		// Apro il file ACL, leggo l'header che contiene il nome del file .HID da caricare
		FILE *fp=fopen(NomeFileACL,"r");
		if (fp==NULL) {
			return ER_CONTINUE;
		}
		char NomeBase[200];
		char PathBase[200];
		Bool TipoSalvataggio;
		if (!MyLog.LoadHeader(fp,NomeBase,PathBase,&TipoSalvataggio))
		{
			return ER_CONTINUE;
		}
		
		
		// Aggiungere il path a ACLbuffer !!!!
		if (strcmp(NomeBase,"")) {
			if (TipoSalvataggio) pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_CONG);
			else pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_SEP);
			pMusicWin->PPartit->SetPathLoadName(PathBase);
			
			pMusicWin->SetCommand(CMD_PARTITURA_LOAD,NO_SEL,ANY_SEL,0,0,0,0,0,NomeBase);
			pMusicWin->DoCommand();
			pMusicWin->HideTagli();
		} else {
			pMusicWin->SetCommand(CMD_PARTITURA_NEW);
			pMusicWin->DoCommand();
			pMusicWin->HideTagli();
		}
		
		
		// Eseguo i primi comandi flushed
		long pos=MyLog.LoadExecuteFlushed(fp,!TipoSalvataggio);
		// Eventualmente risalvo la partitura
		char* smds;
		
		if (TipoSalvataggio) 
		{
			// Devo risalvare la partitura ! (con il nome giusto)
			pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_CONG);
			
			smds=strstr(fileName,".acl");
			
			if (smds!=NULL)
			{
				(*smds)='\0';	  
				strcat(fileName,".hid");
				
				
				pMusicWin->SetCommand(CMD_PARTITURA_SAVEAS,NO_SEL,ANY_SEL,0,0,0,0,0,fileName);
				
				pMusicWin->DoCommand();     
				pMusicWin->HideTagli(); 
				pMusicWin->PPartit->SetFileLoadName(fileName);
			}	  	
			
		} else pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_SEP);
		fseek(fp,pos,SEEK_SET);
		if (!MyLog.LoadExecuteNonFlushed(fp)) {
			return ER_CONTINUE;
		}
		fclose(fp);
		pMusicWin->Redraw();
		if (MyLog.IsActive()) MyLog.ModifyWindow(FALSE);
		// Resetto i nomi del path/file per il salvataggio MDS, ora non pi possibile
		pMusicWin->PPartit->SetFileSaveName("");
		pMusicWin->PPartit->SetPathSaveName("");
		
	}
	
	if((pMusicWin->PPartit->GetModo()))
	{   
		int TipoACL1;
		TipoACL1=WReadModo("Load Modo",Path,FILE_NAME_LEN,fileName,FILE_NAME_LEN); 
		
        SimbImg=TRUE;	 
	} 
	else
	{ 
		if(pMusicWin->PPartit->GetModo())
		{
			SimbImg=TRUE;
		} 	  
	} 
	pMusicWin->Redraw();            
	return ER_CONTINUE;
}

static EventResult Simbolico()
{ 
	return ER_CONTINUE;
}  

static EventResult Image()
{ 
	return ER_CONTINUE;
}  

static EventResult SaveAsOp()
{
	Bool Abilitazione;
	char Path[FILE_NAME_LEN];
    
#ifdef WITH_NET 
	if (tipoLeggio==LEGGIO_MASAE) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#else
	if ((tipoLeggio==LEGGIO_MASAE) || (tipoLeggio==LEGGIO_MASE)) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#endif
	
	if (Abilitazione)
	{
		strcpy(fileName,pMusicWin->PPartit->GetFileSaveName());
		strcpy(Path,pMusicWin->PPartit->GetPathSaveName());
		int ret=WSaveMDS("Save file mds",Path,fileName,FILE_NAME_LEN);
		
		
		
		if (ret==0) return ER_CONTINUE;
		
		pMusicWin->PPartit->SetPathSaveName(Path);
		if (ret==1)
			// Salvataggio normale di un MDS
			pMusicWin->PPartit->SetSaveMethod(MDS_SAVE);
		else
			if (ret==2)
				pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_CONG);
			else 
				pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_SEP);
						
			
			
			
			pMusicWin->SetCommand(CMD_PARTITURA_SAVEAS,NO_SEL,ANY_SEL,0,0,0,0,0,fileName);
			pMusicWin->DoCommand();     
			pMusicWin->HideTagli();
	}	  
	else  
		LegNotEnabled();
	
	
	
	return ER_CONTINUE;
}





EventResult SaveACLOp()
{
	extern int WSaveACL(char *title,char *buffer,int max);
	
	char Path[200];
	
	char* MDSFilename = pMusicWin->PPartit->GetFileSaveName();
	strcpy(Path,MDSFilename);
	strcat(Path,PATH_SEP);
	
	char Nome[200];
	strcpy(Nome,Path);
	
	int ret = WSaveACL("Save ACL", Nome, 90);
	if (ret!=0)
	{ 
		
		if (ret==2)
			pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_CONG);
		else 
			pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_SEP);
	}
	
	pMusicWin->SetCommand(CMD_PARTITURA_SAVEAS,NO_SEL,ANY_SEL,0,0,0,0,0,Nome);
	pMusicWin->DoCommand();     
	pMusicWin->HideTagli();
	
	
	return ER_CONTINUE;
}





EventResult LoadACLOp()
{
	extern Bool WreadACL(char *title,char *buffer,int max);
	
	
	Bool Abilitazione;
	
#ifdef WITH_NET 
	if (tipoLeggio==LEGGIO_MASAE) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#else
	if ((tipoLeggio==LEGGIO_MASAE) || (tipoLeggio==LEGGIO_MASE)) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#endif
	
	
	
	if (!Abilitazione) {
		LegNotEnabled();
		return ER_CONTINUE;
	}
	
	
	// WReadMDS ritorna il nome di file ACL
	char NomeFileACL[200];
	
	char* fileName = pMusicWin->PPartit->GetFileSaveName();
	char Path[200];
	
	strcpy(Path,fileName);
	strcat(Path,PATH_SEP);
	
	char Nome[200];
	strcpy(Nome,Path);
	
	strcpy(NomeFileACL,smrgetenv("SMR_FILES_PATH"));
	strcat(NomeFileACL,Path);
	strcat(NomeFileACL,fileName);
	
	// Apro il file ACL, leggo l'header che contiene il nome del file .HID da caricare
	FILE *fp=fopen(NomeFileACL,"r");
	if (fp==NULL) {
		return ER_CONTINUE;
	}
	char NomeBase[200];
	char PathBase[200];
	Bool TipoSalvataggio;
	if (!MyLog.LoadHeader(fp,NomeBase,PathBase,&TipoSalvataggio))
	{
		return ER_CONTINUE;
	}
	
	if (strcmp(NomeBase,"")) {
		if (TipoSalvataggio) pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_CONG);
		else pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_SEP);
		pMusicWin->PPartit->SetPathLoadName(PathBase);
		  		  
		pMusicWin->SetCommand(CMD_PARTITURA_LOAD,NO_SEL,ANY_SEL,0,0,0,0,0,NomeBase);
		pMusicWin->DoCommand();
		pMusicWin->HideTagli();
	} else {
		pMusicWin->SetCommand(CMD_PARTITURA_NEW);
		pMusicWin->DoCommand();
		pMusicWin->HideTagli();
	}
	
	
	// Eseguo i primi comandi flushed
	long pos=MyLog.LoadExecuteFlushed(fp,!TipoSalvataggio);
	// Eventualmente risalvo la partitura
	char* smds;
	
	if (TipoSalvataggio) 
	{
		// Devo risalvare la partitura ! (con il nome giusto)
    	   pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_CONG);
		   
		   smds=strstr(fileName,".acl");
		   
		   if (smds!=NULL)
		   {
			   (*smds)='\0';	  
			   strcat(fileName,".hid");
			   
			   
			   pMusicWin->SetCommand(CMD_PARTITURA_SAVEAS,NO_SEL,ANY_SEL,0,0,0,0,0,fileName);
			   
			   pMusicWin->DoCommand();     
			   pMusicWin->HideTagli(); 
			   pMusicWin->PPartit->SetFileLoadName(fileName);
		   }	  	
		   
	} else pMusicWin->PPartit->SetSaveMethod(ACL_SAVE_SEP);
	fseek(fp,pos,SEEK_SET);
	if (!MyLog.LoadExecuteNonFlushed(fp)) {
		return ER_CONTINUE;
	}
	fclose(fp);
	pMusicWin->Redraw();
	if (MyLog.IsActive()) MyLog.ModifyWindow(FALSE);
	// Resetto i nomi del path/file per il salvataggio MDS, ora non pi possibile
	pMusicWin->PPartit->SetFileSaveName("");
	pMusicWin->PPartit->SetPathSaveName("");
	
	return ER_CONTINUE;
}


static EventResult SaveOp()
{ 
	char msg[FILE_NAME_LEN+9] = "Saving ";
	char pInt[2] = "?";
	Bool Abilitazione;
	
#ifdef WITH_NET 
	if (tipoLeggio==LEGGIO_MASAE) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#else
	if ((tipoLeggio==LEGGIO_MASAE) || (tipoLeggio==LEGGIO_MASE)) Abilitazione=TRUE;
	else Abilitazione=TRUE;
#endif
	
	
	if (Abilitazione)
	{
		if ((strlen(pMusicWin->PPartit->GetFileSaveName()))==0)
		{
			Message("The score is unnamed: use 'SaveAs'.");
			return ER_CONTINUE;
		}
		
		strcat(msg,pMusicWin->PPartit->GetFileSaveName());
		strcat(msg,pInt);
		
		if ( YNMessage(msg,"Saving main score: \n this will delete the ACL. Continue ?\n"))
		{
			pMusicWin->PPartit->SetSaveMethod(MDS_SAVE);
			pMusicWin->SetCommand(CMD_PARTITURA_SAVE);
			pMusicWin->DoCommand();
		}
		pMusicWin->HideTagli();
	}
	else  
		LegNotEnabled();
	
	
	return ER_CONTINUE;
}

EventResult ImportOp()
{ 
	Bool Abilitazione;
	
#ifdef WITH_NET 
	if (tipoLeggio==LEGGIO_MASAE) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#else
	if ((tipoLeggio==LEGGIO_MASAE) || (tipoLeggio==LEGGIO_MASE)) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#endif
	
	
	if (Abilitazione)
	{	
		int risposta, numTraccia=0;
		int KeySignatureCode;
		risposta=MidiReadWin("Import MIDI File", fileName, &numTraccia, KeySignatureCode);
		if (risposta==1)	
		{
			pMusicWin->SetCommand(CMD_PARTITURA_IMPORT_MIDI,NO_SEL,ANY_SEL,numTraccia ,KeySignatureCode,0,0,0,fileName);
			pMusicWin->DoCommand();
		}
		pMusicWin->HideTagli();
	}
	else  
		LegNotEnabled();
	
	
	return ER_CONTINUE;
}



EventResult AboutOp()
{ 
	
	char buff[3000];
	char * GetVersione();
	char * GetDataVersione();
	
	sprintf(buff,"SMR Music Editor\n\n"
		"Dipartimento di Sistemi e Informatica\n"
		"University of Florence\n"
		"Via S.Marta,3 50139, Firenze, Italy\n\n"
		"wedelmusic@dsi.unifi.it\n"
		"www.wedelmusic.org\n\n"
		"Version: %s\n"
		"Date: %s\n\n"
		"This product includes software developed by the\n"
		"Apache Software Foundation (http://www.apache.org/).", GetVersione(),GetDataVersione());
	
	Message(buff);
	
#ifdef _REGGEN
	int ExtimateRegKey();
	ExtimateRegKey();
#endif
	
	return ER_CONTINUE;
}

/************************************************************/
void About()
{
	AboutOp();
}

/************************************************************/
EventResult HelpOp()
{ 
	extern void Help();
	Help();
	return ER_CONTINUE;
}

/************************************************************/
EventResult ExitOp()
{
	if(pMusicWin!=NULL)
	{
		
		pMusicWin->SetCommand(CMD_PARTITURA_END);
		pMusicWin->DoCommand();
	}
	
	extern Widget LiooWidget;
	Scr->GCloseWindow(LiooWidget);
	
	return ER_CONTINUE;
	
}



static EventResult ComprimiOp()
{ 
	
	Bool Abilitazione;
	
#ifdef WITH_NET 
	if (tipoLeggio==LEGGIO_MASAE) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#else
	if ((tipoLeggio==LEGGIO_MASAE) || (tipoLeggio==LEGGIO_MASE)) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#endif
	
	
	
	if (!Abilitazione) {
		LegNotEnabled();
		return ER_CONTINUE;
	}
	
	
	
	if(Comprimi("Compressione"))
	{
	}
	
	
	return ER_CONTINUE;
}





EventResult CDelSimboloOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay("Select Symbol");
	pMusicWin->SetCommand(CMD_DEL_SYMBOL,IMMEDIATE_SEL,ANY_SEL);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
} 

EventResult CEditSimboloOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay("Select Symbol");
	pMusicWin->SetCommand(CMD_EDIT_SYMBOL,IMMEDIATE_SEL,ANY_SEL);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
} 

static EventResult CDelColonnaFigure()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Select Figure");
		pMusicWin->SetCommand(CMD_DEL_COL_FIGURE,IMMEDIATE_SEL,BATPART_SEL);
		pMusicWin->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
		LegNotEnabled();
		return ER_CONTINUE;
	}
} 



EventResult CLayer()
{
	SymCmd *SC = pMusicWin->GetSymCmd();
	
	if (mainLay+1>12)
		mainLay=1;
	else
		mainLay++;
	
  if ((SC->CommandId==CMD_BATTUTA_NOTE2GRUPPONOTE)||(SC->CommandId==CMD_SPARTITO_ADD_BEAM))
		pMusicWin->SetCommand(SC->CommandId, SC->SelectionType, SC->SelObjType, mainLay,SC->ArgV[1],SC->ArgV[2],SC->ArgV[3]);
	else
		pMusicWin->SetCommand(SC->CommandId, SC->SelectionType, SC->SelObjType, SC->ArgV[0],
        mainLay, aboveNota, SC->ArgV[3], SC->ArgV[4], SC->Text,
		SC->ArgV[5],SC->ArgV[6], SC->ArgV[7],SC->ArgV[8]);
	
	// potrebbe dare problemi l'aggiornamento del gambo!
	// come il cambiamento di qualunque di questi parametri
	//      mainLay, SC->ArgV[2], SC->ArgV[3], SC->ArgV[4], SC->Text);
	
	return ER_CONTINUE;
}


/*
*
*	Menu Modifica/Nota
*
*/

void DrawAccordo(const class Rectangle&);
void DrawSingola(const class Rectangle&);

void CreateNotaMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_NOTES_ID, x, y, orizzontal);
	//crea il menu
	Menu *pm= new Menu(" Notes Menu", SYMB_NOTES_ID, 11, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateNotaMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)NOTA_BREVE,nMenuFont,CNBreveOp);
	pm->SetTextItem(2,(unsigned char *)NOTA_SEMIBREVE,nMenuFont,CNSemibreveOp);
	pm->SetTextItem(3,(unsigned char *)NOTA_MINIMA,nMenuFont,CNMinimaOp);
	pm->SetTextItem(4,(unsigned char *)NOTA_SEMIMINIMA,nMenuFont,CNSemiminimaOp);
	pm->SetTextItem(5,(unsigned char *)NOTA_CROMA,nMenuFont,CNCromaOp);
	pm->SetTextItem(6,(unsigned char *)NOTA_SEMICROMA,nMenuFont,CNSemicromaOp);
	pm->SetTextItem(7,(unsigned char *)NOTA_BISCROMA,nMenuFont,CNBiscromaOp);
	pm->SetTextItem(8,(unsigned char *)NOTA_SEMIBISCROMA,nMenuFont,CNSemibiscromaOp);
	pm->SetTextItem(9,(unsigned char *)NOTA_FUSA,nMenuFont,CNFusaOp);
	pm->SetTextItem(10,(unsigned char *)"Anch",nTextFont,CSpazioOp);
	
	
	
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}


EventResult CNBreveOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Breve: Select Note position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_NBREVE,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo,0,"",0,0,0,headType);
	MusicEditor->ShowTagli();
	return ER_CONTINUE;
}

EventResult CNSemibreveOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Whole note: Select Note position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_NSEMIBREVE,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo,0,"",0,0,0,headType);
	MusicEditor->ShowTagli();
	return ER_CONTINUE;
}

EventResult CNMinimaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Half note: Select Note position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_NMINIMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo,0,"",0,0,0,headType);
	MusicEditor->ShowTagli();
	return ER_CONTINUE;
}

EventResult CNSemiminimaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Quarter note: Select Note position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_NSEMIMINIMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo,0,"",0,0,0,headType);
	MusicEditor->ShowTagli();
	return ER_CONTINUE;
}

EventResult CNCromaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 8th note: Select Note position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_NCROMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo,0,"",0,0,0,headType);
	MusicEditor->ShowTagli();
	return ER_CONTINUE;
}

EventResult CNSemicromaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 16th note: Select Note position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_NSEMICROMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo,0,"",0,0,0,headType);
	MusicEditor->ShowTagli();
	return ER_CONTINUE;
}

EventResult CNBiscromaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 32th note: Select Note position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_NBISCROMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo,0,"",0,0,0,headType);
	MusicEditor->ShowTagli();
	return ER_CONTINUE;
}

EventResult CNSemibiscromaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 64th note: Select Note position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_NSEMIBISCROMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo,0,"",0,0,0,headType);
	MusicEditor->ShowTagli();
	return ER_CONTINUE;
}

EventResult CNFusaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 128th note: Select Note position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_NFUSA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo,0,"",0,0,0,headType);
	MusicEditor->ShowTagli();
	return ER_CONTINUE;
}


void DrawAccordo(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	
	pent=r.Center()+MENUCHIAVE_POSPENT;
	Scr->TextTo(pent);
	Scr->OutText((unsigned char *)COD_PENTAGRAMMA);
	
	Scr->TextTo(pent+Point(DXACC,DYACC1));
	cod[0]=COD_ACC;
	Scr->OutText((unsigned char *)cod);
	
	Scr->TextTo(pent+Point(DXACC,DYACC2));
	cod[0]=COD_ACC;
	Scr->OutText((unsigned char *)cod);
	Scr->SetFont(ofont);
}

void DrawSingola(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	
	pent=r.Center()+MENUCHIAVE_POSPENT;
	Scr->TextTo(pent);
	Scr->OutText((unsigned char *)COD_PENTAGRAMMA);
	Scr->TextTo(pent+Point(DXACC,DYACC1));
	cod[0]=COD_ACC;
	Scr->OutText((unsigned char *)cod);
	Scr->SetFont(ofont);
}

EventResult CAccordo()
{ 
	SymCmd *SC = pMusicWin->GetSymCmd();
	accordo=!accordo;
	pMusicWin->SetCommand(SC->CommandId, SC->SelectionType, SC->SelObjType, SC->ArgV[0],
		SC->ArgV[1], SC->ArgV[2], accordo, SC->ArgV[4], SC->Text,SC->ArgV[5],
		SC->ArgV[6], SC->ArgV[7],SC->ArgV[8]);
	
	return ER_CONTINUE;
	
}








/*
*
*	Menu Modifica/Pausa
*
*/
void CreateRestsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_RESTS_ID, x, y, orizzontal);
	//crea il menu
	Menu *pm= new Menu(" Rests Menu", SYMB_RESTS_ID, 15, orizzontal);
	
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateRestsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)PAUSA_4BATTUTE,nMenuFont,CQuattroBatOp);
	pm->SetTextItem(2,(unsigned char *)PAUSA_2BATTUTE,nMenuFont,CPBreveOp);
	pm->SetTextItem(3,(unsigned char *)PAUSA_SEMIBREVE,nMenuFont,CPSemibreveOp);
	pm->SetTextItem(4,(unsigned char *)PAUSA_MINIMA,nMenuFont,CPMinimaOp);
	pm->SetTextItem(5,(unsigned char *)PAUSA_SEMIMINIMA,nMenuFont,CPSemiminimaOp);
	pm->SetTextItem(6,(unsigned char *)PAUSA_CROMA,nMenuFont,CPCromaOp);
	pm->SetTextItem(7,(unsigned char *)PAUSA_SEMICROMA,nMenuFont,CPSemicromaOp);
	pm->SetTextItem(8,(unsigned char *)PAUSA_BISCROMA,nMenuFont,CPBiscromaOp);
	pm->SetTextItem(9,(unsigned char *)PAUSA_SEMIBISCROMA,nMenuFont,CPSemibiscromaOp);
	pm->SetTextItem(10,(unsigned char *)PAUSA_FUSA,nMenuFont,CPFusaOp);
	pm->SetTextItem(11,(unsigned char *)PAUSA_GENERICA,nMenuFont,CPGenericaOp);
	pm->SetTextItem(12,(unsigned char *)CORONASOPRA,nMenuFont,CCoronaOp,ABIL_CORONA);
	pm->SetTextItem(13,(unsigned char *)CORONAQUADSOPRA,nMenuFont,CCoronaQuadOp,ABIL_CORONA);
	pm->SetTextItem(14,(unsigned char *)CORONATRIANGSOPRA,nMenuFont,CCoronaTriangOp,ABIL_CORONA);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}


EventResult VisSpaziOp()
{
	
	SetViewSpace(!GetViewSpace());
	
	Scr->GSetMainDrawArea();
	
	pMusicWin->Draw();
	
	return ER_CONTINUE;
	
}


EventResult CompViewParOp()
{
	
	// se e' chiamato dalla partitura altrimenti puntare lo spartito
	pMusicWin->PPartit->CompViewParametersOp();
	
	
	return ER_CONTINUE;
	
}

EventResult CQuattroBatOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Four Measures: Select Rest position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_PQUABATT,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo);
	if (aboveNota!=AUTOMATICO) MusicEditor->ShowTagli();
	else MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPBreveOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Two Measures: Select Rest position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_PDUEBATT,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo);
	if (aboveNota!=AUTOMATICO) MusicEditor->ShowTagli();
	else MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPSemibreveOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Whole Rest: Select Rest position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_PSEMIBREVE,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo);
	if (aboveNota!=AUTOMATICO) MusicEditor->ShowTagli();
	else MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPMinimaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Half Rest: Select Rest position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_PMINIMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo);
	if (aboveNota!=AUTOMATICO) MusicEditor->ShowTagli();
	else MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPSemiminimaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Quarter Rest: Select Rest position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_PSEMIMINIMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo);
	if (aboveNota!=AUTOMATICO) MusicEditor->ShowTagli();
	else MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPCromaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 8th Rest: Select Rest position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_PCROMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo);
	if (aboveNota!=AUTOMATICO) MusicEditor->ShowTagli();
	else MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPSemicromaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 16th Rest: Select Rest position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_PSEMICROMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo);
	if (aboveNota!=AUTOMATICO) MusicEditor->ShowTagli();
	else MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPBiscromaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 32nd Rest: Select Rest position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_PBISCROMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo);
	if (aboveNota!=AUTOMATICO) MusicEditor->ShowTagli();
	else MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPSemibiscromaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 64th Rest: Select Rest position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_PSEMIBISCROMA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo);
	if (aboveNota!=AUTOMATICO) MusicEditor->ShowTagli();
	else MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPFusaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 128th Rest: Select Rest position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_PFUSA,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,aboveNota,accordo);
	if (aboveNota!=AUTOMATICO) MusicEditor->ShowTagli();
	else MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPGenericaOp()
{
	short num;
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Generic Rest: Select position");
	
	if (InputNumber("Insert the number of rest measures: ",numero,NUMERO_LEN,"Generic Rest",num))
		MusicEditor->SetCommand(CMD_BATTUTA_INS_PGENERICA,INSERT_SEL,BATTUTA_SEL,0,1,0,0,0,numero,0,0,num);
	
	Scr->GSetMainDrawArea();
	MusicEditor->HideTagli();
	return ER_CONTINUE;
} 

EventResult CSpazioOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Anchorage: Select position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_SPAZIO,INSERT_SEL,BATTUTA_SEL,
		0,mainLay,0);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}








/*
*
*	Menu Modifica/Alterazione
*
*/

void CreateAccidentalsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_ACCIDENTALS_ID, x, y, orizzontal);
	//crea il menu
	Menu *pm= new Menu(" Accidentals Menu", SYMB_ACCIDENTALS_ID, 13, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateAccidentalsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)COD_DIESIS1Q,nMenuFont,CDiesis1QOp);
	pm->SetTextItem(2,(unsigned char *)COD_DIESIS,nMenuFont,CDiesisOp);
	pm->SetTextItem(3,(unsigned char *)COD_DIESIS3Q,nMenuFont,CDiesis3QOp);
	pm->SetTextItem(4,(unsigned char *)COD_BEMOLLE1Q,nMenuFont,CBemolle1QOp);
	pm->SetTextItem(5,(unsigned char *)COD_BEMOLLE,nMenuFont,CBemolleOp);
	pm->SetTextItem(6,(unsigned char *)COD_BEMOLLE3Q,nMenuFont,CBemolle3QOp);
	pm->SetTextItem(7,(unsigned char *)COD_BEQUADRO,nMenuFont,CBequadroOp);
	pm->SetTextItem(8,(unsigned char *)COD_DOPPIODIESIS,nMenuFont,C2DiesisOp);
	pm->SetTextItem(9,(unsigned char *)COD_DOPPIOBEMOLLE,nMenuFont,C2BemolleOp); 
	pm->SetTextItem(10,(unsigned char *)COD_BEQUADRO1Q,nMenuFont,CBequadro1QOp);
	pm->SetTextItem(11,(unsigned char *)COD_BEQUADRO3Q,nMenuFont,CBequadro3QOp);
	if (Alterazione_Con_Parentesi)
		pm->SetTextItem(12,(unsigned char *)"COD_PARENTESIZZA",nMenuFont,CParentesizzaAlterazOp);
	else
		pm->SetTextItem(12,(unsigned char *)COD_NON_PARENTESIZZA,nMenuFont,CParentesizzaAlterazOp);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}

EventResult CDiesisOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Sharp: Select Note or Ornament");
	MusicEditor->SetCommand(CMD_NOTA_DIESIS,IMMEDIATE_SEL,NOTASING_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CDiesis1QOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Sharp1Q: Select Note or Ornament");
	MusicEditor->SetCommand(CMD_NOTA_DIESIS1Q,IMMEDIATE_SEL,NOTASING_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CDiesis3QOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Sharp3Q: Select Note or Ornament");
	MusicEditor->SetCommand(CMD_NOTA_DIESIS3Q,IMMEDIATE_SEL,NOTASING_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CBemolleOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Flat: Select Note or Ornament");
	MusicEditor->SetCommand(CMD_NOTA_BEMOLLE,IMMEDIATE_SEL,NOTASING_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CBemolle1QOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Flat1Q: Select Note or Ornament");
	MusicEditor->SetCommand(CMD_NOTA_BEMOLLE1Q,IMMEDIATE_SEL,NOTASING_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CBemolle3QOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Flat3Q: Select Note or Ornament");
	MusicEditor->SetCommand(CMD_NOTA_BEMOLLE3Q,IMMEDIATE_SEL,NOTASING_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CBequadroOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Natural: Select Note or Ornament");
	MusicEditor->SetCommand(CMD_NOTA_BEQUADRO,IMMEDIATE_SEL,NOTASING_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult C2DiesisOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Double Sharp: Select Note or Ornament");
	MusicEditor->SetCommand(CMD_NOTA_2DIESIS,IMMEDIATE_SEL,NOTASING_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult C2BemolleOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Double Flat: Select Note or Ornament");
	MusicEditor->SetCommand(CMD_NOTA_2BEMOLLE,IMMEDIATE_SEL,NOTASING_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}


EventResult CBequadro1QOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Natural1q: Select Note or Ornament");
	pMusicWin->SetCommand(CMD_NOTA_BEQUADRO1Q,IMMEDIATE_SEL,NOTASING_SEL,aboveNota);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CBequadro3QOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Natural3q: Select Note or Ornament");
	pMusicWin->SetCommand(CMD_NOTA_BEQUADRO3Q,IMMEDIATE_SEL,NOTASING_SEL,aboveNota);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}


EventResult CParentesizzaAlterazOp()
{
	Alterazione_Con_Parentesi++;
	Alterazione_Con_Parentesi = Alterazione_Con_Parentesi % 2;
	if (Alterazione_Con_Parentesi) 
	{
		ScrObject *nodo;
		nodo = LiooListWidget.GetNodoItemID(SYMB_ACCIDENTALS_ID);
		Menu *pm;
		if (nodo->GetID()==CL_MENU)
		{
			pm = (Menu *)nodo;
			Scr->GSetDrawArea(pm->GetScrDrawArea());
			pm->SetColor((ColorIcon)red);
			pm->ChangeTextItem(12,(unsigned char *)COD_PARENTESIZZA);
			pm->Draw();
		}
	}
	else
	{
		ScrObject *nodo;
		nodo = LiooListWidget.GetNodoItemID(SYMB_ACCIDENTALS_ID);
		Menu *pm;
		if (nodo->GetID()==CL_MENU)
		{
			pm = (Menu *)nodo;
			Scr->GSetDrawArea(pm->GetScrDrawArea());
			pm->SetColor((ColorIcon)red);
			pm->ChangeTextItem(12,(unsigned char *)COD_NON_PARENTESIZZA);
			pm->Draw();
		}
	}
	return ER_CONTINUE;
}




/*
*
*	Menu Modifica/Variazione Valore
*
*/
void CreateAugmentationsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_AUGMENTATIONS_ID, x, y, orizzontal);
	//crea il menu
	Menu *pm= new Menu("Augmentations Menu", SYMB_AUGMENTATIONS_ID, 5, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateAugmentationsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)NOTADOWN PUNTO,nMenuFont,C1PuntoOp);
	pm->SetTextItem(2,(unsigned char *)NOTADOWN PUNTO PUNTO,nMenuFont,C2PuntiOp);
	pm->SetTextItem(3,(unsigned char *)NOTADOWN PUNTO PUNTO PUNTO,nMenuFont,C3PuntiOp);
	pm->SetTextItem(4,(unsigned char *)LEGATURAVALORESOPRA,nMenuFont,CLegaturaValore);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}



EventResult C1PuntoOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 1 Dot: Select Note or Rest");
	MusicEditor->SetCommand(CMD_FIGURA_1PUNTO,IMMEDIATE_SEL,FIGURA_SEL);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult C2PuntiOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 2 Dots: Select Note or Rest");
	MusicEditor->SetCommand(CMD_FIGURA_2PUNTI,IMMEDIATE_SEL,FIGURA_SEL);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult C3PuntiOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 3 Dots: Select Note or Rest");
	MusicEditor->SetCommand(CMD_FIGURA_3PUNTI,IMMEDIATE_SEL,FIGURA_SEL);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CLegaturaValore()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Tie up: Select Note");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_LEGATURA_VALORE,IMMEDIATE_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}






/*
*
*	Menu Modifica/Notine
*
*/

void DrawNotaNotina(const class Rectangle& r);
void DrawNotinaNota(const class Rectangle& r);
void DrawNotaAcciaccatura(const class Rectangle& r);

void CreateSmallNotesMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_SMALLNOTES_ID, x, y, orizzontal);
	//crea il menu
	Menu *pm= new Menu(" Small Notes Menu", SYMB_SMALLNOTES_ID, 4, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateSmallNotesMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetImageItem(1,DrawNotaNotina,CNota2NotinaOp);
	pm->SetImageItem(2,DrawNotinaNota,CNotina2NotaOp);
	pm->SetImageItem(3,DrawNotaAcciaccatura,CAcciaccaturaOp);
	
	pm->CalcolaDimensioni();
	pm->Realize(x,y);
	
	LiooListWidget.Add(pm);
	
	Scr->SetFont(ofont);
}


void DrawNotaNotina(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	
	pent=r.Center(); 
	
	Scr->TextTo(pent+Point(-13,-10));
	Scr->OutText((unsigned char *)NOTA_CROMA);
	
	Scr->TextTo(pent+Point(-1,-3));
	Scr->OutText((unsigned char *)COD_FRECCIA);
	
	Scr->TextTo(pent+Point(6,-6));
	Scr->OutText((unsigned char *)COD_NOTINA);
	
	Scr->SetFont(ofont);
}


void DrawNotinaNota(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	
	pent=r.Center(); 
	
	Scr->TextTo(pent+Point(-13,-6));
	Scr->OutText((unsigned char *)COD_NOTINA);
	
	Scr->TextTo(pent+Point(-4,-3));
	Scr->OutText((unsigned char *)COD_FRECCIA);
	
	Scr->TextTo(pent+Point(3,-10));
	Scr->OutText((unsigned char *)NOTA_CROMA);
	
	Scr->SetFont(ofont);
}

void DrawNotaAcciaccatura(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	
	pent=r.Center(); 
	
	Scr->TextTo(pent+Point(-13,-10));
	Scr->OutText((unsigned char *)NOTA_CROMA);
	
	Scr->TextTo(pent+Point(-1,-3));
	Scr->OutText((unsigned char *)COD_FRECCIA);
	
	Scr->TextTo(pent+Point(6,-6));
	Scr->OutText((unsigned char *)COD_NOTINA);
	Scr->Line(pent+Point(8,-1),pent+Point(14,4),SOLID_LINE);
	
	Scr->SetFont(ofont);
}

EventResult CNota2NotinaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Note->Small Note: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_NOTA2NOTINA,IMMEDIATE_SEL,FIGURA_SEL);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CNotina2NotaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Small Note->Note: Select small Note");
	MusicEditor->SetCommand(CMD_NOTA_NOTINA2NOTA,IMMEDIATE_SEL,FIGURA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CAcciaccaturaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 8th Note->Acciaccatura: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_ACCIACCATURA,IMMEDIATE_SEL,NOTA_SEL);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}







/*
*
*	Menu Modifica/GruppoNote
*
*/

void DrawNote2Gruppo(const class Rectangle& r);
void DrawGruppo2Note(const class Rectangle& r);

void CreateBeamingMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_BEAMING_ID, x, y, orizzontal);
	//crea il menu
	Menu *pm= new Menu(" Beaming Menu", SYMB_BEAMING_ID, 5, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateBeamingMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetImageItem(1,DrawNote2Gruppo,CNote2GruppoNoteOp);
	pm->SetImageItem(2,DrawGruppo2Note,CGruppoNote2NoteOp);
	pm->SetTextItem(3,(unsigned char *)TERZINA,nMenuFont,CTerzine);
	pm->SetTextItem(4,(unsigned char *)"Beam",nTextFont,CBeamOp,ABIL_LEGATURA);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}


void DrawNote2Gruppo(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	
	pent=r.Center(); 
	
	
	Scr->TextTo(pent+Point(-14,-7));
	Scr->OutText((unsigned char *)NOTA_SING);
	Scr->TextTo(pent+Point(-9,-7));
	Scr->OutText((unsigned char *)NOTA_SING);
	
	Scr->TextTo(pent+Point(-4,-6));
	Scr->OutText((unsigned char *)COD_FRECCIA);
	
	Scr->TextTo(pent+Point(3,-6));
	Scr->OutText((unsigned char *)GRUPPONOTE);
	
	Scr->SetFont(ofont);
}

void DrawGruppo2Note(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	
	pent=r.Center(); 
	
	
	Scr->TextTo(pent+Point(-16,-6));
	Scr->OutText((unsigned char *)GRUPPONOTE);
	
	Scr->TextTo(pent+Point(-4,-6));
	Scr->OutText((unsigned char *)COD_FRECCIA);
	
	Scr->TextTo(pent+Point(2,-7));
	Scr->OutText((unsigned char *)NOTA_SING);
	Scr->TextTo(pent+Point(8,-7));
	Scr->OutText((unsigned char *)NOTA_SING);
	
	
	
	Scr->SetFont(ofont);
}

EventResult CNote2GruppoNoteOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Notes->Beamed Notes: Select a set of consecutive figures");
	MusicEditor->SetCommand(CMD_BATTUTA_NOTE2GRUPPONOTE,RECT_SEL,ANY_SEL,mainLay,0,0,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CScoreExcerpt()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Score Excerpt: Select Area");
	MusicEditor->SetCommand(CMD_PARTITURA_SCORE_EXCERPT,RECT_SEL,ANY_SEL,mainLay,0,0,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CGruppoNote2NoteOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Beamed Notes->Notes: Select a Beam");
	MusicEditor->SetCommand(CMD_BATTUTA_GRUPPONOTE2NOTE,IMMEDIATE_SEL,GRUPPONOTE_SEL);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}


EventResult CTerzine()
{ 
	
	int valoreTerzina;
	if (InputTerzine("Insert a number ",numero,2,"Tuplets",&DrawInt))
	{  
		Scr->GSetMainDrawArea();
		valoreTerzina=atoi(numero);
		Setmessagedisplay(" Tuplets: Select Figures");
		MusicEditor->SetCommand(CMD_SPARTITO_ADD_LEG_QUADRA,TWO_SEL,FIGURA_SEL,
			mainLay,valoreTerzina,0,aboveNota,DrawInt);
		DrawInt = TRUE;
		MusicEditor->HideTagli();
	}
	else
		Scr->GSetMainDrawArea();
	
	return ER_CONTINUE;
}





/*
*
*	Menu Modifica/Ripetizioni
*
*/
void CreateRepeatsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_REPEATS_ID, x, y, orizzontal);
	Menu *pm= new Menu(" Repeats Menu", SYMB_REPEATS_ID, 6, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateRepeatsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)RIP_TEMPO,nMenuFont,CRipTempoOp);
	pm->SetTextItem(2,(unsigned char*)RIP_MEZZABAT,nMenuFont,CRipMezzaBattutaOp);
	pm->SetTextItem(3,(unsigned char *)RIP_DOPPIABATTUTA,nMenuFont,CRipDoppiaBattutaOp);
	pm->SetTextItem(4,(unsigned char *)RIP_BATTUTA,nMenuFont,CRipBattutaOp);
	pm->SetTextItem(5,(unsigned char *)SUDDIVISIONE,nMenuFont,CSuddivisioneOp,ABIL_SUDDIVIS);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}

EventResult CRipTempoOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Time Repeat: Select Figure position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_RIPTEMPO,INSERT_SEL,BATPART_SEL,0,1);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CRipBattutaOp()
{
	short num;
	
	if ( InputNumber("Insert times the measure has to be repeated",numero,1,"Repeat Measure",num))
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Repeat Measure: Select a Measure");
		pMusicWin->SetCommand(CMD_BATTUTA_INS_RIPBATTUTA,INSERT_SEL,BATPART_SEL,0,1,0,0,0,numero,0,0,num);
		pMusicWin->HideTagli();
	}
	else {
		Scr->GSetMainDrawArea();
	}
	
	return ER_CONTINUE;
}

EventResult CRipMezzaBattutaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Repeat Half Measure: Select Figure position");
	MusicEditor->SetCommand(CMD_BATTUTA_INS_RIPMEZZABATTUTA,INSERT_SEL,BATPART_SEL,0,1);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CRipDoppiaBattutaOp()
{
	
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Single Rep.: Select Measure");
		pMusicWin->SetCommand(CMD_BATTUTA_BSINGOLA_RIP2B,IMMEDIATE_SEL,BATPART_SEL);
		pMusicWin->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		Scr->GSetMainDrawArea();
		pMusicWin->SetCommand(CMD_BATTUTA_BSINGOLA_RIP2B,IMMEDIATE_SEL,BATPART_SEL);
		pMusicWin->HideTagli();
		return ER_CONTINUE;
#endif
	}
}


/*
*
*	Menu ImpostaPartitura
*
*/

static void DrawArm(const class Rectangle& r);
static void DrawTempo(const class Rectangle& r);

static void DrawArm(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	
	pent=r.Center()+MENUCHIAVE_POSPENT;
	Scr->TextTo(pent);
	Scr->OutText((unsigned char *)COD_PENTAGRAMMA);
	Scr->TextTo(pent+Point(DXARM1,DYARM1-8));
	cod[0]=COD_ARM1;
	Scr->OutText((unsigned char *)cod);
	Scr->TextTo(pent+Point(DXARM2,DYARM2-8));
	cod[0]=COD_ARM1;
	Scr->OutText((unsigned char *)cod);
	Scr->SetFont(ofont);
}

static void DrawTempo(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	
	pent=r.Center()+MENUCHIAVE_POSPENT;
	Scr->TextTo(pent);
	Scr->OutText((unsigned char *)COD_PENTAGRAMMA);
	Scr->TextTo(pent+Point(DXTMP,DYNUM));
	cod[0]=COD_TMP;
	Scr->OutText((unsigned char *)cod);
	Scr->TextTo(pent+Point(DXTMP,DYDEN));
	cod[0]=COD_TMP;
	Scr->OutText((unsigned char *)cod);
	Scr->SetFont(ofont);
}







/*
*
*	Menu ImpostaPartitura/Chiave
*
*/

void DrawCViolino8(const class Rectangle& r);
void DrawCViolino8Sopra(const class Rectangle& r);
void DrawCBasso(const class Rectangle& r);
void DrawCBasso8(const class Rectangle& r);
void DrawCBaritono(const class Rectangle& r);
void DrawCTenore(const class Rectangle& r);
void DrawCTenore8(const class Rectangle& r);
void DrawCContralto(const class Rectangle& r);
void DrawCMezzoSoprano(const class Rectangle& r);
void DrawCSoprano(const class Rectangle& r);
//
void DrawCBasso8Sopra(const class Rectangle& r);
void DrawCTab(const class Rectangle& r);
void DrawCPercusBox(const class Rectangle& r);
void DrawCPercus2Lines(const class Rectangle& r);
void DrawCVuota(const class Rectangle& r);
void DrawCBassoOld(const class Rectangle& r);
//

void CreateClefsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_CLEFS_ID, x, y, orizzontal);
	Menu *pm= new Menu(" Clefs Menu", SYMB_CLEFS_ID, 18, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateClefsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetImageItem(1,DrawCViolino,CViolinoOp);
	pm->SetImageItem(2,DrawCBasso,CBassoOp);
	pm->SetImageItem(3,DrawCBaritono,CBaritonoOp);
	pm->SetImageItem(4,DrawCTenore,CTenoreOp);
	pm->SetImageItem(5,DrawCTenore8,CTenore8Op);
	pm->SetImageItem(6,DrawCContralto,CContraltoOp);
	pm->SetImageItem(7,DrawCMezzoSoprano,CMezzoSopranoOp);
	pm->SetImageItem(8,DrawCSoprano,CSopranoOp);
	pm->SetImageItem(9,DrawCViolino8,CViolino8Op);
	pm->SetImageItem(10,DrawCViolino8Sopra,CViolino8SopraOp);
	pm->SetImageItem(11,DrawCBasso8,CBasso8Op);
	pm->SetImageItem(12,DrawCBasso8Sopra,CBasso8SopraOp);
	pm->SetImageItem(13,DrawCTab,CTabOp);
	pm->SetImageItem(14,DrawCPercusBox,CPercusBoxOp);
	pm->SetImageItem(15,DrawCPercus2Lines,CPercus2LinesOp);
	pm->SetImageItem(16,DrawCVuota,CVuotaOp);
	pm->SetImageItem(17,DrawCBassoOld,CBassoOldOp);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}

void DrawChiave(const class Rectangle& r,char codchiave,int row, VUnit delta=0)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	
	pent=r.Center()+MENUCHIAVE_POSPENT;
	Scr->TextTo(pent);
	Scr->OutText((unsigned char *)COD_PENTAGRAMMA);
	Scr->TextTo(pent+Point(DXCHIAVE,VU_PER_ROW2*row+delta));
	cod[0]=codchiave;
	Scr->OutText((unsigned char *)cod);
	Scr->SetFont(ofont);
}

void DrawCViolino(const class Rectangle& r)
{
	DrawChiave(r,COD_CVIOLINO,1,-7);
}


void DrawCBasso8Sopra(const class Rectangle& r)
{
	DrawChiave(r,COD_CBASSO8SOPRA,3,-1);
}

void DrawCTab(const class Rectangle& r)
{
	DrawChiave(r,COD_CTAB,3);
	Point pent=r.Center()+MENUCHIAVE_POSPENT;
	Scr->Line(pent+Point(0,-6),pent+Point(20,-6),SOLID_LINE);
}

void DrawCPercusBox(const class Rectangle& r)
{
	DrawChiave(r,COD_CPERCUSBOX,2,-7);
}

void DrawCPercus2Lines(const class Rectangle& r)
{
	DrawChiave(r,COD_CPERCUS2LINES,2,-5);
}

void DrawCVuota(const class Rectangle& r)
{
	DrawChiave(r,COD_CVUOTA,1,-7);
}

void DrawCBassoOld(const class Rectangle& r)
{
	DrawChiave(r,COD_CBASSOOLD,1,-6);
}

void DrawCViolino8(const class Rectangle& r)
{
	DrawChiave(r,COD_CVIOLINO8,1,-7);
}

void DrawCViolino8Sopra(const class Rectangle& r)
{
	DrawChiave(r,COD_CVIOLINO8SOPRA,1,-7);
}

void DrawCBasso(const class Rectangle& r)
{
	DrawChiave(r,COD_CFA,3,-2);
}

void DrawCBasso8(const class Rectangle& r)
{
	DrawChiave(r,COD_CFA8,3,-1);
}

void DrawCBaritono(const class Rectangle& r)
{
	DrawChiave(r,COD_CFA,2,-2);
}

void DrawCTenore(const class Rectangle& r)
{
	DrawChiave(r,COD_CDO,2,3);
}

void DrawCTenore8(const class Rectangle& r)
{
	DrawChiave(r,COD_CDO8,2,3);
}

void DrawCContralto(const class Rectangle& r)
{
	DrawChiave(r,COD_CDO,1,3);
}

void DrawCMezzoSoprano(const class Rectangle& r)
{
	DrawChiave(r,COD_CDO,0,4);
}

void DrawCSoprano(const class Rectangle& r)
{
	DrawChiave(r,COD_CDO,-1,4);
}

//\\\\//

EventResult CViolinoOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Treble: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CVIOLINO,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CViolino8Op()
{
	Scr->GSetMainDrawArea();
	
	Setmessagedisplay(" Clef Treble 8vb: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CVIOLINO8,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CViolino8SopraOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Treble 8va: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CVIOLINO8SOPRA,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CBassoOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Bass: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CBASSO,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CBasso8Op()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Bass 8vb: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CBASSO8,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CBasso8SopraOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Bass 8va: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CBASSO8SOPRA,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CBassoOldOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Basso Old: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CBASSOOLD,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CBaritonoOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Baritone: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CBARITONO,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CTenoreOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Tenor: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CTENORE,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CTenore8Op()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Tenor 8vb: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CTENORE8,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CContraltoOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Alto: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CCONTRALTO,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CMezzoSopranoOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" MezzoSoprano: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CMEZZOSOPRANO,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CSopranoOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Soprano: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CSOPRANO,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CTabOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Tablature: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CTAB,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPercusBoxOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Percussion Box: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CPERCUSBOX,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPercus2LinesOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Percus 2 Lines: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CPERCUS2LINES,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CVuotaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Clef Empty: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_CVUOTA,IMMEDIATE_SEL,BATTUTA_SEL,0,mainLay);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

/*
*
*	Menu ImpostaPartitura/Armatura Chiave
*/


EventResult CArmChvOp()
{
	CmdID comando;
	KeySignDlg dlg;
	tipoArmaturaChiave arm=dlg.GetKeySignature();
	
	switch (arm)
	{
	case 0:
		comando = CMD_BATTUTA_ARMCHV_0D;
		break;
	case 1:
		comando = CMD_BATTUTA_ARMCHV_1D;
		break;
	case 2:
		comando = CMD_BATTUTA_ARMCHV_2D;
		break;
	case 3:
		comando = CMD_BATTUTA_ARMCHV_3D;
		break;
	case 4:
		comando = CMD_BATTUTA_ARMCHV_4D;
		break;
	case 5:
		comando = CMD_BATTUTA_ARMCHV_5D;
		break;
	case 6:
		comando = CMD_BATTUTA_ARMCHV_6D;
		break;
	case 7:
		comando = CMD_BATTUTA_ARMCHV_7D;
		break;
	case 8:
		comando = CMD_BATTUTA_ARMCHV_1B;
		break;
	case 9:
		comando = CMD_BATTUTA_ARMCHV_2B;
		break;
	case 10:
		comando = CMD_BATTUTA_ARMCHV_3B;
		break;
	case 11:
		comando = CMD_BATTUTA_ARMCHV_4B;
		break;
	case 12:
		comando = CMD_BATTUTA_ARMCHV_5B;
		break;
	case 13:
		comando = CMD_BATTUTA_ARMCHV_6B;
		break;
	case 14:
		comando = CMD_BATTUTA_ARMCHV_7B;
		break;
		
		//Riferite alle armature minori
	case 15:
		comando = CMD_BATTUTA_ARMCHV_0Dm;
		break;
	case 16:
		comando = CMD_BATTUTA_ARMCHV_1Dm;
		break;
	case 17:
		comando = CMD_BATTUTA_ARMCHV_2Dm;
		break;
	case 18:
		comando = CMD_BATTUTA_ARMCHV_3Dm;
		break;
	case 19:
		comando = CMD_BATTUTA_ARMCHV_4Dm;
		break;
	case 20:
		comando = CMD_BATTUTA_ARMCHV_5Dm;
		break;
	case 21:
		comando = CMD_BATTUTA_ARMCHV_6Dm;
		break;
	case 22:
		comando = CMD_BATTUTA_ARMCHV_7Dm;
		break;
	case 23:
		comando = CMD_BATTUTA_ARMCHV_1Bm;
		break;
	case 24:
		comando = CMD_BATTUTA_ARMCHV_2Bm;
		break;
	case 25:
		comando = CMD_BATTUTA_ARMCHV_3Bm;
		break;
	case 26:
		comando = CMD_BATTUTA_ARMCHV_4Bm;
		break;
	case 27:
		comando = CMD_BATTUTA_ARMCHV_5Bm;
		break;
	case 28:
		comando = CMD_BATTUTA_ARMCHV_6Bm;
		break;
	case 29:
		comando = CMD_BATTUTA_ARMCHV_7Bm;
		break;
		//
	default :
		comando = CMD_BATTUTA_ARMCHV_0D;
		break;
	};
	Scr->GSetMainDrawArea();
	pMusicWin->SetCommand(comando,IMMEDIATE_SEL,BATTUTA_SEL);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

static EventResult CArmChv0DOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Key Sign.: Select Measure");
	MusicEditor->SetCommand(CMD_BATTUTA_ARMCHV_0D,IMMEDIATE_SEL,BATTUTA_SEL);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}



/**
*	Menu ImpostaPartitura/Tempo
*
*/


EventResult InsTempoMenu()
{
	TimeSignDlg dlg;
	
	strcpy((char *)tempo, dlg.GetTimeSignature());
	if ((tempo != NULL) && (tempo != "\0"))
	{  
		
		Scr->GSetMainDrawArea();
		pMusicWin->SetCommand(CMD_BATTUTA_TEMPO,IMMEDIATE_SEL,BATTUTA_SEL,0,0,0,0,0,tempo);
		pMusicWin->HideTagli();
	}
	return ER_CONTINUE;
} 


IntEsteso *tpInt;
void testeditlegature(IntEsteso *pInt)
{
	tpInt=pInt;
	EditSlurOperation();  
	
} 

EventResult EditSlurOperation()
{
	Legatura *leg;
	int ret;
	
	EditSlurDlg *dlg=new EditSlurDlg;
	if (dlg==NULL) return ER_CONTINUE;
	
	// seleziona la legatura
    leg=(Legatura *)tpInt;
	
	dlg->SetLegatura(leg);
	ret= dlg->InitDlg();
	
	dlg->Centre();
	if(dlg->Show(TRUE))
	{
		return TRUE;
	}
	else 
		return FALSE;
	
	return ER_CONTINUE;
} 


/*
*
*	Menu ImpostaPartitura/Battuta
*
*/
void CreateBarlinesMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_BARLINES_ID, x, y, orizzontal);
	Menu *pm= new Menu(" Barlines Menu", SYMB_BARLINES_ID, 8, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateBarlinesMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)BARRA_SINGOLA,nMenuFont,CBarraSingolaOp);
	pm->SetTextItem(2,(unsigned char *)BARRA_DOPPIA,nMenuFont,CBarraDoppiaOp);
	pm->SetTextItem(3,(unsigned char *)BARRA_FINALE,nMenuFont,CBarraFinaleOp);
	pm->SetTextItem(4,(unsigned char *)BARRA_INIZIORIT,nMenuFont,CBarraInizioRitOp);
	pm->SetTextItem(5,(unsigned char *)BARRA_FINERIT,nMenuFont,CBarraFineRitOp);
	pm->SetTextItem(6,(unsigned char *)BARRA_INIZIOFINERIT,nMenuFont,CBarraInizioFineRitOp);
	pm->SetTextItem(7,(unsigned char *)BARRA_INVISIBILE,nMenuFont,CBarraInvisibileOp);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}


EventResult CBarraSingolaOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Single: Select Measure");
		pMusicWin->SetCommand(CMD_BATTUTA_BSINGOLA,IMMEDIATE_SEL,BATPART_SEL,lineType);
		pMusicWin->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Single: Select Measure");
		pMusicWin->SetCommand(CMD_BATTUTA_BSINGOLA,IMMEDIATE_SEL,BATPART_SEL,lineType);
		pMusicWin->HideTagli();
		return ER_CONTINUE;
#endif
	}
}

EventResult CBarraDoppiaOp()
{
	
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Double: Select Measure");
		MusicEditor->SetCommand(CMD_BATTUTA_BDOPPIA,IMMEDIATE_SEL,BATPART_SEL);
		MusicEditor->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Double: Select Measure");
		MusicEditor->SetCommand(CMD_BATTUTA_BDOPPIA,IMMEDIATE_SEL,BATPART_SEL);
		MusicEditor->HideTagli();
		return ER_CONTINUE;
#endif
	}
}

EventResult CBarraFinaleOp()
{
	
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Final Barline: Select Measure");
		MusicEditor->SetCommand(CMD_BATTUTA_BFINALE,IMMEDIATE_SEL,BATPART_SEL);
		MusicEditor->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Final Barline: Select Measure");
		MusicEditor->SetCommand(CMD_BATTUTA_BFINALE,IMMEDIATE_SEL,BATPART_SEL);
		MusicEditor->HideTagli();
		return ER_CONTINUE;
#endif
	}
}

EventResult CBarraInizioRitOp()
{
	
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Start Rit.: Select Measure");
		MusicEditor->SetCommand(CMD_BATTUTA_BINIZIORIT,IMMEDIATE_SEL,BATPART_SEL);
		MusicEditor->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Start Ref.: Select Measure");
		MusicEditor->SetCommand(CMD_BATTUTA_BINIZIORIT,IMMEDIATE_SEL,BATPART_SEL);
		MusicEditor->HideTagli();
		return ER_CONTINUE;
#endif
	}
}

EventResult CBarraFineRitOp()
{
	
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" End Ref.: Select Measure");
		MusicEditor->SetCommand(CMD_BATTUTA_BFINERIT,IMMEDIATE_SEL,BATPART_SEL);
		MusicEditor->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" End Ref.: Select Measure");
		MusicEditor->SetCommand(CMD_BATTUTA_BFINERIT,IMMEDIATE_SEL,BATPART_SEL);
		MusicEditor->HideTagli();
		return ER_CONTINUE;
#endif
	}
}

EventResult CBarraInizioFineRitOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Start-End Ref.: Select Measure");
		MusicEditor->SetCommand(CMD_BATTUTA_BINIZIOFINERIT,IMMEDIATE_SEL,BATPART_SEL);
		MusicEditor->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Start-End Ref.: Select Measure");
		MusicEditor->SetCommand(CMD_BATTUTA_BINIZIOFINERIT,IMMEDIATE_SEL,BATPART_SEL);
		MusicEditor->HideTagli();
		return ER_CONTINUE;
#endif
	}
}

EventResult CBarraInvisibileOp()
{
	
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Invisible Barline: Select Measure");
		pMusicWin->SetCommand(CMD_BATTUTA_BINVISIBILE,IMMEDIATE_SEL,BATPART_SEL);
		pMusicWin->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Invisible Barline: Select Measure");
		pMusicWin->SetCommand(CMD_BATTUTA_BINVISIBILE,IMMEDIATE_SEL,BATPART_SEL);
		pMusicWin->HideTagli();
		return ER_CONTINUE;
#endif
	}
}




EventResult InsBatDopoOp()
{
	
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		insDopo=TRUE;
		pMusicWin->SetCommand(CMD_PARTITURA_ADD_BATTUTA,IMMEDIATE_SEL,BATPART_SEL,0,insDopo);
		Setmessagedisplay(" Insert Measure: Select previous Measure");
		Setmessagedisplay(" Select previous Measure");
		pMusicWin->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		Scr->GSetMainDrawArea();
		insDopo=TRUE;
		pMusicWin->SetCommand(CMD_PARTITURA_ADD_BATTUTA,IMMEDIATE_SEL,BATPART_SEL,0,insDopo);
		Setmessagedisplay(" Insert Measure: Select previous Measure");
		Setmessagedisplay(" Select previous Measure");
		pMusicWin->HideTagli();
		return ER_CONTINUE;
#endif
	}
}

EventResult InsBatPrimaOp()
{
	
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		insDopo=FALSE;
		pMusicWin->SetCommand(CMD_PARTITURA_ADD_BATTUTA,IMMEDIATE_SEL,BATPART_SEL,0,insDopo);
		Setmessagedisplay(" Select next Measure");
		pMusicWin->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		Scr->GSetMainDrawArea();
		insDopo=FALSE;
		pMusicWin->SetCommand(CMD_PARTITURA_ADD_BATTUTA,IMMEDIATE_SEL,BATPART_SEL,0,insDopo);
		Setmessagedisplay(" Select next Measure");
		pMusicWin->HideTagli();
		return ER_CONTINUE;
#endif
	}
}

EventResult CDelBattutaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Select Measure");
	pMusicWin->SetCommand(CMD_BATTUTA_ERASE,IMMEDIATE_SEL,BATTUTA_SEL);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
} 

EventResult CDelColonnaBatOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Select a measure of the column");
		pMusicWin->SetCommand(CMD_PARTITURA_DEL_BATTUTA,IMMEDIATE_SEL,BATPART_SEL); 
		pMusicWin->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Select a measure of the column");
		pMusicWin->SetCommand(CMD_PARTITURA_DEL_BATTUTA,IMMEDIATE_SEL,BATPART_SEL);  
		pMusicWin->HideTagli();
		return ER_CONTINUE;
#endif
	}
	
	
} 

EventResult CCopiaBattOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Select a measure of the column");
		pMusicWin->SetCommand(CMD_PARTITURA_COPIA_BATTUTA,IMMEDIATE_SEL,BATPART_SEL);
		pMusicWin->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
		LegNotEnabled();
		return ER_CONTINUE;
	}
	
} 

EventResult CIncollaBattOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Select a measure of the column");
		pMusicWin->SetCommand(CMD_PARTITURA_INCOLLA_BATTUTA,IMMEDIATE_SEL,BATPART_SEL);
		pMusicWin->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
		LegNotEnabled();
		return ER_CONTINUE;
	}
	
} 

EventResult CCopiaSBattOp()
{
    Scr->GSetMainDrawArea();
    Setmessagedisplay(" Select a measure of the column");
    pMusicWin->SetCommand(CMD_PARTITURA_COPIA_SINGOLABATTUTA,IMMEDIATE_SEL,BATTUTA_SEL);
    pMusicWin->HideTagli();
    return ER_CONTINUE;
} 

EventResult CIncollaSBattOp()
{
    Scr->GSetMainDrawArea();
    Setmessagedisplay(" Select a measure of the column");
    pMusicWin->SetCommand(CMD_PARTITURA_INCOLLA_SINGOLABATTUTA,IMMEDIATE_SEL,BATTUTA_SEL);
    pMusicWin->HideTagli();
    return ER_CONTINUE;
} 


EventResult CCheckBattOp()
{
	
	Scr->GSetMainDrawArea();
	CheckLogDlg(pMusicWin->PPartit);
	return ER_CONTINUE;
	
} 



EventResult CFormatBeamingOp()
{
	  	
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Beaming");
	pMusicWin->PPartit->BeamingInPart();
	MusicEditor->RedrawViews(0,TRUE);
	
	return ER_CONTINUE;
	
}

EventResult CUpDownOp()
{	  
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Up/Down");
	pMusicWin->PPartit->UpDownInPart();
	MusicEditor->RedrawViews(0,TRUE);
	
	return ER_CONTINUE;
	
}


void CreateBracketsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_BRACKETS_ID, x, y, orizzontal);
	Menu *pm= new Menu(" Brackets Menu", SYMB_BRACKETS_ID, 4, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateBracketsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)" Nam",nTextFont,CSetNameSpaOp);
	pm->SetTextItem(2,(unsigned char *)COD_GRAFFA,nMenuFont,CAddGraffaOp);
	pm->SetTextItem(3,(unsigned char *)COD_QUADRA,nMenuFont,CAddQuadraOp);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}

EventResult CAddSpartitoOp()
{
	Bool Abilitazione;
	AddPartDlg addpart; 
	
	short nStaff=0;
	wxString partName;
	
#ifdef WITH_NET 
	if (tipoLeggio==LEGGIO_MASAE) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#else
	if ((tipoLeggio==LEGGIO_MASAE) || (tipoLeggio==LEGGIO_MASE)) Abilitazione=TRUE;
	else Abilitazione=FALSE;
#endif
	
	addpart.Initialize();
	
	addpart.Centre(wxBOTH);
	
	if(addpart.ShowModal() == wxID_OK)
	{
		nStaff=addpart.GetNumberOfStaff();
		partName=addpart.GetNewPartName();
	}
	else return ER_CONTINUE;
	
	if (Abilitazione)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Add Score part");
		pMusicWin->SetCommand(CMD_PARTITURA_ADD_SPARTITO,IMMEDIATE_SEL,SPARTITO_SEL,0,nStaff,0,0,0,(char*)partName.c_str());
		pMusicWin->HideTagli();
	}
	else
		LegNotEnabled();
	return ER_CONTINUE;
}


EventResult CSetNameSpaOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		if ( InputString("Insert part name:",name_spar,STRUM_NAME_LEN,"Part name"))
		{  
			Scr->GSetMainDrawArea();
			
			Setmessagedisplay(" Part name: Select the part");
			MusicEditor->SetCommand(CMD_SPARTITO_SET_NAME,IMMEDIATE_SEL,SPARTITO_SEL,0,0,0,0,0,name_spar);
		}
		else
			Scr->GSetMainDrawArea();
		MusicEditor->HideTagli();
		return ER_CONTINUE;
	}
	else
	{
#ifdef WITH_NET   
		LegNotEnabled();
		return ER_CONTINUE;
#else
		if ( InputString("Insert part name:",name_spar,STRUM_NAME_LEN,"Part name"))
		{  
			Scr->GSetMainDrawArea();
			
			Setmessagedisplay(" Part name: Select the part");
			MusicEditor->SetCommand(CMD_SPARTITO_SET_NAME,IMMEDIATE_SEL,SPARTITO_SEL,0,0,0,0,0,name_spar);
		}
		else
			Scr->GSetMainDrawArea();
		MusicEditor->HideTagli();
		return ER_CONTINUE;
#endif
	}
}

EventResult CAddGraffaOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Brace Bracket: Select Parts");
		MusicEditor->SetCommand(CMD_PARTITURA_ADD_GRAFFA,TWO_SEL,SPARTITO_SEL);
		MusicEditor->HideTagli();
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}

EventResult CAddQuadraOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Square Bracket: Select parts");
		MusicEditor->SetCommand(CMD_PARTITURA_ADD_QUADRA,TWO_SEL,SPARTITO_SEL);
		MusicEditor->HideTagli();
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}

EventResult CMovePartOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Move Part: Select part");
		pMusicWin->SetCommand(CMD_PARTITURA_MOVE_PART,TWO_SEL,SPARTITO_SEL);
		pMusicWin->HideTagli();
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}

EventResult CViewLayerOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" View Layer: Select part");
		pMusicWin->SetCommand(CMD_PARTITURA_VIEW_LAYER,IMMEDIATE_SEL,SPARTITO_SEL);
		pMusicWin->HideTagli();
	}
	else
	{
		int currScore=pMusicWin->PPartit->GetCurrentScore();
		Spartito *currSpa=pMusicWin->PPartit->GetSpartNum(currScore-1);	
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" View Layer");
		pMusicWin->PPartit->ViewLayerInPart(currSpa);
	}
	
	return ER_CONTINUE;
}

EventResult CSplittingPart()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Splitting Part: Select part");
		pMusicWin->SetCommand(CMD_PARTITURA_SPLITTING_PART,IMMEDIATE_SEL,SPARTITO_SEL);
		pMusicWin->HideTagli();
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}

EventResult CDisjoiningPart()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Disjoining Part: Select part");
		pMusicWin->SetCommand(CMD_PARTITURA_DISJOINING_PART,IMMEDIATE_SEL,SPARTITO_SEL);
		pMusicWin->HideTagli();
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}

EventResult CJoiningParts()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		int parts[3];
		parts[0]=parts[1]=parts[2]=-1;
		Setmessagedisplay(" Joining Part: Select parts");
		if(MutipleChoiceDial(parts, pMusicWin->PPartit, 3, "Joining Parts - Selection"))
		{
			Scr->GSetMainDrawArea();
			pMusicWin->SetCommand(CMD_PARTITURA_JOINING_PART,NO_SEL,ANY_SEL, parts[0],parts[1],parts[2]);
			pMusicWin->DoCommand();
			pMusicWin->HideTagli();
			Setmessagedisplay(" Editing");
			
		}
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}

EventResult CMergingParts()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		int parts[2];
		parts[0]=parts[1]=-1;
		Setmessagedisplay(" Merging Part: Select parts");
		if(MutipleChoiceDial(parts, pMusicWin->PPartit, 2, "Merging Parts - Selection"))
		{
			Scr->GSetMainDrawArea();
			pMusicWin->SetCommand(CMD_PARTITURA_MERGING_PART,NO_SEL,ANY_SEL, parts[0],parts[1]);
			pMusicWin->DoCommand();
			pMusicWin->HideTagli();
			Setmessagedisplay(" Editing");
			
		}
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}

EventResult CDelSpartito()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Delete Part: Select part");
		pMusicWin->SetCommand(CMD_PARTITURA_DEL_SPARTITO,IMMEDIATE_SEL,SPARTITO_SEL);
		pMusicWin->HideTagli();
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}

EventResult CSwitchLayer()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" MoveLayer: Select part");
		pMusicWin->SetCommand(CMD_PARTITURA_MOVE_LAYER,IMMEDIATE_SEL,SPARTITO_SEL);
		pMusicWin->HideTagli();
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}

EventResult CCopySpartito()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Copy Part: Select part");
		pMusicWin->SetCommand(CMD_PARTITURA_COPY_SPARTITO,IMMEDIATE_SEL,SPARTITO_SEL);
		pMusicWin->HideTagli();
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}

EventResult CPasteSpartito()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{ 
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Paste Part: Select part");
		pMusicWin->SetCommand(CMD_PARTITURA_PASTE_SPARTITO,IMMEDIATE_SEL,SPARTITO_SEL);
		pMusicWin->HideTagli();
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}


EventResult CCutPageBox()
{
    Scr->GSetMainDrawArea();
    Setmessagedisplay(" Cut Page Box: Select Box");
    pMusicWin->SetCommand(CMD_PARTITURA_CUT_PAGEBOX,IMMEDIATE_SEL,ANY_SEL,0,0,0,0,0,"");
    pMusicWin->HideTagli();	
	return ER_CONTINUE;
}

EventResult CCopyPageBox()
{
    Scr->GSetMainDrawArea();
    Setmessagedisplay(" Copy Page Box: Select Box");
    pMusicWin->SetCommand(CMD_PARTITURA_COPY_PAGEBOX,IMMEDIATE_SEL,ANY_SEL,0,0,0,0,0,"");
    pMusicWin->HideTagli();	
	return ER_CONTINUE;
}

EventResult CPastePageBox()
{
	Scr->GSetMainDrawArea();
    Setmessagedisplay(" Paste Page Box: Select Box");
    pMusicWin->SetCommand(CMD_PARTITURA_PASTE_PAGEBOX,IMMEDIATE_SEL,ANY_SEL,0,0,0,0,0,"");
    pMusicWin->HideTagli();	
	return ER_CONTINUE;
}


EventResult CHidePartOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Hide Part: Select part");
		pMusicWin->SetCommand(CMD_PARTITURA_HIDE_PART,IMMEDIATE_SEL,SPARTITO_SEL);
		pMusicWin->HideTagli();
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}

EventResult CShowAllPartsOp()
{
	if (tipoLeggio==LEGGIO_MASAE)
	{
		Scr->GSetMainDrawArea();
		
		pMusicWin->PPartit->ShowAllParts();
		pMusicWin->HideTagli();
	}
	else
		LegNotEnabled();
	
	return ER_CONTINUE;
}


EventResult CMovimentoOp()
{
	int nota, metr, i, ind;
	ClassID idNota;
	Bool punto, fl;
	
	tgenerico[0] = '\0'; //db
	if (WMetronomo("Metronome",tgenerico,TGENERICO_LEN))
	{  
		ind=-1;
		for(i=0;tgenerico[i];i++)
			if (tgenerico[i]=='*') ind = i;
			if (ind>-1)
			{
				fl = TRUE;
				for(i=ind+1;tgenerico[i];i++)
					fl = ((fl) && (tgenerico[i]>='0') && (tgenerico[i]<='9'));
				if (fl)
				{
					nota = (tgenerico[ind+1]-'0');
					punto = ((tgenerico[ind+2]-'0')==1);
					for(i=ind+3,metr=0;tgenerico[i];i++)
						metr = metr*10 + tgenerico[i]-'0';
					tgenerico[ind] = '\0';
					
					switch (nota)
					{
					case 0:
						idNota = CL_NBREVE;
						break;
					case 1:
						idNota = CL_NSEMIBREVE;
						break;
					case 2:
						idNota = CL_NMINIMA;
						break;
					case 3:
						idNota = CL_NSEMIMINIMA;
						break;
					case 4:
						idNota = CL_NCROMA;
						break;
					case 5:
						idNota = CL_NSEMICROMA;
						break;
					case 6:
						idNota = CL_NBISCROMA;
						break;
					case 7:
						idNota = CL_NSEMIBISCROMA;
						break;
					case 8:
						idNota = CL_NFUSA;
						break;
					default:
						idNota = CL_NSEMIMINIMA;
						break;
					}
					Scr->GSetMainDrawArea();
					Setmessagedisplay(" Metronome: Select Measure");
					pMusicWin->SetCommand(CMD_BATTUTA_MOVIMENTO,IMMEDIATE_SEL,BATTUTA_SEL,idNota,punto,metr,
						0,0,tgenerico);
				}
			}
			else
			{
				Scr->GSetMainDrawArea();
				Setmessagedisplay(" Metronome: Select Measure");
				pMusicWin->SetCommand(CMD_BATTUTA_MOVIMENTO,IMMEDIATE_SEL,BATTUTA_SEL,0,0,0,
					0,0,tgenerico);
			}
	}
	else
		Scr->GSetMainDrawArea();
	
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}


static EventResult CScansioneOp()
{
	short num;
	if ( InputNumber("Insert the number of beats (0-9): ",numero,2,"Scansione",num))
	{  
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Scansione: Select Measure");
		MusicEditor->SetCommand(CMD_BATTUTA_SCANSIONE,IMMEDIATE_SEL,BATTUTA_SEL,0,num);
	}
	else
		Scr->GSetMainDrawArea();
	
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

static EventResult CTSaltoOp()
{
	if ( InputString("Insert a text: ",tgenerico,TGENERICO_LEN,"Jump Text"))
	{  
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Jump Text: Select Measure");
		pMusicWin->SetCommand(CMD_BATTUTA_TSALTO,IMMEDIATE_SEL,BATTUTA_SEL,0,0,0,0,0,tgenerico);
	}
	else
		Scr->GSetMainDrawArea();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}


static EventResult CDaCapoOp()
{
	wxString array_da_capo[2];
	array_da_capo[0] = "D.C.";
	array_da_capo[1] = "D.C. al Fine";
	wxSingleChoiceDialog dialog(FrameManager::currFrame,"Select one of the following","Da Capo",2,array_da_capo);
	char tgenerico[TGENERICO_LEN]; 
	if (dialog.ShowModal() == wxID_OK) {
		sprintf(tgenerico,"%s",dialog.GetStringSelection());
		dialog.Destroy();
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Da Capo: Select Measure");
		pMusicWin->SetCommand(CMD_BATTUTA_TSALTO,IMMEDIATE_SEL,BATTUTA_SEL,0,0,0,0,0,tgenerico);
	}
	else
		Scr->GSetMainDrawArea();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}


static EventResult CDaSegnoOp()
{
	wxString array_da_segno[3];
	array_da_segno[0] = "D.S.";
	array_da_segno[1] = "D.S. al Fine";
	array_da_segno[2] = "D.S. al Coda";
	wxSingleChoiceDialog dialog(FrameManager::currFrame,"Select one of the following","Da Segno",3,array_da_segno);
	char tgenerico[TGENERICO_LEN]; 
	if (dialog.ShowModal() == wxID_OK) {
		sprintf(tgenerico,"%s",dialog.GetStringSelection());
		dialog.Destroy();
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Da Segno: Select Measure");
		pMusicWin->SetCommand(CMD_BATTUTA_TSALTO,IMMEDIATE_SEL,BATTUTA_SEL,0,0,0,0,0,tgenerico);
	}
	else
		Scr->GSetMainDrawArea();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}


EventResult CLetteraOp()
{
	
	pMusicWin->GestLabel();
	return ER_CONTINUE;
	
	
}


static EventResult CSegnoOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Segno: Select Measure");
	pMusicWin->SetCommand(CMD_BATTUTA_SEGNO,IMMEDIATE_SEL,BATTUTA_SEL);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

static EventResult CCodaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Coda: Select Measure");
	pMusicWin->SetCommand(CMD_BATTUTA_CODA,IMMEDIATE_SEL,BATTUTA_SEL);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}


static EventResult CFineOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Fine: Select Measure");
	pMusicWin->SetCommand(CMD_BATTUTA_TSALTO,IMMEDIATE_SEL,BATTUTA_SEL,0,0,0,0,0,"Fine");
	pMusicWin->HideTagli();
	return ER_CONTINUE;
	
}


void CreateHorizontalsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_HORIZONTALS_ID, x, y, orizzontal);
	Menu *pm= new Menu(" Horizontals Menu", SYMB_HORIZONTALS_ID, 11, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateHorizontalsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)COD_LEGATURA,nMenuFont,CAddLegaturaOp,ABIL_LEGATURA);
	pm->SetTextItem(2,(unsigned char *)COD_CRESCENDO,nMenuFont,CAddForcellaCrescOp,ABIL_FORCELLA);
	pm->SetTextItem(3,(unsigned char *)COD_DIMINUENDO,nMenuFont,CAddForcellaDiminOp,ABIL_FORCELLA);
	pm->SetTextItem(4,(unsigned char *)"8va",nTextFont,CModifOttOp,ABIL_OTTAVA);
	pm->SetTextItem(5,(unsigned char *)"8ba",nTextFont,CModifOttbaOp,ABIL_OTTAVA);
	pm->SetTextItem(6,(unsigned char *)"15ma",nTextFont,CModifQuindOp,ABIL_OTTAVA);
	pm->SetTextItem(7,(unsigned char *)"15ba",nTextFont,CModifQuindbaOp,ABIL_OTTAVA);
	pm->SetTextItem(8,(unsigned char *)INTFRECCIA,nMenuFont,CFrecciaOp,ABIL_ONDA);
	pm->SetTextItem(9,(unsigned char *)INTONDA,nMenuFont,COndaOp,ABIL_ONDA);
	pm->SetTextItem(10,(unsigned char *)"Bend",nTextFont,CBendOp,ABIL_CAMBIORIT);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}


void CreateRefrainsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_REFRAINS_ID, x, y, orizzontal);
	
	Menu *pm= new Menu(" Refrains Menu", SYMB_REFRAINS_ID, 9, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateRefrainsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)" | | | |",nTextFont,CScansioneOp);
	pm->SetTextItem(2,(unsigned char *)"Jmp",nTextFont,CTSaltoOp);
	pm->SetTextItem(3,(unsigned char *)CAMBIARIT,nMenuFont,CCambiaRitOp,ABIL_CAMBIORIT);
	pm->SetTextItem(4,(unsigned char *)COD_SEGNO,nMenuFont,CSegnoOp);
	pm->SetTextItem(5,(unsigned char *)COD_CODA,nMenuFont,CCodaOp);
	pm->SetTextItem(6,(unsigned char *)COD_FINE,nMenuFont,CFineOp);
	pm->SetTextItem(7,(unsigned char *)COD_DACAPO,nMenuFont,CDaCapoOp);
	pm->SetTextItem(8,(unsigned char *)COD_DASEGNO,nMenuFont,CDaSegnoOp);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}

/*
*
*	Menu ImpostaPartitura/Giustificazione
*
*/


EventResult CBatAddSp()
{    
	Scr->GSetMainDrawArea();
	if(SimbImg)
		pMusicWin->SetCommand(CMD_BATTUTA_SPACE_ADD,INSERT_SEL,BATTUTA_SEL,0,mainLay);
	else
		pMusicWin->SetCommand(CMD_BATTUTA_SPACE_ADD,IMMEDIATE_SEL,FIGURA_SEL,
		0,0,0,0,0,"");
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CBatSubSp()
{
	Scr->GSetMainDrawArea();
	if(SimbImg)
		pMusicWin->SetCommand(CMD_BATTUTA_SPACE_SUB,INSERT_SEL,BATTUTA_SEL,0,mainLay);
	else
		pMusicWin->SetCommand(CMD_BATTUTA_SPACE_SUB,IMMEDIATE_SEL,FIGURA_SEL,
		0,0,0,0,0,"");
	pMusicWin->HideTagli();
	return ER_CONTINUE;	
}

EventResult CJustifAllOp()
{
	Scr->GSetMainDrawArea();
	
	pMusicWin->SetCommand(CMD_PARTITURA_JUSTIFY,NO_SEL,ANY_SEL);
	pMusicWin->DoCommand();
	
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CLineBreakOp()
{
	Scr->GSetMainDrawArea();
	
	AutoLineBreak=!AutoLineBreak;
	pMusicWin->Redraw();
	return ER_CONTINUE;
}

EventResult DebugMillaInsOp()
{
	
	// MILLA debugger
	Scr->GSetMainDrawArea();
	Setmessagedisplay("Select Symbol or Call Insert Toolbar");
	pMusicWin->SetCommand(CMD_DEBUGMILLA_SEL_SYMBOL,IMMEDIATE_SEL,ANY_SEL);
	pMusicWin->HideTagli();
	
	// ho cliccato su ins: se pos era selezionato lo deseleziono	
	// se pos non era selezionato lo lascio com'e'
	
	if (DebugNormalMillaPos)
		DebugNormalMillaPos=!DebugNormalMillaPos;
    
	
	DebugNormalMilla=!DebugNormalMilla;
	
	return ER_CONTINUE;
	
}


EventResult DebugMillaPosOp()
{
	
	// MILLA debugger
	Scr->GSetMainDrawArea();
	Setmessagedisplay("Select Symbol");
	pMusicWin->SetCommand(CMD_DEBUGMILLA_SEL_SYMBOL,IMMEDIATE_SEL,ANY_SEL);
	pMusicWin->HideTagli();
	
	// ho cliccato su pos: se ins era selezionato lo deseleziono	
	// se ins non era selezionato lo lascio com'e'
	
	if (DebugNormalMilla)
		DebugNormalMilla=!DebugNormalMilla;
	
	
	DebugNormalMillaPos=!DebugNormalMillaPos;
	
	return ER_CONTINUE;
	
}


EventResult CAddLegaturaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Slur: Select Notes");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_LEGATURA,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota,DrawInt,"",0,0,lineType);
	
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CAddForcellaCrescOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Crescendo: Select Figures");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_FORC_CRESC,TWO_SEL,FIGURA_SEL,
		mainLay,0,0,aboveNota,DrawInt,"",0,0,lineType);
	
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CAddForcellaDiminOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Diminuendo: Select Figures");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_FORC_DIMIN,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota,DrawInt,"",0,0,lineType);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CModifOttOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Change 8va: Select Figures");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_MODIF8,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CModifOttbaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Change 8ba: Select Figures");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_MODIF8BA,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CModifQuindOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Change 15ma: Select Figures");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_MODIF15MA,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CModifQuindbaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Change 15ba: Select Figures");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_MODIF15BA,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CFrecciaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Arrow: Select Figures");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_FRECCIA,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota,DrawInt);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult COndaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Wave: Select Figures");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_ONDA,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota,DrawInt);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CBeamOp()
{
  Scr->GSetMainDrawArea();
  Setmessagedisplay(" Beam: Select Figures");
//   pMusicWin->SetCommand(CMD_SPARTITO_ADD_ONDA,TWO_SEL,FIGURA_SEL,
// 		      mainLay,0,0,aboveNotaLeg[mainLay-1]);
  MusicEditor->SetCommand(CMD_SPARTITO_ADD_BEAM,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota,DrawInt);
  MusicEditor->HideTagli();
  return ER_CONTINUE;
}

EventResult CCambiaRitOp()
{
	short num;
	if ( InputNumber("Insert the number (0-9)",numero,1,"Change Refrain",num))
	{  
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Change Refrain: Select Figures");
		MusicEditor->SetCommand(CMD_SPARTITO_ADD_CAMBIO_RIT,TWO_SEL,FIGURA_SEL,
			mainLay,num+'0',0,aboveNota,DrawInt);
		MusicEditor->HideTagli();
	}
	else
		Scr->GSetMainDrawArea();
	
	return ER_CONTINUE;
}

EventResult CTrilloOndaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Trill-: Select Figures");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_TRILLOONDA,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota,DrawInt);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPedaleFinoAOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Ped-*: Select Figures");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_PEDALE,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota,DrawInt);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CBendOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Bend: Select Figures");
	MusicEditor->SetCommand(CMD_SPARTITO_ADD_BEND,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota,DrawInt,"",0,0,lineType);
	
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CSillabaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Sillaba: Select Figure");
	pMusicWin->SetCommand(CMD_SPARTITO_ADD_SILLABA,TWO_SEL,FIGURA_SEL,
		      mainLay,0,0,aboveNota,DrawInt);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CLayerInterv()
{ 
	SymCmd *SC = pMusicWin->GetSymCmd();
	
	if (mainLay == 1) 
		mainLay = 2;
	else
		mainLay = 1;
	
	Setmessagedisplay(" Changed Layer");
	pMusicWin->SetCommand(SC->CommandId, SC->SelectionType, SC->SelObjType, 
		mainLay, SC->ArgV[1], SC->ArgV[2], aboveNota, SC->ArgV[4], SC->Text,
		SC->ArgV[5],SC->ArgV[6],SC->ArgV[7],SC->ArgV[8]);
	
	
	
	return ER_CONTINUE;
}



EventResult CTranspose()
{
	Scr->GSetMainDrawArea();
	
	pMusicWin->SetCommand(CMD_PARTITURA_TRANSPOSE,NO_SEL,ANY_SEL);
	pMusicWin->DoCommand();
	
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}


void DrawTremolo3(const class Rectangle& r);

EventResult CCoronaOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Fermata Med: Select Note or Rest");
	MusicEditor->SetCommand(CMD_FIGURA_CORONA,IMMEDIATE_SEL,FIGURA_SEL,aboveNota);
	
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CCoronaQuadOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Fermata Long: Select Note or Rest");
	pMusicWin->SetCommand(CMD_FIGURA_CORONAQUAD,IMMEDIATE_SEL,FIGURA_SEL,aboveNota);
	
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CCoronaTriangOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Fermata Short: Select Note or Rest");
	pMusicWin->SetCommand(CMD_FIGURA_CORONATRIANG,IMMEDIATE_SEL,FIGURA_SEL,aboveNota);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CSuddivisioneOp()
{
	short num;
	if ( InputNumber("Insert the number of cuts ",numero,1,"Suddivisione Nota",num))
	{  
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Suddivisione Nota: Select Note");
		MusicEditor->SetCommand(CMD_NOTA_SUDDIVISIONE,IMMEDIATE_SEL,NOTA_SEL,num);
		MusicEditor->HideTagli();
	}
	else
		Scr->GSetMainDrawArea();
	
	return ER_CONTINUE;
}



EventResult CSopra()
{
	aboveNota = (TipoInserimento)((aboveNota + 1) % ((int)AUTOMATICO+1));
	
	SymCmd *SC = pMusicWin->GetSymCmd();
	
	switch(SC->CommandId)
	{
	case CMD_BATTUTA_NOTE2GRUPPONOTE:
	case CMD_SPARTITO_ADD_LEGATURA:
	case CMD_SPARTITO_ADD_FORC_CRESC:
	case CMD_SPARTITO_ADD_FORC_DIMIN:
	case CMD_SPARTITO_ADD_MODIF8:
	case CMD_SPARTITO_ADD_MODIF15MA:
	case CMD_SPARTITO_ADD_MODIF8BA:
	case CMD_SPARTITO_ADD_MODIF15BA:
	case CMD_SPARTITO_ADD_FRECCIA:
	case CMD_SPARTITO_ADD_ONDA:
	case CMD_SPARTITO_ADD_BEAM:
	case CMD_SPARTITO_ADD_CAMBIO_RIT:
	case CMD_SPARTITO_ADD_LEG_QUADRA:
        pMusicWin->SetCommand(SC->CommandId, SC->SelectionType, SC->SelObjType,
			SC->ArgV[0],SC->ArgV[1], SC->ArgV[2], aboveNota, SC->ArgV[4], SC->Text,
			SC->ArgV[5],SC->ArgV[6], SC->ArgV[7],SC->ArgV[8]);
		break;
	case CMD_BATTUTA_INS_NBREVE:
	case CMD_BATTUTA_INS_NSEMIBREVE:
	case CMD_BATTUTA_INS_NMINIMA:
	case CMD_BATTUTA_INS_NSEMIMINIMA:
	case CMD_BATTUTA_INS_NCROMA:
	case CMD_BATTUTA_INS_NSEMICROMA:
	case CMD_BATTUTA_INS_NBISCROMA:
	case CMD_BATTUTA_INS_NSEMIBISCROMA:
	case CMD_BATTUTA_INS_NFUSA:
	case CMD_BATTUTA_INS_PQUABATT:
	case CMD_BATTUTA_INS_PDUEBATT:
	case CMD_BATTUTA_INS_PSEMIBREVE:
	case CMD_BATTUTA_INS_PMINIMA:
	case CMD_BATTUTA_INS_PSEMIMINIMA:
	case CMD_BATTUTA_INS_PCROMA:
	case CMD_BATTUTA_INS_PSEMICROMA:
	case CMD_BATTUTA_INS_PBISCROMA:
	case CMD_BATTUTA_INS_PSEMIBISCROMA:
	case CMD_BATTUTA_INS_PFUSA:
        pMusicWin->SetCommand(SC->CommandId, SC->SelectionType, SC->SelObjType,
			SC->ArgV[0], SC->ArgV[1], aboveNota, SC->ArgV[3], SC->ArgV[4], SC->Text,
			SC->ArgV[5],SC->ArgV[6], SC->ArgV[7],SC->ArgV[8]);
		break;
	default:
        pMusicWin->SetCommand(SC->CommandId, SC->SelectionType, SC->SelObjType,
			aboveNota, SC->ArgV[1], SC->ArgV[2], SC->ArgV[3], SC->ArgV[4], SC->Text,
			SC->ArgV[5],SC->ArgV[6], SC->ArgV[7],SC->ArgV[8]);
	}
	return ER_CONTINUE;
}





void DrawAccento(const class Rectangle& r);
void DrawMartellato(const class Rectangle& r);
void DrawStaccato(const class Rectangle& r);
void DrawTenuto(const class Rectangle& r);
void DrawPuntoAll(const class Rectangle& r);
void DrawSforzato(const class Rectangle& r);
void DrawMartDolce(const class Rectangle& r);


void CreateExpressionsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_EXPRESSIONS_ID, x, y, orizzontal);
	
	Menu *pm= new Menu(" Expressions Menu", SYMB_EXPRESSIONS_ID, 8, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateExpressionsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetImageItem(1,DrawStaccato,CStaccatoOp);
	pm->SetImageItem(2,DrawAccento,CAccentoOp);
	pm->SetImageItem(3,DrawMartellato,CMartellatoOp);
	pm->SetImageItem(4,DrawSforzato,CSforzatoOp);
	pm->SetImageItem(5,DrawTenuto,CTenutoOp);
	pm->SetImageItem(6,DrawMartDolce,CMartDolceOp);
	pm->SetImageItem(7,DrawPuntoAll,CPuntoAllOp);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}

void DrawEspressione(const class Rectangle& r,char codEsp,int i)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	pent=r.Center();
	Scr->TextTo(pent+Point(0,-18));    
	Scr->OutText((unsigned char *)COD_NOTA);
	Scr->TextTo(pent+Point(0,-12));
	cod[0]=codEsp;
	Scr->OutText((unsigned char *)cod);
	Scr->SetFont(ofont);
}

void DrawAccento(const class Rectangle& r)
{
	DrawEspressione(r,COD_ACCENTO,1);
}

void DrawMartellato(const class Rectangle& r)
{
	DrawEspressione(r,COD_MARTELLATO,1);
}

void DrawStaccato(const class Rectangle& r)
{
	DrawEspressione(r,COD_STACCATO,1);
}

void DrawTenuto(const class Rectangle& r)
{
	DrawEspressione(r,COD_TENUTO,1);
}

void DrawSforzato(const class Rectangle& r)
{
	DrawEspressione(r,COD_SFORZATO,1);
}

void DrawMartDolce(const class Rectangle& r)
{
	DrawEspressione(r,COD_MARTDOLCE,1);
}

void DrawPuntoAll(const class Rectangle& r)
{
	DrawEspressione(r,COD_PUNTOALL,1);
}

/*********************************************************************************/
// variabili di stato del menu generic expressions //

Menu *EspGenMenu=NULL;
#define MAXDIMMENUGENERIC 20
#define MAXINCREMENTO 20
int startpos=0;


/*********************************************************************************/
void CreateGenericExpMenu()
{
	unsigned char *buf;
	int x, y;
	bool orizzontal;
	int maxdim,maxnum=simboli.GetSymbolUsage();
	
	if (maxnum>MAXDIMMENUGENERIC)
	{
		maxdim=MAXDIMMENUGENERIC;
	}
	else
		maxdim=maxnum;
	
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_GENERICEXP_ID, x, y, orizzontal);
	
	Menu *pm= new Menu(" GenericExp Menu", SYMB_GENERICEXP_ID, maxdim+3, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateGenericExpMenu()");
	
	EspGenMenu=pm;
	
	FontID ofont,tmpfont;
	ofont=Scr->SetFont(nTextFont);
	// quindi font_tmp e il font che si stava usando prima di entrare qui
	int font_id, charid;
	
	pm->SetTextItem(1,(unsigned char *)"<",nTextFont,CEspPrevGenericOp);
	
	for(int i=1; i<=maxdim; i++)
	{
		charid=i+startpos-1;
		buf= new unsigned char[2];
		buf[0]=(unsigned char)(simboli.GetCode(charid));
		buf[1]=0;
		font_id=simboli.GetGroupPos(simboli.GetGroup(charid))+6;
		// i font generici cominciano da id=6 fino ad un massimo di 10+6 
		tmpfont=Scr->SetFont(font_id);
		pm->SetTextItem(i+1,(unsigned char *)buf,font_id,CEspGenericOp);
	}
	
	i++;
	pm->SetTextItem(i,(unsigned char *)">",nTextFont,CEspNextGenericOp);
	
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}

/*********************************************************************************/
EventResult CEspGenericOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Generic Expressions: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_ESPGENERIC,IMMEDIATE_SEL,NOTA_SEL,aboveNota,EspGenMenu->GetLastPress()+startpos-2);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

/*********************************************************************************/
EventResult CEspNextGenericOp()
{ 
	unsigned char *buf;
	
	Menu *pm = (Menu *)LiooListWidget.GetNodoItemID(SYMB_GENERICEXP_ID);  
	if (pm==NULL) 
	{
		EM.Error(MUSICAL_ERR_AREA,"EC_LISTA_ELEMENTO_NON_PRESENTE","LiooMenu","TipoString()");
		return FALSE;
	}
	
	int maxdim,maxnum=simboli.GetSymbolUsage();
	startpos+=MAXINCREMENTO;
	
	if (startpos+MAXDIMMENUGENERIC>maxnum) 
	{   
		startpos=maxnum-MAXDIMMENUGENERIC;
		if (startpos<0)
			startpos=0;
	}
	
	if (maxnum>=startpos+MAXDIMMENUGENERIC)
		maxdim=MAXDIMMENUGENERIC;
	else 
		maxdim=maxnum;
	
	FontID ofont, tmpfont;
	ofont=Scr->SetFont(nMusicFont2);
	// quindi font_tmp e il font che si stava usando prima di entrare qui
	
	int font_id, charid;
	
	for(int i=1; i<=maxdim; i++)
	{
		charid=i+startpos-1;
		buf= new unsigned char[2];
		buf[0]=(unsigned char)(simboli.GetCode(charid));
		buf[1]=0;
		font_id=simboli.GetGroupPos(simboli.GetGroup(charid)) +6;
		// i font generici cominciano da id=6 fino ad un massimo di 10+6 
		tmpfont=Scr->SetFont(font_id);
		pm->ChangeTextItem(i+1,(unsigned char *)buf, font_id);
	}
	
	Scr->SetFont(ofont);  
	return ER_CONTINUE;
}

/*********************************************************************************/
EventResult CEspPrevGenericOp()
{ 
	unsigned char *buf;
	Menu *pm = (Menu *)LiooListWidget.GetNodoItemID(SYMB_GENERICEXP_ID);  
	if (pm==NULL) 
	{
		EM.Error(MUSICAL_ERR_AREA,"EC_LISTA_ELEMENTO_NON_PRESENTE","LiooMenu","TipoString()");
		return FALSE;
	}
	
	int maxdim,maxnum=simboli.GetSymbolUsage();
	startpos-=MAXINCREMENTO;
	if (startpos<0) 
		startpos=0;
	
	if (maxnum>=startpos+MAXDIMMENUGENERIC)
		maxdim=MAXDIMMENUGENERIC;
	else 
		maxdim=maxnum;
	
	FontID ofont, font_tmp;
	font_tmp=ofont=Scr->SetFont(nMusicFont2);
	// quindi font_tmp e il font che si stava usando prima di entrare qui
	
	int font_id, charid;
	
	for(int i=1; i<=maxdim; i++)
	{
		charid=i+startpos-1;
		buf= new unsigned char[2];
		buf[0]=(unsigned char)(simboli.GetCode(charid));
		buf[1]=0;
		font_id=simboli.GetGroupPos(simboli.GetGroup(charid)) +6;
		// i font generici cominciano da id=6 fino ad un massimo di 10+6 
		ofont=Scr->SetFont(font_id);
		pm->ChangeTextItem(i+1,(unsigned char *)buf, font_id);
	}
	
	Scr->SetFont(font_tmp);  
	return ER_CONTINUE;
}

/*********************************************************************************/
EventResult CStaccatoOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Staccato: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_STACCATO,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CAccentoOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Accent: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_ACCENTO,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CMartellatoOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Martellato: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_MARTELLATO,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CSforzatoOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Sforzato: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_SFORZATO,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CTenutoOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Tenuto: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_TENUTO,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CMartDolceOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Martellato dolce: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_MARTDOLCE,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPuntoAllOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Punto allungato: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_PUNTOALL,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

void DrawMSuperiore(const class Rectangle& r);
void DrawMInferiore(const class Rectangle& r);
void DrawGSuperiore1(const class Rectangle& r);
void DrawGInferiore1(const class Rectangle& r);
void DrawGSuperiore2(const class Rectangle& r);
void DrawGInferiore2(const class Rectangle& r);
void DrawM2Superiore(const class Rectangle& r);
void DrawM2Inferiore(const class Rectangle& r);
void DrawGlissato(const class Rectangle& r);
void DrawTurnSlash(const class Rectangle& r);
void DrawTurnUp(const class Rectangle& r);
void DrawGlissonda(const class Rectangle& r);

void CreateOrnamentsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_ORNAMENTS_ID, x, y, orizzontal);
	
	Menu *pm= new Menu(" Ornaments Menu", SYMB_ORNAMENTS_ID, 19, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateOrnamentsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)COD_TRILLO,nMenuFont,CTrilloOp);
	pm->SetTextItem(2,(unsigned char *)COD_TRILLO COD_ONDA,nMenuFont,CTrilloOndaOp);
	pm->SetImageItem(3,DrawGSuperiore1,CGSup1Op);
	pm->SetImageItem(4,DrawGInferiore1,CGInf1Op);
	pm->SetImageItem(5,DrawTurnSlash,CTurnSlashOp);
	pm->SetImageItem(6,DrawTurnUp,CTurnUpOp);
	pm->SetImageItem(7,DrawGSuperiore2,CmdNotImplem);
	pm->SetImageItem(8,DrawGInferiore2,CmdNotImplem);
	pm->SetImageItem(9,DrawMSuperiore,CMSupOp);
	pm->SetImageItem(10,DrawMInferiore,CMInfOp);
	pm->SetImageItem(11,DrawM2Superiore,CM2SupOp);
	pm->SetImageItem(12,DrawM2Inferiore,CM2InfOp);
	pm->SetImageItem(13,DrawTremolo3,CTremoloOp);
	pm->SetImageItem(14,DrawGlissato,CGlissatoOp);
	pm->SetImageItem(15,DrawGlissonda,CGlissondaOp);
	pm->SetTextItem(16,(unsigned char *)COD_ARPEGGIO,nMenuFont,CArpeggioOp);
	pm->SetTextItem(17,(unsigned char *)COD_ARPEGGIO_UP,nMenuFont,CArpeggioUpOp);
	pm->SetTextItem(18,(unsigned char *)COD_ARPEGGIO_DOWN,nMenuFont,CArpeggioDownOp);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}

void CreateKoreanOrnamentsMenu()
{
   int x, y;
   bool orizzontal;
   SMRApp::GetApp().workspace->GetMenuConfig(SYMB_KOREANORNAMENTS_ID, x, y, orizzontal);

   Menu *pm= new Menu(" Korean Ornaments Menu", SYMB_KOREANORNAMENTS_ID, 9, orizzontal);
   if(!pm)
    EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateKoreanOrnamentsMenu()");

   FontID ofont=Scr->SetFont(nMenuFont);

   pm->SetTextItem(1,(unsigned char *)COD_SLIDINGUP,nMenuFont,CSlidingUpOp);
   pm->SetTextItem(2,(unsigned char *)COD_SLIDINGDOWN,nMenuFont,CSlidingDownOp);
   pm->SetTextItem(3,(unsigned char *)COD_SLIDINGDUP,nMenuFont,CSlidingDUpOp);
   pm->SetTextItem(4,(unsigned char *)COD_SLIDINGDOWNUP,nMenuFont,CSlidingDownUpOp);
   pm->SetTextItem(5,(unsigned char *)COD_NONGHYNINC,nMenuFont,CNonghynIncOp);
   pm->SetTextItem(6,(unsigned char *)COD_NONGHYNDEC,nMenuFont,CNonghynDecOp);
   pm->SetTextItem(7,(unsigned char *)COD_NONGHYNNARROW,nMenuFont,CNonghynArrowOp);
   pm->SetTextItem(8,(unsigned char *)COD_NONGHYNWIDE,nMenuFont,CNonghynWideOp);
   pm->CalcolaDimensioni();
   pm->Realize(x, y);

   LiooListWidget.Add(pm);
   Scr->SetFont(ofont);
}

EventResult CSlidingUpOp()
{ 	
	short num;
	
	Scr->GSetMainDrawArea();
	num=0;
    Setmessagedisplay(" Sliding Up: Select Note");
    MusicEditor->SetCommand(CMD_NOTA_SLIDING_UP,IMMEDIATE_SEL,NOTA_SEL,aboveNota,num);
    MusicEditor->HideTagli();
	
	return ER_CONTINUE;
}

EventResult CSlidingDownOp()
{
	short num;
	
	Scr->GSetMainDrawArea();
	num=0;
    Setmessagedisplay(" Sliding Down: Select Note");
    MusicEditor->SetCommand(CMD_NOTA_SLIDING_DOWN,IMMEDIATE_SEL,NOTA_SEL,aboveNota,num);
    MusicEditor->HideTagli();
	
	return ER_CONTINUE;
}

EventResult CSlidingDUpOp()
{
	short num;
	
	Scr->GSetMainDrawArea();
	num=0;
    Setmessagedisplay(" Sliding DUp: Select Note");
    MusicEditor->SetCommand(CMD_NOTA_SLIDING_DUP,IMMEDIATE_SEL,NOTA_SEL,aboveNota,num);
    MusicEditor->HideTagli();
	
	return ER_CONTINUE;
}

EventResult CSlidingDownUpOp()
{
	short num;
	
	Scr->GSetMainDrawArea();
	num=0;
    Setmessagedisplay(" Sliding DownUp: Select Note");
    MusicEditor->SetCommand(CMD_NOTA_SLIDING_DOWNUP,IMMEDIATE_SEL,NOTA_SEL,aboveNota,num);
    MusicEditor->HideTagli();
	
	return ER_CONTINUE;
}

EventResult CNonghynIncOp()
{
	short num;
	
	Scr->GSetMainDrawArea();
	num=0;
    Setmessagedisplay(" Nonghyn Inc: Select Note");
    MusicEditor->SetCommand(CMD_NOTA_NONGHYN_INC,IMMEDIATE_SEL,NOTA_SEL,aboveNota,num);
    MusicEditor->HideTagli();
	
	return ER_CONTINUE;
}

EventResult CNonghynDecOp()
{
	short num;
	
	Scr->GSetMainDrawArea();
	num=0;
    Setmessagedisplay(" Nonghyn Dec: Select Note");
    MusicEditor->SetCommand(CMD_NOTA_NONGHYN_DEC,IMMEDIATE_SEL,NOTA_SEL,aboveNota,num);
    MusicEditor->HideTagli();
	
	return ER_CONTINUE;
}

EventResult CNonghynArrowOp()
{
	short num;
	
	Scr->GSetMainDrawArea();
	num=0;
    Setmessagedisplay(" Nonghyn Arrow: Select Note");
    MusicEditor->SetCommand(CMD_NOTA_NONGHYN_ARROW,IMMEDIATE_SEL,NOTA_SEL,aboveNota,num);
    MusicEditor->HideTagli();
	
	return ER_CONTINUE;
}

EventResult CNonghynWideOp()
{
	short num;
	
	Scr->GSetMainDrawArea();
	num=0;
    Setmessagedisplay(" Nonghyn Wide: Select Note");
    MusicEditor->SetCommand(CMD_NOTA_NONGHYN_WIDE,IMMEDIATE_SEL,NOTA_SEL,aboveNota,num);
    MusicEditor->HideTagli();
	
	return ER_CONTINUE;
}

void DrawGlissato(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	
	
	pent=r.Center()+Point(-12,-16);
	Scr->TextTo(pent);
	
	Scr->OutText((unsigned char *)COD_GLISSATO);
	
	Scr->SetFont(ofont);
}

void DrawGlissonda(const class Rectangle& r)
{
	Point pent;
	int i;
	int ofont=Scr->SetFont(nMenuFont);
	
	Colore oldcol = Scr->GetColor();
	Scr->SetColor((ColorIcon)black);
	pent=r.Center()+Point(-12,-13);
	Scr->TextTo(pent);
	
	Scr->SetFont(ofont);
	VUnit ax = -12, bx = 12;
	int T = (bx - ax)/2;
	VUnit x[33];
	VUnit width = 1;
	for (i=0;i<=33;i++)
		x[i] = ax+i*width;
	VUnit y[41];
	for (i=0;i<33;i++)
	{
		y[i] = 5*sin(2*3.14*x[i]/T) + 0.5*x[i];
	}
	for (i=0;i<32;i++)
	{
		Scr->Line(r.Center() + Point(x[i],y[i]) , r.Center() + Point(x[i+1],y[i+1]) );
	}
	Scr->Line(r.Center() + Point(x[0],0.5*x[0]), r.Center() + Point(x[32],0.5*x[32]));
	Scr->SetColor(oldcol);
}

void DrawGruppetto1(const class Rectangle& r,char codGrp)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	
	pent=r.Center()+Point(-6,-17);  
	Scr->TextTo(pent);
	Scr->OutText((unsigned char *)COD_NOTA);
	Scr->TextTo(pent+Point(DXGRUP,DYGRUP));
	cod[0]=codGrp;
	Scr->OutText((unsigned char *)cod);
	Scr->SetFont(ofont);
}

void DrawGruppetto2(const class Rectangle& r,char codGrp)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	
	pent=r.Center()+Point(DGX,DGY-5);
	Scr->TextTo(pent-Point(DXNOTA,DYNOTA));
	Scr->OutText((unsigned char *)COD_NOTA);
	Scr->TextTo(pent+Point(DXGRUP,DYGRUP));
	cod[0]=codGrp;
	Scr->OutText((unsigned char *)cod);
	Scr->TextTo(pent+Point(DXNOTA,DYNOTA));
	Scr->OutText((unsigned char *)COD_NOTA);
	
	Scr->SetFont(ofont);
}

void DrawTurnSlash(const class Rectangle& r)
{
	DrawGruppetto1(r,COD_TURNSLASH);
}

void DrawTurnUp(const class Rectangle& r)
{
	DrawGruppetto1(r,COD_TURNUP);
}

void DrawGSuperiore1(const class Rectangle& r)
{
	DrawGruppetto1(r,COD_GSUP);
}

void DrawGInferiore1(const class Rectangle& r)
{
	DrawGruppetto1(r,COD_GINF);
}

void DrawGSuperiore2(const class Rectangle& r)
{
	DrawGruppetto2(r,COD_GSUP);
}

void DrawGInferiore2(const class Rectangle& r)
{
	DrawGruppetto2(r,COD_GINF);
}

void DrawMordente(const class Rectangle& r,char codMor)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	
	pent=r.Center()+Point(DMX,DMY);
	Scr->TextTo(pent);
	Scr->OutText((unsigned char *)COD_NOTA);
	Scr->TextTo(pent+Point(DXMORD,DYMORD-3));
	cod[0]=codMor;
	Scr->OutText((unsigned char *)cod);
	Scr->SetFont(ofont);
}

void DrawMSuperiore(const class Rectangle& r)
{
	DrawMordente(r,COD_MSUP);
}

void DrawM2Superiore(const class Rectangle& r)
{
	DrawMordente(r,COD_M2SUP);
}

void DrawMInferiore(const class Rectangle& r)
{
	DrawMordente(r,COD_MINF);
}

void DrawM2Inferiore(const class Rectangle& r)
{
	DrawMordente(r,COD_M2INF);
}

void DrawTremolo(const class Rectangle& r,char numBar)
{
	Point pent;
	int i;
	int ofont=Scr->SetFont(nMenuFont);
	
	pent=r.Center()+Point(-6,-17);
	for(i=0;i<numBar;i++)
	{
		switch (i)
		{
		case 0:
			Scr->TextTo(pent);
			break;
		case 1:
			Scr->TextTo(pent+Point(0,+4));
			break;
		case 2:
			Scr->TextTo(pent+Point(0,-4));
			break;
		case 3:
			Scr->TextTo(pent+Point(0,+8));
			break;
		case 4:
			Scr->TextTo(pent+Point(0,-8));
			break;
		default:
			Scr->TextTo(pent);
			break;
		}
		
		Scr->OutText((unsigned char *)COD_TREMOLO);
	}
	Scr->SetFont(ofont);
}


void DrawTremolo3(const class Rectangle& r)
{
	DrawTremolo(r,3);
}



EventResult CTremoloOp()
{ 
	short num;
	if ( InputNumber("Insert the number of lines (1-5): ",numero,1,"Tremolo",num))
	{
		Scr->GSetMainDrawArea();
		if ((num>5) || (num<1)) num = 3;
		Setmessagedisplay(" Tremolo: Select Note");
		MusicEditor->SetCommand(CMD_NOTA_TREMOLO,IMMEDIATE_SEL,NOTA_SEL,num);
		MusicEditor->HideTagli();
	}
	else
		Scr->GSetMainDrawArea();
	
	return ER_CONTINUE;
}

EventResult CGlissatoOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Glissato: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_GLISSATO,IMMEDIATE_SEL,NOTA_SEL,1);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CGlissondaOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Gliss-wave: Select Note");
	pMusicWin->SetCommand(CMD_NOTA_GLISSONDA,IMMEDIATE_SEL,NOTA_SEL,1);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CTrilloOp()
{ 
	
	short num;
	
	Scr->GSetMainDrawArea();
	num=0;
    Setmessagedisplay(" Trill: Select Note");
    MusicEditor->SetCommand(CMD_NOTA_TRILLO,IMMEDIATE_SEL,NOTA_SEL,aboveNota,num);
    MusicEditor->HideTagli();
	
	return ER_CONTINUE;
}

EventResult CGSup1Op()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Gruppetto Sup: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_GRUPPETTO_SUP_1,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CTurnSlashOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Gruppetto Sup: Select Note");
	pMusicWin->SetCommand(CMD_NOTA_TURN_SLASH,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CTurnUpOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Gruppetto Sup: Select Note");
	pMusicWin->SetCommand(CMD_NOTA_TURN_UP,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}


EventResult CGInf1Op()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Gruppetto Inf: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_GRUPPETTO_INF_1,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CMSupOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Mordente Sup: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_MORDENTE_SUP,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CM2SupOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Mordente Doppio Sup: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_MORDENTE2_SUP,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CMInfOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Mordente Inf: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_MORDENTE_INF,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CM2InfOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Mordente Doppio Inf: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_MORDENTE2_INF,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}


EventResult CArpeggioOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Arpeggio: Select Chord");
	MusicEditor->SetCommand(CMD_ACCORDO_ARPEGGIO,IMMEDIATE_SEL,NOTA_SEL);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CArpeggioUpOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Arpeggio Up: Select Chord");
	pMusicWin->SetCommand(CMD_ACCORDO_ARPEGGIO_UP,IMMEDIATE_SEL,NOTA_SEL);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CArpeggioDownOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Arpeggio Down: Select Chord");
	pMusicWin->SetCommand(CMD_ACCORDO_ARPEGGIO_DOWN,IMMEDIATE_SEL,NOTA_SEL);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}





EventResult CTDinamico()
{ 
	
	wxString array_dynamics[30];
	array_dynamics[0]  = "PPPPPP";
	array_dynamics[1]  = "PPPPP";
	array_dynamics[2]  = "PPPP";
	array_dynamics[3]  = "PPP";
	array_dynamics[4]  = "PP";
	array_dynamics[5]  = "P";
	array_dynamics[6]  = "MP";
	array_dynamics[7]  = "MF";
	array_dynamics[8]  = "F";
	array_dynamics[9]  = "FF";
	array_dynamics[10] = "FFF";
	array_dynamics[11] = "FFFF";
	array_dynamics[12] = "FFFFF";
	array_dynamics[13] = "FFFFFF";
	array_dynamics[14] = "FP";
	array_dynamics[15] = "FPP";
	array_dynamics[16] = "FFP";
	array_dynamics[17] = "FFPP";
	array_dynamics[18] = "SP";
	array_dynamics[19] = "SF";
	array_dynamics[20] = "SFP";
	array_dynamics[21] = "SFPP";
	array_dynamics[22] = "SFF";
	array_dynamics[23] = "SFFP";
	array_dynamics[24] = "SFFF";
	array_dynamics[25] = "SFFZ";
	array_dynamics[26] = "SFZ";
	array_dynamics[27] = "FZ";
	array_dynamics[28] = "RF";
	array_dynamics[29] = "RFZ";
	
	wxSingleChoiceDialog dialog(FrameManager::currFrame,"Select the dynamic","Dynamic Text",30,array_dynamics);
	char tcorto[TCORTO_LEN]; 
	if (dialog.ShowModal() == wxID_OK) {
		sprintf(tcorto,"%s",dialog.GetStringSelection());
		dialog.Destroy();
		Scr->GSetMainDrawArea();
		
		if (!(strcasecmp(tcorto,"PPPPPP")))
		{
			Setmessagedisplay(" PPPPPP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_PPPPPP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_PPPPPP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"PPPPP")))
		{
			Setmessagedisplay(" PPPPP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_PPPPP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_PPPPP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"PPPP")))
		{
			Setmessagedisplay(" PPPP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_PPPP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_PPPP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"PPP")))
		{
			Setmessagedisplay(" PPP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_PPP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_PPP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"PP")))
		{
			Setmessagedisplay(" Pianissimo: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_PP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_PP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"P")))
		{
			Setmessagedisplay(" Piano: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_P,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_P);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"FFFFFF")))
		{
			Setmessagedisplay(" FFFFFF: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_FFFFFF,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_FFFFFF);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"FFFFF")))
		{
			Setmessagedisplay(" FFFFF: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_FFFFF,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_FFFFF);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"FFFF")))
		{
			Setmessagedisplay(" FFFF: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_FFFF,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_FFFF);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"FFF")))
		{
			Setmessagedisplay(" FFF: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_FFF,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_FFF);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"FF")))
		{
			Setmessagedisplay(" Fortissimo: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_FF,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_FF);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"F")))
		{
			Setmessagedisplay(" Forte: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_F,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_F);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"MP")))
		{
			Setmessagedisplay(" MezzoPiano: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_MP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_MP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"MF")))
		{
			Setmessagedisplay(" MezzoForte: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_MF,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_MF);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"SP")))
		{
			Setmessagedisplay(" SP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_SP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_SP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"SF")))
		{
			Setmessagedisplay(" SF: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_SF,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_SF);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"SFZ")))
		{
			Setmessagedisplay(" SFZ: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_SFZ,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_SFZ);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"FZ")))
		{
			Setmessagedisplay(" FZ: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_FZ,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_FZ);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"FP")))
		{
			Setmessagedisplay(" FP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_FP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_FP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"RF")))
		{
			Setmessagedisplay(" RF: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_RF,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_RF);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"FFP")))
		{
			Setmessagedisplay(" FFP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_FFP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_FFP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"FFPP")))
		{
			Setmessagedisplay(" FFPP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_FFPP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_FFPP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"FPP")))
		{
			Setmessagedisplay(" FPP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_FPP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_FPP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"RFZ")))
		{
			Setmessagedisplay(" RFZ: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_RFZ,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_RFZ);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"SFF")))
		{
			Setmessagedisplay(" SFF: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_SFF,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_SFF);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"SFFF")))
		{
			Setmessagedisplay(" SFFF: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_SFFF,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_SFFF);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"SFFP")))
		{
			Setmessagedisplay(" SFFP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_SFFP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_SFFP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"SFFZ")))
		{
			Setmessagedisplay(" SFFZ: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_SFFZ,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_SFFZ);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"SFP")))
		{
			Setmessagedisplay(" SFP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_SFP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_SFP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
		if (!(strcasecmp(tcorto,"SFPP")))
		{
			Setmessagedisplay(" SFPP: Select Note");
			pMusicWin->SetCommand(CMD_FIGURA_SFPP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,TD_SFPP);
			pMusicWin->HideTagli();
			return ER_CONTINUE;
		}
  }
  else
	  Scr->GSetMainDrawArea();
  
  return ER_CONTINUE;
}


EventResult CtgenericOp()
{ 
	bool hidden=false;
	Align align;
	wxFont font;
	bool posDown=false;
	
	if ( InputGenericText(tgenerico,TGENERICO_LEN,hidden,align,font,posDown,true) )
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Generic Text: Select Note or Rest");
		MusicEditor->SetCommand(CMD_FIGURA_TGENERICO,IMMEDIATE_SEL,FIGURA_SEL,
			!posDown,hidden,0,0,0,tgenerico);
		MusicEditor->HideTagli();
	}
	else
		Scr->GSetMainDrawArea();
	
	return ER_CONTINUE;
}

EventResult CAnnotazioneOp()
{ 
	bool hidden=false;
	Align align;
	wxFont font;
	bool posDown=true;
	
	if ( InputGenericText(tgenerico,TGENERICO_LEN,hidden,align,font,posDown) )
	{
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Annotation: Select Note or Rest");
		MusicEditor->SetCommand(CMD_FIGURA_ANNOTAZIONE,IMMEDIATE_SEL,FIGURA_SEL,
			!posDown,hidden,0,0,0,tgenerico);
		MusicEditor->HideTagli();
	}
	else
		Scr->GSetMainDrawArea();
	
	return ER_CONTINUE;
}


void CreatePedalsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_PEDALS_ID, x, y, orizzontal);
	
	Menu *pm= new Menu(" Pedals Menu", SYMB_PEDALS_ID, 4, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreatePedalsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)COD_PEDALUP,nMenuFont,CPedalUpOp,ABIL_PEDALUP);
	pm->SetTextItem(2,(unsigned char *)COD_PEDALDOWN,nMenuFont,CPedalDownOp,ABIL_PEDALDOWN);
	pm->SetTextItem(3,(unsigned char *)"Ped",nTextFont,CPedaleFinoAOp,ABIL_PEDALUP);
	
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}


EventResult CPedalUpOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" PedalUp: Select Note or Rest");
	pMusicWin->SetCommand(CMD_FIGURA_PEDALUP,IMMEDIATE_SEL,FIGURA_SEL,aboveNota);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CPedalDownOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" PedalDown: Select Note or Rest");
	pMusicWin->SetCommand(CMD_FIGURA_PEDALDOWN,IMMEDIATE_SEL,FIGURA_SEL,aboveNota);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}


EventResult CSeeLinkOp(bool view)
{ 
	Scr->GSetMainDrawArea();
    if(SimbImg)
	{
		pMusicWin->PPartit->View_Link(view);
		if(view)
		{
			Setmessagedisplay(" SeeLink: Select Note or Rest");
			pMusicWin->SetCommand(CMD_FIGURA_SEELINK,IMMEDIATE_SEL,FIGURA_SEL,
				0,0,0,0,0,"");
			pMusicWin->HideTagli();
		}
		
		else
			pMusicWin->SetCommand(NO_COMMAND,IMMEDIATE_SEL,FIGURA_SEL,
			0,0,0,0,0,"");
	}
	
	return ER_CONTINUE;
}


EventResult CEditLinkOp(bool view2)
{ 
	if (SimbImg)	
	{	
		if(view2) 
		{	
			pMusicWin->PPartit->View_Link(view2);
			Scr->GSetMainDrawArea();
			Setmessagedisplay(" EditLink: Select Note or Rest");
			pMusicWin->SetCommand(CMD_FIGURA_EDITLINK,IMMEDIATE_SEL,FIGURA_SEL,
				0,0,0,0,0,"");
			pMusicWin->HideTagli();
			
		}
		else
			pMusicWin->SetCommand(NO_COMMAND,IMMEDIATE_SEL,FIGURA_SEL,
			0,0,0,0,0,"");
		pMusicWin->PPartit->View_Link(view2);
	}
	
	
	
	
	return ER_CONTINUE;
	
}


void CreateBreathGlassMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_BREATHGLASS_ID, x, y, orizzontal);
	
	Menu *pm= new Menu(" BreathGlass Menu", SYMB_BREATHGLASS_ID, 3, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateBreathGlassMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)PRFIATO,nMenuFont,CPrFiatoOp,ABIL_PRFIATO);
	pm->SetTextItem(2,(unsigned char *)COD_OCCHIALI,nMenuFont,COcchialiOp,ABIL_OCCHIALI);
	
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}



EventResult COcchialiOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Glasses:Select Note or Rest or Space");
	MusicEditor->SetCommand(CMD_FIGURA_OCCHIALI,IMMEDIATE_SEL,FIGURA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPrFiatoOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Take Breath: Select Space");
	MusicEditor->SetCommand(CMD_SPAZIO_PRFIATO,IMMEDIATE_SEL,ANY_SEL);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CTimpanoOp()
{
	Bool fl;
	int i;
	if ( InputString("Insert a text ",tgenerico,TGENERICO_LEN,"Timpano"))
	{  
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Timpano: Select Rest");
		fl = TRUE;
		fl = (fl) && (tgenerico[0] == '-') && (tgenerico[1] == '>');
		if (fl) 
			for(i=2; i<=(int)strlen(tgenerico); i++)
				tgenerico[i-2] = tgenerico[i];
			
			Setmessagedisplay(" Timpano: Select Rest");
			MusicEditor->SetCommand(CMD_PAUSA_TIMPANO,IMMEDIATE_SEL,FIGURA_SEL,
				aboveNota,fl,0,0,0,tgenerico);
			MusicEditor->HideTagli();
	}
	else
		Scr->GSetMainDrawArea();
	
	return ER_CONTINUE;
}

EventResult CChitarraOp()
{
	static char ditaBuffer[255];
	char chordsFile[255];
	
    Scr->GSetMainDrawArea();
	DitaCorde *ditaCorde;
    char *mds=smrgetenv("SMR_FONT_PATH");
	
    if(mds!=NULL)
		strcpy(chordsFile,mds);
    strcat(chordsFile,"wmed-chords.dat");
    if((ditaCorde=InputTabl(chordsFile))!=NULL)
	{
		ditaCorde->GetFullDescription(ditaBuffer,255);
		delete ditaCorde;
		ditaCorde=NULL; 
		
		Setmessagedisplay(" FretBoards: Select Figure");
		MusicEditor->SetCommand(CMD_FIGURA_DITACORDE,IMMEDIATE_SEL,FIGURA_SEL,aboveNota,0,0,0,0,ditaBuffer);
		MusicEditor->HideTagli();
	}
    return ER_CONTINUE;
}

/*
*
*	Menu Strumento/Diteggiatura
*
*/

void DrawFingerNotRounded(const class Rectangle& r);
void DrawFingerRounded1(const class Rectangle& r);
void DrawFingerRounded2(const class Rectangle& r);

void CreateFingeringMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_FINGERING_ID, x, y, orizzontal);
	
	Menu *pm= new Menu(" Fingering Menu", SYMB_FINGERING_ID, 8, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateFingeringMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)" 0",nTextFont,CDito0Op);
	pm->SetTextItem(2,(unsigned char *)" 1",nTextFont,CDito1Op);
	pm->SetTextItem(3,(unsigned char *)" 2",nTextFont,CDito2Op);
	pm->SetTextItem(4,(unsigned char *)" 3",nTextFont,CDito3Op);
	pm->SetTextItem(5,(unsigned char *)" 4",nTextFont,CDito4Op);
	pm->SetTextItem(6,(unsigned char *)" 5",nTextFont,CDito5Op);
	switch (GetTipoFinger())
	{
	case NOTROUNDED:
		pm->SetTextItem(7,(unsigned char *)"!R",nTextFont,CTipoFinger);
		break;
	case ROUNDED1:
		pm->SetTextItem(7,(unsigned char *)"R1",nTextFont,CTipoFinger);
		break;
	case ROUNDED2:
		pm->SetTextItem(7,(unsigned char *)"R2",nTextFont,CTipoFinger);
		break;
	}
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}


void DrawFingerNotRounded(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	
	pent=r.Center()+MENUCHIAVE_POSPENT;
	Scr->TextTo(pent);
	Scr->OutText((unsigned char*)"!R");
	
	Scr->SetFont(ofont);
}

void DrawFingerRounded1(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	
	pent=r.Center()+MENUCHIAVE_POSPENT;
	Scr->TextTo(pent);
	Scr->OutText((unsigned char*)"R1");
	
	Scr->SetFont(ofont);
}

void DrawFingerRounded2(const class Rectangle& r)
{
	Point pent;
	int ofont=Scr->SetFont(nMenuFont);
	char cod[]={0,0};
	
	pent=r.Center()+MENUCHIAVE_POSPENT;
	Scr->TextTo(pent);
	Scr->OutText((unsigned char*)"R2");
	
}


EventResult CTipoFinger()
{ 
	Menu *pm = (Menu *)LiooListWidget.GetNodoItemID(SYMB_FINGERING_ID);  
	if (pm==NULL) 
	{
		EM.Error(MUSICAL_ERR_AREA,"EC_LISTA_ELEMENTO_NON_PRESENTE","LiooMenu","TipoFinger()");
		return FALSE;
	}
	
	switch (GetTipoFinger())
	{
		
		Scr->GSetDrawArea(pm->GetScrDrawArea());
    case NOTROUNDED:
		TipoFinger=ROUNDED1;
		pm->ChangeTextItem(7,(unsigned char *)"R1");
		break;
    case ROUNDED1:
		TipoFinger=ROUNDED2;
		pm->ChangeTextItem(7,(unsigned char *)"R2");
		break;
    case ROUNDED2:
		TipoFinger=NOTROUNDED;
		pm->ChangeTextItem(7,(unsigned char *)"!R");
	}		 	
	return ER_CONTINUE;
}

EventResult CDito0Op()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" 0: Select Note");
	pMusicWin->SetCommand(CMD_NOTA_DITO_0,IMMEDIATE_SEL,NOTASING_SEL,aboveNota,GetTipoFinger());
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CDito1Op()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Finger 1: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_DITO_1,IMMEDIATE_SEL,NOTASING_SEL,aboveNota,GetTipoFinger());
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CDito2Op()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Finger 2: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_DITO_2,IMMEDIATE_SEL,NOTASING_SEL,aboveNota,GetTipoFinger());
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CDito3Op()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Finger 3: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_DITO_3,IMMEDIATE_SEL,NOTASING_SEL,aboveNota,GetTipoFinger());
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CDito4Op()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Finger 4: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_DITO_4,IMMEDIATE_SEL,NOTASING_SEL,aboveNota,GetTipoFinger());
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CDito5Op()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Finger 5: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_DITO_5,IMMEDIATE_SEL,NOTASING_SEL,aboveNota,GetTipoFinger());
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CDiteggiatoCircled()
{ 
	wxMessageBox(NOTYETIMPLEMENTED);
	return ER_CONTINUE;
}

/*
*
*	Menu Strumento/Sordina
*
*/

void CreateMutesMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_MUTES_ID, x, y, orizzontal);
	
	Menu *pm= new Menu(" Mutes Menu", SYMB_MUTES_ID, 4, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateMutesMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	switch (TipoSord)
	{
    case ARCHI:
		pm->SetTextItem(1,(unsigned char *)"Str",nTextFont,CTipoSord); // archi, strings
		break;
    case OTTONI:
		pm->SetTextItem(1,(unsigned char *)"Flt",nTextFont,CTipoSord); // ottoni, flutes
		break;
    case TESTO:
		pm->SetTextItem(1,(unsigned char *)"Txt",nTextFont,CTipoSord); // textual, testuale
	}    
	pm->SetTextItem(2,(unsigned char *)"Con",nTextFont,CConSordinaOp);
	pm->SetTextItem(3,(unsigned char *)"Via",nTextFont,CViaSordinaOp);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}

EventResult CTipoSord()
{
	Menu *pm = (Menu *)LiooListWidget.GetNodoItemID(SYMB_MUTES_ID);
	Scr->GSetDrawArea(pm->GetScrDrawArea());
	
	switch (TipoSord)
	{
    case ARCHI:
		TipoSord=OTTONI;
		pm->ChangeTextItem(1,(unsigned char *)"Flt");
		break;
    case OTTONI:
		TipoSord=TESTO;
		pm->ChangeTextItem(1,(unsigned char *)"Txt");
		break;
    case TESTO:
		TipoSord=ARCHI;
		pm->ChangeTextItem(1,(unsigned char *)"Str");    
	}
		 	
	return ER_CONTINUE;
}


EventResult CConSordinaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Mute On: Select Note");
	switch (TipoSord)
	{
    case ARCHI:
		MusicEditor->SetCommand(CMD_NOTA_CONSORDINAARCHI,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
		break;
    case OTTONI:
		MusicEditor->SetCommand(CMD_NOTA_CONSORDINAOTTONI,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
		break;
    case TESTO:
		MusicEditor->SetCommand(CMD_NOTA_CONSORDINATESTO,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	}
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CViaSordinaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Mute OFF: Select Note");
	switch (TipoSord)
	{
    case ARCHI:
		MusicEditor->SetCommand(CMD_NOTA_VIASORDINAARCHI,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
		break;
    case OTTONI:
		MusicEditor->SetCommand(CMD_NOTA_VIASORDINAOTTONI,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
		break;
    case TESTO:
		MusicEditor->SetCommand(CMD_NOTA_VIASORDINATESTO,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	}
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}





void CreateHarmonicsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_HARMONICS_ID, x, y, orizzontal);
	
	Menu *pm= new Menu(" Harmonics Menu", SYMB_HARMONICS_ID, 3, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateHarmonicsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)ARMONICIARCHI,nMenuFont,CArmoniciArchiOp);
	pm->SetTextItem(2,(unsigned char *)ARMONICIOTTONI,nMenuFont,CArmoniciOttoniOp);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}


EventResult CArmoniciArchiOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Harmonics Strings: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_ARMONICIARCHI,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CArmoniciOttoniOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Harmonics Brass: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_ARMONICIOTTONI,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}







void CreateStringsMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_STRINGS_ID, x, y, orizzontal);
	
	Menu *pm= new Menu(" Strings Menu", SYMB_STRINGS_ID, 11, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateStringsMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)" 0.",nTextFont,CCordaVuotaOp);
	pm->SetTextItem(2,(unsigned char *)" I.",nTextFont,CCordaUnoOp);
	pm->SetTextItem(3,(unsigned char *)" II.",nTextFont,CCordaDueOp);
	pm->SetTextItem(4,(unsigned char *)" III.",nTextFont,CCordaTreOp);
	pm->SetTextItem(5,(unsigned char *)" IV.",nTextFont,CCordaQuattroOp);
	pm->SetTextItem(6,(unsigned char *)" V.",nTextFont,CCordaCinqueOp);
	pm->SetTextItem(7,(unsigned char *)" VI.",nTextFont,CCordaSeiOp);
	pm->SetTextItem(8,(unsigned char *)" VII.",nTextFont,CCordaSetteOp);
	// Le Strings sono in carattere romano oppure normale
	if (StringsRoman) 
		pm->SetTextItem(9,(unsigned char *)"Rom",nTextFont,CStringsRoman);
	else
		pm->SetTextItem(9,(unsigned char *)"Num",nTextFont,CStringsRoman);
	
	switch (GetTipoStrings())
	{
	case NOTCIRCLED:
		pm->SetTextItem(10,(unsigned char *)"!C",nTextFont,CTipoStrings);
		break;
	case BRACKETS:
		pm->SetTextItem(10,(unsigned char *)"()",nTextFont,CTipoStrings);
		break;
	case CIRCLED1:
		pm->SetTextItem(10,(unsigned char *)"C1",nTextFont,CTipoStrings);
		break;
	case CIRCLED2:
		pm->SetTextItem(10,(unsigned char *)"C2",nTextFont,CTipoStrings);
		break;
	}
	
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}

EventResult CStringsRoman()
{
	StringsRoman++;
	StringsRoman = StringsRoman % 2;
	Menu *pm = (Menu *)LiooListWidget.GetNodoItemID(SYMB_STRINGS_ID);  
	if (pm==NULL) 
	{
		EM.Error(MUSICAL_ERR_AREA,"EC_LISTA_ELEMENTO_NON_PRESENTE","LiooMenu","TipoString()");
		return FALSE;
	}
	Scr->GSetDrawArea(pm->GetScrDrawArea());
	if (StringsRoman)
	{
		pm->ChangeTextItem(1,(unsigned char *)" 0.");
		pm->ChangeTextItem(2,(unsigned char *)" I.");
		pm->ChangeTextItem(3,(unsigned char *)" II.");
		pm->ChangeTextItem(4,(unsigned char *)" III.");
		pm->ChangeTextItem(5,(unsigned char *)" IV.");
		pm->ChangeTextItem(6,(unsigned char *)" V.");
		pm->ChangeTextItem(7,(unsigned char *)" VI.");
		pm->ChangeTextItem(8,(unsigned char *)" VII.");
		pm->ChangeTextItem(9,(unsigned char *)" Rom");
	}
	else {
		pm->ChangeTextItem(1,(unsigned char *)" 0.");
		pm->ChangeTextItem(2,(unsigned char *)" 1.");
		pm->ChangeTextItem(3,(unsigned char *)" 2.");
		pm->ChangeTextItem(4,(unsigned char *)" 3.");
		pm->ChangeTextItem(5,(unsigned char *)" 4.");
		pm->ChangeTextItem(6,(unsigned char *)" 5.");
		pm->ChangeTextItem(7,(unsigned char *)" 6.");
		pm->ChangeTextItem(8,(unsigned char *)" 7.");
		pm->ChangeTextItem(9,(unsigned char *)" Num");
	}
	return ER_CONTINUE;	
}


EventResult CTipoStrings()
{ 
	Menu *pm = (Menu *)LiooListWidget.GetNodoItemID(SYMB_STRINGS_ID);  
	if (pm==NULL) 
	{
		EM.Error(MUSICAL_ERR_AREA,"EC_LISTA_ELEMENTO_NON_PRESENTE","LiooMenu","TipoString()");
		return FALSE;
	}
	
	Scr->GSetDrawArea(pm->GetScrDrawArea());
	
	switch (GetTipoStrings())
	{
    case NOTCIRCLED:
		TipoStrings=BRACKETS;
		pm->ChangeTextItem(10,(unsigned char *)"()");
		break;
	case BRACKETS:
		TipoStrings=CIRCLED1;
		pm->ChangeTextItem(10,(unsigned char *)"C1");
		break;
	case CIRCLED1:
		TipoStrings=CIRCLED2;
		pm->ChangeTextItem(10,(unsigned char *)"C2");
		break;
    case CIRCLED2:
		TipoStrings=NOTCIRCLED;
		pm->ChangeTextItem(10,(unsigned char *)"!C");
	}		 	
	return ER_CONTINUE;
}



// MENU VIOLIN 
void CreateViolinMenu()
{
	int x, y;
	bool orizzontal;
	SMRApp::GetApp().workspace->GetMenuConfig(SYMB_VIOLIN_ID, x, y, orizzontal);
	
	Menu *pm= new Menu(" Violin Menu", SYMB_VIOLIN_ID, 9, orizzontal);
	if(!pm)
		EM.Error(GENERAL_ERR_AREA,"EC_MEMORYFAULT","LiooMenu","CreateViolinMenu()");
	
	FontID ofont=Scr->SetFont(nMenuFont);
	
	pm->SetTextItem(1,(unsigned char *)COD_ARCOGIU,nMenuFont,CArcoGiuOp);
	pm->SetTextItem(2,(unsigned char *)COD_ARCOSU,nMenuFont,CArcoSuOp);
	pm->SetTextItem(3,(unsigned char *)" Arc",nTextFont,CArcoOp);
	pm->SetTextItem(4,(unsigned char *)" Pizz.",nTextFont,CPizzicatoOp);
	pm->SetTextItem(5,(unsigned char *)COD_PUNTA,nMenuFont,CPuntaOp);
	pm->SetTextItem(6,(unsigned char *)COD_TALLONE,nMenuFont,CTalloneOp);
	pm->SetTextItem(7,(unsigned char *)" Pont.",nTextFont,CPonticelloOp);
	pm->SetTextItem(8,(unsigned char *)" Tast.",nTextFont,CTastieraOp);
	pm->CalcolaDimensioni();
	pm->Realize(x, y);
	
	LiooListWidget.Add(pm);
	Scr->SetFont(ofont);
}

EventResult CArcoOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Arco: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_ARCO,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CArcoSuOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" ArcoSu: Select Note");
	MusicEditor->SetCommand(CMD_ARCO_ARCOSU,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CArcoGiuOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" ArcoGiu: Select Note");
	MusicEditor->SetCommand(CMD_ARCO_ARCOGIU,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CCordaOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Corda: Select Note");
	MusicEditor->SetCommand(CMD_ARCO_CORDA,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPizzicatoOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Pizzicato: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_PIZZICATO,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPonticelloOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Ponticello: Select Note");
	MusicEditor->SetCommand(CMD_ARCO_PONTICELLO,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CTastieraOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Tastiera: Select Note");
	MusicEditor->SetCommand(CMD_ARCO_TASTIERA,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CPuntaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Punta: Select Note");
	MusicEditor->SetCommand(CMD_ARCO_PUNTA,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CTalloneOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Tallone: Select Note");
	MusicEditor->SetCommand(CMD_ARCO_TALLONE,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CCordaVuotaOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" String0: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_CORDA_0,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CCordaUnoOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" String1: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_CORDA_1,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CCordaDueOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" String2: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_CORDA_2,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CCordaTreOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" String3: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_CORDA_3,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CCordaQuattroOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" String4: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_CORDA_4,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CCordaCinqueOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" String5: Select Note");
	MusicEditor->SetCommand(CMD_NOTA_CORDA_5,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	MusicEditor->HideTagli();
	return ER_CONTINUE;
}

EventResult CCordaSeiOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" String6: Select Note");
	pMusicWin->SetCommand(CMD_NOTA_CORDA_6,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CCordaSetteOp()
{
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" String7: Select Note");
	pMusicWin->SetCommand(CMD_NOTA_CORDA_7,IMMEDIATE_SEL,NOTA_SEL,aboveNota);
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

//*********************************************************************
// azioni dei bottini di esecuzione 
//*********************************************************************

EventResult ImpOp()
{ 
	if (exe_status!=EXE_NONE && exe_status!=EXE_COMPILE && exe_status!=EXE_START &&
		exe_status!=EXE_STOP && exe_status!=EXE_INIT && exe_status!=EXE_PAUSE) {
		Message("Operation not allowed"); 
		return ER_CONTINUE;
	}
	
	if (tipoLeggio!=LEGGIO_MASAE){
		Message(NOTYETIMPLEMENTED); 
		return ER_CONTINUE;
	}
	
	StopOp(); 
	
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Score Compiling");
	
	char *SaveName=pMusicWin->PPartit->GetFileSaveName();
	if (strlen(SaveName)==0) {
		Message("File of execution must have a name"); 
		exe_status=EXE_NONE;
		return ER_CONTINUE;
	}
	
	{ 
		if (!(pMusicWin->OkCompila()))
		{  exe_status=EXE_NONE;
		return ER_CONTINUE;
		}
		
		pMusicWin->CursorWait();
		
		pMusicWin->SetCommand(CMD_PARTITURA_IMPAGINA);
		pMusicWin->DoCommand();
		
		pMusicWin->HideTagli();
		exe_status=EXE_COMPILE;
		return ER_CONTINUE;
	}
	return ER_CONTINUE;
}


/*********************************************************************/

static unsigned char TxtIt[10];

/*********************************************************************/
EventResult InitOp()
{ 
	
	if (tipoLeggio!=LEGGIO_MASAE){
		Message(NOTYETIMPLEMENTED); 
		return ER_CONTINUE;
	}
	
	StopOp(); 
	
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Initialization of lecterns");
	
	pMusicWin->CursorWait();
	if (SimbImg)
	{  
		pMusicWin->SetCommand(CMD_PARTITURA_INITESECUZIONE);
		pMusicWin->DoCommand();
		exe_status=EXE_INIT;
	}
	
	
	VisualizzaMetr(0, 0, 0);
	pMusicWin->SetVelocEsec(0);
	return ER_CONTINUE;
}

/*********************************************************************/




/*********************************************************************/
EventResult GoOp()
{ 
	if (exe_status!=EXE_INIT || !(pMusicWin->OkEsecuzione())) {
		Message("Operation not allowed, please initialize first"); 
		return ER_CONTINUE;
	}
	
	if (SimbImg)
    {
		
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Under execution");
		
		pMusicWin->CursorGo();
		pMusicWin->SetCommand(CMD_PARTITURA_AVVIOESECUZIONE);
		pMusicWin->DoCommand();
		exe_status=EXE_START;
    }
	
	return ER_CONTINUE;
}

/*********************************************************************/
EventResult StopOp()
{ 
	if(pMusicWin==NULL) 
		return ER_CONTINUE; 
	
	if (exe_status!=EXE_NONE && exe_status!=EXE_COMPILE && exe_status!=EXE_START &&
		exe_status!=EXE_STOP && exe_status!=EXE_INIT && exe_status!=EXE_PAUSE) {
		Message("Operation not allowed, only in execution"); 
		return ER_CONTINUE;
	}
	
	if (SimbImg)
    {
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Locked execution");
		
		pMusicWin->CursorWait();
		
		pMusicWin->SetCommand(CMD_PARTITURA_INTERROMPI);
		pMusicWin->DoCommand();
		
		exe_status=EXE_STOP;
	}
	return ER_CONTINUE;
}

/*********************************************************************/
EventResult JumpOp()
{
	if (exe_status!=EXE_STOP && exe_status!=EXE_PAUSE && exe_status!=EXE_INIT) {
		Message("Operation not allowed: please stop, pause or initialize"); 
		return ER_CONTINUE;
	}
	
	if (!(pMusicWin->OkJump()))
		return ER_CONTINUE;
	
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Jump in the score");
	
	short nbat;
	
	if(SimbImg)
	{
		CursorTypes tipoCur = Scr->GGetCursor();
		
		pMusicWin->CursorWait();
		
		if (WidgetJump("Jump",tgenerico,TGENERICO_LEN, pMusicWin->GetNumEtichette(), pMusicWin->GetNumeroBattute()))
		{
			nbat = atoi(tgenerico);  // trova la battuta in forma numerica (NumericCode)
			
			
			pMusicWin->SetCommand(CMD_PARTITURA_JUMP,NO_SEL,ANY_SEL,nbat);
			pMusicWin->DoCommand();
			
			pMusicWin->CursorEsecuzione();
			
			((wxMEScoreFrame*)FrameManager::currFrame)->Gettoolbar()->Getexec_status()->SetValue("0");
			
			pMusicWin->SetVelocEsec(0);
		}
		else
		{
			switch (tipoCur)
			{
			case AVANTI:
				pMusicWin->CursorGo();
				break;
			case WAIT:
				pMusicWin->CursorWait();
				break;
			case DEFAULT:
				pMusicWin->CursorEditing();
				break;
			case EXECUTION:
				pMusicWin->CursorEsecuzione();
				break;
			default:
				pMusicWin->CursorWait();
				break;
			}
		}
	}
	exe_status=EXE_INIT;
	return ER_CONTINUE;
}



/*********************************************************************/

static EventResult SCROp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Single Execution");
	pMusicWin->SetCommand(CMD_PARTITURA_PAGINAZIONE);
	pMusicWin->DoCommand();
	
	return ER_CONTINUE;
}


/*********************************************************************/

EventResult ToEditOp()
{ 
	
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Editing Mode");
	
	pMusicWin->CursorEditing();
	pMusicWin->DisattivaModEsecuzione();
	pMusicWin->ForceFormattingForExecution();
	
	
	exe_status=EXE_NONE;
	pMusicWin->Redraw();
	
	return ER_CONTINUE;
}

/*********************************************************************/
EventResult VisualizzaMetr(int Metr, int Vel, int Rate)
{
	if(dynamic_cast<wxMEScoreFrame*>(FrameManager::currFrame)!=NULL)
	{
		wxString metr;
		metr<<Metr;
		wxString vel;
		vel<<Vel;
		wxString rate;
		rate<<-Rate;
		((wxMEScoreFrame*)FrameManager::currFrame)->Gettoolbar()->Getexec_status()->SetValue(metr);
		((wxMEScoreFrame*)FrameManager::currFrame)->Gettoolbar()->Getexec_statusperc()->SetValue(vel);
	}
	
	return ER_CONTINUE;
}

void MESetStatusText(const wxString& msg)
{
	((wxMEScoreFrame*)FrameManager::currFrame)->SetStatusText(msg);
}

/*********************************************************************/
EventResult DecOp()
{ 
	if (exe_status!=EXE_START && exe_status!=EXE_PAUSE) {
		Message("Operation allowed during execution"); 
		return ER_CONTINUE;
	}
	if (SimbImg)
    {
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Decrement of execution rate");
		pMusicWin->SetCommand(CMD_PARTITURA_DECELLERA);
		pMusicWin->DoCommand();
		VisualizzaMetr((pMusicWin->GetMetr() * (1000 + pMusicWin->GetVelocEsec()))/1000, 
			pMusicWin->GetVelocEsec()/10, (pMusicWin->PPartit)->GetAudioRate());
	}
	
	return ER_CONTINUE;
}

/*********************************************************************/
EventResult pausaOp()
{ 
	if (exe_status!=EXE_START && exe_status!=EXE_PAUSE) {
		Message("Operation allowed during execution"); 
		return ER_CONTINUE;
	}
	if (SimbImg)
    {
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Execution in standby");
		
		pMusicWin->SetCommand(CMD_PARTITURA_PAUSA);
		pMusicWin->DoCommand();
	}
	
	if (exe_status==EXE_PAUSE) 
		exe_status=EXE_START;
	else
		exe_status=EXE_PAUSE;
	
	return ER_CONTINUE;
}

/*********************************************************************/
EventResult AccOp()
{ 
	if (exe_status!=EXE_START && exe_status!=EXE_PAUSE) {
		Message("Operation allowed during execution"); 
		return ER_CONTINUE;
	}
	
	if (SimbImg)
    {
		Scr->GSetMainDrawArea();
		Setmessagedisplay(" Increment of execution rate");
		
		pMusicWin->SetCommand(CMD_PARTITURA_ACCELLERA);
		pMusicWin->DoCommand();
		VisualizzaMetr((pMusicWin->GetMetr() * (1000 + pMusicWin->GetVelocEsec()))/1000, 
			pMusicWin->GetVelocEsec()/10, (pMusicWin->PPartit)->GetAudioRate() );
	}
	
	return ER_CONTINUE;
}


/*****************************************************************/
EventResult MidiOp()
{ 
	int numTraccia=0;
	char fileName[200];
	
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Output to MIDI device");
	strcpy(fileName,"test.mid");
	pMusicWin->SetCommand(CMD_PARTITURA_EXPORT_MIDI,NO_SEL,ANY_SEL,numTraccia ,0,0,0,0,fileName);
	pMusicWin->DoCommand();
	return ER_CONTINUE;
}

static EventResult UnoOp()
{ 
	Scr->GSetMainDrawArea();
	pMusicWin->SetCommand(CMD_DEBUG_UNO);
	pMusicWin->DoCommand();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

static EventResult DueOp()
{ 
	Scr->GSetMainDrawArea();
	pMusicWin->SetCommand(CMD_DEBUG_DUE);
	pMusicWin->DoCommand();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

static EventResult TreOp()
{ 
	Scr->GSetMainDrawArea();
	pMusicWin->SetCommand(CMD_DEBUG_TRE);
	pMusicWin->DoCommand();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

static EventResult QuattroOp()
{ 
	Scr->GSetMainDrawArea();
	pMusicWin->SetCommand(CMD_DEBUG_QUATTRO);
	pMusicWin->DoCommand();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

static EventResult CinqueOp()
{ 
	Scr->GSetMainDrawArea();
	pMusicWin->SetCommand(CMD_DEBUG_CINQUE);
	pMusicWin->DoCommand();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

static EventResult SeiOp()
{ 
	Scr->GSetMainDrawArea();
	pMusicWin->SetCommand(CMD_DEBUG_SEI);
	pMusicWin->DoCommand();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

static EventResult SetteOp()
{ 
	Scr->GSetMainDrawArea();
	pMusicWin->SetCommand(CMD_DEBUG_SETTE);
	pMusicWin->DoCommand();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

static EventResult OttoOp()
{ 
	Scr->GSetMainDrawArea();
	pMusicWin->SetCommand(CMD_DEBUG_OTTO);
	pMusicWin->DoCommand();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

static EventResult NoveOp()
{ 
	Scr->GSetMainDrawArea();
	pMusicWin->SetCommand(CMD_DEBUG_NOVE);
	pMusicWin->DoCommand();
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}


EventResult CmdNotImplem()
{
#ifdef TINYMOODS
	Message("Not available on tinyMoods");
#else
	Message(NOTYETIMPLEMENTED);
#endif
	return ER_CONTINUE;
}

static EventResult LegNotEnabled()
{
	Message("Functionality not available on this lectern");
	return ER_CONTINUE;
}


void PrimoTasto(Menu *pm)
{
	if(pm->GetOrizzontal())
		pm->SetTextItem(0,(unsigned char *)" V",nTextFont,COrizzontal,ABIL,FALSE,gray,BUTTON_WIDTH/2,BUTTON_HEIGHT);
	else
		pm->SetTextItem(0,(unsigned char *)" H",nTextFont,COrizzontal,ABIL,FALSE,gray,BUTTON_WIDTH,BUTTON_HEIGHT/2);
}


Bool InputNumber(char *msg,char *buffer,int max,char *title, short& n)
{
	int i;
	if (InputString(msg,buffer,max,title))
	{
		for(i=0,n=0;buffer[i];i++)
			if ((buffer[i]<'0') || (buffer[i]>'9'))
				return FALSE;
			else
				n = n*10 + buffer[i]-'0';
			return TRUE;
	}
	return FALSE;
}

/*
*
*	Fine LiooMenu
*
*
*/





static EventResult COrizzontal()
{
	Menu *pm=(Menu *)LiooListWidget.GetActiveNodo();
	if (pm==NULL) 
	{
		EM.Error(MUSICAL_ERR_AREA,"EC_LISTA_ELEMENTO_NON_PRESENTE","LiooMenu","COrizzontal()");
		return ER_CONTINUE;
	}
	
	pm->SetOrizzontal(!(pm->GetOrizzontal()));
	pm->CalcolaDimensioni();
	
	if(pm->GetOrizzontal())
		pm->ChangeTextItem(0,(unsigned char *)" V");
	else
		pm->ChangeTextItem(0,(unsigned char *)" H");
	
	Scr->GCloseWindow(pm->GetScrWindow());
	
	wxPoint position = pm->GetPosition();
	pm->Realize(position.x, position.y);
	
	return ER_CONTINUE;
}





static EventResult CChiudi()
{
    //  finestra che si vuole chiudere
	Menu *pm=(Menu *)LiooListWidget.GetActiveNodo();
	if (pm==NULL) 
	{
		EM.Error(MUSICAL_ERR_AREA,"EC_LISTA_ELEMENTO_NON_PRESENTE","LiooMenu","CChiudi()");
		return ER_CONTINUE;
	}
	
    //	elimino la finestra (il widget)
	Scr->GCloseWindow(pm->GetScrWindow());
	
	pm->SetClose(TRUE);
	
	return ER_CONTINUE;
}


//pulsante di modalita'di esecuzione:

EventResult ChangeMmExecMode()
{
	
	return ER_CONTINUE;
}


EventResult ChangeDeclickMode()
{
	
	return ER_CONTINUE;
}

//////////////////////////////////////////////


EventResult CInsertImageOp()
{	
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Insert Image: Select Region  ");
	pMusicWin->SetCommand(CMD_PARTITURA_INSERTIMAGE,RECT_SEL,ANY_SEL,
		0,0,0,0,0,"");
	pMusicWin->HideTagli();
	return ER_CONTINUE;	
}

EventResult CInsertTextOp()
{ 
	Scr->GSetMainDrawArea();
	Setmessagedisplay(" Insert Text: Select Point  ");
	pMusicWin->SetCommand(CMD_PARTITURA_INSERTTEXT,IMMEDIATE_SEL,ANY_SEL,
		0,0,0,0,0,"");
	pMusicWin->HideTagli();
	return ER_CONTINUE;
}

EventResult CEditLyric()
{
	if (tipoLeggio!=LEGGIO_MASAE){
		Message(NOTYETIMPLEMENTED); 
		return ER_CONTINUE;
	}
    Scr->GSetMainDrawArea();
    Setmessagedisplay(" Edit Lyric: Select part");
    pMusicWin->SetCommand(CMD_PARTITURA_EDIT_LYRIC,IMMEDIATE_SEL,SPARTITO_SEL);
    pMusicWin->HideTagli();
	
	return ER_CONTINUE;
	
}

EventResult CRemoveLyr()
{
	if (tipoLeggio!=LEGGIO_MASAE){
		Message(NOTYETIMPLEMENTED); 
		return ER_CONTINUE;
	}
    Scr->GSetMainDrawArea();
    Setmessagedisplay(" Edit Lyric: Select part");
    pMusicWin->SetCommand(CMD_PARTITURA_REMOVE_LYRIC,IMMEDIATE_SEL,SPARTITO_SEL);
    pMusicWin->HideTagli();
	
	return ER_CONTINUE;
	
}
////////////////////////////////////////
EventResult CNewLyric()
{
	if (tipoLeggio!=LEGGIO_MASAE){
		Message(NOTYETIMPLEMENTED); 
		return ER_CONTINUE;
	}
    Scr->GSetMainDrawArea();
    Setmessagedisplay(" New Lyric: Select part");
    pMusicWin->SetCommand(CMD_PARTITURA_NEW_LYRIC,IMMEDIATE_SEL,SPARTITO_SEL);
    pMusicWin->HideTagli();
	
	return ER_CONTINUE;
	
}

EventResult CSelectLyric()
{
	if (tipoLeggio!=LEGGIO_MASAE){
		Message(NOTYETIMPLEMENTED); 
		return ER_CONTINUE;
	}
    Scr->GSetMainDrawArea();
    Setmessagedisplay(" New Lyric: Select part");
    pMusicWin->SetCommand(CMD_PARTITURA_SELECT_LYRIC,IMMEDIATE_SEL,SPARTITO_SEL);
    pMusicWin->HideTagli();
	
	return ER_CONTINUE;
	
}
///////////////////////////////////////


EventResult CFit2Window()
{
	Scr->GSetMainDrawArea();
	
	return ER_CONTINUE;
}
